
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtMouseEventCapture=function(e){
e=Dwt.getParams(arguments,DwtMouseEventCapture.PARAMS);
this.targetObj=e.targetObj;
this._id=e.id;
this._mouseOverHdlr=e.mouseOverHdlr||DwtMouseEventCapture.emptyHdlr;
this._mouseDownHdlr=e.mouseDownHdlr||DwtMouseEventCapture.emptyHdlr;
this._mouseMoveHdlr=e.mouseMoveHdlr||DwtMouseEventCapture.emptyHdlr;
this._mouseUpHdlr=e.mouseUpHdlr||DwtMouseEventCapture.emptyHdlr;
this._mouseOutHdlr=e.mouseOutHdlr||DwtMouseEventCapture.emptyHdlr;
this._mouseWheelHdlr=e.mouseWheelHdlr||DwtMouseEventCapture.emptyHdlr;
this._hardCapture=(e.hardCapture!==false)
};
DwtMouseEventCapture.PARAMS=["targetObj","id","mouseOverHdlr","mouseDownHdlr","mouseMoveHdlr","mouseUpHdlr","mouseOutHdlr","mouseWheelHdlr","hardCapture"];
DwtMouseEventCapture._capturing=false;
DwtMouseEventCapture.getCaptureObj=function(){
return window._mouseEventCaptureObj
};
DwtMouseEventCapture.getTargetObj=function(){
return window._mouseEventCaptureObj?window._mouseEventCaptureObj.targetObj:null
};
DwtMouseEventCapture.getId=function(){
return window._mouseEventCaptureObj?window._mouseEventCaptureObj._id:null
};
DwtMouseEventCapture.prototype.toString=function(){
return"DwtMouseEventCapture"
};
DwtMouseEventCapture.prototype.capturing=function(){
return DwtMouseEventCapture._capturing
};
DwtMouseEventCapture.prototype.capture=function(){
if(window._mouseEventCaptureObj){
window._mouseEventCaptureObj.release()
}
if(document.body!=null&&document.body.addEventListener!=null){
document.body.addEventListener("mouseover",this._mouseOverHdlr,true);
document.body.addEventListener("mousedown",this._mouseDownHdlr,true);
document.body.addEventListener("mousemove",this._mouseMoveHdlr,true);
document.body.addEventListener("mouseup",this._mouseUpHdlr,true);
document.body.addEventListener("mouseout",this._mouseOutHdlr,true);
document.body.addEventListener("DOMMouseScroll",this._mouseWheelHdlr,true)
}else{
this._savedMouseOverHdlr=document.onmouseover;
this._savedMouseDownHdlr=document.onmousedown;
this._savedMouseMoveHdlr=document.onmousemove;
this._savedMouseUpHdlr=document.onmouseup;
this._savedMouseOutHdlr=document.onmouseout;
this._savedMouseWheelHdlr=document.onmousewheel;
document.onmouseover=this._mouseOverHdlr;
document.onmousedown=this._mouseDownHdlr;
document.onmousemove=this._mouseMoveHdlr;
document.onmouseup=this._mouseUpHdlr;
document.onmouseout=this._mouseOutHdlr;
document.onmousewheel=this._mouseWheelHdlr
}
if(this._hardCapture&&document.body&&document.body.setCapture){
document.body.setCapture()
}
window._mouseEventCaptureObj=this;
DwtMouseEventCapture._capturing=true
};
DwtMouseEventCapture.prototype.release=function(){
if(window._mouseEventCaptureObj==null){
return
}
var e=window._shellCaptureObj;
if(document.body&&document.body.addEventListener){
document.body.removeEventListener("mouseover",this._mouseOverHdlr,true);
document.body.removeEventListener("mousedown",this._mouseDownHdlr,true);
document.body.removeEventListener("mousemove",this._mouseMoveHdlr,true);
document.body.removeEventListener("mouseup",this._mouseUpHdlr,true);
document.body.removeEventListener("mouseout",this._mouseOutHdlr,true);
document.body.removeEventListener("DOMMouseScroll",this._mouseWheelHdlr,true)
}else{
document.onmouseover=this._savedMouseOverHdlr;
document.onmousedown=this._savedMouseDownHdlr;
document.onmousemove=this._savedMouseMoveHdlr;
document.onmouseup=this._savedMouseUpHdlr;
document.onmouseout=this._savedMouseOutHdlr;
document.onmousewheel=this._savedMouseWheelHdlr
}
if(this._hardCapture&&document.body&&document.body.releaseCapture){
document.body.releaseCapture()
}
window._mouseEventCaptureObj=null;
DwtMouseEventCapture._capturing=false
};
DwtMouseEventCapture.emptyHdlr=function(t){
var a=DwtMouseEventCapture.getCaptureObj();
var e=DwtShell.mouseEvent;
e.setFromDhtmlEvent(t);
if(a._hardCapture){
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
}else{
e._stopPropagation=false;
e._returnValue=true;
e.setToDhtmlEvent(t);
return true
}};
