
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtTabGroup=function(t,e){
this.__members=new AjxVector();
this.__parent=null;
this.__name=t;
this.__blockApplicationHandling=e;
this.__currFocusMember=null;
this.__evtMgr=new AjxEventMgr()
};
DwtTabGroup.NOT_ROOT_TABGROUP="NOT ROOT TAB GROUP";
DwtTabGroup.__changeEvt=new DwtTabGroupEvent();
DwtTabGroup.prototype.toString=function(){
return"DwtTabGroup"
};
DwtTabGroup.prototype.getName=function(){
return this.__name
};
DwtTabGroup.prototype.addFocusChangeListener=function(e){
this.__checkRoot();
this.__evtMgr.addListener(DwtEvent.STATE_CHANGE,e)
};
DwtTabGroup.prototype.removeFocusChangeListener=function(e){
this.__checkRoot();
this.__evtMgr.removeListener(DwtEvent.STATE_CHANGE,e)
};
DwtTabGroup.prototype.addMember=function(n,a){
if(!n){
return
}
var t=(n instanceof Array)?n:[n];
for(var o=0,e=t.length;
o<e;
o++){
this.__members.add(t[o],a);
if(t[o] instanceof DwtTabGroup){
t[o].newParent(this)
}}};
DwtTabGroup.prototype.addMemberAfter=function(e,t){
this.addMember(e,this.__members.indexOf(t)+1)
};
DwtTabGroup.prototype.addMemberBefore=function(e,t){
this.addMember(e,this.__members.indexOf(t))
};
DwtTabGroup.prototype.removeMember=function(a,e,t){
return this.replaceMember(a,null,e,t)
};
DwtTabGroup.prototype.removeAllMembers=function(){
this.__members.removeAll()
};
DwtTabGroup.prototype.replaceMember=function(o,n,h,s,e,i){
var t=this.__getTabGroupForMember(o);
if(!t){
this.addMember(n);
return null
}
var r=this.__getRootTabGroup();
var a;
if(e){
a=e
}else{
if(r.__currFocusMember==o||((o instanceof DwtTabGroup)&&o.contains(r.__currFocusMember))){
if(n){
a=(n instanceof DwtTabGroup)?n.getFirstMember():n
}else{
a=this.__getPrevMember(o,h);
if(!a){
a=this.__getNextMember(o,h)
}}}}
if(a&&!i){
r.__currFocusMember=a;
if(!s){
this.__notifyListeners(a)
}}
return n?this.__members.replaceObject(o,n):this.__members.remove(o)
};
DwtTabGroup.prototype.contains=function(e){
return(Boolean(this.__getTabGroupForMember(e)))
};
DwtTabGroup.prototype.newParent=function(e){
this.__parent=e
};
DwtTabGroup.prototype.getFirstMember=function(e){
return this.__getLeftMostMember(e)
};
DwtTabGroup.prototype.getTabGroupMemberByName=function(t){
var e=this.__members.getArray();
for(var a=0;
a<e.length;
a++){
var o=e[a];
if(o instanceof DwtTabGroup&&o.getName()==t){
return o
}}};
DwtTabGroup.prototype.getLastMember=function(e){
return this.__getRightMostMember(e)
};
DwtTabGroup.prototype.getFocusMember=function(){
this.__checkRoot();
return this.__currFocusMember
};
DwtTabGroup.prototype.setFocusMember=function(i,e,t){
this.__checkRoot();
if(!this.__checkEnabled(i,e)){
return false
}
var a=this.__getTabGroupForMember(i);
if(a){
this.__currFocusMember=i;
if(!t){
this.__notifyListeners(this.__currFocusMember)
}
return true
}
return false
};
DwtTabGroup.prototype.getNextFocusMember=function(e,t){
this.__checkRoot();
return this.__setFocusMember(true,e,t)
};
DwtTabGroup.prototype.getPrevFocusMember=function(e,t){
this.__checkRoot();
return this.__setFocusMember(false,e,t)
};
DwtTabGroup.prototype.resetFocusMember=function(t,a){
this.__checkRoot();
var e=this.__getLeftMostMember(t);
if((e!=this.__currFocusMember)&&!a){
this.__notifyListeners(this.__currFocusMember)
}
this.__currFocusMember=e;
return this.__currFocusMember
};
DwtTabGroup.prototype.blockDefaultHandling=function(e){
this.__blockDefaultHandling=blockDefaultHandling
};
DwtTabGroup.prototype.isDefaultHandlingBlocked=function(e){
return this.__blockDefaultHandling
};
DwtTabGroup.prototype.dump=function(e){
if(!window.AjxDebug&&window.DBG){
return
}
this.__dump(this,e)
};
DwtTabGroup.prototype.size=function(){
return this.__members.size()
};
DwtTabGroup.prototype.__getPrevMember=function(s,t){
var e=this.__members.getArray();
for(var o=this.__members.indexOf(s)-1;
o>-1;
o--){
var n=e[o];
if(!(n instanceof DwtTabGroup)){
if(this.__checkEnabled(n,t)){
return n
}}else{
n=n.__getRightMostMember(t);
if(n&&this.__checkEnabled(n,t)){
return n
}}}
return this.__parent?this.__parent.__getPrevMember(this,t):null
};
DwtTabGroup.prototype.__checkEnabled=function(t,e){
if(!e){
return true
}
if(!t||t.noTab){
return false
}
if(t instanceof DwtControl){
return(t.getEnabled()&&t.getVisible())
}else{
return !t.disabled&&Dwt.getVisible(t)
}};
DwtTabGroup.prototype.__getNextMember=function(r,t){
var e=this.__members.getArray();
var s=this.__members.size();
for(var n=this.__members.indexOf(r)+1;
n<s;
n++){
var o=e[n];
if(!(o instanceof DwtTabGroup)){
if(this.__checkEnabled(o,t)){
return o
}}else{
o=o.__getLeftMostMember(t);
if(o&&this.__checkEnabled(o,t)){
return o
}}}
return this.__parent?this.__parent.__getNextMember(this,t):null
};
DwtTabGroup.prototype.__getRightMostMember=function(t){
var e=this.__members.getArray();
var n=null;
for(var o=this.__members.size()-1;
o>=0;
o--){
n=e[o];
if(!(n instanceof DwtTabGroup)){
if(this.__checkEnabled(n,t)){
break
}}else{
n=n.__getRightMostMember(t);
if(n&&this.__checkEnabled(n,t)){
break
}}}
return(n&&this.__checkEnabled(n,t))?n:null
};
DwtTabGroup.prototype.__getLeftMostMember=function(t){
var n=this.__members.size();
var e=this.__members.getArray();
var s=null;
for(var o=0;
o<n;
o++){
s=e[o];
if(!(s instanceof DwtTabGroup)){
if(this.__checkEnabled(s,t)){
break
}}else{
s=s.__getLeftMostMember(t);
if(s&&this.__checkEnabled(s,t)){
break
}}}
return(s&&this.__checkEnabled(s,t))?s:null
};
DwtTabGroup.prototype.__notifyListeners=function(t){
var a=this.__getRootTabGroup();
if(a.__evtMgr){
var e=DwtTabGroup.__changeEvt;
e.reset();
e.tabGroup=this;
e.newFocusMember=t;
a.__evtMgr.notifyListeners(DwtEvent.STATE_CHANGE,e)
}};
DwtTabGroup.prototype.__getRootTabGroup=function(){
var e=this;
while(e.__parent){
e=e.__parent
}
return e
};
DwtTabGroup.prototype.__dump=function(n,t,h){
h=h||0;
var r="";
for(var o=0;
o<h;
o++){
r+="&nbsp;&nbsp;&nbsp;&nbsp;"
}
t=t||AjxDebug.DBG1;
r+="&nbsp;&nbsp;&nbsp;&nbsp;";
var s=n.__members.size();
var e=n.__members.getArray();
for(var o=0;
o<s;
o++){
if(e[o] instanceof DwtTabGroup){
n.__dump(e[o],t,h+1)
}else{
if(e[o].toString){}else{}}}};
DwtTabGroup.prototype.__setFocusMember=function(o,t,a){
if(!this.__currFocusMember){
return this.resetFocusMember(t,a)
}
var i=this.__getTabGroupForMember(this.__currFocusMember);
if(!i){
return null
}
var e=(o)?i.__getNextMember(this.__currFocusMember,t):i.__getPrevMember(this.__currFocusMember,t);
if(!e){
e=(o)?this.__getLeftMostMember(t):this.__getRightMostMember(t);
if(e==this.__currFocusMember){
return null
}}
this.__currFocusMember=e;
if(!a){
this.__notifyListeners(this.__currFocusMember)
}
return this.__currFocusMember
};
DwtTabGroup.prototype.__getTabGroupForMember=function(s){
if(!s){
return null
}
var n=this.__members.size();
var t=this.__members.getArray();
var e;
for(var o=0;
o<n;
o++){
e=t[o];
if(e==s){
return this
}else{
if(e instanceof DwtTabGroup&&(e=e.__getTabGroupForMember(s))){
return e
}}}
return null
};
DwtTabGroup.prototype.__checkRoot=function(){
if(this.__parent){
throw DwtTabGroup.NOT_ROOT_TABGROUP
}};
