
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtButton=function(a){
if(arguments.length==0){
return
}
a=Dwt.getParams(arguments,DwtButton.PARAMS);
a.className=a.className||"ZButton";
DwtLabel.call(this,a);
var t=a.parent;
if(!t._hasSetMouseEvents||AjxEnv.isIE){
this._setMouseEvents()
}
var e;
if(t._hasSetMouseEvents){
e=AjxEnv.isIE?[DwtEvent.ONMOUSEENTER,DwtEvent.ONMOUSELEAVE]:[]
}else{
e=AjxEnv.isIE?[DwtEvent.ONMOUSEENTER,DwtEvent.ONMOUSELEAVE]:[DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT];
e=e.concat([DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP])
}
if(e&&e.length){
this._setEventHdlrs(e)
}
this._listeners=a.listeners||DwtButton._listeners;
this._addMouseListeners();
this._ignoreInternalOverOut=true;
this._dropDownEvtMgr=new AjxEventMgr();
this._selected=false;
this._actionTiming=a.actionTiming||DwtButton.ACTION_MOUSEUP;
this.__preventMenuFocus=null
};
DwtButton.prototype=new DwtLabel;
DwtButton.prototype.constructor=DwtButton;
DwtButton.prototype.toString=function(){
return"DwtButton"
};
DwtButton.PARAMS=["parent","style","className","posStyle","actionTiming","id","index","listeners"];
DwtButton.TOGGLE_STYLE=DwtLabel._LAST_STYLE*2;
DwtButton.ALWAYS_FLAT=DwtLabel._LAST_STYLE*4;
DwtButton._LAST_STYLE=DwtButton.ALWAYS_FLAT;
DwtButton.ACTION_MOUSEUP=1;
DwtButton.ACTION_MOUSEDOWN=2;
DwtButton.NOTIFY_WINDOW=500;
DwtButton.prototype.TEMPLATE="dwt.Widgets#ZButton";
DwtButton.prototype.dispose=function(){
if((this._menu instanceof DwtMenu)&&(this._menu.parent==this)){
this._menu.dispose();
this._menu=null
}
DwtLabel.prototype.dispose.call(this)
};
DwtButton.prototype.addSelectionListener=function(t,e){
this.addListener(DwtEvent.SELECTION,t,e)
};
DwtButton.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtButton.prototype.removeSelectionListeners=function(){
this.removeAllListeners(DwtEvent.SELECTION)
};
DwtButton.prototype.addDropDownSelectionListener=function(e){
return this._dropDownEvtMgr.addListener(DwtEvent.SELECTION,e)
};
DwtButton.prototype.removeDropDownSelectionListener=function(e){
this._dropDownEvtMgr.removeListener(DwtEvent.SELECTION,e)
};
DwtButton.prototype._dropDownImg="SelectPullDownArrow";
DwtButton.prototype._dropDownDepImg="SelectPullDownArrow";
DwtButton.prototype._dropDownHovImg="SelectPullDownArrowHover";
DwtButton.prototype.setDropDownImages=function(t,a,i,e){
this._dropDownImg=t;
this._dropDownHovImg=i;
this._dropDownDepImg=e
};
DwtButton.prototype.setDropDownHovImage=function(e){
this._dropDownHovImg=e
};
DwtButton.prototype._addEventListeners=function(a,t){
for(var e=0;
e<t.length;
e++){
this.addListener(event,a[event])
}};
DwtButton.prototype._removeEventListeners=function(a,t){
for(var e=0;
e<t.length;
e++){
this.removeListener(event,a[event])
}};
DwtButton.prototype._addMouseListeners=function(){
var t=[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP];
t=t.concat(AjxEnv.isIE?[DwtEvent.ONMOUSEENTER,DwtEvent.ONMOUSELEAVE]:[DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT]);
for(var e=0;
e<t.length;
e++){
this.addListener(t[e],this._listeners[t[e]])
}};
DwtButton.prototype._removeMouseListeners=function(){
var t=[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP];
t=t.concat(AjxEnv.isIE?[DwtEvent.ONMOUSEENTER,DwtEvent.ONMOUSELEAVE]:[DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT]);
for(var e=0;
e<t.length;
e++){
this.removeListener(t[e],this._listeners[t[e]])
}};
DwtButton.prototype.setDisplayState=function(t,e){
if(this._selected&&t!=DwtControl.SELECTED&&!e){
t=[DwtControl.SELECTED,t].join(" ")
}
DwtLabel.prototype.setDisplayState.call(this,t)
};
DwtButton.prototype.setEnabled=function(t){
if(t!=this._enabled){
DwtLabel.prototype.setEnabled.call(this,t);
if(t){
var a=(AjxEnv.isIE)?this.getHtmlElement().firstChild:null;
if(a){
var e=a.className;
a.className="";
a.className=e
}
this._addMouseListeners();
if(this._menu){
this._setDropDownCellMouseHandlers(true);
if(this._dropDownEl&&this._dropDownImg){
AjxImg.setImage(this._dropDownEl,this._dropDownImg)
}}}else{
this._removeMouseListeners();
if(this._menu){
this._setDropDownCellMouseHandlers(false);
if(this._dropDownEl&&this._dropDownImg){
AjxImg.setDisabledImage(this._dropDownEl,this._dropDownImg)
}}}}};
DwtButton.prototype.setImage=function(e){
DwtLabel.prototype.setImage.call(this,e);
this._setMinWidth()
};
DwtButton.prototype.setText=function(e){
DwtLabel.prototype.setText.call(this,e);
this._setMinWidth()
};
DwtButton.prototype._setMinWidth=function(){
if(this.getText()!=null){
Dwt.addClass(this.getHtmlElement(),"ZHasText")
}else{
Dwt.delClass(this.getHtmlElement(),"ZHasText")
}};
DwtButton.prototype.setHoverImage=function(e){
this._hoverImageInfo=e
};
DwtButton.prototype.setMenu=function(n,a,i,t,o){
this._menu=n;
this._shouldToggleMenu=(a===true);
this._followIconStyle=i;
this._popupAbove=t;
this._popupRight=o;
if(this._menu){
if(this._dropDownEl){
var e=(this._imageCell)?1:0;
if(this._textCell){
e++
}
Dwt.addClass(this.getHtmlElement(),"ZHasDropDown");
if(this._dropDownImg){
AjxImg.setImage(this._dropDownEl,this._dropDownImg)
}
if(this._enabled){
this._setDropDownCellMouseHandlers(true)
}
if(!(this._menu instanceof AjxCallback)){
this._menu.setAssociatedElementId(this._dropDownEl.id)
}}
if((this.__preventMenuFocus!=null)&&(this._menu instanceof DwtMenu)){
this._menu.dontStealFocus(this.__preventMenuFocus)
}}else{
if(this._dropDownEl){
Dwt.delClass(this.getHtmlElement(),"ZHasDropDown");
this._dropDownEl.innerHTML=""
}}};
DwtButton.prototype._setDropDownCellMouseHandlers=function(e){
this._dropDownEventsEnabled=e
};
DwtButton.prototype.getMenu=function(e){
if(this._menu instanceof AjxCallback){
if(e){
return null
}
var t=this._menu;
this.setMenu(t.run(this),this._shouldToggleMenu,this._followIconStyle,this._popupAbove);
if((this.__preventMenuFocus!=null)&&(this._menu instanceof DwtMenu)){
this._menu.dontStealFocus(this.__preventMenuFocus)
}}
if(this._menu){
this.getHtmlElement().setAttribute("menuId",this._menu._htmlElId)
}
return this._menu
};
DwtButton.prototype.resetClassName=function(){
this.setDisplayState(DwtControl.NORMAL)
};
DwtButton.prototype.setActionTiming=function(e){
this._actionTiming=e
};
DwtButton.prototype.setHovered=function(e){
this.setDisplayState(e?DwtControl.HOVER:DwtControl.NORMAL)
};
DwtButton.prototype.setEnabledImage=function(e){
this._enabledImageInfo=e;
this.setImage(e)
};
DwtButton.prototype.setDepressedImage=function(e){
this._depressedImageInfo=e
};
DwtButton.prototype.setSelected=function(e){
if(this._selected!=e){
this._selected=e;
this.setDisplayState(e?DwtControl.SELECTED:DwtControl.NORMAL)
}};
DwtButton.prototype.isToggled=function(){
return this._selected
};
DwtButton.prototype.popup=function(i){
i=i||this.getMenu();
if(!i){
return
}
var l=i.parent;
var n=l.getBounds();
var h=i.shell.getSize();
var e=i.getSize();
var c=l.getHtmlElement();
var a=Dwt.toWindow(c,0,0);
var t=(c.style.borderLeftWidth=="")?0:parseInt(c.style.borderLeftWidth);
var r;
if(this._popupRight){
r=a.x+n.width-e.x
}else{
r=a.x+t;
r=((r+e.x)>=h.x)?h.x-e.x:r
}
var s;
if(this._popupAbove){
s=a.y-e.y
}else{
var o=(c.style.borderTopWidth=="")?0:parseInt(c.style.borderTopWidth);
o+=(c.style.borderBottomWidth=="")?0:parseInt(c.style.borderBottomWidth);
s=a.y+n.height+o
}
i.popup(0,r,s)
};
DwtButton.prototype.getKeyMapName=function(){
return"DwtButton"
};
DwtButton.prototype.handleKeyAction=function(e,t){
switch(e){
case DwtKeyMap.SELECT:this._emulateSingleClick();
break;
case DwtKeyMap.SUBMENU:var a=this.getMenu();
if(!a){
return false
}
this._emulateDropDownClick();
a.setSelectedItem(0);
break
}
return true
};
DwtButton.prototype._emulateSingleClick=function(){
this.trigger();
var e=this.getHtmlElement();
var t=Dwt.toWindow(e);
var a=new DwtMouseEvent();
this._setMouseEvent(a,{
dwtObj:this,target:e,button:DwtMouseEvent.LEFT,docX:t.x,docY:t.y}
);
if(this._actionTiming==DwtButton.ACTION_MOUSEDOWN){
this.notifyListeners(DwtEvent.ONMOUSEDOWN,a)
}else{
this.notifyListeners(DwtEvent.ONMOUSEUP,a)
}};
DwtButton.prototype._emulateDropDownClick=function(){
var e=this._dropDownEl;
if(!e){
return
}
var t=Dwt.toWindow(e);
var a=new DwtMouseEvent();
this._setMouseEvent(a,{
dwtObj:this,target:e,button:DwtMouseEvent.LEFT,docX:t.x,docY:t.y}
);
DwtButton._dropDownCellMouseDownHdlr(a)
};
DwtButton.prototype._focusByMouseUpEvent=function(){
if(!(this.parent&&(this.parent instanceof DwtToolBar)&&this.parent.noFocus)){
DwtShell.getShell(window).getKeyboardMgr().grabFocus(this.getTabGroupMember())
}};
DwtButton.prototype._focus=function(){
this.setDisplayState(DwtControl.FOCUSED)
};
DwtButton.prototype._blur=function(){
this.setDisplayState(DwtControl.NORMAL)
};
DwtButton.prototype._toggleMenu=function(){
if(this._shouldToggleMenu){
var e=this.getMenu();
if(!e.isPoppedUp()){
this.popup();
this._menuUp=true
}else{
e.popdown();
this._menuUp=false;
this.deactivate()
}}else{
this.popup()
}};
DwtButton.prototype._isDropDownEvent=function(t){
if(this._dropDownEventsEnabled&&this._dropDownEl){
var e=t.docX;
var a=Dwt.toWindow(this._dropDownEl,0,0,window).x;
if(e>=a){
return true
}}
return false
};
DwtButton.prototype.trigger=function(){
if(this._depressedImageInfo){
this.setImage(this._depressedImageInfo)
}
this.setDisplayState(DwtControl.ACTIVE,true);
this.isActive=true
};
DwtButton.prototype.deactivate=function(){
this._showHoverImage(true);
if(this._style&DwtButton.TOGGLE_STYLE){
this._selected=!this._selected
}
this.setDisplayState(DwtControl.HOVER)
};
DwtButton.prototype.dontStealFocus=function(e){
if(e==null){
e=true
}
if(this._menu instanceof DwtMenu){
this._menu.dontStealFocus(e)
}
this.__preventMenuFocus=e
};
DwtButton.prototype._showHoverImage=function(t){
if(this._hoverImageInfo){
var e=this._getIconEl();
if(e){
var a=t?this._hoverImageInfo:this.__imageInfo;
e.firstChild.className=AjxImg.getClassForImage(a)
}}};
DwtButton.prototype._handleClick=function(t){
if(this.isListenerRegistered(DwtEvent.SELECTION)){
var e=(new Date()).getTime();
if(!this._lastNotify||(e-this._lastNotify>DwtButton.NOTIFY_WINDOW)){
var a=DwtShell.selectionEvent;
DwtUiEvent.copy(a,t);
a.item=this;
a.detail=(typeof this.__detail=="undefined")?0:this.__detail;
this.notifyListeners(DwtEvent.SELECTION,a);
this._lastNotify=e;
this.shell.notifyGlobalSelection(a)
}}else{
if(this._menu){
if(this._menu instanceof DwtMenu&&!this.isListenerRegistered(DwtEvent.SELECTION)){
this._menu.setAssociatedObj(this)
}
this._toggleMenu()
}}};
DwtButton.prototype._setMouseOutClassName=function(){
this.setDisplayState(DwtControl.NORMAL)
};
DwtButton.prototype._createHtmlFromTemplate=function(e,t){
DwtLabel.prototype._createHtmlFromTemplate.call(this,e,t);
this._dropDownEl=document.getElementById(t.id+"_dropdown")
};
DwtButton._dropDownCellMouseDownHdlr=function(t){
var a=DwtControl.getTargetControl(t);
var e=DwtShell.mouseEvent;
e.setFromDhtmlEvent(t,a);
if(e.button==DwtMouseEvent.LEFT){
if(this._depImg){
AjxImg.setImage(this,this._depImg)
}}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
};
DwtButton._dropDownCellMouseUpHdlr=function(t){
var e=DwtShell.mouseEvent;
e.setFromDhtmlEvent(t);
if(e.button==DwtMouseEvent.LEFT){
if(this._hovImg&&!this.noMenuBar){
AjxImg.setImage(this,this._hovImg)
}
DwtEventManager.notifyListeners(DwtEvent.ONMOUSEDOWN,e);
var i=DwtControl.getTargetControl(t);
if(i){
if(i.getMenu()&&i.getMenu().isPoppedUp()){
i.getMenu().popdown()
}else{
if(i._menu instanceof AjxCallback){
i.popup()
}
if(i._dropDownEvtMgr.isListenerRegistered(DwtEvent.SELECTION)){
var a=DwtShell.selectionEvent;
DwtUiEvent.copy(a,e);
a.item=i;
i._dropDownEvtMgr.notifyListeners(DwtEvent.SELECTION,a)
}else{
i._toggleMenu()
}}}}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
};
DwtButton._mouseOverListener=function(i){
var t=i.dwtObj;
if(!t){
return false
}
t._showHoverImage(true);
t.setDisplayState(DwtControl.HOVER);
var o=t._dropDownEl;
if(t._menu&&o&&t._dropDownHovImg&&!t.noMenuBar&&t.isListenerRegistered(DwtEvent.SELECTION)){
if(t._dropDownHovImg){
AjxImg.setImage(o,t._dropDownHovImg)
}}
if(AjxEnv.isIE){
if(i&&i.target&&i.target.firstChild){
var a=i.target.firstChild;
var e=a.className;
a.className="";
a.className=e
}}
i._stopPropagation=true
};
DwtButton._mouseOutListener=function(t){
var e=t.dwtObj;
if(!e){
return false
}
e._showHoverImage(false);
e._setMouseOutClassName();
e.isActive=false;
var a=e._dropDownEl;
if(e._menu&&a&&e._dropDownImg){
AjxImg.setImage(a,e._dropDownImg)
}};
DwtButton._mouseDownListener=function(t){
var e=t.dwtObj;
if(!e){
return false
}
if(e._isDropDownEvent(t)){
return DwtButton._dropDownCellMouseDownHdlr(t)
}
if(t.button!=DwtMouseEvent.LEFT){
return
}
var a=e._dropDownEl;
if(e._menu&&a&&e._dropDownDepImg){
AjxImg.setImage(a,e._dropDownDepImg)
}
switch(e._actionTiming){
case DwtButton.ACTION_MOUSEDOWN:e.trigger();
e._handleClick(t);
break;
case DwtButton.ACTION_MOUSEUP:e.trigger();
break
}};
DwtButton._mouseUpListener=function(a){
var e=a.dwtObj;
if(!e){
return false
}
if(e._isDropDownEvent(a)){
return DwtButton._dropDownCellMouseUpHdlr(a)
}
if(a.button!=DwtMouseEvent.LEFT){
return
}
var i=e._dropDownEl;
if(e._menu&&i&&e._dropDownHovImg&&!e.noMenuBar){
AjxImg.setImage(i,e._dropDownHovImg)
}
switch(e._actionTiming){
case DwtButton.ACTION_MOUSEDOWN:e.deactivate();
break;
case DwtButton.ACTION_MOUSEUP:var t=e.getHtmlElement();
if(e.isActive){
e.deactivate();
e._handleClick(a)
}
break
}};
DwtButton._listeners={};
DwtButton._listeners[DwtEvent.ONMOUSEOVER]=new AjxListener(null,DwtButton._mouseOverListener);
DwtButton._listeners[DwtEvent.ONMOUSEOUT]=new AjxListener(null,DwtButton._mouseOutListener);
DwtButton._listeners[DwtEvent.ONMOUSEDOWN]=new AjxListener(null,DwtButton._mouseDownListener);
DwtButton._listeners[DwtEvent.ONMOUSEUP]=new AjxListener(null,DwtButton._mouseUpListener);
DwtButton._listeners[DwtEvent.ONMOUSEENTER]=new AjxListener(null,DwtButton._mouseOverListener);
DwtButton._listeners[DwtEvent.ONMOUSELEAVE]=new AjxListener(null,DwtButton._mouseOutListener);
