
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtCheckbox=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtCheckbox.PARAMS);
e.className=e.className||"DwtCheckbox";
DwtControl.call(this,e);
this._textPosition=DwtCheckbox.DEFAULT_POSITION;
this._initName=e.name;
this._initValue=e.value;
this._initChecked=e.checked;
this._createHtml()
};
DwtCheckbox.prototype=new DwtControl;
DwtCheckbox.prototype.constructor=DwtCheckbox;
DwtCheckbox.prototype.toString=function(){
return"DwtCheckbox"
};
DwtCheckbox.PARAMS=["parent","style","name","checked","className","posStyle","id","index","value"];
DwtCheckbox.TEXT_LEFT="left";
DwtCheckbox.TEXT_RIGHT="right";
DwtCheckbox.DEFAULT_POSITION=DwtCheckbox.TEXT_RIGHT;
DwtCheckbox.prototype.TEMPLATE="dwt.Widgets#DwtCheckbox";
DwtCheckbox.prototype.getTabGroupMember=function(){
return this._inputEl
};
DwtCheckbox.prototype.focus=function(){
if(this._inputEl){
this._inputEl.focus();
DwtShell.getShell(window).getKeyboardMgr().grabFocus(this.getTabGroupMember())
}};
DwtCheckbox.prototype.blur=function(){
if(this._inputEl){
this._inputEl.blur()
}};
DwtCheckbox.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtCheckbox.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtCheckbox.prototype.setEnabled=function(e){
if(e!=this._enabled){
DwtControl.prototype.setEnabled.call(this,e);
this._inputEl.disabled=!e;
var t=e?"Text":"DisabledText";
if(this._textElLeft){
this._textElLeft.className=t
}
if(this._textElRight){
this._textElRight.className=t
}}};
DwtCheckbox.prototype.setSelected=function(e){
if(this._inputEl&&this._inputEl.checked!=e){
this._inputEl.checked=e
}};
DwtCheckbox.prototype.isSelected=function(){
return this._inputEl&&this._inputEl.checked
};
DwtCheckbox.prototype.setText=function(e){
if(this._textEl&&this._text!=e){
this._text=e;
this._textEl.innerHTML=e||""
}};
DwtCheckbox.prototype.getText=function(){
return this._text
};
DwtCheckbox.prototype.setTextPosition=function(e){
this._textEl=e==DwtCheckbox.TEXT_LEFT?this._textElLeft:this._textElRight;
if(this._textPosition!=e){
this._textPosition=e;
if(this._textElLeft){
this._textElLeft.innerHTML=""
}
if(this._textElRight){
this._textElRight.innerHTML=""
}
this.setText(this._text)
}};
DwtCheckbox.prototype.getTextPosition=function(){
return this._textPosition
};
DwtCheckbox.prototype.setValue=function(t){
var e=this._inputEl||this;
if(e.value!==t){
e.value=t
}};
DwtCheckbox.prototype.getValue=function(){
var e=this._inputEl||this;
return e.value!=null?e.value:this.getText()
};
DwtCheckbox.prototype.getInputElement=function(){
return this._inputEl
};
DwtCheckbox.prototype.setToolTipContent=function(e){
if(e&&!this.__mouseEventsSet){
this.__mouseEventsSet=true;
this._setMouseEvents()
}
DwtControl.prototype.setToolTipContent.apply(this,arguments)
};
DwtCheckbox.prototype._replaceElementHook=function(t,a,e,i){
a=this.getInputElement();
DwtControl.prototype._replaceElementHook.call(this,t,a,e,i);
if(t.id){
this.setHtmlElementId(t.id+"_control");
a.id=t.id;
if(this._textEl){
this._textEl.setAttribute("for",t.id)
}}};
DwtCheckbox.prototype._createHtml=function(e){
var t={
id:this._htmlElId};
this._createHtmlFromTemplate(e||this.TEMPLATE,t)
};
DwtCheckbox.prototype._createHtmlFromTemplate=function(t,a){
a.name=this._initName||this._htmlElId;
a.value=this._initValue;
a.checked=Boolean(this._initChecked)?"checked":"";
DwtControl.prototype._createHtmlFromTemplate.call(this,t,a);
this._inputEl=document.getElementById(a.id+"_input");
if(this._inputEl){
var e=DwtShell.getShell(window).getKeyboardMgr();
var i=AjxCallback.simpleClosure(e.grabFocus,e,this.getTabGroupMember());
Dwt.setHandler(this._inputEl,DwtEvent.ONFOCUS,i);
Dwt.setHandler(this._inputEl,DwtEvent.ONCLICK,DwtCheckbox.__handleClick)
}
this._textElLeft=document.getElementById(a.id+"_text_left");
this._textElRight=document.getElementById(a.id+"_text_right");
this.setTextPosition(this._textPosition)
};
DwtCheckbox.__handleClick=function(e){
var t=DwtUiEvent.getEvent(e);
var o=DwtUiEvent.getTarget(t);
var i=DwtShell.selectionEvent;
DwtUiEvent.copy(i,t);
i.item=this;
i.detail=o.checked;
var a=DwtControl.findControl(o);
a.setSelected(o.checked);
a.notifyListeners(DwtEvent.SELECTION,i)
};
