
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtColorPicker=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtColorPicker.PARAMS);
e.className=e.className||"DwtColorPicker";
DwtComposite.call(this,e);
this._hideNoFill=e.hideNoFill;
this._noFillLabel=e.noFillLabel;
this._allowColorInput=e.allowColorInput;
this._defaultColor=e.defaultColor||"#000000";
this._createHtml()
};
DwtColorPicker.prototype=new DwtComposite;
DwtColorPicker.prototype.constructor=DwtColorPicker;
DwtColorPicker.prototype.toString=function(){
return"DwtColorPicker"
};
DwtColorPicker.PARAMS=["parent","className","posStyle","noFillLabel","allowColorInput","defaultColor"];
DwtColorPicker._RGB_RE=/^rgb\(([0-9]{1,3}),\s*([0-9]{1,3}),\s*([0-9]{1,3})\)$/;
DwtColorPicker._HEX_RE=/^\#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/i;
DwtColorPicker.prototype.TEMPLATE="dwt.Widgets#DwtColorPicker";
DwtColorPicker.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtColorPicker.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtColorPicker.prototype.dispose=function(){
if(this._disposed){
return
}
DwtControl.prototype.dispose.call(this)
};
DwtColorPicker.prototype._createHtml=function(e){
this._createHtmlFromTemplate(e||this.TEMPLATE,{
id:this.getHtmlElement().id}
)
};
DwtColorPicker.prototype._createHtmlFromTemplate=function(t,n){
n.allowColorInput=this._allowColorInput;
n.hideNoFill=this._hideNoFill;
n.noFillLabel=this._noFillLabel;
DwtComposite.prototype._createHtmlFromTemplate.apply(this,arguments);
if(n.allowColorInput){
var u=document.getElementById(n.id+"_input");
var h={
parent:this,validationStyle:DwtInputField.CONTINUAL_VALIDATION,errorIconStyle:DwtInputField.ERROR_ICON_RIGHT,validator:DwtColorPicker.__isValidInputValue};
var d=this._colorInput=new DwtInputField(h);
d.replaceElement(u);
var i=new AjxCallback(this,this._updatePreview);
d.setValidationCallback(i);
var c=this._error=new DwtLabel({
parent:this}
);
var e=document.getElementById(n.id+"_error");
c.replaceElement(e);
c.setVisible(false);
this._preview=document.getElementById(n.id+"_preview");
var l=document.getElementById(n.id+"_button");
var s=new DwtButton({
parent:this}
);
s.setText(AjxMsg.setColor);
s.replaceElement(l);
s.addSelectionListener(new AjxListener(this,this._handleSetColor))
}
var l=document.getElementById(n.id+"_default");
if(l){
if(!DwtColorPicker.Button){
DwtColorPicker.__defineClasses()
}
var s=this._defaultColorButton=new DwtColorPicker.Button({
parent:this}
);
s.setText(n.noFillLabel||AjxMsg.colorsUseDefault);
s.replaceElement(l);
s.addSelectionListener(new AjxListener(this,this._handleColorSelect,[null]))
}
var o=document.getElementById(n.id+"_colors");
var a=AjxEnv.isIE?DwtEvent.ONMOUSEENTER:DwtEvent.ONMOUSEOVER;
var r=AjxEnv.isIE?DwtEvent.ONMOUSELEAVE:DwtEvent.ONMOUSEOUT;
Dwt.setHandler(o,DwtEvent.ONMOUSEDOWN,AjxCallback.simpleClosure(this._handleMouseDown,this));
Dwt.setHandler(o,DwtEvent.ONMOUSEUP,AjxCallback.simpleClosure(this._handleMouseUp,this));
Dwt.setHandler(o,a,AjxCallback.simpleClosure(this._handleMouseOver,this));
Dwt.setHandler(o,r,AjxCallback.simpleClosure(this._handleMouseOut,this))
};
DwtColorPicker.prototype._handleMouseOver=function(e){
var t=DwtUiEvent.getEvent(e);
var a=DwtUiEvent.getTarget(t);
if(!Dwt.hasClass(a,"Color")){
return
}
this._handleMouseOut(e);
Dwt.addClass(a,DwtControl.HOVER);
this._mouseOverEl=a
};
DwtColorPicker.prototype._handleMouseOut=function(e){
if(this._mouseOverEl){
Dwt.delClass(this._mouseOverEl,DwtControl.HOVER)
}
this._mouseOverEl=null
};
DwtColorPicker.prototype._handleMouseDown=function(e){
var t=DwtUiEvent.getEvent(e);
var a=DwtUiEvent.getTarget(t);
this._mouseDownEl=Dwt.hasClass(a,"Color")?a:null
};
DwtColorPicker.prototype._handleMouseUp=function(e){
var t=DwtUiEvent.getEvent(e);
var i=DwtUiEvent.getTarget(t);
if(this._mouseDownEl!=i){
return
}
var a=DwtCssStyle.getProperty(i,"background-color");
this._handleColorSelect(DwtColorPicker.__color2hex(a))
};
DwtColorPicker.prototype._handleSetColor=function(e){
var t=this._colorInput.getValue();
if(t){
t=DwtColorPicker.__color2hex(t);
if(!t){
return
}
this._handleColorSelect(t)
}};
DwtColorPicker.prototype._handleColorSelect=function(e){
this._inputColor=e;
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}
if(this.isListenerRegistered(DwtEvent.SELECTION)){
var t=DwtShell.selectionEvent;
t.item=this;
t.detail=this._inputColor;
this.notifyListeners(DwtEvent.SELECTION,t)
}};
DwtColorPicker.prototype.getInputColor=function(){
return this._inputColor
};
DwtColorPicker.prototype.setDefaultColor=function(e){
if(this._defaultColorButton){
this._defaultColorButton.setDefaultColor(e)
}};
DwtColorPicker.__color2hex=function(a){
if(a=="white"){
return"#FFFFFF"
}
if(a=="black"){
return"#000000"
}
var e=a&&a.match(DwtColorPicker._RGB_RE);
if(e){
for(var t=1;
t<=3;
t++){
if(parseInt(e[t])>255){
return""
}}
return AjxColor.color(e[1],e[2],e[3])
}
e=a&&a.match(DwtColorPicker._HEX_RE);
if(e){
return a
}
return""
};
DwtColorPicker.__isValidInputValue=function(e){
if(!e){
return e
}
var t=DwtColorPicker.__color2hex(e);
if(!t){
throw AjxMsg.colorFormatError
}
return e
};
DwtColorPicker.prototype._updatePreview=function(a,t,e){
if(t){
e=DwtColorPicker.__color2hex(e);
Dwt.setVisible(this._preview,true);
this._preview.style.backgroundColor=e;
this._error.setVisible(false)
}else{
Dwt.setVisible(this._preview,false);
this._error.setVisible(true);
this._error.setText(AjxMsg.colorFormatError)
}};
DwtColorPicker.__defineClasses=function(){
DwtColorPicker.Button=function(e){
e.className=e.className||"DwtColorPickerButton";
DwtButton.call(this,e);
this._colorDiv=document.getElementById(this.getHtmlElement().id+"_color")
};
DwtColorPicker.Button.prototype=new DwtButton;
DwtColorPicker.Button.prototype.constructor=DwtColorPicker.Button;
DwtColorPicker.Button.prototype.setDefaultColor=function(e){
this._colorDiv.style.backgroundColor=e
};
DwtColorPicker.Button.prototype.toString=function(){
return"DwtColorPickerButton"
};
DwtColorPicker.Button.prototype.TEMPLATE="dwt.Widgets#DwtColorPickerButton"
};
