
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtDialog=function(t){
if(arguments.length==0){
return
}
t=Dwt.getParams(arguments,DwtDialog.PARAMS);
t.className=t.className||"DwtDialog";
this._title=t.title=t.title||"";
var a=t.standardButtons;
var l=t.extraButtons;
if(!a){
a=[DwtDialog.OK_BUTTON,DwtDialog.CANCEL_BUTTON]
}else{
if(a==DwtDialog.NO_BUTTONS){
a=null
}else{
if(a&&!a.length){
a=[a]
}}}
this._buttonList=[];
var d={};
d[DwtDialog.ALIGN_LEFT]=[];
d[DwtDialog.ALIGN_CENTER]=[];
d[DwtDialog.ALIGN_RIGHT]=[];
if(a||l){
this._buttonDesc={};
if(a&&a.length){
this._initialEnterButtonId=this._enterButtonId=a[0];
for(var o=0;
o<a.length;
o++){
var h=a[o];
this._buttonList.push(h);
var r=DwtDialog.ALIGN[h];
if(r){
d[r].push(h)
}
this._buttonDesc[h]=new DwtDialog_ButtonDescriptor(h,AjxMsg[DwtDialog.MSG_KEY[h]],r)
}
this._resetCallbacks()
}
if(l&&l.length){
if(!this._enterButtonId){
this._initialEnterButtonId=this._enterButtonId=l[0]
}
for(var o=0;
o<l.length;
o++){
var h=l[o].id;
this._buttonList.push(h);
var r=l[o].align;
if(r){
d[r].push(h)
}
this._buttonDesc[h]=l[o]
}}}
this._buttonElementId={};
for(var o=0;
o<this._buttonList.length;
o++){
var h=this._buttonList[o];
this._buttonElementId[h]=this._buttonDesc[h].label?this._buttonDesc[h].label+"_"+Dwt.getNextId():Dwt.getNextId()
}
DwtBaseDialog.call(this,t);
this._button={};
for(var o=0;
o<this._buttonList.length;
o++){
var h=this._buttonList[o];
var c=this._button[h]=new DwtButton({
parent:this,id:this._htmlElId+"_button"+h}
);
c.setText(this._buttonDesc[h].label);
c.buttonId=h;
c.addSelectionListener(new AjxListener(this,this._buttonListener));
var e=document.getElementById(this._buttonElementId[h]);
if(e){
e.appendChild(c.getHtmlElement())
}}
var s=d[DwtDialog.ALIGN_LEFT].concat(d[DwtDialog.ALIGN_CENTER],d[DwtDialog.ALIGN_RIGHT]);
for(var o=0;
o<s.length;
o++){
var n=this._button[s[o]];
this._tabGroup.addMember(n)
}};
DwtDialog.PARAMS=["parent","className","title","standardButtons","extraButtons","zIndex","mode","loc","id"];
DwtDialog.prototype=new DwtBaseDialog;
DwtDialog.prototype.constructor=DwtDialog;
DwtDialog.prototype.toString=function(){
return"DwtDialog"
};
DwtDialog.ALIGN_LEFT=1;
DwtDialog.ALIGN_RIGHT=2;
DwtDialog.ALIGN_CENTER=3;
DwtDialog.CANCEL_BUTTON=1;
DwtDialog.OK_BUTTON=2;
DwtDialog.DISMISS_BUTTON=3;
DwtDialog.NO_BUTTON=4;
DwtDialog.YES_BUTTON=5;
DwtDialog.LAST_BUTTON=5;
DwtDialog.NO_BUTTONS=256;
DwtDialog.ALL_BUTTONS=[DwtDialog.CANCEL_BUTTON,DwtDialog.OK_BUTTON,DwtDialog.DISMISS_BUTTON,DwtDialog.NO_BUTTON,DwtDialog.YES_BUTTON];
DwtDialog.MSG_KEY={};
DwtDialog.MSG_KEY[DwtDialog.CANCEL_BUTTON]="cancel";
DwtDialog.MSG_KEY[DwtDialog.OK_BUTTON]="ok";
DwtDialog.MSG_KEY[DwtDialog.DISMISS_BUTTON]="dismiss";
DwtDialog.MSG_KEY[DwtDialog.NO_BUTTON]="no";
DwtDialog.MSG_KEY[DwtDialog.YES_BUTTON]="yes";
DwtDialog.ALIGN={};
DwtDialog.ALIGN[DwtDialog.CANCEL_BUTTON]=DwtDialog.ALIGN_RIGHT;
DwtDialog.ALIGN[DwtDialog.OK_BUTTON]=DwtDialog.ALIGN_RIGHT;
DwtDialog.ALIGN[DwtDialog.DISMISS_BUTTON]=DwtDialog.ALIGN_RIGHT;
DwtDialog.ALIGN[DwtDialog.NO_BUTTON]=DwtDialog.ALIGN_RIGHT;
DwtDialog.ALIGN[DwtDialog.YES_BUTTON]=DwtDialog.ALIGN_RIGHT;
DwtDialog.MODELESS=DwtBaseDialog.MODELESS;
DwtDialog.MODAL=DwtBaseDialog.MODAL;
DwtDialog.prototype.CONTROLS_TEMPLATE="dwt.Widgets#DwtDialogControls";
DwtDialog.prototype.popdown=function(){
DwtBaseDialog.prototype.popdown.call(this);
this.resetButtonStates()
};
DwtDialog.prototype.popup=function(e,t){
this._focusButtonId=t;
DwtBaseDialog.prototype.popup.call(this,e)
};
DwtDialog.prototype._resetTabFocus=function(){
if(this._focusButtonId){
var e=this.getButton(this._focusButtonId);
this._tabGroup.setFocusMember(e,true)
}else{
DwtBaseDialog.prototype._resetTabFocus.call(this)
}};
DwtDialog.prototype.reset=function(){
this._resetCallbacks();
this.resetButtonStates();
DwtBaseDialog.prototype.reset.call(this)
};
DwtDialog.prototype.resetButtonStates=function(){
for(b in this._button){
this._button[b].setEnabled(true);
this._button[b].setHovered(false)
}
this.associateEnterWithButton(this._initialEnterButtonId)
};
DwtDialog.prototype.getButton=function(e){
return this._button[e]
};
DwtDialog.prototype.setButtonEnabled=function(t,e){
this._button[t].setEnabled(e)
};
DwtDialog.prototype.setButtonVisible=function(e,t){
this._button[e].setVisible(t)
};
DwtDialog.prototype.getButtonEnabled=function(e){
return this._button[e].getEnabled()
};
DwtDialog.prototype.registerCallback=function(t,a,i,e){
this._buttonDesc[t].callback=(a instanceof AjxCallback)?a:(new AjxCallback(i,a,e))
};
DwtDialog.prototype.unregisterCallback=function(e){
this._buttonDesc[e].callback=null
};
DwtDialog.prototype.setButtonListener=function(e,t){
this._button[e].removeSelectionListeners();
this._button[e].addSelectionListener(t)
};
DwtDialog.prototype.setEnterListener=function(e){
this.removeAllListeners(DwtEvent.ENTER);
this.addEnterListener(e)
};
DwtDialog.prototype.associateEnterWithButton=function(e){
this._enterButtonId=e
};
DwtDialog.prototype.getKeyMapName=function(){
return"DwtDialog"
};
DwtDialog.prototype.handleKeyAction=function(e,t){
switch(e){
case DwtKeyMap.ENTER:this.notifyListeners(DwtEvent.ENTER,t);
break;
case DwtKeyMap.CANCEL:var a=false;
a=a||this._runCallbackForButtonId(DwtDialog.CANCEL_BUTTON);
a=a||this._runCallbackForButtonId(DwtDialog.NO_BUTTON);
a=a||this._runCallbackForButtonId(DwtDialog.DISMISS_BUTTON);
if(!a&&this._buttonDesc[DwtDialog.OK_BUTTON]&&this._buttonList.length==1){
a=a||this._runCallbackForButtonId(DwtDialog.OK_BUTTON)
}
this.popdown();
return true;
case DwtKeyMap.YES:if(this._buttonDesc[DwtDialog.YES_BUTTON]){
this._runCallbackForButtonId(DwtDialog.YES_BUTTON)
}
break;
case DwtKeyMap.NO:if(this._buttonDesc[DwtDialog.NO_BUTTON]){
this._runCallbackForButtonId(DwtDialog.NO_BUTTON)
}
break;
default:return false
}
return true
};
DwtDialog.prototype._createHtmlFromTemplate=function(a,o){
DwtBaseDialog.prototype._createHtmlFromTemplate.call(this,a,o);
var i=o.id+"_focus";
if(document.getElementById(i)){
this._focusElementId=i
}
this._buttonsEl=document.getElementById(o.id+"_buttons");
if(this._buttonsEl){
var t=[];
var e=0;
this._addButtonsHtml(t,e);
this._buttonsEl.innerHTML=t.join("")
}};
DwtDialog.prototype._getButtonsContainerStartTemplate=function(){
return"<table cellspacing='0' cellpadding='0' border='0' width='100%'><tr>"
};
DwtDialog.prototype._getButtonsAlignStartTemplate=function(){
return"<td align=\"{0}\"><table cellspacing='5' cellpadding='0' border='0'><tr>"
};
DwtDialog.prototype._getButtonsAlignEndTemplate=function(){
return"</tr></table></td>"
};
DwtDialog.prototype._getButtonsCellTemplate=function(){
return'<td id="{0}"></td>'
};
DwtDialog.prototype._getButtonsContainerEndTemplate=function(){
return"</tr></table>"
};
DwtDialog.prototype._addButtonsHtml=function(s,t){
if(this._buttonList&&this._buttonList.length){
var a=new Array();
var e=new Array();
var n=new Array();
for(var o=0;
o<this._buttonList.length;
o++){
var r=this._buttonList[o];
switch(this._buttonDesc[r].align){
case DwtDialog.ALIGN_RIGHT:e.push(r);
break;
case DwtDialog.ALIGN_LEFT:a.push(r);
break;
case DwtDialog.ALIGN_CENTER:n.push(r);
break
}}
s[t++]=this._getButtonsContainerStartTemplate();
if(a.length){
s[t++]=AjxMessageFormat.format(this._getButtonsAlignStartTemplate(),["left"]);
for(var o=0;
o<a.length;
o++){
var r=a[o];
var h=this._buttonDesc[r].cellTemplate?this._buttonDesc[r].cellTemplate:this._getButtonsCellTemplate();
s[t++]=AjxMessageFormat.format(h,[this._buttonElementId[r]])
}
s[t++]=this._getButtonsAlignEndTemplate()
}
if(n.length){
s[t++]=AjxMessageFormat.format(this._getButtonsAlignStartTemplate(),["center"]);
for(var o=0;
o<n.length;
o++){
var r=n[o];
var h=this._buttonDesc[r].cellTemplate?this._buttonDesc[r].cellTemplate:this._getButtonsCellTemplate();
s[t++]=AjxMessageFormat.format(h,[this._buttonElementId[r]])
}
s[t++]=this._getButtonsAlignEndTemplate()
}
if(e.length){
s[t++]=AjxMessageFormat.format(this._getButtonsAlignStartTemplate(),["right"]);
for(var o=0;
o<e.length;
o++){
var r=e[o];
var h=this._buttonDesc[r].cellTemplate?this._buttonDesc[r].cellTemplate:this._getButtonsCellTemplate();
s[t++]=AjxMessageFormat.format(h,[this._buttonElementId[r]])
}
s[t++]=this._getButtonsAlignEndTemplate()
}
s[t++]=this._getButtonsContainerEndTemplate()
}
return t
};
DwtDialog.prototype._buttonListener=function(a,e){
var i=DwtControl.getTargetControl(a);
var t=(i&&i.buttonId)||this._enterButtonId;
if(t){
this._runCallbackForButtonId(t,e)
}};
DwtDialog.prototype._runCallbackForButtonId=function(i,e){
var t=this._buttonDesc[i];
var a=t&&t.callback;
if(!a){
return false
}
e=(e instanceof Array)?e:[e];
a.run.apply(a,e);
return true
};
DwtDialog.prototype._runEnterCallback=function(e){
if(this._enterButtonId&&this.getButtonEnabled(this._enterButtonId)){
this._runCallbackForButtonId(this._enterButtonId,e)
}};
DwtDialog.prototype._resetCallbacks=function(){
if(this._buttonDesc){
for(var e=0;
e<DwtDialog.ALL_BUTTONS.length;
e++){
var t=DwtDialog.ALL_BUTTONS[e];
if(this._buttonDesc[t]){
this._buttonDesc[t].callback=new AjxCallback(this,this.popdown)
}}}};
DwtDialog_ButtonDescriptor=function(o,e,i,a,t){
this.id=o;
this.label=e;
this.align=i;
this.callback=a;
this.cellTemplate=t
};
