
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtForm=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtForm.PARAMS);
e.className=e.className||"DwtForm";
DwtComposite.apply(this,arguments);
this.setScrollStyle(DwtControl.SCROLL);
this._tabGroup=new DwtTabGroup(this._htmlElId);
this._context={
set:AjxCallback.simpleClosure(this.set,this),get:AjxCallback.simpleClosure(this.get,this)};
this._dirty={};
this._ignore={};
this._invalid={};
this._errorMessages={};
this.setModel(e.model);
this.setForm(e.form);
this.reset()
};
DwtForm.prototype=new DwtComposite;
DwtForm.prototype.constructor=DwtForm;
DwtForm.prototype.toString=function(){
return"DwtForm"
};
DwtForm.PARAMS=DwtControl.PARAMS.concat("form","model");
DwtForm.prototype.setValue=function(n,a,t){
if(typeof n!="string"){
n=String(n)
}
if(n.match(/\./)||n.match(/\[/)){
var o=n.replace(/\[(\d+)\](\.)?/,".$1$2").split(".");
var i=this.getControl(o[0]);
if(Dwt.instanceOf(i,"DwtForm")){
i.setValue(o.slice(1).join("."),a,t)
}
return
}
var e=this._items[n];
if(!e){
return
}
if(!t&&a==e.value){
return
}
this._setModelValue(n,a);
this._setControlValue(n,a)
};
DwtForm.prototype.getValue=function(n,e){
if(typeof n!="string"){
n=String(n)
}
if(n.match(/\./)||n.match(/\[/)){
var o=n.replace(/\[(\d+)\](\.)?/,".$1$2").split(".");
var i=this.getControl(o[0]);
if(Dwt.instanceOf(i,"DwtForm")){
return i.getValue(o.slice(1).join("."))
}
return null
}
var t=this._items[n];
if(!t){
return
}
if(t.getter){
return this._call(t.getter)||e
}
var a=this._getControlValue(n);
if(a==null){
a=t.value
}
return a||e||""
};
DwtForm.prototype.getControl=function(t){
if(typeof t!="string"){
t=String(t)
}
var e=this._items[t];
return e&&e.control
};
DwtForm.prototype.isRelevant=function(e){
return this.isVisible(e)&&this.isEnabled(e)
};
DwtForm.prototype.getTabGroupMember=function(){
return this._tabGroup
};
DwtForm.prototype.setLabel=function(i,e){
var t=this._items[i];
if(!t){
return
}
if(e==this.getLabel(i)){
return
}
var a=t.control;
if(!a){
return
}
if(a.setLabel){
a.setLabel(e);
return
}
if(a.setText){
a.setText(e);
return
}};
DwtForm.prototype.getLabel=function(a){
var e=this._items[a];
var t=e&&e.control;
if(t){
if(t.getLabel){
return t.getLabel()
}
if(t.getText){
return t.getText()
}}
return""
};
DwtForm.prototype.setVisible=function(o,i){
if(arguments.length==1){
DwtComposite.prototype.setVisible.call(this,arguments[0]);
return
}
var t=this._items[o];
var a=t&&t.control;
if(!a){
return
}
if(a.setVisible){
a.setVisible(i)
}else{
Dwt.setVisible(a,i)
}
var e=document.getElementById([this._htmlElId,o,"row"].join("_"));
if(e){
Dwt.setVisible(e,i)
}};
DwtForm.prototype.isVisible=function(a){
if(arguments.length==0){
return DwtComposite.prototype.isVisible.call(this)
}
var e=this._items[a];
var t=e&&e.control;
if(!t){
return false
}
if(t.getVisible){
return t.getVisible()
}
if(t.isVisible){
return t.isVisible()
}
return Dwt.getVisible(t)
};
DwtForm.prototype.setEnabled=function(i,e){
if(arguments.length==1){
DwtComposite.prototype.setEnabled.call(this,arguments[0]);
return
}
var t=this._items[i];
var a=t&&t.control;
if(!a){
return
}
if(a.setEnabled){
a.setEnabled(e)
}else{
a.disabled=!e
}};
DwtForm.prototype.isEnabled=function(a){
if(arguments.length==0){
return DwtComposite.prototype.isEnabled.call(this)
}
var e=this._items[a];
var t=e&&e.control;
if(!t){
return false
}
if(t.isEnabled){
return t.isEnabled()
}
if(t.getEnabled){
return t.getEnabled()
}
return !t.disabled
};
DwtForm.prototype.setValid=function(t,e){
if(typeof(t)=="boolean"){
e=arguments[0];
for(t in this._items){
this.setValid(t,e)
}
return
}
if(e){
delete this._invalid[t]
}else{
this._invalid[t]=true
}};
DwtForm.prototype.isValid=function(e){
if(arguments.length==0||AjxUtil.isUndefined(e)){
for(var e in this._invalid){
return false
}
return true
}
return !(e in this._invalid)
};
DwtForm.prototype.setErrorMessage=function(t,e){
if(!t||t==""){
this._errorMessages={};
return
}
if(!e){
delete this._errorMessages[t]
}else{
this._errorMessages[t]=e
}};
DwtForm.prototype.getErrorMessage=function(t){
if(arguments.length==0){
var e={};
for(var t in this._invalid){
e[t]=this._errorMessages[t]
}
return e
}
return this._errorMessages[t]
};
DwtForm.prototype.getInvalidItems=function(){
return AjxUtil.keys(this._invalid)
};
DwtForm.prototype.setDirty=function(i,t,e){
if(typeof i=="boolean"){
t=arguments[0];
for(i in this._items){
this.setDirty(i,t,true)
}
if(!e&&this._ondirty){
this._call(this._ondirty,["*"])
}
return
}
if(t){
this._dirty[i]=true
}else{
delete this._dirty[i]
}
if(!e&&this._ondirty){
var a=this._items[i];
if(!a.ignore||!this._call(a.ignore)){
this._call(this._ondirty,[i])
}}};
DwtForm.prototype.isDirty=function(t){
if(arguments.length==0){
for(var t in this._dirty){
var e=this._items[t];
if(e.ignore&&this._call(e.ignore)){
continue
}
return true
}
return false
}
var e=this._items[t];
return e.ignore&&this._call(e.ignore)?false:t in this._dirty
};
DwtForm.prototype.getDirtyItems=function(){
DwtForm.__acceptDirtyItem.form=this;
return AjxUtil.keys(this._dirty,DwtForm.__acceptDirtyItem)
};
DwtForm.__acceptDirtyItem=function(a){
var t=arguments.callee.form;
var e=t._items[a];
return !e.ignore||!t._call(e.ignore)
};
DwtForm.prototype.setIgnore=function(t,e){
if(typeof t=="boolean"){
this._ignore={};
return
}
if(e){
this._ignore[t]=true;
return
}
delete this._ignore[t]
};
DwtForm.prototype.isIgnore=function(e){
return e in this._ignore
};
DwtForm.prototype.set=function(t,e){
this.setValue(t,e,true);
this.update()
};
DwtForm.prototype.get=DwtForm.prototype.getValue;
DwtForm.prototype.setModel=function(e,t){
this._context.model=this.model=e
};
DwtForm.prototype.setForm=function(e){
this._context.form=this.form=e;
this._createHtml(e.template)
};
DwtForm.prototype.validate=function(e){
if(arguments.length==0){
this.setValid(true);
for(var e in this._items){
this._validateItem(e)
}
return this.isValid()
}
return this._validateItem(e)
};
DwtForm.prototype._validateItem=function(s){
if(!s){
return true
}
var i=this._items[s];
if(!i){
return true
}
try{
var o=this.getValue(s);
var a=i.validator?i.validator(o):((i.control&&i.control.validator)?i.control.validator(o):true);
this.setValid(s,Boolean(a)||a==="");
if(AjxUtil.isString(a)||AjxUtil.isObject(a)){
this._setControlValue(s,a);
i.value=i.setter?this._call(i.setter,[a]):a;
var t=!Boolean(this._call(i.equals,[i.value,i.ovalue]));
this.setDirty(s,t)
}}
catch(n){
this.setErrorMessage(s,AjxUtil.isString(n)?n:n.message);
this.setValid(s,false)
}
return !(s in this._invalid)
};
DwtForm.prototype.reset=function(i){
this._dirty={};
this._ignore={};
this._invalid={};
for(var a in this._items){
var t=this._items[a];
if(t.control instanceof DwtForm){
t.control.reset(i)
}
var e=this._items[a].def;
if(!e){
continue
}
this._initControl(e,i)
}
this.update();
for(var a in this._items){
var t=this._items[a];
t.ovalue=t.value
}
this.validate();
this.setDirty(false);
if(this._onreset){
this._call(this._onreset)
}};
DwtForm.prototype.update=function(){
for(var t in this._items){
var e=this._items[t];
if(e.control instanceof DwtForm){
e.control.update()
}
if(e.getter){
this.setValue(t,this._call(e.getter))
}}
for(var t in this._items){
var e=this._items[t];
if(e.visible){
this.setVisible(t,Boolean(this._call(e.visible)))
}
if(e.enabled){
this.setEnabled(t,Boolean(this._call(e.enabled)))
}
if(e.ignore){
this.setIgnore(t,Boolean(this._call(e.ignore)))
}}
if(this._onupdate){
this._call(this._onupdate)
}};
DwtForm.prototype._setModelValue=function(i,a){
var t=this._items[i];
t.value=t.setter?this._call(t.setter,[a]):a;
var e=!Boolean(this._call(t.equals,[t.value,t.ovalue]));
this.setDirty(i,e);
this.validate(i);
return e
};
DwtForm.prototype._setControlValue=function(a,e){
var t=this._items[a].control;
if(t){
if(t instanceof DwtCheckbox||t instanceof DwtRadioButton){
t.setSelected(e);
return
}
if(t instanceof DwtMenuItem&&t.isStyle(DwtMenuItem.CHECK_STYLE)){
t.setChecked(e,true);
return
}
if(t.setSelectedValue){
t.setSelectedValue(e);
return
}
if(t.setValue){
t.setValue(e);
return
}
if(t.setText&&!(t instanceof DwtButton)){
t.setText(e);
return
}
if(!(t instanceof DwtControl)){
if(t.type=="checkbox"||t=="radio"){
t.checked=e
}else{
t.value=e
}
return
}}};
DwtForm.prototype._getControlValue=function(t){
var e=this._items[t].control;
if(e){
if(e instanceof DwtCheckbox||e instanceof DwtRadioButton){
return e.isSelected()
}
if(e.getSelectedValue){
return e.getSelectedValue()
}
if(e.getValue){
return e.getValue()
}
if(e.getText&&!(e instanceof DwtButton)){
return e.getText()
}
if(!(e instanceof DwtControl)){
if(e.type=="checkbox"||e=="radio"){
return e.checked
}
return e.value
}}};
DwtForm.prototype._deleteItem=function(e){
delete this._items[e];
delete this._dirty[e];
delete this._invalid[e];
delete this._ignore[e]
};
DwtForm.prototype._call=function(t,e){
if(t){
if(e){
return t.apply(this,e)
}
return t.call(this)
}};
DwtForm.prototype._createHtml=function(e){
this._createHtmlFromTemplate(e||this.TEMPLATE,{
id:this._htmlElId}
)
};
DwtForm.prototype._createHtmlFromTemplate=function(t,s){
DwtComposite.prototype._createHtmlFromTemplate.apply(this,arguments);
var a=[];
this._items={};
this._tabGroup.removeAllMembers();
this._onupdate=null;
this._onreset=null;
this._ondirty=null;
var e=this.form;
if(e&&e.items){
this._registerControls(e.items,null,a);
this._onupdate=DwtForm.__makeFunc(e.onupdate);
this._onreset=DwtForm.__makeFunc(e.onreset);
this._ondirty=DwtForm.__makeFunc(e.ondirty)
}
var l=this.getHtmlElement().getElementsByTagName("A");
for(var r=0;
r<l.length;
r++){
var h=l[r];
if(!h.href||h.getAttribute("notab")=="true"){
continue
}
var c=h.id&&h.id.substr(this.getHTMLElId().length+1);
if(this._items[c]){
continue
}
a.push({
tabindex:h.getAttribute("tabindex")||Number.MAX_VALUE,control:h}
)
}
a.sort(DwtForm.__byTabIndex);
for(var r=0;
r<a.length;
r++){
var n=a[r].control;
var o=(n.getTabGroupMember&&n.getTabGroupMember())||n;
this._tabGroup.addMember(o)
}};
DwtForm.prototype._registerControls=function(a,n,e,s,o,r){
for(var t=0;
t<a.length;
t++){
this._registerControl(a[t],n,e,s,o,r)
}};
DwtForm.prototype._registerControl=function(l,s,b,y,c,n){
var f=l.id||[this._htmlElId,Dwt.getNextId()].join("_");
var g=this._items[f]={
id:f,def:l,parentDef:s,equals:DwtForm.__makeFunc(l.equals)||DwtForm.__equals,getter:DwtForm.__makeGetter(l),setter:DwtForm.__makeSetter(l),value:l.value,visible:DwtForm.__makeFunc(l.visible),enabled:DwtForm.__makeFunc(l.enabled),validator:DwtForm.__makeFunc(l.validator),ignore:DwtForm.__makeFunc(l.ignore),control:l.control};
if(l.aka){
this._items[f].aka=l.aka;
this._items[l.aka]=g
}
var d=g.control;
if(d){
return d
}
c=c||this;
var o=l.type=l.type||n;
var t=(s&&s.menu==l);
var a=document.getElementById([c._htmlElId,f].join("_"));
if(Dwt.instanceOf(o,"DwtRadioButtonGroup")){
d=new window[o]({}
);
g.control=d;
var r={
name:[c._htmlElId,f].join("_"),value:l.value};
if(l.items){
for(var p=0;
p<l.items.length;
p++){
var m=l.items[p];
var h=m.checked||m.value==l.value;
var u=this._registerControl(m,l,b,r,c,"DwtRadioButton");
this._items[m.id].value=h;
if(u){
d.addRadio(u.getInputElement().id,u,h);
var e=DwtForm.__makeFunc(m.onclick||l.onclick);
u.addSelectionListener(new AjxListener(this,this._radio2group2model,[m.id,f,e]));
DwtForm.__hack_fixRadioButtonHandler(u)
}}}}else{
if(o){
if(Dwt.instanceOf(o,"DwtInputField")){
g.value=g.value||""
}
if(Dwt.instanceOf(o,"DwtFormRows")){
g.equals=DwtFormRows.__equals
}
if(a||t){
d=g.control=this._createControl(l,s,b,y,c,n)
}}else{
if(a){
this._attachElementHandlers(l,s,b,c,a);
d=g.control=a;
if(l.items){
this._registerControls(l.items,l,b,null,c,null)
}}}}
if(a&&d instanceof DwtControl){
d.replaceElement(a)
}
if(a&&d instanceof DwtInputField){
d.getInputElement().id+="_input"
}
if(l.notab==null){
l.notab=a&&a.getAttribute("notab")=="true"
}
if(b&&d&&!l.notab&&!(d instanceof DwtRadioButtonGroup)){
b.push({
tabindex:(a&&a.getAttribute("tabindex"))||Number.MAX_VALUE,control:d}
)
}
if(d instanceof DwtListView){
g.getter=g.getter||AjxCallback.simpleClosure(this.__list_getValue,this,f);
g.setter=g.setter||AjxCallback.simpleClosure(this.__list_setValue,this,f)
}
return d
};
DwtForm.prototype._attachElementHandlers=function(s,a,i,l,n){
var t=s.id;
var e=n.nodeName.toLowerCase();
var h=n.type;
if(h=="checkbox"||h=="radio"){
var r;
if(h=="radio"){
r=n.name;
if(!this._items[r]){
this._items[r]={
id:r}
}
if(n.checked){
this._items[r].value=n.value
}}
var d=n.onclick;
var c=DwtForm.__makeFunc(s.onclick);
n.onclick=AjxCallback.simpleClosure(this._htmlInput_checked,this,t,r,c,d)
}else{
if(e=="select"){
var o=n.onchange;
var c=DwtForm.__makeFunc(s.onchange);
n.onchange=AjxCallback.simpleClosure(this._htmlSelect_selectedIndex,this,t,c,o)
}else{
if(e=="button"||e=="a"||h=="button"||h=="reset"||h=="submit"){
var d=n.onclick;
var c=DwtForm.__makeFunc(s.onclick);
n.onclick=AjxCallback.simpleClosure(this._htmlElement,this,t,c,d)
}else{
if(e=="textarea"||e=="input"){
var o=n.onchange;
var c=DwtForm.__makeFunc(s.onchange);
n.onchange=AjxCallback.simpleClosure(this._htmlInput_value,this,t,c,o)
}}}}
return n
};
DwtForm.prototype._createControl=function(u,c,S,D,f,l){
var x=u.id||[this._htmlElId,Dwt.getNextId()].join("_");
var n=u.type=u.type||l;
D=D?AjxUtil.createProxy(D):{};
D.id=D.id||[this._htmlElId,x].join("_");
D.parent=f||this;
D.template=u.template||D.template;
D.className=u.className||D.className;
var C=Dwt.instanceOf(n,"DwtRadioButton");
var k=Dwt.instanceOf(n,"DwtCheckbox");
if(C||k){
D.name=u.name||D.name;
D.value=u.value||D.value;
D.checked=u.checked!=null?u.checked:D.checked
}
var m=Dwt.instanceOf(n,"DwtInputField");
if(m){
D.type=u.password?DwtInputField.PASSWORD:null;
D.size=u.cols;
D.rows=u.rows
}
var r=Dwt.instanceOf(n,"DwtTabViewPage");
if(r){
D.contentTemplate=u.template;
delete u.template
}
var v=Dwt.instanceOf(n,"DwtTree");
if(v){
D.style=u.style
}
D.formItemDef=u;
if(u.params){
for(var q in u.params){
D[q]=u.params[q]
}}
var g=new window[n](D);
if(g instanceof DwtSelect){
var o=u.items;
if(o){
for(var A=0;
A<o.length;
A++){
var w=o[A];
w.displayValue=w.label||w.value;
g.addOption(w)
}}
var t=DwtForm.__makeFunc(u.onchange);
g.addChangeListener(new AjxListener(this,this._control2model,[x,t]))
}else{
if(g instanceof DwtButton||g instanceof DwtMenuItem){
if(u.label){
g.setText(u.label)
}
if(u.image){
g.setImage(u.image)
}
if(u.menu){
var a=Dwt.instanceOf(u.menu.type||"DwtMenu","DwtMenu");
var e;
if(a){
e=this._registerControl(u.menu,u,null,null,g,"DwtMenu")
}else{
e=new DwtMenu({
parent:g}
);
var W=Dwt.instanceOf(u.menu.type,"DwtCalendar")?DwtMenu.CALENDAR_PICKER_STYLE:DwtMenu.GENERIC_WIDGET_STYLE;
this._registerControl(u.menu,u,null,{
style:W}
,e)
}
g.setMenu(e)
}
var O;
if(f instanceof DwtToolBar||f instanceof DwtMenu){
O=c.id
}
var t=DwtForm.__makeFunc(u.onclick||(c&&c.onclick));
g.addSelectionListener(new AjxListener(this,this._item2parent,[x,O,t]))
}else{
if(g instanceof DwtCheckbox&&!(g instanceof DwtRadioButton)){
var t=DwtForm.__makeFunc(u.onclick);
g.addSelectionListener(new AjxListener(this,this._control2model,[x,t]))
}else{
if(g instanceof DwtInputField){
var j=DwtForm.__makeFunc(u.onchange);
var T=AjxCallback.simpleClosure(this._input2model2handler,this,x,j);
g.setHandler(DwtEvent.ONKEYUP,T);
var B=DwtForm.__makeFunc(u.onblur);
if(B){
var s=AjxCallback.simpleClosure(this._input2model2handler,this,x,B);
g.setHandler(DwtEvent.ONBLUR,s)
}
g.setHint(u.hint)
}else{
if(g instanceof DwtListView){
g.addSelectionListener(new AjxListener(this,this._handleListSelection,[x]))
}else{
if(g instanceof DwtMenu){
if(u.items){
var z=u.items;
for(var A=0;
A<z.length;
A++){
var b=z[A];
if(b.type==DwtMenuItem.SEPARATOR_STYLE){
new DwtMenuItem({
parent:g,style:DwtMenuItem.SEPARATOR_STYLE}
);
continue
}
this._registerControl(b,u,null,null,g,"DwtMenuItem")
}}}else{
if(g instanceof DwtTabView){
var d=u.items;
if(d){
this._registerControls(d,u,null,null,g,"DwtTabViewPage")
}}else{
if(g instanceof DwtTabViewPage&&f instanceof DwtTabView){
var F=f.addTab(u.label,g);
if(u.image){
f.getTabButton(F).setImage(u.image)
}
if(u.items){
this._registerControls(u.items,u,S,null,g)
}}else{
if(g instanceof DwtToolBar){
var y=u.items;
if(y){
for(var A=0;
A<y.length;
A++){
var h=y[A];
if(h.type==DwtToolBar.SPACER){
g.addSpacer(h.size);
continue
}
if(h.type==DwtToolBar.SEPARATOR){
g.addSeparator(h.className);
continue
}
if(h.type==DwtToolBar.FILLER){
g.addFiller(h.className);
continue
}
this._registerControl(h,u,null,null,g,"DwtToolBarButton")
}}}else{
if(g instanceof DwtCalendar){
if(u.onselect instanceof AjxListener){
g.addSelectionListener(u.onselect)
}}else{
if(g instanceof DwtComposite){
if(u.items){
this._registerControls(u.items,u,S,null,g)
}}}}}}}}}}}}
if(u.width||u.height){
if(g instanceof DwtInputField){
Dwt.setSize(g.getInputElement(),u.width,u.height)
}else{
g.setSize(u.width,u.height)
}}
return g
};
DwtForm.prototype._initControl=function(e,i){
var a=e.id;
if(e.label){
this.setLabel(a,e.label)
}
var t=this._items[a];
if(i){
t.ovalue=t.value
}else{
if(e.value){
if(Dwt.instanceOf(e.type,"DwtRadioButton")){
t.ovalue=t.value=t.control&&t.control.isSelected()
}else{
this.setValue(a,e.value,true);
t.ovalue=t.value
}}else{
t.ovalue=null
}}
if(typeof e.enabled=="boolean"){
this.setEnabled(a,e.enabled)
}
if(typeof e.visible=="boolean"){
this.setVisible(a,e.visible)
}};
DwtForm.prototype._htmlElement=function(i,a,t,e){
if(a){
this._call(a,[i])
}
if(t){
t(e)
}};
DwtForm.prototype._htmlInput_checked=function(s,n,a,t,e){
var o=this.getControl(s);
var i=o.checked;
this._setModelValue(s,i);
if(n&&i){
this._setModelValue(n,o.value)
}
this.update();
this._htmlElement(s,a,t,e)
};
DwtForm.prototype._htmlInput_value=function(i,a,t,e){
this._setModelValue(i,this.getControl(i).value);
this.update();
this._htmlElement(i,a,t,e)
};
DwtForm.prototype._htmlSelect_selectedIndex=function(o,i,a,t){
var e=this.getControl(o);
this._setModelValue(o,e.options[e.selectedIndex].value);
this.update();
this._htmlElement(o,i,a,t)
};
DwtForm.prototype._control2model=function(t,e){
this._setModelValue(t,this._getControlValue(t));
this.update();
if(e){
this._call(e,[t])
}};
DwtForm.prototype._radio2group2model=function(e,t,a){
this._setModelValue(t,this.getControl(e).getValue());
this._setModelValue(e,this._getControlValue(e));
this.update();
if(a){
this._call(a,[e])
}};
DwtForm.prototype._input2model2handler=function(t,e){
this._setModelValue(t,this._getControlValue(t));
this.update();
if(e){
this._call(e,[t])
}};
DwtForm.prototype._item2parent=function(i,o,t){
var a=this.getControl(i);
var e=this._items[i].def;
if(a instanceof DwtButtonColorPicker||(e.menu&&!e.onclick)){
a._toggleMenu()
}else{
if(o){
this._setModelValue(o,this._getControlValue(i)||i);
this.update()
}}
if(t){
this._call(t,[i])
}};
DwtForm.prototype._handleListSelection=function(t,e){
this.update()
};
DwtForm.prototype.__list_getValue=function(e){
return this.getControl(e).getSelection()
};
DwtForm.prototype.__list_setValue=function(t,e){
this.getControl(t).setSelection(e)
};
DwtForm.__makeGetter=function(s){
var t=s.getter;
if(t){
return DwtForm.__makeFunc(t)
}
var n=s.ref;
if(!n){
return null
}
var r=n.split(".");
var e=["var context = this.model;",];
for(var o=0;
o<r.length;
o++){
var a=r[o];
var h=DwtForm.__makeFuncName(a);
if(o==r.length-1){
break
}
e.push("context = context && (context.",h," ? context.",h,"() : context.",a,");")
}
e.push("var value = context ? (context.",h," ? context.",h,"() : context.",a,") : this._items.",a,".value;","return value !== undefined ? value : defaultValue;");
return new Function("defaultValue",e.join(""))
};
DwtForm.__makeSetter=function(l){
var o=l.setter;
if(o){
return DwtForm.__makeFunc(o)
}
var a=l.ref;
if(!a){
return null
}
var n=a.split(".");
var h=["var context = this.model;",];
for(var r=0;
r<n.length;
r++){
var s=r==n.length-1;
var e=n[r];
var t=DwtForm.__makeFuncName(e,s?"set":"get");
if(s){
break
}
h.push("context = context && (context.",t," ? context.",t,"() : context.",e,");")
}
h.push("if (context) {","if (context.",t,") {","context.",t,"(value);","}","else {","context.",e," = value;","}","}");
return new Function("value",h.join("\n"))
};
DwtForm.__makeFuncName=function(e,t){
return[t||"get",e.substr(0,1).toUpperCase(),e.substr(1)].join("")
};
DwtForm.__makeFunc=function(t){
if(t==null){
return null
}
if(typeof t=="function"&&!(t instanceof RegExp)){
return t
}
var e=["with (this._context) {","return (",t,");","}"].join("");
return new Function(e)
};
DwtForm.__equals=function(t,e){
return t==e
};
DwtForm.__byTabIndex=function(t,e){
return t.tabindex-e.tabindex
};
DwtForm.__hack_fixRadioButtonHandler=function(t){
var e=[t.getInputElement().onclick,DwtCheckbox.__handleClick];
var a=function(o){
for(var n=0;
n<e.length;
n++){
var s=e[n];
if(s){
s(o)
}}};
Dwt.setHandler(t.getInputElement(),DwtEvent.ONCLICK,a)
};
DwtFormRows=function(a){
if(arguments.length==0){
return
}
this._itemDef=a.formItemDef||{};
a.className=a.className||"DwtFormRows";
DwtForm.call(this,{
id:a.id,parent:a.parent,form:{}
,template:this._itemDef.template}
);
this._rowsTabGroup=new DwtTabGroup(this._htmlElId);
this._rowDef=this._itemDef.rowitem||{};
this._equals=DwtForm.__makeFunc(this._rowDef.equals)||DwtForm.__equals;
this._rowCount=0;
this._minRows=this._itemDef.minrows||1;
this._maxRows=this._itemDef.maxrows||Number.MAX_VALUE;
if(this._itemDef.rowtemplate){
this.ROW_TEMPLATE=this._itemDef.rowtemplate
}
var t=this._itemDef.items||[];
for(var e=0;
e<t.length;
e++){
this.addRow(t[e])
}
for(;
e<this._minRows;
e++){
this.addRow()
}
this._onaddrow=DwtForm.__makeFunc(this._itemDef.onaddrow);
this._onremoverow=DwtForm.__makeFunc(this._itemDef.onremoverow)
};
DwtFormRows.prototype=new DwtForm;
DwtFormRows.prototype.constructor=DwtFormRows;
DwtFormRows.prototype.toString=function(){
return"DwtFormRows"
};
DwtFormRows.prototype.TEMPLATE="dwt.Widgets#DwtFormRows";
DwtFormRows.prototype.ROW_TEMPLATE="dwt.Widgets#DwtFormRow";
DwtFormRows.prototype.getTabGroupMember=function(){
return this._rowsTabGroup
};
DwtFormRows.prototype.setValue=function(o){
if(arguments.length>1){
DwtForm.prototype.setValue.apply(this,arguments);
return
}
var a=Math.max(o.length,this._minRows);
for(var t=this._rowCount;
t>a;
t--){
this.removeRow(t-1)
}
var e=Math.min(o.length,this._maxRows);
for(var t=this._rowCount;
t<e;
t++){
this.addRow()
}
for(var t=0;
t<e;
t++){
this.setValue(String(t),o[t],true)
}
for(var t=o.length;
t<this._rowCount;
t++){
this.setValue(String(t),null,true)
}};
DwtFormRows.prototype.getValue=function(){
if(arguments.length>0){
return DwtForm.prototype.getValue.apply(this,arguments)
}
var t=new Array(this._rowCount);
for(var e=0;
e<this._rowCount;
e++){
t[e]=this.getValue(String(e))
}
return t
};
DwtFormRows.prototype.getRowCount=function(){
return this._rowCount
};
DwtFormRows.prototype.addRow=function(n,o){
if(this._rowCount>=this._maxRows){
return
}
n=n||(this._rowDef&&AjxUtil.createProxy(this._rowDef));
if(!n){
return
}
if(o==null){
o=this._rowCount
}
for(var d=this._rowCount-1;
d>=o;
d--){
var b=d,u=d+1;
var m=this._items[b];
m.aka=String(u);
delete this._items[b];
this._items[m.aka]=m;
this._setControlIds(m.id,m.aka)
}
n.id=n.id||Dwt.getNextId();
n.aka=String(o);
this._rowCount++;
var w={
id:[this.getHTMLElId(),n.id].join("_")};
var p=AjxTemplate.expand(this.ROW_TEMPLATE,w);
var e=this._rowsEl;
e.appendChild(Dwt.toDocumentFragment(p,w.id+"_row"));
var g=e.lastChild;
if(o!=this._rowCount-1){
e.insertBefore(g,e.childNodes[o])
}
var y=[];
var s=this._registerControl(n,null,y);
var t=this._itemDef.additem?AjxUtil.createProxy(this._itemDef.additem):{
image:"Add"};
t.id=t.id||n.id+"_add";
t.visible="this.getRowCount() < this.getMaxRows()";
t.ignore=true;
var c=this._registerControl(t,null,y,null,null,"DwtButton");
if(!t.onclick){
c.addSelectionListener(new AjxListener(this,this._handleAddRow,[n.id]))
}
var h=this._itemDef.removeitem?AjxUtil.createProxy(this._itemDef.removeitem):{
image:"Remove"};
h.id=h.id||n.id+"_remove";
h.visible="this.getRowCount() > this.getMinRows()";
h.ignore=true;
var f=this._registerControl(h,null,y,null,null,"DwtButton");
if(!h.onclick){
f.addSelectionListener(new AjxListener(this,this._handleRemoveRow,[n.id]))
}
var m=this._items[n.id];
m._rowEl=g;
m._addId=t.id;
m._removeId=h.id;
this._setControlIds(m.id,o);
var a=new DwtTabGroup(n.id);
y.sort(DwtForm.__byTabIndex);
for(var d=0;
d<y.length;
d++){
var s=y[d].control;
a.addMember(s.getTabGroupMember()||s)
}
if(o==this._rowCount-1){
this._rowsTabGroup.addMember(a)
}else{
var r=this._items[String(o+1)];
var l=this._rowsTabGroup.getTabGroupMemberByName(r.id);
this._rowsTabGroup.addMemberBefore(a,l)
}
this.update();
if(this._onaddrow){
this._call(this._onaddrow,[o])
}
return s
};
DwtFormRows.prototype.removeRow=function(r){
if(this._rowCount<=this._minRows){
return
}
var c=this._items[r];
if(c.control instanceof DwtControl){
this.removeChild(c.control)
}
delete this._items[c.aka];
this._deleteItem(c.id);
var h=this._items[c._addId];
if(h){
this.removeChild(h.control);
this._deleteItem(h.id)
}
var l=this._items[c._removeId];
if(l){
this.removeChild(l.control);
this._deleteItem(l.id)
}
var s=Number(c.aka);
for(var a=s+1;
a<this._rowCount;
a++){
var n=a,t=a-1;
this._items[t]=this._items[n];
this._items[t].aka=String(t);
this._setControlIds(this._items[t].id,this._items[t].aka)
}
this._deleteItem(String(--this._rowCount));
var e=c._rowEl;
e.parentNode.removeChild(e);
delete c._rowEl;
var o=this._rowsTabGroup.getTabGroupMemberByName(c.id);
this._rowsTabGroup.removeMember(o);
this.update();
if(this._onremoverow){
this._call(this._onremoverow,[Number(c.aka)])
}};
DwtFormRows.prototype.getMinRows=function(){
return this._minRows
};
DwtFormRows.prototype.getMaxRows=function(){
return this._maxRows
};
DwtFormRows.prototype.getRowCount=function(){
return this._rowCount
};
DwtFormRows.prototype.getIndexForRowId=function(a){
var t=this._rowsEl.childNodes;
for(var e=0;
e<t.length;
e++){
if(t[e].id==[this._htmlElId,a,"row"].join("_")){
return e
}}
return -1
};
DwtFormRows.__equals=function(t,e){
if(t===e){
return true
}
if(!t||!e||t.length!=e.length){
return false
}
for(var o=0;
o<t.length;
o++){
if(!this._call(this._equals,[t[o],e[o]])){
return false
}}
return true
};
DwtFormRows.prototype._setControlIds=function(o,e){
var n=[this.getHTMLElId(),e].join("_");
var i=this._items[o];
this._setControlId(i&&i.control,n);
var t=this._items[i._addId];
this._setControlId(t&&t.control,n+"_add");
var a=this._items[i._removeId];
this._setControlId(a&&a.control,n+"_remove")
};
DwtFormRows.prototype._setControlId=function(e,t){
if(!e){
return
}
if(e instanceof DwtControl){
e.setHtmlElementId(t)
}else{
e.id=t
}};
DwtFormRows.prototype._handleAddRow=function(t){
if(this.getRowCount()<this.getMaxRows()){
var e=this.getIndexForRowId(t)+1;
this.addRow(null,e)
}};
DwtFormRows.prototype._handleRemoveRow=function(e){
this.removeRow(e)
};
DwtFormRows.prototype._setModelValue=function(t,e){
if(DwtForm.prototype._setModelValue.apply(this,arguments)){
this.parent.setDirty(this._itemDef.id,true)
}};
DwtFormRows.prototype._createHtmlFromTemplate=function(e,t){
DwtForm.prototype._createHtmlFromTemplate.apply(this,arguments);
this._rowsEl=document.getElementById(this._htmlElId+"_rows")
};
