
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtGridSizePicker=function(e,t){
if(arguments.length==0){
return
}
DwtControl.call(this,{
parent:e,className:"DwtGridSizePicker"}
);
this._title=t;
if(e instanceof DwtMenu){
e.addPopdownListener(new AjxListener(this,this._reset))
}
this._reset()
};
DwtGridSizePicker.prototype=new DwtControl;
DwtGridSizePicker.prototype.constructor=DwtGridSizePicker;
DwtGridSizePicker.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtGridSizePicker.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtGridSizePicker.prototype._createGrid=function(){
var a=this.getHtmlElement();
var t=["<table cellpadding='0' border='0' cellspacing='0'>","<tr class='info'><td colspan='",this.maxCols,"'>",this._title,"</td></tr>"];
var o=["<tr class='grid'>"];
for(var e=0;
e<this.maxCols;
++e){
o.push("<td unselectable='unselectable'></td>")
}
o.push("</tr>");
o=o.join("");
for(var e=0;
e<this.maxRows;
++e){
t.push(o)
}
t.push("</table>");
t=t.join("");
a.innerHTML=t;
a.onmouseover=DwtGridSizePicker._onMouseOver;
a.onmouseup=DwtGridSizePicker._onSelect
};
DwtGridSizePicker.prototype._reset=function(){
this._endRow=-1;
this._endCol=-1;
this.maxRows=7;
this.maxCols=7;
this._createGrid()
};
DwtGridSizePicker._onSelect=function(e){
if(AjxEnv.isIE){
e=window.event
}
DwtControl.getTargetControl(e)._onSelect(e)
};
DwtGridSizePicker.prototype._onSelect=function(i){
if(AjxEnv.isIE){
i=window.event
}
var a=new DwtUiEvent();
a.setFromDhtmlEvent(i);
var o=a.target;
if(o.tagName.toLowerCase()=="td"){
var n=o.parentNode.rowIndex;
if(n>0){
var e=o.cellIndex;
var t=DwtShell.selectionEvent;
t.item=this;
t.detail={
rows:n,cols:e+1};
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}
this.notifyListeners(DwtEvent.SELECTION,t)
}}};
DwtGridSizePicker.prototype._onMouseOut=function(i){
if(AjxEnv.isIE){
i=window.event
}
var t=new DwtUiEvent();
t.setFromDhtmlEvent(i);
var o=t.target;
var a=this.getHtmlElement().firstChild;
try{
while(o&&o!==a){
o=o.parentNode
}}
catch(e){
o=null
}
if(!o){
this._endRow=this._endCol=-1;
this._update()
}};
DwtGridSizePicker._onMouseOver=function(e){
if(AjxEnv.isIE){
e=window.event
}
DwtControl.getTargetControl(e)._onMouseOver(e)
};
DwtGridSizePicker.prototype._onMouseOver=function(t){
var e=new DwtUiEvent(true);
e.setFromDhtmlEvent(t);
var a=e.target;
if(this._updateTimeout){
clearTimeout(this._updateTimeout)
}
this._updateTimeout=setTimeout(AjxCallback.simpleClosure(this._updateOnTimeout,this,a),10);
e.setToDhtmlEvent(t)
};
DwtGridSizePicker.prototype._addRow=function(){
var t=this.getHtmlElement().firstChild;
var a=t.insertRow(-1);
a.className="grid";
for(var e=0;
e<this.maxCols;
++e){
var o=a.insertCell(-1);
o.unselectable=true
}
++this.maxRows
};
DwtGridSizePicker.prototype._addCol=function(){
var t=this.getHtmlElement().firstChild;
var o=t.rows;
for(var e=1;
e<=this.maxRows;
++e){
var a=o[e];
var n=a.insertCell(-1);
n.unselectable=true
}
++t.rows[0].cells[0].colSpan;
++this.maxCols
};
DwtGridSizePicker.prototype._updateOnTimeout=function(a){
var e=true,i,t;
if(a.tagName.toLowerCase()=="td"){
i=a.parentNode.rowIndex;
if(i>0){
t=this._endCol=a.cellIndex;
this._endRow=a.parentNode.rowIndex-1;
e=false
}}
if(e){
this._endRow=this._endCol=-1
}
this._update();
if(!e){
if(i==this.maxRows){
this._addRow()
}
if(t==this.maxCols-1){
this._addCol()
}}};
DwtGridSizePicker.prototype._update=function(){
var t=this._endRow;
var s=this._endCol;
var h=this.getHtmlElement().firstChild;
var n=h.rows[0].cells[0];
this._rows=t+1;
this._cols=s+1;
if(this._rows>0&&this._cols>0){
n.innerHTML=this._rows+" x "+this._cols
}else{
n.innerHTML=this._title
}
for(var a=0;
a<this.maxRows;
++a){
var l=h.rows[a+1];
for(var e=0;
e<this.maxCols;
++e){
var r=l.cells[e];
var o=(a>this._endRow)||(e>this._endCol);
if(o){
Dwt.delClass(r,"Hovered")
}else{
Dwt.addClass(r,"Hovered")
}}}};
