
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtRadioButtonGroup=function(a,e){
this._radios={};
this._radioButtons={};
this._values={};
this._value2id={};
this._eventMgr=new AjxEventMgr();
for(var t in a){
this.addRadio(t,a[t],(t==e))
}};
DwtRadioButtonGroup.prototype.toString=function(){
return"DwtRadioButtonGroup"
};
DwtRadioButtonGroup.prototype._enabled=true;
DwtRadioButtonGroup.prototype._visible=true;
DwtRadioButtonGroup.prototype.addSelectionListener=function(e){
return this._eventMgr.addListener(DwtEvent.SELECTION,e)
};
DwtRadioButtonGroup.prototype.removeSelectionListener=function(e){
return this._eventMgr.removeListener(DwtEvent.SELECTION,e)
};
DwtRadioButtonGroup.prototype.setEnabled=function(e){
this._enabled=e;
for(var t in this._radios){
this._radios[t].disabled=!e
}};
DwtRadioButtonGroup.prototype.isEnabled=function(){
return this._enabled
};
DwtRadioButtonGroup.prototype.setVisible=function(e){
this._visible=e;
for(var t in this._radioButtons){
this._radioButtons[t].setVisible(e)
}
for(var t in this._radios){
Dwt.setVisible(this._radios[t],e)
}};
DwtRadioButtonGroup.prototype.isVisible=function(){
return this._visible
};
DwtRadioButtonGroup.prototype.addRadio=function(r,s,i){
var e=s instanceof DwtRadioButton;
var o=e?s:null;
var n=o?o.getValue():s;
this._values[r]=n;
this._value2id[n]=r;
var t=document.getElementById(r);
this._radios[r]=t;
this._radioButtons[r]=o;
var a=AjxCallback.simpleClosure(this._handleClick,this);
Dwt.setHandler(t,DwtEvent.ONCLICK,a);
t.checked=i;
if(i){
this._selectedId=r
}};
DwtRadioButtonGroup.prototype.getRadioByValue=function(e){
var t=this._value2id[e];
return this._radios[t]
};
DwtRadioButtonGroup.prototype.getRadioButtonByValue=function(e){
var t=this._value2id[e];
return this._radioButtons[t]
};
DwtRadioButtonGroup.prototype.setSelectedId=function(i,e){
if(i!=this._selectedId){
var t=document.getElementById(i);
if(!t){
return
}
t.checked=true;
this._selectedId=i;
if(!e){
var a=DwtShell.selectionEvent;
a.reset();
this._notifySelection(a)
}}};
DwtRadioButtonGroup.prototype.setSelectedValue=function(t,e){
var a=this._valueToId(t);
this.setSelectedId(a,e)
};
DwtRadioButtonGroup.prototype.getSelectedId=function(){
return this._selectedId
};
DwtRadioButtonGroup.prototype.getSelectedValue=function(){
return this._values[this._selectedId]
};
DwtRadioButtonGroup.prototype.getValue=function(){
return this.getSelectedValue()
};
DwtRadioButtonGroup.prototype.getData=function(t){
var e=!AjxUtil.isUndefined(this._selectedId)&&this._radioButtons[this._selectedId];
if(e){
return e.getData(t)
}};
DwtRadioButtonGroup.prototype._valueToId=function(e){
for(var t in this._values){
if(this._values[t]==e){
return t
}
if(e===true&&this._values[t]=="true"){
return t
}
if(e===false&&(this._values[t]=="false"||this._values[t]=="")){
return t
}}
return null
};
DwtRadioButtonGroup.prototype._notifySelection=function(e){
e.item=this;
e.detail={
id:this._selectedId,value:this._values[this._selectedId]};
this._eventMgr.notifyListeners(DwtEvent.SELECTION,e)
};
DwtRadioButtonGroup.prototype._handleClick=function(e){
e=DwtUiEvent.getEvent(e);
var a=DwtUiEvent.getTarget(e);
if(a&&a.nodeName.match(/label/i)){
a=document.getElementById(a.getAttribute(AjxEnv.isIE?"htmlFor":"for"))
}
var i=a.id;
if(!a.checked){
for(i in this._radios){
if(this._radios[i].checked){
break
}}}
if(i!=this._selectedId){
this._selectedId=i;
var t=DwtShell.selectionEvent;
DwtUiEvent.copy(t,e);
this._notifySelection(t)
}};
