
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
XFormChoices=function(i,t,e,a){
if(arguments.length==0){
return
}
if(i!=null){
this._choiceObject=i
}
if(t!=null){
this._type=t
}
if(e!=null){
this._valueProperty=e
}
if(a!=null){
this._labelProperty=a
}
this._choiceChangeTime=new Date().getTime();
this._lastNormalizeTime=0;
if(this._type==XFormChoices.AUTO){
this.autoDetermineType()
}
this._eventMgr=new AjxEventMgr()
};
XFormChoices.prototype=new Object();
XFormChoices.prototype.constructor=XFormChoices;
XFormChoices.normalizeChoices=function(d,r,o,l){
var c;
var s;
var a;
var h=0;
switch(r){
case XFormChoices.SIMPLE_LIST:c=[].concat(d);
s=[].concat(d);
break;
case XFormChoices.OBJECT_LIST:c=[];
s=[];
a=[];
if(o==null){
o="value"
}
if(l==null){
l="label"
}
var t=d.length;
for(var n=0;
n<t;
n++){
if(d[n]){
c.push(d[n][o]);
s.push(d[n][l]);
if(d[n]["visible"]==false){
a.push(false);
h++
}else{
a.push(true)
}}}
break;
case XFormChoices.OBJECT_REFERENCE_LIST:c=[];
s=[];
if(l==null){
l="label"
}
var t=d.length;
for(var n=0;
n<t;
n++){
if(d[n]){
c.push(d[n]);
s.push(d[n][l])
}}
break;
case XFormChoices.HASH:c=[];
s=[];
for(var e in d){
c.push(e);
s.push(d[e])
}
break
}
return{
values:c,labels:s,visible:a,totalInvisibleChoices:h}
};
XFormChoices.AUTO="auto";
XFormChoices.SIMPLE_LIST="list";
XFormChoices.HASH="hash";
XFormChoices.OBJECT_LIST="object";
XFormChoices.OBJECT_REFERENCE_LIST="object_reference_list";
XFormChoices.prototype._type=XFormChoices.AUTO;
XFormChoices.prototype._valueProperty="value";
XFormChoices.prototype._labelProperty="label";
XFormChoices.prototype._visibleProperty="visible";
XFormChoices.prototype.getChoiceObject=function(){
return this._choiceObject
};
XFormChoices.prototype.autoDetermineType=function(){
var t;
var a=this._choiceObject;
if(a){
if(AjxUtil.isArray(a)){
var e=a[0];
if(AjxUtil.isObject(e)){
t=XFormChoices.OBJECT_LIST
}else{
t=XFormChoices.SIMPLE_LIST
}}else{
if(AjxUtil.isObject(a)){
t=XFormChoices.HASH
}}}
if(t==null){
t=XFormChoices.SIMPLE_LIST
}
this._type=t
};
XFormChoices.prototype.setChoices=function(e){
this._choiceObject=e
};
XFormChoices.prototype.getChoices=function(){
if(this._lastNormalizeTime==this._choiceChangeTime&&this.$normalizedChoices){
return this.$normalizedChoices
}
this._lastNormalizeTime=this._choiceChangeTime;
this.$normalizedChoices=XFormChoices.normalizeChoices(this._choiceObject,this._type,this._valueProperty,this._labelProperty);
return this.$normalizedChoices
};
XFormChoices.prototype.getChoiceByValue=function(a){
switch(this._type){
case XFormChoices.SIMPLE_LIST:return a;
break;
case XFormChoices.OBJECT_LIST:var t=this._valueProperty||"value";
for(var e=0;
e<this._choiceObject.length;
e++){
if(this._choiceObject[e][t]==a){
return this._choiceObject[e]
}}
break;
case XFormChoices.OBJECT_REFERENCE_LIST:for(var e=0;
e<this._choiceObject.length;
e++){
if(this._choiceObject[e]==a){
return this._choiceObject[e]
}}
break;
case XFormChoices.HASH:return this._choiceObject[a];
break
}
return null
};
XFormChoices.prototype.dirtyChoices=function(){
this._choiceChangeTime=new Date().getTime();
this.notifyListeners(DwtEvent.XFORMS_CHOICES_CHANGED,{}
)
};
XFormChoices.prototype.addListener=function(e,t){
return this._eventMgr.addListener(e,t)
};
XFormChoices.prototype.notifyListeners=function(e,t){
return this._eventMgr.notifyListeners(e,t)
};
XFormChoices.prototype.isListenerRegistered=function(e){
return this._eventMgr.isListenerRegistered(e)
};
XFormChoices.prototype.removeListener=function(e,t){
return this._eventMgr.removeListener(e,t)
};
