
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxXmlDoc=function(){
if(!AjxXmlDoc._inited){
AjxXmlDoc._init()
}};
AjxXmlDoc.prototype.toString=function(){
return"AjxXmlDoc"
};
AjxXmlDoc.INVALID_CHARS_RE=/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uD800-\uDFFF\uFFFE-\uFFFF]/g;
AjxXmlDoc.REC_AVOID_CHARS_RE=/[\u007F-\u0084\u0086-\u009F\uFDD0-\uFDDF]/g;
AjxXmlDoc._inited=false;
AjxXmlDoc._msxmlVers=null;
AjxXmlDoc.create=function(){
var t=new AjxXmlDoc();
var e=null;
if(AjxEnv.isIE){
e=new ActiveXObject(AjxXmlDoc._msxmlVers);
e.async=true;
if(AjxXmlDoc._msxmlVers=="MSXML2.DOMDocument.4.0"){
e.setProperty("SelectionLanguage","XPath");
e.setProperty("SelectionNamespaces","xmlns:zimbra='urn:zimbra' xmlns:mail='urn:zimbraMail' xmlns:account='urn:zimbraAccount'")
}}else{
if(document.implementation&&document.implementation.createDocument){
e=document.implementation.createDocument("","",null)
}else{
throw new AjxException("Unable to create new Doc",AjxException.INTERNAL_ERROR,"AjxXmlDoc.create")
}}
t._doc=e;
return t
};
AjxXmlDoc.createFromDom=function(t){
var e=new AjxXmlDoc();
e._doc=t;
return e
};
AjxXmlDoc.createFromXml=function(e){
var t=AjxXmlDoc.create();
t.loadFromString(e);
return t
};
AjxXmlDoc.replaceInvalidChars=function(e){
AjxXmlDoc.INVALID_CHARS_RE.lastIndex=0;
return e.replace(AjxXmlDoc.INVALID_CHARS_RE,"?")
};
AjxXmlDoc.getXml=function(t){
var e=new XMLSerializer();
return AjxXmlDoc.replaceInvalidChars(e.serializeToString(t))
};
AjxXmlDoc.prototype.getDoc=function(){
return this._doc
};
AjxXmlDoc.prototype.loadFromString=function(t){
var e=this._doc;
e.loadXML(t);
if(AjxEnv.isIE){
if(e.parseError.errorCode!=0){
throw new AjxException(e.parseError.reason,AjxException.INVALID_PARAM,"AjxXmlDoc.loadFromString")
}}};
AjxXmlDoc.prototype.loadFromUrl=function(e){
if(AjxEnv.isChrome||AjxEnv.isSafari){
var t=new window.XMLHttpRequest();
t.open("GET",e,false);
t.send(null);
var a=t.responseXML;
this._doc=a
}else{
this._doc.load(e)
}};
AjxXmlDoc.prototype.toJSObject=function(a,t,e){
_node=function(){
this.__msh_content=""
};
_node.prototype.toString=function(){
return this.__msh_content
};
rec=function(l,c){
var r={}
,h,d;
for(l=l.firstChild;
l;
l=l.nextSibling){
if(l.nodeType==1){
h=l.tagName;
if(a){
h=h.replace(/^.*?:/,"")
}
if(t){
h=h.toLowerCase()
}
d=new _node();
if(r[h]){
if(r[h]==1){
c[h]=[c[h]];
r[h]=2
}
c[h].push(d)
}else{
c[h]=d;
r[h]=1
}
if(e){
if(l.attributes&&l.attributes.length){
for(var s=0;
s<l.attributes.length;
s++){
attr=l.attributes[s];
d[attr.name]=AjxUtil.isNumeric(attr.value)?attr.value:String(attr.value)
}}}
rec(l,d)
}else{
if(l.nodeType==3){
c.__msh_content+=l.nodeValue
}}}};
var i=new _node();
rec(this._doc.documentElement,i);
return i
};
AjxXmlDoc.prototype.getElementsByTagNameNS=function(t,e){
var a=this.getDoc();
return AjxEnv.isIE?a.getElementsByTagName(t+":"+e):a.getElementsByTagNameNS(t,e)
};
AjxXmlDoc.prototype.getFirstElementByTagNameNS=function(t,e){
return this.getElementsByTagNameNS(t,e)[0]
};
AjxXmlDoc.prototype.getElementsByTagName=function(e){
var t=this.getDoc();
return t.getElementsByTagName(e)
};
AjxXmlDoc._init=function(){
if(AjxEnv.isIE){
var e=["MSXML4.DOMDocument","MSXML3.DOMDocument","MSXML2.DOMDocument.4.0","MSXML2.DOMDocument.3.0","MSXML2.DOMDocument","MSXML.DOMDocument","Microsoft.XmlDom"];
for(var a=0;
a<e.length;
a++){
try{
new ActiveXObject(e[a]);
AjxXmlDoc._msxmlVers=e[a];
break
}
catch(t){}}
if(!AjxXmlDoc._msxmlVers){
throw new AjxException("MSXML not installed",AjxException.INTERNAL_ERROR,"AjxXmlDoc._init")
}}else{
if(AjxEnv.isNav||AjxEnv.isOpera||AjxEnv.isSafari){
Document.prototype.loadXML=function(l){
var h=new DOMParser();
var n=h.parseFromString(l,"text/xml");
while(this.hasChildNodes()){
this.removeChild(this.lastChild)
}
var o=n.childNodes.length;
if(AjxEnv.isChrome7){
var c=this.createDocumentFragment();
for(var s=0;
s<o;
s++){
var r=this.importNode(n.childNodes[s],true);
c.appendChild(r)
}
this.appendChild(c)
}else{
for(var s=0;
s<o;
s++){
var r=this.importNode(n.childNodes[s],true);
this.appendChild(r)
}}};
if(AjxEnv.isNav){
_NodeGetXml=function(){
var i=new XMLSerializer();
return i.serializeToString(this)
};
Node.prototype.__defineGetter__("xml",_NodeGetXml)
}}}
AjxXmlDoc._inited=true
};
AjxXmlDoc.prototype.set=function(e,i,t){
var o=this._doc.createElement(e);
if(i!=null){
var a=this._doc.createTextNode("");
o.appendChild(a);
a.nodeValue=i
}
if(t==null){
this.root.appendChild(o)
}else{
t.appendChild(o)
}
return o
};
AjxXmlDoc.prototype.getDocXml=function(){
if(AjxEnv.isSafari){
return AjxXmlDoc.getXml(this.getDoc())
}else{
return AjxXmlDoc.replaceInvalidChars(this.getDoc().xml)
}};
AjxXmlDoc.createRoot=function(a){
var e=AjxXmlDoc.create();
var t=e.getDoc();
e.root=t.createElement(a);
t.appendChild(e.root);
return e
};
AjxXmlDoc.createElement=function(t,i){
var e=AjxXmlDoc.create();
var o=e.getDoc();
e.root=o.createElement(t);
if(i!=null){
var a=o.createTextNode("");
e.root.appendChild(a);
a.nodeValue=i
}
o.appendChild(e.root);
return e
};
AjxXmlDoc.prototype.appendChild=function(e){
if(this._doc!=e._doc&&(AjxEnv.isChrome||AjxEnv.isSafari)){
this.root.appendChild(this.getDoc().importNode(e.root,true))
}else{
this.root.appendChild(e.root)
}};
