AjxTemplate.register("share.Widgets#ZmToolBarSeparator", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<table><tr><td id='";
	buffer[_i++] = data["itemId"];
	buffer[_i++] = "' valign='middle'><div class='vertSep'></div></td></tr></table>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmToolBarSeparator"
}, true);
AjxTemplate.register("share.Widgets", AjxTemplate.getTemplate("share.Widgets#ZmToolBarSeparator"), AjxTemplate.getParams("share.Widgets#ZmToolBarSeparator"));

AjxTemplate.register("share.Widgets#ZmAppChooser", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<table class='ZToolbarTable' border=0 cellpadding=0 cellspacing=0><tr valign='bottom' id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_items'><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_suffix' valign=bottom><div class='ZAppTabSpacer'></div></td><td id=\"admin_link_container\" width=\"100%\" valign=\"middle\" align=\"right\" style=\"padding-right: 10px;\">\n";
	buffer[_i++] = "                &nbsp;\n";
	buffer[_i++] = "            </td></tr></table>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmAppChooser",
	"class": "ZWidget"
}, true);

AjxTemplate.register("share.Widgets#ZmAppChooserItem", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] =  AjxTemplate.expand("dwt.Widgets#ZToolbarItem", data) ;

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmAppChooserItem"
}, true);

AjxTemplate.register("share.Widgets#ZmAppChooserButton", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	 var buttonClass = data.buttonClass || "AppTab"; 
	buffer[_i++] = "<table class='ZWidgetTable Z";
	buffer[_i++] = buttonClass;
	buffer[_i++] = "Table Z";
	buffer[_i++] = buttonClass;
	buffer[_i++] = "Border' cellspacing=0 cellpadding=0 style='table-layout:auto;'><tr><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_left_icon'  \tclass='ZLeftIcon ZWidgetIcon'></td><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_title'\t\tclass='ZWidgetTitle'></td><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_right_icon' \tclass='ZRightIcon ZWidgetIcon'></td></tr></table>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmAppChooserButton",
	"class": "ZAppTab"
}, true);

AjxTemplate.register("share.Widgets#ZmAppChooserSpacer", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	 var buttonClass = data.buttonClass || "AppTab"; 
	buffer[_i++] = "<div class='Z";
	buffer[_i++] = buttonClass;
	buffer[_i++] = "Spacer'></div>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmAppChooserSpacer"
}, true);

AjxTemplate.register("share.Widgets#ZToast", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<div class='ZToastBG'><div class='ZToastContent'><div id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_icon' class='ZToastIcon'></div><div id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_text' class='ZToastText'></div></div></div>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZToast",
	"class": "ZToastInfo"
}, true);

AjxTemplate.register("share.Widgets#ZmSearchToolBar", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<table border=0 cellpadding=0 cellspacing=0 width='100%' height='100%'><tr><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_inputField' width='100%' class='ZmSearchToolbarCell'></td><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_searchMenuButton' class='ZmSearchToolbarCell'></td><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_searchButton' hint='text' class='ZmSearchToolbarCell'></td><!-- UNCOMMENT THIS IF YOU WANT CUSTOM SEARCH TO APPEAR AS A SEPARATE BUTTON ON SEARCH TOOLBAR\n";
	buffer[_i++] = "\t\t\t<td class='ZmSearchToolbarSeparatorCell'><div id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_customSearchButtonSep' class='vertSep' style='display:none'></div></td><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_customSearchButton' class='ZmSearchToolbarCell'></td>\n";
	buffer[_i++] = "\t\t\t--><td class='ZmSearchToolbarSeparatorCell'><div class='vertSep'></div></td><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_saveButton' hint='text' class='ZmSearchToolbarCell'></td><td class='ZmSearchToolbarSeparatorCell'><div class='vertSep'></div></td><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_advancedButton' hint='text' class='ZmSearchToolbarCell'></td></tr></table>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmSearchToolBar"
}, true);

AjxTemplate.register("share.Widgets#ZmPeopleSearchToolBar", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<table border=0 cellpadding=0 cellspacing=0 width='100%' height='100%'><tr><td><div width='100%' class='ZmPeopleSearchToolbarDiv'><table border=0 cellpadding=0 cellspacing=0 class='ZmPeopleSearchToolbarTable'><tr><td id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_inputField' width='100%'></td><td>";
	buffer[_i++] =  AjxImg.getImageHtml("Search2") ;
	buffer[_i++] = "</td></tr></table></div></td></tr></table>";
	
		    if (appCtxt.get(ZmSetting.PEOPLE_SEARCH_ENABLED) &&
			                (appCtxt.get(ZmSetting.CONTACTS_ENABLED) ||
			                 appCtxt.get(ZmSetting.GAL_ENABLED)      ||
			                 appCtxt.isOffline))
		    {
	            //add divider to top row if people search is enabled
	            var el = document.getElementById("skin_spacing_search");
	            if (el) {
	                var td = document.createElement("td");
	                td.innerHTML = "<div class='divider'></div>";
	                el.parentNode.insertBefore( td, el.nextSibling ); //insert after el
	            }
		    }
		

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmPeopleSearchToolBar"
}, true);

AjxTemplate.register("share.Widgets#ZmChooseFolderDialog", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<div class='ChooserDialog'><span id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_folderDescDivId' style='margin: 0; margin-bottom: 2px'></span><div>";
	buffer[_i++] =  ZmMsg.chooserDescription ;
	buffer[_i++] = "</div><div id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_inputDivId'></div><div class='overview' id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_folderTreeDivId'></div></div>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmChooseFolderDialog"
}, true);

AjxTemplate.register("share.Widgets#ZmChooseAccountDialog", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<div class='ChooserDialog' style='width:300px'><table border=0 width=100%><tr><td><center><div id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_chooseAccountMsg'></div><div id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_accountSelectId'></div></center></td></tr></table></div>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmChooseAccountDialog"
}, true);

AjxTemplate.register("share.Widgets#ZmPickTagDialog", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<div class='ChooserDialog'><div style='width:300px'>";
	buffer[_i++] =  ZmMsg.chooserDescription ;
	buffer[_i++] = "</div><div id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_inputDivId'></div><div style='background-color:white; width:100%; overflow:auto' id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_tagTreeDivId'></div></div>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmPickTagDialog"
}, true);

AjxTemplate.register("share.Widgets#ZmDebugLogDialog", 
function(name, params, data, buffer) {
	var _hasBuffer = Boolean(buffer);
	data = (typeof data == "string" ? { id: data } : data) || {};
	buffer = buffer || [];
	var _i = buffer.length;

	buffer[_i++] = "<div class='DebugLogDialog-desc' id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_desc'></div><div class='DebugLogDialog-log' id='";
	buffer[_i++] = data["id"];
	buffer[_i++] = "_log'></div>";

	return _hasBuffer ? buffer.length : buffer.join("");
},
{
	"id": "share.Widgets#ZmDebugLogDialog"
}, true);

