
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.Directionality",{
init:function(t,e){
var i=this;
i.editor=t;
t.addCommand("mceDirectionLTR",function(){
var a=t.dom.getParent(t.selection.getNode(),t.dom.isBlock);
if(a){
if(t.dom.getAttrib(a,"dir")!="ltr"){
t.dom.setAttrib(a,"dir","ltr")
}else{
t.dom.setAttrib(a,"dir","")
}}
t.nodeChanged()
}
);
t.addCommand("mceDirectionRTL",function(){
var a=t.dom.getParent(t.selection.getNode(),t.dom.isBlock);
if(a){
if(t.dom.getAttrib(a,"dir")!="rtl"){
t.dom.setAttrib(a,"dir","rtl")
}else{
t.dom.setAttrib(a,"dir","")
}}
t.nodeChanged()
}
);
t.addButton("ltr",{
title:"directionality.ltr_desc",cmd:"mceDirectionLTR"}
);
t.addButton("rtl",{
title:"directionality.rtl_desc",cmd:"mceDirectionRTL"}
);
t.onNodeChange.add(i._nodeChange,i)
}
,getInfo:function(){
return{
longname:"Directionality",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/directionality",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_nodeChange:function(t,i,o){
var n=t.dom,s;
o=n.getParent(o,n.isBlock);
if(!o){
i.setDisabled("ltr",1);
i.setDisabled("rtl",1);
return
}
s=n.getAttrib(o,"dir");
i.setActive("ltr",s=="ltr");
i.setDisabled("ltr",0);
i.setActive("rtl",s=="rtl");
i.setDisabled("rtl",0)
}}
);
tinymce.PluginManager.add("directionality",tinymce.plugins.Directionality)
}
)();
