
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(r){
var l=r.DOM,t=r.dom.Event,o=r.extend,s=r.each,i=r.util.Cookie,n,u=r.explode;
r.ThemeManager.requireLangPack("advanced");
r.create("tinymce.themes.AdvancedTheme",{
sizes:[8,10,12,14,18,24,36],controls:{
bold:["bold_desc","Bold"],italic:["italic_desc","Italic"],underline:["underline_desc","Underline"],strikethrough:["striketrough_desc","Strikethrough"],justifyleft:["justifyleft_desc","JustifyLeft"],justifycenter:["justifycenter_desc","JustifyCenter"],justifyright:["justifyright_desc","JustifyRight"],justifyfull:["justifyfull_desc","JustifyFull"],bullist:["bullist_desc","InsertUnorderedList"],numlist:["numlist_desc","InsertOrderedList"],outdent:["outdent_desc","Outdent"],indent:["indent_desc","Indent"],cut:["cut_desc","Cut"],copy:["copy_desc","Copy"],paste:["paste_desc","Paste"],undo:["undo_desc","Undo"],redo:["redo_desc","Redo"],link:["link_desc","mceLink"],unlink:["unlink_desc","unlink"],image:["image_desc","mceImage"],cleanup:["cleanup_desc","mceCleanup"],help:["help_desc","mceHelp"],code:["code_desc","mceCodeEditor"],hr:["hr_desc","InsertHorizontalRule"],removeformat:["removeformat_desc","RemoveFormat"],sub:["sub_desc","subscript"],sup:["sup_desc","superscript"],forecolor:["forecolor_desc","ForeColor"],forecolorpicker:["forecolor_desc","mceForeColor"],backcolor:["backcolor_desc","HiliteColor"],backcolorpicker:["backcolor_desc","mceBackColor"],charmap:["charmap_desc","mceCharMap"],visualaid:["visualaid_desc","mceToggleVisualAid"],anchor:["anchor_desc","mceInsertAnchor"],newdocument:["newdocument_desc","mceNewDocument"],blockquote:["blockquote_desc","mceBlockQuote"]}
,stateControls:["bold","italic","underline","strikethrough","bullist","numlist","justifyleft","justifycenter","justifyright","justifyfull","sub","sup","blockquote"],init:function(c,h){
var a=this,e,d,f;
a.editor=c;
a.url=h;
a.onResolveName=new r.util.Dispatcher(this);
a.settings=e=o({
theme_advanced_path:true,theme_advanced_toolbar_location:"bottom",theme_advanced_buttons1:"bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect",theme_advanced_buttons2:"bullist,numlist,|,outdent,indent,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code",theme_advanced_buttons3:"hr,removeformat,visualaid,|,sub,sup,|,charmap",theme_advanced_blockformats:"p,address,pre,h1,h2,h3,h4,h5,h6",theme_advanced_toolbar_align:"center",theme_advanced_fonts:"Andale Mono=andale mono,times;Arial=arial,helvetica,sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;Courier New=courier new,courier;Georgia=georgia,palatino;Helvetica=helvetica;Impact=impact,chicago;Symbol=symbol;Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal,monaco;Times New Roman=times new roman,times;Trebuchet MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;Wingdings=wingdings,zapf dingbats",theme_advanced_more_colors:1,theme_advanced_row_height:23,theme_advanced_resize_horizontal:1,theme_advanced_resizing_use_cookie:1,theme_advanced_font_sizes:"1,2,3,4,5,6,7",readonly:c.settings.readonly}
,c.settings);
if(!e.font_size_style_values){
e.font_size_style_values="8pt,10pt,12pt,14pt,18pt,24pt,36pt"
}
if(r.is(e.theme_advanced_font_sizes,"string")){
e.font_size_style_values=r.explode(e.font_size_style_values);
e.font_size_classes=r.explode(e.font_size_classes||"");
f={};
c.settings.theme_advanced_font_sizes=e.theme_advanced_font_sizes;
s(c.getParam("theme_advanced_font_sizes","","hash"),function(m,g){
var y;
if(g==m&&m>=1&&m<=7){
g=m+" ("+a.sizes[m-1]+"pt)";
if(c.settings.convert_fonts_to_spans){
y=e.font_size_classes[m-1];
m=e.font_size_style_values[m-1]||(a.sizes[m-1]+"pt")
}}
if(/^\s*\./.test(m)){
y=m.replace(/\./g,"")
}
f[g]=y?{
"class":y}
:{
fontSize:m}
}
);
e.theme_advanced_font_sizes=f
}
if((d=e.theme_advanced_path_location)&&d!="none"){
e.theme_advanced_statusbar_location=e.theme_advanced_path_location
}
if(e.theme_advanced_statusbar_location=="none"){
e.theme_advanced_statusbar_location=0
}
c.onInit.add(function(){
c.onNodeChange.add(a._nodeChanged,a);
if(c.settings.content_css!==false){
c.dom.loadCSS(c.baseURI.toAbsolute("themes/advanced/skins/"+c.settings.skin+"/content.css"))
}}
);
c.onSetProgressState.add(function(b,v,y){
var g,m=b.id,w;
if(v){
a.progressTimer=setTimeout(function(){
g=b.getContainer();
g=g.insertBefore(l.create("DIV",{
style:"position:relative"}
),g.firstChild);
w=l.get(b.id+"_tbl");
l.add(g,"div",{
id:m+"_blocker","class":"mceBlocker",style:{
width:w.clientWidth+2,height:w.clientHeight+2}}
);
l.add(g,"div",{
id:m+"_progress","class":"mceProgress",style:{
left:w.clientWidth/2,top:w.clientHeight/2}}
)
}
,y||0)
}else{
l.remove(m+"_blocker");
l.remove(m+"_progress");
clearTimeout(a.progressTimer)
}}
);
l.loadCSS(e.editor_css?c.documentBaseURI.toAbsolute(e.editor_css):h+"/skins/"+c.settings.skin+"/ui.css");
if(e.skin_variant){
l.loadCSS(h+"/skins/"+c.settings.skin+"/ui_"+e.skin_variant+".css")
}}
,createControl:function(e,c){
var h,a;
if(a=c.createControl(e)){
return a
}
switch(e){
case"styleselect":return this._createStyleSelect();
case"formatselect":return this._createBlockFormats();
case"fontselect":return this._createFontSelect();
case"fontsizeselect":return this._createFontSizeSelect();
case"forecolor":return this._createForeColorMenu();
case"backcolor":return this._createBackColorMenu()
}
if((h=this.controls[e])){
return c.createButton(e,{
title:"advanced."+h[0],cmd:h[1],ui:h[2],value:h[3]}
)
}}
,execCommand:function(a,h,e){
var c=this["_"+a];
if(c){
c.call(this,h,e);
return true
}
return false
}
,_importClasses:function(a){
var h=this.editor,e=h.controlManager.get("styleselect");
if(e.getLength()==0){
s(h.dom.getClasses(),function(c){
e.add(c["class"],c["class"])
}
)
}}
,_createStyleSelect:function(e){
var c=this,d=c.editor,h=d.controlManager,a=h.createListBox("styleselect",{
title:"advanced.style_select",onselect:function(m){
if(a.selectedValue===m){
d.execCommand("mceSetStyleInfo",0,{
command:"removeformat"}
);
a.select();
return false
}else{
d.execCommand("mceSetCSSClass",0,m)
}}}
);
if(a){
s(d.getParam("theme_advanced_styles","","hash"),function(m,f){
if(m){
a.add(c.editor.translate(f),m)
}}
);
a.onPostRender.add(function(f,m){
if(!a.NativeListBox){
t.add(m.id+"_text","focus",c._importClasses,c);
t.add(m.id+"_text","mousedown",c._importClasses,c);
t.add(m.id+"_open","focus",c._importClasses,c);
t.add(m.id+"_open","mousedown",c._importClasses,c)
}else{
t.add(m.id,"focus",c._importClasses,c)
}}
)
}
return a
}
,_createFontSelect:function(){
var e,a=this,h=a.editor;
e=h.controlManager.createListBox("fontselect",{
title:"advanced.fontdefault",cmd:"FontName"}
);
if(e){
s(h.getParam("theme_advanced_fonts",a.settings.theme_advanced_fonts,"hash"),function(c,d){
e.add(h.translate(d),c,{
style:c.indexOf("dings")==-1?"font-family:"+c:""}
)
}
)
}
return e
}
,_createFontSizeSelect:function(){
var e=this,h=e.editor,d,a=0,c=[];
d=h.controlManager.createListBox("fontsizeselect",{
title:"advanced.font_size",onselect:function(m){
if(m.fontSize){
h.execCommand("FontSize",false,m.fontSize)
}else{
s(e.settings.theme_advanced_font_sizes,function(f,g){
if(f["class"]){
c.push(f["class"])
}}
);
h.editorCommands._applyInlineStyle("span",{
"class":m["class"]}
,{
check_classes:c}
)
}}}
);
if(d){
s(e.settings.theme_advanced_font_sizes,function(g,m){
var f=g.fontSize;
if(f>=1&&f<=7){
f=e.sizes[parseInt(f)-1]+"pt"
}
d.add(m,g,{
style:"font-size:"+f,"class":"mceFontSize"+(a++)+(" "+(g["class"]||""))}
)
}
)
}
return d
}
,_createBlockFormats:function(){
var e,h={
p:"advanced.paragraph",address:"advanced.address",pre:"advanced.pre",h1:"advanced.h1",h2:"advanced.h2",h3:"advanced.h3",h4:"advanced.h4",h5:"advanced.h5",h6:"advanced.h6",div:"advanced.div",blockquote:"advanced.blockquote",code:"advanced.code",dt:"advanced.dt",dd:"advanced.dd",samp:"advanced.samp"}
,a=this;
e=a.editor.controlManager.createListBox("formatselect",{
title:"advanced.block",cmd:"FormatBlock"}
);
if(e){
s(a.editor.getParam("theme_advanced_blockformats",a.settings.theme_advanced_blockformats,"hash"),function(c,d){
e.add(a.editor.translate(d!=c?d:h[c]),c,{
"class":"mce_formatPreview mce_"+c}
)
}
)
}
return e
}
,_createForeColorMenu:function(){
var e,c=this,h=c.settings,a={}
,d;
if(h.theme_advanced_more_colors){
a.more_colors_func=function(){
c._mceColorPicker(0,{
color:e.value,func:function(m){
e.setColor(m)
}}
)
}
}
if(d=h.theme_advanced_text_colors){
a.colors=d
}
if(h.theme_advanced_default_foreground_color){
a.default_color=h.theme_advanced_default_foreground_color
}
a.title="advanced.forecolor_desc";
a.cmd="ForeColor";
a.scope=this;
e=c.editor.controlManager.createColorSplitButton("forecolor",a);
return e
}
,_createBackColorMenu:function(){
var e,c=this,h=c.settings,a={}
,d;
if(h.theme_advanced_more_colors){
a.more_colors_func=function(){
c._mceColorPicker(0,{
color:e.value,func:function(m){
e.setColor(m)
}}
)
}
}
if(d=h.theme_advanced_background_colors){
a.colors=d
}
if(h.theme_advanced_default_background_color){
a.default_color=h.theme_advanced_default_background_color
}
a.title="advanced.backcolor_desc";
a.cmd="HiliteColor";
a.scope=this;
e=c.editor.controlManager.createColorSplitButton("backcolor",a);
return e
}
,renderUI:function(d){
var h,c,a,y=this,e=y.editor,g=y.settings,b,f,p;
h=f=l.create("span",{
id:e.id+"_parent","class":"mceEditor "+e.settings.skin+"Skin"+(g.skin_variant?" "+e.settings.skin+"Skin"+y._ufirst(g.skin_variant):"")}
);
if(!l.boxModel){
h=l.add(h,"div",{
"class":"mceOldBoxModel"}
)
}
h=b=l.add(h,"table",{
id:e.id+"_tbl","class":"mceLayout",cellSpacing:0,cellPadding:0}
);
h=a=l.add(h,"tbody");
switch((g.theme_advanced_layout_manager||"").toLowerCase()){
case"rowlayout":c=y._rowLayout(g,a,d);
break;
case"customlayout":c=e.execCallback("theme_advanced_custom_layout",g,a,d,f);
break;
default:c=y._simpleLayout(g,a,d,f)
}
h=d.targetNode;
p=l.stdMode?b.getElementsByTagName("tr"):b.rows;
l.addClass(p[0],"mceFirst");
l.addClass(p[p.length-1],"mceLast");
s(l.select("tr",a),function(m){
l.addClass(m.firstChild,"mceFirst");
l.addClass(m.childNodes[m.childNodes.length-1],"mceLast")
}
);
if(l.get(g.theme_advanced_toolbar_container)){
l.get(g.theme_advanced_toolbar_container).appendChild(f)
}else{
l.insertAfter(f,h)
}
t.add(e.id+"_path_row","click",function(m){
m=m.target;
if(m.nodeName=="A"){
y._sel(m.className.replace(/^.*mcePath_([0-9]+).*$/,"$1"));
return t.cancel(m)
}}
);
if(!e.getParam("accessibility_focus")){
t.add(l.add(f,"a",{
href:"#"}
,"<!-- IE -->"),"focus",function(){
tinyMCE.get(e.id).focus()
}
)
}
if(g.theme_advanced_toolbar_location=="external"){
d.deltaHeight=0
}
y.deltaHeight=d.deltaHeight;
d.targetNode=null;
return{
iframeContainer:c,editorContainer:e.id+"_parent",sizeContainer:b,deltaHeight:d.deltaHeight}
}
,getInfo:function(){
return{
longname:"Advanced theme",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",version:r.majorVersion+"."+r.minorVersion}
}
,resizeBy:function(h,a){
var e=l.get(this.editor.id+"_tbl");
this.resizeTo(e.clientWidth+h,e.clientHeight+a)
}
,resizeTo:function(d,a){
var c=this.editor,h=c.settings,p=l.get(c.id+"_tbl"),f=l.get(c.id+"_ifr"),e;
d=Math.max(h.theme_advanced_resizing_min_width||100,d);
a=Math.max(h.theme_advanced_resizing_min_height||100,a);
d=Math.min(h.theme_advanced_resizing_max_width||65535,d);
a=Math.min(h.theme_advanced_resizing_max_height||65535,a);
e=p.clientHeight-f.clientHeight;
l.setStyle(f,"height",a-e);
l.setStyles(p,{
width:d,height:a}
)
}
,destroy:function(){
var e=this.editor.id;
t.clear(e+"_resize");
t.clear(e+"_path_row");
t.clear(e+"_external_close")
}
,_simpleLayout:function(g,e,d,p){
var b=this,O=b.editor,T=g.theme_advanced_toolbar_location,h=g.theme_advanced_statusbar_location,c,f,a,z;
if(g.readonly){
c=l.add(e,"tr");
c=f=l.add(c,"td",{
"class":"mceIframeContainer"}
);
return f
}
if(T=="top"){
b._addToolbars(e,d)
}
if(T=="external"){
c=z=l.create("div",{
style:"position:relative"}
);
c=l.add(c,"div",{
id:O.id+"_external","class":"mceExternalToolbar"}
);
l.add(c,"a",{
id:O.id+"_external_close",href:"javascript:;","class":"mceExternalClose"}
);
c=l.add(c,"table",{
id:O.id+"_tblext",cellSpacing:0,cellPadding:0}
);
a=l.add(c,"tbody");
if(p.firstChild.className=="mceOldBoxModel"){
p.firstChild.appendChild(z)
}else{
p.insertBefore(z,p.firstChild)
}
b._addToolbars(a,d);
O.onMouseUp.add(function(){
var m=l.get(O.id+"_external");
l.show(m);
l.hide(n);
var y=t.add(O.id+"_external_close","click",function(){
l.hide(O.id+"_external");
t.remove(O.id+"_external_close","click",y)
}
);
l.show(m);
l.setStyle(m,"top",0-l.getRect(O.id+"_tblext").h-1);
l.hide(m);
l.show(m);
m.style.filter="";
n=O.id+"_external";
m=null
}
)
}
if(h=="top"){
b._addStatusBar(e,d)
}
if(!g.theme_advanced_toolbar_container){
c=l.add(e,"tr");
c=f=l.add(c,"td",{
"class":"mceIframeContainer"}
)
}
if(T=="bottom"){
b._addToolbars(e,d)
}
if(h=="bottom"){
b._addStatusBar(e,d)
}
return f
}
,_rowLayout:function(z,c,f){
var T=this,h=T.editor,O,b,y=h.controlManager,d,g,e,a;
O=z.theme_advanced_containers_default_class||"";
b=z.theme_advanced_containers_default_align||"center";
s(u(z.theme_advanced_containers||""),function(m,p){
var w=z["theme_advanced_container_"+m]||"";
switch(w.toLowerCase()){
case"mceeditor":d=l.add(c,"tr");
d=g=l.add(d,"td",{
"class":"mceIframeContainer"}
);
break;
case"mceelementpath":T._addStatusBar(c,f);
break;
default:a=(z["theme_advanced_container_"+m+"_align"]||b).toLowerCase();
a="mce"+T._ufirst(a);
d=l.add(l.add(c,"tr"),"td",{
"class":"mceToolbar "+(z["theme_advanced_container_"+m+"_class"]||O)+" "+a||b}
);
e=y.createToolbar("toolbar"+p);
T._addControls(w,e);
l.setHTML(d,e.renderHTML());
f.deltaHeight-=z.theme_advanced_row_height
}}
);
return g
}
,_addControls:function(c,d){
var h=this,a=h.settings,e,f=h.editor.controlManager;
if(a.theme_advanced_disable&&!h._disabled){
e={};
s(u(a.theme_advanced_disable),function(m){
e[m]=1
}
);
h._disabled=e
}else{
e=h._disabled
}
s(u(c),function(m){
var g;
if(e&&e[m]){
return
}
if(m=="tablecontrols"){
s(["table","|","row_props","cell_props","|","row_before","row_after","delete_row","|","col_before","col_after","delete_col","|","split_cells","merge_cells"],function(p){
p=h.createControl(p,f);
if(p){
d.add(p)
}}
);
return
}
g=h.createControl(m,f);
if(g){
d.add(g)
}}
)
}
,_addToolbars:function(W,g){
var v=this,h,d,e=v.editor,c=v.settings,T,b=e.controlManager,B,f,a=[],O;
O=c.theme_advanced_toolbar_align.toLowerCase();
O="mce"+v._ufirst(O);
f=l.add(l.add(W,"tr"),"td",{
"class":"mceToolbar "+O}
);
if(!e.getParam("accessibility_focus")){
a.push(l.createHTML("a",{
href:"#",onfocus:"tinyMCE.get('"+e.id+"').focus();"}
,"<!-- IE -->"))
}
a.push(l.createHTML("a",{
href:"#",accesskey:"q",title:e.getLang("advanced.toolbar_focus")}
,"<!-- IE -->"));
for(h=1;
(T=c["theme_advanced_buttons"+h]);
h++){
d=b.createToolbar("toolbar"+h,{
"class":"mceToolbarRow"+h}
);
if(c["theme_advanced_buttons"+h+"_add"]){
T+=","+c["theme_advanced_buttons"+h+"_add"]
}
if(c["theme_advanced_buttons"+h+"_add_before"]){
T=c["theme_advanced_buttons"+h+"_add_before"]+","+T
}
v._addControls(T,d);
a.push(d.renderHTML());
g.deltaHeight-=c.theme_advanced_row_height
}
a.push(l.createHTML("a",{
href:"#",accesskey:"z",title:e.getLang("advanced.toolbar_focus"),onfocus:"tinyMCE.getInstanceById('"+e.id+"').focus();"}
,"<!-- IE -->"));
l.setHTML(f,a.join(""))
}
,_addStatusBar:function(h,f){
var d,b=this,a=b.editor,y=b.settings,g,e,x,c;
d=l.add(h,"tr");
d=c=l.add(d,"td",{
"class":"mceStatusbar"}
);
d=l.add(d,"div",{
id:a.id+"_path_row"}
,y.theme_advanced_path?a.translate("advanced.path")+": ":"&#160;");
l.add(d,"a",{
href:"#",accesskey:"x"}
);
if(y.theme_advanced_resizing){
l.add(c,"a",{
id:a.id+"_resize",href:"javascript:;",onclick:"return false;","class":"mceResize"}
);
if(y.theme_advanced_resizing_use_cookie){
a.onPostRender.add(function(){
var p=i.getHash("TinyMCE_"+a.id+"_size"),m=l.get(a.id+"_tbl");
if(!p){
return
}
if(y.theme_advanced_resize_horizontal){
m.style.width=Math.max(10,p.cw)+"px"
}
m.style.height=Math.max(10,p.ch)+"px";
l.get(a.id+"_ifr").style.height=Math.max(10,parseInt(p.ch)+b.deltaHeight)+"px"
}
)
}
a.onPostRender.add(function(){
t.add(a.id+"_resize","mousedown",function(m){
var q,p,k,w,j,v;
q=l.get(a.id+"_tbl");
k=q.clientWidth;
w=q.clientHeight;
miw=y.theme_advanced_resizing_min_width||100;
mih=y.theme_advanced_resizing_min_height||100;
maw=y.theme_advanced_resizing_max_width||65535;
mah=y.theme_advanced_resizing_max_height||65535;
p=l.add(l.get(a.id+"_parent"),"div",{
"class":"mcePlaceHolder"}
);
l.setStyles(p,{
width:k,height:w}
);
l.hide(q);
l.show(p);
g={
x:m.screenX,y:m.screenY,w:k,h:w,dx:null,dy:null};
e=t.add(l.doc,"mousemove",function(O){
var T,z;
g.dx=O.screenX-g.x;
g.dy=O.screenY-g.y;
T=Math.max(miw,g.w+g.dx);
z=Math.max(mih,g.h+g.dy);
T=Math.min(maw,T);
z=Math.min(mah,z);
if(y.theme_advanced_resize_horizontal){
p.style.width=T+"px"
}
p.style.height=z+"px";
return t.cancel(O)
}
);
x=t.add(l.doc,"mouseup",function(T){
var z;
t.remove(l.doc,"mousemove",e);
t.remove(l.doc,"mouseup",x);
q.style.display="";
l.remove(p);
if(g.dx===null){
return
}
z=l.get(a.id+"_ifr");
if(y.theme_advanced_resize_horizontal){
q.style.width=Math.max(10,g.w+g.dx)+"px"
}
q.style.height=Math.max(10,g.h+g.dy)+"px";
z.style.height=Math.max(10,z.clientHeight+g.dy)+"px";
if(y.theme_advanced_resizing_use_cookie){
i.setHash("TinyMCE_"+a.id+"_size",{
cw:g.w+g.dx,ch:g.h+g.dy}
)
}}
);
return t.cancel(m)
}
)
}
)
}
f.deltaHeight-=21;
d=h=null
}
,_nodeChanged:function(d,A,f,a){
var v=this,g,e=0,T,c,b=v.settings,O,p,h;
if(b.readonly){
return
}
r.each(v.stateControls,function(m){
A.setActive(m,d.queryCommandState(v.controls[m][1]))
}
);
A.setActive("visualaid",d.hasVisual);
A.setDisabled("undo",!d.undoManager.hasUndo()&&!d.typing);
A.setDisabled("redo",!d.undoManager.hasRedo());
A.setDisabled("outdent",!d.queryCommandState("Outdent"));
g=l.getParent(f,"A");
if(c=A.get("link")){
if(!g||!g.name){
c.setDisabled(!g&&a);
c.setActive(!!g)
}}
if(c=A.get("unlink")){
c.setDisabled(!g&&a);
c.setActive(!!g&&!g.name)
}
if(c=A.get("anchor")){
c.setActive(!!g&&g.name);
if(r.isWebKit){
g=l.getParent(f,"IMG");
c.setActive(!!g&&l.getAttrib(g,"mce_name")=="a")
}}
g=l.getParent(f,"IMG");
if(c=A.get("image")){
c.setActive(!!g&&f.className.indexOf("mceItem")==-1)
}
if(c=A.get("styleselect")){
if(f.className){
v._importClasses();
c.select(f.className)
}else{
c.select()
}}
if(c=A.get("formatselect")){
g=l.getParent(f,l.isBlock);
if(g){
c.select(g.nodeName.toLowerCase())
}}
if(d.settings.convert_fonts_to_spans){
d.dom.getParent(f,function(m){
if(m.nodeName==="SPAN"){
if(!O&&m.className){
O=m.className
}
if(!p&&m.style.fontSize){
p=m.style.fontSize
}
if(!h&&m.style.fontFamily){
h=m.style.fontFamily.replace(/[\"\']+/g,"").replace(/^([^,]+).*/,"$1").toLowerCase()
}}
return false
}
);
if(c=A.get("fontselect")){
c.select(function(m){
return m.replace(/^([^,]+).*/,"$1").toLowerCase()==h
}
)
}
if(c=A.get("fontsizeselect")){
c.select(function(m){
if(m.fontSize&&m.fontSize===p){
return true
}
if(m["class"]&&m["class"]===O){
return true
}}
)
}}else{
if(c=A.get("fontselect")){
c.select(d.queryCommandValue("FontName"))
}
if(c=A.get("fontsizeselect")){
T=d.queryCommandValue("FontSize");
c.select(function(m){
return m.fontSize==T
}
)
}}
if(b.theme_advanced_path&&b.theme_advanced_statusbar_location){
g=l.get(d.id+"_path")||l.add(d.id+"_path_row","span",{
id:d.id+"_path"}
);
l.setHTML(g,"");
d.dom.getParent(f,function(m){
var x=m.nodeName.toLowerCase(),k,y,w="";
if(m.nodeType!=1||m.nodeName==="BR"||(l.hasClass(m,"mceItemHidden")||l.hasClass(m,"mceItemRemoved"))){
return
}
if(T=l.getAttrib(m,"mce_name")){
x=T
}
if(r.isIE&&m.scopeName!=="HTML"){
x=m.scopeName+":"+x
}
x=x.replace(/mce\:/g,"");
switch(x){
case"b":x="strong";
break;
case"i":x="em";
break;
case"img":if(T=l.getAttrib(m,"src")){
w+="src: "+T+" "
}
break;
case"a":if(T=l.getAttrib(m,"name")){
w+="name: "+T+" ";
x+="#"+T
}
if(T=l.getAttrib(m,"href")){
w+="href: "+T+" "
}
break;
case"font":if(b.convert_fonts_to_spans){
x="span"
}
if(T=l.getAttrib(m,"face")){
w+="font: "+T+" "
}
if(T=l.getAttrib(m,"size")){
w+="size: "+T+" "
}
if(T=l.getAttrib(m,"color")){
w+="color: "+T+" "
}
break;
case"span":if(T=l.getAttrib(m,"style")){
w+="style: "+T+" "
}
break
}
if(T=l.getAttrib(m,"id")){
w+="id: "+T+" "
}
if(T=m.className){
T=T.replace(/(webkit-[\w\-]+|Apple-[\w\-]+|mceItem\w+|mceVisualAid)/g,"");
if(T&&T.indexOf("mceItem")==-1){
w+="class: "+T+" ";
if(l.isBlock(m)||x=="img"||x=="span"){
x+="."+T
}}}
x=x.replace(/(html:)/g,"");
x={
name:x,node:m,title:w};
v.onResolveName.dispatch(v,x);
w=x.title;
x=x.name;
y=l.create("a",{
href:"javascript:;",onmousedown:"return false;",title:w,"class":"mcePath_"+(e++)}
,x);
if(g.hasChildNodes()){
g.insertBefore(l.doc.createTextNode(" \u00bb "),g.firstChild);
g.insertBefore(y,g.firstChild)
}else{
g.appendChild(y)
}}
,d.getBody())
}}
,_sel:function(e){
this.editor.execCommand("mceSelectNodeDepth",false,e)
}
,_mceInsertAnchor:function(e,a){
var h=this.editor;
h.windowManager.open({
url:r.baseURL+"/themes/advanced/anchor.htm",width:320+parseInt(h.getLang("advanced.anchor_delta_width",0)),height:90+parseInt(h.getLang("advanced.anchor_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceCharMap:function(){
var e=this.editor;
e.windowManager.open({
url:r.baseURL+"/themes/advanced/charmap.htm",width:550+parseInt(e.getLang("advanced.charmap_delta_width",0)),height:250+parseInt(e.getLang("advanced.charmap_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceHelp:function(){
var e=this.editor;
e.windowManager.open({
url:r.baseURL+"/themes/advanced/about.htm",width:480,height:380,inline:true}
,{
theme_url:this.url}
)
}
,_mceColorPicker:function(e,a){
var h=this.editor;
a=a||{};
h.windowManager.open({
url:r.baseURL+"/themes/advanced/color_picker.htm",width:375+parseInt(h.getLang("advanced.colorpicker_delta_width",0)),height:250+parseInt(h.getLang("advanced.colorpicker_delta_height",0)),close_previous:false,inline:true}
,{
input_color:a.color,func:a.func,theme_url:this.url}
)
}
,_mceCodeEditor:function(a,e){
var h=this.editor;
h.windowManager.open({
url:r.baseURL+"/themes/advanced/source_editor.htm",width:parseInt(h.getParam("theme_advanced_source_editor_width",720)),height:parseInt(h.getParam("theme_advanced_source_editor_height",580)),inline:true,resizable:true,maximizable:true}
,{
theme_url:this.url}
)
}
,_mceImage:function(a,e){
var h=this.editor;
if(h.dom.getAttrib(h.selection.getNode(),"class").indexOf("mceItem")!=-1){
return
}
h.windowManager.open({
url:r.baseURL+"/themes/advanced/image.htm",width:355+parseInt(h.getLang("advanced.image_delta_width",0)),height:275+parseInt(h.getLang("advanced.image_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceLink:function(a,e){
var h=this.editor;
h.windowManager.open({
url:r.baseURL+"/themes/advanced/link.htm",width:310+parseInt(h.getLang("advanced.link_delta_width",0)),height:200+parseInt(h.getLang("advanced.link_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceNewDocument:function(){
var e=this.editor;
e.windowManager.confirm("advanced.newdocument",function(a){
if(a){
e.execCommand("mceSetContent",false,"")
}}
)
}
,_mceForeColor:function(){
var e=this;
this._mceColorPicker(0,{
color:e.fgColor,func:function(a){
e.fgColor=a;
e.editor.execCommand("ForeColor",false,a)
}}
)
}
,_mceBackColor:function(){
var e=this;
this._mceColorPicker(0,{
color:e.bgColor,func:function(a){
e.bgColor=a;
e.editor.execCommand("HiliteColor",false,a)
}}
)
}
,_ufirst:function(e){
return e.substring(0,1).toUpperCase()+e.substring(1)
}}
);
r.ThemeManager.add("advanced",r.themes.AdvancedTheme)
}
(tinymce));
