
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
var Validator={
isEmail:function(e){
return this.test(e,"^[-!#$%&'*+\\./0-9=?A-Z^_`a-z{|}~]+@[-!#$%&'*+\\/0-9=?A-Z^_`a-z{|}~]+.[-!#$%&'*+\\./0-9=?A-Z^_`a-z{|}~]+$")
}
,isAbsUrl:function(e){
return this.test(e,"^(news|telnet|nttp|file|http|ftp|https)://[-A-Za-z0-9\\.]+\\/?.*$")
}
,isSize:function(e){
return this.test(e,"^[0-9]+(%|in|cm|mm|em|ex|pt|pc|px)?$")
}
,isId:function(e){
return this.test(e,"^[A-Za-z_]([A-Za-z0-9_])*$")
}
,isEmpty:function(a){
var e,t;
if(a.nodeName=="SELECT"&&a.selectedIndex<1){
return true
}
if(a.type=="checkbox"&&!a.checked){
return true
}
if(a.type=="radio"){
for(t=0,e=a.form.elements;
t<e.length;
t++){
if(e[t].type=="radio"&&e[t].name==a.name&&e[t].checked){
return false
}}
return true
}
return new RegExp("^\\s*$").test(a.nodeType==1?a.value:a)
}
,isNumber:function(e,t){
return !isNaN(e.nodeType==1?e.value:e)&&(!t||!this.test(e,"^-?[0-9]*\\.[0-9]*$"))
}
,test:function(e,t){
e=e.nodeType==1?e.value:e;
return e==""||new RegExp(t).test(e)
}};
var AutoValidator={
settings:{
id_cls:"id",int_cls:"int",url_cls:"url",number_cls:"number",email_cls:"email",size_cls:"size",required_cls:"required",invalid_cls:"invalid",min_cls:"min",max_cls:"max"}
,init:function(e){
var t;
for(t in e){
this.settings[t]=e[t]
}}
,validate:function(o){
var t,e,a=this.settings,n=0;
e=this.tags(o,"label");
for(t=0;
t<e.length;
t++){
this.removeClass(e[t],a.invalid_cls)
}
n+=this.validateElms(o,"input");
n+=this.validateElms(o,"select");
n+=this.validateElms(o,"textarea");
return n==3
}
,invalidate:function(e){
this.mark(e.form,e)
}
,reset:function(l){
var r=["label","input","select","textarea"];
var n,o,a,h=this.settings;
if(l==null){
return
}
for(n=0;
n<r.length;
n++){
a=this.tags(l.form?l.form:l,r[n]);
for(o=0;
o<a.length;
o++){
this.removeClass(a[o],h.invalid_cls)
}}}
,validateElms:function(r,h){
var t,o,a,u=this.settings,d=true,l=Validator,c;
t=this.tags(r,h);
for(o=0;
o<t.length;
o++){
a=t[o];
this.removeClass(a,u.invalid_cls);
if(this.hasClass(a,u.required_cls)&&l.isEmpty(a)){
d=this.mark(r,a)
}
if(this.hasClass(a,u.number_cls)&&!l.isNumber(a)){
d=this.mark(r,a)
}
if(this.hasClass(a,u.int_cls)&&!l.isNumber(a,true)){
d=this.mark(r,a)
}
if(this.hasClass(a,u.url_cls)&&!l.isAbsUrl(a)){
d=this.mark(r,a)
}
if(this.hasClass(a,u.email_cls)&&!l.isEmail(a)){
d=this.mark(r,a)
}
if(this.hasClass(a,u.size_cls)&&!l.isSize(a)){
d=this.mark(r,a)
}
if(this.hasClass(a,u.id_cls)&&!l.isId(a)){
d=this.mark(r,a)
}
if(this.hasClass(a,u.min_cls,true)){
c=this.getNum(a,u.min_cls);
if(isNaN(c)||parseInt(a.value)<parseInt(c)){
d=this.mark(r,a)
}}
if(this.hasClass(a,u.max_cls,true)){
c=this.getNum(a,u.max_cls);
if(isNaN(c)||parseInt(a.value)>parseInt(c)){
d=this.mark(r,a)
}}}
return d
}
,hasClass:function(a,t,e){
return new RegExp("\\b"+t+(e?"[0-9]+":"")+"\\b","g").test(a.className)
}
,getNum:function(t,e){
e=t.className.match(new RegExp("\\b"+e+"([0-9]+)\\b","g"))[0];
e=e.replace(/[^0-9]/g,"");
return e
}
,addClass:function(i,a,e){
var t=this.removeClass(i,a);
i.className=e?a+(t!=""?(" "+t):""):(t!=""?(t+" "):"")+a
}
,removeClass:function(t,e){
e=t.className.replace(new RegExp("(^|\\s+)"+e+"(\\s+|$)")," ");
return t.className=e!=" "?e:""
}
,tags:function(t,e){
return t.getElementsByTagName(e)
}
,mark:function(t,a){
var e=this.settings;
this.addClass(a,e.invalid_cls);
this.markLabels(t,a,e.invalid_cls);
return false
}
,markLabels:function(o,s,e){
var t,a;
t=this.tags(o,"label");
for(a=0;
a<t.length;
a++){
if(t[a].getAttribute("for")==s.id||t[a].htmlFor==s.id){
this.addClass(t[a],e)
}}
return null
}};
