
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Briefcase")){
if(AjxPackage.define("zimbraMail.briefcase.view.ZmBriefcaseBaseView")){
ZmBriefcaseBaseView=function(e){
if(arguments.length==0){
return
}
e.posStyle=e.posStyle||DwtControl.ABSOLUTE_STYLE;
e.type=ZmItem.BRIEFCASE_ITEM;
e.pageless=(e.pageless!==false);
ZmListView.call(this,e)
};
ZmBriefcaseBaseView.prototype=new ZmListView;
ZmBriefcaseBaseView.prototype.constructor=ZmBriefcaseBaseView;
ZmBriefcaseBaseView.prototype.getTitle=function(){
return[ZmMsg.zimbraTitle,this._controller.getApp().getDisplayName()].join(": ")
};
ZmBriefcaseBaseView.prototype._sortIndex=function(r,s){
if(!r){
return 0
}
var e=r.getArray(),o=e.length;
for(var n=0;
n<e.length;
n++){
var t=e[n];
if(!t.isFolder&&s.name.toLowerCase()<t.name.toLowerCase()){
o=n;
break
}}
return o
};
ZmBriefcaseBaseView.prototype._changeListener=function(n){
if((n.type!=this.type)&&(ZmList.MIXED!=this.type)){
return
}
var t=n.getDetail("items");
if(n.event==ZmEvent.E_CREATE){
for(var a=0;
a<t.length;
a++){
var o=t[a];
if(this._list&&this._list.contains(o)){
continue
}
this.addItem(o,this._sortIndex(this._list,o));
this.scrollToItem(o);
if(this.getSelection().length>0){
this.selectItem(o,true)
}else{
this.setSelection(o)
}}}
if(n.event==ZmEvent.E_MODIFY){
for(var a=0;
a<t.length;
a++){
var o=t[a];
if(this._list&&this._list.contains(o)){
this._redrawItem(o);
if(this._expanded&&this._expanded[o.id]){
this.parent._expand(o)
}}}}
ZmListView.prototype._changeListener.call(this,n);
if(n.event==ZmEvent.E_MOVE){
var e=this._controller._folderId||this.folderId||this._folderId;
var o=t&&t.length?t[0]:t;
if(o&&o.folderId==e&&this._getRowIndex(o)===null){
this.addItem(o,0,true);
o.handled=true
}}};
ZmBriefcaseBaseView.prototype._getToolTip=function(o){
var i=o.item;
if(i.isFolder){
return null
}
var n=[{
name:ZmMsg.briefcasePropName,value:i.name}
];
if(i.size){
n.push({
name:ZmMsg.briefcasePropSize,value:AjxUtil.formatSize(i.size)}
)
}
if(i.modifyDate){
var a=AjxDateFormat.getDateTimeInstance(AjxDateFormat.FULL,AjxDateFormat.MEDIUM);
var e=a.format(i.modifyDate);
n.push({
name:ZmMsg.briefcasePropModified,value:e}
)
}
if(i.locked){
n.push({
name:ZmMsg.status,value:ZmMsg.locked}
)
}
var t={
title:ZmMsg.briefcaseFileProps,fileProperties:n,tagTooltip:this._getTagToolTip(i)};
return AjxTemplate.expand("briefcase.Briefcase#Tooltip",t)
};
ZmBriefcaseBaseView.prototype.uploadFiles=function(){
var e=appCtxt.getUploadDialog();
var t=this.processUploadFiles();
e.uploadFiles(t,document.getElementById("zdnd_form"),{
id:this._controller._folderId}
)
};
ZmBriefcaseBaseView.prototype.processUploadFiles=function(){
var o=[];
var n=document.getElementById("zdnd_ul");
if(n){
for(var t=0;
t<n.childNodes.length;
t++){
var a=n.childNodes[t];
var s=a.childNodes[0];
if(s.name!="_attFile_"){
continue
}
if(!s.value){
continue
}
var e={
fullname:s.value,name:s.value.replace(/^.*[\\\/:]/,"")};
o.push(e)
}}
return o
};
ZmBriefcaseBaseView.prototype.getListView=function(){
return this
};
ZmBriefcaseBaseView.prototype.getTitle=function(){
return[ZmMsg.zimbraTitle,ZmMsg.briefcase].join(": ")
};
ZmBriefcaseBaseView.prototype._cloneList=function(o){
var t=new ZmList(o.type,o.search);
var a;
for(var e=0;
e<o.size();
e++){
a=o.get(e);
a.list=t;
t.add(a)
}
t.setHasMore(o.hasMore());
return t
};
ZmBriefcaseBaseView.prototype.appendFolders=function(o){
if(o._foldersAdded){
return o
}
var t=this._folders=this._controller._getSubfolders();
var n=t?t.length:0;
var a=o;
if(n>0){
for(var e=n-1;
e>=0;
e--){
a.add(t[e],0)
}
a._foldersAdded=true
}
return a
};
ZmBriefcaseBaseView.prototype.set=function(s,t,r){
this.cleanup();
if(!r){
s=this.appendFolders(s)
}
this._zmList=s;
ZmListView.prototype.set.call(this,s,t);
if(this._expanded){
var e=s.getArray();
var o=e.length;
for(var a=0;
a<o;
a++){
var n=e[a];
if(this._expanded[n.id]){
this.parent._expand(n)
}}}};
ZmBriefcaseBaseView.prototype.renameFile=function(i){
var t=this._getFieldId(i,ZmItem.F_NAME);
t=document.getElementById(t);
var e=Dwt.getBounds(t);
var a=this._enableRenameInput(true,e);
a.setValue(i.name);
this._fileItem=i
};
ZmBriefcaseBaseView.prototype._enableRenameInput=function(e,a){
var t=this._getRenameInput();
if(e){
t.setBounds(a.x,a.y,a.width,18);
t.setDisplay(Dwt.DISPLAY_INLINE);
t.focus()
}else{
t.setDisplay(Dwt.DISPLAY_NONE);
t.setLocation("-10000px","-10000px")
}
return t
};
ZmBriefcaseBaseView.prototype._getRenameInput=function(){
if(!this._renameField){
this._renameField=new DwtInputField({
parent:appCtxt.getShell(),className:"RenameInput DwtInputField",posStyle:Dwt.ABSOLUTE_STYLE}
);
this._renameField.setZIndex(Dwt.Z_VIEW+10);
this._renameField.setDisplay(Dwt.DISPLAY_NONE);
this._renameField.setLocation("-10000px","-10000px");
this._renameField.addListener(DwtEvent.ONKEYUP,new AjxListener(this,this._handleKeyUp));
this.addSelectionListener(new AjxListener(this,this.cleanup))
}
return this._renameField
};
ZmBriefcaseBaseView.prototype._handleKeyUp=function(o){
var e=true;
var t=DwtKeyEvent.getCharCode(o);
var i=this._fileItem;
if(t==DwtKeyEvent.KEY_ENTER){
var n=this._renameField.getValue();
if(n!=""&&n!=i.name){
if(this._checkDuplicate(n)){
this._redrawItem(i);
var a=appCtxt.getMsgDialog();
a.setMessage(AjxMessageFormat.format(ZmMsg.itemWithFileNameExits,n),DwtMessageDialog.CRITICAL_STYLE,ZmMsg.briefcase);
a.popup()
}else{
i.rename(n,new AjxCallback(this,this.resetRenameFile))
}}else{
this.redrawItem(i)
}
e=false
}else{
if(t==DwtKeyEvent.KEY_ESCAPE){
this._redrawItem(i);
e=false
}}
DwtUiEvent.setBehaviour(o,true,e)
};
ZmBriefcaseBaseView.prototype.resetRenameFile=function(){
this._enableRenameInput(false);
this._fileItem=null
};
ZmBriefcaseBaseView.prototype._redrawItem=function(e){
this.resetRenameFile();
this.redrawItem(e)
};
ZmBriefcaseBaseView.prototype._checkDuplicate=function(e){
e=e.toLowerCase();
var o=this.getList();
if(o){
o=o.getArray();
for(var t=0;
t<o.length;
t++){
var a=o[t];
if(a.name.toLowerCase()==e){
return true
}}}
return false
};
ZmBriefcaseBaseView.prototype.cleanup=function(){
if(this._renameField){
this.resetRenameFile()
}}
}
if(AjxPackage.define("zimbraMail.briefcase.view.ZmBriefcaseIconView")){
ZmBriefcaseIconView=function(e){
ZmBriefcaseBaseView.call(this,e);
this.getHtmlElement().style.backgroundColor="white"
};
ZmBriefcaseIconView.prototype=new ZmBriefcaseBaseView;
ZmBriefcaseIconView.prototype.constructor=ZmBriefcaseIconView;
ZmBriefcaseIconView.prototype.toString=function(){
return"ZmBriefcaseIconView"
};
ZmBriefcaseIconView.prototype._createItemHtml=function(h,a){
var t=h.name;
var s=h.contentType;
if(s&&s.match(/;/)){
s=s.split(";")[0]
}
var i=s?ZmMimeTable.getInfo(s):null;
o="Img"+(i?i.imageLarge:"UnknownDoc_48");
if(h.isFolder){
o="ImgBriefcase_48"
}
if(t.length>14){
t=t.substring(0,14)+"..."
}
var e=document.createElement("div");
e.className="ZmBriefcaseItemSmall";
var r=[];
var n=0;
var o=null;
if(!o){
var s=h.contentType;
if(s&&s.match(/;/)){
s=s.split(";")[0]
}
var i=s?ZmMimeTable.getInfo(s):null;
o=i?i.image:"UnknownDoc";
if(h.isFolder){
o="Folder"
}}
r[n++]="<table><tr><td>";
n=this._getImageHtml(r,n,"CheckboxUnchecked",this._getFieldId(h,ZmItem.F_SELECTION));
r[n++]="</td><td><div class='Img";
r[n++]=o;
r[n++]="'></div></td><td nowrap>";
r[n++]=AjxStringUtil.htmlEncode(h.name);
r[n++]="</td><tr></table>";
if(a&&a.isDragProxy){
Dwt.setPosition(e,Dwt.ABSOLUTE_STYLE)
}
e.innerHTML=r.join("");
this.associateItemWithElement(h,e);
return e
};
ZmBriefcaseIconView.prototype.set=function(t,e,a){
a=true;
ZmBriefcaseBaseView.prototype.set.call(this,t,e,a)
}
}
if(AjxPackage.define("zimbraMail.briefcase.view.ZmDetailListView")){
ZmDetailListView=function(i,t,e){
this._controller=t;
var a=this._getHeaderList(i);
var o={
parent:i,className:"ZmBriefcaseDetailListView",view:ZmId.VIEW_BRIEFCASE_DETAIL,controller:t,headerList:a,dropTgt:e};
ZmBriefcaseBaseView.call(this,o);
this.enableRevisionView(true);
this._expanded={};
this._itemRowIdList={};
this._dragSrc=new DwtDragSource(Dwt.DND_DROP_MOVE);
this._dragSrc.addDragListener(new AjxListener(this,this._dragListener));
this.setDragSource(this._dragSrc);
this._dropTgt=new DwtDropTarget("ZmDetailListView");
this._dropTgt.markAsMultiple();
this._dropTgt.addDropListener(new AjxListener(this,this._dropListener));
this.setDropTarget(this._dropTgt)
};
ZmDetailListView.prototype=new ZmBriefcaseBaseView;
ZmDetailListView.prototype.constructor=ZmDetailListView;
ZmDetailListView.ROW_DOUBLE_CLASS="RowDouble";
ZmDetailListView.SINGLE_COLUMN_SORT=[{
field:ZmItem.F_NAME,msg:"name"}
,{
field:ZmItem.F_SIZE,msg:"size"}
,{
field:ZmItem.F_DATE,msg:"date"}
];
ZmDetailListView.prototype.toString=function(){
return"ZmDetailListView"
};
ZmDetailListView.KEY_ID="_keyId";
ZmDetailListView.COLWIDTH_ICON=20;
ZmDetailListView.prototype.enableRevisionView=function(e){
this._revisionView=e
};
ZmDetailListView.prototype._changeListener=function(n){
if(n.event==ZmEvent.E_MOVE||n.event==ZmEvent.E_DELETE){
if(this.getDnDSelection()&&this.getDnDSelection instanceof AjxVector){
this.dragDeselect(this.getDnDSelection().get(0))
}else{
if(this.getDnDSelection()){
this.dragDeselect(this.getDnDSelection())
}}}
ZmBriefcaseBaseView.prototype._changeListener.call(this,n);
if(this._revisionView&&(n.event==ZmEvent.E_DELETE||n.event==ZmEvent.E_MOVE)){
var t=n.getDetail("items")?n.getDetail("items"):[this._getItemFromEvent(n)];
for(var a=0,e=t.length;
a<e;
a++){
var o=t[a];
this.collapse(o,true)
}}};
ZmDetailListView.prototype._getHeaderList=function(t){
var a=[];
var e=this._view;
if(appCtxt.get(ZmSetting.SHOW_SELECTION_CHECKBOX)){
a.push(new DwtListHeaderItem({
field:ZmItem.F_SELECTION,icon:"CheckboxUnchecked",width:ZmListView.COL_WIDTH_ICON,name:ZmMsg.selection}
))
}
if(this.isMultiColumn()){
if(this._revisionView){
a.push(new DwtListHeaderItem({
field:ZmItem.F_EXPAND,icon:"NodeCollapsed",width:ZmDetailListView.COLWIDTH_ICON,name:ZmMsg.expand}
))
}
if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
a.push(new DwtListHeaderItem({
field:ZmItem.F_TAG,icon:"Tag",width:ZmDetailListView.COLWIDTH_ICON,name:ZmMsg.tag}
))
}
a.push(new DwtListHeaderItem({
field:ZmItem.F_LOCK,icon:"PadLock",width:ZmDetailListView.COLWIDTH_ICON,name:ZmMsg.lock}
),new DwtListHeaderItem({
field:ZmItem.F_TYPE,icon:"GenericDoc",width:ZmDetailListView.COLWIDTH_ICON,name:ZmMsg.icon}
),new DwtListHeaderItem({
field:ZmItem.F_NAME,text:ZmMsg._name,sortable:ZmItem.F_NAME}
),new DwtListHeaderItem({
field:ZmItem.F_FILE_TYPE,text:ZmMsg.type,width:ZmMsg.COLUMN_WIDTH_TYPE_DLV}
),new DwtListHeaderItem({
field:ZmItem.F_SIZE,text:ZmMsg.size,width:ZmMsg.COLUMN_WIDTH_SIZE_DLV,sortable:ZmItem.F_SIZE}
),new DwtListHeaderItem({
field:ZmItem.F_DATE,text:ZmMsg.modified,width:ZmMsg.COLUMN_WIDTH_DATE_DLV,sortable:ZmItem.F_DATE}
),new DwtListHeaderItem({
field:ZmItem.F_FROM,text:ZmMsg.author,width:ZmMsg.COLUMN_WIDTH_OWNER_DLV}
),new DwtListHeaderItem({
field:ZmItem.F_FOLDER,text:ZmMsg.folder,width:ZmMsg.COLUMN_WIDTH_FOLDER_DLV}
),new DwtListHeaderItem({
field:ZmItem.F_VERSION,text:ZmMsg.version,width:ZmMsg.COLUMN_WIDTH_VERSION_DLV}
))
}else{
a.push(new DwtListHeaderItem({
field:ZmItem.F_SORTED_BY,text:AjxMessageFormat.format(ZmMsg.arrangedBy,ZmMsg.name),sortable:ZmItem.F_SORTED_BY,resizeable:false}
))
}
return a
};
ZmDetailListView.prototype._getHeaderToolTip=function(a,e,i){
var t;
if(a==ZmItem.F_EXPAND){
t=ZmMsg.expandCollapse
}else{
if(a==ZmItem.F_LOCK){
t=ZmMsg.fileLockStatus
}else{
if(a==ZmItem.F_DATE){
t=ZmMsg.sortByModified
}else{
if(a==ZmItem.F_FROM){
t=ZmMsg.author
}else{
if(a==ZmItem.F_VERSION){
t=ZmMsg.latestVersion
}else{
if(a==ZmItem.F_NAME){
t=ZmMsg.sortByName
}else{
t=ZmBriefcaseBaseView.prototype._getHeaderToolTip.call(this,a,e,i)
}}}}}}
return t
};
ZmDetailListView.prototype._getActionMenuForColHeader=function(e){
if(!this.isMultiColumn()){
if(!this._colHeaderActionMenu||e){
this._colHeaderActionMenu=this._getSortMenu(ZmDetailListView.SINGLE_COLUMN_SORT,ZmItem.F_NAME)
}
return this._colHeaderActionMenu
}
var t=ZmListView.prototype._getActionMenuForColHeader.call(this,e);
return t
};
ZmDetailListView.prototype._colHeaderActionListener=function(e){
if(!this.isMultiColumn()){
this._sortMenuListener(e)
}else{
ZmListView.prototype._colHeaderActionListener.apply(this,arguments)
}};
ZmDetailListView.prototype._isExpandable=function(e){
return(!e.isFolder&&!e.isRevision&&parseInt(e.version)>1)
};
ZmDetailListView.prototype._getCellContents=function(c,l,u,h,i,t){
if(h==ZmItem.F_SELECTION){
var s=t.bContained?"CheckboxChecked":"CheckboxUnchecked";
l=this._getImageHtml(c,l,s,this._getFieldId(u,h))
}else{
if(h==ZmItem.F_EXPAND){
l=this._getImageHtml(c,l,this._isExpandable(u)?(this._expanded[u.id]?"NodeExpanded":"NodeCollapsed"):null,this._getFieldId(u,h))
}else{
if(h==ZmItem.F_TYPE){
c[l++]=AjxImg.getImageHtml(u.getIcon())
}else{
if(h==ZmItem.F_LOCK){
l=this._getImageHtml(c,l,(u.locked?"PadLock":"Blank_16"),this._getFieldId(u,h))
}else{
if(h==ZmItem.F_VERSION){
c[l++]=u.version
}else{
if(h==ZmItem.F_NAME||h==ZmItem.F_SUBJECT){
c[l++]="<div id='"+this._getFieldId(u,ZmItem.F_NAME)+"'>"+this._getDisplayName(u)+"</div>"
}else{
if(h==ZmItem.F_FILE_TYPE){
if(u.isFolder){
c[l++]=ZmMsg.folder
}else{
var n=u.contentType?ZmMimeTable.getInfo(u.contentType):null;
c[l++]=n?n.desc:"&nbsp;"
}}else{
if(h==ZmItem.F_SIZE){
c[l++]=u.isFolder?ZmMsg.folder:AjxUtil.formatSize(u.size)
}else{
if(h==ZmItem.F_DATE){
if(u.modifyDate){
c[l++]=AjxDateUtil.simpleComputeDateStr(u.modifyDate)
}}else{
if(h==ZmItem.F_FROM){
var e=u.modifier||u.creator;
e=e?e.split("@"):[""];
var o=e[0];
var d=appCtxt.get(ZmSetting.USERNAME);
if(d){
var a=d.split("@");
if(e[1]!=a[1]){
o=e.join("@")
}}
c[l++]="<span style='white-space: nowrap'>";
c[l++]=o;
c[l++]="</span>"
}else{
if(h==ZmItem.F_FOLDER){
var r=appCtxt.getById(u.folderId);
c[l++]=r?r.getName():u.folderId
}else{
if(h==ZmItem.F_SORTED_BY){
c[l++]=this._getAbridgedContent(u,i)
}else{
l=ZmListView.prototype._getCellContents.apply(this,arguments)
}}}}}}}}}}}}
return l
};
ZmDetailListView.prototype._getDisplayName=function(t){
var e;
if(t.isRevision){
e=("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+t.subject)
}else{
if(parseInt(t.version)>1){
e=AjxMessageFormat.format(ZmMsg.briefcaseFileVersion,[AjxStringUtil.htmlEncode(t.name),t.version])
}}
return e||(AjxStringUtil.htmlEncode(t.name))
};
ZmDetailListView.prototype._getAbridgedContent=function(a,i){
var e=0,t=[];
e=this._getTable(t,e,a);
e=this._getRow(t,e,a);
if(this._revisionView){
t[e++]="<td style='vertical-align:middle;' width=16 id='"+this._getFieldId(a,ZmItem.F_FOLDER)+"'><center>";
e=this._getCellContents(t,e,a,ZmItem.F_EXPAND,i);
t[e++]="</center></td>"
}
t[e++]="<td style='vertical-align:middle;' width=20 id='"+this._getFieldId(a,ZmItem.F_FOLDER)+"'><center>";
t[e++]=AjxImg.getImageHtml(a.getIcon());
t[e++]="</center></td>";
t[e++]="<td style='vertical-align:middle;' width='100%' id='"+this._getFieldId(a,ZmItem.F_NAME)+"'>";
t[e++]="&nbsp;"+this._getDisplayName(a);
t[e++]="</td>";
t[e++]="<td style='vertical-align:middle;text-align:left;' width=40 id='"+this._getFieldId(a,ZmItem.F_SIZE)+"'>";
e=this._getCellContents(t,e,a,ZmItem.F_SIZE,i);
t[e++]="</td>";
t[e++]="<td style='vertical-align:middle;' width='16' align='right' id='"+this._getFieldId(a,ZmItem.F_TAG)+"'>";
e=this._getImageHtml(t,e,a.getTagImageInfo(),this._getFieldId(a,ZmItem.F_TAG));
t[e++]="</td>";
t[e++]="</tr>";
t[e++]="</table>";
t[e++]="<table width='100%' border='0' cellpadding=0 cellspacing=0><tr>";
t[e++]="<td style='text-align:center'>";
e=this._getCellContents(t,e,a,ZmItem.F_FROM,i);
t[e++]="<td style='text-align:right;padding-right:50px;'>";
e=this._getCellContents(t,e,a,ZmItem.F_DATE,i);
t[e++]="</td>";
t[e++]="<td style='vertical-align:middle;' width='16' align='right' id='"+this._getFieldId(a,ZmItem.F_LOCK)+"' ";
e=this._getImageHtml(t,e,(a.locked?"PadLock":"Blank_16"),this._getFieldId(a,ZmItem.F_LOCK));
t[e++]="</td>";
t[e++]="</tr></table>";
return t.join("")
};
ZmDetailListView.prototype._getDivClass=function(t,e,a){
if(e.isRevision){
return[t,"BriefcaseItemExpanded"].join(" ")
}else{
return ZmBriefcaseBaseView.prototype._getDivClass.apply(this,arguments)
}};
ZmDetailListView.prototype.expandItem=function(e){
if(e&&this._isExpandable(e)&&this._revisionView){
this.parent._toggle(e)
}};
ZmDetailListView.prototype.expand=function(e,t){
if(!e||!t||t.size()==0){
return
}
this._addRevisionRows(e,t);
this._setImage(e,ZmItem.F_EXPAND,"NodeExpanded");
this._expanded[e.id]=true
};
ZmDetailListView.prototype._addRevisionRows=function(n,s){
var e=this._itemRowIdList[n.id];
if(e&&e.length&&e.length==s.size()&&this._rowsArePresent(n)){
this._showRows(e,true)
}else{
var a=this._getRowIndex(n);
this._itemRowIdList[n.id]=[];
for(var o=0;
o<s.size();
o++){
var t=s.get(o);
var r=this._createItemHtml(t);
if(!document.getElementById(r.id)){
this._addRow(r,a+o+1)
}else{
this._showRows([r.id],true)
}
this._itemRowIdList[n.id].push(r.id)
}}};
ZmDetailListView.prototype.collapse=function(a,t){
var e=this._itemRowIdList[a.id];
this._showRows(e,false);
this._setImage(a,ZmItem.F_EXPAND,"NodeCollapsed");
this._expanded[a.id]=false;
if(t){
this._itemRowIdList[a.id]=null
}};
ZmDetailListView.prototype.collapseAll=function(){
var t=this.getItemList(),e;
for(var a in this._expanded){
if(this._expanded[a]){
e=t.getById(a);
if(e){
this.collapse(e)
}}}};
ZmDetailListView.prototype.refreshItem=function(t){
if(t&&this._expanded[t.id]){
var e=this._itemRowIdList[t.id]
}};
ZmDetailListView.prototype._showRows=function(e,t){
if(e&&e.length){
for(var a=0;
a<e.length;
a++){
var o=document.getElementById(e[a]);
if(o){
Dwt.setVisible(o,t)
}}}};
ZmDetailListView.prototype._rowsArePresent=function(a){
var e=this._itemRowIdList[a.id];
if(e&&e.length){
for(var t=0;
t<e.length;
t++){
if(document.getElementById(e[t])){
return true
}}}
this._itemRowIdList[a.id]=[];
this._expanded[a.id]=false;
return false
};
ZmDetailListView.prototype._allowFieldSelection=function(a,t){
if(t==ZmItem.F_EXPAND){
var e=appCtxt.getById(a);
return(e&&!this._isExpandable(e))
}else{
return ZmListView.prototype._allowFieldSelection.apply(this,arguments)
}};
ZmDetailListView.prototype._sortColumn=function(t,o){
ZmBriefcaseBaseView.prototype._sortColumn.apply(this,arguments);
var a=this._controller.getSearchString();
var e=this._controller.getSearchStringHint();
if(this._sortByString&&(a||e)){
var i={
query:a,queryHint:e,types:[ZmItem.BRIEFCASE_ITEM],sortBy:this._sortByString};
appCtxt.getSearchController().search(i)
}};
ZmDetailListView.prototype.isMultiColumn=function(t){
var e=t||this._controller;
return !e.isReadingPaneOnRight()
};
ZmDetailListView.prototype.reRenderListView=function(t){
var a=this.isMultiColumn();
if(a!=this._isMultiColumn||t){
this._saveState({
selection:true,focus:true,scroll:true,expansion:true}
);
this._isMultiColumn=a;
this.headerColCreated=false;
this._headerList=this._getHeaderList();
this._rowHeight=null;
this._normalClass=a?DwtListView.ROW_CLASS:ZmDetailListView.ROW_DOUBLE_CLASS;
var e=this._zmList||this.getList()||(new AjxVector());
this.set(e);
this._restoreState()
}};
ZmDetailListView.prototype.setSize=function(t,e){
ZmListView.prototype.setSize.call(this,t,e);
this._resetColWidth()
};
ZmDetailListView.prototype.resetSize=function(a,t){
this.setSize(a,t);
var e=(t==Dwt.DEFAULT)?t:t-DwtListView.HEADERITEM_HEIGHT;
Dwt.setSize(this._parentEl,a,e)
};
ZmDetailListView.prototype._resetColWidth=function(){
if(!this.headerColCreated){
return
}
var t=this._getLastColumnIndex();
if(t){
var e=this._headerList[t];
if(e._field!=ZmItem.F_SORTED_BY){
DwtListView.prototype._resetColWidth.apply(this,arguments)
}}};
ZmDetailListView.prototype._getToolTip=function(i){
if(i.field==ZmItem.F_LOCK){
var a=i.item;
if(a.locked){
var t=AjxDateFormat.getDateTimeInstance(AjxDateFormat.LONG,AjxDateFormat.SHORT);
var e={
title:ZmMsg.checkedOutFile,fileProperties:[{
name:ZmMsg.checkoutTo,value:a.lockUser}
,{
name:ZmMsg.when,value:t.format(a.lockTime)}
]};
return AjxTemplate.expand("briefcase.Briefcase#Tooltip",e)
}}
return ZmBriefcaseBaseView.prototype._getToolTip.call(this,i)
};
ZmDetailListView.prototype._folderChangeListener=function(o){
if(appCtxt.getCurrentController()!=this._controller){
return
}
ZmBriefcaseBaseView.prototype._folderChangeListener.call(this,o);
var a=o.getDetail("organizers");
var t=(a&&a.length)?a[0]:o.source;
var n=this._controller._folderId;
var i=false;
if(o.event==ZmEvent.E_CREATE){
if(t&&n==t.parent.id){
i=true
}}else{
if(o.event==ZmEvent.E_MODIFY){
var e=o.getDetail("fields");
if(e[ZmOrganizer.F_NAME]||e[ZmOrganizer.F_COLOR]){
i=true
}}else{
if(o.event==ZmEvent.E_MOVE||o.event==ZmEvent.E_DELETE){
i=true;
if(this.getDnDSelection()&&this.getDnDSelection instanceof AjxVector){
this.dragDeselect(this.getDnDSelection().get(0))
}else{
if(this.getDnDSelection()){
this.dragDeselect(this.getDnDSelection())
}}
if(n!=t.id){
this.collapseAll()
}}}}
if(i){
appCtxt.getApp(ZmApp.BRIEFCASE).search({
folderId:n}
)
}};
ZmDetailListView.prototype._dropListener=function(e){
var t=e.srcData.data;
var i=this.getTargetItemDiv(e.uiEvent);
var a=this.getItemFromElement(i);
if(e.srcData&&e.srcData.controller!=appCtxt.getCurrentController()){
appCtxt.getCurrentController()._dropListener(e);
return
}
if(e.action==DwtDropEvent.DRAG_ENTER){
e.doIt=(a&&(a instanceof ZmBriefcaseFolderItem)&&(a.folder&&a.folder.mayContain(t)));
this.dragSelect(i)
}else{
if(e.action==DwtDropEvent.DRAG_DROP){
this.dragDeselect(i);
appCtxt.getCurrentController()._doMove(t,a.folder)
}else{
if(e.action==DwtDropEvent.DRAG_LEAVE){
view.dragDeselect(i)
}else{
if(e.action==DwtDropEvent.DRAG_OP_CHANGED){}}}}};
ZmDetailListView.prototype._dragListener=function(e){
if(e.action==DwtDragEvent.SET_DATA){
e.srcData={
data:e.srcControl.getDnDSelection(),controller:this}
}};
ZmDetailListView.prototype._createHeader=function(l,h,n,a,t,e,r){
if(n._field==ZmItem.F_SORTED_BY){
var s=n._field;
var o=this._itemCountTextTdId=DwtId._makeId(this.view,ZmSetting.RP_RIGHT,"td");
l[h++]="<td id='";
l[h++]=e;
l[h++]="' class='";
l[h++]=(e==this._currentColId)?"DwtListView-Column DwtListView-ColumnActive'":"DwtListView-Column'";
l[h++]=" width='auto'><table border=0 cellpadding=0 cellspacing=0 width='100%'><tr><td id='";
l[h++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_LABEL,this._view,s);
l[h++]="' class='DwtListHeaderItem-label'>";
l[h++]=n._label;
l[h++]="</td>";
l[h++]="<td class='itemSortIcon' id='";
l[h++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_ARROW,this._view,s);
l[h++]="'>";
l[h++]=AjxImg.getImageHtml(this._bSortAsc?"ColumnUpArrow":"ColumnDownArrow");
l[h++]="</td>";
l[h++]="<td align=right class='itemCountText' id='";
l[h++]=o;
l[h++]="'></td></tr></table></div></td>"
}else{
return DwtListView.prototype._createHeader.apply(this,arguments)
}}
}
if(AjxPackage.define("zimbraMail.briefcase.view.ZmPreviewPaneView")){
ZmPreviewPaneView=function(a,t,e){
if(arguments.length==0){
return
}
var i={};
i.className=i.className||"ZmPreviewPaneView";
i.parent=a;
i.controller=t;
i.posStyle=Dwt.ABSOLUTE_STYLE;
DwtComposite.call(this,i);
this._controller=t;
this._vertMsgSash=new DwtSash({
parent:this,style:DwtSash.HORIZONTAL_STYLE,className:"AppSash-horiz",threshold:ZmPreviewPaneView.SASH_THRESHOLD,posStyle:Dwt.ABSOLUTE_STYLE}
);
this._vertMsgSash.registerCallback(this._sashCallback,this);
this._horizMsgSash=new DwtSash({
parent:this,style:DwtSash.VERTICAL_STYLE,className:"AppSash-vert",threshold:ZmPreviewPaneView.SASH_THRESHOLD,posStyle:Dwt.ABSOLUTE_STYLE}
);
this._horizMsgSash.registerCallback(this._sashCallback,this);
this._previewView=new ZmPreviewView({
parent:this,posStyle:DwtControl.ABSOLUTE_STYLE,controller:this._controller}
);
this._detailListView=new ZmDetailListView(this,this._controller,this._controller._dropTgt);
this._detailListView.addSelectionListener(new AjxListener(this,this._listSelectionListener));
this._listSelectionShortcutDelayAction=new AjxTimedAction(this,this._listSelectionTimedAction);
this._delayedSelectionItem=null;
this.setReadingPane()
};
ZmPreviewPaneView.prototype=new DwtComposite;
ZmPreviewPaneView.prototype.constructor=ZmPreviewPaneView;
ZmPreviewPaneView.LIST_SELECTION_SHORTCUT_DELAY=300;
ZmPreviewPaneView.prototype.toString=function(){
return"ZmPreviewPaneView"
};
ZmPreviewPaneView.SASH_THRESHOLD=5;
ZmPreviewPaneView._TAG_IMG="TI";
ZmPreviewPaneView.prototype.getController=function(){
return this._controller
};
ZmPreviewPaneView.prototype.getTitle=function(){
return this._detailListView.getTitle()
};
ZmPreviewPaneView.prototype.getListView=function(){
return this._detailListView
};
ZmPreviewPaneView.prototype.setReadingPane=function(){
var i=this._detailListView,e=this._previewView;
var n=this._controller.isReadingPaneOn();
if(!n){
e.setVisible(false);
this._vertMsgSash.setVisible(false);
this._horizMsgSash.setVisible(false)
}else{
e.setVisible(true);
var t=this._controller.isReadingPaneOnRight();
var a=t?this._vertMsgSash:this._horizMsgSash;
var s=t?this._horizMsgSash:this._vertMsgSash;
s.setVisible(false);
a.setVisible(true)
}
i.reRenderListView();
e.noTab=!n||AjxEnv.isIE;
var o=this.getSize();
this._resetSize(o.x,o.y,true)
};
ZmPreviewPaneView.prototype.reRenderListView=function(t){
var e=this._detailListView;
e.reRenderListView(t);
var a=this.getSize();
this._resetSize(a.x,a.y,true)
};
ZmPreviewPaneView.prototype.enableRevisionView=function(e){
this._detailListView.enableRevisionView(e)
};
ZmPreviewPaneView.prototype.isRevisionViewEnabled=function(){
return this._detailListView._revisionView
};
ZmPreviewPaneView.prototype.resetPreviewPane=function(a,e){
this._detailListView._colHeaderActionMenu=null;
this.setReadingPane();
if(e==ZmSetting.RP_OFF){
var t=this.getSelection();
if(t.length>0){
this._previewView.set(t[0])
}else{
this._selectFirstItem()
}}};
ZmPreviewPaneView.prototype.getPreviewView=function(){
return this._previewView
};
ZmPreviewPaneView.prototype.getSelectionCount=function(){
return this._detailListView.getSelectionCount()
};
ZmPreviewPaneView.prototype.getSelection=function(){
return this._detailListView.getSelection()
};
ZmPreviewPaneView.prototype.reset=function(){
this._detailListView.reset();
this._previewView.reset()
};
ZmPreviewPaneView.prototype.isPreviewPaneVisible=function(){
return this._previewView.getVisible()
};
ZmPreviewPaneView.prototype.setBounds=function(t,i,a,e){
DwtComposite.prototype.setBounds.call(this,t,i,a,e);
this._resetSize(a,e)
};
ZmPreviewPaneView.prototype._resetSize=function(o,e,t){
if(o<=0||e<=0){
return
}
if(!t&&o==this._lastResetWidth&&e==this._lastResetHeight){
return
}
var a=this._controller.isReadingPaneOnRight();
if(this.isPreviewPaneVisible()){
var s=this.getSash();
var n=s.getSize();
var i=a?n.x:n.y;
if(a){
var r=this._vertSashX||(Number(ZmMsg.LISTVIEW_WIDTH))||Math.floor(o/3);
this._detailListView.resetSize(r,e);
s.setLocation(r,0);
this._previewView.setBounds(r+i,0,o-(r+i),e)
}else{
var h=this._horizSashY||(Math.floor(e/2)-DwtListView.HEADERITEM_HEIGHT);
this._detailListView.resetSize(o,h);
s.setLocation(0,h);
this._previewView.setBounds(0,h+i,o,e-(h+i))
}}else{
this._detailListView.resetSize(o,e)
}
this._detailListView._resetColWidth();
this._lastResetWidth=o;
this._lastResetHeight=e
};
ZmPreviewPaneView.prototype._sashCallback=function(m){
var n=this._controller.isReadingPaneOnRight();
if(m>0){
if(n){
var i=300;
var t=this._previewView.getSize().x;
m=Math.max(0,Math.min(m,t-i));
var u=((AjxEnv.isIE)?this._vertMsgSash.getLocation().x:this._detailListView.getSize().x)+m;
if(m>0){
this._detailListView.resetSize(u,Dwt.DEFAULT);
this._previewView.setBounds(this._previewView.getLocation().x+m,Dwt.DEFAULT,t-m,Dwt.DEFAULT)
}else{
m=0
}}else{
var r=this._previewView.getSize().y-m;
var l=150;
if(r>l){
this._detailListView.resetSize(Dwt.DEFAULT,this._detailListView.getSize().y+m);
this._previewView.setBounds(Dwt.DEFAULT,this._previewView.getLocation().y+m,Dwt.DEFAULT,r)
}else{
m=0
}}}else{
var d=Math.abs(m);
if(n){
if(!this._minMLVWidth){
var o=this._detailListView._headerList[0];
var h=o._width;
if(h=="auto"){
var s=Dwt.byId(o._id);
h=s&&Dwt.getSize(s).x
}
this._minMLVWidth=h
}
var a=((AjxEnv.isIE)?this._vertMsgSash.getLocation().x:this._detailListView.getSize().x);
d=Math.max(0,Math.min(d,a-this._minMLVWidth));
if(d>0){
m=-d;
this._detailListView.resetSize(a-d,Dwt.DEFAULT);
this._previewView.setBounds(this._previewView.getLocation().x-d,Dwt.DEFAULT,this._previewView.getSize().x+d,Dwt.DEFAULT)
}else{
m=0
}}else{
if(!this._minMLVHeight){
var c=this._detailListView.getList();
if(c&&c.size()){
var f=c.get(0);
var e=document.getElementById(this._detailListView._getItemId(f));
this._minMLVHeight=DwtListView.HEADERITEM_HEIGHT+(Dwt.getSize(e).y*2)
}else{
this._minMLVHeight=DwtListView.HEADERITEM_HEIGHT
}}
if(this.getSash().getLocation().y-d>this._minMLVHeight){
this._detailListView.resetSize(Dwt.DEFAULT,this._detailListView.getSize().y-d);
this._previewView.setBounds(Dwt.DEFAULT,this._previewView.getLocation().y-d,Dwt.DEFAULT,this._previewView.getSize().y+d)
}else{
m=0
}}}
if(m){
this._detailListView._resetColWidth();
if(n){
this._vertSashX=this._vertMsgSash.getLocation().x
}else{
this._horizSashY=this._horizMsgSash.getLocation().y
}}
return m
};
ZmPreviewPaneView.prototype._selectFirstItem=function(){
var t=this._detailListView.getList();
var e=t?t.get(0):null;
if(e&&!e.isFolder){
this._detailListView.setSelection(e)
}else{
this._previewView.enablePreview(false)
}};
ZmPreviewPaneView.prototype.getSash=function(){
var e=this._controller.isReadingPaneOnRight();
return e?this._vertMsgSash:this._horizMsgSash
};
ZmPreviewPaneView.prototype.getLimit=function(e){
return this._detailListView.getLimit(e)
};
ZmPreviewPaneView.prototype._staleHandler=function(){
var e=this._controller._currentSearch;
if(e){
e.lastId=e.lastSortVal=null;
e.offset=e.limit=0;
appCtxt.getSearchController().redoSearch(e)
}};
ZmPreviewPaneView.prototype.set=function(t,e){
this._detailListView.set(t,e);
var t=this._detailListView._zmList;
if(t){
t.addChangeListener(new AjxListener(this,this._listViewChangeListener))
}
this._previewView.set(null)
};
ZmPreviewPaneView.prototype._listViewChangeListener=function(t){
var e=this._detailListView.getSelection();
e=e&&e[0];
if(e){
this._listSelectionListener(t,e)
}else{
this._previewView.enablePreview(false)
}};
ZmPreviewPaneView.prototype._listSelectionTimedAction=function(){
if(!this._delayedSelectionItem){
return
}
if(this._listSelectionShortcutDelayActionId){
AjxTimedAction.cancelAction(this._listSelectionShortcutDelayActionId)
}
this._previewView.set(this._delayedSelectionItem)
};
ZmPreviewPaneView.prototype._listSelectionListener=function(i){
var a=i.item,o=false;
if(!a){
return
}
var e=appCtxt.isOffline&&appCtxt.getCurrentSearch();
if(e){
appCtxt.accountList.setActiveAccount(a.getAccount())
}
var t=i&&i._details&&i._details.oldFolderId==a.folderId;
if((i.event==ZmEvent.E_MOVE&&t)||i.event==ZmEvent.E_DELETE){
return
}
if(i.field==ZmItem.F_EXPAND&&this._detailListView._isExpandable(a)){
this._detailListView.expandItem(a)
}else{
if(this._controller.isReadingPaneOn()&&a){
if(i.kbNavEvent){
if(this._listSelectionShortcutDelayActionId){
AjxTimedAction.cancelAction(this._listSelectionShortcutDelayActionId)
}
this._delayedSelectionItem=a;
this._listSelectionShortcutDelayActionId=AjxTimedAction.scheduleAction(this._listSelectionShortcutDelayAction,ZmPreviewPaneView.LIST_SELECTION_SHORTCUT_DELAY)
}else{
this._previewView.set(a)
}}}};
ZmPreviewPaneView.prototype._toggle=function(e){
if(this._detailListView._expanded[e.id]){
this._detailListView.collapse(e)
}else{
this._expand(e)
}};
ZmPreviewPaneView.prototype._expand=function(t){
var e=new AjxCallback(this,this._handleVersions,t);
if(t&&t instanceof ZmBriefcaseItem){
t.getRevisions(e)
}};
ZmPreviewPaneView.prototype._handleVersions=function(t,e){
e=e.getResponse();
e=e.ListDocumentRevisionsResponse.doc;
var a=this._getRevisionItems(t,e);
this._detailListView.expand(t,a)
};
ZmPreviewPaneView.prototype._getRevisionItems=function(o,s){
var n=[];
for(var t=0;
t<s.length;
t++){
var e=s[t];
var a=new ZmRevisionItem(this._getRevisionId(e),o);
a.set(e);
n.push(a)
}
return AjxVector.fromArray(n)
};
ZmPreviewPaneView.prototype._getRevisionId=function(e){
return(e.id+"_"+(e.version||e.ver))
};
ZmPreviewPaneView.prototype._restoreVerListener=function(){
var e=this._detailListView.getSelection();
if(!e||e.length==0){
return
}
var t=e[0];
this.restoreVersion(t)
};
ZmPreviewPaneView.prototype.restoreVersion=function(t){
if(t.isRevision){
var e=t.parent;
if(e&&e.version!=t.revision){
e.restoreVersion(t.version,new AjxCallback(this,this.refreshItem,e))
}}};
ZmPreviewPaneView.prototype.deleteVersions=function(e){
e=e||this._detailListView.getSelection();
if(!e||e.length==0){
return
}
var a=new ZmBatchCommand(true,null,true);
for(var t=0;
t<e.length;
t++){
a.add(new AjxCallback(this,this.deleteVersion,[e[t],a]))
}
a.run()
};
ZmPreviewPaneView.prototype.deleteVersion=function(a,e){
if(a.isRevision){
var t=a.parent;
if(t&&t.version!=a.revision){
t.deleteVersion(a.version,new AjxCallback(this,this.refreshItem,t),e)
}}};
ZmPreviewPaneView.prototype.refreshItem=function(e){
this._detailListView.collapse(e,true);
this._expand(e)
};
ZmPreviewView=function(e){
if(arguments.length==0){
return
}
this._controller=e.controller;
e.className=e.className||"ZmPreviewView";
e.posStyle=Dwt.ABSOLUTE_STYLE;
DwtComposite.call(this,e);
this._initialize()
};
ZmPreviewView.prototype=new DwtComposite;
ZmPreviewView.prototype.constructor=ZmPreviewView;
ZmPreviewView.prototype.toString=function(){
return"ZmPreviewView"
};
ZmPreviewView.prototype._initialize=function(){
var e=this.getHTMLElId();
this.getHtmlElement().innerHTML=AjxTemplate.expand("briefcase.Briefcase#PreviewView",{
id:e}
);
this._headerEl=document.getElementById(e+"_header");
this._bodyEl=document.getElementById(e+"_body");
var t={
parent:this,className:"PreviewFrame",id:e+"_iframe",hidden:false,html:AjxTemplate.expand("briefcase.Briefcase#NoPreview",{
id:e}
),noscroll:false,posStyle:DwtControl.STATIC_STYLE};
this._iframePreview=new DwtIframe(t);
this._iframePreviewId=this._iframePreview.getIframe().id;
this._iframePreview.reparentHtmlElement(this._bodyEl);
this._previewContainer=document.getElementById(e+"_filepreview");
this._noresultContainer=document.getElementById(e+"_noitem");
this._headerName=document.getElementById(this._htmlElId+"_name");
this._headerImage=document.getElementById(this._htmlElId+"_image");
this._headerCreated=document.getElementById(this._htmlElId+"_created");
this._headerCreator=document.getElementById(this._htmlElId+"_creator");
this._headerModified=document.getElementById(this._htmlElId+"_modified");
this._headerModifier=document.getElementById(this._htmlElId+"_modifier");
this._headerLockTime=document.getElementById(this._htmlElId+"_lockTime");
this._headerLockUser=document.getElementById(this._htmlElId+"_lockUser");
this._headerNotesSection=document.getElementById(this._htmlElId+"_notes_section");
this._headerNotes=document.getElementById(this._htmlElId+"_notes");
this._headerExpand=document.getElementById(this._htmlElId+"_expand");
this._lockStatus=document.getElementById(this._htmlElId+"_lock");
Dwt.setHandler(this._headerExpand,DwtEvent.ONCLICK,AjxCallback.simpleClosure(this._toggleExpand,this));
this._iframePreview.getIframe().onload=AjxCallback.simpleClosure(this._updatePreview,this)
};
ZmPreviewView._errorCallback=function(a,e){
var t=window._zmPreviewView;
t._handleError(t._previewItem,a,e)
};
ZmPreviewView.prototype._handleError=function(o,n,a){
this.enablePreview(true);
if(o){
var t=o.getRestUrl();
t=AjxStringUtil.fixCrossDomainReference(t);
if(ZmMimeTable.isRenderable(o.contentType)){
this._iframePreview.setSrc(t)
}else{
if(ZmMimeTable.isMultiMedia(o.contentType)){
i=["<div style='height:100%;width:100%;text-align:center;vertical-align:middle;padding-top:30px;'>","<embed src='",t,"'/>","</div>"].join("");
this._iframePreview.setIframeContent(i)
}else{
var e=t+"?disp=a";
var i=["<div style='height:100%;width:100%;text-align:center;vertical-align:middle;padding-top:30px;'>",AjxMessageFormat.format(ZmMsg.previewDownloadLink,e),"</div>"].join("");
this._iframePreview.setIframeContent(i)
}}}};
ZmPreviewView.prototype._setupErrorCallback=function(e){
if(!window._zmPreviewView){
window._zmPreviewView=this
}
e=e+(e.match(/\?/)?"&":"?")+"callback=ZmPreviewView._errorCallback";
return e
};
ZmPreviewView.prototype.set=function(t){
if(!t){
this.enablePreview(false);
return
}
this._oldItem=this._previewItem;
this._previewItem=t;
this.enablePreview(true);
this._previewContent=false;
if(t.isFolder){
this._setFolder(t);
return
}
this._setHeader(t);
var e=t.getRestUrl();
e=AjxStringUtil.fixCrossDomainReference(e);
if(ZmMimeTable.isWebDoc(t.contentType)){
e=e+(e.match(/\?/)?"&":"?")+"viewonly=1"
}else{
this._setupLoading();
e=this._setupErrorCallback(e);
e+=(e.match(/\?/)?"&":"?")+"fmt=native&view=html"
}
this._iframePreview.setSrc(e);
Dwt.setLoadedTime("ZmBriefcaseItem",new Date())
};
ZmPreviewView.prototype._setupLoading=function(){
var t=["<div style='height:100%;width:100%;text-align:center;vertical-align:middle;padding-top:30px;'>",ZmMsg.generatingPreview,"</div>"].join("");
try{
this._iframePreview.setIframeContent(t)
}
catch(e){}};
ZmPreviewView.prototype._resetIframeHeight=function(){
var t=this._iframePreview.getIframe();
var i=this._iframePreview.getDocument();
var o=AjxEnv.isIE?i.body.scrollHeight:0;
var e=Math.max(i.body.scrollHeight,i.documentElement.scrollHeight,o);
t.style.height=e+"px";
if(AjxEnv.isWebKitBased){
var a=Math.max(i.body.scrollHeight,i.documentElement.scrollHeight);
if(a>e){
t.style.height=a+"px"
}}};
ZmPreviewView.prototype._setFolder=function(e){
this._cleanup();
this._headerName.innerHTML=AjxStringUtil.htmlEncode(e.name);
this._headerImage.className="ImgBriefcase_48";
if(this._headerModifier){
this._headerModifier.innerHTML=e.getOwner()
}
this._setIframeContent(AjxTemplate.expand("briefcase.Briefcase#FolderPreview"))
};
ZmPreviewView.prototype._setIframeContent=function(e){
this._previewContent=e;
this._iframePreview.setSrc('javascript:"";')
};
ZmPreviewView.prototype._updatePreview=function(){
if(this._previewContent){
this._iframePreview.setIframeContent(this._previewContent);
this._previewContent=false
}};
ZmPreviewView.prototype._cleanup=function(){
this._headerName.innerHTML="";
this._headerImage.className="ImgUnknownDoc_48";
if(this._headerModified){
this._headerModified.innerHTML=""
}
if(this._headerCreated){
this._headerCreated.innerHTML=""
}
if(this._headerCreator){
this._headerCreator.innerHTML=""
}
if(this._lockStatus){
this._lockStatus.innerHTML=AjxImg.getImageHtml("Blank_16")
}
if(this._headerLockTime){
this._headerLockTime.innerHTML=""
}
if(this._headerLockUser){
this._headerLockUser.innerHTML=""
}
Dwt.setVisible(this._headerNotesSection,false);
this._previewContent=false
};
ZmPreviewView.prototype._setHeader=function(i){
this._headerName.innerHTML=AjxStringUtil.htmlEncode(i.name);
var o=i.contentType;
if(o&&o.match(/;/)){
o=o.split(";")[0]
}
var e=o?ZmMimeTable.getInfo(o):null;
var a="Img"+(e?e.imageLarge:"UnknownDoc_48");
this._headerImage.className=a;
var t=AjxDateFormat.getDateTimeInstance(AjxDateFormat.LONG,AjxDateFormat.SHORT);
if(this._headerModified){
this._headerModified.innerHTML=t.format(i.modifyDate)
}
if(this._headerModifier){
this._headerModifier.innerHTML=i.modifier
}
if(this._headerCreated){
this._headerCreated.innerHTML=t.format(i.createDate)
}
if(this._headerCreator){
this._headerCreator.innerHTML=i.creator
}
if(this._lockStatus){
this._lockStatus.innerHTML=AjxImg.getImageHtml(i.locked?"PadLock":"Blank_16")
}
if(this._headerLockTime){
if(i.locked){
t=AjxDateFormat.getDateInstance();
this._headerLockTime.innerHTML=t.format(i.lockTime)
}else{
this._headerLockTime.innerHTML=""
}}
if(this._headerLockUser){
this._headerLockUser.innerHTML=i.locked?i.lockUser:""
}
this.setNotes(i)
};
ZmPreviewView.prototype.setNotes=function(e){
var t=e.subject;
Dwt.setVisible(this._headerNotesSection,t);
if(t&&this._headerNotes){
this._headerNotes.innerHTML=AjxStringUtil.nl2br(e.subject)
}
this.expandNotes(false)
};
ZmPreviewView.prototype.expandNotes=function(e){
this._expandState=e;
if(this._headerNotes){
this._headerNotes.style.height=e?"":"15px"
}
if(this._headerExpand){
this._headerExpand.innerHTML=AjxImg.getImageHtml((e?"NodeExpanded":"NodeCollapsed"))
}};
ZmPreviewView.prototype._toggleExpand=function(){
this.expandNotes(!this._expandState)
};
ZmPreviewView.prototype.downloadListener=function(e){
this._controller.downloadFile(e)
};
ZmPreviewView.prototype.emailListener=function(e){
this._controller.sendFilesAsAttachment(e)
};
ZmPreviewView.prototype.openListener=function(e){
this._controller.openFile(e)
};
ZmPreviewView.prototype.editListener=function(e){
this._controller.editFile(e)
};
ZmPreviewView.prototype.enablePreview=function(e){
if(e){
Dwt.setDisplay(this._previewContainer,Dwt.DISPLAY_INLINE);
Dwt.setDisplay(this._noresultContainer,Dwt.DISPLAY_NONE)
}else{
Dwt.setDisplay(this._previewContainer,Dwt.DISPLAY_NONE);
Dwt.setDisplay(this._noresultContainer,Dwt.DISPLAY_INLINE)
}}
}
if(AjxPackage.define("zimbraMail.briefcase.view.ZmNewBriefcaseDialog")){
ZmNewBriefcaseDialog=function(a,t){
var i=ZmMsg.createNewBriefcaseItem;
var e=ZmOrganizer.BRIEFCASE;
ZmNewOrganizerDialog.call(this,a,t,i,e)
};
ZmNewBriefcaseDialog.prototype=new ZmNewOrganizerDialog;
ZmNewBriefcaseDialog.prototype.constructor=ZmNewBriefcaseDialog;
ZmNewBriefcaseDialog.prototype.toString=function(){
return"ZmNewBriefcaseDialog"
};
ZmNewBriefcaseDialog.prototype._createRemoteContentHtml=function(t,e){
return e
}
}
if(AjxPackage.define("zimbraMail.briefcase.view.dialog.ZmBriefcaseTabView")){
ZmBriefcaseTabView=function(a,t,e){
this._app=appCtxt.getApp(ZmApp.BRIEFCASE);
this.view=ZmId.VIEW_BRIEFCASE_ICON;
DwtTabViewPage.call(this,a,t,Dwt.STATIC_STYLE);
this.setScrollStyle(Dwt.SCROLL)
};
ZmBriefcaseTabView.prototype=new DwtTabViewPage;
ZmBriefcaseTabView.prototype.constructor=ZmBriefcaseTabView;
ZmBriefcaseTabView.prototype.toString=function(){
return"ZmBriefcaseTabView"
};
ZmBriefcaseTabView.prototype.showMe=function(){
DwtTabViewPage.prototype.showMe.call(this);
this.setSize(Dwt.DEFAULT,235);
this._itemCountText.setVisible(true);
this.showFolder(this._folderId||ZmOrganizer.ID_BRIEFCASE)
};
ZmBriefcaseTabView.prototype.hideMe=function(){
DwtTabViewPage.prototype.hideMe.call(this);
this._itemCountText.setVisible(false)
};
ZmBriefcaseTabView.prototype._createHtml=function(){
this._contentEl=this.getContentHtmlElement();
this._tableID=Dwt.getNextId();
this._folderTreeCellId=Dwt.getNextId();
this._folderListId=Dwt.getNextId();
var a=[];
var e=0;
a[e++]=['<table class="ZmBriefcaseTabView_Table" id="',this._tableID,'" cellspacing="0" cellpadding="0" border="0">'].join("");
a[e++]="<tr>";
a[e++]=['<td width="30%" valign="top" id="',this._folderTreeCellId,'">'].join("");
a[e++]="</td>";
a[e++]=['<td width="70%" valign="top" id="',this._folderListId,'">'].join("");
a[e++]="</td>";
a[e++]="</tr>";
a[e++]="</table>";
this._contentEl.innerHTML=a.join("");
this.showBriefcaseTreeView();
var t=new AjxCallback(this,this._createHtml1);
AjxDispatcher.require(["BriefcaseCore","Briefcase"],false,t)
};
ZmBriefcaseTabView.prototype._createHtml1=function(){
this._app=appCtxt.getApp(ZmApp.BRIEFCASE);
var i=this._controller=new ZmBriefcaseController(this._app._container,this._app);
var n={
parent:i._container,className:"BriefcaseTabBox BriefcaseList",view:this.view,controller:i};
var o=this._listView=this._controller._listView[this.view]=new ZmBriefcaseIconView(n);
o.reparentHtmlElement(this._folderListId);
Dwt.setPosition(o.getHtmlElement(),Dwt.RELATIVE_STYLE);
var t=this.parent._tabBar;
var a=t._suffixEl;
if(a){
var e=new DwtText({
parent:t,className:"itemCountText",id:this.view+"Text"}
);
this._itemCountText=i._itemCountText[this.view]=e;
e.reparentHtmlElement(a.id);
e.getHtmlElement().style.textAlign="right"
}};
ZmBriefcaseTabView.prototype.setSize=function(i,e){
DwtTabViewPage.prototype.setSize.call(this,i,e);
var a=this.getSize();
var n=a.x*0.4;
var o=a.x-n;
var t=e-15;
if(this._overview){
this._overview.setSize(n,t);
this._listView.setSize(o-5,t)
}
return this
};
ZmBriefcaseTabView.prototype.showFolder=function(e){
this._folderId=e;
var a=new AjxCallback(this,this.showFolderContents,[e]);
var t={
folderId:e,callback:a,noRender:true};
if(appCtxt.multiAccounts){
t.accountName=appCtxt.getAppViewMgr().getCurrentView().getFromAccount().name
}
this._app.search(t)
};
ZmBriefcaseTabView.prototype.showFolderContents=function(t,a){
var e=a.getResponse();
if(e){
var i=this._controller._list=e.getResults(ZmItem.BRIEFCASE_ITEM);
this._controller._list.setHasMore(e.getAttribute("more"));
ZmListController.prototype.show.call(this._controller,e,ZmId.VIEW_BRIEFCASE_ICON);
this._listView.set(i);
this._listView.focus();
this._controller._setItemCountText()
}};
ZmBriefcaseTabView.prototype._handleKeys=function(t){
var e=DwtKeyEvent.getCharCode(t);
return(e!=DwtKeyEvent.KEY_ENTER&&e!=DwtKeyEvent.KEY_END_OF_TEXT)
};
ZmBriefcaseTabView.prototype.gotAttachments=function(){
return false
};
ZmBriefcaseTabView.prototype.uploadFiles=function(a,o){
if(!o){
o=[];
var e=this._listView.getSelection();
if(!e||(e.length==0)){
var a=appCtxt.getAttachDialog();
a.setFooter(ZmMsg.attachSelectMessage);
return
}
for(var t in e){
o.push({
id:e[t].id,ct:e[t].contentType,s:e[t].size}
)
}}
o=AjxUtil.toArray(o);
var n=a.getUploadCallback();
if(n){
n.run(AjxPost.SC_OK,null,o)
}};
ZmBriefcaseTabView.prototype.showBriefcaseTreeView=function(){
var a=appCtxt.isChildWindow?parentAppCtxt:appCtxt;
var e=a.getApp(ZmApp.BRIEFCASE);
e._createDeferredFolders();
var t=this.toString();
var o=appCtxt.getActiveAccount();
var i={
treeIds:[ZmOrganizer.BRIEFCASE],fieldId:this._folderTreeCellId,overviewId:(appCtxt.multiAccounts)?([t,o.name].join(":")):t,account:o};
this._setOverview(i)
};
ZmBriefcaseTabView.prototype._setOverview=function(o){
var i=o.overviewId;
var n=appCtxt.getOverviewController();
var a=n.getOverview(i);
if(!a){
var e={
overviewId:i,overviewClass:"BriefcaseTabBox",headerClass:"DwtTreeItem",noTooltips:true,treeIds:o.treeIds};
a=this._overview=n.createOverview(e);
a.set(o.treeIds);
document.getElementById(o.fieldId).appendChild(a.getHtmlElement());
var t=a.getTreeView(ZmOrganizer.BRIEFCASE);
t.addSelectionListener(new AjxListener(this,this._treeListener));
this._hideRoot(t)
}else{
if(o.account){
a.account=o.account
}}};
ZmBriefcaseTabView.prototype._treeListener=function(a){
if(a.detail==DwtTree.ITEM_SELECTED){
var e=a.item;
var t=e.getData(Dwt.KEY_OBJECT);
if(t){
this.showFolder(t.id)
}}};
ZmBriefcaseTabView.prototype._hideRoot=function(t){
var a=t.getTreeItemById(ZmOrganizer.ID_ROOT);
if(!a){
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
a=t.getTreeItemById(e)
}
a.showCheckBox(false);
a.setExpanded(true);
a.setVisible(false,true)
}
}
if(AjxPackage.define("zimbraMail.briefcase.view.dialog.ZmCheckinDialog")){
ZmCheckinDialog=function(a,e,t){
if(arguments.length==0){
return
}
DwtDialog.call(this,{
parent:a,className:t,title:ZmMsg.checkInFileToBriefcase}
);
this._controller=e;
this._createUploadHtml();
this.getButton(DwtDialog.OK_BUTTON).setText(ZmMsg.checkIn);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._upload))
};
ZmCheckinDialog.prototype=new DwtDialog;
ZmCheckinDialog.prototype.constructor=ZmCheckinDialog;
ZmCheckinDialog.prototype.popup=function(e,t){
this._item=e;
this._uploadCallback=t;
this._verDiv.innerHTML=Number(e.version)+1;
this._fileTD.innerHTML="";
this._fileTD.innerHTML=['<input type="file" name="file" id="',this._templateId,'_file" size="35"/>'].join("");
this._notes.value="";
DwtDialog.prototype.popup.call(this)
};
ZmCheckinDialog.prototype._createUploadHtml=function(){
this._templateId=Dwt.getNextId();
var e=appCtxt.get(ZmSetting.CSFE_UPLOAD_URI);
this.setContent(AjxTemplate.expand("briefcase.Briefcase#CheckinDialog",{
id:this._templateId,uri:e}
));
this._verDiv=document.getElementById(this._templateId+"_version");
this._fileTD=document.getElementById(this._templateId+"_fileTD");
this._notes=document.getElementById(this._templateId+"_notes")
};
ZmCheckinDialog.prototype._upload=function(){
var a=document.getElementById(this._templateId+"_file");
if(!a.value){
return
}
var t=this._item;
var e={
fullname:a.value,name:a.value.replace(/^.*[\\\/:]/,""),id:t.id,version:t.version,folder:t.folderId,notes:this._notes.value};
var i=new AjxCallback(this,this._uploadSaveDocs,e);
this._initiateUpload(this._templateId+"_form",i)
};
ZmCheckinDialog.prototype._initiateUpload=function(i,o){
this.setButtonEnabled(DwtDialog.OK_BUTTON,false);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,false);
var a=document.getElementById(i);
var t=appCtxt.getUploadManager();
window._uploadManager=t;
try{
t.execute(o,a)
}
catch(e){
if(e.msg){
this._popupErrorDialog(e.msg)
}else{
this._popupErrorDialog(ZmMsg.unknownError)
}}};
ZmCheckinDialog.prototype._uploadSaveDocs=function(a,e,t){
if(e!=AjxPost.SC_OK){
var i=AjxMessageFormat.format(ZmMsg.uploadError,e);
if(e=="413"){
i=ZmMsg.errorAttachmentTooBig
}
this._popupErrorDialog(i)
}else{
a.guid=t;
this._uploadSaveDocs2(a,e,t)
}};
ZmCheckinDialog.prototype._uploadSaveDocs2=function(i,e,t){
var a={
SaveDocumentRequest:{
_jsns:"urn:zimbraMail",doc:{
id:i.id,ver:i.version,l:i.folderId,name:i.name,desc:i.notes,upload:{
id:i.guid}}}};
var n=new AjxCallback(this,this._uploadSaveDocsResponse,[i,e,t]);
var o={
jsonObj:a,asyncMode:true,callback:n,errorCallback:new AjxCallback(this,this._handleSaveDocError,[i,e,t])};
appCtxt.getAppController().sendRequest(o)
};
ZmCheckinDialog.prototype._handleSaveDocError=function(i,e,t,a){
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
if(a.code==ZmCsfeException.MAIL_ALREADY_EXISTS){
var o=appCtxt.getMsgDialog();
o.reset();
o.setMessage(AjxMessageFormat.format(ZmMsg.itemWithFileNameExits,i.name),DwtMessageDialog.CRITICAL_STYLE,ZmMsg.briefcase);
o.popup();
return true
}
return false
};
ZmCheckinDialog.prototype._uploadSaveDocsResponse=function(t,o,s,i){
var a=i&&i._data;
var h=a&&a.SaveDocumentResponse;
if(h){
h=h.doc[0];
t.done=true;
t.name=h.name;
t.version=h.ver;
this._finishUpload(t)
}
this.popdown();
if(a&&a.Fault){
var n=a.Fault;
var r=n.Detail.Error;
var e=r.Code;
if(e==ZmCsfeException.MAIL_QUOTA_EXCEEDED){
this._popupErrorDialog(ZmMsg.errorQuotaExceeded)
}}};
ZmCheckinDialog.prototype._finishUpload=function(e){
if(this._uploadCallback){
this._uploadCallback.run(e)
}};
ZmCheckinDialog.prototype._popupErrorDialog=function(t){
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
var e=appCtxt.getMsgDialog();
e.setMessage(t,DwtMessageDialog.CRITICAL_STYLE,this._title);
e.popup()
}
}
if(AjxPackage.define("zimbraMail.briefcase.controller.ZmBriefcaseController")){
ZmBriefcaseController=function(e,t){
if(arguments.length==0){
return
}
ZmListController.call(this,e,t);
this._idMap={};
this._listChangeListener=new AjxListener(this,this._fileListChangeListener);
this._listeners[ZmOperation.OPEN_FILE]=new AjxListener(this,this._openFileListener);
this._listeners[ZmOperation.SAVE_FILE]=new AjxListener(this,this._saveFileListener);
this._listeners[ZmOperation.SEND_FILE]=new AjxListener(this,this._sendFileListener);
this._listeners[ZmOperation.SEND_FILE_AS_ATT]=new AjxListener(this,this._sendFileAsAttachmentListener);
this._listeners[ZmOperation.NEW_FILE]=new AjxListener(this,this._uploadFileListener);
this._listeners[ZmOperation.VIEW_FILE_AS_HTML]=new AjxListener(this,this._viewAsHtmlListener);
this._listeners[ZmOperation.CREATE_SLIDE_SHOW]=new AjxListener(this,this._createSlideShow);
this._listeners[ZmOperation.EDIT_FILE]=new AjxListener(this,this._editFileListener);
this._listeners[ZmOperation.RENAME_FILE]=new AjxListener(this,this._renameFileListener);
this._listeners[ZmOperation.NEW_BRIEFCASE_WIN]=new AjxListener(this,this._newWinListener);
this._listeners[ZmOperation.NEW_SPREADSHEET]=new AjxListener(this,this._handleDoc,[ZmOperation.NEW_SPREADSHEET]);
this._listeners[ZmOperation.NEW_PRESENTATION]=new AjxListener(this,this._handleDoc,[ZmOperation.NEW_PRESENTATION]);
this._listeners[ZmOperation.NEW_DOC]=new AjxListener(this,this._handleDoc,[ZmOperation.NEW_DOC]);
this._listeners[ZmOperation.CHECKIN]=new AjxListener(this,this._handleCheckin);
this._listeners[ZmOperation.CHECKOUT]=new AjxListener(this,this._checkoutListener);
this._listeners[ZmOperation.DISCARD_CHECKOUT]=new AjxListener(this,this._handleDiscardCheckout);
this._listeners[ZmOperation.RESTORE_VERSION]=new AjxListener(this,this._restoreVerListener);
this._listeners[ZmOperation.SHOW_DOWNLOADS]=new AjxListener(this,ZmListController.prototype._showDownloadsListener);
this._dragSrc=new DwtDragSource(Dwt.DND_DROP_MOVE);
this._dragSrc.addDragListener(new AjxListener(this,this._dragListener));
this._parentView={}
};
ZmBriefcaseController.prototype=new ZmListController;
ZmBriefcaseController.prototype.constructor=ZmBriefcaseController;
ZmBriefcaseController.prototype.toString=function(){
return"ZmBriefcaseController"
};
ZmBriefcaseController._VIEWS={};
ZmBriefcaseController._VIEWS[ZmId.VIEW_BRIEFCASE_DETAIL]="ZmPreviewPaneView";
ZmBriefcaseController.RP_IDS=[ZmSetting.RP_BOTTOM,ZmSetting.RP_RIGHT,ZmSetting.RP_OFF];
ZmBriefcaseController.PREVIEW_PANE_TEXT={};
ZmBriefcaseController.PREVIEW_PANE_TEXT[ZmSetting.RP_OFF]=ZmMsg.previewPaneOff;
ZmBriefcaseController.PREVIEW_PANE_TEXT[ZmSetting.RP_BOTTOM]=ZmMsg.previewPaneAtBottom;
ZmBriefcaseController.PREVIEW_PANE_TEXT[ZmSetting.RP_RIGHT]=ZmMsg.previewPaneOnRight;
ZmBriefcaseController.PREVIEW_PANE_ICON={};
ZmBriefcaseController.PREVIEW_PANE_ICON[ZmSetting.RP_OFF]="SplitPaneOff";
ZmBriefcaseController.PREVIEW_PANE_ICON[ZmSetting.RP_BOTTOM]="SplitPane";
ZmBriefcaseController.PREVIEW_PANE_ICON[ZmSetting.RP_RIGHT]="SplitPaneVertical";
ZmBriefcaseController.ACTION_CODE_TO_MENU_ID={};
ZmBriefcaseController.ACTION_CODE_TO_MENU_ID[ZmKeyMap.READING_PANE_OFF]=ZmSetting.RP_OFF;
ZmBriefcaseController.ACTION_CODE_TO_MENU_ID[ZmKeyMap.READING_PANE_BOTTOM]=ZmSetting.RP_BOTTOM;
ZmBriefcaseController.ACTION_CODE_TO_MENU_ID[ZmKeyMap.READING_PANE_RIGHT]=ZmSetting.RP_RIGHT;
ZmBriefcaseController.LIST_VIEW={};
ZmBriefcaseController.LIST_VIEW[ZmId.VIEW_BRIEFCASE_DETAIL]={
image:"GenericDoc",text:ZmMsg.byLatestFile};
ZmBriefcaseController.LIST_VIEW[ZmId.VIEW_BRIEFCASE_REVISION]={
image:"VersionHistory",text:ZmMsg.byVersionHistory};
ZmBriefcaseController.prototype._dropListener=function(a){
var e=this._listView[this._currentView];
var i=e.getTargetItemDiv(a.uiEvent);
var t=e.getItemFromElement(i);
if(!t||!(t.isRevision||t.isFolder)){
ZmListController.prototype._dropListener.call(this,a)
}else{
a.doIt=false
}};
ZmBriefcaseController.prototype._standardActionMenuOps=function(){
return[ZmOperation.TAG_MENU,ZmOperation.DELETE,ZmOperation.MOVE]
};
ZmBriefcaseController.prototype._getToolBarOps=function(){
var e=[ZmOperation.NEW_MENU,ZmOperation.SEP,ZmOperation.NEW_FILE,ZmOperation.SAVE_FILE,ZmOperation.EDIT_FILE,ZmOperation.SEP,ZmOperation.DELETE,ZmOperation.MOVE,ZmOperation.NEW_BRIEFCASE_WIN,ZmOperation.SEP,ZmOperation.TAG_MENU,ZmOperation.SEP];
if(appCtxt.get(ZmSetting.SPREADSHEET_ENABLED)){
e.push(ZmOperation.NEW_SPREADSHEET,ZmOperation.SEP)
}
if(appCtxt.get(ZmSetting.SLIDES_ENABLED)){
e.push(ZmOperation.NEW_PRESENTATION,ZmOperation.SEP)
}
if(appCtxt.get(ZmSetting.MAIL_ENABLED)){
e.push(ZmOperation.SEND_FILE_MENU,ZmOperation.SEP)
}
e.push(ZmOperation.SEP,ZmOperation.SHOW_DOWNLOADS,ZmOperation.SEP);
e.push(ZmOperation.VIEW_MENU);
return e
};
ZmBriefcaseController.prototype._handleDoc=function(e){
this._app.handleOp(e)
};
ZmBriefcaseController.prototype._initializeToolBar=function(e){
if(!this._toolbar[e]){
ZmListController.prototype._initializeToolBar.call(this,e);
this._setupViewMenu(e,true);
this._setNewButtonProps(e,ZmMsg.newDocument,"Doc","DocDis",ZmOperation.NEW_DOC);
this._initSendMenu(e);
var t=this._toolbar[e];
t.addFiller();
this._initializeNavToolBar(e);
appCtxt.notifyZimlets("initializeToolbar",[this._app,t,this,e],{
waitUntilLoaded:true}
)
}else{
this._setupDeleteButton(this._toolbar[e]);
this._setupViewMenu(e,false)
}};
ZmBriefcaseController.prototype._setupDeleteButton=function(t){
var a=this._getSearchFolder();
var e=(a&&a.nId==ZmFolder.ID_TRASH);
var i=e?ZmMsg.deletePermanentTooltip:ZmMsg.deleteTooltip;
var o=t.getButton(ZmOperation.DELETE);
if(o){
o.setToolTipContent(ZmOperation.getToolTip(ZmOperation.DELETE,ZmKeyMap.MAP_NAME_R[this.getKeyMapName()],i))
}};
ZmBriefcaseController.prototype._initializeNavToolBar=function(e){
this._toolbar[e].addOp(ZmOperation.TEXT);
var t=this._itemCountText[e]=this._toolbar[e].getButton(ZmOperation.TEXT);
t.addClassName("itemCountText")
};
ZmBriefcaseController.prototype._resetOperations=function(b,u){
if(!b){
return
}
ZmListController.prototype._resetOperations.call(this,b,u);
var z=this._listView[this._currentView].getSelection();
var W=false,l=0,S=false,a=false,t=false;
var C=false,y=false,M=true,c=true;
var p=false;
if(z){
for(var A=0;
A<z.length;
A++){
var B=z[A];
if(B.isFolder){
W=true;
l++
}else{
if(B.isRevision){
S=true;
if(B.parent.version==B.version){
p=true
}}else{
a=true
}}
C=C||(!B.isFolder&&B.isWebDoc());
M=M&&B.locked;
y=y||B.locked;
c=c&&(B.locked&&B.lockUser==appCtxt.getActiveAccount().name)
}}
t=W?(a||S):(a&&S);
var w=appCtxt.getById(this._folderId);
if(!(w instanceof ZmBriefcase)){
w=null
}
var s=(w&&w.nId==ZmOrganizer.ID_TRASH);
var k=((w&&w.nId!=ZmOrganizer.ID_TRASH&&w.isShared()));
var v=w?w.isReadOnly():false;
var T=(l>1);
var g=(u>0);
var d=appCtxt.getActiveAccount().isZimbraAccount;
var e=appCtxt.get(ZmSetting.MAIL_ENABLED);
var j=w&&w.isAdmin();
var B=z[0];
var n=B&&B.isRevision;
b.enable([ZmOperation.SEND_FILE_MENU,ZmOperation.SEND_FILE,ZmOperation.SEND_FILE_AS_ATT],(d&&e&&g&&!T&&!W));
b.enable(ZmOperation.TAG_MENU,(!k&&g&&!W&&!n));
b.enable([ZmOperation.NEW_FILE,ZmOperation.VIEW_MENU],true);
b.enable([ZmOperation.NEW_SPREADSHEET,ZmOperation.NEW_PRESENTATION,ZmOperation.NEW_DOC],true);
b.enable(ZmOperation.MOVE,(g&&!v&&!k&&!n));
b.enable(ZmOperation.NEW_FILE,!(s||v));
b.enable(ZmOperation.NEW_BRIEFCASE_WIN,(g&&!W));
var D=z&&z[0];
var h=D&&!D.isFolder&&D.isWebDoc();
var f=D&&!D.isFolder&&D.locked;
var O=f&&(B.lockUser==appCtxt.getActiveAccount().name);
b.enable(ZmOperation.RENAME_FILE,(u==1&&!W&&!v&&!n&&(f?O:true)));
b.enable(ZmOperation.SAVE_FILE,u>0&&(!W||a));
b.enable(ZmOperation.OPEN_FILE,(u==1&&h));
b.enable(ZmOperation.EDIT_FILE,!v&&(!f||O)&&h&&!n&&u==1);
b.enable(ZmOperation.DELETE,(!v&&g&&!t&&(f?O:true)&&(n?!p:true)));
if(b&&b instanceof ZmActionMenu){
b.getOp(ZmOperation.OPEN_FILE)&&b.getOp(ZmOperation.OPEN_FILE).setVisible(g&&!T&&h);
var r=!v&&O&&!h&&!n;
b.getOp(ZmOperation.CHECKIN)&&b.getOp(ZmOperation.CHECKIN).setVisible(r);
b.enable(ZmOperation.CHECKIN,r&&u==1);
var q=!v&&!y&&!S;
b.getOp(ZmOperation.CHECKOUT)&&b.getOp(ZmOperation.CHECKOUT).setVisible(!n&&!f);
b.enable(ZmOperation.CHECKOUT,q);
var m=c&&!S;
b.getOp(ZmOperation.DISCARD_CHECKOUT)&&b.getOp(ZmOperation.DISCARD_CHECKOUT).setVisible(m);
b.enable(ZmOperation.DISCARD_CHECKOUT,m&&(j||c||!k));
var F=(!v&&u==1&&n);
var x=B&&B.isRevision&&(B.parent.version==B.version);
b.getOp(ZmOperation.RESTORE_VERSION)&&b.getOp(ZmOperation.RESTORE_VERSION).setVisible(n);
b.enable(ZmOperation.RESTORE_VERSION,F&&!x)
}
var o=!(s||v);
if(appCtxt.get(ZmSetting.DOCS_ENABLED)){
b.enable(ZmOperation.NEW_DOC,o)
}
if(appCtxt.get(ZmSetting.SPREADSHEET_ENABLED)){
b.enable(ZmOperation.NEW_SPREADSHEET,o)
}
if(appCtxt.get(ZmSetting.SLIDES_ENABLED)){
b.enable(ZmOperation.NEW_PRESENTATION,o);
b.enable(ZmOperation.CREATE_SLIDE_SHOW,o&&g)
}};
ZmBriefcaseController.prototype._getTagMenuMsg=function(){
return ZmMsg.tagFile
};
ZmBriefcaseController.prototype._doDelete=function(e){
if(!e){
e=this._listView[this._currentView].getSelection()
}
var i=(e instanceof Array)?e[0]:e;
if(!i){
return
}
var a=(e.length>1)?(i.isRevision?ZmMsg.confirmPermanentDeleteItemList:ZmMsg.confirmDeleteItemList):null;
if(!a){
var o=new AjxMessageFormat((this._folderId==String(ZmOrganizer.ID_TRASH)||i.isRevision)?ZmMsg.confirmPermanentDeleteItem:ZmMsg.confirmDeleteItem);
a=o.format(AjxStringUtil.htmlEncode(i.name))
}
var t=appCtxt.getConfirmationDialog();
t.popup(a,new AjxCallback(this,this._doDelete2,[e]))
};
ZmBriefcaseController.prototype._doDelete2=function(t){
var s=(t instanceof Array)?t[0]:t;
if(s.isRevision){
var e=this._parentView[this._currentView];
e.deleteVersions(t)
}else{
if(s.isFolder){
var a=new ZmBatchCommand(true),n;
for(var o=0;
o<t.length;
o++){
n=t[o].folder;
if(n.isHardDelete()){
a.add(new AjxCallback(n,n._delete,[a]))
}else{
var r=appCtxt.getById(ZmFolder.ID_TRASH);
a.add(new AjxCallback(n,n.move,[r,false,null,a]))
}}
a.run()
}else{
ZmListController.prototype._doDelete.call(this,t)
}}};
ZmBriefcaseController.prototype._getViewType=function(){
return this._currentView
};
ZmBriefcaseController.prototype._defaultView=function(){
return ZmId.VIEW_BRIEFCASE_DETAIL
};
ZmBriefcaseController.prototype._createNewView=function(view){
var viewCtor=eval(ZmBriefcaseController._VIEWS[view]);
this._parentView[view]=new viewCtor(this._container,this,this._dropTgt);
var listView=this._parentView[view].getListView();
listView.setDragSource(this._dragSrc);
return listView
};
ZmBriefcaseController.prototype._setViewContents=function(e){
var t=this._parentView[e];
t.set(this._list,this._switchView);
this._switchView=false
};
ZmBriefcaseController.prototype._getDefaultFocusItem=function(){
return this._listView[this._currentView]
};
ZmBriefcaseController.prototype._getSubfolders=function(t){
var t=t||this._currentSearch.folderId;
var s=t&&appCtxt.getById(t);
var n=[];
if(s){
var o=s.children;
for(var a=0,e=o.size();
a<e;
a++){
s=o.get(a);
if(s.type==ZmOrganizer.BRIEFCASE){
n.push(new ZmBriefcaseFolderItem(o.get(a)))
}}}
return n
};
ZmBriefcaseController.prototype.show=function(e){
this._folderId=e&&e.search&&e.search.folderId;
this._list=e.getResults(ZmItem.BRIEFCASE_ITEM);
this._list.setHasMore(e.getAttribute("more"));
ZmListController.prototype.show.call(this,e,this._currentView);
this._setup(this._currentView);
var a=this._listView[this._currentView];
a.offset=0;
a._folderId=this._folderId;
var t={};
t[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
t[ZmAppViewMgr.C_APP_CONTENT]=this._parentView[this._currentView];
this._setView({
view:this._currentView,elements:t,isAppView:true}
);
this._resetNavToolBarButtons(this._currentView)
};
ZmBriefcaseController.prototype.switchView=function(e,a){
var i=(a||e!=this._currentView);
if(i){
var o=this._listView[this._currentView];
if(o){
o.cleanup()
}
this._switchView=true;
this._currentView=e;
this._setup(e)
}
this._resetOperations(this._toolbar[e],0);
if(i){
var t={};
t[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[e];
t[ZmAppViewMgr.C_APP_CONTENT]=this._parentView[e];
this._setView({
view:e,elements:t,isAppView:true}
);
this._resetNavToolBarButtons(e)
}
Dwt.setTitle(this.getCurrentView().getTitle())
};
ZmBriefcaseController.prototype._preHideCallback=function(){
var e=this._listView[this._currentView];
if(e){
e.cleanup()
}
return ZmController.prototype._preHideCallback.call(this)
};
ZmBriefcaseController.prototype.getItemById=function(e){
return(this._idMap[e]?this._idMap[e].item:null)
};
ZmBriefcaseController.prototype.__popupUploadDialog=function(i,o){
var e=this._folderId;
if(!e||e==ZmOrganizer.ID_TRASH){
e=ZmOrganizer.ID_BRIEFCASE
}
if(this.chkFolderPermission(e)){
var a=appCtxt.getById(e);
var t=appCtxt.getUploadDialog();
t.setConflictAction(ZmUploadDialog.ACTION_KEEP_MINE);
t.popup(a,o,i,null,false,true,true)
}};
ZmBriefcaseController.prototype.chkFolderPermission=function(e){
var a=appCtxt.getById(e);
if(a.isRemote()&&a.isReadOnly()){
var t=appCtxt.getMsgDialog();
t.setMessage(ZmMsg.errorPermissionCreate,DwtMessageDialog.WARNING_STYLE);
t.popup();
return false
}
return true
};
ZmBriefcaseController.prototype._listSelectionListener=function(a){
Dwt.setLoadingTime("ZmBriefcaseItem",new Date());
ZmListController.prototype._listSelectionListener.call(this,a);
if(a.detail==DwtListView.ITEM_DBL_CLICKED){
var t=a.item;
if(t.isFolder){
this._app.search({
folderId:t.id,noClear:true}
);
return
}
var e=t.getRestUrl(false,false,true);
e=AjxStringUtil.fixCrossDomainReference(e);
if(t.isWebDoc()){
e=ZmBriefcaseApp.addEditorParam(e);
e+=(e.match(/\?/)?"&":"?")+"localeId="+AjxEnv.DEFAULT_LOCALE
}
if(e){
if(t.isDownloadable()&&!this._alwaysOpenInNewWindow(t)){
this._downloadFile(e)
}else{
window.open(e,this._getWindowName(t.name),t.isWebDoc()?"":ZmBriefcaseApp.getDocWindowFeatures())
}}}};
ZmBriefcaseController.prototype._alwaysOpenInNewWindow=function(e){
return(e.contentType==ZmMimeTable.APP_ADOBE_PDF&&this.hasPDFReader())||(e.contentType==ZmMimeTable.TEXT_XML)||(e.contentType==ZmMimeTable.APP_XML)
};
ZmBriefcaseController.prototype.hasPDFReader=function(){
if(AjxUtil.isUndefined(this._hasPDFReader)){
this._hasPDFReader=AjxPluginDetector.detectPDFReader()
}
return this._hasPDFReader
};
ZmBriefcaseController.prototype._listActionListener=function(a){
var t=a.item;
if(t&&t.isFolder){
a.detail=DwtTree.ITEM_ACTIONED;
var e=appCtxt.getOverviewController();
var o=e.getTreeController(ZmOrganizer.BRIEFCASE);
t.setData(ZmTreeView.KEY_TYPE,ZmOrganizer.BRIEFCASE);
t.setData(Dwt.KEY_OBJECT,t.folder);
t.setData(ZmTreeView.KEY_ID,this._app.getOverviewId());
t.setData(Dwt.KEY_ID,t.id);
o._treeViewListener(a);
return
}
if(t&&appCtxt.isOffline&&appCtxt.getCurrentSearch()){
appCtxt.accountList.setActiveAccount(t.getAccount())
}
ZmListController.prototype._listActionListener.call(this,a);
var i=this.getActionMenu();
i.popup(0,a.docX,a.docY);
if(a.ersatz){
i.setSelectedItem(0)
}};
ZmBriefcaseController.prototype._restoreVerListener=function(){
var e=this._parentView[this._currentView];
e._restoreVerListener()
};
ZmBriefcaseController.prototype._checkoutListener=function(){
var e=this._getSelectedItems();
if(e.length>1){
for(var t=0;
t<e.length;
t++){
var a=e[t];
if(a&&a instanceof ZmBriefcaseItem){
this.checkout(a)
}}}else{
var a=e[0];
if(a&&a instanceof ZmBriefcaseItem){
this.checkout(a,a.isWebDoc()?null:new AjxCallback(this,this._postCheckout,a))
}}};
ZmBriefcaseController.prototype._postCheckout=function(e){
if(AjxEnv.isSafari){
setTimeout(AjxCallback.simpleClosure(this.downloadFile,this,e),100)
}else{
this.downloadFile(e)
}};
ZmBriefcaseController.prototype._handleCheckin=function(){
var e=this._getSelectedItem();
if(e&&e instanceof ZmBriefcaseItem){
var t=this._getCheckinDlg();
t.popup(e,new AjxCallback(this,this._doneCheckin,e))
}};
ZmBriefcaseController.prototype._doneCheckin=function(t,e){
t.version=e.version;
t.name=e.name;
this.unlockItem(t,new AjxCallback(this,this.refreshItem,t))
};
ZmBriefcaseController.prototype._handleDiscardCheckout=function(){
var e=this._getSelectedItems();
for(var t=0;
t<e.length;
t++){
var a=e[t];
if(a&&a instanceof ZmBriefcaseItem){
this.unlockItem(a)
}}};
ZmBriefcaseController.prototype.refreshItem=function(t){
var e=this._parentView[this._currentView];
e.refreshItem(t)
};
ZmBriefcaseController.prototype.checkout=function(e,t){
this.lockItem(e,t)
};
ZmBriefcaseController.prototype.checkin=function(e,t){
this.unlockItem(e,t)
};
ZmBriefcaseController.prototype.unlockItem=function(e,t){
e.unlock(t,new AjxCallback(this,this._handleErrorResponse,e))
};
ZmBriefcaseController.prototype.lockItem=function(e,t){
e.lock(t,new AjxCallback(this,this._handleErrorResponse,e))
};
ZmBriefcaseController.prototype._handleErrorResponse=function(a,e){
if(!(e&&e.code)){
return
}
var i;
switch(e.code){
case ZmCsfeException.CANNOT_UNLOCK:i=ZmMsg.unlockSufficientPermission;
break;
case ZmCsfeException.CANNOT_LOCK:i=ZmMsg.lockSuffientPermissions;
break
}
if(i){
var t=appCtxt.getMsgDialog();
t.setMessage(i,DwtMessageDialog.WARNING_STYLE);
t.popup()
}
return i
};
ZmBriefcaseController.prototype._getSelectedItem=function(){
var e=this._listView[this._currentView];
var t=e.getSelection();
return(t&&t.length>0)?t[0]:null
};
ZmBriefcaseController.prototype._getSelectedItems=function(){
var e=this._listView[this._currentView];
return e.getSelection()
};
ZmBriefcaseController.prototype._getCheckinDlg=function(){
if(!this._checkinDlg){
this._checkinDlg=new ZmCheckinDialog(appCtxt.getShell())
}
return this._checkinDlg
};
ZmBriefcaseController.prototype._getActionMenuOps=function(){
var e=[ZmOperation.OPEN_FILE,ZmOperation.SAVE_FILE,ZmOperation.EDIT_FILE,ZmOperation.SEND_FILE,ZmOperation.SEND_FILE_AS_ATT];
if(appCtxt.get(ZmSetting.SLIDES_ENABLED)){
e.push(ZmOperation.CREATE_SLIDE_SHOW)
}
e.push(ZmOperation.SEP);
e.push(ZmOperation.CHECKOUT,ZmOperation.CHECKIN,ZmOperation.DISCARD_CHECKOUT,ZmOperation.RESTORE_VERSION);
e.push(ZmOperation.SEP);
e=e.concat(this._standardActionMenuOps());
e.push(ZmOperation.RENAME_FILE);
return e
};
ZmBriefcaseController.prototype._renameFileListener=function(){
var e=this._listView[this._currentView];
var t=e.getSelection();
if(!t){
return
}
e.renameFile(t[0])
};
ZmBriefcaseController.prototype._newWinListener=function(){
var e=this._listView[this._currentView];
var t=e.getSelection();
if(!t){
return
}
t=AjxUtil.toArray(t);
var a=t[0];
if(a){
this.openFile(a)
}};
ZmBriefcaseController.prototype._editFileListener=function(){
var e=this._listView[this._currentView];
var t=e.getSelection();
if(!t){
return
}
t=AjxUtil.toArray(t);
var a=t[0];
if(a){
this.editFile(a)
}};
ZmBriefcaseController.prototype.editFile=function(e){
e=AjxUtil.toArray(e);
for(var a=0;
a<e.length;
a++){
var o=e[a];
var t=o.getRestUrl(false,false,true);
if(t){
if(o.isWebDoc()){
t=AjxStringUtil.fixCrossDomainReference(t);
t=ZmBriefcaseApp.addEditorParam(t);
t+=(t.match(/\?/)?"&":"?")+"action=edit&localeId="+AjxEnv.DEFAULT_LOCALE;
window.open(t,this._getWindowName(o.name),"")
}}}};
ZmBriefcaseController.prototype._getWindowName=function(e){
if(!e){
return ZmMsg.briefcase
}
return AjxEnv.isIE?e.replace(/[^\w]/g,""):e
};
ZmBriefcaseController.prototype._openFileListener=function(){
var e=this._listView[this._currentView];
var t=e.getSelection();
if(!t){
return
}
this.openFile(t)
};
ZmBriefcaseController.prototype.openFile=function(t){
t=AjxUtil.toArray(t);
for(var o=0;
o<t.length;
o++){
var n=t[o];
var a=n.getRestUrl(false,false,true);
if(!a){
continue
}
a=AjxStringUtil.fixCrossDomainReference(a);
if(n.isWebDoc()){
a=ZmBriefcaseApp.addEditorParam(a);
a+=(a.match(/\?/)?"&":"?")+"localeId="+AjxEnv.DEFAULT_LOCALE
}else{
if(!ZmMimeTable.isRenderable(n.contentType)&&!ZmMimeTable.isMultiMedia(n.contentType)&&!appCtxt.isOffline){
a+=(a.match(/\?/)?"&":"?")+"view=html"
}}
this._fileInfo={
restUrl:a,name:this._getWindowName(n.name),features:n.isWebDoc()?"":ZmBriefcaseApp.getDocWindowFeatures()};
var e=new AjxTimedAction(this,this._openChild);
AjxTimedAction.scheduleAction(e,100)
}};
ZmBriefcaseController.prototype._openChild=function(){
if(this._fileInfo){
var e=window.open(this._fileInfo.restUrl,this._fileInfo.name,this._fileInfo.features);
e.focus()
}
this._fileInfo=null
};
ZmBriefcaseController.prototype._saveFileListener=function(){
var e=this._listView[this._currentView];
var t=e.getSelection();
if(!t){
return
}
t=AjxUtil.toArray(t);
this.downloadFile(t)
};
ZmBriefcaseController.prototype.downloadFile=function(t){
var a,s,n=t.length;
if(n>1){
var h=[];
var e=appCtxt.getById(t[0].folderId);
for(var o=0;
o<n;
o++){
s=t[o];
if(!s.isFolder){
var r;
if(appCtxt.isOffline&&e.isShared()){
r=s.id
}else{
r=s.getNormalizedItemId()
}
h.push((s.isRevision?s.parent.id:r)+"."+s.version)
}}
a=[((e.isShared()&&!appCtxt.isOffline)?e.getOwnerRestUrl():e.getRestUrl()),"?fmt=zip&list=",h.join(",")].join("")
}else{
s=AjxUtil.isArray(t)?t[0]:t;
a=s.getRestUrl();
a+="?disp=a"+(s.version?"&ver="+s.version:"")
}
if(!a){
return false
}
a=AjxStringUtil.fixCrossDomainReference(a);
if(a){
this._downloadFile(a)
}};
ZmBriefcaseController.prototype._downloadFile=function(e){
if(e){
ZmZimbraMail.unloadHackCallback();
location.href=e
}};
ZmBriefcaseController.prototype._viewAsHtmlListener=function(){
var e=this._listView[this._currentView];
var t=e.getSelection();
if(!t){
return
}
t=AjxUtil.toArray(t);
for(var o=0;
o<t.length;
o++){
var n=t[o];
var a=n.getRestUrl();
if(n&&a){
this.viewAsHtml(a)
}}};
ZmBriefcaseController.prototype.viewAsHtml=function(e){
if(e.match(/\?/)){
e+="&view=html"
}else{
e+="?view=html"
}
window.open(e)
};
ZmBriefcaseController.prototype._uploadFileListener=function(){
this.__popupUploadDialog(ZmMsg.uploadFileToBriefcase,new AjxCallback(this,this._handlePostUpload))
};
ZmBriefcaseController.prototype._handlePostUpload=function(a,t,e){
var i=ZmMsg.successfullyUploaded;
if(e.length>1){
i=AjxMessageFormat.format(ZmMsg.successfullyUploadedFiles,e.length)
}
appCtxt.setStatusMsg(i,ZmStatusView.LEVEL_INFO)
};
ZmBriefcaseController.prototype._sendFileListener=function(t){
var f=this._listView[this._currentView];
var d=f.getSelection();
d=AjxUtil.toArray(d);
var u=[];
var m=[];
var h=this._app._inNewWindow(t);
var p,s;
var r=false;
for(var n=0;
n<d.length;
n++){
var y=d[n];
p=appCtxt.getById(y.folderId);
var e;
if(p.restUrl){
e=[p.restUrl,"/",AjxStringUtil.urlComponentEncode(y.name)].join("")
}else{
e=y.getRestUrl()
}
if(appCtxt.isOffline){
var a=appCtxt.get(ZmSetting.OFFLINE_REMOTE_SERVER_URI);
e=a+e.substring((e.indexOf("/",7)))
}
m.push(e);
u.push(y.name);
if(r){
continue
}
s=p&&p.shares;
if(s){
for(var o=0;
o<s.length;
o++){
r=r||s[o].grantee.type==ZmShare.TYPE_PUBLIC
}}}
if(!s||!r){
var c=[u,m,h];
var g=new AjxCallback(this,this._sendFileListener2,c);
var l=appCtxt.getConfirmationDialog();
l.popup(ZmMsg.errorPermissionRequired,g)
}else{
this._sendFileListener2(u,m)
}};
ZmBriefcaseController.prototype._sendFileListener2=function(r,h,n){
var i=ZmOperation.NEW_MESSAGE;
var e=new ZmMailMsg();
var o=null;
var t=new AjxListFormat().format(r);
var s=appCtxt.get(ZmSetting.COMPOSE_AS_FORMAT)==ZmSetting.COMPOSE_HTML;
var a=h.join(s?"<br>":"\n");
AjxDispatcher.run("Compose",{
action:i,inNewWindow:n,msg:e,toOverride:o,subjOverride:t,extraBodyText:a}
)
};
ZmBriefcaseController.prototype._sendFileAsAttachmentListener=function(a){
var e=this._listView[this._currentView];
var t=e.getSelection();
this.sendFilesAsAttachment(t)
};
ZmBriefcaseController.prototype.sendFilesAsAttachment=function(h,c){
h=AjxUtil.toArray(h);
var e=[];
for(var n=0;
n<h.length;
n++){
var d=h[n];
e.push({
id:(d.isRevision?d.parent.id:d.id),ver:(d.isRevision?d.version:null),ct:d.contentType,s:d.size}
)
}
if(e.length==0){
return
}
var o=ZmOperation.NEW_MESSAGE;
var t=new ZmMailMsg();
var r;
var a=AjxDispatcher.run("GetComposeController");
a._setView({
action:o,msg:t,toOverride:r,inNewWindow:false}
);
var s=ZmComposeController.DRAFT_TYPE_AUTO;
var l=new AjxCallback(a,a._handleResponseSaveDraftListener,[s,c]);
a.saveDraft(s,null,e,l)
};
ZmBriefcaseController.prototype._resetOpForCurrentView=function(e){
this._resetOperations(this._toolbar[this._currentView],e||0)
};
ZmBriefcaseController.prototype._initSendMenu=function(e){
var a=this._toolbar[e].getButton(ZmOperation.SEND_FILE_MENU);
if(!a){
return
}
var r=new ZmPopupMenu(a);
a.setMenu(r);
var o=[ZmOperation.SEND_FILE,ZmOperation.SEND_FILE_AS_ATT];
for(var n=0;
n<o.length;
n++){
var h=o[n];
var s={
image:ZmOperation.getProp(h,"image"),text:ZmMsg[ZmOperation.getProp(h,"textKey")]};
var t=r.createMenuItem(h,s);
t.setData(ZmOperation.MENUITEM_ID,h);
t.addSelectionListener(this._listeners[h])
}
return r
};
ZmBriefcaseController.prototype._setupViewMenu=function(e,i){
var t,a;
if(i){
t=this._toolbar[e].getButton(ZmOperation.VIEW_MENU);
var a=t.getMenu();
if(!a){
a=new ZmPopupMenu(t);
t.setMenu(a);
this._setupPreviewPaneMenu(a)
}}
if(!a){
t=this._toolbar[e].getButton(ZmOperation.VIEW_MENU);
a=t&&t.getMenu()
}
this._resetPreviewPaneMenu(a,e)
};
ZmBriefcaseController.prototype._setupPreviewPaneMenu=function(s){
if(s.getItemCount()>0){
new DwtMenuItem({
parent:s,style:DwtMenuItem.SEPARATOR_STYLE,id:"PREVIEW_SEPERATOR"}
)
}
var n={
text:ZmMsg.readingPaneAtBottom,style:DwtMenuItem.RADIO_STYLE,radioGroupId:"RP"};
var o=ZmDoublePaneController.RP_IDS;
var e=appCtxt.get(ZmSetting.READING_PANE_LOCATION_BRIEFCASE);
for(var a=0;
a<o.length;
a++){
var r=o[a];
if(!s._menuItems[r]){
n.text=ZmBriefcaseController.PREVIEW_PANE_TEXT[r];
n.image=ZmBriefcaseController.PREVIEW_PANE_ICON[r];
var t=s.createMenuItem(r,n);
t.setData(ZmOperation.MENUITEM_ID,r);
t.addSelectionListener(new AjxListener(this,this._previewPaneListener,r));
if(r==e){
t.setChecked(true,true)
}}}};
ZmBriefcaseController.prototype._resetPreviewPaneMenu=function(n,e){
e=e||this._currentView;
var t=(e==ZmId.VIEW_BRIEFCASE_DETAIL);
var o=ZmDoublePaneController.RP_IDS;
for(var a=0;
a<o.length;
a++){
var s=o[a];
if(n._menuItems[s]){
n._menuItems[s].setEnabled(t)
}}};
ZmBriefcaseController.prototype.isReadingPaneOn=function(){
return(this._getReadingPanePref()!=ZmSetting.RP_OFF)
};
ZmBriefcaseController.prototype.isReadingPaneOnRight=function(){
return(this._getReadingPanePref()==ZmSetting.RP_RIGHT)
};
ZmBriefcaseController.prototype._getReadingPanePref=function(){
return appCtxt.get(ZmSetting.READING_PANE_LOCATION_BRIEFCASE)
};
ZmBriefcaseController.prototype._setReadingPanePref=function(e){
appCtxt.set(ZmSetting.READING_PANE_LOCATION_BRIEFCASE,e)
};
ZmBriefcaseController.prototype._previewPaneListener=function(t){
var e=appCtxt.get(ZmSetting.READING_PANE_LOCATION_BRIEFCASE);
appCtxt.set(ZmSetting.READING_PANE_LOCATION_BRIEFCASE,t);
var a=this._parentView[this._currentView];
a.resetPreviewPane(t,e)
};
ZmBriefcaseController.CONVERTABLE={
doc:/\.doc$/i,xls:/\.xls$/i,pdf:/\.pdf$/i,ppt:/\.ppt$/i,zip:/\.zip$/i,txt:/\.txt$/i};
ZmBriefcaseController.prototype.isConvertable=function(i){
var e=i.name;
for(var t in ZmBriefcaseController.CONVERTABLE){
var a=ZmBriefcaseController.CONVERTABLE[t];
if(e.match(a)){
return true
}}
return false
};
ZmBriefcaseController.prototype.addChangeListeners=function(){
var e=this._list.getArray();
if(e){
var t=((e instanceof Array)&&e.length>0)?e[0].list:e.list;
if(t){
t.addChangeListener(this._listChangeListener)
}}};
ZmBriefcaseController.prototype._fileListChangeListener=function(t){
if(t.handled){
return
}
var e=t._details;
if(!e){
return
}
this._list._notify(t.event,{
items:e.items}
)
};
ZmBriefcaseController.prototype.getParentView=function(){
return this._parentView[this._currentView]
};
ZmBriefcaseController.prototype._addListListeners=function(e){
e.addActionListener(new AjxListener(this,this._listActionListener))
};
ZmBriefcaseController.prototype.isMultiColView=function(){
return(this._currentView==ZmId.VIEW_BRIEFCASE_COLUMN)
};
ZmBriefcaseController.prototype.mapSupported=function(e){
return(e=="list"&&(this._currentView!=ZmId.VIEW_BRIEFCASE))
};
ZmBriefcaseController.prototype.getItemTooltip=function(o,e){
if(o.isFolder){
return null
}
var n=[{
name:ZmMsg.briefcasePropName,value:o.name}
];
if(o.size){
n.push({
name:ZmMsg.briefcasePropSize,value:AjxUtil.formatSize(o.size)}
)
}
if(o.modifyDate){
var i=AjxDateFormat.getDateTimeInstance(AjxDateFormat.FULL,AjxDateFormat.MEDIUM);
var t=i.format(o.modifyDate);
n.push({
name:ZmMsg.briefcasePropModified,value:t}
)
}
var a={
fileProperties:n,tagTooltip:e._getTagToolTip(o)};
return AjxTemplate.expand("briefcase.Briefcase#Tooltip",a)
};
ZmBriefcaseController.prototype._getDateInLocaleFormat=function(e){
var t=AjxDateFormat.getDateTimeInstance(AjxDateFormat.FULL,AjxDateFormat.MEDIUM);
return t.format(e)
};
ZmBriefcaseController.prototype._resetToolbarOperations=function(){
if(this._listView[this._currentView]!=null){
this._resetOperations(this._toolbar[this._currentView],this._listView[this._currentView].getSelectionCount())
}};
ZmBriefcaseController.prototype._createSlideShow=function(){
var s=[];
var e=this._listView[this._currentView];
var t=e.getSelection();
if(!t){
return
}
t=AjxUtil.toArray(t);
for(var o in t){
var n=t[o];
var a=n.getRestUrl();
if(n&&!n.isFolder&&a!=null){
s.push(a)
}}
window.importSlides=true;
window.importSlidesQueue=s;
this._app.handleOp(ZmOperation.NEW_PRESENTATION)
};
ZmBriefcaseController.prototype._getItemCount=function(){
var h=this._listView[this._currentView];
var r=h&&h._list;
if(!r){
return null
}
var t=r.getArray();
var o=0;
for(var n=0,e=t.length;
n<e;
n++){
var s=t[n];
if(s&&s.type==ZmItem.BRIEFCASE_ITEM&&!s.isFolder){
o++
}}
return o
};
ZmBriefcaseController.prototype.handleCreateNotify=function(e){
if(this.isMultiColView()){
var t=(this._folderId==String(ZmOrganizer.ID_TRASH));
if(!t){
this.getParentView().handleNotifyCreate(e)
}}else{
var i=this.getList();
if(i){
var a=ZmBriefcaseItem.createFromDom(e,{
list:i}
);
if(i.search&&i.search.matches&&i.search.matches(a)){
i.notifyCreate(e)
}}}};
ZmBriefcaseController.prototype.handleModifyNotify=function(t){
var e=this._listView[this._currentView];
if(e){
e.deselectAll()
}
this._resetToolbarOperations()
};
ZmBriefcaseController.prototype._actionErrorCallback=function(e){
var t=false;
if(e.code==ZmCsfeException.MAIL_ALREADY_EXISTS){
t=true;
var a=appCtxt.getMsgDialog();
a.setMessage(ZmMsg.errorFileAlreadyExistsResolution,DwtMessageDialog.WARNING_STYLE);
a.popup()
}
return t
};
ZmBriefcaseController.prototype.createFromAttachment=function(i,a,t){
var o=this._saveAttDialog=appCtxt.getChooseFolderDialog();
var e=new AjxCallback(this,this._chooserCallback,[i,a,t]);
ZmController.showDialog(o,e,this._getCopyParams(o,i,a))
};
ZmBriefcaseController.prototype._getCopyParams=function(i,t,e){
var a={
data:{
msgId:t,partId:e}
,treeIds:[ZmOrganizer.BRIEFCASE],overviewId:i.getOverviewId(this._app._name),title:ZmMsg.addToBriefcaseTitle,description:ZmMsg.targetFolder,appName:ZmApp.BRIEFCASE};
a.omit={};
a.omit[ZmFolder.ID_DRAFTS]=true;
a.omit[ZmFolder.ID_TRASH]=true;
return a
};
ZmBriefcaseController.prototype._chooserCallback=function(i,a,e,t){
var o=new AjxCallback(this,this._handleDuplicateCheck,[i,a,e,t]);
this._app.search({
query:t.createQuery(),noRender:true,callback:o,accountName:(t&&t.account&&t.account.name)||undefined}
)
};
ZmBriefcaseController.prototype._handleDuplicateCheck=function(o,u,e,a,r){
var n=appCtxt.getById(o);
var f=a;
if(f.isReadOnly(a.id)){
ZmOrganizer._showErrorMsg(ZmMsg.errorPermission);
return
}
if(o.indexOf(":")<0){
o=n.getAccount().id+":"+n.id
}
var l=r.getResponse();
var d=l&&l.getResults(ZmItem.BRIEFCASE_ITEM);
if(d instanceof ZmList){
d=d.getArray()
}
var h=false;
for(var s=0,c=d.length;
s<c;
s++){
if(d[s].name==e){
h=d[s];
break
}}
var t=(!a.account||a.account==appCtxt.getActiveAccount()||(a.id.indexOf(":")!=-1))?a.id:[a.account.id,a.id].join(":");
if(h){
var m=this._conflictDialog=this._getFileConflictDialog();
m.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._handleConflictDialog,[o,u,e,t,h]));
m.popup()
}else{
this._createFromAttachment(o,u,e,t)
}
if(this._saveAttDialog.isPoppedUp()){
this._saveAttDialog.popdown()
}};
ZmBriefcaseController.prototype._handleConflictDialog=function(i,r,t,a,o){
var e={};
if(this._renameRadio.checked){
var h=this._renameField.value;
var n=this.checkInvalidFileName(h);
if(n){
var s=appCtxt.getMsgDialog();
s.setMessage(n,DwtMessageDialog.WARNING_STYLE);
s.popup();
return false
}
e.rename=h
}else{
e.id=o.id;
e.version=o.version
}
this._createFromAttachment(i,r,t,a,e)
};
ZmBriefcaseController.prototype.checkInvalidFileName=function(t){
var e;
t=t.replace(/^\s+/,"").replace(/\s+$/,"");
if(t==""){
e=ZmMsg.emptyDocName
}else{
if(!ZmOrganizer.VALID_NAME_RE.test(t)){
e=AjxMessageFormat.format(ZmMsg.errorInvalidName,AjxStringUtil.htmlEncode(t))
}else{
if(t.length>ZmOrganizer.MAX_NAME_LENGTH){
e=AjxMessageFormat.format(ZmMsg.nameTooLong,ZmOrganizer.MAX_NAME_LENGTH)
}}}
return e
};
ZmBriefcaseController.prototype._createFromAttachment=function(i,a,t,e,n){
n=n||{};
if(n.id||n.rename){
n.callback=new AjxCallback(this,this._handleSuccessCreateFromAttachment,[i,a,t,e])
}
if(n.rename){
n.errorCallback=new AjxCallback(this,this._handleErrorCreateFromAttachment,[i,a,t,e])
}
var o=new ZmBriefcaseItem();
o.createFromAttachment(i,a,t,e,n)
};
ZmBriefcaseController.prototype._handleSuccessCreateFromAttachment=function(o,i,a,e,t){
if(this._conflictDialog){
this._renameField.value="";
this._conflictDialog.popdown()
}};
ZmBriefcaseController.prototype._handleErrorCreateFromAttachment=function(n,o,t,e,a){
var i=false;
if(a.code==ZmCsfeException.MAIL_ALREADY_EXISTS){
i=true;
var s=appCtxt.getMsgDialog();
s.setMessage(AjxMessageFormat.format(ZmMsg.errorFileExistsWarning,t),DwtMessageDialog.WARNING_STYLE);
s.popup()
}
return i
};
ZmBriefcaseController.prototype._getFileConflictDialog=function(){
if(!this._nameConflictDialog){
var e=this._nameConflictDialog=new DwtDialog({
parent:appCtxt.getShell()}
);
var t=this._nameConflictId=Dwt.getNextId();
e.setContent(AjxTemplate.expand("briefcase.Briefcase#NameConflictDialog",{
id:t}
));
e.setTitle(ZmMsg.addToBriefcaseTitle);
this._renameRadio=document.getElementById(t+"_rename");
this._renameField=document.getElementById(t+"_newname")
}
return this._nameConflictDialog
};
ZmBriefcaseController.prototype.getKeyMapName=function(){
return"ZmBriefcaseController"
};
ZmBriefcaseController.prototype.handleKeyAction=function(e){
switch(e){
case ZmKeyMap.READING_PANE_BOTTOM:case ZmKeyMap.READING_PANE_RIGHT:case ZmKeyMap.READING_PANE_OFF:var t=ZmBriefcaseController.ACTION_CODE_TO_MENU_ID[e];
this._previewPaneListener(t,true);
break;
default:return ZmListController.prototype.handleKeyAction.call(this,e)
}
return true
}
}
if(AjxPackage.define("zimbraMail.briefcase.controller.ZmBriefcaseTreeController")){
ZmBriefcaseTreeController=function(e){
ZmFolderTreeController.call(this,(e||ZmOrganizer.BRIEFCASE));
this._listeners[ZmOperation.NEW_BRIEFCASE]=new AjxListener(this,this._newListener);
this._listeners[ZmOperation.SHARE_BRIEFCASE]=new AjxListener(this,this._shareBriefcaseListener);
this._listeners[ZmOperation.BROWSE]=new AjxListener(this,function(){
appCtxt.getSearchController().fromBrowse("")
}
);
this._eventMgrs={};
this._app=appCtxt.getApp(ZmApp.BRIEFCASE)
};
ZmBriefcaseTreeController.prototype=new ZmFolderTreeController;
ZmBriefcaseTreeController.prototype.constructor=ZmBriefcaseTreeController;
ZmBriefcaseTreeController.prototype.toString=function(){
return"ZmBriefcaseTreeController"
};
ZmBriefcaseTreeController.prototype.resetOperations=function(o,a,f){
var y=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
if(o&&f!=y){
var d=appCtxt.getById(f);
if(!d){
return
}
var m=ZmOrganizer.normalizeId(f);
var p=(m==y);
var r=(m==ZmOrganizer.getSystemId(ZmOrganizer.ID_BRIEFCASE));
var e=(m==ZmOrganizer.getSystemId(ZmOrganizer.ID_NOTEBOOK));
var u=(!p&&d.parent.id==y);
var h=d.link;
var g=h||d.isRemote();
var s=(m==ZmFolder.ID_TRASH);
var n=ZmMsg.del;
o.getOp(ZmOperation.EMPTY_FOLDER).setVisible(s);
if(s){
var b=((d.numTotal>0)||(d.children&&(d.children.size()>0)));
o.enableAll(false);
o.enable(ZmOperation.EMPTY_FOLDER,b);
o.getOp(ZmOperation.EMPTY_FOLDER).setText(ZmMsg.emptyTrash)
}else{
o.enableAll(true);
var i=o.getMenuItem(ZmOperation.DELETE);
i.setEnabled(!e&&!r&&(!g||(h&&u)||ZmBriefcaseTreeController.__isAllowed(d.parent,ZmShare.PERM_DELETE)));
i=o.getMenuItem(ZmOperation.NEW_BRIEFCASE);
i.setText(ZmMsg.newFolder);
i.setImage("NewFolder");
i.setEnabled(!g||ZmBriefcaseTreeController.__isAllowed(d,ZmShare.PERM_CREATE_SUBDIR)||d.isAdmin()||ZmShare.getRoleFromPerm(d.perm)==ZmShare.ROLE_MANAGER);
if(appCtxt.get(ZmSetting.SHARING_ENABLED)){
r=(!p&&d.parent.id==y)||a==ZmOrganizer.BRIEFCASE;
i=o.getMenuItem(ZmOperation.SHARE_BRIEFCASE);
i.setText(ZmMsg.shareFolder);
i.setImage(r?"SharedMailFolder":"Section");
var t=(!g||d.isAdmin());
if(appCtxt.isOffline){
var c=d.getAccount();
t=!c.isMain&&c.isZimbraAccount
}
i.setEnabled(t)
}}
var l=o.getOp(ZmOperation.DELETE);
if(l){
l.setText(n)
}
this._enableRecoverDeleted(o,s);
this._resetButtonPerSetting(o,ZmOperation.SHARE_BRIEFCASE,appCtxt.get(ZmSetting.SHARING_ENABLED))
}};
ZmBriefcaseTreeController.prototype._getAllowedSubTypes=function(){
return ZmTreeController.prototype._getAllowedSubTypes.call(this)
};
ZmBriefcaseTreeController.prototype._getSearchTypes=function(e){
return[ZmItem.BRIEFCASE_ITEM]
};
ZmBriefcaseTreeController.__isAllowed=function(e,t){
var i=true;
if(e.link||e.isRemote()){
i=false;
var a=e.getMainShare();
if(a&&!a.isPermRestricted(t)){
i=a.isPermAllowed(t)
}}
return i
};
ZmBriefcaseTreeController.prototype._getHeaderActionMenuOps=function(){
var e=[ZmOperation.NEW_BRIEFCASE];
e.push(ZmOperation.EXPAND_ALL,ZmOperation.SEP,ZmOperation.BROWSE);
return e
};
ZmBriefcaseTreeController.prototype._getActionMenuOps=function(){
var e=[ZmOperation.NEW_BRIEFCASE];
if(appCtxt.get(ZmSetting.SHARING_ENABLED)){
e.push(ZmOperation.SHARE_BRIEFCASE)
}
e.push(ZmOperation.DELETE,ZmOperation.EDIT_PROPS,ZmOperation.EMPTY_FOLDER,ZmOperation.RECOVER_DELETED_ITEMS);
return e
};
ZmBriefcaseTreeController.prototype._getNewDialog=function(){
return appCtxt.getNewBriefcaseDialog()
};
ZmBriefcaseTreeController.prototype.getTreeStyle=function(){
return DwtTree.SINGLE_STYLE
};
ZmBriefcaseTreeController.prototype._itemClicked=function(e){
appCtxt.getApp(ZmApp.BRIEFCASE).search({
folderId:e.id,callback:new AjxCallback(this,this._handleSearchResponse,[e])}
)
};
ZmBriefcaseTreeController.prototype._shareBriefcaseListener=function(a){
if(!this._sharingPossible()){
return
}
this._pendingActionData=this._getActionedOrganizer(a);
var i=this._pendingActionData;
var t=null;
var e=appCtxt.getSharePropsDialog();
e.popup(ZmSharePropsDialog.NEW,i,t)
};
ZmBriefcaseTreeController.prototype._notifyListeners=function(n,o,e,i,a,t){
if(this._eventMgrs[n]&&this._eventMgrs[n].isListenerRegistered(o)){
if(a){
DwtUiEvent.copy(t,a)
}
t.items=e;
if(e.length==1){
t.item=e[0]
}
t.detail=i;
this._eventMgrs[n].notifyListeners(o,t)
}};
ZmBriefcaseTreeController.prototype._doCreate=function(e){
ZmTreeController.prototype._doCreate.apply(this,[e])
};
ZmBriefcaseTreeController.prototype._getItems=function(i){
var a=this.getTreeView(i);
if(a){
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
var t=a.getTreeItemById(e);
if(t){
return t.getItems()
}}
return[]
};
ZmBriefcaseTreeController.prototype.show=function(e){
e.include={};
e.include[ZmFolder.ID_TRASH]=true;
e.showUnread=false;
return ZmFolderTreeController.prototype.show.call(this,e)
};
ZmBriefcaseTreeController.prototype._handleSearchResponse=function(t,e){
if(t.nId==ZmFolder.ID_TRASH){
this._treeView[this._app.getOverviewId()].setSelected(ZmFolder.ID_TRASH,true)
}}
}};
