
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("IMCore")){
if(AjxPackage.define("ajax.dwt.events.DwtIdleTimer")){
DwtIdleTimer=function(t,e){
DwtIdleTimer._initEvents();
this.timeout=t;
this.handler=e;
this.idle=false;
this._onIdle=AjxCallback.simpleClosure(this.setIdle,this);
this._startTimer();
DwtIdleTimer.getHandlers().add(this)
};
DwtIdleTimer.idleHandlers=0;
DwtIdleTimer.prototype.toString=function(){
return"DwtIdleTimer"
};
DwtIdleTimer.prototype.kill=function(){
this._stopTimer();
this.idle=false;
DwtIdleTimer.getHandlers().remove(this)
};
DwtIdleTimer.prototype.resurrect=function(e){
this.idle=false;
DwtIdleTimer.getHandlers().add(this,null,true);
if(e!=null){
this.timeout=e
}
this._startTimer()
};
DwtIdleTimer.prototype.setIdle=function(){
if(!this.idle){
DwtIdleTimer.idleHandlers++;
this.idle=true;
this.handler.run(true)
}};
DwtIdleTimer.prototype.resume=function(){
if(this.idle){
this.idle=false;
this.handler.run(false);
DwtIdleTimer.idleHandlers--
}};
DwtIdleTimer.prototype._startTimer=function(){
this._stopTimer();
this._timer=setTimeout(this._onIdle,this.timeout)
};
DwtIdleTimer.prototype._stopTimer=function(){
if(this._timer){
clearTimeout(this._timer);
this._timer=null
}};
DwtIdleTimer._initEvents=function(){
if(!DwtIdleTimer._initialized){
if(!AjxEnv.isIE){
window.addEventListener("keydown",DwtIdleTimer.resetIdle,true);
window.addEventListener("mousemove",DwtIdleTimer.resetIdle,true);
window.addEventListener("mousedown",DwtIdleTimer.resetIdle,true);
window.addEventListener("focus",DwtIdleTimer.resetIdle,true)
}else{
document.body.attachEvent("onkeydown",DwtIdleTimer.resetIdle);
document.body.attachEvent("onkeyup",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmousedown",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmousemove",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmouseover",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmouseout",DwtIdleTimer.resetIdle);
window.attachEvent("onfocus",DwtIdleTimer.resetIdle)
}
DwtIdleTimer._initialized=true
}};
DwtIdleTimer.getHandlers=function(){
var e=DwtIdleTimer.HANDLERS;
if(!e){
e=DwtIdleTimer.HANDLERS=new AjxVector()
}
return e
};
DwtIdleTimer.resetIdle=function(){
var e=DwtIdleTimer.getHandlers();
e.foreach("_startTimer");
if(DwtIdleTimer.idleHandlers>0){
e.foreach("resume")
}}
}
if(AjxPackage.define("ajax.util.AjxPluginDetector")){
AjxPluginDetector=function(){};
AjxPluginDetector.canDetectPlugins=function(){
return AjxEnv.isIE||(navigator.plugins&&navigator.plugins.length>0)
};
AjxPluginDetector.detectFlash=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("ShockwaveFlash.ShockwaveFlash.1")
}else{
return AjxPluginDetector.detectPlugin("Shockwave","Flash")
}};
AjxPluginDetector.detectPDFReader=function(){
if(AjxEnv.isIE){
return(AjxPluginDetector.detectActiveXControl("PDF.PdfCtrl.5")||AjxPluginDetector.detectActiveXControl("AcroExch.Document"))
}else{
var e=false;
if(AjxEnv.isChrome){
e=AjxPluginDetector.detectPlugin("Chrome PDF Viewer")
}else{
if(AjxEnv.isFirefox){
e=AjxPluginDetector.detectPlugin("Firefox PDF Plugin for Mac OS X")
}}
if(!e){
e=AjxPluginDetector.detectPlugin("Adobe Acrobat")
}
return e
}};
AjxPluginDetector.detectDirector=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("SWCtl.SWCtl.1")
}else{
return AjxPluginDetector.detectPlugin("Shockwave","Director")
}};
AjxPluginDetector.detectQuickTime=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectQuickTimeActiveXControl()
}else{
return AjxPluginDetector.detectPlugin("QuickTime")
}};
AjxPluginDetector.getQuickTimeVersion=function(){
if(AjxEnv.isIE){
var n=new ActiveXObject("QuickTimeCheckObject.QuickTimeCheck.1");
if(n.IsQuickTimeAvailable(0)){
try{
var a=Number(n.QuickTimeVersion).toString(16);
var t=[];
for(var s=0;
s<3;
s++){
t[s]=Number(a.charAt(s))
}
return t
}
catch(r){}}
return null
}else{
var o=AjxPluginDetector.matchPluginName(/QuickTime Plug-in (\d+)\.?(\d+)?\.?(\d+)?/);
if(o){
var t=[];
for(var s=0;
s<3;
s++){
t[s]=Number(o[s+1]||0)
}
return t
}else{
return null
}}};
AjxPluginDetector.detectReal=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("rmocx.RealPlayer G2 Control")||AjxPluginDetector.detectActiveXControl("RealPlayer.RealPlayer(tm) ActiveX Control (32-bit)")||AjxPluginDetector.detectActiveXControl("RealVideo.RealVideo(tm) ActiveX Control (32-bit)")
}else{
return AjxPluginDetector.detectPlugin("RealPlayer")
}};
AjxPluginDetector.detectWindowsMedia=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("MediaPlayer.MediaPlayer.1")
}else{
return AjxPluginDetector.detectPlugin("Windows Media")
}};
AjxPluginDetector.detectPlugin=function(){
var o=AjxPluginDetector.detectPlugin.arguments;
var i=navigator.plugins;
var t=i.length;
for(var a=0;
a<t;
a++){
var n=0;
for(var e=0;
e<o.length;
e++){
if(i[a]){
if((i[a].name.indexOf(o[e])>=0)){
n++
}else{
if(i[a].description.indexOf(o[e])>=0){
n++
}}}}
if(n==o.length){
return true
}else{
if(n){}}}
return false
};
AjxPluginDetector.matchPluginName=function(t){
var o=navigator.plugins;
var a=o.length;
for(var i=0;
i<a;
i++){
var e=o[i].name.match(t);
if(e){
return e
}}
return null
};
AjxPluginDetector.detectActiveXControl=function(t){
try{
new ActiveXObject(t);
return true
}
catch(a){
return false
}};
AjxPluginDetector.detectQuickTimeActiveXControl=function(a){
try{
var t=new ActiveXObject("QuickTimeCheckObject.QuickTimeCheck.1");
return t.IsQuickTimeAvailable(0)
}
catch(i){
return false
}};
AjxPluginDetector._argumentsToString=function(e){
var o=[];
for(var t=0,a=e.length;
t<a;
t++){
o[t]=e[t]
}
return o.join(",")
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmImService")){
ZmImService=function(e){
if(arguments.length==0){
return
}
this._roster=e
};
ZmImService.prototype.isLoggedIn=function(){
alert("Not implemented")
};
ZmImService.prototype.getMyAddress=function(){
alert("Not implemented")
};
ZmImService.prototype.makeServerAddress=function(t,e){
alert("Not implemented")
};
ZmImService.prototype.getGateways=function(t,e){
alert("Not implemented")
};
ZmImService.prototype.reconnectGateway=function(e){
alert("Not implemented")
};
ZmImService.prototype.unregisterGateway=function(e,t){
alert("Not implemented")
};
ZmImService.prototype.registerGateway=function(e,i,a,t){
alert("Not implemented")
};
ZmImService.prototype.getRoster=function(t,e){
alert("Not implemented")
};
ZmImService.prototype.initializePresence=function(e){
alert("Not implemented")
};
ZmImService.prototype.setPresence=function(e,t,a,i){
alert("Not implemented")
};
ZmImService.prototype.setIdle=function(t,e){
alert("Not implemented")
};
ZmImService.prototype.createRosterItem=function(i,t,e,a){
alert("Not implemented")
};
ZmImService.prototype.deleteRosterItem=function(t,e){
alert("Not implemented")
};
ZmImService.prototype.sendSubscribeAuthorization=function(e,t,a){};
ZmImService.prototype.sendMessage=function(e,o,t,a,i){
alert("Not implemented")
};
ZmImService.prototype.closeChat=function(e,t){
alert("Not implemented")
};
ZmImService.prototype.getConferenceServices=function(t,e){
alert("Not implemented")
};
ZmImService.prototype.getConferenceRooms=function(e,a,t){
alert("Not implemented")
};
ZmImService.prototype.createConferenceRoom=function(e,t,i,a){
alert("Not implemented")
};
ZmImService.prototype.configureConferenceRoom=function(t,e,i,a){
alert("Not implemented")
};
ZmImService.prototype.joinConferenceRoom=function(t,e,i,a){
alert("Not implemented")
};
ZmImService.prototype.handleNotification=function(e){
alert("Not implemented")
};
ZmImService.prototype.startIgnoreNotify=function(){
this.__avoidNotifyTimeout=new Date().getTime()
};
ZmImService.prototype.getShowNotify=function(){
return !this.__avoidNotifyTimeout||(new Date().getTime()-this.__avoidNotifyTimeout>ZmRoster.NOTIFICATION_FOO_TIMEOUT)
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmZimbraImService")){
ZmZimbraImService=function(e){
ZmImService.call(this,e);
this._loggedIn=false;
this._leftChatFormatter=new AjxMessageFormat(ZmMsg.imLeftChat);
this._enteredChatFormatter=new AjxMessageFormat(ZmMsg.imEnteredChat)
};
ZmZimbraImService.prototype=new ZmImService;
ZmZimbraImService.prototype.constructor=ZmZimbraImService;
ZmZimbraImService.prototype.toString=function(){
return"ZmZimbraImService"
};
ZmZimbraImService.prototype.isLoggedIn=function(){
return this._loggedIn
};
ZmZimbraImService.prototype.login=function(e){
this._loggedIn=true;
this._roster.onServiceLoggedIn(e);
this._delayedInstantNotify()
};
ZmZimbraImService.prototype.getMyAddress=function(){
if(this._myAddress==null){
this._myAddress=appCtxt.get(ZmSetting.USERNAME)
}
return this._myAddress
};
ZmZimbraImService.prototype.makeServerAddress=function(a,e){
if(e==null||/^(xmpp|local)$/i.test(e)){
return a
}
var t=this._roster.getGatewayByType(e);
if(t){
return a+"@"+t.domain
}};
ZmZimbraImService.prototype.getGateways=function(i,a){
var t=AjxSoapDoc.create("IMGatewayListRequest","urn:zimbraIM");
var e=new AjxCallback(this,this._handleResponseGetGateways,[i]);
return this._send(a,t,e)
};
ZmZimbraImService.prototype._handleResponseGetGateways=function(i,t){
var e=t.getResponse();
var a=e.IMGatewayListResponse.service;
a=a||[];
a.unshift({
type:"XMPP",domain:"XMPP"}
);
if(i){
i.run(a)
}
return a
};
ZmZimbraImService.prototype.reconnectGateway=function(t){
var e=AjxSoapDoc.create("IMGatewayRegisterRequest","urn:zimbraIM");
var a=e.getMethod();
a.setAttribute("op","reconnect");
a.setAttribute("service",t.type);
appCtxt.getAppController().sendRequest({
soapDoc:e,asyncMode:true}
)
};
ZmZimbraImService.prototype.unregisterGateway=function(e,t){
var a=AjxSoapDoc.create("IMGatewayRegisterRequest","urn:zimbraIM");
var i=a.getMethod();
i.setAttribute("op","unreg");
i.setAttribute("service",e);
if(t){
t.addNewRequestParams(a)
}else{
appCtxt.getAppController().sendRequest({
soapDoc:a,asyncMode:true}
)
}};
ZmZimbraImService.prototype.registerGateway=function(e,i,a,t){
var o=AjxSoapDoc.create("IMGatewayRegisterRequest","urn:zimbraIM");
var n=o.getMethod();
n.setAttribute("op","reg");
n.setAttribute("service",e);
n.setAttribute("name",i);
n.setAttribute("password",a);
if(t){
t.addNewRequestParams(o);
t.setSensitive(true)
}else{
appCtxt.getAppController().sendRequest({
soapDoc:o,asyncMode:true,sensitive:true}
)
}};
ZmZimbraImService.prototype.getRoster=function(i,a){
var t=AjxSoapDoc.create("IMGetRosterRequest","urn:zimbraIM");
var e=new AjxCallback(this,this._handleResponseGetRoster,[i]);
return this._send(a,t,e)
};
ZmZimbraImService.prototype._handleResponseGetRoster=function(i,t){
var e=t.getResponse();
var a=e?e.IMGetRosterResponse:null;
if(i){
i.run(a)
}
return a
};
ZmZimbraImService.prototype.initializePresence=function(e){
if(e){
this.setPresence(e.show,null,e.customStatusMsg)
}};
ZmZimbraImService.prototype.setPresence=function(e,a,o,n){
var i=AjxSoapDoc.create("IMSetPresenceRequest","urn:zimbraIM");
var t=i.set("presence");
if(e){
t.setAttribute("show",e)
}
if(a){
t.setAttribute("priority",a)
}
if(o){
t.setAttribute("status",o)
}
if(n){
n.addNewRequestParams(i)
}else{
appCtxt.getAppController().sendRequest({
soapDoc:i,asyncMode:true}
)
}};
ZmZimbraImService.prototype.setIdle=function(a,e){
this._idlePresenceErrorCallbackObj=this._idlePresenceErrorCallbackObj||new AjxCallback(this,this._idlePresenceErrorCallback);
var i={
errorCallback:this._idlePresenceErrorCallbackObj};
var o={
IMSetIdleRequest:{
_jsns:"urn:zimbraIM",isIdle:a?"1":"0",idleTime:e/1000}};
var t={
jsonObj:o,asyncMode:true,noBusyOverlay:true,errorCallback:this._idlePresenceErrorCallbackObj};
appCtxt.getAppController().sendRequest(t)
};
ZmZimbraImService.prototype._idlePresenceErrorCallback=function(e){
return e.code==ZmCsfeException.EMPTY_RESPONSE
};
ZmZimbraImService.prototype.createRosterItem=function(n,t,e,i){
var a=AjxSoapDoc.create("IMSubscribeRequest","urn:zimbraIM");
var o=a.getMethod();
o.setAttribute("addr",n);
if(t){
o.setAttribute("name",t)
}
if(e){
o.setAttribute("groups",e)
}
o.setAttribute("op","add");
return this._send(i,a)
};
ZmZimbraImService.prototype.deleteRosterItem=function(a,t){
var e=AjxSoapDoc.create("IMSubscribeRequest","urn:zimbraIM");
var i=e.getMethod();
i.setAttribute("addr",a.id);
i.setAttribute("op","remove");
return this._send(t,e)
};
ZmZimbraImService.prototype.sendSubscribeAuthorization=function(e,a,o){
var t=AjxSoapDoc.create("IMAuthorizeSubscribeRequest","urn:zimbraIM");
var i=t.getMethod();
i.setAttribute("addr",o);
i.setAttribute("authorized",e?"true":"false");
i.setAttribute("add",a?"true":"false");
appCtxt.getAppController().sendRequest({
soapDoc:t,asyncMode:true}
)
};
ZmZimbraImService.prototype.sendMessage=function(h,n,a,s,t){
var o=AjxSoapDoc.create("IMSendMessageRequest","urn:zimbraIM");
var r=o.set("message");
if(s){
o.set("typing",null,r)
}
var i=h.getThread();
if(i){
r.setAttribute("thread",i)
}
r.setAttribute("addr",h.getRosterItem(0).getAddress());
if(n||a){
var e=o.set("body",null,r);
if(n){
o.set("text",n,e)
}
if(a){
o.set("html",a,e)
}}
this._delayedInstantNotify();
return this._send(t,o)
};
ZmZimbraImService.prototype.closeChat=function(e,a){
var t=AjxSoapDoc.create("IMModifyChatRequest","urn:zimbraIM");
var i=t.getMethod();
i.setAttribute("thread",e.getThread());
i.setAttribute("op","close");
return this._send(a,t)
};
ZmZimbraImService.prototype.getConferenceServices=function(i,t){
var e=AjxSoapDoc.create("IMListConferenceServicesRequest","urn:zimbraIM");
var a=new AjxCallback(this,this._handleResponseListConferenceServices,[i]);
return this._send(t,e,a)
};
ZmZimbraImService.prototype._handleResponseListConferenceServices=function(t,e){
t.run(e.getResponse().IMListConferenceServicesResponse.svc)
};
ZmZimbraImService.prototype.getConferenceRooms=function(e,n,a){
var t=AjxSoapDoc.create("IMListConferenceRoomsRequest","urn:zimbraIM");
var o=t.getMethod();
o.setAttribute("svc",e.getAddress());
var i=new AjxCallback(this,this._handleResponseListConferenceRooms,[n]);
return this._send(a,t,i)
};
ZmZimbraImService.prototype._handleResponseListConferenceRooms=function(t,e){
t.run(e.getResponse().IMListConferenceRoomsResponse.room||[])
};
ZmZimbraImService.prototype.createConferenceRoom=function(e,t,r,i){
var s=[t,e.getAddress()].join("@");
var a=AjxSoapDoc.create("IMJoinConferenceRoomRequest","urn:zimbraIM");
var n=a.getMethod();
n.setAttribute("nickname",appCtxt.get(ZmSetting.USERNAME));
n.setAttribute("addr",s);
var o=new AjxCallback(this,this._handleResponseCreateConferenceRoom,[e,s,t,r]);
return this._send(i,a,o)
};
ZmZimbraImService.prototype._handleResponseCreateConferenceRoom=function(e,s,i,n,a){
var t=a.getResponse().IMJoinConferenceRoomResponse;
var o={
addr:s,name:i,status:t.status,thread:t.thread};
n.run(o)
};
ZmZimbraImService.prototype.configureConferenceRoom=function(t,i,h,n){
var s=AjxSoapDoc.create("IMModifyChatRequest","urn:zimbraIM");
var e=s.getMethod();
e.setAttribute("thread",t.thread);
e.setAttribute("op","configure");
for(var a in i){
var r=i[a];
if(typeof r!="undefined"){
var o=s.set("var",r);
o.setAttribute("name",a);
if(a=="password"){
n=n||{};
n.sensitive=true
}}}
var l=h?new AjxCallback(this,this._handleResponseConfigureConferenceRoom,[h]):null;
return this._send(n,s,l)
};
ZmZimbraImService.prototype._handleResponseConfigureConferenceRoom=function(e){
e.run()
};
ZmZimbraImService.prototype.joinConferenceRoom=function(a,e,s,i){
var t=AjxSoapDoc.create("IMJoinConferenceRoomRequest","urn:zimbraIM");
var n=t.getMethod();
n.setAttribute("nickname",appCtxt.get(ZmSetting.USERNAME));
n.setAttribute("addr",a.getAddress());
if(e){
n.setAttribute("password",e);
i=i||{};
i.sensitive=true
}
var o=s?new AjxCallback(this,this._handleResponseJoinConferenceRoom,[a,s]):null;
return this._send(i,t,o)
};
ZmZimbraImService.prototype._handleResponseJoinConferenceRoom=function(a,o,t){
var e=t.getResponse().IMJoinConferenceRoomResponse;
var i={
thread:e.thread,error:e.error};
o.run(i)
};
ZmZimbraImService.prototype.handleNotification=function(l){
if(l.n){
var b=this.getShowNotify();
var h=this._roster.getChatList();
for(var y=0;
y<l.n.length;
y++){
var t=l.n[y];
if(t.type=="roster"){
var v=this._roster.getRosterItemList();
v.removeAllItems();
if(t.n&&t.n.length){
var n=[];
for(var u=0;
u<t.n.length;
u++){
var o=t.n[u];
if(o.type=="subscribed"&&o.to.indexOf("@")>=0){
n.push(new ZmRosterItem(o.to,v,o.name,null,o.groups))
}}
if(n.length){
v.addItems(n)
}}
v.setLoaded(true)
}else{
if(t.type=="subscribe"){
this._roster.onServiceRequestBuddyAuth(t.from)
}else{
if(t.ask&&/^(un)?subscribed$/.test(t.type)){
if(t.ask=="subscribe"&&t.to){
var v=this._roster.getRosterItemList();
var k=v.getByAddr(t.to);
if(!k){
k=new ZmRosterItem(t.to,v,(t.name||t.to),null,t.groups);
v.addItem(k);
if(b){
this._watingFormatter=this._watingFormatter||new AjxMessageFormat(ZmMsg.imSubscribeAuthRequest_waiting);
ZmTaskbarController.INSTANCE.setMessage(this._watingFormatter.format(t.to))
}}}else{
if(t.ask=="unsubscribe"&&t.to){}}}else{
if(t.type=="subscribed"){
var r=t;
if(r.to){
var v=this._roster.getRosterItemList();
var k=v.getByAddr(r.to);
if(k){
if(r.groups){
k._notifySetGroups(r.groups)
}
if(r.name&&r.name!=k.getName()){
k._notifySetName(r.name)
}}else{
if(r.to.indexOf("@")>=0){
this._roster.onServiceAddBuddy(r.to,r.name,null,r.groups,b)
}}}else{
if(r.from){}}}else{
if(t.type=="unsubscribed"){
var x=t;
if(x.to){
this._roster.onServiceRemoveBuddy(x.to,b)
}}else{
if(t.type=="presence"){
var f=t;
if(f.from==this.getMyAddress()){
if(this._roster.getPresence().setFromJS(f)){
this._roster.notifyPresence()
}}
var m=this._roster.getRosterItemList().getByAddr(f.from);
if(m){
this._roster.onServiceSetBuddyPresence(m,f,b)
}}else{
if(t.type=="message"){
appCtxt.getApp(ZmApp.IM).prepareVisuals();
var i=t;
if(i.body==null||i.body.length==0){
var g=this._roster.getRosterItem(i.from);
if(g){
g._notifyTyping(i.typing)
}}else{
var a=new ZmChatMessage(i,i.from==this.getMyAddress());
this._roster.onServiceAddChatMessage(a)
}}else{
if(t.type=="enteredchat"){
appCtxt.getApp(ZmApp.IM).prepareVisuals();
var w=this._roster.getChatList().getChatByThread(t.thread);
if(w){
w.addMessage(ZmChatMessage.system(this._enteredChatFormatter.format([t.addr])));
var q=this._roster.getRosterItem(t.addr);
if(!q){
var s=new ZmRosterPresence(ZmRosterPresence.SHOW_UNKNOWN);
q=new ZmRosterItem(t.addr,this._roster.getChatList(),null,s,null)
}
w.addRosterItem(q)
}}else{
if(t.type=="leftchat"){
appCtxt.getApp(ZmApp.IM).prepareVisuals();
var w=this._roster.getChatList().getChatByThread(t.thread);
if(w){
w.addMessage(ZmChatMessage.system(this._leftChatFormatter.format([t.addr])));
w.removeRosterItem(this._roster.getRosterItem(t.addr))
}}else{
if(t.type=="otherLocation"){
var d=this._roster.getGatewayByType(t.service);
d.setState(t.username,ZmImGateway.STATE.BOOTED_BY_OTHER_LOGIN)
}else{
if(t.type=="gwStatus"){
var d=this._roster.getGatewayByType(t.service);
d.setState(t.name||null,t.state);
var c,e=ZmStatusView.LEVEL_INFO;
switch(t.state){
case ZmImGateway.STATE.BAD_AUTH:c=ZmMsg.errorNotAuthenticated;
e=ZmStatusView.LEVEL_WARNING;
break;
case ZmImGateway.STATE.ONLINE:this._gatewayOnlineFormat=this._gatewayOnlineFormat||new AjxMessageFormat(ZmMsg.imToastGwOnline);
c=this._gatewayOnlineFormat.format(ZmMsg["imGateway_"+t.service]);
break;
case ZmImGateway.STATE.SHUTDOWN:this._gatewayOfflineFormat=this._gatewayOfflineFormat||new AjxMessageFormat(ZmMsg.imToastGwOffline);
c=this._gatewayOfflineFormat.format(ZmMsg["imGateway_"+t.service]);
break
}
if(c){
appCtxt.setStatusMsg(AjxStringUtil.htmlEncode(c),e)
}}else{
if(t.type=="privacy"){
this._roster.getPrivacyList().reset(t.list[0].item)
}}}}}}}}}}}}}}};
ZmZimbraImService.prototype._delayedInstantNotify=function(){
if(appCtxt.get(ZmSetting.INSTANT_NOTIFY)&&appCtxt.get(ZmSetting.IM_PREF_INSTANT_NOTIFY)&&!appCtxt.getAppController().getInstantNotify()){
var e=appCtxt.getAppController();
var t=new AjxTimedAction(e,e.setInstantNotify,[true]);
AjxTimedAction.scheduleAction(t,4000)
}};
ZmZimbraImService.prototype._send=function(t,e,a){
t=t||{};
t.asyncMode=true;
t.soapDoc=e;
t.callback=a;
appCtxt.getAppController().sendRequest(t)
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmImGateway")){
ZmImGateway=function(a){
this.type=a.type.toLowerCase();
this.domain=a.domain.toLowerCase();
this.nick=null;
this.state=ZmImGateway.STATE.UNKNOWN;
if(a.registration){
for(var e=0;
e<a.registration.length;
++e){
var t=a.registration[e];
this.nick=t.name;
this.state=t.state;
break
}}
this._eventMgr=new AjxEventMgr()
};
ZmImGateway.STATE={
UNKNOWN:"unknown",BAD_AUTH:"bad_auth",INTENTIONALLY_OFFLINE:"intentionally_offline",ONLINE:"online",SHUTDOWN:"shutdown",START:"start",TRYING_TO_CONNECT:"trying_to_connect",BOOTED_BY_OTHER_LOGIN:"disabled"};
ZmImGateway.LOGIN_FORBIDDEN_STATES={};
ZmImGateway.LOGIN_FORBIDDEN_STATES[ZmImGateway.STATE.ONLINE]=true;
ZmImGateway.LOGIN_FORBIDDEN_STATES[ZmImGateway.STATE.INTENTIONALLY_OFFLINE]=true;
ZmImGateway.LOGIN_FORBIDDEN_STATES[ZmImGateway.STATE.START]=true;
ZmImGateway.LOGIN_FORBIDDEN_STATES[ZmImGateway.STATE.TRYING_TO_CONNECT]=true;
ZmImGateway.EVENT_SET_STATE="ZmImGateway.setState";
ZmImGateway.prototype.getNick=function(){
return this.nick
};
ZmImGateway.prototype.getState=function(){
return this.state
};
ZmImGateway.prototype.setState=function(e,t){
if(t=="disabled"){
t=ZmImGateway.STATE.BOOTED_BY_OTHER_LOGIN
}
if(e!=null){
this.nick=e
}
this.state=t;
this._eventMgr.notifyListeners(ZmImGateway.EVENT_SET_STATE,{
gw:this,nick:e,state:t}
)
};
ZmImGateway.prototype.isOnline=function(){
var t=this.getState();
var e=this.getNick();
if(t&&e&&ZmImGateway.LOGIN_FORBIDDEN_STATES[t]){
return e
}
return null
};
ZmImGateway.prototype.addListener=function(e,t){
this._eventMgr.addListener(e,t)
};
ZmImGateway.prototype.removeListener=function(e,t){
this._eventMgr.removeListener(e,t)
};
ZmImGateway.prototype.reconnect=function(){
AjxDispatcher.run("GetRoster").reconnectGateway(this)
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmRoster")){
ZmRoster=function(e){
ZmModel.call(this,ZmEvent.S_ROSTER);
this._gateways={
byService:{}
,byDomain:{}
,array:[]};
this._notificationBuffer=[];
this._imApp=e
};
ZmRoster.prototype=new ZmModel;
ZmRoster.prototype.constructor=ZmRoster;
ZmRoster.F_PRESENCE="ZmRoster.presence";
ZmRoster.NOTIFICATION_FOO_TIMEOUT=10000;
ZmRoster.GATEWAY_EVENT="gateway list";
ZmRoster.prototype.toString=function(){
return"ZmRoster"
};
ZmRoster.prototype.getPrivacyList=function(){
return this._privacyList=this._privacyList||new ZmImPrivacyList(this)
};
ZmRoster.prototype.getChatList=function(){
if(!this._chatList){
this._chatList=new ZmChatList(this)
}
return this._chatList
};
ZmRoster.prototype.getMyAddress=function(){
return ZmImApp.INSTANCE.getService().getMyAddress()
};
ZmRoster.prototype.getRosterItem=function(a,e){
if(!a){
return null
}
a=a.toLowerCase();
var t=this.getRosterItemList().getByAddr(a);
if(t){
return t
}
if(e){
a=ZmImAddress.parse(a);
t=a?this.getRosterItemList().getByAddr(a.screenName):null;
if(t){
return t
}
if(a){
a=this.makeServerAddress(a.screenName,a.service);
if(a){
return this.getRosterItemList().getByAddr(a)
}}}};
ZmRoster.prototype.getRosterItemList=function(){
if(!this._rosterItemList){
this._rosterItemList=new ZmRosterItemList()
}
return this._rosterItemList
};
ZmRoster.prototype.getPresence=function(){
if(!this._rosterPresence){
this._rosterPresence=new ZmRosterPresence()
}
return this._rosterPresence
};
ZmRoster.prototype.notifyPresence=function(){
var e={};
e[ZmRoster.F_PRESENCE]=this.getPresence();
this._notify(ZmEvent.E_MODIFY,{
fields:e}
)
};
ZmRoster.prototype.reload=function(t){
this.getRosterItemList().removeAllItems();
var a=new AjxCallback(this,this._handleResponseReload);
var e={
asyncMode:true,noBusyOverlay:t};
ZmImApp.INSTANCE.getService().getRoster(a,e)
};
ZmRoster.prototype._handleResponseReload=function(r){
if(!r){
return
}
var s=this.getRosterItemList();
if(r.items&&r.items.item){
var t=r.items.item;
if(t.length){
var e=new Array(t.length);
for(var a=0;
a<t.length;
a++){
var n=t[a];
if(n.subscription=="TO"||n.subscription=="BOTH"){
var o=new ZmRosterPresence();
o.setFromJS(n.presence);
e[a]=new ZmRosterItem(n.addr,s,n.name,o,n.groups)
}}
s.addItems(e)
}}
if(r.presence){
if(/XA|AWAY/.test(r.presence.show)){
r.presence.show="ONLINE";
this.setPresence("ONLINE")
}
this.getPresence().setFromJS(r.presence);
this.notifyPresence()
}
ZmImApp.INSTANCE.getService().startIgnoreNotify()
};
ZmRoster.prototype.createRosterItem=function(a,t,e){
ZmImApp.INSTANCE.getService().createRosterItem(a,t,e)
};
ZmRoster.prototype.setPresence=function(e,t,a,i){
ZmImApp.INSTANCE.getService().setPresence(e,t,a,i);
ZmImApp.INSTANCE.getService().startIgnoreNotify()
};
ZmRoster.prototype.pushNotification=function(e){
if(!this._gateways){
this._notificationBuffer.push(e)
}else{
this.handleNotification(e)
}};
ZmRoster.prototype.refresh=function(){
this._requestGateways(new AjxCallback(this,this.reload))
};
ZmRoster.prototype.handleNotification=function(e){
ZmImApp.INSTANCE.getService().handleNotification(e)
};
ZmRoster.prototype.getConferenceTree=function(){
AjxDispatcher.require(["IMConference"]);
if(!this._conferenceTree){
this._conferenceTree=new ZmTree(ZmOrganizer.CONFERENCE_ITEM);
this._conferenceTree.root=new ZmOrganizer({
tree:this._conferenceTree}
)
}
return this._conferenceTree
};
ZmRoster.prototype.getConferenceServices=function(i,a){
var e=this.getConferenceTree();
if(!e.root.children.size()||a){
var t=new AjxCallback(this,this._handleResponceGetConferenceServices,[i]);
ZmImApp.INSTANCE.getService().getConferenceServices(t)
}else{
i.run(e.root.children.getArray())
}};
ZmRoster.prototype._handleResponceGetConferenceServices=function(h,s){
var t=this.getConferenceTree();
var a=t.root;
for(var n=0,r=s.length;
n<r;
n++){
var o={
id:s[n].addr,tree:t,name:s[n].name,parent:a};
var e=new ZmConferenceService(o);
a.children.add(e)
}
h.run(a.children.getArray())
};
ZmRoster.prototype.joinChatRequest=function(e,i){
var t=AjxSoapDoc.create("IMJoinConferenceRoomRequest","urn:zimbraIM");
var a=t.getMethod();
a.setAttribute("thread",e);
a.setAttribute("addr",i);
appCtxt.getAppController().sendRequest({
soapDoc:t,asyncMode:true}
)
};
ZmRoster.prototype.sendSubscribeAuthorization=function(e,t,a){
ZmImApp.INSTANCE.getService().sendSubscribeAuthorization(e,t,a)
};
ZmRoster.prototype.addGatewayListListener=function(e){
this._evtMgr.addListener(ZmRoster.GATEWAY_EVENT,e)
};
ZmRoster.prototype.reconnectGateway=function(e){
ZmImApp.INSTANCE.getService().reconnectGateway(e);
ZmImApp.INSTANCE.getService().startIgnoreNotify()
};
ZmRoster.prototype.unregisterGateway=function(e,t){
ZmImApp.INSTANCE.getService().unregisterGateway(e,t);
ZmImApp.INSTANCE.getService().startIgnoreNotify()
};
ZmRoster.prototype.registerGateway=function(e,i,a,t){
ZmImApp.INSTANCE.getService().registerGateway(e,i,a,t);
ZmImApp.INSTANCE.getService().startIgnoreNotify();
this.getGatewayByType(e).nick=i
};
ZmRoster.prototype._requestGateways=function(e){
ZmImApp.INSTANCE.getService().getGateways(new AjxCallback(this,this._handleRequestGateways,[e]))
};
ZmRoster.prototype._handleRequestGateways=function(s,n){
var a={};
var e={};
for(var t=0;
t<n.length;
++t){
var o=n[t]=new ZmImGateway(n[t]);
a[n[t].type.toLowerCase()]=o;
e[n[t].domain.toLowerCase()]=o
}
this._gateways={
byService:a,byDomain:e,array:n};
for(var t=0;
t<this._notificationBuffer.length;
++t){
this.handleNotification(this._notificationBuffer[t])
}
this._notificationBuffer=[];
this._evtMgr.notifyListeners(ZmRoster.GATEWAY_EVENT,{
roster:this}
);
if(s){
s.run()
}};
ZmRoster.prototype.getGatewayByType=function(e){
return this._gateways.byService[e.toLowerCase()]
};
ZmRoster.prototype.getGatewayByDomain=function(e){
return this._gateways.byDomain[e.toLowerCase()]
};
ZmRoster.prototype.getGateways=function(){
return this._gateways.array
};
ZmRoster.prototype.makeServerAddress=function(t,e){
return ZmImApp.INSTANCE.getService().makeServerAddress(t,e)
};
ZmRoster.prototype.makeGenericAddress=function(e){
e=this.breakDownAddress(e);
if(e.type.toLowerCase()=="xmpp"){
e.type="local"
}
return ZmImAddress.make(e.type,e.addr)
};
ZmRoster.prototype.breakDownAddress=function(i){
var t=/@(.*)$/;
var e=t.exec(i);
if(e){
var a=this.getGatewayByDomain(e[1]);
if(a){
return{
type:a.type,addr:i.substr(0,e.index),gateway:a}
}}
return{
type:"XMPP",addr:i}
};
ZmRoster.prototype.getGroups=function(){
return AjxVector.fromArray(this.getRosterItemList().getGroupsArray())
};
ZmRoster.prototype.setIdle=function(e){
if(ZmImApp.INSTANCE.getService().isLoggedIn()){
ZmImApp.INSTANCE.getService().setIdle(e,this._idleTimer.timeout)
}};
ZmRoster.prototype.onServiceAddChatMessage=function(e){
appCtxt.getApp(ZmApp.IM).prepareVisuals();
var i=this.getRosterItem(e.from);
if(i){
i._notifyTyping(false)
}
var a=this.getChatList();
var t=a.getChatByThread(e.thread);
if(t==null){
if(!e.fromMe){
t=a.getChatByRosterAddr(e.from,true,true)
}else{
t=a.getChatByRosterAddr(e.to,false)
}
if(t){
t.setThread(e.thread)
}}
if(t){
if(!e.fromMe){
if(appCtxt.get(ZmSetting.IM_PREF_FLASH_BROWSER)){
AjxDispatcher.require("Alert");
ZmBrowserAlert.getInstance().start(ZmMsg.newInstantMessage)
}
if(appCtxt.get(ZmSetting.IM_PREF_DESKTOP_ALERT)){
AjxDispatcher.require("Alert");
ZmDesktopAlert.getInstance().start(ZmMsg.newInstantMessage,e.getTextBody())
}}
t.addMessage(e)
}};
ZmRoster.prototype.onServiceAddBuddy=function(r,i,o,t,a){
var s=this.getRosterItemList();
var n=new ZmRosterItem(r,s,i,o,t);
s.addItem(n);
if(a){
this._newRosterItemtoastFormatter=this._newRosterItemtoastFormatter||new AjxMessageFormat(ZmMsg.imNewRosterItemToast);
var e=this._newRosterItemtoastFormatter.format([n.getDisplayName()]);
ZmTaskbarController.INSTANCE.setMessage(e)
}};
ZmRoster.prototype.onServiceRemoveBuddy=function(o,t){
var i=this.getRosterItemList();
var a=i.getByAddr(o);
if(a){
var e=a.getDisplayName();
i.removeItem(a);
if(t){
this._removeRosterItemToastFormatter=this._removeRosterItemToastFormatter||new AjxMessageFormat(ZmMsg.imRemoveRosterItemToast);
ZmTaskbarController.INSTANCE.setMessage(this._removeRosterItemToastFormatter.format([e]))
}}};
ZmRoster.prototype.onServiceRequestBuddyAuth=function(t){
var e=this.getRosterItem(t);
ZmTaskbarController.INSTANCE.showSubscribeRequest(t,e)
};
ZmRoster.prototype.onServiceSetBuddyPresence=function(n,s,i){
var o=n.getPresence().getShow();
if(n.getPresence().setFromJS(s)){
n._notifyPresence();
if(o!=ZmRosterPresence.SHOW_UNKNOWN){
this._presenceToastFormatter=this._presenceToastFormatter||new AjxMessageFormat(ZmMsg.imStatusToast);
var t=this._presenceToastFormatter.format([n.getDisplayName(),AjxStringUtil.htmlEncode(n.getPresence().getShowText())]);
var e=o==n.getPresence().getShow();
if(i&&((!e&&appCtxt.get(ZmSetting.IM_PREF_NOTIFY_PRESENCE))||(e&&appCtxt.get(ZmSetting.IM_PREF_NOTIFY_STATUS)))){
ZmTaskbarController.INSTANCE.setMessage(t);
var a=this.getChatList().getChatByRosterAddr(s.from);
if(a){
a.addMessage(ZmChatMessage.system(t))
}}}}};
ZmRoster.prototype.onServiceLoggedIn=function(t){
if(!this._idleTimer){
this._idleTimer=new DwtIdleTimer(appCtxt.get(ZmSetting.IM_PREF_IDLE_TIMEOUT)*60*1000,new AjxCallback(this,this.setIdle));
if(!appCtxt.get(ZmSetting.IM_PREF_REPORT_IDLE)){
this._idleTimer.kill()
}}
this._notify(ZmEvent.E_LOAD,{
loggedIn:true}
);
var a=new AjxCallback(this,this._loggedInGatewayCallback,[t]);
var e={
asyncMode:true,noBusyOverlay:true};
ZmImApp.INSTANCE.getService().getGateways(a,e)
};
ZmRoster.prototype._loggedInGatewayCallback=function(e,t){
this._handleRequestGateways(null,t);
ZmImApp.INSTANCE.getService().initializePresence(e?e.presence:null);
this.reload();
if(e&&e.callback){
e.callback.run(this)
}};
ZmRoster.prototype.onServiceLoggedOut=function(){
if(this.getPresence().setFromJS({
show:ZmRosterPresence.SHOW_OFFLINE}
)){
this.notifyPresence()
}
this.getRosterItemList().removeAllItems();
this._notify(ZmEvent.E_LOAD,{
loggedIn:false}
)
};
ZmRosterTreeGroups=function(e){
this._groups=e.getGroups()
};
ZmRosterTreeGroups.prototype.constructor=ZmRosterTreeGroups;
ZmRosterTreeGroups.prototype.autocompleteMatch=function(r,h){
r=r.toLowerCase();
var e=[];
var t=this._groups;
var s=t.size();
for(var o=0;
o<s;
o++){
var n=t.get(o);
if(n.toLowerCase().indexOf(r)==0){
e.push({
data:n,text:n}
)
}}
h.run(e)
};
ZmRosterTreeGroups.prototype.getArray=function(){
return this._groups
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmRosterItem")){
ZmRosterItem=function(o,i,t,a,e){
if(arguments.length>0){
ZmItem.call(this,ZmOrganizer.ROSTER_ITEM,o,i);
this.name=t;
this.presence=a||new ZmRosterPresence();
this.groupNames=e;
this.groups=e?e.split(/,/):[];
this.numUnreadIMs=0
}};
ZmRosterItem.prototype=new ZmItem;
ZmRosterItem.prototype.constructor=ZmRosterItem;
ZmRosterItem.F_PRESENCE="ZmRosterItem.presence";
ZmRosterItem.F_GROUPS="ZmRosterItem.groups";
ZmRosterItem.F_NAME="ZmRosterItem.name";
ZmRosterItem.F_UNREAD="ZmRosterItem.unread";
ZmRosterItem.F_TYPING="ZmRosterItem.typing";
ZmRosterItem.prototype.toString=function(){
return"ZmRosterItem - "+this.name
};
ZmRosterItem.prototype._delete=function(){
ZmImApp.INSTANCE.getService().deleteRosterItem(this)
};
ZmRosterItem.prototype.getPresence=function(){
return this.presence
};
ZmRosterItem.prototype.addGroup=function(e){
this.groups.push(e);
this.groupNames=this.groups.join(",")
};
ZmRosterItem.prototype._notifyTyping=function(t){
var e={};
e[ZmRosterItem.F_TYPING]=!!t;
this.list._notify(ZmEvent.E_MODIFY,{
fields:e,items:[this]}
)
};
ZmRosterItem.prototype._notifyPresence=function(){
var e={};
e[ZmRosterItem.F_PRESENCE]=this.getPresence();
this.list._notify(ZmEvent.E_MODIFY,{
fields:e,items:[this]}
);
delete this._toolTip;
var t=this.getContact();
if(t){
t.notifyModify({}
)
}};
ZmRosterItem.prototype.setUnread=function(t,a){
this.numUnreadIMs=a?this.numUnreadIMs+t:t;
var e={};
e[ZmRosterItem.F_UNREAD]=this.numUnreadIMs;
this.list._notify(ZmEvent.E_MODIFY,{
fields:e,items:[this]}
);
delete this._toolTip
};
ZmRosterItem.prototype._notifySetGroups=function(t){
this.groupNames=t;
this.groups=this.groupNames?this.groupNames.split(/,/):[];
var e={};
e[ZmRosterItem.F_GROUPS]=this.groupNames;
this.list._notify(ZmEvent.E_MODIFY,{
fields:e,items:[this]}
);
delete this._toolTip
};
ZmRosterItem.prototype._notifySetName=function(t){
this.name=t;
var e={};
e[ZmRosterItem.F_NAME]=this.name;
this.list._notify(ZmEvent.E_MODIFY,{
fields:e,items:[this]}
);
delete this._toolTip
};
ZmRosterItem.sortCompare=function(o,i){
var t=ZmOrganizer.checkSortArgs(o,i);
if(t!=null){
return t
}
var e=o.getDisplayName().toLowerCase();
var a=i.getDisplayName().toLowerCase();
if(e<a){
return -1
}
if(e>a){
return 1
}
return 0
};
ZmRosterItem.prototype.getId=function(){
return this.id
};
ZmRosterItem.prototype.getAddress=function(){
return this.id
};
ZmRosterItem.prototype.getGroups=function(){
return this.groups
};
ZmRosterItem.prototype.getGroupNames=function(){
return this.groupNames
};
ZmRosterItem.prototype.getName=function(){
return this.name
};
ZmRosterItem.prototype.getContact=function(){
var t=AjxDispatcher.run("GetContacts");
var e=t.getContactByEmail(this.getAddress());
if(!e){
var a=AjxDispatcher.run("GetRoster");
var i=a.makeGenericAddress(this.id);
if(i){
e=t.getContactByIMAddress(i)
}}
return e
};
ZmRosterItem.prototype.getDisplayName=function(){
if(this.name){
return this.name
}
var e=this.getContact();
if(e){
return e.getFullName()
}
return ZmImAddress.display(this.id)
};
ZmRosterItem.prototype.getUnread=function(){
return this.numUnreadIMs
};
ZmRosterItem.prototype.handleInput=function(t){
function e(i){
i.sendMessage(null,null,false);
this._isTyping=null
}
if(!this._isTyping){
var a=!t.enter;
this._isTyping=a;
t.chat.sendMessage(null,null,a);
if(this._clearTypingTimer){
clearTimeout(this._clearTypingTimer)
}
this._clearTypingTimer=setTimeout(AjxCallback.simpleClosure(e,this,t.chat),5000)
}};
ZmRosterItem.prototype.chatStarted=function(e,t){};
ZmRosterItem.prototype.inGroup=function(e){
for(var t in this.groups){
if(this.groups[t]==e){
return true
}}
return false
};
ZmRosterItem.checkName=function(e){
return null
};
ZmRosterItem.checkAddress=function(e){
if(e==null||e==""){
return ZmMsg.rosterItemAddressNoValue
}else{
return null
}};
ZmRosterItem.checkGroups=function(e){
return null
};
ZmRosterItem.prototype.getToolTip=function(){
return AjxTemplate.expand("im.Chat#RosterItemTooltip",{
buddy:this,contact:this.getContact()}
)
};
ZmRosterItem.prototype.isDefaultBuddy=function(){
return false
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmRosterItemList")){
ZmRosterItemList=function(){
ZmList.call(this,ZmItem.ROSTER_ITEM)
};
ZmRosterItemList.prototype=new ZmList;
ZmRosterItemList.prototype.constructor=ZmRosterItemList;
ZmRosterItemList.prototype.toString=function(){
return"ZmRosterItemList"
};
ZmRosterItemList.prototype.setLoaded=function(){
this._notify(ZmEvent.E_LOAD)
};
ZmRosterItemList.prototype.addItem=function(a,t,e){
this.add(a,e);
if(!t){
this._notify(ZmEvent.E_CREATE,{
items:[a]}
)
}};
ZmRosterItemList.prototype.addItems=function(e){
for(var t=0,a=e.length;
t<a;
t++){
this.add(e[t])
}
this._notify(ZmEvent.E_CREATE,{
items:e}
)
};
ZmRosterItemList.prototype.removeItem=function(t,e){
if(!t.isDefaultBuddy()){
this.remove(t);
if(!e){
this._notify(ZmEvent.E_REMOVE,{
items:[t]}
)
}}};
ZmRosterItemList.prototype.getByAddr=function(e){
return this.getById(e.toLowerCase())
};
ZmRosterItemList.prototype.getGroupsArray=function(){
var r={};
var t=[];
var n=this.getArray();
for(var o=0;
o<n.length;
o++){
var e=n[o].getGroups();
for(var s in e){
var a=e[s];
if(!(a in r)){
r[a]=true;
t.push(a)
}}}
return t
};
ZmRosterItemList.prototype.removeAllItems=function(){
var t=this.getVector().clone().getArray();
for(var e=0;
e<t.length;
e++){
this.removeItem(t[e])
}}
}
if(AjxPackage.define("zimbraMail.im.model.ZmRosterPresence")){
ZmRosterPresence=function(e,t,a){
this._show=e||ZmRosterPresence.SHOW_OFFLINE;
this._priority=t;
this._showStatus=a
};
ZmRoster.prototype.constructor=ZmRoster;
ZmRosterPresence.SHOW_UNKNOWN="UNKNOWN";
ZmRosterPresence.SHOW_OFFLINE="OFFLINE";
ZmRosterPresence.SHOW_ONLINE="ONLINE";
ZmRosterPresence.SHOW_CHAT="CHAT";
ZmRosterPresence.SHOW_AWAY="AWAY";
ZmRosterPresence.SHOW_EXT_AWAY="XA";
ZmRosterPresence.SHOW_DND="DND";
ZmRosterPresence.prototype.setShow=function(e){
this._show=e;
return this
};
ZmRosterPresence.prototype.setStatus=function(e){
this._showStatus=e;
return this
};
ZmRosterPresence.prototype.setPriority=function(e){
this._priority=e;
return this
};
ZmRosterPresence.prototype.getShow=function(){
return this._show
};
ZmRosterPresence.prototype.getStatus=function(){
return this._showStatus
};
ZmRosterPresence.prototype.getPriority=function(){
return this._priority
};
ZmRosterPresence.prototype.setFromJS=function(e){
var t=(this._show==e.show)&&(this._priority==e.priority)&&(this._showStatus==e.status);
if(!t){
this._show=e.show||ZmRosterPresence.SHOW_OFFLINE;
this._priority=e.priority;
this._showStatus=e.status
}
return !t
};
ZmRosterPresence.prototype.getShowText=function(){
if(this._showStatus){
return this._showStatus
}
switch(this._show){
case ZmRosterPresence.SHOW_ONLINE:return ZmMsg.imStatusOnline;
case ZmRosterPresence.SHOW_CHAT:return ZmMsg.imStatusChat;
case ZmRosterPresence.SHOW_AWAY:return ZmMsg.imStatusAway;
case ZmRosterPresence.SHOW_EXT_AWAY:return ZmMsg.imStatusExtAway;
case ZmRosterPresence.SHOW_DND:return ZmMsg.imStatusDND;
case ZmRosterPresence.SHOW_UNKNOWN:return ZmMsg.imStatusUnknown;
case ZmRosterPresence.SHOW_OFFLINE:return ZmMsg.imStatusOffline;
default:return ZmMsg.imStatusOffline
}};
ZmRosterPresence.prototype.getIcon=function(e){
switch(this._show){
case ZmRosterPresence.SHOW_ONLINE:return e?"_ImSmallAvailable":"ImAvailable";
case ZmRosterPresence.SHOW_CHAT:return"ImFree2Chat";
case ZmRosterPresence.SHOW_AWAY:return e?"_ImSmallAway":"ImAway";
case ZmRosterPresence.SHOW_EXT_AWAY:return e?"_ImSmallExtendedAway":"ImExtendedAway";
case ZmRosterPresence.SHOW_DND:return e?"_ImSmallDnD":"ImDnd";
case ZmRosterPresence.SHOW_UNKNOWN:return"ImBuddy";
case ZmRosterPresence.SHOW_OFFLINE:return e?"_ImSmallUnavailable":"Offline";
default:return e?"_ImSmallUnavailable":"Offline"
}};
ZmRosterPresence.operationToShow=function(e){
switch(e){
case ZmOperation.IM_PRESENCE_ONLINE:return ZmRosterPresence.SHOW_ONLINE;
case ZmOperation.IM_PRESENCE_CHAT:return ZmRosterPresence.SHOW_CHAT;
case ZmOperation.IM_PRESENCE_AWAY:return ZmRosterPresence.SHOW_AWAY;
case ZmOperation.IM_PRESENCE_XA:return ZmRosterPresence.SHOW_EXT_AWAY;
case ZmOperation.IM_PRESENCE_DND:return ZmRosterPresence.SHOW_DND;
case ZmOperation.IM_PRESENCE_OFFLINE:return ZmRosterPresence.SHOW_OFFLINE;
default:return ZmRosterPresence.SHOW_OFFLINE
}};
ZmRosterPresence.prototype.getShowOperation=function(){
return ZmRosterPresence.showToOperation(this.getShow())
};
ZmRosterPresence.showToOperation=function(e){
switch(e){
case ZmRosterPresence.SHOW_ONLINE:return ZmOperation.IM_PRESENCE_ONLINE;
case ZmRosterPresence.SHOW_CHAT:return ZmOperation.IM_PRESENCE_CHAT;
case ZmRosterPresence.SHOW_AWAY:return ZmOperation.IM_PRESENCE_AWAY;
case ZmRosterPresence.SHOW_EXT_AWAY:return ZmOperation.IM_PRESENCE_XA;
case ZmRosterPresence.SHOW_DND:return ZmOperation.IM_PRESENCE_DND;
case ZmRosterPresence.SHOW_OFFLINE:return ZmOperation.IM_PRESENCE_OFFLINE;
default:return ZmOperation.IM_PRESENCE_OFFLINE
}}
}
if(AjxPackage.define("zimbraMail.im.model.ZmChat")){
ZmChat=function(a,t,e){
if(e==null){
e=appCtxt.getApp(ZmApp.IM).getRoster().getChatList()
}
ZmItem.call(this,ZmItem.CHAT,a,e);
this._sendMessageCallbackObj=new AjxCallback(this,this._sendMessageCallback);
this.messages=[];
this._rosterItemList=new ZmRosterItemList();
this._isGroupChat=false;
this._chatName=t;
this._thread=null;
this._unread=0;
this._historyIndex=0
};
ZmChat.prototype=new ZmItem;
ZmChat.prototype.constructor=ZmChat;
ZmChat.F_MESSAGE="ZmChat.message";
ZmChat.F_TYPING="ZmChat.typing";
ZmChat.prototype.toString=function(){
return"ZmChat: id = "+this.id
};
ZmChat.prototype._getRosterItemList=function(){
return this._rosterItemList
};
ZmChat.prototype.addRosterItem=function(a,t,e){
this._rosterItemList.addItem(a,t,e);
this._isGroupChat=this._isGroupChat||(this.getRosterSize()>1)
};
ZmChat.prototype.removeRosterItem=function(t,e){
this._rosterItemList.removeItem(t)
};
ZmChat.prototype.getRosterSize=function(){
return this._rosterItemList.size()
};
ZmChat.prototype.getName=function(){
return this._chatName
};
ZmChat.prototype.getConfThread=function(){
if(this._thread){
return this._thread
}
return AjxDispatcher.run("GetRoster").getMyAddress()+new Date().getTime()
};
ZmChat.prototype.getThread=function(){
return this._thread
};
ZmChat.prototype.setThread=function(e){
this._thread=e
};
ZmChat.prototype.setName=function(e){
this._chatName=e
};
ZmChat.prototype.setTyping=function(a,t){
var e={};
e[ZmChat.F_TYPING]=t;
this._notify(ZmEvent.E_MODIFY,{
item:a,fields:e}
)
};
ZmChat.prototype.getDisplayName=function(s,a){
if(!s){
return ZmMsg.imSystem
}
var n=AjxDispatcher.run("GetRoster").getRosterItem(s);
var t;
if(n){
t=n.getDisplayName()
}else{
var e=a?null:this._rosterItemList.getByAddr(s);
var t=e?e.getDisplayName():s;
if(a||this._rosterItemList.size()==1){
var o=t.indexOf("@");
if(o!=-1){
t=t.substring(0,o)
}}}
return t
};
ZmChat.prototype.isGroupChat=function(){
return this._isGroupChat
};
ZmChat.prototype.hasRosterAddr=function(e){
return this._rosterItemList.getByAddr(e)
};
ZmChat.prototype.getRosterItem=function(e){
if(e==null){
e=0
}
return this._rosterItemList.getArray()[e]
};
ZmChat.prototype.isZimbraAssistant=function(){
return(this._rosterItemList.size()==1&&this.getRosterItem(0).getAddress()==ZmAssistantBuddy.ADDR)
};
ZmChat.prototype.getIcon=function(){
return this.getRosterItem().getPresence().getIcon()
};
ZmChat.prototype.getTitle=function(){
return[ZmMsg.zimbraTitle,AjxMessageFormat.format(ZmMsg.chatWith,[this.getRosterItem(0).getDisplayName()])].join(": ")
};
ZmChat.prototype.getStatusTitle=function(){};
ZmChat.prototype.addMessage=function(t){
this.messages.push(t);
this._historyIndex=this.messages.length;
var e={};
e[ZmChat.F_MESSAGE]=t;
this._notify(ZmEvent.E_MODIFY,{
fields:e}
)
};
ZmChat.prototype.resetUnread=function(){
this._unread=0;
if(this.getRosterSize()==1){
this.getRosterItem(0).setUnread(0)
}};
ZmChat.prototype.getUnread=function(){
return this._unread
};
ZmChat.prototype.incUnread=function(){
++this._unread;
if(this.getRosterSize()==1){
this.getRosterItem(0).setUnread(this._unread)
}
return this._unread
};
ZmChat.prototype.sendClose=function(){
if(this._thread){
ZmImApp.INSTANCE.getService().closeChat(this)
}};
ZmChat.prototype.sendMessage=function(n,a,i){
var t={
callback:this._sendMessageCallbackObj,noBusyOverlay:true};
ZmImApp.INSTANCE.getService().sendMessage(this,n,a,i,t);
if(n||a){
var e=a?{
_content:a,html:true}
:{
_content:n,html:false};
var s={
thread:this._thread,from:AjxDispatcher.run("GetRoster").getMyAddress(),to:this.getRosterItem(0).getAddress(),ts:new Date().getTime(),body:[e]};
var o=new ZmChatMessage(s,true,false)
}
return o
};
ZmChat.prototype.sendByEmail=function(a){
var i=this._rosterItemList.getVector().map("getContact").map("getEmail").join(AjxEmailAddress.SEPARATOR);
var t,e=AjxVector.fromArray(this.messages);
if(a==DwtHtmlEditor.HTML){
t=e.map("toHtml").join("<br/>")
}else{
t=e.map("toText").join("\n")
}
AjxDispatcher.run("Compose",{
action:ZmOperation.NEW_MESSAGE,toOverride:i,subjOverride:this.getTitle(),composeMode:a,extraBodyText:t}
)
};
ZmChat.prototype.getHistory=function(e){
while(true){
this._historyIndex+=e;
if(this._historyIndex<0){
this._historyIndex=-1
}
if(this._historyIndex>=this.messages.length){
this._historyIndex=this.messages.length
}
var t=this.messages[this._historyIndex];
if(!t||t.fromMe){
break
}}
return t&&t.body
};
ZmChat.prototype._sendMessageCallback=function(e){
try{
var t=e.getResponse();
this.setThread(t.IMSendMessageResponse.thread)
}
catch(a){
appCtxt.setStatusMsg(a,ZmStatusView.LEVEL_CRITICAL)
}}
}
if(AjxPackage.define("zimbraMail.im.model.ZmChatList")){
ZmChatList=function(e){
ZmList.call(this,ZmItem.CHAT);
this._roster=e
};
ZmChatList.prototype=new ZmList;
ZmChatList.prototype.constructor=ZmChatList;
ZmChatList.prototype.toString=function(){
return"ZmChatList"
};
ZmChatList.prototype.addChat=function(e,t){
this.add(e);
this._notify(ZmEvent.E_CREATE,{
items:[e],background:t}
)
};
ZmChatList.prototype.removeChat=function(e){
this.remove(e);
this._notify(ZmEvent.E_DELETE,{
items:[e]}
)
};
ZmChatList.prototype.getChatByRosterItem=function(a,n){
var s=a.getAddress();
if(!a.isDefaultBuddy()){
return this.getChatByRosterAddr(s,n)
}
var o=this.getArray();
var e;
for(var t=0;
t<o.length;
t++){
e=o[t];
if(e.getRosterSize()==1&&e.hasRosterAddr(s)){
return e
}}
if(!n){
return null
}
e=new ZmChat(Dwt.getNextId(),a.getDisplayName(),this);
e.addRosterItem(a);
this.addChat(e);
return e
};
ZmChatList.prototype.getChatByRosterAddr=function(h,r,o){
var s=this.getArray();
var e;
for(var a=0;
a<s.length;
a++){
e=s[a];
if(e.getRosterSize()==1&&e.hasRosterAddr(h)){
return e
}}
if(!r){
return null
}
var n=this._roster.getRosterItem(h);
if(n==null){
var t=new ZmRosterPresence(ZmRosterPresence.SHOW_UNKNOWN);
n=new ZmRosterItem(h,this,h,t,null)
}
e=new ZmChat(Dwt.getNextId(),n.getDisplayName(),this);
e.addRosterItem(n);
this.addChat(e,o);
return e
};
ZmChatList.prototype.getChatsByRosterAddr=function(n){
var a=[];
var o=this.getArray();
for(var t=0;
t<o.length;
t++){
var e=o[t];
if(e.hasRosterAddr(n)){
a.push(e)
}}
return a
};
ZmChatList.prototype.getChatByThread=function(e){
var o=this.getArray();
for(var a=0;
a<o.length;
a++){
var t=o[a];
if(t.getThread()==e){
return t
}}
return null
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmChatMessage")){
ZmChatMessage=function(t,a,e){
if(t){
this.subject=t.subject;
if(t.body!=null&&t.body.length>0){
this.body=t.body[0]._content;
this.isHtml=t.body[0].html
}
this.from=t.from;
this.to=t.to;
this.thread=t.thread;
this.ts=t.ts;
this.error=t.error
}
if(!this.ts){
this.ts=new Date().getTime()
}
this.fromMe=a;
this.isSystem=e;
this.htmlEncode=!this.isHtml
};
ZmChatMessage.prototype.constructor=ZmChatMessage;
ZmChatMessage.prototype.toString=function(){
return"ZmChatMessage - from("+this.from+") body("+this.body+")"
};
ZmChatMessage.system=function(e){
var t=new ZmChatMessage(null,false,true);
t.body=e;
return t
};
ZmChatMessage.prototype.getShortTime=function(){
var e=AjxDateFormat.getTimeInstance(AjxDateFormat.SHORT);
return e.format(new Date(this.ts))
};
ZmChatMessage.prototype.toText=function(){
return AjxStringUtil.trim(AjxTemplate.expand("im.Chat#ChatMessagePlainText",this))
};
ZmChatMessage.prototype.toHtml=function(){
return AjxStringUtil.trim(AjxTemplate.expand("im.Chat#ChatMessageHTML",this))
};
ZmChatMessage.prototype.getHtmlBody=function(){
return this.htmlEncode?AjxStringUtil.htmlEncode(this.body,true).replace(/\r?\n/g,"<br/>"):this.body
};
ZmChatMessage.prototype.getTextBody=function(){
return this.isHtml?AjxStringUtil.convertHtml2Text(this.body):this.body
};
ZmChatMessage.prototype.displayHtml=function(t,o){
var e=this.getHtmlBody();
var i={
isSystem:this.isSystem,fromMe:this.fromMe,shortTime:AjxStringUtil.htmlEncode(this.getShortTime()),body:e||"&nbsp;"};
if(!o||o!=this.from){
i.displayName=AjxStringUtil.htmlEncode(t.getDisplayName(this.from,this.fromMe))
}
var a=[];
if(o&&o!=this.from){
a.push("<div class='ZmChatWindowChatEntry-sep'>&nbsp;</div>")
}
a.push(AjxTemplate.expand("im.Chat#ChatMessageLine",i));
return a.join("")
};
ZmChatMessage.prototype.getErrorMessage=function(){
return ZMsg["im."+this.error]||ZMsg["im.unknown_error"]
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmImPrivacyList")){
ZmImPrivacyList=function(t,e){
this._roster=t;
this._list=[];
this._name=e||"default"
};
ZmImPrivacyList.prototype.block=function(e){
if(this._parseAddr(e).uid){
return this.blockBuddy(e)
}
return this.blockDomain(e)
};
ZmImPrivacyList.prototype.unblock=function(e){
if(this._parseAddr(e).uid){
return this.unblockBuddy(e)
}
return this.unblockDomain(e)
};
ZmImPrivacyList.prototype.allow=function(e){
if(this._parseAddr(e).uid){
return this.allowBuddy(e)
}
return this.allowDomain(e)
};
ZmImPrivacyList.prototype.blockBuddy=function(e){
this._purge(e);
e=this._parseAddr(e);
e.type="deny";
this._list.unshift(e);
this._notifyBuddyChanges([e])
};
ZmImPrivacyList.prototype.unblockBuddy=function(e){
this._purge(e,"deny");
this._notifyBuddyChanges([e])
};
ZmImPrivacyList.prototype.allowBuddy=function(e){
this._purge(e);
e=this._parseAddr(e);
e.type="allow";
this._list.unshift(e);
this._notifyBuddyChanges([e])
};
ZmImPrivacyList.prototype.blockDomain=function(e){
return this.blockBuddy(e)
};
ZmImPrivacyList.prototype.unblockDomain=function(e){
return this.unblockBuddy(e)
};
ZmImPrivacyList.prototype.allowDomain=function(e){
return this.allowBuddy(e)
};
ZmImPrivacyList.prototype._purge=function(s,o){
var e=this._list;
for(var t=e.length;
--t>=0;
){
var n=e[t];
if(n.addr==s&&(!o||n.type==o)){
e.splice(t,1)
}}};
ZmImPrivacyList.prototype.isAllowed=function(t){
var e=this._is(t,"allow");
if(e==null){
e=true
}
return e
};
ZmImPrivacyList.prototype.isDenied=function(t){
var e=this._is(t,"deny");
if(e==null){
e=false
}
return e
};
ZmImPrivacyList.prototype._is=function(l,s){
var e=this._list;
var n=this._parseAddr(l);
for(var o=0;
o<e.length;
++o){
var h=e[o];
if(h.addr==l||(!h.uid&&h.domain==n.domain)){
return h.type==s
}}
return null
};
ZmImPrivacyList.prototype.toSoap=function(s){
var e=this._list;
var t=[];
for(var o=0;
o<e.length;
++o){
var n=e[o];
t.push({
"!action":n.type,"!order":o+1,"!addr":n.addr}
)
}
s.set("list",{
"!name":this._name,item:t}
)
};
ZmImPrivacyList.prototype.reset=function(e){
this._list=[];
if(e){
var a=[];
for(var t=0;
t<e.length;
++t){
var o=e[t];
var n=this._parseAddr(o.addr);
n.type=o.action;
this._list.push(n);
a.push(o.addr)
}
this._notifyBuddyChanges(a)
}};
ZmImPrivacyList.prototype._notifyBuddyChanges=function(a){
for(var t=0;
t<a.length;
++t){
var e=this._roster.getRosterItem(a[t].addr);
if(e){
e._notifyPresence()
}}};
ZmImPrivacyList.parseAddr=function(t){
var e=t.indexOf("@");
if(e>=0){
return{
uid:t.substr(0,e),domain:t.substr(e+1),addr:t}
}else{
return{
uid:null,domain:t,addr:t}
}};
ZmImPrivacyList.prototype._parseAddr=ZmImPrivacyList.parseAddr
}
if(AjxPackage.define("zimbraMail.im.controller.ZmImServiceController")){
ZmImServiceController=function(o,e){
if(arguments.length==0){
return
}
this._roster=o;
this.service=null;
this.capabilities={};
for(var t=0,a=e?e.length:0;
t<a;
t++){
this.capabilities[e[t]]=true
}};
ZmImServiceController.ACCOUNTS="ACCOUNTS";
ZmImServiceController.CONFERENCES="INSTANT_NOTIFY";
ZmImServiceController.AUTO_LOGIN_PREF="AUTO_LOGIN_PREF";
ZmImServiceController.INSTANT_NOTIFY="INSTANT_NOTIFY";
ZmImServiceController.prototype.login=function(e){
alert("Not implemented")
};
ZmImServiceController.prototype.getMyPresenceTooltip=function(e){
alert("Not implemented")
};
ZmImServiceController.prototype.defineStatusMenu=function(){
alert("Not implemented")
}
}
if(AjxPackage.define("zimbraMail.im.controller.ZmZimbraImServiceController")){
ZmZimbraImServiceController=function(t){
var e=[ZmImServiceController.ACCOUNTS,ZmImServiceController.CONFERENCES,ZmImServiceController.AUTO_LOGIN_PREF,ZmImServiceController.INSTANT_NOTIFY];
ZmImServiceController.call(this,t,e);
this.service=new ZmZimbraImService(t)
};
ZmZimbraImServiceController.prototype=new ZmImServiceController;
ZmZimbraImServiceController.prototype.constructor=ZmZimbraImServiceController;
ZmZimbraImServiceController.prototype.toString=function(){
return"ZmZimbraImServiceController"
};
ZmZimbraImServiceController.prototype.login=function(e){
if(!this._showedJive){
this._chatListChangeListenerObj=new AjxListener(this,this._chatListChangeListener);
ZmImApp.INSTANCE.getRoster().getChatList().addChangeListener(this._chatListChangeListenerObj)
}
this.service.login(e)
};
ZmZimbraImServiceController.prototype.getMyPresenceTooltip=function(e){
this._presenceTooltipFormat=this._presenceTooltipFormat||new AjxMessageFormat(ZmMsg.presenceTooltip);
return this._presenceTooltipFormat.format(e)
};
ZmZimbraImServiceController.prototype.defineStatusMenu=function(){
return{
statuses:[ZmOperation.IM_PRESENCE_OFFLINE,ZmOperation.IM_PRESENCE_ONLINE,ZmOperation.IM_PRESENCE_CHAT,ZmOperation.IM_PRESENCE_DND,ZmOperation.IM_PRESENCE_AWAY,ZmOperation.IM_PRESENCE_XA]}
};
ZmZimbraImServiceController.prototype._chatListChangeListener=function(t){
if(!this._showedJive&&(t.event==ZmEvent.E_CREATE)){
this._showedJive=true;
ZmImApp.INSTANCE.getRoster().getChatList().removeChangeListener(this._chatListChangeListenerObj);
delete this._chatListChangeListenerObj;
var e={
msg:AjxTemplate.expand("im.Chat#JiveNotification"),transitions:[{
type:"fade-in",duration:500}
,{
type:"pause",duration:5000}
,{
type:"fade-out",duration:500}
]};
appCtxt.setStatusMsg(e)
}}
}};
