
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("PreferencesCore")){
if(AjxPackage.define("zimbraMail.prefs.model.ZmPref")){
ZmPref=function(a,t,e){
ZmSetting.call(this,a,t,ZmSetting.T_PREF,e);
this.origValue=null;
this.isDirty=false
};
ZmPref.prototype=new ZmSetting;
ZmPref.prototype.constructor=ZmPref;
ZmPref.KEY_ID="prefId_";
ZmPref.TYPE_STATIC="STATIC";
ZmPref.TYPE_INPUT="INPUT";
ZmPref.TYPE_CHECKBOX="CHECKBOX";
ZmPref.TYPE_COLOR="COLOR";
ZmPref.TYPE_RADIO_GROUP="RADIO_GROUP";
ZmPref.TYPE_SELECT="SELECT";
ZmPref.TYPE_COMBOBOX="COMBOBOX";
ZmPref.TYPE_TEXTAREA="TEXTAREA";
ZmPref.TYPE_PASSWORD="PASSWORD";
ZmPref.TYPE_IMPORT="IMPORT";
ZmPref.TYPE_EXPORT="EXPORT";
ZmPref.TYPE_SHORTCUTS="SHORTCUTS";
ZmPref.TYPE_CUSTOM="CUSTOM";
ZmPref.TYPE_LOCALES="LOCALES";
ZmPref.ORIENT_VERTICAL="vertical";
ZmPref.ORIENT_HORIZONTAL="horizontal";
ZmPref.MAX_ROWS=7;
ZmPref.loadSkins=function(e){
var n=appCtxt.get(ZmSetting.AVAILABLE_SKINS);
e.options=[];
for(var t=0;
t<n.length;
t++){
var a=n[t];
e.options.push(a);
var o=ZmMsg["theme-"+a]||a.substr(0,1).toUpperCase()+a.substr(1);
e.displayOptions.push(o)
}};
ZmPref.loadCsvFormats=function(t){
var e=appCtxt.get(ZmSetting.AVAILABLE_CSVFORMATS);
if(!e._options){
var a=e._options=[];
var n=e._displayOptions=[];
for(var o=0;
o<e.length;
o++){
a.push(e[o])
}
a.sort(ZmPref.__BY_CSVFORMAT);
for(var o=0;
o<a.length;
o++){
n.push((ZmMsg[a[o]]||a[o]))
}}
t.options=e._options;
t.displayOptions=e._displayOptions
};
ZmPref.__BY_CSVFORMAT=function(t,e){
if(t.match(/^zimbra/)){
return -1
}
if(e.match(/^zimbra/)){
return 1
}
if(t.match(/^yahoo/)){
return -1
}
if(e.match(/^yahoo/)){
return 1
}
return t.localeCompare(e)
};
ZmPref.loadPageSizes=function(t){
var e=(t.maxSetting&&appCtxt.get(t.maxSetting))||100;
var n=[];
for(var o=0;
o<ZmPref.PAGE_SIZES.length;
o++){
var a=parseInt(ZmPref.PAGE_SIZES[o]);
if(a<=e){
n.push(ZmPref.PAGE_SIZES[o])
}}
if(e>ZmPref.PAGE_SIZES[ZmPref.PAGE_SIZES.length-1]){
n.push(String(e))
}
t.displayOptions=t.options=n
};
ZmPref.PAGE_SIZES=["10","25","50","100","250","500","1000"];
ZmPref.validateEmail=function(e){
if(e){
return e.match(/\@localhost$/i)||AjxEmailAddress.parse(e)!=null
}
return true
};
ZmPref.validateEmailList=function(e){
for(var t in e){
if(!ZmPref.validateEmail(e[t])){
return false
}}
return true
};
ZmPref.downloadSinceDisplay=function(e){
if(e==""){
return 0
}
if(e==appCtxt.get(ZmSetting.POP_DOWNLOAD_SINCE)){
return 1
}
return 2
};
ZmPref.downloadSinceValue=function(t){
if(t==0){
return""
}
if(t==1){
return appCtxt.get(ZmSetting.POP_DOWNLOAD_SINCE)
}
var e=new Date();
e.setMinutes(e.getMinutes()+e.getTimezoneOffset());
return AjxDateFormat.format("yyyyMMddHHmmss'Z'",e)
};
ZmPref.validatePollingInterval=function(e){
var a=appCtxt.get(ZmSetting.MIN_POLLING_INTERVAL);
if(e&&a&&e>=a){
return true
}else{
var t=a/60;
ZmPref.SETUP[ZmSetting.POLLING_INTERVAL].errorMessage=AjxMessageFormat.format(ZmMsg.invalidPollingInterval,t);
return false
}};
ZmPref.pollingIntervalDisplay=function(e){
if(appCtxt.get(ZmSetting.INSTANT_NOTIFY)&&e==appCtxt.get(ZmSetting.INSTANT_NOTIFY_INTERVAL)){
return e
}else{
return e/60
}};
ZmPref.pollingIntervalValue=function(e){
if(appCtxt.get(ZmSetting.INSTANT_NOTIFY)&&e==appCtxt.get(ZmSetting.INSTANT_NOTIFY_INTERVAL)){
return e
}else{
return e*60
}};
ZmPref.dateLocal2GMT=function(c){
if(!c){
return""
}
var u,t,m,d,r,h;
u=parseInt(c.substr(0,4),10);
t=parseInt(c.substr(4,2),10);
m=parseInt(c.substr(6,2),10);
d=parseInt(c.substr(8,2),10);
r=parseInt(c.substr(10,2),10);
h=parseInt(c.substr(12,2),10);
var o=new Date(u,t-1,m,d,r,h,0);
u=o.getUTCFullYear();
t=o.getUTCMonth()+1;
m=o.getUTCDate();
d=o.getUTCHours();
r=o.getUTCMinutes();
h=o.getUTCSeconds();
var l=[u,t,m,d,r,h];
for(var s=l.length;
--s>0;
){
var e=l[s];
if(e<10){
l[s]="0"+e
}}
return(l.join("")+"Z")
};
ZmPref.dateGMT2Local=function(c){
if(!c){
return""
}
var u,t,m,d,r,h;
u=parseInt(c.substr(0,4),10);
t=parseInt(c.substr(4,2),10);
m=parseInt(c.substr(6,2),10);
d=parseInt(c.substr(8,2),10);
r=parseInt(c.substr(10,2),10);
h=parseInt(c.substr(12,2),10);
var o=new Date();
o.setUTCMilliseconds(0);
o.setUTCSeconds(h);
o.setUTCMinutes(r);
o.setUTCHours(d);
o.setUTCDate(m);
o.setUTCMonth(t-1);
o.setUTCFullYear(u);
u=o.getFullYear();
t=o.getMonth()+1;
m=o.getDate();
d=o.getHours();
r=o.getMinutes();
h=o.getSeconds();
var l=[u,t,m,d,r,h];
for(var s=l.length;
--s>0;
){
var e=l[s];
if(e<10){
l[s]="0"+e
}}
return(l.join("")+"Z")
};
ZmPref.int2DurationDay=function(e){
return e!=null&&e!=0?e+"d":e
};
ZmPref.string2EmailList=function(o){
var n=[];
var s,a=AjxEmailAddress.split(o);
if(a&&a.length){
for(var t=0;
t<a.length;
t++){
s=a[t];
var e=AjxEmailAddress.parse(s);
if(e){
s=e.getAddress()
}
if(s){
n.push(AjxStringUtil.htmlEncode(s))
}}}
return n
};
ZmPref.durationDay2Int=function(e){
return parseInt(e,10)
};
ZmPref.approximateInterval=function(t){
var e=[].concat(ZmPref.SETUP.POLLING_INTERVAL.options);
e.sort(ZmPref.__BY_NUMBER);
return ZmPref.approximateValue(e,t)
};
ZmPref.approximateValue=function(n,h){
for(var r=0;
r<n.length+1;
r++){
var t=n[r];
var e=n[r+1];
if(h<e){
var s=h-t;
var o=e-h;
return s<o?t:e
}}
return n[n.length-1]
};
ZmPref.validateLifetime=function(t){
var e=appCtxt.get(ZmSetting.MAIL_LIFETIME_GLOBAL);
if(e=="0"){
return true
}
return ZmPref.__BY_DURATION(t,e)<=0
};
ZmPref.validateLifetimeJunk=function(t){
var e=appCtxt.get(ZmSetting.MAIL_LIFETIME_JUNK_GLOBAL);
if(e=="0"){
return true
}
return ZmPref.__BY_DURATION(t,e)<=0&&ZmPref.validateLifetime(t)
};
ZmPref.validateLifetimeTrash=function(t){
var e=appCtxt.get(ZmSetting.MAIL_LIFETIME_TRASH_GLOBAL);
if(e=="0"){
return true
}
return ZmPref.__BY_DURATION(t,e)<=0&&ZmPref.validateLifetime(t)
};
ZmPref.approximateLifetimeInboxRead=function(e){
return ZmPref.approximateLifetime("MAIL_LIFETIME_INBOX_READ",e,ZmPref.validateLifetime)
};
ZmPref.approximateLifetimeInboxUnread=function(e){
return ZmPref.approximateLifetime("MAIL_LIFETIME_INBOX_UNREAD",e,ZmPref.validateLifetime)
};
ZmPref.approximateLifetimeJunk=function(e){
return ZmPref.approximateLifetime("MAIL_LIFETIME_JUNK",e,ZmPref.validateLifetimeJunk,ZmPref.validateLifetime)
};
ZmPref.approximateLifetimeSent=function(e){
return ZmPref.approximateLifetime("MAIL_LIFETIME_SENT",e,ZmPref.validateLifetime)
};
ZmPref.approximateLifetimeTrash=function(e){
return ZmPref.approximateLifetime("MAIL_LIFETIME_TRASH",e,ZmPref.validateLifetimeTrash,ZmPref.validateLifetime)
};
ZmPref.approximateLifetime=function(n,e,a){
var h=[].concat(ZmPref.SETUP[n].options);
for(var o=0;
o<h.length;
o++){
var r=h[o];
h[o]=ZmPref.__DUR2SECS(r!="0"?r+"d":r)
}
h.sort(ZmPref.__BY_NUMBER);
valuesLoop:for(var o=h.length-1;
o>=0;
o--){
for(var t=2;
t<arguments.length;
t++){
var l=arguments[t];
var r=ZmPref.__SECS2DUR(h[o]);
if(!l(r)){
h.pop();
continue valuesLoop
}}
break
}
var s;
if(e=="0"){
s=h[h.length-1]
}else{
s=ZmPref.approximateValue(h,ZmPref.__DUR2SECS(e+"d"))
}
e=ZmPref.__SECS2DUR(s);
return e!="0"?parseInt(e,10):0
};
ZmPref.markMsgReadDisplay=function(e){
return(e>0)?1:e
};
ZmPref.markMsgReadValue=function(t){
if(t==ZmSetting.MARK_READ_TIME){
var e=Dwt.byId(DwtId._makeId(ZmId.WIDGET_INPUT,ZmId.OP_MARK_READ));
if(e){
return e.value
}}
return t
};
ZmPref.setFormValue=function(e,a){
var o=appCtxt.getApp(ZmApp.PREFERENCES);
var i=ZmPref.getPrefSectionWithPref(e);
if(o&&i){
var t=o.getPreferencesPage(i.id);
if(t){
t.setFormValue(e,a)
}}};
ZmPref.getFormValue=function(e){
var i=appCtxt.getApp(ZmApp.PREFERENCES);
var a=ZmPref.getPrefSectionWithPref(e);
if(i&&a){
var t=i.getPreferencesPage(a.id);
if(t){
return t.getFormValue(e)
}}};
ZmPref.setIncludeOrig=function(l,n,i){
l.setValue(n);
l.origValue=l.copyValue();
var t=[ZmSetting.REPLY_INCLUDE_WHAT,ZmSetting.REPLY_USE_PREFIX,ZmSetting.REPLY_INCLUDE_HEADERS];
var a=AjxUtil.arrayAsHash(t);
var o=ZmSetting.REPLY_INCLUDE_ORIG;
if(!a[l.id]){
t=[ZmSetting.FORWARD_INCLUDE_WHAT,ZmSetting.FORWARD_USE_PREFIX,ZmSetting.FORWARD_INCLUDE_HEADERS];
o=ZmSetting.FORWARD_INCLUDE_ORIG
}
var r=AjxUtil.map(t,function(c){
return appCtxt.get(c)
}
);
var s=(r[0]==ZmSetting.INC_NONE||r[0]==ZmSetting.INC_ATTACH)?r[0]:r.join("|");
var e=ZmMailApp.INC_MAP_REV[s];
var h=appCtxt.getSettings().getSetting(o);
h.setValue(e);
i.push(h)
};
ZmPref.initIncludeWhat=function(e,t){
AjxTimedAction.scheduleAction(new AjxTimedAction(this,function(){
ZmPref._showIncludeOptions(e,(t==ZmSetting.INC_BODY||t==ZmSetting.INC_SMART))
}
),100)
};
ZmPref.onChangeIncludeWhat=function(i){
var e=i._args.newValue;
var a=i._args.oldValue;
var o=(e==ZmSetting.INC_BODY||e==ZmSetting.INC_SMART);
var t=(a==ZmSetting.INC_BODY||a==ZmSetting.INC_SMART);
if(o!=t){
ZmPref._showIncludeOptions(i._args.selectObj,o)
}};
ZmPref._showIncludeOptions=function(e,t){
var a=(e._name==ZmSetting.REPLY_INCLUDE_WHAT)?[ZmSetting.REPLY_USE_PREFIX,ZmSetting.REPLY_INCLUDE_HEADERS]:[ZmSetting.FORWARD_USE_PREFIX,ZmSetting.FORWARD_INCLUDE_HEADERS];
for(var o=0;
o<a.length;
o++){
var n=e.parent._dwtObjects[a[o]];
if(n){
n.setVisible(t)
}}};
ZmPref.getSendToFiltersActive=function(e,t){
if(e.target.checked){
if(t){
t.run(false)
}
return false
}
AjxDispatcher.run("GetFilterController").hasOutgoingFiltersActive(t)
};
ZmPref.onChangeDefaultApp=function(e){
if(window.isNodeWebkit&&NodeWebkitUtils.isWindows()){
var a=DwtControl.getTargetControl(e);
if(!a||a.isSelected()){
return
}
var t=require("os"),o=t.release().split(".");
var i=appCtxt.getMsgDialog();
i.registerCallback(DwtDialog.OK_BUTTON,ZmPref._handleOnChangeDefaultOk,this,[i]);
i.setMessage((parseInt(o[0],10)>=10)?ZmMsg.mailtoResetWin10:ZmMsg.mailtoReset,DwtMessageDialog.WARNING_STYLE);
i.popup()
}};
ZmPref._handleOnChangeDefaultOk=function(a){
var t=NodeWebkitMailto.isRegistered(),e=appCtxt.getSettings().getSetting(ZmSetting.OFFLINE_IS_MAILTO_HANDLER);
if(e.getValue()!=t){
e.setValue(t);
e.origValue=e.copyValue()
}
ZmPref.setFormValue(ZmSetting.OFFLINE_IS_MAILTO_HANDLER,t);
a.popdown()
};
ZmPref.onChangeConfirm=function(a,t,o,s,i){
var e=false;
var n=o?new AjxCallback(this,ZmPref._showOnChangeConfirm,[a,s]):null;
if(AjxUtil.isFunction(t)){
e=t(i,n)
}else{
if(AjxUtil.isInstance(t,AjxCallback)){
e=t.run(i,n)
}else{
e=t
}}
ZmPref._showOnChangeConfirm(a,s,e)
};
ZmPref._showOnChangeConfirm=function(a,i,e){
if(e){
if(e){
var t=appCtxt.getYesNoMsgDialog();
t.reset();
t.setMessage(a);
t.setButtonListener(DwtDialog.NO_BUTTON,new AjxListener(null,ZmPref._handleOnChangeConfirmNo,[i]));
t.popup()
}}};
ZmPref._handleOnChangeConfirmNo=function(e){
if(e){
e.run()
}
appCtxt.getYesNoMsgDialog().popdown()
};
ZmPref.__BY_NUMBER=function(t,e){
if(t==e){
return 0
}
if(t==Math.POSITIVE_INFINITY||e==Math.NEGATIVE_INFINITY){
return 1
}
if(e==Math.POSITIVE_INFINITY||t==Math.NEGATIVE_INFINITY){
return -1
}
return Number(t)-Number(e)
};
ZmPref.__BY_DURATION=function(t,e){
if(t==e){
return 0
}
if(t=="0"){
return 1
}
if(e=="0"){
return -1
}
var i=ZmPref.__DUR2SECS(t);
var o=ZmPref.__DUR2SECS(e);
return i-o
};
ZmPref.__DURMULT={
s:1,m:60,h:3600,d:86400};
ZmPref.__DURDIV={
86400:"d",3600:"h",60:"m",1:"s"};
ZmPref.__DUR2SECS=function(t){
if(t=="0"){
return Number.POSITIVE_INFINITY
}
var e=t.substring(t.length-1).toLowerCase();
return parseInt(t,10)*ZmPref.__DURMULT[e]
};
ZmPref.__SECS2DUR=function(i,t){
if(i==Number.POSITIVE_INFINITY){
return"0"
}
var a=ZmPref.__DURDIV;
if(t){
t={};
t[ZmPref.__DURMULT[t]]=t
}
for(var o in a){
var e=Math.floor(i/o);
if(e>0){
return[e,a[o]].join("")
}}
return"0"+t
};
ZmPref.MAX_LENGTH={};
ZmPref.MAX_LENGTH[ZmSetting.INITIAL_SEARCH]=512;
ZmPref.MAX_LENGTH[ZmSetting.SIGNATURE]=1024;
ZmPref.MAX_LENGTH[ZmSetting.AWAY_MESSAGE]=8192;
ZmPref.setPrefList=function(e,t){
ZmPref[e]=t
};
ZmPref.SETUP={};
ZmPref.registerPref=function(t,e){
ZmPref.SETUP[t]=e
};
ZmPref.clearPrefSections=function(){
ZmPref._prefSectionMap={};
ZmPref._prefSectionArray=null
};
ZmPref.registerPrefSection=function(a,t){
if(!a||!t){
return
}
var e=t.templateId||a;
if(!e.match(/#/)){
e=["prefs.Pages",e].join("#")
}
t.templateId=e;
t.id=a;
appCtxt.set(ZmSetting.PREF_SECTIONS,t,a);
ZmPref._prefSectionArray=null
};
ZmPref.unregisterPrefSection=function(e){
appCtxt.set(ZmSetting.PREF_SECTIONS,null,e);
ZmPref._prefSectionArray=null
};
ZmPref.getPrefSectionMap=function(){
return appCtxt.get(ZmSetting.PREF_SECTIONS)
};
ZmPref.getPrefSectionArray=function(){
if(!ZmPref._prefSectionArray){
ZmPref._prefSectionArray=[];
var e=appCtxt.get(ZmSetting.PREF_SECTIONS);
for(var t in e){
ZmPref._prefSectionArray.push(e[t])
}
ZmPref._prefSectionArray.sort(ZmPref.__BY_PRIORITY)
}
return ZmPref._prefSectionArray
};
ZmPref.getPrefSectionWithPref=function(o){
var t=appCtxt.get(ZmSetting.PREF_SECTIONS);
for(var a in t){
var n=t[a];
if(n.prefs==null){
continue
}
for(var e=0;
e<n.prefs.length;
e++){
if(n.prefs[e]==o){
return n
}}}
return null
};
ZmPref.requireAllPreConditions=function(o){
var a=appCtxt.getApp(ZmApp.PREFERENCES);
var e=a.getPrefController();
for(var t=0;
t<arguments.length;
t++){
if(!e.checkPreCondition(null,arguments[t])){
return false
}}
return true
};
ZmPref.clearPrefSections();
ZmPref.__BY_PRIORITY=function(t,e){
return Number(t.priority)-Number(e.priority)
}
}
if(AjxPackage.define("zimbraMail.prefs.model.ZmPrefPage")){
ZmPrefPage=function(e){
if(arguments.length==0){
return
}
e.type=e.type||ZmOrganizer.PREF_PAGE;
ZmOrganizer.call(this,e);
this.pageId=e.pageId;
this.icon=e.icon;
this.tooltip=e.tooltip
};
ZmPrefPage.prototype=new ZmOrganizer;
ZmPrefPage.prototype.constructor=ZmPrefPage;
ZmPrefPage.prototype.toString=function(){
return"ZmPrefPage"
};
ZmOrganizer.ORG_CLASS[ZmId.ORG_PREF_PAGE]="ZmPrefPage";
ZmPrefPage.createFromSection=function(a){
var e=appCtxt.getOverviewController();
var t=e.getTreeController(ZmOrganizer.PREF_PAGE);
var i={
id:ZmId.getPrefPageId(a.id),name:a.title,parent:null,tree:t.getDataTree(),icon:a.icon,tooltip:a.description};
return new ZmPrefPage(i)
};
ZmPrefPage.prototype.getIcon=function(){
return this.icon||"Preferences"
};
ZmPrefPage.prototype.getToolTip=function(e){
return this.tooltip||""
}
}
if(AjxPackage.define("zimbraMail.prefs.model.ZmPersona")){
ZmPersona=function(e,t){
if(arguments.length==0){
return
}
ZmAccount.call(this,ZmAccount.TYPE_PERSONA,e.id,null,t);
e.sendFromDisplay=e.sendFromDisplay||appCtxt.get(ZmSetting.DISPLAY_NAME);
e.sendFromAddress=e.sendFromAddress||appCtxt.get(ZmSetting.USERNAME);
this.identity=e
};
ZmPersona.prototype=new ZmAccount;
ZmPersona.prototype.constructor=ZmPersona;
ZmPersona.prototype.toString=function(){
return"ZmPersona"
};
ZmPersona.prototype.setName=function(e){
this.getIdentity().name=AjxStringUtil.htmlEncode(e)
};
ZmPersona.prototype.getName=function(){
return AjxStringUtil.htmlDecode(this.getIdentity().name)
};
ZmPersona.prototype.setEmail=function(e){
this.getIdentity().sendFromAddress=e
};
ZmPersona.prototype.getEmail=function(){
return this.getIdentity().sendFromAddress
};
ZmPersona.prototype.getIdentity=function(){
return this.identity
};
ZmPersona.prototype.create=function(a,t,e){
return this.getIdentity().create(a,t,e)
};
ZmPersona.prototype.save=function(a,t,e){
return this.getIdentity().save(a,t,e)
};
ZmPersona.prototype.doDelete=function(a,t,e){
return this.getIdentity().doDelete(a,t,e)
}
}
if(AjxPackage.define("zimbraMail.prefs.controller.ZmPrefPageTreeController")){
ZmPrefPageTreeController=function(){
ZmTreeController.apply(this,arguments)
};
ZmPrefPageTreeController.prototype=new ZmTreeController;
ZmPrefPageTreeController.prototype.constructor=ZmPrefPageTreeController;
ZmPrefPageTreeController.prototype.toString=function(){
return"ZmPrefPageTreeController"
};
ZmPrefPageTreeController.prototype.show=function(p){
var n=appCtxt.getApp(ZmApp.PREFERENCES);
var h=n.getPrefController().getPrefsView();
var e=p.account;
if(appCtxt.multiAccounts&&!this._currentAccount){
this._currentAccount=e
}
var l=new ZmTree(ZmOrganizer.PREF_PAGE);
var d=l.root=new ZmPrefPage({
id:ZmId.getPrefPageId(0),name:"",tree:l}
);
appCtxt.cacheSet(d.id,d);
var c=[];
var a=h.getNumTabs();
for(var m=0;
m<a;
m++){
var y=m+1;
var b=h.getTabTitle(y);
var o=h.getSectionForTab(y);
if(!e||this._showSection(e,o.id)){
var g=ZmPrefPage.createFromSection(o);
g.pageId=y;
g.account=e;
c.push(g)
}}
for(var m=0;
m<c.length;
m++){
var g=c[m];
var o=h.getSectionForTab(g.pageId);
var u=o.parentId;
if(appCtxt.isOffline&&(o.id=="SIGNATURES"||o.id=="ACCOUNTS"||o.id=="COMPOSING"||o.id=="FILTERS")){
u=null
}
var s=(u&&l.getById(ZmId.getPrefPageId(u)))||d;
s.children.add(g);
g.parent=s;
g.icon=o.icon||s.getIcon()
}
appCtxt.setTree(l.type,l,e);
var r=ZmTreeController.prototype.show.apply(this,arguments);
if(!appCtxt.multiAccounts||(appCtxt.multiAccounts&&e.isMain)){
var f=d.children.get(0);
if(f){
r.setSelected(f,true)
}}
if(!appCtxt.isOffline){
var t=r.getHeaderItem();
if(t){
t.setExpanded(true,true)
}}
r.addSelectionListener(this._handleTreeItemSelection.bind(this,h));
r.addPreSelectionListener(this._handleTreeItemPreSelection.bind(this,h));
return r
};
ZmPrefPageTreeController.prototype._showSection=function(t,e){
if(appCtxt.isOffline){
if(e=="MOBILE"){
return false
}
if(t.isMain){
if(e=="FILTERS"||e=="SHARING"||e=="SIGNATURES"||e=="ACCOUNTS"||e=="NOTIFICATIONS"||e=="TRUSTED_ADDR"){
return false
}}else{
if(e=="COMPOSING"||e=="AUTO_ARCHIVING"){
return false
}
if(!t.isZimbraAccount&&(e=="MAIL"||e=="SHARING"||e=="CALENDAR"||e=="NOTIFICATIONS"||e=="TRUSTED_ADDR")){
return false
}}}
return(t.isMain||(!t.isMain&&(e!="GENERAL"&&e!="SHORTCUTS"&&e!="PREF_ZIMLETS"&&e!="BACKUP"&&e!="COMPOSING")))
};
ZmPrefPageTreeController.prototype._dragListener=function(e){
e.operation=Dwt.DND_DROP_NONE
};
ZmPrefPageTreeController.prototype._dropListener=function(e){
e.doIt=false
};
ZmPrefPageTreeController.prototype._handleTreeItemSelection=function(t,a){
if(a.detail!=DwtTree.ITEM_SELECTED||a.handled){
return
}
var e=a.item.getData(Dwt.KEY_OBJECT);
t.switchToTab(e&&e.pageId)
};
ZmPrefPageTreeController.prototype._handleTreeItemPreSelection=function(a,i){
var t=i.item.getData(Dwt.KEY_OBJECT);
if(t.nId!="PREF_PAGE_FILTERS"){
return true
}
var e=appCtxt.get(ZmSetting.OFFLINE_REMOTE_SERVER_VERSION,null,t.account);
if(e&&e.substr(0,1)>7){
var o=appCtxt.getMsgDialog();
o.reset();
o.setMessage(ZmMsg.filtersDisabled,DwtMessageDialog.INFO_STYLE);
o.popup();
return false
}
return true
};
ZmPrefPageTreeController.prototype._handleMultiAccountItemSelection=function(s,h,a,l){
if(this._currentAccount!=l.account){
var i=appCtxt.getApp(ZmApp.PREFERENCES).getPrefController();
var e=i.getPrefsView();
this._currentAccount=i._activeAccount=l.account;
if(e.getChangedPrefs(true,true)){
s.handled=true;
var o=appCtxt.getYesNoCancelMsgDialog();
var n=[s,h,a,l,i,o];
var t=new AjxCallback(this,this._savePrefsYes,n);
var c=new AjxCallback(this,this._savePrefsNo,n);
var r=new AjxCallback(this,this._savePrefsCancel,o);
o.reset();
o.setMessage(ZmMsg.confirmExitPreferencesChangeAcct,DwtMessageDialog.WARNING_STYLE);
o.registerCallback(DwtDialog.YES_BUTTON,t,this);
o.registerCallback(DwtDialog.NO_BUTTON,c,this);
o.registerCallback(DwtDialog.CANCEL_BUTTON,r,this);
o.popup();
return
}else{
e.resetOnAccountChange()
}}
s.handled=false;
this._handleItemSelection(s,h,a,l)
};
ZmPrefPageTreeController.prototype._savePrefsYes=function(i,n,o,a,e,t){
t.popdown();
var s=new AjxCallback(this,this._continueTreeItemSelection,[i,n,o,a,e]);
e.save(s,true)
};
ZmPrefPageTreeController.prototype._savePrefsNo=function(i,n,o,a,e,t){
t.popdown();
e.getPrefsView().reset();
this._continueTreeItemSelection(i,n,o,a,e)
};
ZmPrefPageTreeController.prototype._savePrefsCancel=function(e){
e.popdown()
};
ZmPrefPageTreeController.prototype._continueTreeItemSelection=function(a,o,i,t,e){
e.getPrefsView().resetOnAccountChange();
this._handleItemSelection(a,o,i,t);
e.getPrefsView().switchToTab(t.pageId)
}
}
if(AjxPackage.define("ajax.dwt.widgets.DwtCalendar")){
DwtCalendar=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtCalendar.PARAMS);
e.className=e.className||"DwtCalendar";
DwtComposite.call(this,e);
this._skipNotifyOnPage=false;
this._hidePrevNextMo=e.hidePrevNextMo;
this._readOnly=e.readOnly;
this._showWeekNumber=e.showWeekNumber;
this._uuid=Dwt.getNextId();
var t=this._origDayClassName=e.className+"Day";
this._todayClassName=" "+e.className+"Day-today";
this._selectedDayClassName=" "+t+"-"+DwtCssStyle.SELECTED;
this._hoveredDayClassName=" "+t+"-"+DwtCssStyle.HOVER;
this._activeDayClassName=" "+t+"-"+DwtCssStyle.ACTIVE;
this._hiliteClassName=" "+t+"-hilited";
this._greyClassName=" "+t+"-grey";
if(!this._readOnly){
this._installListeners()
}
this._selectionMode=DwtCalendar.DAY;
this._init();
this._weekDays=new Array(7);
this._workingDays=e.workingDays||DwtCalendar._DEF_WORKING_DAYS;
this._useISO8601WeekNo=e.useISO8601WeekNo;
this.setFirstDayOfWeek(e.firstDayOfWeek||DwtCalendar.SUN);
this._forceRollOver=(e.forceRollOver!==false)
};
DwtCalendar.PARAMS=["parent","className","posStyle","firstDayOfWeek","forceRollOver","workingDaysArray","hidePrevNextMo","readOnly"];
DwtCalendar.prototype=new DwtComposite;
DwtCalendar.prototype.constructor=DwtCalendar;
DwtCalendar.SUN=0;
DwtCalendar.MON=1;
DwtCalendar.TUE=2;
DwtCalendar.WED=3;
DwtCalendar.THU=4;
DwtCalendar.FRI=5;
DwtCalendar.SAT=6;
DwtCalendar.DAY=1;
DwtCalendar.WEEK=2;
DwtCalendar.WORK_WEEK=3;
DwtCalendar.MONTH=4;
DwtCalendar.RANGE_CHANGE="DwtCalendar.RANGE_CHANGE";
DwtCalendar._FULL_WEEK=[1,1,1,1,1,1,1];
DwtCalendar._DEF_WORKING_DAYS=[0,1,1,1,1,1,0];
DwtCalendar._DAYS_IN_MONTH=[31,28,31,30,31,30,31,31,30,31,30,31];
DwtCalendar._NO_MONTH=-2;
DwtCalendar._PREV_MONTH=-1;
DwtCalendar._THIS_MONTH=0;
DwtCalendar._NEXT_MONTH=1;
DwtCalendar._NORMAL=1;
DwtCalendar._HOVERED=2;
DwtCalendar._ACTIVE=3;
DwtCalendar._SELECTED=4;
DwtCalendar._DESELECTED=5;
DwtCalendar.DATE_SELECTED=1;
DwtCalendar.DATE_DESELECTED=2;
DwtCalendar.DATE_DBL_CLICKED=3;
DwtCalendar._LAST_DAY_CELL_IDX=41;
DwtCalendar._BUTTON_CLASS="DwtCalendarButton";
DwtCalendar._BUTTON_HOVERED_CLASS=DwtCalendar._BUTTON_CLASS+"-"+DwtCssStyle.HOVER;
DwtCalendar._BUTTON_ACTIVE_CLASS=DwtCalendar._BUTTON_CLASS+"-"+DwtCssStyle.ACTIVE;
DwtCalendar._TITLE_CLASS="DwtCalendarTitle";
DwtCalendar._TITLE_HOVERED_CLASS=DwtCalendar._TITLE_CLASS+"-"+DwtCssStyle.HOVER;
DwtCalendar._TITLE_ACTIVE_CLASS=DwtCalendar._TITLE_CLASS+"-"+DwtCssStyle.ACTIVE;
DwtCalendar.prototype.toString=function(){
return"DwtCalendar"
};
DwtCalendar.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtCalendar.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtCalendar.prototype.addActionListener=function(e){
this.addListener(DwtEvent.ACTION,e)
};
DwtCalendar.prototype.removeActionListener=function(e){
this.removeListener(DwtEvent.ACTION,e)
};
DwtCalendar.prototype.addDateRangeListener=function(e){
this.addListener(DwtEvent.DATE_RANGE,e)
};
DwtCalendar.prototype.removeDateRangeListener=function(e){
this.removeListener(DwtEvent.DATE_RANGE,e)
};
DwtCalendar.prototype.setSkipNotifyOnPage=function(e){
this._skipNotifyOnPage=e
};
DwtCalendar.prototype.getSkipNotifyOnPage=function(){
return this._skipNotifyOnPage
};
DwtCalendar.prototype.setDate=function(i,s,a,t){
a=(a==null)?this._forceRollOver:a;
if(!i){
i=new Date()
}
var l=new Date(i.getTime());
var o=this._date;
var n=false;
var d=false;
var e;
if(this._date2CellId!=null){
var h=(l.getFullYear()*10000)+(l.getMonth()*100)+l.getDate();
var e=this._date2CellId[h];
if(e){
if(e==this._selectedCellId){
d=true
}
var c=document.getElementById(e);
if(c._dayType==DwtCalendar._THIS_MONTH){
d=true
}else{
if(a){
d=n=true
}else{
d=true
}}}else{
d=n=true
}}else{
d=n=true
}
if(d){
if(this._date){
if(AjxDateUtil.isDayShifted(l)){
AjxDateUtil.rollToNextDay(l)
}
l.setHours(this._date.getHours(),this._date.getMinutes(),this._date.getSeconds(),0)
}
this._date=l;
if(!n&&!this._readOnly){
this._setSelectedDate();
this._setToday()
}}
if(n){
this._layout()
}
if(d&&!s){
var r=t?DwtCalendar.DATE_DBL_CLICKED:DwtCalendar.DATE_SELECTED;
this._notifyListeners(DwtEvent.SELECTION,r,this._date)
}
return true
};
DwtCalendar.prototype.isSelected=function(t){
if(t==this._selectedDayElId){
return true
}else{
if(this._selectionMode!=DwtCalendar.DAY){
var e=this._getDayCellIndex(t);
if(Math.floor(e/7)==Math.floor(this._getDayCellIndex(this._selectedDayElId)/7)&&this._currWorkingDays[e%7]){
return true
}}}
return false
};
DwtCalendar.prototype.getForceRollOver=function(){
return this._forceRollOver
};
DwtCalendar.prototype.setForceRollOver=function(e){
if(e==null){
return
}
if(this._forceRollOver!=e){
this._forceRollOver=e;
this._layout()
}};
DwtCalendar.prototype.getSelectionMode=function(){
return this._selectionMode
};
DwtCalendar.prototype.setSelectionMode=function(e){
if(this._selectionMode==e){
return
}
this._selectionMode=e;
if(e==DwtCalendar.WEEK){
this._currWorkingDays=DwtCalendar._FULL_WEEK
}else{
if(e==DwtCalendar.WORK_WEEK){
this._currWorkingDays=this._workingDays
}}
this._layout()
};
DwtCalendar.prototype.setWorkingWeek=function(e){
this._workingDays=this._currWorkingDays=e;
if(this._selectionMode==DwtCalendar.WORK_WEEK){
this._layout()
}};
DwtCalendar.prototype.setHilite=function(s,a,t){
if(this._date2CellId==null){
return
}
var e;
var r;
if(t){
for(r in this._date2CellId){
e=document.getElementById(this._date2CellId[r]);
if(e._isHilited){
e._isHilited=false;
this._setClassName(e,DwtCalendar._NORMAL)
}}}
var n;
for(var o in s){
r=s[o];
n=this._date2CellId[r.getFullYear()*10000+r.getMonth()*100+r.getDate()];
if(n){
e=document.getElementById(n);
if(e._isHilited!=a){
e._isHilited=a;
this._setClassName(e,DwtCalendar._NORMAL)
}}}};
DwtCalendar.prototype.getDate=function(){
return this._date
};
DwtCalendar.prototype.setFirstDayOfWeek=function(e){
for(var a=0;
a<7;
a++){
this._weekDays[a]=(a<e)?(6-(e-a-1)):(a-e);
var t=document.getElementById(this._getDOWCellId(a));
t.innerHTML=AjxDateUtil.WEEKDAY_SHORT[(e+a)%7]
}
this._firstDayOfWeek=e;
this._layout()
};
DwtCalendar.prototype.getDateRange=function(){
return this._range
};
DwtCalendar.prototype._getDayCellId=function(e){
return("c:"+e+":"+this._uuid)
};
DwtCalendar.prototype._getDayCellIndex=function(e){
return e.substring(2,e.indexOf(":",3))
};
DwtCalendar.prototype._getDOWCellId=function(e){
return("w:"+e+":"+this._uuid)
};
DwtCalendar.prototype._getWeekNumberCellId=function(e){
return("k:"+e+":"+this._uuid)
};
DwtCalendar.prototype._getDaysInMonth=function(t,e){
if(t!=1){
return DwtCalendar._DAYS_IN_MONTH[t]
}
if(e%4!=0||(e%100==0&&e%400!=0)){
return 28
}
return 29
};
DwtCalendar.prototype._installListeners=function(){
this._setMouseEventHdlrs();
this.addListener(DwtEvent.ONMOUSEOVER,new AjxListener(this,this._mouseOverListener));
this.addListener(DwtEvent.ONMOUSEOUT,new AjxListener(this,this._mouseOutListener));
this.addListener(DwtEvent.ONMOUSEDOWN,new AjxListener(this,this._mouseDownListener));
this.addListener(DwtEvent.ONMOUSEUP,new AjxListener(this,this._mouseUpListener));
this.addListener(DwtEvent.ONDBLCLICK,new AjxListener(this,this._doubleClickListener))
};
DwtCalendar.prototype._notifyListeners=function(e,a,t,i){
if(!this.isListenerRegistered(e)){
return
}
var o=DwtShell.selectionEvent;
if(i){
DwtUiEvent.copy(o,i)
}else{
o.reset()
}
o.item=this;
o.detail=t;
o.type=a;
this.notifyListeners(e,o)
};
DwtCalendar.prototype._layout=function(){
if(this._date==null){
this._date=new Date()
}
if(!this._calWidgetInited){
this._init()
}
var p=new Date(this._date.getTime());
p.setDate(1);
var s=p.getFullYear();
var g=p.getMonth();
var n=p.getDay();
var a=this._getDaysInMonth(g,s);
var l=1;
var y=1;
this._date2CellId=new Object();
this._selectedDayElId=null;
var o,d,b,f,e;
if(!this._hidePrevNextMo){
if(g!=0){
o=this._getDaysInMonth(g-1,s)-this._weekDays[n]+1;
d=s;
b=g-1;
if(g!=11){
f=g+1;
e=s
}else{
f=0;
e=s+1
}}else{
o=this._getDaysInMonth(11,s-1)-this._weekDays[n]+1;
d=s-1;
b=11;
f=1;
e=s
}}
for(var c=0;
c<6;
c++){
for(var h=0;
h<7;
h++){
var m=document.getElementById(this._getDayCellId(c*7+h));
if(m._isHilited==null){
m._isHilited=false
}
if(l<=a){
if(c!=0||h>=this._weekDays[n]){
this._date2CellId[(s*10000)+(g*100)+l]=m.id;
m._day=l;
m._month=g;
m._year=s;
m.innerHTML=l++;
m._dayType=DwtCalendar._THIS_MONTH;
if(this._readOnly){
m.style.fontFamily="Arial";
m.style.fontSize="10px"
}}else{
if(this._hidePrevNextMo){
m.innerHTML=""
}else{
this._date2CellId[(d*10000)+(b*100)+o]=m.id;
m._day=o;
m._month=b;
m._year=d;
m.innerHTML=o++;
m._dayType=DwtCalendar._PREV_MONTH
}}}else{
if(!this._hidePrevNextMo){
this._date2CellId[(e*10000)+(f*100)+y]=m.id;
m._day=y;
m._month=f;
m._year=e;
m.innerHTML=y++;
m._dayType=DwtCalendar._NEXT_MONTH
}}
this._setClassName(m,DwtCalendar._NORMAL)
}
if(this._showWeekNumber){
var r=this._getWeekNumberCellId("kw"+c*7);
var u=document.getElementById(r);
if(u){
var t=document.getElementById(this._getDayCellId(c*7));
u.innerHTML=AjxDateUtil.getWeekNumber(new Date(t._year,t._month,t._day),this._firstDayOfWeek,null,this._useISO8601WeekNo)
}}}
this._setTitle(g,s);
if(!this._readOnly){
this._setSelectedDate();
this._setToday()
}
this._setRange()
};
DwtCalendar.prototype._setRange=function(){
var e=document.getElementById(this._getDayCellId(0));
var i=new Date(e._year,e._month,e._day,0,0,0,0);
e=document.getElementById(this._getDayCellId(DwtCalendar._LAST_DAY_CELL_IDX));
var a=this._getDaysInMonth(e._month,e._year);
var t;
if(e._day<a){
t=new Date(e._year,e._month,e._day+1,0,0,0,0)
}else{
if(e._month<11){
t=new Date(e._year,e._month+1,1,0,0,0,0)
}else{
t=new Date(e._year+1,0,1,0,0,0,0)
}}
if(this._range==null){
this._range={}
}else{
if(this._range.start.getTime()==i.getTime()&&this._range.end.getTime()==t.getTime()){
return false
}}
this._range.start=i;
this._range.end=t;
if(!this.isListenerRegistered(DwtEvent.DATE_RANGE)){
return
}
if(!this._dateRangeEvent){
this._dateRangeEvent=new DwtDateRangeEvent(true)
}
this._dateRangeEvent.item=this;
this._dateRangeEvent.start=i;
this._dateRangeEvent.end=t;
this.notifyListeners(DwtEvent.DATE_RANGE,this._dateRangeEvent)
};
DwtCalendar.prototype._setToday=function(){
var e;
var t=new Date();
var a=t.getDate();
if(!this._todayDay||this._todayDay!=a){
if(this._todayCellId!=null){
e=document.getElementById(this._todayCellId);
e._isToday=false;
this._setClassName(e,DwtCalendar._NORMAL)
}
this._todayCellId=this._date2CellId[(t.getFullYear()*10000)+(t.getMonth()*100)+a];
if(this._todayCellId!=null){
e=document.getElementById(this._todayCellId);
e._isToday=true;
this._setClassName(e,DwtCalendar._NORMAL)
}}};
DwtCalendar.prototype._setSelectedDate=function(){
var t=this._date.getDate();
var o=this._date.getMonth();
var a=this._date.getFullYear();
var e;
if(this._selectedDayElId){
e=document.getElementById(this._selectedDayElId);
this._setClassName(e,DwtCalendar._DESELECTED)
}
var i=this._date2CellId[(a*10000)+(o*100)+t];
e=document.getElementById(i);
this._selectedDayElId=i;
this._setClassName(e,DwtCalendar._SELECTED)
};
DwtCalendar.prototype._setCellClassName=function(t,a,i){
if(t._dayType!=DwtCalendar._THIS_MONTH){
a+=this._greyClassName
}
if(this._selectionMode==DwtCalendar.DAY&&t.id==this._selectedDayElId&&i!=DwtCalendar._DESELECTED){
a+=this._selectedDayClassName
}else{
if(this._selectionMode!=DwtCalendar.DAY&&i!=DwtCalendar._DESELECTED&&this._selectedDayElId!=null){
var e=this._getDayCellIndex(t.id);
if(Math.floor(this._getDayCellIndex(this._selectedDayElId)/7)==Math.floor(e/7)&&this._currWorkingDays[e%7]){
a+=this._selectedDayClassName
}}}
if(t._isHilited){
a+=this._hiliteClassName
}
if(t._isToday){
a+=this._todayClassName
}
return a
};
DwtCalendar.prototype._setClassName=function(e,s){
var a="";
if(s==DwtCalendar._NORMAL){
a=this._origDayClassName
}else{
if(s==DwtCalendar._HOVERED){
a=this._hoveredDayClassName
}else{
if(s==DwtCalendar._ACTIVE){
a=this._activeDayClassName
}else{
if(s==DwtCalendar._DESELECTED&&this._selectionMode==DwtCalendar.DAY){
a=this._origDayClassName
}else{
if(this._selectionMode!=DwtCalendar.DAY&&(s==DwtCalendar._SELECTED||s==DwtCalendar._DESELECTED)){
var n=Math.floor(this._getDayCellIndex(this._selectedDayElId)/7)*7;
for(var t=0;
t<7;
t++){
a=this._origDayClassName;
var o=document.getElementById(this._getDayCellId(n++));
o.className=this._setCellClassName(o,a,s)
}
return
}}}}}
e.className=this._setCellClassName(e,a,s)
};
DwtCalendar.prototype._setTitle=function(o,i){
var e=document.getElementById(this._monthCell);
var a=DwtCalendar.getMonthFormatter();
var t=new Date(i,o);
e.innerHTML=a.format(t)
};
DwtCalendar.prototype._init=function(){
var o=new Array(100);
var e=0;
this._monthCell="t:"+this._uuid;
o[e++]="<table width=100% cellspacing='0' cellpadding='0' style='border-collapse:collapse;'>";
o[e++]="<tr><td class=DwtCalendarTitlebar>";
o[e++]="<table width='100%' cellspacing='0' cellpadding='0'>";
o[e++]="<tr>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:py:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("FastRevArrowSmall",null,["id='b:py:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:pm:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("RevArrowSmall",null,["id='b:pm:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="<td align='center' class='DwtCalendarTitleCell' nowrap'><span class='";
o[e++]=DwtCalendar._TITLE_CLASS;
o[e++]="' id='";
o[e++]=this._monthCell;
o[e++]="'>&nbsp;</span></td>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:nm:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("FwdArrowSmall",null,["id='b:nm:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:ny:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("FastFwdArrowSmall",null,["id='b:ny:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="</tr>";
o[e++]="</table>";
o[e++]="</td></tr>";
o[e++]="<tr><td>";
o[e++]="<table cellspacing='0' cellpadding='1' width='100%'>";
o[e++]="<tr>";
if(this._showWeekNumber){
o[e++]="<td class='DwtCalendarWeekNoTitle' width='14%' id='";
o[e++]=this._getWeekNumberCellId("kw");
o[e++]="'>";
o[e++]=AjxMsg.calendarWeekTitle;
o[e++]="</td>"
}
for(var a=0;
a<7;
a++){
o[e++]="<td class='DwtCalendarDow' width='";
o[e++]=(a<5?"14%":"15%");
o[e++]="' id='";
o[e++]=this._getDOWCellId(a);
o[e++]="'>&nbsp;</td>"
}
o[e++]="</tr>";
for(var a=0;
a<6;
a++){
o[e++]=(AjxEnv.isLinux||AjxEnv.isMac)?"<tr style='line-height:12px'>":"<tr>";
if(this._showWeekNumber){
o[e++]="<td class='DwtCalendarWeekNo' id='"+this._getWeekNumberCellId("kw"+a*7)+"'>&nbsp;</td>"
}
for(var t=0;
t<7;
t++){
o[e++]="<td id='";
o[e++]=this._getDayCellId(a*7+t);
o[e++]="'>&nbsp;</td>"
}
o[e++]="</tr>"
}
o[e++]="</td></tr></table></table>";
this.getHtmlElement().innerHTML=o.join("");
if(!this._readOnly){
document.getElementById("b:py:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("FastRevArrowSmall");
document.getElementById("b:pm:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("RevArrowSmall");
document.getElementById("b:nm:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("FwdArrowSmall");
document.getElementById("b:ny:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("FastFwdArrowSmall")
}
this._calWidgetInited=true
};
DwtCalendar.prototype.setMouseOverDayCallback=function(e){
this._mouseOverDayCB=e
};
DwtCalendar.prototype.setMouseOutDayCallback=function(e){
this._mouseOutDayCB=e
};
DwtCalendar.prototype.getDndDate=function(){
var e=this._lastDndCell;
if(e){
return new Date(e._year,e._month,e._day)
}
return null
};
DwtCalendar._tmpDate=new Date();
DwtCalendar._tmpDate.setHours(0,0,0,0);
DwtCalendar.prototype._mouseOverListener=function(t){
var a=t.target;
if(a.id.charAt(0)=="c"){
this._setClassName(a,DwtCalendar._HOVERED);
if(this._mouseOverDayCB){
DwtCalendar._tmpDate.setFullYear(a._year,a._month,a._day);
this._mouseOverDayCB.run(this,DwtCalendar._tmpDate)
}}else{
if(a.id.charAt(0)=="t"){
return
}else{
if(a.id.charAt(0)=="b"){
var e;
if(a.firstChild==null){
e=a;
AjxImg.getParentElement(a).className=DwtCalendar._BUTTON_HOVERED_CLASS
}else{
a.className=DwtCalendar._BUTTON_HOVERED_CLASS;
e=AjxImg.getImageElement(a)
}
e.className=e._origClassName
}}}
t._stopPropagation=true
};
DwtCalendar.prototype._mouseOutListener=function(t){
this.setToolTipContent(null);
var a=t.target;
if(a.id.charAt(0)=="c"){
this._setClassName(a,DwtCalendar._NORMAL);
if(this._mouseOutDayCB){
this._mouseOutDayCB.run(this)
}}else{
if(a.id.charAt(0)=="b"){
var e;
a.className=DwtCalendar._BUTTON_CLASS;
if(a.firstChild==null){
e=a;
AjxImg.getParentElement(a).className=DwtCalendar._BUTTON_CLASS
}else{
a.className=DwtCalendar._BUTTON_CLASS;
e=AjxImg.getImageElement(a)
}
e.className=e._origClassName
}}};
DwtCalendar.prototype._mouseDownListener=function(t){
if(t.button==DwtMouseEvent.LEFT){
var a=t.target;
if(a.id.charAt(0)=="c"){
this._setClassName(a,DwtCalendar._ACTIVE)
}else{
if(a.id.charAt(0)=="t"){
a.className=DwtCalendar._TITLE_ACTIVE_CLASS
}else{
if(a.id.charAt(0)=="b"){
var e;
if(a.firstChild==null){
e=a;
AjxImg.getParentElement(a).className=DwtCalendar._BUTTON_ACTIVE_CLASS
}else{
a.className=DwtCalendar._BUTTON_ACTIVE_CLASS;
e=AjxImg.getImageElement(a)
}
e.className=e._origClassName
}else{
if(a.id.charAt(0)=="w"){}}}}}};
DwtCalendar.prototype._mouseUpListener=function(t){
var i=t.target;
if(t.button==DwtMouseEvent.LEFT){
if(i.id.charAt(0)=="c"){
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}
var a=new Date(i._year,i._month,i._day);
if(a.getDate()!=i._day){
a.setDate(i._day)
}
if(this.setDate(a)){
return
}
this._setClassName(i,DwtCalendar._HOVERED)
}else{
if(i.id.charAt(0)=="b"){
var e;
if(i.firstChild==null){
e=i;
AjxImg.getParentElement(i).className=DwtCalendar._BUTTON_HOVERED_CLASS
}else{
i.className=DwtCalendar._BUTTON_HOVERED_CLASS;
e=AjxImg.getImageElement(i)
}
e.className=e._origClassName;
if(e.id.indexOf("py")!=-1){
this._prevYear()
}else{
if(e.id.indexOf("pm")!=-1){
this._prevMonth()
}else{
if(e.id.indexOf("nm")!=-1){
this._nextMonth()
}else{
this._nextYear()
}}}}else{
if(i.id.charAt(0)=="t"){
i.className=DwtCalendar._TITLE_HOVERED_CLASS;
this.setDate(new Date(),this._skipNotifyOnPage);
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}}}}}else{
if(t.button==DwtMouseEvent.RIGHT&&i.id.charAt(0)=="c"){
this._notifyListeners(DwtEvent.ACTION,0,new Date(i._year,i._month,i._day),t)
}}};
DwtCalendar.prototype._doubleClickListener=function(e){
var t=e.target;
if(this._selectionEvent){
this._selectionEvent.type=DwtCalendar.DATE_DBL_CLICKED
}
if(t.id.charAt(0)=="c"){
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}
this.setDate(new Date(t._year,t._month,t._day),false,false,true)
}};
DwtCalendar.prototype._prevMonth=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.MONTH,-1),this._skipNotifyOnPage)
};
DwtCalendar.prototype._nextMonth=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.MONTH,1),this._skipNotifyOnPage)
};
DwtCalendar.prototype._prevYear=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.YEAR,-1),this._skipNotifyOnPage)
};
DwtCalendar.prototype._nextYear=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.YEAR,1),this._skipNotifyOnPage)
};
DwtCalendar.getDateFormatter=function(){
if(!DwtCalendar._dateFormatter){
DwtCalendar._dateFormatter=new AjxDateFormat(AjxMsg.formatCalDate)
}
return DwtCalendar._dateFormatter
};
DwtCalendar.getDateLongFormatter=function(){
if(!DwtCalendar._dateLongFormatter){
DwtCalendar._dateLongFormatter=new AjxDateFormat(AjxMsg.formatCalDateLong)
}
return DwtCalendar._dateLongFormatter
};
DwtCalendar.getDateFullFormatter=function(){
if(!DwtCalendar._dateFullFormatter){
DwtCalendar._dateFullFormatter=new AjxDateFormat(AjxMsg.formatCalDateFull)
}
return DwtCalendar._dateFullFormatter
};
DwtCalendar.getHourFormatter=function(){
if(!DwtCalendar._hourFormatter){
DwtCalendar._hourFormatter=new AjxMessageFormat(AjxMsg.formatCalHour)
}
return DwtCalendar._hourFormatter
};
DwtCalendar.getDayFormatter=function(){
if(!DwtCalendar._dayFormatter){
DwtCalendar._dayFormatter=new AjxDateFormat(AjxMsg.formatCalDay)
}
return DwtCalendar._dayFormatter
};
DwtCalendar.getMonthFormatter=function(){
if(!DwtCalendar._monthFormatter){
DwtCalendar._monthFormatter=new AjxDateFormat(AjxMsg.formatCalMonth)
}
return DwtCalendar._monthFormatter
};
DwtCalendar.getShortMonthFormatter=function(){
if(!DwtCalendar._shortMonthFormatter){
DwtCalendar._shortMonthFormatter=new AjxDateFormat(AjxMsg.formatShortCalMonth)
}
return DwtCalendar._shortMonthFormatter
};
DwtCalendar.prototype._dragEnter=function(e){};
DwtCalendar.prototype._dragHover=function(e){};
DwtCalendar.prototype._dragOver=function(e){
var t=e.target;
if(t.id.charAt(0)=="c"){
this._setClassName(t,DwtCalendar._HOVERED);
this._lastDndCell=t
}else{
this._lastDndCell=null
}};
DwtCalendar.prototype._dragLeave=function(e){}
}}
if(AjxPackage.define("prefs.Options")){
AjxTemplate.register("prefs.Options#OptionsOuter",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table id='' class='fullSize' cellspacing=0 cellpadding=0><tr><td><ul id=\"";
e[a++]=o.id;
e[a++]="_outer_tabs\" class='ZTabList'><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_general' class='ZTab' onclick='controller.showPage(\"general\")'>General</li><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_mail' class='ZTab'>Mail</li><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_identity' class='ZTab' onclick='controller.showPage(\"identity\")'>Mail Identities</li><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_pop' class='ZTab' onclick='controller.showPage(\"pop\")'>Pop Accounts</li><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_filters' class='ZTab'>Mail Filters</li><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_addressBook' class='ZTab'>Address Book</li><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_calendar' class='ZTab'>Calendar</li><li id='";
e[a++]=o.id;
e[a++]="_outer_tabs_shortcuts' class='ZTab'>Shortcuts</li></ul></td></tr><tr><td colspan=2 style='padding:0px'><div id='";
e[a++]=o.id;
e[a++]="_page_title' class='ZmPanelHead'></div></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_page_container' style='height:100%' valign=top ><!--\t\t<div class='ZScrollContainerOuter'><div id='";
e[a++]=o.id;
e[a++]="_page_container' class='ZScrollContainerInner'></div></div>\n";
e[a++]="--></td><tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Options#OptionsOuter"}
,false);
AjxTemplate.register("prefs.Options",AjxTemplate.getTemplate("prefs.Options#OptionsOuter"),AjxTemplate.getParams("prefs.Options#OptionsOuter"));
AjxTemplate.register("prefs.Options#PopForm",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<!--<div class='ZScrollContainerInner'>\t--><table class=\"ZFormTable ZFixedTable\" cellspacing=0 cellpadding=2 border=0><colgroup><col width=30%><col width=70%></colgroup><tr><td><div class='ZSmallSpacer'></div></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.popAccountNameLabel;
e[a++]='</td><td><input id="';
e[a++]=o.id;
e[a++]="_name\" type=text class='ZFieldSizeMedium'></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.popAccountFolderLabel;
e[a++]='</td><td><button id="';
e[a++]=o.id;
e[a++]="_location\" type=text  class='DwtButtton' style='width:200px'>Inbox</button></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.popAccountDownloadLabel;
e[a++]='</td><td><select id="';
e[a++]=o.id;
e[a++]="_download\" class='ZFieldSizeMedium'><option>";
e[a++]=ZmMsg.popAccountDownloadLeave;
e[a++]="</option><option>";
e[a++]=ZmMsg.popAccountDownloadRemove;
e[a++]="</option></select></td></tr><tr><td colspan=2><div class=ZLineDivider><span class=ZLineDividerTitle>";
e[a++]=ZmMsg.accountSettings;
e[a++]="</span></div></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.popAccountServerLabel;
e[a++]='</td><td><input id="';
e[a++]=o.id;
e[a++]="_server\" type=text class='ZFieldSizeHusky'></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.usernameLabel;
e[a++]='</td><td><input id="';
e[a++]=o.id;
e[a++]="_username\" type=text class='ZFieldSizeHusky'></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.passwordLabel;
e[a++]='</td><td><table cellspacing=0 cellpadding=0><tr><td><input id="';
e[a++]=o.id;
e[a++]="_password\" type='password' class='ZFieldSizeSmall'></td><td>&nbsp;<input id='";
e[a++]=o.id;
e[a++]="_show_password' type='checkbox' class='ZCheckbox'></td><td><label for='";
e[a++]=o.id;
e[a++]="_show_password' class='ZCheckboxLabelInline'>";
e[a++]=ZmMsg.showPassword;
e[a++]="</label></td></tr></table></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_ssl_row'><td class='ZCheckboxCell'><input id=\"";
e[a++]=o.id;
e[a++]="_ssl\" type=checkbox></td><td><label for='";
e[a++]=o.id;
e[a++]="_ssl' class='ZCheckboxLabel'>";
e[a++]=ZmMsg.popAccountUseSSL;
e[a++]="</label></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_port_row'><td class='ZLabelCell'>";
e[a++]=ZmMsg.portLabel;
e[a++]='</td><td><table cellspacing=0 cellpadding=0><tr><td><input id="';
e[a++]=o.id;
e[a++]="_port\" type=text style='width:6em'></td><td>&nbsp;<span class='ZHelpLabel' id=\"";
e[a++]=o.id;
e[a++]='_port_label">';
e[a++]=ZmMsg.defaultPort;
e[a++]="</span></td></tr></table></td></tr><tr><td><div class='ZSmallSpacer'></div></td></tr><tr><td></td><td><div class='ZFieldSizeHusky'><button id='";
e[a++]=o.id;
e[a++]="_testButton'>";
e[a++]=ZmMsg.popAccountTest;
e[a++]="</button></div></td></tr><tr><td colspan=2><div id='";
e[a++]=o.id;
e[a++]="_identity_title_row' class=ZLineDivider><span class=ZLineDividerTitle>";
e[a++]=ZmMsg.identitiesTab;
e[a++]="</span></div></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_identity_help_row'><td colspan=2><div class='ZHelpLabelIndent'>";
e[a++]=ZmMsg.popAccountIdentityHelp;
e[a++]="<div class='ZSmallSpacer'></div></div></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_identity_create_row'><td class='ZCheckboxLabelCell' colspan=2 style='padding-left:50px;'><table><tr><td><input id=\"";
e[a++]=o.id;
e[a++]="_create_identity\" type=checkbox onchange='pageController.toggleIdentityFields(this.checked)'></td><td width=100%><label for='";
e[a++]=o.id;
e[a++]="_create_identity' class='ZCheckboxLabelInline'>";
e[a++]=ZmMsg.popAccountCreateNewIdentity;
e[a++]="</label></td></tr></table></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_identity_spacer_row'><td><div class='ZSmallSpacer'></div></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_identity_name_row'><td class='ZLabelCell'>";
e[a++]=ZmMsg.identityNameLabel;
e[a++]='</td><td id="';
e[a++]=o.id;
e[a++]="_identity_name\" class='ZLabelCellLeft'>New Account 1</td></tr><tr id='";
e[a++]=o.id;
e[a++]="_identity_email_row'><td class='ZLabelCell'>";
e[a++]=ZmMsg.emailAddrLabel;
e[a++]='</td><td><input id="';
e[a++]=o.id;
e[a++]="_email\" type=text  class='ZFieldSizeHusky'></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_identity_use_address_row'><td class='ZLabelCell'>";
e[a++]=ZmMsg.linkToNewIdentity;
e[a++]='</td><td><table cellspacing=0 cellpadding=0><tr><td><input id="';
e[a++]=o.id;
e[a++]='_identity_use_address" type=checkbox></td><td><label for="';
e[a++]=o.id;
e[a++]="_identity_use_address\" class='ZCheckboxLabel'>";
e[a++]=ZmMsg.whenReplyingToAddress;
e[a++]="</label></td></tr></table></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_identity_use_folder_row'><td></td><td><table cellspacing=0 cellpadding=0 border=0><tr><td><input id=\"";
e[a++]=o.id;
e[a++]='_identity_use_folder" type=checkbox></td><td><label for="';
e[a++]=o.id;
e[a++]="_identity_use_folder\" class='ZCheckboxLabel'>";
e[a++]=ZmMsg.whenReplyingToFolder;
e[a++]="</label></td></tr></table></td></tr><tr><td><div class='ZSmallSpacer'></div></td></tr></table></div>";
return i?e.length:e.join("")
}
,{
id:"prefs.Options#PopForm"}
,false);
AjxTemplate.register("prefs.Options#IdentityForm",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table class=\"ZFormTable ZFixedTable\" cellspacing=0 cellpadding=2 border=0 style='height:100%'><colgroup><col width=103><col width='100%'></colgroup><tr><td><div class='ZSmallSpacer'></div></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.identityNameLabel;
e[a++]='</td><td><input id="';
e[a++]=o.id;
e[a++]="_name\" type=text class='ZFieldSizeMedium'></td></tr><tr><td><div class='ZSmallSpacer'></div></td></tr><tr><td colspan=2><ul id=\"";
e[a++]=o.id;
e[a++]="_tabs\" class='ZTabList'><li id='";
e[a++]=o.id;
e[a++]="_tabs_options' class='ZTab' onclick='pageController.showPage(\"options\")'>Identity Options</li><li id='";
e[a++]=o.id;
e[a++]="_tabs_signature' class='ZTab' onclick='pageController.showPage(\"signature\")'>Signature</li><li id='";
e[a++]=o.id;
e[a++]="_tabs_advanced' class='ZTab' onclick='pageController.showPage(\"advanced\")'>Advanced</li></ul></td></tr><tr><td style='height:100%' valign=top colspan=2><div id='";
e[a++]=o.id;
e[a++]="_subFormContainer' style='width:95%;position:relative;'></div></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Options#IdentityForm"}
,false);
AjxTemplate.register("prefs.Options#IdentityForm_options",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<fieldset class='ZFieldset' style='width:auto'><legend class='ZLegend'>";
e[a++]=ZmMsg.sendWithIdentity;
e[a++]="</legend><table class='ZFormTable XZFixedTable' cellspacing=0 cellpadding=2 width='99%'><colgroup><col width=20><col width=60><col width='50%'><col width='50%'></colgroup><tr><td class='ZLabelCell' colspan=2>";
e[a++]=ZmMsg.sendFrom;
e[a++]="</td><td><input id='";
e[a++]=o.id;
e[a++]="_sendFromName' style='width:100%'></td><td><select id='";
e[a++]=o.id;
e[a++]="_sendFromAddress' style='width:90%'><option>bob@zimbra.com</option></select></td></tr><tr><td class='ZCheckboxCell'><input id='";
e[a++]=o.id;
e[a++]="_setReplyToCheckbox' type='checkbox'></td><td class='ZCheckboxLabelCell'><nobr>";
e[a++]=ZmMsg.setReplyTo;
e[a++]="</nobr></td><td><input id='";
e[a++]=o.id;
e[a++]="_setReplyToName' style='width:100%'></td><td><select id='";
e[a++]=o.id;
e[a++]="_setReplyToAddress' style='width:90%'><option>bob@zimbra.com</option></select></td></tr></table></fieldset>";
if(AjxEnv.isIE){
e[a++]="<br>"
}
e[a++]="<fieldset class='ZFieldset' style='width:auto'><legend class='ZLegend'>";
e[a++]=ZmMsg.selectIdentityWhen;
e[a++]="</legend><table class='ZFormTable ZFixedTable' cellspacing=0 cellpadding=2 width='99%' border=0><colgroup><col width=20><col width='100%'><col width=40></colgroup><tr><td class='ZCheckboxCell'><input id='";
e[a++]=o.id;
e[a++]="_whenSentToCheckbox' type='checkbox'></td><td class='ZCheckboxLabelCell'>";
e[a++]=ZmMsg.whenSentTo;
e[a++]="</td></tr><tr><td></td><td><input id='";
e[a++]=o.id;
e[a++]="_whenSentToInput' style='width:100%'></td></tr><tr><td></td><td class='ZHelpLabel'>";
e[a++]=ZmMsg.whenSentToHint;
e[a++]="</td></tr><tr><td><div class='ZSmallSpacer'></div></td></tr><tr><td class='ZCheckboxCell'><input id='";
e[a++]=o.id;
e[a++]="_whenInFolderCheckbox' type='checkbox'></td><td class='ZCheckboxLabelCell'>";
e[a++]=ZmMsg.whenInFolder;
e[a++]="</td></tr><tr><td></td><td><table cellspacing=0 cellpadding=0 style='width:100%'><tr><td style='width:100%'><input id='";
e[a++]=o.id;
e[a++]="_whenInFolderInput' style='width:100%'></td><td style='padding-left:10px;'><button id='";
e[a++]=o.id;
e[a++]="_folderBrowseButton' style='width:30px'><div class='ImgFolder'></div></button></td></tr></table></td></tr><tr><td></td><td class='ZHelpLabel'>";
e[a++]=ZmMsg.whenInFolderHint;
e[a++]="</td></tr></table></fieldset>";
return i?e.length:e.join("")
}
,{
id:"prefs.Options#IdentityForm_options"}
,false);
AjxTemplate.register("prefs.Options#IdentityForm_signature",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table class='ZFormTable ZFixedTable' cellspacing=0 cellpadding=2 style='width:95%;' border=0><colgroup><col width=103><col width='100%'><col width=20></colgroup><tr><td><div class='ZSmallSpacer'></div></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.placeSignature;
e[a++]="</td><td colspan=2><select id='";
e[a++]=o.id;
e[a++]="_signatureStyleSelect'><option>";
e[a++]=ZmMsg.aboveQuotedText;
e[a++]="</option><option>";
e[a++]=ZmMsg.atBottomOfMessage;
e[a++]="</option></select></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.applySignature;
e[a++]="</td><td colspan=2><select id='";
e[a++]=o.id;
e[a++]="_signatureEnabledSelect'><option>";
e[a++]=ZmMsg.automaticSignature;
e[a++]="</option><option>";
e[a++]=ZmMsg.manualSignature;
e[a++]="</option></select></td></tr><tr><td class='ZLabelCell'>";
e[a++]=ZmMsg.mailSignature;
e[a++]="</td><td><textarea id='";
e[a++]=o.id;
e[a++]="_signature' style='width:100%;height:120px'></textarea></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Options#IdentityForm_signature"}
,false);
AjxTemplate.register("prefs.Options#IdentityForm_advanced",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table class='ZFormTable ZFixedTable' cellspacing=0 cellpadding=2 width='99%' border=0><colgroup><col width='200'><col width='100%'</colgroup><tr><td><div class='ZSmallSpacer'></div></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_useDefaultsRadios'><td class='ZLabelCell'>";
e[a++]=ZmMsg.replyWithIdentity;
e[a++]="</td><td style='padding:0px'><table><tr><td class='ZCheckboxCell'><input  name='";
e[a++]=o.id;
e[a++]="_group' id='";
e[a++]=o.id;
e[a++]="_useDefaultsCheckbox_default' class='ZRadioButton' type='radio' onclick='";
e[a++]=o.controller;
e[a++]="._toggleAdvancedSettings(false)'></td><td class='ZCheckboxLabelCell' colspan='2'><label for='";
e[a++]=o.id;
e[a++]="_useDefaultsCheckbox_default' class='ZCheckboxLabel'>";
e[a++]=ZmMsg.identitiesUseDefault;
e[a++]="</label></td></tr><tr><td class='ZCheckboxCell'><input  name='";
e[a++]=o.id;
e[a++]="_group' id='";
e[a++]=o.id;
e[a++]="_useDefaultsCheckbox_custom' class='ZRadioButton' type='radio' onclick='";
e[a++]=o.controller;
e[a++]="._toggleAdvancedSettings(true)'></td><td class='ZCheckboxLabelCell' colspan='2'><label for='";
e[a++]=o.id;
e[a++]="_useDefaultsCheckbox_custom' class='ZCheckboxLabel'>";
e[a++]=ZmMsg.customizeSettings;
e[a++]="</label></td></tr></table></td></tr><tr><td><div class='ZSmallSpacer'></div></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_replyForwardSelect_row'><td class='ZLabelCell' ><label id='";
e[a++]=o.id;
e[a++]="_replyForwardSelect_label' for='";
e[a++]=o.id;
e[a++]="_replyForwardSelect'>";
e[a++]=ZmMsg.replyForwardFormat;
e[a++]="</label></td><td><select id='";
e[a++]=o.id;
e[a++]="_replyForwardSelect' class='ZFieldSizeLarge'><option>";
e[a++]=ZmMsg.originalFormat;
e[a++]="</option><option>";
e[a++]=ZmMsg.text;
e[a++]="</option><option>";
e[a++]=ZmMsg.htmlDocument;
e[a++]="</option></select></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_replyIncludeSelect_row'><td class='ZLabelCell' id='";
e[a++]=o.id;
e[a++]="_replyIncludeSelect_label' >";
e[a++]=ZmMsg.replyInclude;
e[a++]="</td><td><select id='";
e[a++]=o.id;
e[a++]="_replyIncludeSelect' class='ZFieldSizeLarge'><option>";
e[a++]=ZmMsg.dontIncludeMessage;
e[a++]="</option><option>";
e[a++]=ZmMsg.includeInBody;
e[a++]="</option><option>";
e[a++]=ZmMsg.includePrefix;
e[a++]="</option><option>";
e[a++]=ZmMsg.includeOriginalAsAttach;
e[a++]="</option><option>";
e[a++]=ZmMsg.smartInclude;
e[a++]="</option></select></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_forwardIncludeSelect_row'><td class='ZLabelCell' id='";
e[a++]=o.id;
e[a++]="_forwardIncludeSelect_label' >";
e[a++]=ZmMsg.forwardInclude;
e[a++]="</td><td><select id='";
e[a++]=o.id;
e[a++]="_forwardIncludeSelect' class='ZFieldSizeLarge'><option>";
e[a++]=ZmMsg.includeOriginalInBody;
e[a++]="</option><option>";
e[a++]=ZmMsg.includePrefix;
e[a++]="</option><option>";
e[a++]=ZmMsg.includeOriginalAsAttach;
e[a++]="</option></select></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_prefixSelect_row'><td class='ZLabelCell' id='";
e[a++]=o.id;
e[a++]="_prefixSelect_label' >";
e[a++]=ZmMsg.prefixTextWith;
e[a++]="</td><td><select id='";
e[a++]=o.id;
e[a++]="_prefixSelect' class='ZFieldSizeSmall'><option>&gt;</option><option>|</option></select></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Options#IdentityForm_advanced"}
,false);
AjxTemplate.register("prefs.Options#GeneralForm",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="General Options";
return i?e.length:e.join("")
}
,{
id:"prefs.Options#GeneralForm"}
,false)
}
if(AjxPackage.define("prefs.Pages")){
AjxTemplate.register("prefs.Pages#General",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.loginOptions;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
if(!appCtxt.isOffline){
e[a++]="<tr id='prefs.Pages#General_PASSWORD_LABEL'><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.password;
e[a++]=":</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_PASSWORD' tabindex='50'></div></td></tr><tr><td class='ZOptionsLabelTop'>";
e[a++]=ZmMsg.loginLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_CLIENT_TYPE' tabindex='20'></div></td></tr>"
}
if(!appCtxt.isOffline){
e[a++]="<tr><td colspan=2><hr></td></tr>"
}
if(o.isEnabled(ZmSetting.SKIN_CHANGE_ENABLED)){
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.themeLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_SKIN_NAME' tabindex='30'></div></td></tr>"
}
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.languageLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_LOCALE_NAME' tabindex='40'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.defaultTimezone;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_DEFAULT_TIMEZONE' tabindex='45'></div></td></tr></table></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.searches;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
if(o.isEnabled(ZmSetting.SEARCH_INCLUDES_SPAM,ZmSetting.SEARCH_INCLUDES_TRASH)){
if(o.isEnabled(ZmSetting.SEARCH_INCLUDES_SPAM)){
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.searchSettingsLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_SEARCH_INCLUDES_SPAM' tabindex='60'></div></td></tr>"
}
if(o.isEnabled(ZmSetting.SEARCH_INCLUDES_TRASH)){
e[a++]="<tr><td class='ZOptionsLabel'>";
if(!o.isEnabled(ZmSetting.SEARCH_INCLUDES_SPAM)){
e[a++]=ZmMsg.searchSettingsLabel
}else{
e[a++]="\n";
e[a++]="\t\t\t\t\t\t\t\t\t\t&nbsp;\n";
e[a++]="\t\t\t\t\t\t\t\t\t"
}
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_SEARCH_INCLUDES_TRASH' tabindex='70'></div></td></tr>"
}
e[a++]="<tr><td colspan=2><hr></td></tr>"
}
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.searchLanguageLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_SHOW_SEARCH_STRING' tabindex='80'></div></td></tr></table></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.other;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.pageSizeLabel;
e[a++]="</td><td class='ZOptionsField'><table cellspacing=0 cellpadding=0 border=0><tr><td><div id='";
e[a++]=o.id;
e[a++]="_PAGE_SIZE' tabindex='90'></div></td><td style=\"padding-left:4px;\">";
e[a++]=ZmMsg.pageSizeDesc;
e[a++]="</td></tr></table></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.selection;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_SHOW_SELECTION_CHECKBOX' tabindex='95'></div></td></tr>";
if(appCtxt.isOffline&&appCtxt.accountList.size()>2){
e[a++]="<tr><td class='ZOptionsLabel'></td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_SHOW_ALL_MAILBOXES' tabindex='100'></div></td></tr>"
}
if(o.isEnabled(ZmSetting.OFFLINE_SUPPORTS_MAILTO)){
e[a++]="<tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.systemDefaults;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_IS_MAILTO_HANDLER' tabindex='110'></div></td></tr>"
}
if(appCtxt.isOffline&&appCtxt.accountList.accountTypeExists(ZmAccount.TYPE_ZIMBRA)){
e[a++]="<tr><td class='ZOptionsLabel'></td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_NOTEBOOK_SYNC_ENABLED' tabindex='120'></div></td></tr>"
}
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.printFontSizeLabel;
e[a++]="</td><td class='ZOptionsField'><select id='";
e[a++]=o.id;
e[a++]="_DEFAULT_PRINTFONTSIZE' tabindex='130'></select></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.emailAddrs;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_SHORT_ADDRESS' tabindex='140'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.bubbles;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_USE_ADDR_BUBBLES' tabindex='150'></div></td></tr>";
if(appCtxt.isOffline){
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.offlineUpdateNotifyLabel;
e[a++]="</td><td class='ZOptionsField'><select id='";
e[a++]=o.id;
e[a++]="_OFFLINE_UPDATE_NOTIFY' tabindex='160'></select></td></tr>"
}
e[a++]="</table></td></tr></table>";
if(ZmZimbraMail.showPasswordLockFeature()){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.passwordLock;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td>";
e[a++]=ZmMsg.passwordLockDesc;
e[a++]="</td></tr><tr><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_PASSWORD_LOCK_ENABLED' tabindex='170' style=\"margin-left: 150px;\"></div></td></tr></table></td></tr></table>"
}
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#General"}
,false);
AjxTemplate.register("prefs.Pages",AjxTemplate.getTemplate("prefs.Pages#General"),AjxTemplate.getParams("prefs.Pages#General"));
AjxTemplate.register("prefs.Pages#Mail",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var i=e.length;
e[i++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[i++]=n.id;
e[i++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div>";
if(!appCtxt.multiAccounts||n.activeAccount.isMain){
e[i++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[i++]=ZmMsg.displayMessages;
e[i++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
if(!appCtxt.isOffline&&n.isEnabled(ZmSetting.POLLING_INTERVAL_ENABLED)){
e[i++]="<tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.pollingIntervalLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_POLLING_INTERVAL' tabindex='40' size='3' /></td></tr>"
}
e[i++]="<tr><td class='ZOptionsLabelTop'>";
e[i++]=appCtxt.isOffline?ZmMsg.checkMailPrefLabelOffline:ZmMsg.checkMailPrefLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_GET_MAIL_ACTION' tabindex='45'></div></td></tr><tr><td class='ZOptionsLabelTop'>";
e[i++]=ZmMsg.displayMail;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_VIEW_AS_HTML' tabindex='50'></div></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.messagePreviewLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_SHOW_FRAGMENTS' tabindex='70'></div></td></tr><tr><td class='ZOptionsLabel'></td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_OPEN_MAIL_IN_NEW_WIN' tabindex='80'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.imagesLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_DISPLAY_EXTERNAL_IMAGES' tabindex='90'></div></td></tr><tr><td class='ZOptionsLabelTop'>";
e[i++]=ZmMsg.messageReadLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_MARK_MSG_READ' tabindex='95'></div></td></tr><tr><td class='ZOptionsLabelTop'>";
e[i++]=ZmMsg.selectAfterDeleteLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_SELECT_AFTER_DELETE' tabindex='97'></div></td></tr>";
if(!appCtxt.isOffline){
e[i++]="<tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.initialMailSearchLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_INITIAL_SEARCH' tabindex='100'></div></td></tr>"
}
e[i++]="</table></td></tr></table>"
}
if(appCtxt.isOffline&&n.activeAccount==appCtxt.accountList.defaultAccount){
var a=appCtxt.accountList.size();
if((a>2&&!appCtxt.get(ZmSetting.OFFLINE_SHOW_ALL_MAILBOXES))||a==2){
e[i++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[i++]=ZmMsg.displayMessages;
e[i++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.initialMailSearchLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_INITIAL_SEARCH' tabindex='100'></div></td></tr></table></td></tr></table>"
}}
e[i++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[i++]=ZmMsg.messagesReceiving;
e[i++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
if(n.isEnabled(ZmSetting.MAIL_NOTIFY_SOUNDS)){
e[i++]="<tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.messageArrivalLabel;
e[i++]="</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_NOTIFY_SOUNDS' tabindex='105' type=checkbox /></td></tr>"
}
if(n.isEnabled(ZmSetting.MAIL_NOTIFY_APP)){
e[i++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_NOTIFY_APP' tabindex='106' type=checkbox /></td></tr>"
}
if(n.isEnabled(ZmSetting.MAIL_NOTIFY_BROWSER)){
e[i++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_NOTIFY_BROWSER' tabindex='107' type=checkbox /></td></tr>"
}
if(n.isEnabled(ZmSetting.MAIL_NOTIFY_TOASTER)){
e[i++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table cellspacing=0 cellpadding=0><tr><td><div id='";
e[i++]=n.id;
e[i++]="_MAIL_NOTIFY_TOASTER' tabindex='108'></div></td></tr></table></td></tr>"
}
if(appCtxt.isOffline){
e[i++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_OFFLINE_NOTIFY_NEWMAIL_ON_INBOX' tabindex='109' /></td></tr>"
}
if(!appCtxt.multiAccounts||appCtxt.isFamilyMbox||(!n.activeAccount.isMain&&n.activeAccount.isZimbraAccount)){
if(n.isEnabled(ZmSetting.MAIL_FORWARDING_ENABLED)){
e[i++]="<tr><td class='ZOptionsLabel'>";
if(!n.isEnabled(ZmSetting.MAIL_NOTIFY_SOUNDS)){
e[i++]=ZmMsg.messageArrivalLabel
}else{
e[i++]="\n";
e[i++]="\t\t\t\t\t\t\t\t\t\t&nbsp;\n";
e[i++]="\t\t\t\t\t\t\t\t\t"
}
e[i++]="</td><td class='ZOptionsField'>";
e[i++]=ZmMsg.forwardCopyTo;
e[i++]="</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField' style='padding-left:2em;'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_FORWARDING_ADDRESS' tabindex='110' /></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField' style='padding-left:2em;'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_LOCAL_DELIVERY_DISABLED' tabindex='120'></td></tr>"
}
if(n.isEnabled(ZmSetting.NOTIF_FEATURE_ENABLED)){
if(n.isEnabled(ZmSetting.MAIL_FORWARDING_ENABLED)){
e[i++]="<tr><td>&nbsp;</td><td><hr></td></tr>"
}
e[i++]="<tr><td class='ZOptionsLabel'>";
if(!n.isEnabled(ZmSetting.MAIL_FORWARDING_ENABLED)){
e[i++]=ZmMsg.messageArrivalLabel
}else{
e[i++]="\n";
e[i++]="\t\t\t\t\t\t\t\t&nbsp;\n";
e[i++]="\t\t\t\t\t\t\t"
}
e[i++]="</td><td class='ZOptionsField'><input id='";
e[i++]=n.id;
e[i++]="_NOTIF_ENABLED' tabindex='130' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField' style='padding-left:2em;'><div id='";
e[i++]=n.id;
e[i++]="_NOTIF_ADDRESS' tabindex='140' /></td></tr>"
}
if(n.isEnabled(ZmSetting.VACATION_MSG_FEATURE_ENABLED)){
if(n.isEnabled(ZmSetting.MAIL_FORWARDING_ENABLED,ZmSetting.NOTIF_FEATURE_ENABLED)){
e[i++]="<tr><td>&nbsp;</td><td><hr></td></tr>"
}
e[i++]="<tr><td class='ZOptionsLabel'>";
if(!n.isEnabled(ZmSetting.MAIL_FORWARDING_ENABLED)&&!n.isEnabled(ZmSetting.NOTIF_FEATURE_ENABLED)){
e[i++]=ZmMsg.messageArrivalLabel
}else{
e[i++]="\n";
e[i++]="\t\t\t\t\t\t\t\t&nbsp;\n";
e[i++]="\t\t\t\t\t\t\t"
}
e[i++]="</td><td class='ZOptionsField'><input id='";
e[i++]=n.id;
e[i++]="_VACATION_MSG_ENABLED' tabindex='150' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField' style='padding-left:2em;'><table border=\"0\"><tr><td><textarea id='";
e[i++]=n.id;
e[i++]='_VACATION_MSG\' tabindex=\'160\' rows=3 cols=70></textarea><span style="display:none"><input type="hidden" name="st_dt" id="';
e[i++]=n.id;
e[i++]='_VACATION_FROM"/><input type="hidden" name="ed_dt" id="';
e[i++]=n.id;
e[i++]='_VACATION_UNTIL"/></span></td></tr><tr><td><table><tr><td><input type="checkbox" id="';
e[i++]=n.id;
e[i++]="_START_DATE_ENABLED\"></td><td><input style='height:22px;' type='text' autocomplete='off' size=14 maxlength=10 id='";
e[i++]=n.id;
e[i++]="_VACATION_FROM1'></td><td id='";
e[i++]=n.id;
e[i++]='_startMiniCal\'></td></tr><tr><td><input type="checkbox" id="';
e[i++]=n.id;
e[i++]="_END_DATE_ENABLED\"></td><td><input style='height:22px;' type='text' autocomplete='off' size=14 maxlength=10 id='";
e[i++]=n.id;
e[i++]="_VACATION_UNTIL1'></td><td id='";
e[i++]=n.id;
e[i++]="_endMiniCal'></td></tr></table></td></tr></table></td></tr>"
}
if(n.isEnabled(ZmSetting.MAIL_READ_RECEIPT_ENABLED)){
e[i++]="<tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.readReceipt;
e[i++]="</td><td class='ZOptionsField'>";
e[i++]=ZmMsg.readReceiptPref;
e[i++]="</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_SEND_READ_RECEIPTS' tabindex='170'></div></td></tr><tr><td colspan=2><hr></td></tr>"
}
e[i++]="<tr><td class='ZOptionsLabel'>";
e[i++]=ZmMsg.removeDupesToSelfLabel;
e[i++]="</td><td class='ZOptionsField'>";
e[i++]=ZmMsg.removeDupesToSelf;
e[i++]="</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_DEDUPE_MSG_TO_SELF' tabindex='180'></div></td></tr>"
}
e[i++]="</table></td></tr></table>";
if(!appCtxt.multiAccounts||appCtxt.isFamilyMbox||(!n.activeAccount.isMain&&n.activeAccount.isZimbraAccount)){
if(appCtxt.get(ZmSetting.MAIL_BLACKLIST_MAX_NUM_ENTRIES)>0||appCtxt.get(ZmSetting.MAIL_WHITELIST_MAX_NUM_ENTRIES)>0){
e[i++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[i++]=ZmMsg.junkMailOptions;
e[i++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel' style='text-align:left'>";
e[i++]=ZmMsg.blackListLabel;
e[i++]="</td><td class='ZOptionsLabel' style='text-align:left'>";
e[i++]=ZmMsg.whiteListLabel;
e[i++]="</td></tr><tr><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_BLACKLIST'></div></td><td class='ZOptionsField'><div id='";
e[i++]=n.id;
e[i++]="_MAIL_WHITELIST'></div></td></tr></table></td></tr></table>"
}}
if(n.isEnabled(ZmSetting.POP_ENABLED)){
e[i++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[i++]=ZmMsg.externalAccess;
e[i++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabelTop'>";
e[i++]=ZmMsg.externalAccessPop;
e[i++]="</td><td class='ZOptionsField'><input id='";
e[i++]=n.id;
e[i++]="_POP_DOWNLOAD_SINCE' tabindex='200' type=radio></td></tr><tr><td></td><td class='ZOptionsInfo'><span id='";
e[i++]=n.id;
e[i++]="_POP_DOWNLOAD_SINCE_VALUE'></span></td></tr></table></td></tr></table>"
}
return o?e.length:e.join("")
}
,{
id:"prefs.Pages#Mail"}
,false);
AjxTemplate.register("prefs.Pages#BlackList",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0><tr><td id='";
e[a++]=o.id;
e[a++]="_EMAIL_ADDRESS' tabindex='182'></div></td><td id='";
e[a++]=o.id;
e[a++]="_ADD_BUTTON' valign=top tabindex='184'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_LISTVIEW' tabindex='186'></td><td id='";
e[a++]=o.id;
e[a++]="_REMOVE_BUTTON' valign=top tabindex='188'></td></tr></table><div class='ZOptionsInfo' id='";
e[a++]=o.id;
e[a++]="_NUM_USED'></div>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#BlackList"}
,false);
AjxTemplate.register("prefs.Pages#WhiteList",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0><tr><td id='";
e[a++]=o.id;
e[a++]="_EMAIL_ADDRESS' tabindex='190'></div></td><td id='";
e[a++]=o.id;
e[a++]="_ADD_BUTTON' valign=top tabindex='192'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_LISTVIEW' tabindex='194'></td><td id='";
e[a++]=o.id;
e[a++]="_REMOVE_BUTTON' valign=top tabindex='196'></td></tr></table><div class='ZOptionsInfo' id='";
e[a++]=o.id;
e[a++]="_NUM_USED'></div>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#WhiteList"}
,false);
AjxTemplate.register("prefs.Pages#TrustedList",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0><tr><td id='";
e[a++]=o.id;
e[a++]="_EMAIL_ADDRESS' tabindex='190'></div></td><td id='";
e[a++]=o.id;
e[a++]="_ADD_BUTTON' valign=top tabindex='192'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_LISTVIEW' tabindex='194'></td><td id='";
e[a++]=o.id;
e[a++]="_REMOVE_BUTTON' valign=top tabindex='196'></td></tr></table><div class='ZOptionsInfo' id='";
e[a++]=o.id;
e[a++]="_NUM_USED'></div>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#TrustedList"}
,false);
AjxTemplate.register("prefs.Pages#Trusted",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><!-- TODO: What about intersection with notebook page compose? --><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.trustedAddrsDomains;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><div>";
e[a++]=ZmMsg.trustedAddrHeaderMsg;
e[a++]="</div><div id='";
e[a++]=o.id;
e[a++]="_TRUSTED_ADDR_LIST' tabindex='65' /></td></td></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Trusted"}
,false);
AjxTemplate.register("prefs.Pages#AutoArchive",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.autoArchiveHeading;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td>&nbsp;</td><td class='ZOptionsField paddedTableCell'><div type=\"checkbox\" id='";
e[a++]=o.id;
e[a++]="_AUTO_ARCHIVE_ENABLED' tabindex='62' /></td></tr></table><table style='padding-left:50'><tr><td>&nbsp;</td><td align='right'>";
e[a++]=ZmMsg.autoArchiveAge;
e[a++]="</td><td class='paddedTableCell'><table><tr><td class='ZLabelCell'><input id='";
e[a++]=o.id;
e[a++]="_AUTO_ARCHIVE_AGE' style='height:20px;' type=\"text\" size=8 tabindex='64'/></td><td>";
e[a++]=ZmMsg.daysLabel;
e[a++]="</td></tr></table></td></tr><tr><td>&nbsp;</td><td align='right'>";
e[a++]=ZmMsg.autoArchiveFreq;
e[a++]="</td><td class='ZLabelCell' ><select id='";
e[a++]=o.id;
e[a++]="_AUTO_ARCHIVE_FREQ' style='padding:1px' tabindex='66'/></td></tr></table><table style='padding-left:30' id='lastAutoArchiveSection' class=\"ZmAutoArchiveInfoDiv\"><tr><td><p id='lastAutoArchiveInfo' class=\"ZmAutoArchiveInfo\"> ";
e[a++]=ZmMsg.autoArchiveLastRun;
e[a++]="</p></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#AutoArchive"}
,false);
AjxTemplate.register("prefs.Pages#Composing",function(a,r,s,t){
var n=Boolean(t);
s=(typeof s=="string"?{
id:s}
:s)||{};
t=t||[];
var o=t.length;
t[o++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
t[o++]=s.id;
t[o++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><!-- TODO: What about intersection with notebook page compose? --><td class='ZOptionsHeader ImgPrefsHeader'>";
t[o++]=ZmMsg.composingMessages;
t[o++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
var i=s.isEnabled(ZmSetting.HTML_COMPOSE_ENABLED);
if(i){
t[o++]="<tr><td class='ZOptionsLabel' valign=top>";
t[o++]=ZmMsg.composeLabel;
t[o++]="</td><td class='ZOptionsNestedTable'><table><colgroup><col width=1><col width=1><col> <!-- family --><col width=1><col> <!-- size --><col width=1><col> <!-- color --></colgroup><tr valign=top><td class='ZOptionsFieldTop'><div id='";
t[o++]=s.id;
t[o++]="_COMPOSE_AS_FORMAT' tabindex='20'></div></td><td class='ZOptionsLabelTop ZOptionsLabelNarrow'>";
t[o++]=ZmMsg.fFamilyLabel;
t[o++]="</td><td class='ZOptionsField'><select id='";
t[o++]=s.id;
t[o++]="_COMPOSE_INIT_FONT_FAMILY' tabindex='30'></select></td><td class='ZOptionsLabelTop ZOptionsLabelNarrow'>";
t[o++]=ZmMsg.fSizeLabel;
t[o++]="</td><td class='ZOptionsField'><select id='";
t[o++]=s.id;
t[o++]="_COMPOSE_INIT_FONT_SIZE' tabindex='40'></select></td><td class='ZOptionsLabelTop ZOptionsLabelNarrow'>";
t[o++]=ZmMsg.fColorLabel;
t[o++]="</td><td class='ZOptionsField'><select id='";
t[o++]=s.id;
t[o++]="_COMPOSE_INIT_FONT_COLOR' tabindex='50'></select></td></tr></table></td></tr>"
}
t[o++]="<tr><td class='ZOptionsLabel' valign=top>";
t[o++]=ZmMsg.settingsLabel;
t[o++]="</td><td class='ZOptionsField'><div id='";
t[o++]=s.id;
t[o++]="_AUTO_SAVE_DRAFT_INTERVAL' tabindex='65' /></td></tr>";
if(i){
t[o++]="<tr><td>&nbsp;</td><td class='ZOptionsField'><div type=checkbox id=\"";
t[o++]=s.id;
t[o++]='_COMPOSE_SAME_FORMAT" /></td></tr>'
}
var e=s.isEnabled(ZmSetting.NEW_WINDOW_COMPOSE);
if(e){
t[o++]="<tr><td>&nbsp;</td><td class='ZOptionsField'><div id='";
t[o++]=s.id;
t[o++]="_NEW_WINDOW_COMPOSE' tabindex='60' /></td></tr>"
}
if(appCtxt.get(ZmSetting.SPELL_CHECK_ENABLED)){
t[o++]="<tr><td>&nbsp;</td><td class='ZOptionsField'><div id='";
t[o++]=s.id;
t[o++]="_MAIL_MANDATORY_SPELLCHECK' tabindex='62' /></td></tr>"
}
if(s.isEnabled(ZmSetting.SAVE_TO_SENT)){
t[o++]="<tr><td>&nbsp;</td><td class='ZOptionsField'><div id='";
t[o++]=s.id;
t[o++]="_SAVE_TO_SENT' tabindex='67' /></td></tr>"
}
if(s.isEnabled(ZmSetting.MAIL_ENABLED)){
if(i||e){
t[o++]="<tr><td colspan=2><hr></td></tr>"
}
t[o++]="<tr><td class='ZOptionsLabel'>";
t[o++]=ZmMsg.composeReplyLabel;
t[o++]="</td><td class='ZOptionsField'>";
t[o++]=ZmMsg.composeReplyEmail;
t[o++]="</td></tr><tr><td>&nbsp;</td><td class='ZOptionsField'><table><tr><td><div id='";
t[o++]=s.id;
t[o++]="_REPLY_INCLUDE_WHAT' tabindex='70' /></td><td><div id='";
t[o++]=s.id;
t[o++]="_REPLY_USE_PREFIX' tabindex='72' /></td><td><div id='";
t[o++]=s.id;
t[o++]="_REPLY_INCLUDE_HEADERS' tabindex='74' /></td></tr></table></td></tr><tr><td colspan=2></td></tr><tr><td class='ZOptionsLabel'>";
t[o++]=ZmMsg.forwardingLabel;
t[o++]="</td><td class='ZOptionsField'>";
t[o++]=ZmMsg.forwardingEmail;
t[o++]="</td></tr><tr><td>&nbsp;</td><td class='ZOptionsField'><table><tr><td><div id='";
t[o++]=s.id;
t[o++]="_FORWARD_INCLUDE_WHAT' tabindex='80' /></td><td><div id='";
t[o++]=s.id;
t[o++]="_FORWARD_USE_PREFIX' tabindex='82' /></td><td><div id='";
t[o++]=s.id;
t[o++]="_FORWARD_INCLUDE_HEADERS' tabindex='84' /></td></tr></table></td></tr><tr><td colspan=2></td></tr><tr><td class='ZOptionsLabel'>";
t[o++]=ZmMsg.prefixLabel;
t[o++]="</td><td class='ZOptionsField'>";
t[o++]=ZmMsg.prefixTextWith;
t[o++]="</td></tr><tr><td>&nbsp;</td><td class='ZOptionsField'><div id='";
t[o++]=s.id;
t[o++]="_REPLY_PREFIX' tabindex='90' /></td></tr><tr><td>&nbsp;</td><td class='ZOptionsField'>";
t[o++]=ZmMsg.prefixNote;
t[o++]="</td></tr>"
}
if(!appCtxt.isOffline){
t[o++]="<tr><td colspan=2><hr></td></tr><tr><td colspan=2><b>";
t[o++]=ZmMsg.composeMoreOptions;
t[o++]="</b></td></tr>"
}
t[o++]="</table></td></tr></table>";
return n?t.length:t.join("")
}
,{
id:"prefs.Pages#Composing"}
,false);
AjxTemplate.register("prefs.Pages#Signatures",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.signatures;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100% cellspacing=0><tr><td><div id='";
e[a++]=o.id;
e[a++]="_SIGNATURES' tabindex='20'></div></td></tr></table></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.signaturesUsing;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table id='";
e[a++]=o.id;
e[a++]="_SIG_TABLE' border=0 cellpadding=0 cellspacing=10><tr><td>&nbsp;</td><td>";
e[a++]=ZmMsg.newMessages;
e[a++]="</td><td>";
e[a++]=ZmMsg.repliesForwards;
e[a++]="</td></tr></table><hr><table width=100% cellspacing=0><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.placeSignature;
e[a++]="</td><td class='ZOptionsInfo'><div id='";
e[a++]=o.id;
e[a++]="_SIGNATURE_STYLE' tabindex='40'></div></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Signatures"}
,false);
AjxTemplate.register("prefs.Pages#SignatureSplitView",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]='<table border=0 cellpadding=0 cellspacing=0 width=\'100%\'><tr><td>&nbsp;</td><td><table border=0 cellpadding=0 cellspacing=0 width="100%"><tr><td class="Label">';
e[a++]=ZmMsg.nameLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_SIG_NAME' tabindex='50' size=30></td><td width=\"100%\">&nbsp;</td><td><div id='";
e[a++]=o.id;
e[a++]="_SIG_FORMAT' tabIndex='60'></div></td></tr></table></td></tr><tr><td width=180 height=150 valign='top'><div id='";
e[a++]=o.id;
e[a++]="_SIG_LIST' width='100%' tabindex='40'></div></td><td><div id='";
e[a++]=o.id;
e[a++]="_SIG_EDITOR' tabindex='80'></div></td></tr><tr><td><table><tr><td class=\"ZOptionsField\"><div id='";
e[a++]=o.id;
e[a++]="_SIG_NEW' tabIndex='86'></div></td><td class='ZOptionsField'>&nbsp;</td><td class=\"ZOptionsField\" align='right'><div id='";
e[a++]=o.id;
e[a++]="_SIG_DELETE' tabIndex='87'></div></td></tr></table></td><td align='right'><table border=0 cellpadding=0 cellspacing=0><tr><td class=\"Label\">";
e[a++]=ZmMsg.signatureVcardLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_SIG_VCARD' tabindex='85' size=30></td><td><div id='";
e[a++]=o.id;
e[a++]="_SIG_VCARD_BROWSE' style='padding-right:5px; padding-left:5px;' tabIndex='86'></div></td><td><div id='";
e[a++]=o.id;
e[a++]="_SIG_VCARD_CLEAR' tabIndex='87'></div></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#SignatureSplitView"}
,false);
AjxTemplate.register("prefs.Pages#Contacts",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<!-- REVERT_PAGE (button) --><div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div>";
if(o.activeAccount.isMain){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.options;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
if(!appCtxt.multiAccounts||o.activeAccount.isMain){
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.settingsLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_AUTO_ADD_ADDRESS' tabindex='40' type=checkbox></td></tr>"
}
if(!appCtxt.multiAccounts||(appCtxt.isFamilyMbox&&o.activeAccount.isMain)||(!o.activeAccount.isMain&&o.activeAccount.isZimbraAccount)){
if(o.isEnabled(ZmSetting.INITIALLY_SEARCH_GAL)){
e[a++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_INITIALLY_SEARCH_GAL' tabindex='50' type=checkbox></td></tr>"
}}
e[a++]="</table></td></tr></table>"
}
if(!appCtxt.multiAccounts||(appCtxt.isFamilyMbox&&o.activeAccount.isMain)||!o.activeAccount.isMain){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.autocomplete;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
if(appCtxt.isOffline&&!o.activeAccount.isMain){
e[a++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_AUTOCOMPLETE_SHARE' tabindex='55' type=checkbox></td></tr>"
}
if(o.activeAccount.isZimbraAccount){
if(o.isEnabled(ZmSetting.GAL_ENABLED)&&o.isEnabled(ZmSetting.GAL_AUTOCOMPLETE_ENABLED)){
e[a++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_GAL_AUTOCOMPLETE' tabindex='60' type=checkbox></td></tr>"
}
if(o.isEnabled(ZmSetting.SHARING_ENABLED)){
e[a++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_AUTOCOMPLETE_SHARED_ADDR_BOOKS' tabindex='70'></div></td></tr>"
}
e[a++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_AUTOCOMPLETE_ON_COMMA' tabindex='80'></div></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_AUTOCOMPLETE_NO_GROUP_MATCH' tabindex='90'></div></td></tr>"
}
e[a++]="</table></td></tr></table>"
}
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Contacts"}
,false);
AjxTemplate.register("prefs.Pages#Accounts",function(a,r,s,e){
var n=Boolean(e);
s=(typeof s=="string"?{
id:s}
:s)||{};
e=e||[];
var o=e.length;
e[o++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[o++]=s.id;
e[o++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[o++]=ZmMsg.accounts;
e[o++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td style='padding:0;margin:0;border:solid 1px silver'> <!-- TODO: correct border color --><div id='";
e[o++]=s.id;
e[o++]="_ACCOUNTS' tabindex='20'></div></td></tr><tr><td><table width=100%><colgroup><col width=1><col width=*><col width=1><col width=1></colgroup><tr><td align=left><button id='";
e[o++]=s.id;
e[o++]="_DELETE' tabindex='30'>";
e[o++]=ZmMsg.del;
e[o++]="</button></td><td>&nbsp;</td><td align=right>";
if(!appCtxt.isOffline&&(s.isEnabled(ZmSetting.POP_ACCOUNTS_ENABLED)||s.isEnabled(ZmSetting.IMAP_ACCOUNTS_ENABLED))){
e[o++]="<button id='";
e[o++]=s.id;
e[o++]="_ADD_EXTERNAL' tabindex='40'>";
e[o++]=ZmMsg.addExternalAccount;
e[o++]="</button>"
}
e[o++]="</td><td align=right>";
if(s.isEnabled(ZmSetting.IDENTITIES_ENABLED)){
e[o++]="<button id='";
e[o++]=s.id;
e[o++]="_ADD_PERSONA' tabindex='50'>";
e[o++]=ZmMsg.addPersona;
e[o++]="</button>"
}
e[o++]='</td></tr></table></td></tr></table></td></tr></table><div id="';
e[o++]=s.id;
e[o++]="_PRIMARY\" class='ZAccountSettings'>";
e[o++]=AjxTemplate.expand("#PrimaryAccount",s);
e[o++]="</div>";
if(s.isEnabled(ZmSetting.POP_ACCOUNTS_ENABLED)||s.isEnabled(ZmSetting.IMAP_ACCOUNTS_ENABLED)){
e[o++]='<div id="';
e[o++]=s.id;
e[o++]="_EXTERNAL\" class='ZAccountSettings' style='display:none;'>";
e[o++]=AjxTemplate.expand("#ExternalAccount",s);
e[o++]="</div>";
var i=ZmDataSource.getProviders();
for(var t in i){
if(!AjxTemplate.getTemplate("prefs.Pages#ExternalAccount-"+t)){
continue
}
e[o++]='<div id="';
e[o++]=s.id;
e[o++]="_";
e[o++]=t;
e[o++]="\" class='ZAccountSettings' style='display:none;'>";
e[o++]=AjxTemplate.expand("#ExternalAccount-"+t,s);
e[o++]="</div>"
}}
if(s.isEnabled(ZmSetting.IDENTITIES_ENABLED)){
e[o++]='<div id="';
e[o++]=s.id;
e[o++]="_PERSONA\" class='ZAccountSettings' style='display:none;'>";
e[o++]=AjxTemplate.expand("#Persona",s);
e[o++]="</div>"
}
return n?e.length:e.join("")
}
,{
id:"prefs.Pages#Accounts"}
,false);
AjxTemplate.register("prefs.Pages#PrimaryAccount",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.accountHeaderPrimary;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.emailAddrLabel;
e[a++]="</td><td class='ZOptionsField'><span id='";
e[a++]=o.id;
e[a++]="_PRIMARY_EMAIL' tabindex='1010'></span></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.accountNameLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_PRIMARY_NAME' tabindex='1020'></td></tr>";
if(appCtxt.isFamilyMbox){
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.isVisible;
e[a++]=":</td><td class='ZOptionsField'><span id='";
e[a++]=o.id;
e[a++]="_PRIMARY_VISIBLE' tabindex='1021'></span></td></tr>"
}
e[a++]="<tr><td colspan=2><hr></td></tr><tr><td style='text-align:left' colspan=2><b>";
e[a++]=ZmMsg.accountFromPrompt;
e[a++]="</b></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.fromLabel;
e[a++]="</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.fromDetail;
e[a++]="</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table><tr><td style='padding-right:.5em;'><input id='";
e[a++]=o.id;
e[a++]="_PRIMARY_FROM_NAME' tabindex='1030' size=30></td><td><select id='";
e[a++]=o.id;
e[a++]="_PRIMARY_FROM_EMAIL' tabindex='1035' size=40></select></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.setReplyTo;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_PRIMARY_REPLY_TO' tabindex='1040' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table cellpadding='0' cellspacing='0' border='0'><tr><td style='padding-right:.5em;'><input id='";
e[a++]=o.id;
e[a++]="_PRIMARY_REPLY_TO_NAME' tabindex='1050' size=30></td><td><select id='";
e[a++]=o.id;
e[a++]="_PRIMARY_REPLY_TO_EMAIL' tabindex='1060'></select></td></tr></table></td></tr><tr valign=top><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.signatureLabel;
e[a++]="</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.manageSignatures;
e[a++]="</td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#PrimaryAccount"}
,false);
AjxTemplate.register("prefs.Pages#ExternalAccount",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.accountHeaderExternal;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td colspan=2><div id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_ALERT'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.emailAddrLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_EMAIL' tabindex='2010' size=30></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.accountNameLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_NAME' tabindex='2020' size=30></div></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.accountTypeLabel;
e[a++]="</td>";
if(o.isEnabled(ZmSetting.POP_ACCOUNTS_ENABLED)&&o.isEnabled(ZmSetting.IMAP_ACCOUNTS_ENABLED)){
e[a++]="<td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_ACCOUNT_TYPE' tabindex='2030'></div></td>"
}else{
if(o.isEnabled(ZmSetting.POP_ACCOUNTS_ENABLED)){
e[a++]="<td class='ZOptionsField'>POP3</td>"
}else{
e[a++]="<td class='ZOptionsField'>IMAP</td>"
}}
e[a++]="</tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.accountUsernameLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_USERNAME' tabindex='2040' size=30></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.accountServerLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_HOST' tabindex='2050' size=30></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.passwordLabel;
e[a++]="</td><td class='ZOptionsField'><!-- NOTE: impossible to set a hint because it will just be turned into ****** --><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_PASSWORD' tabindex='2060' type=password></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.advancedSettingsLabel;
e[a++]="</td><td class='ZOptionsField'><table cellpadding='0' cellspacing='0' border='0'><tr><td><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_CHANGE_PORT' tabindex='2070' type=checkbox></td><td><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_PORT' tabindex='2080' size=4></td><td class='ZOptionsInfo'><span id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_PORT_DEFAULT'></span></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_SSL' tabindex='2090' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table><tr><td><div id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_TEST' tabindex='2100'></div></td></tr></table></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabelTop'>";
e[a++]=ZmMsg.accountDownloadToLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_DOWNLOAD_TO' tabindex='2110'></div></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><hr></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_DELETE_AFTER_DOWNLOAD' tabindex='2120' type=checkbox></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel' style='text-align:left' colspan=2>";
e[a++]=ZmMsg.accountFromPrompt;
e[a++]="</td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.fromLabel;
e[a++]="</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.fromDetail;
e[a++]="</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table><tr><td style='padding-right:.5em;'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_FROM_NAME' tabindex='2130' size=30></td><td><select id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_FROM_EMAIL' tabindex='2135' size=40></select></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.setReplyTo;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_REPLY_TO' tabindex='2140' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table cellpadding='0' cellspacing='0' border='0'><tr><td style='padding-right:.5em;'><input id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_REPLY_TO_NAME' tabindex='2150' size=30></td><td><select id='";
e[a++]=o.id;
e[a++]="_EXTERNAL_REPLY_TO_EMAIL' tabindex='2160'></select></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.signatureLabel;
e[a++]="</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.manageSignatures;
e[a++]="</td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#ExternalAccount"}
,false);
AjxTemplate.register("prefs.Pages#Persona",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.personaSettings;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.accountPersonaInstructions;
e[a++]="</td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.accountPersonaLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_PERSONA_NAME' tabindex='3010'></div></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel' style='text-align:left' colspan=2>";
e[a++]=ZmMsg.accountFromPrompt;
e[a++]="</td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.fromLabel;
e[a++]="</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.fromDetail;
e[a++]="</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField' style='padding-left:2em;'><table><tr><td style='padding-right:.5em;'><input id='";
e[a++]=o.id;
e[a++]="_PERSONA_FROM_NAME' tabindex='3020' size=30></td><td><select id='";
e[a++]=o.id;
e[a++]="_PERSONA_FROM_EMAIL' tabindex='3030' size=40></select></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.setReplyTo;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_PERSONA_REPLY_TO' tabindex='3040' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField' style='padding-left:2em;'><table><tr><td style='padding-right:.5em;'><input id='";
e[a++]=o.id;
e[a++]="_PERSONA_REPLY_TO_NAME' tabindex='3050' size=30></td><td><select id='";
e[a++]=o.id;
e[a++]="_PERSONA_REPLY_TO_EMAIL' tabindex='3060' size=40></select></td></tr></table></td></tr><tr valign=top><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.signatureLabel;
e[a++]="</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.manageSignatures;
e[a++]="</td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.accountPersonaUseLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_PERSONA_WHEN_SENT_TO' tabindex='3080' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsInfo' style='padding-left:2em;'><input id='";
e[a++]=o.id;
e[a++]="_PERSONA_WHEN_SENT_TO_LIST' tabindex='3085' size=80></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsInfo' style='padding-left:2em;'>";
e[a++]=ZmMsg.whenSentToHint;
e[a++]="</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_PERSONA_WHEN_IN_FOLDER' tabindex='3090' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField' style='padding-left:2em;'><table><tr><td><input id='";
e[a++]=o.id;
e[a++]="_PERSONA_WHEN_IN_FOLDER_LIST' tabindex='3100' size=60></td><td><div id='";
e[a++]=o.id;
e[a++]="_PERSONA_WHEN_IN_FOLDER_BUTTON' tabindex='3110'></div></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsInfo' style='padding-left:2em;'>";
e[a++]=ZmMsg.whenInFolderHint;
e[a++]="</td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Persona"}
,false);
AjxTemplate.register("prefs.Pages#MailFilters",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]='<div class="rightAlign">';
e[a++]=ZmMsg.filterRuleChangesSavedImmediately;
e[a++]="</div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionTabView'><table width=100% cellspacing=0 cellpadding=0><tr><td><div id='";
e[a++]=o.id;
e[a++]="_tabview' tabindex='20'></div></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#MailFilters"}
,false);
AjxTemplate.register("prefs.Pages#MailFilter",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100% cellpadding=0><tr><td><div id='";
e[a++]=o.id;
e[a++]="_toolbar' tabindex='20'></div></td></tr><tr><td><div id='";
e[a++]=o.id;
e[a++]="_list' tabindex='30'></div></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#MailFilter"}
,false);
AjxTemplate.register("prefs.Pages#MailFilterRule",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table width='100%'><tr><td width='1%' nowrap>";
e[a++]=ZmMsg.filterNameLabel;
e[a++]="</td><td><input id='";
e[a++]=o.id;
e[a++]="_name' type='text' width=100 tabindex='10'></td><td width='1%' style='text-align:right; white-space:nowrap;'><input id='";
e[a++]=o.id;
e[a++]="_active' type='checkbox' name='cbActive' checked tabindex='20'>";
e[a++]=ZmMsg.active;
e[a++]="</td></tr></table><br><div style='color:#555555'><div id='";
e[a++]=o.id;
e[a++]="_condition' tabindex='30'></div></div><fieldset class='FilterRuleSection'><div style='overflow-x:hidden;overflow-y:scroll;height:145px;'><table id='";
e[a++]=o.id;
e[a++]="_conditions' width='100%' border=0 cellpadding=0 cellspacing=0 tabindex='40'><tbody></tbody></table></div></fieldset><br><div style='color:#555555'>";
e[a++]=ZmMsg.filterActions;
e[a++]="</div><fieldset class='FilterRuleSection'><div style='overflow-x:hidden;overflow-y:scroll;height:82px'><table id='";
e[a++]=o.id;
e[a++]="_actions' width='100%' border=0 cellpadding=0 cellspacing=0 tabindex='50'><tbody></tbody></table></div></fieldset><input id='";
e[a++]=o.id;
e[a++]="_stop' type='checkbox' name='cbStop' checked tabindex='60'>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#MailFilterRule"}
,false);
AjxTemplate.register("prefs.Pages#Calendar",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div>";
if(o.activeAccount.isMain){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.general;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.defaultViewLabel;
e[a++]="</td><td class='ZOptionsField'><select id='";
e[a++]=o.id;
e[a++]="_CALENDAR_INITIAL_VIEW' tabindex='20'></select></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.calendarStartWeekLabel;
e[a++]="</td><td class='ZOptionsField'><select id='";
e[a++]=o.id;
e[a++]="_CAL_FIRST_DAY_OF_WEEK' tabindex='30'></select></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.calendarInitialApptVisibility;
e[a++]="</td><td class='ZOptionsField'><select id='";
e[a++]=o.id;
e[a++]="_CAL_APPT_VISIBILITY' tabindex='35'></select></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_ALWAYS_SHOW_MINI_CAL' tabindex='40' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_SHOW_CALENDAR_WEEK' tabindex='40' type=checkbox></td></tr>";
if(!appCtxt.multiAccounts){
e[a++]="<tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_AUTO_ADD_INVITES' tabindex='40' type=checkbox></td></tr>"
}
e[a++]="<tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.deleteInviteOnReplyLabel;
e[a++]="</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_DELETE_INVITE_ON_REPLY' tabindex='50' type=checkbox></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.forwardInvitesToLabel;
e[a++]="</td><td class='ZOptionsField' style='padding-left:2em;'>";
e[a++]=ZmMsg.forwardInvitesTo;
e[a++]=" <input id='";
e[a++]=o.id;
e[a++]="_CAL_INV_FORWARDING_ADDRESS' tabindex='110'></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.apptReminderLabel;
e[a++]="</td><td class='ZOptionsField'><select id='";
e[a++]=o.id;
e[a++]="_CAL_REMINDER_WARNING_TIME' tabindex='60'></select></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_SHOW_PAST_DUE_REMINDERS' tabindex='59' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_REMINDER_NOTIFY_SOUNDS' tabindex='65' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_REMINDER_NOTIFY_BROWSER' tabindex='68' type=checkbox></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table cellspacing=0 cellpadding=0><tr><td><div id='";
e[a++]=o.id;
e[a++]="_CAL_REMINDER_NOTIFY_TOASTER' tabindex='69'></div></td></tr></table></td></tr></table></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.calendarWorkHoursHeader;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain' id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_HOURS'></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.apptCreating;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_USE_QUICK_ADD' tabindex='70' type=checkbox></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_SHOW_TIMEZONE' tabindex='80' type=checkbox></td></tr></table></td></tr></table>"
}else{
if(appCtxt.multiAccounts&&o.activeAccount.isZimbraAccount&&appCtxt.getSettings(o.activeAccount).attrExists(ZmSetting.CAL_AUTO_ADD_INVITES)){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.general;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_AUTO_ADD_INVITES' tabindex='81' type=checkbox></td></tr></table></td></tr></table>"
}}
if(o.isAclSupported){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.calPerms;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td colspan=2>";
e[a++]=AjxMessageFormat.format(ZmMsg.calPermsNote,o.domain);
e[a++]="</td></tr><tr><td colspan=2>&nbsp;</td></tr><tr><td class='ZOptionsLabelTop'>";
e[a++]=ZmMsg.freeBusyLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_CAL_FREE_BUSY_ACL' tabindex='82'></div></td></tr><tr><td>&nbsp;</td><td><textarea id='";
e[a++]=o.id;
e[a++]="_CAL_FREE_BUSY_ACL_USERS' tabindex='84' rows=3 cols=70></textarea></td></tr><tr><td class='ZOptionsLabelTop'>";
e[a++]=ZmMsg.invitesLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_CAL_INVITE_ACL' tabindex='86'></div></td></tr><tr><td>&nbsp;</td><td><textarea id='";
e[a++]=o.id;
e[a++]="_CAL_INVITE_ACL_USERS' tabindex='88' rows=3 cols=70></textarea></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_CAL_SEND_INV_DENIED_REPLY' tabindex='40' type=checkbox></td></tr></table></td></tr></table>"
}
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>Apple iCal</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td colspan=2>";
e[a++]=ZmMsg.calAppleICalNote;
e[a++]="</td></tr><tr><td colspan=2>&nbsp;</td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_ENABLE_APPL_ICAL_DELEGATION' tabindex='50' type=checkbox></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Calendar"}
,false);
AjxTemplate.register("prefs.Pages#WorkHours",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.calendarWorkWeek;
e[a++]="</td><td class='ZOptionsField'><table><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_0' tabindex='41'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_1' tabindex='42'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_2' tabindex='43'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_3' tabindex='44'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_4' tabindex='45'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_5' tabindex='46'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_6' tabindex='47'></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.calendarWorkHours;
e[a++]="</td><td class='ZOptionsField'><table><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_HOURS_NORMAL'><td><td> ";
e[a++]=ZmMsg.calendarWorkHoursNormal;
e[a++]=" <td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME' tabindex='48'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME' tabindex='49'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_HOURS_CUSTOM'><td><td> ";
e[a++]=ZmMsg.calendarWorkHoursCustom;
e[a++]=" <td><td id='";
e[a++]=o.id;
e[a++]="_CAL_CUSTOM_WORK_HOURS'></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'>";
e[a++]=ZmMsg.calendarWorkHoursDisclaimer;
e[a++]=" ";
e[a++]=AjxTimezone.getMediumName(appCtxt.get(ZmSetting.DEFAULT_TIMEZONE));
e[a++]="</td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#WorkHours"}
,false);
AjxTemplate.register("prefs.Pages#CustomWorkHoursDlg",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=2 cellpadding=2 width=300><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_0' tabindex='10'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME_0' tabindex='20'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME_0' tabindex='30'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_1' tabindex='40'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME_1' tabindex='50'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME_1' tabindex='60'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_2' tabindex='70'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME_2' tabindex='80'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME_2' tabindex='90'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_3' tabindex='100'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME_3' tabindex='110'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME_3' tabindex='120'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_4' tabindex='130'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME_4' tabindex='140'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME_4' tabindex='150'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_5' tabindex='160'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME_5' tabindex='170'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME_5' tabindex='180'></td></tr><tr><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_DAY_6' tabindex='190'></td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_START_TIME_6' tabindex='200'></td><td> ";
e[a++]=ZmMsg.calendarWorkHoursDelimiter;
e[a++]=" </td><td id='";
e[a++]=o.id;
e[a++]="_CAL_WORKING_END_TIME_6' tabindex='210'></td></tr><tr><td colspan=\"4\">";
e[a++]=ZmMsg.calendarWorkHoursDisclaimer;
e[a++]=" ";
e[a++]=AjxTimezone.getMediumName(appCtxt.get(ZmSetting.DEFAULT_TIMEZONE));
e[a++]="</td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#CustomWorkHoursDlg"}
,false);
AjxTemplate.register("prefs.Pages#IM",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.options;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%>";
if(o.isEnabled(ZmSetting.IM_PREF_AUTO_LOGIN)){
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.imLoginLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_AUTO_LOGIN' tabindex='20'></div></td></tr><tr><td colspan=2><hr></td></tr>"
}
if(o.isEnabled(ZmSetting.IM_PREF_INSTANT_NOTIFY)){
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.imNotificationsLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_INSTANT_NOTIFY' tabindex='30'></div></td></tr>"
}
e[a++]="<tr><td class='ZOptionsLabel'>";
e[a++]=o.isEnabled(ZmSetting.IM_PREF_INSTANT_NOTIFY)?"&nbsp;":ZmMsg.imNotificationsLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_NOTIFY_PRESENCE' tabindex='50'></div></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_NOTIFY_STATUS' tabindex='60'></div></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.imArrivalLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_NOTIFY_SOUNDS' tabindex='35'></div></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_FLASH_BROWSER' tabindex='40'></div></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table cellspacing=0 cellpadding=0><tr><td><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_DESKTOP_ALERT' tabindex='40'></div></td><td>";
e[a++]=ZmMsg.showPopupBrowserPlusLink;
e[a++]="</td></tr></table></td></tr><tr><td colspan=2><hr></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.imChat;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_LOGCHATS_ENABLED' tabindex='70'></div></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsField'><table cellspacing=\"0\" cellpadding=\"0\"><tr><td colspan=\"2\"><div id='";
e[a++]=o.id;
e[a++]="_IM_PREF_REPORT_IDLE' tabindex='70'></div></td></tr><tr><td style=\"padding-left: 10px; text-align: right;\">";
e[a++]=ZmMsg.imPrefIdleTimeoutLabel;
e[a++]='</td><td style="padding: 3px"><div id=\'';
e[a++]=o.id;
e[a++]="_IM_PREF_IDLE_TIMEOUT' tabindex='80'></div></td></tr><tr><td style=\"padding-left: 10px; text-align: right;\">";
e[a++]=ZmMsg.imPrefIdleStatusLabel;
e[a++]='</td><td style="padding: 3px"><div id=\'';
e[a++]=o.id;
e[a++]="_IM_PREF_IDLE_STATUS' tabindex='90'></div></td></tr></table></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#IM"}
,false);
AjxTemplate.register("prefs.Pages#ImAccountLabel",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]='<table class="ImAccountLabel"><tr><td>';
e[a++]=o.name;
e[a++]="</td><td style='width:1%;'><img src=\"";
e[a++]=appContextPath;
e[a++]="/public/tmp/";
e[a++]=o.nameLower;
e[a++]='.png"/></td></tr></table>';
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#ImAccountLabel"}
,false);
AjxTemplate.register("prefs.Pages#ZmImAccountRow",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]='<table><tr><td class="ZOptionsLabel" style="vertical-align:top;"><table class="ImAccountLabel"><tr><td>';
e[a++]=o.name;
e[a++]="</td><td style='width:1%;'><img src=\"";
e[a++]=appContextPath;
e[a++]="/public/tmp/";
e[a++]=o.nameLower;
e[a++]='.png"/></td></tr></table></td><td id = "';
e[a++]=o.id;
e[a++]='_valueCell" class="ZOptionsField" width="100%"></td></tr></table>';
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#ZmImAccountRow"}
,false);
AjxTemplate.register("prefs.Pages#ZmImAccountSeparator",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<hr>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#ZmImAccountSeparator"}
,false);
AjxTemplate.register("prefs.Pages#ZmImGatewayControl",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]='<table><tr><td class="ImAccountGatewayLabel">';
e[a++]=o.nameLabel;
e[a++]='</td><td class="ImAccountGatewayValue"><div id=\'';
e[a++]=o.id;
e[a++]='_nameField\'/></td></tr><tr><td class="ImAccountGatewayLabel">';
e[a++]=ZmMsg.passwordLabel;
e[a++]='</td><td class="ImAccountGatewayValue"><div id=\'';
e[a++]=o.id;
e[a++]='_passwordField\'/></td></tr><tr><td class="ImAccountLabel">&nbsp</td><td class="ImAccountGatewayValue"><div id=\'';
e[a++]=o.id;
e[a++]="_clearButton'/></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#ZmImGatewayControl"}
,false);
AjxTemplate.register("prefs.Pages#Shortcuts",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.keyboardShortcuts;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><div align=\"right\"><div id='";
e[a++]=o.id;
e[a++]="_SHORTCUT_PRINT' style='width:80px;'></div></div><div id='";
e[a++]=o.id;
e[a++]="_SHORTCUT_LIST'></div></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Shortcuts"}
,false);
AjxTemplate.register("prefs.Pages#AccountTestContent",function(t,r,s,e){
var n=Boolean(e);
s=(typeof s=="string"?{
id:s}
:s)||{};
e=e||[];
var o=e.length;
e[o++]="<table id='";
e[o++]=s.id;
e[o++]="_accts' class='ZmDataSourceTestTable' border=0 cellspacing=0 cellpadding=3><tr><th>";
e[o++]=ZmMsg.account;
e[o++]="</th><th>";
e[o++]=ZmMsg.status;
e[o++]="</th></tr>";
for(var a=0;
a<s.accounts.length;
a++){
e[o++]=AjxTemplate.expand("#AccountTestItem",{
id:s.id,account:s.accounts[a]}
)
}
e[o++]="</table>";
return n?e.length:e.join("")
}
,{
id:"prefs.Pages#AccountTestContent"}
,false);
AjxTemplate.register("prefs.Pages#AccountTestItem",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<tr><td class='ZmTestItem'>";
e[a++]=AjxStringUtil.htmlEncode(o.account.name);
e[a++]="</td><td id='";
e[a++]=o.account["id"];
e[a++]="_test_status' class='ZmTestStatus'></td></tr><tr id='";
e[a++]=o.account["id"];
e[a++]="_test_details' style='display:none'><td><table border='0'><tr valign='top'><td class='ZmTestError'>";
e[a++]=ZmMsg.errorLabel;
e[a++]="</td><td id='";
e[a++]=o.account["id"];
e[a++]="_test_error' class='ZmTestError'></td></tr><tr valign='top'><td class='ZmTestNote'>";
e[a++]=ZmMsg.noteLabel;
e[a++]="</td><td class='ZmTestNote'>";
e[a++]=ZmMsg.popAccountTestNote;
e[a++]="</td></tr></table></td></tr>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#AccountTestItem"}
,false);
AjxTemplate.register("prefs.Pages#Import",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellpadding=3 cellspacing=3><tr><td class='ZOptionsLabel'>";
e[a++]=o.label;
e[a++]="</td><td class='ZOptionsInfo'><form id='";
e[a++]=o.id;
e[a++]="_form'\n";
e[a++]="\t\t\t\t  action='";
e[a++]=o.action;
e[a++]="' method='POST' enctype='multipart/form-data'\n";
e[a++]="\t\t\t\t  style='margin: 0px; padding: 0px;'><input id='";
e[a++]=o.id;
e[a++]="_input' tabindex='10'\n";
e[a++]="\t\t\t\t\t   type='file' name='";
e[a++]=o.name;
e[a++]="'\n";
e[a++]="\t\t\t\t\t   style='font-family:Tahoma; font-size:10px'></form></td></tr><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsInfo'><div id='";
e[a++]=o.id;
e[a++]="_button' tabindex='20'></div></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Import"}
,false);
AjxTemplate.register("prefs.Pages#Export",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellpadding=3 cellspacing=3><tr><td class='ZOptionsLabel'>&nbsp;</td><td class='ZOptionsInfo'><div id='";
e[a++]=o.id;
e[a++]="_options' tabindex=\"10\"></div></td><td class='ZOptionsInfo'><div id='";
e[a++]=o.id;
e[a++]='_button\' tabindex="20"></div></td></tr></table>';
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Export"}
,false);
AjxTemplate.register("prefs.Pages#Zimlets",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.zimlets;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td><div>";
e[a++]=ZmMsg.zimletsPrefsMsg;
e[a++]="</div><br/></td></tr><tr><td><div id='";
e[a++]=o.id;
e[a++]="_CHECKED_ZIMLETS' tabindex='30'></div></td></tr></table></td></tr></table>";
if(appCtxt.isOffline){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.zimletInstall;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td><div>";
e[a++]=ZmMsg.zimletsPrefsUpload;
e[a++]="</div><br/></td></tr><tr><td><table border=0><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.fileLabel;
e[a++]="</td><td><form id='";
e[a++]=o.id;
e[a++]="_form' action='";
e[a++]=o.action;
e[a++]="' method='POST' enctype='multipart/form-data' style='margin:0px; padding:0px;'><input id='";
e[a++]=o.id;
e[a++]="_input' tabindex='40' type='file' name='zimletUpload' style='font-family:Tahoma; font-size:10px'></form></td></tr><tr><td></td><td id='";
e[a++]=o.id;
e[a++]="_button'></td></tr></table></td></tr></table></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.zimletSyncData;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td><select id='";
e[a++]=o.id;
e[a++]="_OFFLINE_ZIMLET_SYNC_ACCOUNT_ID' tabindex='130'></select></td></tr></table></td></tr></table>"
}
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Zimlets"}
,false);
AjxTemplate.register("prefs.Pages#BackUp",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.offlineBackupHeader;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100% cellpadding=5><tr><td class='ZOptionsLabel'></td><td class='ZOptionsField' colspan=2><div id='";
e[a++]=o.id;
e[a++]="_button' tabindex='200'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.offlineBackUpAccounts;
e[a++]="</td><td class='ZOptionsField' colspan=2><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_BACKUP_ACCOUNT_ID' tabindex='200'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.offlineBackUpInterval;
e[a++]="</td><td class='ZOptionsField' colspan=2><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_BACKUP_INTERVAL' tabindex='200'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.offlineBackUpPath;
e[a++]="</td><td class='ZOptionsField' colspan=2><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_BACKUP_PATH' tabindex='210'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.offlineBackUpRetention;
e[a++]="</td><td class='ZOptionsField' width=\"2%\"><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_BACKUP_KEEP' tabindex='230'></div></td><td>";
e[a++]=ZmMsg.offlineBackUpKeep;
e[a++]="</td></tr></table></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.offlineBackUpRestore;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100% cellpadding=5><tr><td class='ZOptionsField' colspan=2><div id='";
e[a++]=o.id;
e[a++]="_OFFLINE_BACKUP_RESTORE' tabindex='300'></div></td></tr><tr><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_restore_button' tabindex='320'></div></td><td>&nbsp;</td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#BackUp"}
,false);
AjxTemplate.register("prefs.Pages#SharingPrefPage",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.pendingSharesTitle;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td><div id='";
e[a++]=o.id;
e[a++]="_shareForm'></div></td></tr></table></td></tr><tr><td class='ZOptionsSectionMain'><div><div id='";
e[a++]=o.id;
e[a++]="_pendingShares'></div></div></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.mountedSharesTitle;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><div><div id='";
e[a++]=o.id;
e[a++]="_mountedShares'></div></div></td></tr></table><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.sharingByMe;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><div id='";
e[a++]=o.id;
e[a++]="_sharesBy'></div></td></tr><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td><div class=\"sharingPageListTitle\">";
e[a++]=ZmMsg.shareAFolder;
e[a++]="</div></td></tr><tr><td><div id='";
e[a++]=o.id;
e[a++]="_grantForm'></div></td></tr></table></td></tr></table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#SharingPrefPage"}
,false);
AjxTemplate.register("prefs.Pages#ShareForm",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]='<table><tr><td colspan=3><div id="';
e[a++]=o.id;
e[a++]='_group" class="ZOptionsInfo" tabindex=\'5\'></div></td></tr><tr><td><div id="';
e[a++]=o.id;
e[a++]='_user" class="ZOptionsInfo" tabindex=\'10\'></div></td><td><div id="';
e[a++]=o.id;
e[a++]='_owner" class="ZOptionsInfo" tabindex=\'20\'></div></td><td><div id="';
e[a++]=o.id;
e[a++]="_findButton\" tabindex='30'></div></td></tr></table><br/>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#ShareForm"}
,false);
AjxTemplate.register("prefs.Pages#GrantForm",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<div>";
e[a++]=ZmMsg.grantFormText;
e[a++]="</div><br/><table cellspacing=5><tr><td>";
e[a++]=ZmMsg.folderType;
e[a++]="</td><td><div id='";
e[a++]=o.id;
e[a++]="_folderType' tabindex='40'></div></td><td><div id='";
e[a++]=o.id;
e[a++]="_shareButton' tabindex='50'></div></td></tr></table><br/>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#GrantForm"}
,false);
AjxTemplate.register("prefs.Pages#MobileDevices",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.mobileDevices;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td><div id='";
e[a++]=o.id;
e[a++]="_deviceToolbar' tabindex='20'></div></td></tr><tr><td><div id='";
e[a++]=o.id;
e[a++]="_deviceList' tabindex='30'></div></td></tr></table></td></tr></table>";
e[a++]=ZmMsg.mobileDeviceChangesSavedImmediately;
e[a++]="<br>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#MobileDevices"}
,false);
AjxTemplate.register("prefs.Pages#MobileDeviceInfo",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0><tr><td>";
e[a++]=ZmMsg.mobileDevice;
e[a++]=":</td><td>";
e[a++]=o.device.type;
e[a++]="</td></tr><tr><td>";
e[a++]=ZmMsg.mobileUserAgent;
e[a++]=":</td><td>";
e[a++]=o.device.ua;
e[a++]="</td></tr><tr><td>";
e[a++]=ZmMsg.mobileDeviceId;
e[a++]=":</td><td>";
e[a++]=o.device.id;
e[a++]="</td></tr><tr><td>";
e[a++]=ZmMsg.mobileProtocolVersion;
e[a++]=":</td><td>";
e[a++]=o.device.protocol;
e[a++]="</td></tr><tr><td>";
e[a++]=ZmMsg.mobileProvisionable;
e[a++]=":</td><td>";
e[a++]=o.device.provisionable?AjxMsg.yes:AjxMsg.no;
e[a++]="</td></tr><tr><td>";
e[a++]=ZmMsg.status;
e[a++]=":</td><td>";
e[a++]=o.device.getStatusString();
e[a++]="</td></tr>";
if(o.device.firstReqReceived){
e[a++]="<tr><td>";
e[a++]=ZmMsg.mobileFirstReqReceived;
e[a++]=":</td><td>";
e[a++]=o.device.getFirstReqReceivedString();
e[a++]="</td></tr>"
}
if(o.device.lastPolicyUpdate){
e[a++]="<tr><td>";
e[a++]=ZmMsg.mobileLastPolicyUpdate;
e[a++]=":</td><td>";
e[a++]=o.device.getLastPolicyUpdateString();
e[a++]="</td></tr>"
}
if(o.device.remoteWipeReqTime){
e[a++]="<tr><td>";
e[a++]=ZmMsg.mobileRemoteWipeReq;
e[a++]=":</td><td>";
e[a++]=o.device.getRemoteWipeReqTimeString();
e[a++]="</td></tr>"
}
if(o.device.remoteWipeAckTime){
e[a++]="<tr><td>";
e[a++]=ZmMsg.mobileRemoteWipeAck;
e[a++]=":</td><td>";
e[a++]=o.device.getRemoteWipeAckTimeString();
e[a++]="</td></tr>"
}
e[a++]="</table>";
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#MobileDeviceInfo"}
,false);
AjxTemplate.register("prefs.Pages#Notifications",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]="<!-- REVERT_PAGE (button) --><div align=right style='margin-right: 20px; margin-bottom: 10px;'><div id='";
e[a++]=o.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div></div><table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.notificationsEmail;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table width=100%><!--<tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.emailNotificationsLabel;
e[a++]="</td>--><!--<td class='ZOptionsField'><input id='";
e[a++]=o.id;
e[a++]="_EMAIL_ENABLED' tabindex='100' type='checkbox'></td>--><!--</tr>--><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.emailNotificationsDescription;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_EMAIL' tabindex='200'></div></td></tr></table></td></tr></table>";
if(appCtxt.get(ZmSetting.CAL_DEVICE_EMAIL_REMINDERS_ENABLED)){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg.notificationsDeviceEmail;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><div class='ZOptionsSectionMain' style=\"width:100%;padding:0px;\"><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0><tr><td class='ZOptionsSectionMain'><table width=100%><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.deviceEmailNotificationsRegionLabel;
e[a++]='</td><td class=\'ZOptionsField\' colspan="4"><table border="0" cellpadding="0" cellspacing="0"><tr><td><div id=\'';
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_REGION' tabindex='400'></div></td></tr></table></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.deviceEmailNotificationsCarrierLabel;
e[a++]="</td><td class='ZOptionsField' colspan=\"4\"><div id='";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_CARRIER' tabindex='500'></div></td></tr><tr id='";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_PHONE_row'><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.deviceEmailNotificationsPhoneNumberLabel;
e[a++]="</td><td class='ZOptionsField' colspan=\"3\"><div id='";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_PHONE' tabindex='600'></div></td><td class=\"ZOptionsField\"><div id=\"";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_PHONE_SEND_CODE\" tabindex='610'></div></td></tr><tr id=\"";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_CUSTOM_NUMBER_row\"><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.deviceEmailNotificationsCustomeEmailLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_CUSTOM_NUMBER' tabindex='700'></div></td><td class=\"ZOptionsField\">@</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_CUSTOM_ADDRESS' tabindex='710'></div></td><td class=\"ZOptionsField\"><div id=\"";
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_CUSTOM_SEND_CODE\" tabindex='720'></div></td></tr><tr id='";
e[a++]=o.id;
e[a++]='_DEVICE_EMAIL_PHONE_HINT_row\'><td></td><td class="ZOptionsInfo" colspan="4"><div id="';
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_PHONE_HINT\"></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.deviceEmailNotificationsVerificationCodeLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]='_DEVICE_EMAIL_CODE\' tabindex=\'800\'></div></td><td class="ZOptionsField" colspan="3"><div id="';
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_CODE_VALIDATE\" tabindex='810'></div></td></tr><tr><td class='ZOptionsLabel'>";
e[a++]=ZmMsg.deviceEmailNotificationsVerificationStatusLabel;
e[a++]="</td><td class='ZOptionsField'><div id='";
e[a++]=o.id;
e[a++]='_DEVICE_EMAIL_CODE_STATUS\' tabindex=\'900\'></div></td><td class="ZOptionsField" colspan="3"><div id="';
e[a++]=o.id;
e[a++]="_DEVICE_EMAIL_CODE_INVALIDATE\" tabindex='910'></div></td></tr></table></td></tr></table></div>"
}
return i?e.length:e.join("")
}
,{
id:"prefs.Pages#Notifications"}
,false)
}
if(AjxPackage.define("prefs.Widgets")){
AjxTemplate.register("prefs.Widgets#infoBox",function(t,n,o,e){
var i=Boolean(e);
o=(typeof o=="string"?{
id:o}
:o)||{};
e=e||[];
var a=e.length;
e[a++]='<div id="';
e[a++]=o.id;
e[a++]="_infoBox\" class='ZInfoBox'><table id='";
e[a++]=o.id;
e[a++]="_infoBox_outer' width='100%' cellspacing=0 cellpadding=0><tr><td rowspan=2 style='vertical-align:top'><div class='ImgInformation_32'></div></td><td><div id=\"";
e[a++]=o.id;
e[a++]='_infoBox_close" class="ZInfoTitleClose" onclick=\'Dwt.toggle("';
e[a++]=o.id;
e[a++]="_infoBox_container\")'>";
e[a++]=ZmMsg.close;
e[a++]='</div><div id="';
e[a++]=o.id;
e[a++]="_title\" class='ZInfoTitle'>";
e[a++]=o._labels["infoTitle"];
e[a++]='</div></td></tr><tr><td id="';
e[a++]=o.id;
e[a++]='_body">';
e[a++]=o._labels["infoContents"];
e[a++]="</td></tr></table></div>";
return i?e.length:e.join("")
}
,{
id:"prefs.Widgets#infoBox","xml:space":"strip"}
,false);
AjxTemplate.register("prefs.Widgets",AjxTemplate.getTemplate("prefs.Widgets#infoBox"),AjxTemplate.getParams("prefs.Widgets#infoBox"))
};
