
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("SpreadsheetPreview")){
if(AjxPackage.define("ajax.util.AjxStringUtil")){
AjxStringUtil=function(){};
AjxStringUtil.TRIM_RE=/^\s+|\s+$/g;
AjxStringUtil.COMPRESS_RE=/\s+/g;
AjxStringUtil.ELLIPSIS=" ... ";
AjxStringUtil.LIST_SEP=", ";
AjxStringUtil.makeString=function(e){
return e?String(e):""
};
AjxStringUtil.capitalize=function(e){
return e.length>0?e.charAt(0).toUpperCase()+e.substr(1).toLowerCase():""
};
AjxStringUtil.capitalizeWords=function(e){
return AjxUtil.map(e.split(/\s+/g),AjxStringUtil.capitalize).join(" ")
};
AjxStringUtil.toMixed=function(s,e,o){
if(!s||(typeof s!="string")){
return""
}
e=e||/\s+/;
var a=s.split(e);
var n=[];
n.push(o?a[0].toLowerCase():a[0].substring(0,1).toUpperCase()+a[0].substring(1).toLowerCase());
for(var t=1;
t<a.length;
t++){
n.push(a[t].substring(0,1).toUpperCase()+a[t].substring(1).toLowerCase())
}
return n.join("")
};
AjxStringUtil.fromMixed=function(t,e){
e=["$1",e||" ","$2"].join("");
return AjxStringUtil.trim(t.replace(/([a-z])([A-Z]+)/g,e))
};
AjxStringUtil.trim=function(o,e,i){
if(!o){
return""
}
var a=AjxStringUtil.TRIM_RE;
var t=AjxStringUtil.COMPRESS_RE;
if(i){
a=new RegExp("^"+i+"+|"+i+"+$","g");
t=new RegExp(i+"+","g")
}else{
i=" "
}
o=o.replace(a,"");
if(e){
o=o.replace(t,i)
}
return o
};
AjxStringUtil.repeat=function(o,e){
var a="";
for(var t=0;
t<e;
t++){
a+=o
}
return a
};
AjxStringUtil.getUnitsFromSizeString=function(t){
var a="px";
if(typeof(t)=="string"){
var e=Number(parseInt(t,10)).toString();
if(t.length>e.length){
a=t.substr(e.length,(t.length-e.length));
if(!(a=="em"||a=="ex"||a=="px"||a=="in"||a=="cm"==a=="mm"||a=="pt"||a=="pc"||a=="%")){
a="px"
}}}
return a
};
AjxStringUtil.split=function(l,o){
if(!l){
return[]
}
var s=0;
o=o?o:",";
var u=new Object();
if(typeof o=="string"){
u[o]=1
}else{
for(s=0;
s<o.length;
s++){
u[o[s]]=1
}}
var e=false;
var a=0;
var t=0;
var d;
var r=[];
var n=0;
for(s=0;
s<l.length;
s++){
var h=l.charAt(s);
if(h=='"'){
e=!e
}else{
if(h=="("){
a++
}else{
if(h==")"){
a--
}else{
if(u[h]){
if(!e&&!a){
d=l.substring(t,s);
r[n++]=d;
t=s+1
}}}}}}
d=l.substring(t,l.length);
r[n++]=d;
return r
};
AjxStringUtil.splitKeepLeadingWhitespace=function(t){
var i=/\s*\S+/g;
var o=[];
var e;
while(e=i.exec(t)){
var a=e[0];
o.push(a)
}
return o
};
AjxStringUtil.wordWrap=function(F){
if(!(F&&F.text)){
return""
}
var g=F.text;
var y=F.before||"",t=F.after||"";
if(F.htmlMode){
return[y,g,t].join("")
}
var B=F.len||80;
var x=F.pre||"";
var n="\n";
g=AjxStringUtil.trim(g,false,"[\t ]");
g=g.replace(/\r\n/g,n);
var e=g.split(n);
var k=[];
for(var z=0,S=e.length;
z<S;
z++){
var c=e[z];
var q=c.match(/^([\s>\|]+)/);
var T=q?q[1]:"";
if(T){
c=c.substr(T.length)
}
var r=AjxStringUtil.splitKeepLeadingWhitespace(c);
if(r&&r[0]&&r[0].length){
var j=AjxStringUtil.MSG_SEP_RE.test(c)||AjxStringUtil.COLON_RE.test(c)||AjxStringUtil.HDR_RE.test(c)||AjxStringUtil.SIG_RE.test(c);
for(var d=0,f=r.length;
d<f;
d++){
var s=F.preserveReturns&&(d==f-1);
k.push({
w:r[d],p:T,special:(j&&d==0),lastWord:s}
)
}}else{
k.push({
para:true,p:T}
)
}}
var W=F.len||72;
var o=F.pre||"";
var u=o.length;
var h="",a=0,r=[],b=null;
for(var A=0,B=k.length;
A<B;
A++){
var C=k[A];
var d=C.w,v=C.p;
var O=r.length?1:0;
var D=(b===null)?0:b.length;
if(C.para){
if(r.length){
h+=o+(b||"")+r.join("").replace(/^ /,"")+n
}
h+=o+v+n;
r=[];
a=0;
b=null
}else{
if((u+D+a+O+d.length<=W)&&(v==b||b===null)&&!C.special){
r.push(d);
a+=d.length;
b=v;
if(C.lastWord&&k[A+1]){
k[A+1].special=true
}}else{
if(r.length){
h+=o+(b||"")+r.join("").replace(/^ /,"")+n
}
r=[d];
a=d.length;
b=v;
if(C.lastWord&&k[A+1]){
k[A+1].special=true
}}}}
if(r.length){
h+=o+b+r.join("").replace(/^ /,"")+n
}
return[y,h,t].join("")
};
AjxStringUtil.quoteText=function(i){
if(!(i&&i.text)){
return""
}
var h=i.text;
var r=i.before||"",e=i.after||"";
if(i.htmlMode||!i.pre){
return[r,h,e].join("")
}
var n=i.len||80;
var a=i.pre||"";
var s="\n";
h=AjxStringUtil.trim(h);
h=h.replace(/\n\r/g,s);
var u=h.split(s);
var d=[];
for(var t=0,o=u.length;
t<o;
t++){
var c=AjxStringUtil.trim(u[t]);
d.push(a+c+s)
}
return r+d.join("")+e
};
AjxStringUtil.SHIFT_CHAR={
48:")",49:"!",50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",59:":",186:":",187:"+",188:"<",189:"_",190:">",191:"?",192:"~",219:"{",220:"|",221:"}",222:'"'};
AjxStringUtil.shiftChar=function(e,t){
return t?AjxStringUtil.SHIFT_CHAR[e]||String.fromCharCode(e):String.fromCharCode(e)
};
AjxStringUtil.diffPoint=function(o,a){
if(!(o&&a)){
return 0
}
var e=Math.min(o.length,a.length);
var t=0;
while(t<e&&(o.charAt(t)==a.charAt(t))){
t++
}
return t
};
AjxStringUtil.resolve=function(t,e){
return AjxMessageFormat.format(t,e)
};
AjxStringUtil.urlEncode=function(t){
if(!t){
return""
}
var e=window.encodeURL||window.encodeURI;
return e(t)
};
AjxStringUtil.urlComponentEncode=function(t){
if(!t){
return""
}
var e=window.encodeURLComponent||window.encodeURIComponent;
return e(t)
};
AjxStringUtil.urlDecode=function(t){
if(!t){
return""
}
var e=window.decodeURL||window.decodeURI;
return e(t)
};
AjxStringUtil.urlComponentDecode=function(o){
if(!o){
return""
}
var a=window.decodeURLComponent||window.decodeURIComponent;
var t;
try{
t=a(o)
}
catch(i){
t=unescape(o)
}
return t||o
};
AjxStringUtil.ENCODE_MAP={
">":"&gt;","<":"&lt;","&":"&amp;"};
AjxStringUtil.htmlEncode=function(t,e){
if(!t){
return""
}
if(!AjxEnv.isSafari||AjxEnv.isSafariNightly){
if(e){
return t.replace(/[<>&]/g,function(a){
return AjxStringUtil.ENCODE_MAP[a]
}
).replace(/  /g," &nbsp;")
}else{
return t.replace(/[<>&]/g,function(a){
return AjxStringUtil.ENCODE_MAP[a]
}
)
}}else{
if(e){
return t.replace(/[&]/g,"&amp;").replace(/  /g," &nbsp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
}else{
return t.replace(/[&]/g,"&amp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
}}};
AjxStringUtil.htmlDecode=function(t,e){
if(e){
t=t.replace(/&nbsp;/g," ")
}
return t.replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&gt;/g,">")
};
AjxStringUtil.stripTags=function(t,e){
if(!t){
return""
}
if(e){
t=t.replace(/(<(\w+)[^>]*>).*(<\/\2[^>]*>)/,"$1$3")
}
return t.replace(/<\/?[^>]+>/gi,"")
};
AjxStringUtil.convertToHtml=function(r,s){
if(!r){
return""
}
if(s){
var n=/^(>|\|\s+)/;
var t=r.split(/\r?\n/);
var h=0;
for(var a=0;
a<t.length;
a++){
var e=t[a];
if(e.length>0){
var o=0;
while(e.match(n)){
e=e.replace(n,"");
o++
}
while(o>h){
e="<blockquote>"+e;
h++
}
while(o<h){
e=e+"</blockquote>";
h--
}}
t[a]=e
}
while(h>0){
t.push("</blockquote>");
h--
}
r=t.join("\n");
r=r.replace(/&/mg,"&amp;");
r=r.replace(/<(?!\/?blockquote)/mg,"&lt;");
r=r.replace(/(\/?blockquote)?>/mg,function(l,i){
return i?l:"&gt;"
}
)
}else{
r=r.replace(/&/mg,"&amp;").replace(/</mg,"&lt;").replace(/>/mg,"&gt;")
}
r=r.replace(/  /mg," &nbsp;").replace(/^ /mg,"&nbsp;").replace(/\t/mg,"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;").replace(/\r?\n/mg,"<br>");
return r
};
AjxStringUtil.SPACE_ENCODE_MAP={
" ":"&nbsp;",">":"&gt;","<":"&lt;","&":"&amp;","\n":"<br>"};
AjxStringUtil.htmlEncodeSpace=function(e){
if(!e){
return""
}
return e.replace(/[&]/g,"&amp;").replace(/ /g,"&nbsp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
};
AjxStringUtil.htmlRubyEncode=function(e,t){
if(e&&t){
return["<ruby>","<rb>",AjxStringUtil.htmlEncode(e),"</rb> ","<rp>(</rp><rt>",AjxStringUtil.htmlEncode(t),"</rt><rp>)</rp>","</ruby>"].join("")
}
return AjxStringUtil.htmlEncode(e||t||"")
};
AjxStringUtil.nl2br=function(e){
if(!e){
return""
}
return e.replace(/^ /mg,"&nbsp;").replace(/\t/mg,"<span style='white-space:pre'>\t</span>").replace(/\n/g,"<br>")
};
AjxStringUtil.xmlEncode=function(e){
if(e){
e=""+e;
return e.replace(/&/g,"&amp;").replace(/</g,"&lt;")
}
return""
};
AjxStringUtil.xmlDecode=function(e){
return e?e.replace(/&amp;/g,"&").replace(/&lt;/g,"<"):""
};
AjxStringUtil.xmlAttrEncode=function(e){
return e?e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/\x22/g,"&quot;").replace(/\x27/g,"&apos;"):""
};
AjxStringUtil.xmlAttrDecode=function(e){
return e?e.replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&quot;/g,'"').replace(/&apos;/g,"'"):""
};
AjxStringUtil.__RE_META={
" ":" ","\n":"\\n","\r":"\\r","\t":"\\t"};
AjxStringUtil.__reMetaEscape=function(t,e){
return AjxStringUtil.__RE_META[e]||"\\"+e
};
AjxStringUtil.regExEscape=function(e){
return e.replace(/(\W)/g,AjxStringUtil.__reMetaEscape)
};
AjxStringUtil._calcDIV=null;
AjxStringUtil.calcDIV=function(){
if(AjxStringUtil._calcDIV==null){
AjxStringUtil._calcDIV=document.createElement("div");
AjxStringUtil._calcDIV.style.zIndex=0;
AjxStringUtil._calcDIV.style.position=DwtControl.ABSOLUTE_STYLE;
AjxStringUtil._calcDIV.style.visibility="hidden";
document.body.appendChild(AjxStringUtil._calcDIV)
}
return AjxStringUtil._calcDIV
};
AjxStringUtil.clip=function(e,s,n){
var o=AjxStringUtil.calcDIV();
if(arguments.length==3){
o.className=n
}
o.innerHTML=e;
if(o.offsetWidth<=s){
return e
}
for(var a=e.length-1;
a>0;
a--){
var t=e.substr(0,a);
o.innerHTML=t+AjxStringUtil.ELLIPSIS;
if(o.offsetWidth<=s){
return t+AjxStringUtil.ELLIPSIS
}}
return e
};
AjxStringUtil.clipByLength=function(a,t){
var e=a.length;
return(e<=t)?a:[a.substr(0,t/2),"...",a.substring(e-((t/2)-3),e)].join("")
};
AjxStringUtil.wrap=function(n,s,r){
var u=AjxStringUtil.calcDIV();
if(arguments.length==3){
u.className=r
}
var h="";
var o="";
var e=n.split("/n");
for(var i=0;
i<e.length;
i++){
if(i!=0){
h+=o+"<br>";
o=""
}
htmlRows=e[i].split("<br>");
for(var c=0;
c<htmlRows.length;
c++){
if(c!=0){
h+=o+"<br>";
o=""
}
words=htmlRows[c].split(" ");
var d=0;
while(d<words.length){
u.innerHTML=o+" "+words[d];
var a=u.offsetWidth;
if(a>s){
u.innerHTML=words[d];
a=a-u.offsetWidth;
if((a>=s)||(u.offsetWidth<=s)){
h+=o+"<br>";
o=""
}else{
var l=true;
var t=0;
while(l){
t++;
u.innerHTML=o+" "+words[d].substring(0,t);
l=(u.offsetWidth<=s)
}
t--;
h+=o+words[d].substring(0,t)+"<br>";
words[d]=words[d].substr(t);
o=""
}}else{
o+=" "+words[d];
d++
}}}}
h+=o;
return h
};
AjxStringUtil.MSG_SEP_RE=new RegExp("^\\s*--+\\s*("+AjxMsg.origMsg+"|"+AjxMsg.forwardedMessage+")\\s*--+","i");
AjxStringUtil.SIG_RE=/^(- ?-+)|(__+)\r?$/;
AjxStringUtil.COLON_RE=/\S+:$/;
AjxStringUtil.PREFIX_RE=/^\s*(&gt;|>|\|)/;
AjxStringUtil.BRACKET_RE=/^\s*\[.+\]\s*$/;
AjxStringUtil.LINE_RE=/^\s*_{30,}\s*$/;
AjxStringUtil.BLANK_RE=/^\s*$/;
AjxStringUtil.SPLIT_RE=/\r\n|\r|\n/;
AjxStringUtil.HDR_RE=/^\s*\w+:/;
AjxStringUtil.HTML_BLANK_RE=/^\s*(<br\s*\/?>)*\s*$/i;
AjxStringUtil.HTML_BR_RE=/<br\s*\/?>/gi;
AjxStringUtil.HTML_BODY_RE=/<body(\s|>)/i;
AjxStringUtil.HTML_QUOTE_PRE_RE=/^\s*<blockquote/i;
AjxStringUtil.HTML_QUOTE_POST_RE=/^\s*<\/blockquote>/i;
AjxStringUtil.HTML_QUOTE_COLOR="#1010FF";
AjxStringUtil.HTML_QUOTE_STYLE="color:#000;font-weight:normal;font-style:normal;text-decoration:none;font-family:Helvetica,Arial,sans-serif;font-size:12pt;";
AjxStringUtil.getTopLevel=function(m,h,t){
if(!m){
return[""]
}
var e=/<br|<div/i.test(m);
var l=e?AjxStringUtil.HTML_BR_RE:AjxStringUtil.SPLIT_RE;
var h=e?"<br>":"\n";
m=AjxStringUtil._trimBlankLines(m,l,h,e);
var f=m.split(l);
var s=f.length;
var o=0,a=0;
var n=[];
var r=false;
while(o<s){
var u=r;
var d=AjxStringUtil._linesToSkip(f,o,t);
r=(d>0);
if(u&&!r){
a=o
}else{
if(!u&&r&&o>a){
var c=AjxStringUtil._trimBlankLines(f.slice(a,o).join(h),l,h,t);
if(c&&c.length){
n.push(c)
}}}
o+=r?d:1
}
if(!r&&o>a){
var c=AjxStringUtil._trimBlankLines(f.slice(a,o).join(h),l,h,t);
if(c&&c.length){
n.push(c)
}}
return n
};
AjxStringUtil._linesToSkip=function(l,a,e){
var o=l.length;
var h=0;
var t=a;
var c=e?AjxStringUtil.stripTags(l[a]):l[a];
if(AjxStringUtil.MSG_SEP_RE.test(c)){
h=o-a
}else{
if(AjxStringUtil.PREFIX_RE.test(c)){
while(a<l.length&&(AjxStringUtil.PREFIX_RE.test(c)||AjxStringUtil.BLANK_RE.test(c))){
a++;
c=e?AjxStringUtil.stripTags(l[a]):l[a]
}
h=a-t
}else{
if(AjxStringUtil.HTML_QUOTE_PRE_RE.test(c)&&c.indexOf(AjxStringUtil.HTML_QUOTE_COLOR)!=-1){
while(a<l.length&&(!AjxStringUtil.HTML_QUOTE_POST_RE.test(c))){
a++;
c=l[a]
}
if(a<l.length){
l[a]=l[a].replace(AjxStringUtil.HTML_QUOTE_POST_RE,"")
}
h=a-t
}else{
if(AjxStringUtil.COLON_RE.test(c)){
var s=AjxStringUtil._nextNonBlankLineIndex(l,a+1,e);
var r=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(r&&AjxStringUtil.PREFIX_RE.test(r)){
h=s-a
}else{
if(s!=-1){
s=AjxStringUtil._nextNonBlankLineIndex(l,s+1,e)
}
var n=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(n&&AjxStringUtil.BRACKET_RE.test(r)&&AjxStringUtil.PREFIX_RE.test(n)){
h=s-a
}}}else{
if(AjxStringUtil.LINE_RE.test(c)){
var s=AjxStringUtil._nextNonBlankLineIndex(l,a+1,e);
var r=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(r&&AjxStringUtil.HDR_RE.test(r)){
h=o-a
}}else{
if(AjxStringUtil.SIG_RE.test(c)){
h=o-a
}}}}}}
return h
};
AjxStringUtil._nextNonBlankLineIndex=function(e,t,a){
while(t<e.length&&AjxStringUtil.BLANK_RE.test(a?AjxStringUtil.stripTags(e[t]):e[t])){
t++
}
return((t<e.length)?t:-1)
};
AjxStringUtil._trimBlankLines=function(r,s,n,e){
var l=r.split(s);
var o=l.length;
var h=e?AjxStringUtil.HTML_BLANK_RE:AjxStringUtil.BLANK_RE;
var a=0;
while(a<o&&h.test(l[a])){
a++
}
var t=o;
while(t>0&&h.test(l[t-1])){
t--
}
if(a!=0||t!=o){
r=l.slice(a,t).join(n)+n
}
if(e&&AjxStringUtil.HTML_BODY_RE.test(r)){
r=r.replace(/<body\s*[^>]*>(<br\s*\/?>)+/i,"<body>");
r=r.replace(/(<br\s*\/?>)+<\/body>/i,"</body>")
}
return r
};
AjxStringUtil._NO_LIST=0;
AjxStringUtil._ORDERED_LIST=1;
AjxStringUtil._UNORDERED_LIST=2;
AjxStringUtil._INDENT="    ";
AjxStringUtil._NON_WHITESPACE=/\S+/;
AjxStringUtil._LF=/\n/;
AjxStringUtil.convertHtml2Text=function(i,n,o){
if(!i){
return null
}
if(n&&AjxUtil.isFunction(n._before)){
i=n._before(i)
}
if(typeof i=="string"){
var s=document.createElement("SPAN");
s.innerHTML=i;
i=s
}
var r=[];
var a=0;
var t={};
this._traverse(i,r,a,AjxStringUtil._NO_LIST,0,0,t,n,o);
var e=r.join("");
if(n&&AjxUtil.isFunction(n._after)){
e=n._after(e)
}
return e
};
AjxStringUtil._traverse=function(e,f,d,l,r,n,s,c,u){
var h=e.nodeName.toLowerCase();
var p=null;
if(c&&c[h]){
p=c[h](e,s)
}
if(p!=null){
f[d++]=p
}else{
if(h=="#text"){
if(e.nodeValue.search(AjxStringUtil._NON_WHITESPACE)!=-1){
if(s.lastNode=="ol"||s.lastNode=="ul"){
f[d++]="\n"
}
if(s.isPreformatted){
f[d++]=AjxStringUtil.trim(e.nodeValue)+" "
}else{
f[d++]=AjxStringUtil.trim(e.nodeValue.replace(AjxStringUtil._LF," "),true)+" "
}}}else{
if(h=="p"){
f[d++]=u?"\n":"\n\n"
}else{
if(l==AjxStringUtil._NO_LIST&&(h=="br"||h=="hr")){
f[d++]="\n"
}else{
if(h=="ol"||h=="ul"){
f[d++]="\n";
if(e.parentNode.nodeName.toLowerCase()!="li"&&s.lastNode!="br"&&s.lastNode!="hr"){
f[d++]="\n"
}
l=(h=="ol")?AjxStringUtil._ORDERED_LIST:AjxStringUtil._UNORDERED_LIST;
r++;
n=0
}else{
if(h=="li"){
for(var a=0;
a<r;
a++){
f[d++]=AjxStringUtil._INDENT
}
if(l==AjxStringUtil._ORDERED_LIST){
f[d++]=n+". "
}else{
f[d++]="\u002A "
}}else{
if(h=="img"){
if(e.alt&&e.alt!=""){
f[d++]=e.alt
}}else{
if(h=="tr"&&e.parentNode.firstChild!=e){
f[d++]="\n"
}else{
if(h=="td"&&e.parentNode.firstChild!=e){
f[d++]="\t"
}else{
if(h=="div"){
f[d++]="\n"
}else{
if(h=="blockquote"){
f[d++]="\n\n"
}else{
if(h=="pre"){
s.isPreformatted=true
}else{
if(h=="#comment"||h=="script"||h=="select"||h=="style"){
return d
}}}}}}}}}}}}}
var m=e.childNodes;
var o=m.length;
for(var a=0;
a<o;
a++){
var t=m[a];
if(t.nodeType==1&&t.tagName.toLowerCase()=="li"){
n++
}
d=this._traverse(t,f,d,l,r,n,s,c,u)
}
if(c&&c["/"+h]){
f[d++]=c["/"+h](e)
}
if(h=="h1"||h=="h2"||h=="h3"||h=="h4"||h=="h5"||h=="h6"){
f[d++]="\n";
s.list=false
}else{
if(h=="pre"){
s.isPreformatted=false
}else{
if(h=="li"){
if(!s.list){
f[d++]="\n"
}
s.list=false
}else{
if(h=="ol"||h=="ul"){
s.list=true
}else{
if(h!="#text"){
s.list=false
}}}}}
s.lastNode=h;
return d
};
AjxStringUtil.queryStringSet=function(r,l){
var h=l?"":location.search;
if(h.indexOf("?")==0){
h=h.substr(1)
}
var s=h.split("&");
var a={};
for(var o=0;
o<s.length;
o++){
var n=s[o].split("=");
a[n[0]]=n[1]
}
for(var e in r){
a[e]=r[e]
}
var t=[];
var o=0;
for(var e in a){
if(e){
t[o++]=[e,a[e]].join("=")
}}
return"?"+t.join("&")
};
AjxStringUtil.queryStringRemove=function(e,a){
e=e?e:"";
if(e.indexOf("?")==0){
e=e.substr(1)
}
var n=e.split("&");
var t=[];
for(var o=0;
o<n.length;
o++){
if(n[o].indexOf(a)!=0){
t.push(n[o])
}}
return"?"+t.join("&")
};
AjxStringUtil.getAsString=function(e){
return !e?"":(typeof(e)=="object")?e.toString():e
};
AjxStringUtil.isWhitespace=function(e){
return(e.charCodeAt(0)<=32)
};
AjxStringUtil.isDigit=function(t){
var e=t.charCodeAt(0);
return(e>=48&&e<=57)
};
AjxStringUtil.compareRight=function(o,t){
var n=0;
var r=0;
var s=0;
var i;
var e;
for(;
(r<o.length||s<t.length);
r++,s++){
i=o.charAt(r);
e=t.charAt(s);
if(!AjxStringUtil.isDigit(i)&&!AjxStringUtil.isDigit(e)){
return n
}else{
if(!AjxStringUtil.isDigit(i)){
return -1
}else{
if(!AjxStringUtil.isDigit(e)){
return +1
}else{
if(i<e){
if(n==0){
n=-1
}}else{
if(i>e){
if(n==0){
n=+1
}}}}}}}};
AjxStringUtil.natCompare=function(h,r){
var s=0,o=0;
var t=0,e=0;
var n,i;
while(s<h.length||o<r.length){
t=e=0;
n=h.charAt(s);
i=r.charAt(o);
while(AjxStringUtil.isWhitespace(n)||n=="0"){
t=(n=="0")?(t+1):0;
n=h.charAt(++s)
}
while(AjxStringUtil.isWhitespace(i)||i=="0"){
e=(i=="0")?(e+1):0;
i=r.charAt(++o)
}
if(AjxStringUtil.isDigit(n)&&AjxStringUtil.isDigit(i)){
var l=AjxStringUtil.compareRight(h.substring(s),r.substring(o));
if(l&&l!=0){
return l
}}
if(n==0&&i==0){
return t-e
}
if(n<i){
return -1
}else{
if(n>i){
return +1
}}
++s;
++o
}};
AjxStringUtil.clipFile=function(n,t){
var a=n.lastIndexOf(".");
var e=a?(a+1):n.length;
if(e<=t){
return n
}else{
var o=n.substr(0,a);
var i=n.substr(a+1,n.length-1);
return[o.substr(0,t/2),"...",o.substring(e-((t/2)-3),e),".",(i?i:"")].join("")
}};
AjxStringUtil.URL_PARSE_RE=new RegExp("^(?:([^:/?#.]+):)?(?://)?(([^:/?#]*)(?::(\\d*))?)?((/(?:[^?#](?![^?#/]*\\.[^?#/.]+(?:[\\?#]|$)))*/?)?([^?#/]*))?(?:\\?([^#]*))?(?:#(.*))?");
AjxStringUtil.parseURL=function(a){
var n=["source","protocol","authority","domain","port","path","directoryPath","fileName","query","anchor"];
var o=AjxStringUtil.URL_PARSE_RE.exec(a);
var t={};
for(var e=0;
e<n.length;
e++){
t[n[e]]=(o[e]?o[e]:"")
}
if(t.directoryPath.length>0){
t.directoryPath=t.directoryPath.replace(/\/?$/,"/")
}
return t
};
AjxStringUtil.parseQueryString=function(s){
var a=s||(""+window.location);
var t=a.indexOf("?");
if(t==-1){
return null
}
var e=a.substring(t+1).replace(/#.*$/,"");
var n=e.split("&");
var h={};
for(var o=0;
o<n.length;
o++){
var r=n[o].split("=");
h[r[0]]=r[1]
}
return h
};
AjxStringUtil._SPECIAL_CHARS=/["\\\x00-\x1f]/g;
AjxStringUtil._CHARS={
"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};
AjxStringUtil.objToString=function(n){
var f=typeof n,h,l,r,s,u,m,c,e=[];
var d=function(i){
if(!AjxStringUtil._CHARS[i]){
var t=i.charCodeAt();
AjxStringUtil._CHARS[i]="\\u00"+Math.floor(t/16).toString(16)+(t%16).toString(16)
}
return AjxStringUtil._CHARS[i]
};
var p=function(t){
return'"'+t.replace(AjxStringUtil._SPECIAL_CHARS,d)+'"'
};
if(n===null){
return"null"
}
if(f==="string"){
return p(n)
}
if(f==="boolean"||n instanceof Boolean){
return String(n)
}
if(f==="number"||n instanceof Number){
return isFinite(n)?String(n):"null"
}
if(AjxUtil.isArray(n)||(f==="object"&&n.length)){
for(h=e.length-1;
h>=0;
--h){
if(e[h]===n){
return"null"
}}
e[e.length]=n;
c=[];
for(h=n.length-1;
h>=0;
--h){
c[h]=AjxStringUtil.objToString(n[h])
}
e.pop();
return"["+c.join(",")+"]"
}
if(f==="object"&&n){
for(h=e.length-1;
h>=0;
--h){
if(e[h]===n){
return"null"
}}
e[e.length]=n;
c=[];
r=0;
for(s in n){
if(typeof s==="string"&&n.hasOwnProperty(s)){
u=n[s];
m=typeof u;
if(m!=="undefined"&&m!=="function"){
c[r++]=p(s)+":"+AjxStringUtil.objToString(u)
}}}
e.pop();
return"{"+c.join(",")+"}"
}
return"null"
};
AjxStringUtil.prettyPrint=function(i,a,e,t){
AjxStringUtil._visited=new AjxVector();
var o=AjxStringUtil._prettyPrint(i,a,e,t);
AjxStringUtil._visited=null;
return o
};
AjxStringUtil._visited=null;
AjxStringUtil._prettyPrint=function(r,e,d,t){
var f=0;
var n=false;
var y=false;
if(arguments.length>4){
f=arguments[4];
n=arguments[5];
y=arguments[6]
}
if(AjxUtil.isObject(r)){
var c=r.toString?r.toString():"";
if(t&&c&&t[c]){
return"["+c+"]"
}
if(AjxStringUtil._visited.contains(r)){
return"[visited object]"
}else{
AjxStringUtil._visited.add(r)
}}
var a=AjxStringUtil.repeat(" ",f);
var p="";
if(r===undefined){
p+="[undefined]"
}else{
if(r===null){
p+="[null]"
}else{
if(AjxUtil.isBoolean(r)){
p+=r?"true":"false"
}else{
if(AjxUtil.isString(r)){
p+='"'+AjxStringUtil._escapeForHTML(r)+'"'
}else{
if(AjxUtil.isNumber(r)){
p+=r
}else{
if(AjxUtil.isObject(r)){
var h=AjxUtil.isArray(r);
if(y){
p+=h?"[Array]":r.toString()
}else{
y=!e;
var g=new Array();
for(var s in r){
g.push(s)
}
if(h){
g.sort(function(w,i){
return w-i
}
)
}else{
g.sort()
}
if(n){
p+=h?"[":"{"
}
var l=g.length;
for(var s=0;
s<l;
s++){
var m=g[s];
var o=r[m];
var u=null;
if(o==window||o==document||(!AjxEnv.isIE&&o instanceof Node)){
u=o.toString()
}
if((typeof(o)=="function")){
if(d){
u="[function]"
}else{
continue
}}
if(s>0){
p+=","
}
p+="\n"+a;
if(t&&t[m]){
p+=m+": ["+m+"]"
}else{
if(u!=null){
p+=m+": "+u
}else{
p+=m+": "+this._prettyPrint(o,e,d,t,f+2,true,y)
}}}
if(s>0){
p+="\n"+AjxStringUtil.repeat(" ",f-1)
}
if(n){
p+=h?"]":"}"
}}}}}}}}
return p
};
AjxStringUtil._escapeForHTML=function(t){
if(typeof(t)!="string"){
return t
}
var e=t;
e=e.replace(/\&/g,"&amp;");
e=e.replace(/\</g,"&lt;");
e=e.replace(/\>/g,"&gt;");
e=e.replace(/\"/g,"&quot;");
e=e.replace(/\xA0/g,"&nbsp;");
return e
};
AjxStringUtil._testSpan;
AjxStringUtil._testSpanBold;
AjxStringUtil.WIDTH={};
AjxStringUtil.WIDTH_BOLD={};
AjxStringUtil.MAX_CACHE=1000;
AjxStringUtil._cacheSize=0;
AjxStringUtil.getWidth=function(r,n){
if(!AjxStringUtil._testSpan){
var o=AjxStringUtil._testSpan=document.createElement("SPAN");
var i=AjxStringUtil._testSpanBold=document.createElement("SPAN");
o.style.position=i.style.position=Dwt.ABSOLUTE_STYLE;
var a=DwtShell.getShell(window).getHtmlElement();
a.appendChild(o);
a.appendChild(i);
Dwt.setLocation(o,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
Dwt.setLocation(i,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
i.style.fontWeight="bold"
}
var t=n?AjxStringUtil.WIDTH_BOLD:AjxStringUtil.WIDTH;
if(t[r]){
return t[r]
}
if(AjxStringUtil._cacheSize>=AjxStringUtil.MAX_CACHE){
AjxStringUtil.WIDTH={};
AjxStringUtil.WIDTH_BOLD={};
AjxStringUtil._cacheSize=0
}
var s=n?AjxStringUtil._testSpanBold:AjxStringUtil._testSpan;
s.innerHTML=r;
var e=t[r]=Dwt.getSize(s).x;
AjxStringUtil._cacheSize++;
return e
};
AjxStringUtil.fixCrossDomainReference=function(t,a){
var o=AjxStringUtil.parseURL(t);
if(o.authority==window.location.host){
return t
}
if((a&&t.indexOf(a)>=0)||!a){
var i=o.protocol+"://"+o.authority;
var e=window.location.protocol+"//"+window.location.host;
t=t.replace(i,e)
}
return t
};
AjxStringUtil._dummyDiv=document.createElement("DIV");
AjxStringUtil.htmlPlatformIndependent=function(t){
var a=AjxStringUtil._dummyDiv;
a.innerHTML=t;
var e=a.innerHTML;
a.innerHTML="";
return e
};
AjxStringUtil.equalsHtmlPlatformIndependent=function(t,e){
return AjxStringUtil.htmlPlatformIndependent(t)==AjxStringUtil.htmlPlatformIndependent(e)
};
AjxStringUtil.quoteString=function(a,t){
a=a||"";
var e=t?'"':"'";
return e+a+e
};
AjxStringUtil.buildAttribute=function(a,o,e,i,t,s){
if(!a){
return""
}
var n=(e===false)?"":" ";
n+=(a+"=");
if(t){
o=escape(o)
}else{
if(s){
o=AjxStringUtil.htmlEncode(o)
}}
n+=AjxStringUtil.quoteString(o,i);
return n
}
}
if(AjxPackage.define("ajax.util.AjxUtil")){
AjxUtil=function(){};
AjxUtil.FLOAT_RE=/^[+\-]?((\d+(\.\d*)?)|((\d*\.)?\d+))([eE][+\-]?\d+)?$/;
AjxUtil.NOTFLOAT_RE=/[^\d\.]/;
AjxUtil.NOTINT_RE=/[^0-9]+/;
AjxUtil.LIFETIME_FIELD=/^([0-9])+([dhms]|ms)?$/;
AjxUtil.isSpecified=function(e){
return((e!==void 0)&&(e!==null))
};
AjxUtil.isUndefined=function(e){
return(e===void 0)
};
AjxUtil.isNull=function(e){
return(e===null)
};
AjxUtil.isBoolean=function(e){
return(typeof(e)=="boolean")
};
AjxUtil.isString=function(e){
return(typeof(e)=="string")
};
AjxUtil.isNumber=function(e){
return(typeof(e)=="number")
};
AjxUtil.isObject=function(e){
return((typeof(e)=="object")&&(e!==null))
};
AjxUtil.isArray=function(e){
return AjxUtil.isInstance(e,Array)
};
AjxUtil.isFunction=function(e){
return(typeof(e)=="function")
};
AjxUtil.isDate=function(e){
return AjxUtil.isInstance(e,Date)
};
AjxUtil.isLifeTime=function(e){
return AjxUtil.LIFETIME_FIELD.test(e)
};
AjxUtil.isNumeric=function(e){
return(!isNaN(parseFloat(e))&&AjxUtil.FLOAT_RE.test(e)&&!AjxUtil.NOTFLOAT_RE.test(e))
};
AjxUtil.isLong=function(e){
return(AjxUtil.isNumeric(e)&&!AjxUtil.NOTINT_RE.test(e))
};
AjxUtil.isNonNegativeLong=function(e){
return(AjxUtil.isNumeric(e)&&AjxUtil.isLong(e)&&(parseFloat(e)>=0))
};
AjxUtil.isInt=function(e){
return(AjxUtil.isNumeric(e)&&!AjxUtil.NOTINT_RE.test(e))
};
AjxUtil.isPositiveInt=function(e){
return(AjxUtil.isNumeric(e)&&AjxUtil.isInt(e)&&(parseInt(e)>0))
};
AjxUtil.isEmpty=function(e){
return(AjxUtil.isNull(e)||AjxUtil.isUndefined(e)||(e==="")||(AjxUtil.isArray(e)&&(e.length==0)))
};
AjxUtil.IP_ADDRESS_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?$/;
AjxUtil.IP_ADDRESS_WITH_PORT_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?:\d{1,5}$/;
AjxUtil.SUBNET_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?\/\d{1,2}$/;
AjxUtil.DOMAIN_NAME_SHORT_RE=/^[A-Za-z0-9\-]{2,}$/;
AjxUtil.DOMAIN_NAME_FULL_RE=/^[A-Za-z0-9\-]{1,}(\.[A-Za-z0-9\-]{2,}){1,}$/;
AjxUtil.HOST_NAME_RE=/^[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{1,})*(\.[A-Za-z0-9\-]{2,})*$/;
AjxUtil.HOST_NAME_WITH_PORT_RE=/^[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{2,})*:([0-9])+$/;
AjxUtil.EMAIL_SHORT_RE=/^[^@\s]+$/;
AjxUtil.EMAIL_FULL_RE=/^[^@\s]+@[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{2,})+$/;
AjxUtil.SHORT_URL_RE=/^[A-Za-z0-9]{2,}:\/\/[A-Za-z0-9\-]+(\.[A-Za-z0-9\-]+)*(:([0-9])+)?$/;
AjxUtil.IP_SHORT_URL_RE=/^[A-Za-z0-9]{2,}:\/\/\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?(:([0-9])+)?$/;
AjxUtil.isIpAddress=function(e){
return AjxUtil.IP_ADDR_RE.test(e)
};
AjxUtil.isDomain=function(e){
return AjxUtil.DOMAIN_RE.test(e)
};
AjxUtil.isHostName=function(e){
return AjxUtil.HOST_NAME_RE.test(e)
};
AjxUtil.isDomainName=function(t,e){
return e?AjxUtil.DOMAIN_NAME_SHORT_RE.test(t):AjxUtil.DOMAIN_NAME_FULL_RE.test(t)
};
AjxUtil.isEmailAddress=function(t,e){
return e?AjxUtil.EMAIL_SHORT_RE.test(t):AjxUtil.EMAIL_FULL_RE.test(t)
};
AjxUtil.isValidEmailNonReg=function(e){
return((e.indexOf("@")>0)&&(e.lastIndexOf("@")==e.indexOf("@"))&&(e.indexOf(".@")<0))
};
AjxUtil.SIZE_GIGABYTES="GB";
AjxUtil.SIZE_MEGABYTES="MB";
AjxUtil.SIZE_KILOBYTES="KB";
AjxUtil.SIZE_BYTES="B";
AjxUtil.formatSize=function(o,i,n){
if(i==null){
i=true
}
if(n==null){
n=20
}
var t=AjxMsg.sizeBytes;
var a=AjxMsg.SIZE_BYTES;
if(o>=1073741824){
t=AjxMsg.sizeGigaBytes;
a=AjxUtil.SIZE_GIGABYTES
}else{
if(o>=1048576){
t=AjxMsg.sizeMegaBytes;
a=AjxUtil.SIZE_MEGABYTES
}else{
if(o>1023){
t=AjxMsg.sizeKiloBytes;
a=AjxUtil.SIZE_KILOBYTES
}}}
var e=AjxUtil.formatSizeForUnits(o,a,i,n);
return AjxMessageFormat.format(AjxMsg.formatSizeAndUnits,[e,t])
};
AjxUtil.formatSizeForUnits=function(o,t,e,s){
if(t==null){
t=AjxUtil.SIZE_BYTES
}
if(e==null){
e=true
}
if(s==null){
s=20
}
switch(t){
case AjxUtil.SIZE_GIGABYTES:o/=1073741824;
break;
case AjxUtil.SIZE_MEGABYTES:o/=1048576;
break;
case AjxUtil.SIZE_KILOBYTES:o/=1024;
break
}
var n=I18nMsg.formatNumber.replace(/\..*$/,"");
n=n.replace(/,/,"");
if(!e&&s){
n=n+=".";
for(var a=0;
a<s;
a++){
n+="#"
}}
return AjxNumberFormat.format(n,o)
};
AjxUtil.parseSize=function(t,i){
if(typeof t!=_STRING_){
t=t.toString()
}
var o=parseFloat(t.replace(/^\s*/,""));
var a=/[GMK]?B$/i;
var e=a.exec(t);
if(e){
i=e[0].toUpperCase()
}
switch(i){
case AjxUtil.SIZE_GIGABYTES:o*=1073741824;
break;
case AjxUtil.SIZE_MEGABYTES:o*=1048576;
break;
case AjxUtil.SIZE_KILOBYTES:o*=1024;
break
}
return o
};
AjxUtil.isInstance=function(e,t){
return !!(e&&e.constructor&&(e.constructor===t))
};
AjxUtil.assert=function(e,t){
if(!e&&AjxUtil.onassert){
AjxUtil.onassert(t)
}};
AjxUtil.onassert=function(t){
var l=new Object();
l.message=t;
var c=new Array();
if(AjxEnv.isIE5_5up){
var o=arguments.callee.caller;
var n=0;
while(o&&n++<20){
c[c.length]=o;
o=o.caller
}}else{
try{
var o=arguments.callee.caller;
while(o){
c[c.length]=o;
if(c.length>2){
break
}
o=o.caller
}}
catch(h){}}
l.stack=c;
var r="";
var a=170;
for(var n=1;
n<c.length;
n++){
if(n>1){
r+="\n"
}
if(n<11){
var s=c[n].toString();
if(s.length>a){
s=s.substr(0,a)+"...";
s=s.replace(/\n/g,"")
}
r+=n+": "+s
}else{
r+="("+(c.length-11)+" frames follow)";
break
}}
alert("assertion:\n\n"+t+"\n\n---- Call Stack ---\n"+r);
throw l
};
AjxUtil.ELEMENT_NODE=1;
AjxUtil.TEXT_NODE=3;
AjxUtil.DOCUMENT_NODE=9;
AjxUtil.getInnerText=function(e){
if(AjxEnv.isIE){
return e.innerText
}
function t(s){
if(s){
if(s.nodeType==3){
return s.data
}
if(s.nodeType==1){
if(/^br$/i.test(s.tagName)){
return"\r\n"
}
var o="";
for(var a=s.firstChild;
a;
a=a.nextSibling){
o+=t(a)
}
return o
}}
return""
}
return t(e)
};
AjxUtil.createProxy=function(a,s){
var o;
var t=function(){};
t.prototype=a;
if(a instanceof Array){
o=new Array();
var i=a.length;
for(var e=0;
e<i;
e++){
o[e]=a[e]
}}else{
o=new t
}
if(s){
for(var n in a){
if(typeof a[n]=="object"&&a[n]!==null){
o[n]=AjxUtil.createProxy(a[n],s-1)
}}}
o._object_=a;
return o
};
AjxUtil.unProxy=function(t){
var e=t&&t._object_;
if(e){
for(var a in t){
if(t.hasOwnProperty(a)&&a!="_object_"){
e[a]=t[a]
}}
return e
}
return null
};
AjxUtil.collapseList=function(a){
var t=[];
for(var e=0;
e<a.length;
e++){
if(a[e]){
t.push(a[e])
}}
return t
};
AjxUtil.arrayAsHash=function(r,o){
var s={};
var a=typeof o=="function"&&o;
var n=o||true;
for(var t=0;
t<r.length;
t++){
var e=r[t];
s[e]=a?a(e,s,t,r):n
}
return s
};
AjxUtil.arrayAdd=function(a,t,e){
if(e==null||e<0||e>=a.length){
a.push(t)
}else{
a.splice(e,0,t)
}};
AjxUtil.arrayRemove=function(a,t){
if(a){
for(var e=0;
e<a.length;
e++){
if(a[e]==t){
a.splice(e,1);
return true
}}}
return false
};
AjxUtil.indexOf=function(n,t,e){
if(n){
for(var a=0;
a<n.length;
a++){
var o=n[a];
if((e&&o===t)||(!e&&o==t)){
return a
}}}
return -1
};
AjxUtil.keys=function(t,e){
var a=[];
for(var i in t){
if(e&&!e(i,t)){
continue
}
a.push(i)
}
return a
};
AjxUtil.values=function(a,t){
var e=[];
for(var i in a){
if(t&&!t(i,a)){
continue
}
e.push(a[i])
}
return e
};
AjxUtil.foreach=function(a,t){
if(!t){
return
}
for(var e=0;
e<a.length;
e++){
t(a[e],e)
}};
AjxUtil.map=function(o,a){
var e=new Array(o.length);
for(var t=0;
t<o.length;
t++){
e[t]=a?a(o[t],t):o[t]
}
return e
};
AjxUtil.uniq=function(a){
var e={};
for(var t=0;
t<a.length;
t++){
e[a[t]]=true
}
return AjxUtil.keys(e)
};
AjxUtil.concat=function(t){
var a=[];
for(var e=0;
e<arguments.length;
e++){
a.push.apply(a,arguments[e])
}
return a
};
AjxUtil.union=function(e){
var t=[];
return AjxUtil.uniq(t.concat.apply(t,arguments))
};
AjxUtil.intersection=function(t){
var i=AjxUtil.concat.apply(this,arguments);
var e=AjxUtil.arrayAsHash(i,AjxUtil.__intersection_count);
for(var a in e){
if(e[a]==1){
delete e[a]
}}
return AjxUtil.keys(e)
};
AjxUtil.__intersection_count=function(t,a,e,i){
return a[t]!=null?a[t]+1:1
};
AjxUtil.complement=function(i,t){
var a=AjxUtil.arrayAsHash(i);
var e=AjxUtil.arrayAsHash(t);
for(var o in e){
if(o in a){
delete e[o]
}}
return AjxUtil.keys(e)
};
AjxUtil.getFirstElement=function(o,i,a,t){
for(var n=o.firstChild;
n;
n=n.nextSibling){
if(n.nodeType!=AjxUtil.ELEMENT_NODE){
continue
}
if(i&&n.nodeName!=i){
continue
}
if(a){
var e=n.getAttributeNode(a);
if(e.nodeName!=a){
continue
}
if(t&&e.nodeValue!=t){
continue
}}
return n
}
return null
};
AjxUtil.formatUrl=function(s){
s=s||{};
var a=[];
var o=0;
if(!s.relative){
var n=s.protocol||location.protocol;
if(n.indexOf(":")==-1){
n=n+":"
}
a[o++]=n;
a[o++]="//";
a[o++]=s.host||location.hostname;
var t=Number(s.port||location.port);
if(t&&((n==ZmSetting.PROTO_HTTP&&t!=ZmSetting.HTTP_DEFAULT_PORT)||(n==ZmSetting.PROTO_HTTPS&&t!=ZmSetting.HTTPS_DEFAULT_PORT))){
a[o++]=":";
a[o++]=t
}}
a[o++]=s.path||location.pathname;
var e="";
if(s.qsArgs){
e=AjxStringUtil.queryStringSet(s.qsArgs,s.qsReset)
}else{
e=s.qsReset?"":location.search
}
a[o++]=e;
return a.join("")
};
AjxUtil.byNumber=function(t,e){
return Number(t)-Number(e)
};
AjxUtil.byStringProp=function(i,t,e){
return t[i].localeCompare(e[i])
};
AjxUtil.mergeArrays=function(h,n,e){
if(!e){
e=AjxUtil.__mergeArrays_orderfunc
}
var l=[];
var o=h.length;
for(var t=0;
t<o;
t++){
l.push(h[t])
}
var s=[];
var a=n.length;
for(var t=0;
t<a;
t++){
s.push(n[t])
}
var r=[];
while(l.length>0&&s.length>0){
if(e(l[0],r[r.length-1])==0){
l.shift();
continue
}
if(e(s[0],r[r.length-1])==0){
s.shift();
continue
}
if(e(l[0],s[0])<0){
r.push(l.shift())
}else{
if(e(l[0],s[0])==0){
r.push(l.shift());
s.shift()
}else{
r.push(s.shift())
}}}
while(l.length>0){
if(e(l[0],r[r.length-1])==0){
l.shift();
continue
}
r.push(l.shift())
}
while(s.length>0){
if(e(s[0],r[r.length-1])==0){
s.shift();
continue
}
r.push(s.shift())
}
return r
};
AjxUtil.__mergeArrays_orderfunc=function(t,e){
if(t>e){
return 1
}
if(t<e){
return -1
}
if(t==e){
return 0
}};
AjxUtil.arraySubstract=function(h,n,e){
if(!e){
e=function(c,i){
if(c>i){
return 1
}
if(c<i){
return -1
}
if(c==i){
return 0
}}
}
var l=[];
var o=h.length;
for(var t=0;
t<o;
t++){
l.push(h[t])
}
var s=[];
var a=n.length;
for(var t=0;
t<a;
t++){
s.push(n[t])
}
s.sort(e);
l.sort(e);
var r=[];
while(l.length>0&&s.length>0){
if(e(l[0],s[0])==0){
l.shift();
s.shift();
continue
}
if(e(l[0],s[0])<0){
r.push(l.shift());
continue
}
if(e(l[0],s[0])>0){
s.shift();
continue
}}
while(l.length>0){
r.push(l.shift())
}
return r
};
AjxUtil.getHashKeys=function(a){
var t=[];
for(var e in a){
t.push(e)
}
t.sort();
return t
};
AjxUtil.arrayCompare=function(t,e){
if((!t||!e)&&(t!=e)){
return false
}
if(t.length!=e.length){
return false
}
for(var a=0;
a<t.length;
a++){
if(t[a]!=e[a]){
return false
}}
return true
};
AjxUtil.hashCompare=function(r,s){
var a=AjxUtil.getHashKeys(r);
var t=AjxUtil.getHashKeys(s);
if(!AjxUtil.arrayCompare(a,t)){
return false
}
for(var n=0,e=a.length;
n<e;
n++){
var o=a[n];
if(r[o]!=s[o]){
return false
}}
return true
};
AjxUtil.hashCopy=function(t){
var a={};
for(var e in t){
a[e]=t[e]
}
return a
};
AjxUtil.hashUpdate=function(i,a,e,o){
for(var t in a){
if((e||!(t in i))&&(!o||AjxUtil.indexOf(o,t)==-1)){
i[t]=a[t]
}}
return i
};
AjxUtil.isArray1=function(e){
return Boolean(e&&(e.length!=null)&&e.splice&&e.slice)
};
AjxUtil.toArray=function(e){
return AjxUtil.isArray1(e)?e:(e===undefined)?[]:[e]
};
AjxUtil.get=function(e){
for(var t=1;
e&&t<arguments.length;
t++){
e=e[arguments[t]]
}
return e
}
}
if(AjxPackage.define("ajax.util.AjxTimedAction")){
AjxTimedAction=function(a,t,e){
AjxCallback.call(this,a,t,e);
this._tid=-1;
this._id=-1;
this._runResult=null
};
AjxTimedAction.prototype=new AjxCallback();
AjxTimedAction.prototype.constructor=AjxTimedAction;
AjxTimedAction.MAX_TIMEOUT=20*24*60*60*1000;
AjxTimedAction.prototype.toString=function(){
return"AjxTimedAction"
};
AjxTimedAction.prototype.getRunResult=function(){
return this._runResult
};
AjxTimedAction._pendingActions={};
AjxTimedAction._nextActionId=1;
AjxTimedAction.scheduleAction=function(a,t){
if(!a){
return
}
if(a._tid&&a._tid!=-1){
AjxTimedAction.cancelAction(a._id)
}
t=t||0;
if(t>AjxTimedAction.MAX_TIMEOUT){
if(window.DBG){}
t=AjxTimedAction.MAX_TIMEOUT
}
var i=a._id=AjxTimedAction._nextActionId++;
AjxTimedAction._pendingActions[i]=a;
var e="AjxTimedAction._exec("+i+")";
a._tid=window.setTimeout(e,t);
return a._id
};
AjxTimedAction.cancelAction=function(t){
var e=AjxTimedAction._pendingActions[t];
if(e){
window.clearTimeout(e._tid);
delete AjxTimedAction._pendingActions[t];
delete e._tid
}};
AjxTimedAction._exec=function(a){
try{
var t=AjxTimedAction._pendingActions[a];
if(t){
delete AjxTimedAction._pendingActions[a];
delete t._tid;
t._runResult=t.run()
}}
catch(e){
AjxException.reportScriptError(e)
}}
}
if(AjxPackage.define("ajax.net.AjxRpcRequest")){
AjxRpcRequest=function(e){
if(!AjxRpcRequest.__inited){
AjxRpcRequest.__init()
}
this.id=e;
this.__httpReq=AjxRpcRequest.__msxmlVers?(new ActiveXObject(AjxRpcRequest.__msxmlVers)):(new XMLHttpRequest())
};
AjxRpcRequest.TIMEDOUT=-1000;
AjxRpcRequest.__inited=false;
AjxRpcRequest.__msxmlVers=null;
AjxRpcRequest.prototype.toString=function(){
return"AjxRpcRequest"
};
AjxRpcRequest.prototype.invoke=function(a,t,s,c,h,r){
var e=(c!=null);
this.requestStr=a;
this.__httpReq.open((h)?"get":"post",t,e);
if(e){
if(r){
var o=new AjxTimedAction(this,this.__handleTimeout,[c]);
c._timedActionId=AjxTimedAction.scheduleAction(o,r)
}
var l=this;
this.__httpReq.onreadystatechange=function(i){
if(window.AjxRpcRequest){
AjxRpcRequest.__handleResponse(l,c)
}}
}else{
this.__httpReq.onreadystatechange=function(i){}
}
if(s){
for(var n in s){
this.__httpReq.setRequestHeader(n,s[n])
}}
this.__httpReq.send(a);
if(e){
return this.id
}else{
if(this.__httpReq.status==200||this.__httpReq.status==201){
return{
text:this.__httpReq.responseText,xml:this.__httpReq.responseXML,success:true}
}else{
return{
text:this.__httpReq.responseText,xml:this.__httpReq.responseXML,success:false,status:this.__httpReq.status}
}}};
AjxRpcRequest.prototype.cancel=function(){
AjxRpc.freeRpcCtxt(this);
if(AjxEnv.isFirefox3_5up){
this.__httpReq.onreadystatechange=function(){}
}
this.__httpReq.abort()
};
AjxRpcRequest.prototype.__handleTimeout=function(e){
this.cancel();
e.run({
text:null,xml:null,success:false,status:AjxRpcRequest.TIMEDOUT}
)
};
AjxRpcRequest.__handleResponse=function(a,i){
try{
if(!a||!a.__httpReq){
a.cancel();
AjxDebug.println(AjxDebug.RPC,"Async RPC request: Lost request object!!!");
i.run({
text:null,xml:null,success:false,status:500}
);
return
}
if(a.__httpReq.readyState==4){
if(i._timedActionId!==null){
AjxTimedAction.cancelAction(i._timedActionId)
}
var e=500;
try{
e=a.__httpReq.status
}
catch(t){}
if(e==200||e==201){
i.run({
text:a.__httpReq.responseText,xml:a.__httpReq.responseXML,success:true,reqId:a.id}
)
}else{
i.run({
text:a.__httpReq.responseText,xml:a.__httpReq.responseXML,success:false,status:e,reqId:a.id}
)
}
a.cancel()
}}
catch(t){
AjxException.reportScriptError(t)
}};
AjxRpcRequest.__init=function(){
if(!window.XMLHttpRequest&&window.ActiveXObject){
var t=["MSXML2.XMLHTTP.4.0","MSXML2.XMLHTTP.3.0","MSXML2.XMLHTTP","Microsoft.XMLHTTP"];
for(var o=0;
o<t.length;
o++){
try{
var e=new ActiveXObject(t[o]);
AjxRpcRequest.__msxmlVers=t[o];
break
}
catch(a){}}
if(!AjxRpcRequest.__msxmlVers){
throw new AjxException("MSXML not installed",AjxException.INTERNAL_ERROR,"AjxRpc._init")
}}
AjxRpcRequest.__inited=true
}
}
if(AjxPackage.define("ajax.net.AjxRpc")){
AjxRpc=function(){};
AjxRpc.__rpcCache=[];
AjxRpc.__rpcOutstanding={};
AjxRpc.__RPC_CACHE_MAX=50;
AjxRpc.__RPC_COUNT=0;
AjxRpc.__RPC_REAP_AGE=300000;
AjxRpc.invoke=function(a,t,n,c,l,h){
var e=(c!=null);
var o=AjxRpc.__getFreeRpcCtxt();
try{
var i=o.invoke(a,t,n,c,l,h)
}
catch(s){
var r=new AjxException();
r.method="AjxRpc.prototype._invoke";
if(s instanceof Error){
r.detail=s.message;
r.code=AjxException.NETWORK_ERROR;
r.msg="Network error"
}else{
if(s instanceof XMLHttpRequestException&&s.code==101){
r.detail=s.message;
r.code=AjxException.NETWORK_ERROR;
r.msg="Network error"
}else{
r.detail=s.toString();
r.code=AjxException.UNKNOWN_ERROR;
r.msg="Unknown Error"
}}
if(!e){
AjxRpc.freeRpcCtxt(o)
}
throw r
}
if(!e){
AjxRpc.freeRpcCtxt(o)
}
return i
};
AjxRpc.freeRpcCtxt=function(e){
if(AjxRpc.__rpcOutstanding[e.id]){
AjxRpc.__rpcCache.push(e);
delete AjxRpc.__rpcOutstanding[e.id]
}};
AjxRpc.getRpcRequestById=function(e){
return(AjxRpc.__rpcOutstanding[e])
};
AjxRpc.__getFreeRpcCtxt=function(){
var e;
if(AjxRpc.__rpcCache.length>0){
e=AjxRpc.__rpcCache.pop();
AjxDebug.println(AjxDebug.RPC,"reusing RPC ID "+e.id)
}else{
if(AjxRpc.__RPC_COUNT<AjxRpc.__RPC_CACHE_MAX){
var s="__RpcCtxt_"+AjxRpc.__RPC_COUNT;
e=new AjxRpcRequest(s);
AjxRpc.__RPC_COUNT++;
AjxDebug.println(AjxDebug.RPC,"Created RPC "+s+", total created: "+AjxRpc.__RPC_COUNT)
}else{
e=AjxRpc.__reap();
if(!e){
var n=[];
for(var t in AjxRpc.__rpcOutstanding){
var e=AjxRpc.__rpcOutstanding[t];
var o=e.requestStr;
if(o){
n.push(o.replace(/"authToken":"\w*"/,'"authToken":"[removed]"'))
}}
var a=n.join("<br><br>");
AjxDebug.println(AjxDebug.RPC,"Out of RPC cache!!! Outstanding requests: "+a);
throw new AjxException("Out of RPC cache",AjxException.OUT_OF_RPC_CACHE,"AjxRpc.__getFreeRpcCtxt",a)
}}}
AjxRpc.__rpcOutstanding[e.id]=e;
e.timestamp=(new Date()).getTime();
return e
};
AjxRpc.__reap=function(){
var e;
var a=(new Date()).getTime();
for(var t in AjxRpc.__rpcOutstanding){
e=AjxRpc.__rpcOutstanding[t];
if(e.timestamp+AjxRpc.__RPC_REAP_AGE<a){
AjxDebug.println(AjxDebug.RPC,"AjxRpc.__reap: cleared RPC context "+e.id);
e.cancel();
delete AjxRpc.__rpcOutstanding[t];
return e
}}
return null
}
}
if(AjxPackage.define("ajax.xml.AjxXmlDoc")){
AjxXmlDoc=function(){
if(!AjxXmlDoc._inited){
AjxXmlDoc._init()
}};
AjxXmlDoc.prototype.toString=function(){
return"AjxXmlDoc"
};
AjxXmlDoc.INVALID_CHARS_RE=/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uD800-\uDFFF\uFFFE-\uFFFF]/g;
AjxXmlDoc.REC_AVOID_CHARS_RE=/[\u007F-\u0084\u0086-\u009F\uFDD0-\uFDDF]/g;
AjxXmlDoc._inited=false;
AjxXmlDoc._msxmlVers=null;
AjxXmlDoc.create=function(){
var t=new AjxXmlDoc();
var e=null;
if(AjxEnv.isIE){
e=new ActiveXObject(AjxXmlDoc._msxmlVers);
e.async=true;
if(AjxXmlDoc._msxmlVers=="MSXML2.DOMDocument.4.0"){
e.setProperty("SelectionLanguage","XPath");
e.setProperty("SelectionNamespaces","xmlns:zimbra='urn:zimbra' xmlns:mail='urn:zimbraMail' xmlns:account='urn:zimbraAccount'")
}}else{
if(document.implementation&&document.implementation.createDocument){
e=document.implementation.createDocument("","",null)
}else{
throw new AjxException("Unable to create new Doc",AjxException.INTERNAL_ERROR,"AjxXmlDoc.create")
}}
t._doc=e;
return t
};
AjxXmlDoc.createFromDom=function(t){
var e=new AjxXmlDoc();
e._doc=t;
return e
};
AjxXmlDoc.createFromXml=function(e){
var t=AjxXmlDoc.create();
t.loadFromString(e);
return t
};
AjxXmlDoc.replaceInvalidChars=function(e){
AjxXmlDoc.INVALID_CHARS_RE.lastIndex=0;
return e.replace(AjxXmlDoc.INVALID_CHARS_RE,"?")
};
AjxXmlDoc.getXml=function(t){
var e=new XMLSerializer();
return AjxXmlDoc.replaceInvalidChars(e.serializeToString(t))
};
AjxXmlDoc.prototype.getDoc=function(){
return this._doc
};
AjxXmlDoc.prototype.loadFromString=function(t){
var e=this._doc;
e.loadXML(t);
if(AjxEnv.isIE){
if(e.parseError.errorCode!=0){
throw new AjxException(e.parseError.reason,AjxException.INVALID_PARAM,"AjxXmlDoc.loadFromString")
}}};
AjxXmlDoc.prototype.loadFromUrl=function(e){
if(AjxEnv.isChrome||AjxEnv.isSafari){
var t=new window.XMLHttpRequest();
t.open("GET",e,false);
t.send(null);
var a=t.responseXML;
this._doc=a
}else{
this._doc.load(e)
}};
AjxXmlDoc.prototype.toJSObject=function(a,t,e){
_node=function(){
this.__msh_content=""
};
_node.prototype.toString=function(){
return this.__msh_content
};
rec=function(l,c){
var r={}
,h,d;
for(l=l.firstChild;
l;
l=l.nextSibling){
if(l.nodeType==1){
h=l.tagName;
if(a){
h=h.replace(/^.*?:/,"")
}
if(t){
h=h.toLowerCase()
}
d=new _node();
if(r[h]){
if(r[h]==1){
c[h]=[c[h]];
r[h]=2
}
c[h].push(d)
}else{
c[h]=d;
r[h]=1
}
if(e){
if(l.attributes&&l.attributes.length){
for(var s=0;
s<l.attributes.length;
s++){
attr=l.attributes[s];
d[attr.name]=AjxUtil.isNumeric(attr.value)?attr.value:String(attr.value)
}}}
rec(l,d)
}else{
if(l.nodeType==3){
c.__msh_content+=l.nodeValue
}}}};
var i=new _node();
rec(this._doc.documentElement,i);
return i
};
AjxXmlDoc.prototype.getElementsByTagNameNS=function(t,e){
var a=this.getDoc();
return AjxEnv.isIE?a.getElementsByTagName(t+":"+e):a.getElementsByTagNameNS(t,e)
};
AjxXmlDoc.prototype.getFirstElementByTagNameNS=function(t,e){
return this.getElementsByTagNameNS(t,e)[0]
};
AjxXmlDoc.prototype.getElementsByTagName=function(e){
var t=this.getDoc();
return t.getElementsByTagName(e)
};
AjxXmlDoc._init=function(){
if(AjxEnv.isIE){
var e=["MSXML4.DOMDocument","MSXML3.DOMDocument","MSXML2.DOMDocument.4.0","MSXML2.DOMDocument.3.0","MSXML2.DOMDocument","MSXML.DOMDocument","Microsoft.XmlDom"];
for(var a=0;
a<e.length;
a++){
try{
new ActiveXObject(e[a]);
AjxXmlDoc._msxmlVers=e[a];
break
}
catch(t){}}
if(!AjxXmlDoc._msxmlVers){
throw new AjxException("MSXML not installed",AjxException.INTERNAL_ERROR,"AjxXmlDoc._init")
}}else{
if(AjxEnv.isNav||AjxEnv.isOpera||AjxEnv.isSafari){
Document.prototype.loadXML=function(l){
var h=new DOMParser();
var n=h.parseFromString(l,"text/xml");
while(this.hasChildNodes()){
this.removeChild(this.lastChild)
}
var o=n.childNodes.length;
if(AjxEnv.isChrome7){
var c=this.createDocumentFragment();
for(var s=0;
s<o;
s++){
var r=this.importNode(n.childNodes[s],true);
c.appendChild(r)
}
this.appendChild(c)
}else{
for(var s=0;
s<o;
s++){
var r=this.importNode(n.childNodes[s],true);
this.appendChild(r)
}}};
if(AjxEnv.isNav){
_NodeGetXml=function(){
var i=new XMLSerializer();
return i.serializeToString(this)
};
Node.prototype.__defineGetter__("xml",_NodeGetXml)
}}}
AjxXmlDoc._inited=true
};
AjxXmlDoc.prototype.set=function(e,i,t){
var o=this._doc.createElement(e);
if(i!=null){
var a=this._doc.createTextNode("");
o.appendChild(a);
a.nodeValue=i
}
if(t==null){
this.root.appendChild(o)
}else{
t.appendChild(o)
}
return o
};
AjxXmlDoc.prototype.getDocXml=function(){
if(AjxEnv.isSafari){
return AjxXmlDoc.getXml(this.getDoc())
}else{
return AjxXmlDoc.replaceInvalidChars(this.getDoc().xml)
}};
AjxXmlDoc.createRoot=function(a){
var e=AjxXmlDoc.create();
var t=e.getDoc();
e.root=t.createElement(a);
t.appendChild(e.root);
return e
};
AjxXmlDoc.createElement=function(t,i){
var e=AjxXmlDoc.create();
var o=e.getDoc();
e.root=o.createElement(t);
if(i!=null){
var a=o.createTextNode("");
e.root.appendChild(a);
a.nodeValue=i
}
o.appendChild(e.root);
return e
};
AjxXmlDoc.prototype.appendChild=function(e){
if(this._doc!=e._doc&&(AjxEnv.isChrome||AjxEnv.isSafari)){
this.root.appendChild(this.getDoc().importNode(e.root,true))
}else{
this.root.appendChild(e.root)
}}
}
if(AjxPackage.define("zimbraMail.spreadsheets.model.msgs")){
ZmMsg.SS={
func:{
sum:{
help:ZmMsg.spreadSheet_func_sum}
,multiply:{
help:ZmMsg.spreadSheet_func_multiply}
,modulo:{
help:ZmMsg.spreadSheet_func_modulo}
,PI:{
help:ZmMsg.spreadSheet_func_PI,helper:"=PI|"}
,sin:{
help:ZmMsg.spreadSheet_func_sin}
,cos:{
help:ZmMsg.spreadSheet_func_cos}
,tan:{
help:ZmMsg.spreadSheet_func_tan}
,round:{
help:ZmMsg.spreadSheet_func_round}
,ceil:{
help:ZmMsg.spreadSheet_func_ceil}
,floor:{
help:ZmMsg.spreadSheet_func_floor}
,abs:{
help:ZmMsg.spreadSheet_func_abs}
,sqrt:{
help:ZmMsg.spreadSheet_func_sqrt}
,exp:{
help:ZmMsg.spreadSheet_func_exp}
,log:{
help:ZmMsg.spreadSheet_func_log}
,min:{
help:ZmMsg.spreadSheet_func_min}
,max:{
help:ZmMsg.spreadSheet_func_max}
,len:{
help:ZmMsg.spreadSheet_func_len}
,concat:{
help:ZmMsg.spreadSheet_func_concat}
,average:{
help:ZmMsg.spreadSheet_func_average}
,join:{
help:ZmMsg.spreadSheet_func_join,args:"join(separator, string1 [, string2...])",helper:'=join(", ", |)'}
,"if":{
help:ZmMsg.spreadSheet_func_if,args:"if(condition, true_value, false_value)"}}}
}
if(AjxPackage.define("zimbraMail.spreadsheets.model.ZmSpreadSheetModel")){
ZmSpreadSheetModel=function(a,o){
this.ROWS=a;
this.COLS=o;
this.version=1;
var s=this.data=new Array(a);
for(var t=0;
t<a;
++t){
var n=s[t]=new Array(o);
for(var e=0;
e<o;
++e){
n[e]=new ZmSpreadSheetCellModel(this)
}}
this.colProps=new Array(o);
for(var t=0;
t<o;
++t){
this.colProps[t]=ZmSpreadSheetModel.getDefaultColProp()
}
this.rowProps=new Array(a);
for(var t=0;
t<a;
++t){
this.rowProps[t]=ZmSpreadSheetModel.getDefaultRowProp()
}
this._expressionCells=[];
this.reset();
this._maxActiveRow=0;
this._maxActiveCol=0
};
ZmSpreadSheetModel.DEBUG=false;
ZmSpreadSheetModel.DATE_FORMATS=["MM/dd/yy","MM/dd/yyyy","MM-dd-yy","MM-dd-yyyy","MMM dd","MMMM dd","M/d","MMM yyyy","MMMM yyyy","MMMM dd,yyyy","dd-MMM-yyyy","dd-MM"];
ZmSpreadSheetModel.getDefaultColProp=function(){
var e={
width:100};
return e
};
ZmSpreadSheetModel.getDefaultRowProp=function(){
var e={
height:15};
return e
};
ZmSpreadSheetModel.getCellName=function(t,e){
return ZmSpreadSheetModel.getColName(e)+t
};
ZmSpreadSheetModel.getRangeName=function(t,i,e,a){
return ZmSpreadSheetModel.getCellName(t,i)+":"+ZmSpreadSheetModel.getCellName(e,a)
};
ZmSpreadSheetModel.getColName=function(e){
--e;
var t=[];
do{
t.unshift(String.fromCharCode(65+e%26));
e=Math.floor(e/26)
}
while(e>0);
return t.join("")
};
ZmSpreadSheetModel.identifyCell=function(n){
if(/^([a-z]+)([0-9]+)$/i.test(n)){
var t=RegExp.$1.toUpperCase();
var e=parseInt(RegExp.$2);
var o=0;
for(var a=0;
a<t.length;
++a){
o*=26;
o+=t.charCodeAt(a)-64
}
return{
row:e-1,col:o-1}
}
throw"Can't parse cell identifier "+n+" at ZmSpreadSheetModel.identifyCell"
};
ZmSpreadSheetModel.getRangeBounds=function(o){
var e=o.split(/:/);
var s=ZmSpreadSheetModel.identifyCell(e[0]);
var n=ZmSpreadSheetModel.identifyCell(e[1]);
var i=Math.min(s.row,n.row);
var h=Math.min(s.col,n.col);
var t=Math.max(s.row,n.row);
var r=Math.max(s.col,n.col);
return[{
row:i,col:h}
,{
row:t,col:r}
]
};
ZmSpreadSheetModel.shiftCell=function(e,t,a){
var i=ZmSpreadSheetModel.identifyCell(e);
i.row+=t;
i.col+=a;
return ZmSpreadSheetModel.getCellName(i.row+1,i.col+1)
};
ZmSpreadSheetModel.shiftRange=function(t,i,o){
var e=t.split(/:/);
return ZmSpreadSheetModel.shiftCell(e[0],i,o)+":"+ZmSpreadSheetModel.shiftCell(e[1],i,o)
};
ZmSpreadSheetModel.getRangeGeometry=function(e){
var t=ZmSpreadSheetModel.getRangeBounds(e);
return{
rows:t[1].row-t[0].row+1,cols:t[1].col-t[0].col+1,bounds:t}
};
ZmSpreadSheetModel.prototype.getCellsInRange=function(s){
var e=ZmSpreadSheetModel.getRangeBounds(s);
var h=e[0].row;
var t=e[0].col;
var o=e[1].row;
var r=e[1].col;
var l=[];
for(var n=h;
n<=o;
++n){
for(var a=t;
a<=r;
++a){
l.push(this.data[n][a])
}}
return l
};
ZmSpreadSheetModel.prototype._setMaxActiveRow=function(e){
if(this._maxActiveRow<e){
this._maxActiveRow=e
}};
ZmSpreadSheetModel.prototype._setMaxActiveCol=function(e){
if(this._maxActiveCol<e){
this._maxActiveCol=e
}};
ZmSpreadSheetModel.prototype.forEachCell=function(e,o,n){
var t=this.getCellsInRange(e);
for(var a=0;
a<t.length;
++a){
o.apply(n,[t[a],a,t])
}};
ZmSpreadSheetModel.prototype.insertRow=function(t){
if(t==null){
t=this.ROWS
}
var a=new Array(this.COLS);
for(var e=this.COLS;
--e>=0;
){
a[e]=new ZmSpreadSheetCellModel(this)
}
this.data.splice(t,0,a);
this.rowProps.splice(t,0,ZmSpreadSheetModel.getDefaultRowProp());
++this.ROWS;
this.triggerEvent("onInsertRow",a,t);
this.recompute()
};
ZmSpreadSheetModel.prototype.insertCol=function(a){
if(a==null){
a=this.COLS
}
var e=new Array(this.ROWS);
for(var t=this.ROWS;
--t>=0;
){
var o=new ZmSpreadSheetCellModel(this);
e[t]=o;
this.data[t].splice(a,0,o)
}
this.colProps.splice(a,0,ZmSpreadSheetModel.getDefaultColProp());
++this.COLS;
this.triggerEvent("onInsertCol",e,a);
this.recompute()
};
ZmSpreadSheetModel.prototype.deleteRow=function(a){
if(this.ROWS>1){
var e=this.data[a];
for(var t=e.length;
--t>=0;
){
if(e[t]._expr){
e[t].setExpression(null)
}
e[t]._td=null
}
this.data.splice(a,1);
this.rowProps.splice(a,1);
--this.ROWS;
this.triggerEvent("onDeleteRow",a);
this.recompute()
}};
ZmSpreadSheetModel.prototype.deleteCol=function(t){
if(this.COLS>1){
for(var a=this.ROWS;
--a>=0;
){
var e=this.data[a][t];
if(e._expr){
e.setExpression(null)
}
this.data[a].splice(t,1);
e._td=null
}
this.colProps.splice(t,1);
--this.COLS;
this.triggerEvent("onDeleteCol",t);
this.recompute()
}};
ZmSpreadSheetModel.prototype.getRowHeight=function(e){
if(!this.rowProps[e]){
return ZmSpreadSheetModel.getDefaultRowProp().height
}
return this.rowProps[e].height
};
ZmSpreadSheetModel.prototype.setRowHeight=function(t,e){
this.rowProps[t].height=e
};
ZmSpreadSheetModel.prototype.getColWidth=function(e){
return this.colProps[e].width
};
ZmSpreadSheetModel.prototype.setColWidth=function(e,t){
this.colProps[e].width=t
};
ZmSpreadSheetModel.prototype.checkBounds=function(t,e){
if(t<0||t>this.ROWS-1){
throw"Row out of bounds"
}
if(e<0||e>this.COLS-1){
throw"Col out of bounds"
}};
ZmSpreadSheetModel.prototype.reset=function(){
this._viewEvents={}
};
ZmSpreadSheetModel.prototype.triggerEvent=function(e){
var o=this._viewEvents[e];
if(!o){
return null
}
var t=new Array(arguments.length-1);
for(var a=1;
a<arguments.length;
++a){
t[a-1]=arguments[a]
}
o.run.apply(o,t)
};
ZmSpreadSheetModel.prototype.setViewListener=function(e,t){
this._viewEvents[e]=t
};
ZmSpreadSheetModel.prototype.getCell=function(t,e){
return this.data[t-1][e-1]
};
ZmSpreadSheetModel.prototype.getCellByID=function(e){
var t=ZmSpreadSheetModel.identifyCell(e);
return this.data[t.row][t.col]
};
ZmSpreadSheetModel.prototype._orderExpressionCells=function(n){
var i=[];
var s={};
var t=n||this._expressionCells;
while(t.length>0){
var e=t.shift();
var o=e.getName();
if(e._expr&&!s[o]){
t.unshift.apply(t,e._expr.dependsArray());
s[o]=true;
i.push(e)
}}
if(!n){
this._expressionCells=i
}
return i
};
ZmSpreadSheetModel.prototype.recompute=function(o){
for(var a=this._expressionCells.length;
--a>=0;
){
var e=this._expressionCells[a];
try{
e.updateExpression()
}
catch(t){
e._td.firstChild.innerHTML="#REF"
}}};
ZmSpreadSheetModel.prototype.fillSeries=function(t,e){};
ZmSpreadSheetModel.prototype.paste=function(r,f){
var n=r.geometry;
var m=r.bounds;
var t=ZmSpreadSheetModel.getRangeGeometry(f);
var u=t.bounds;
var h;
if(t.rows<n.rows){
t.rows=n.rows
}else{
t.rows-=t.rows%n.rows
}
if(t.cols<n.cols){
t.cols=n.cols
}else{
t.cols-=t.cols%n.cols
}
u[1].row=u[0].row+t.rows-1;
u[1].col=u[0].col+t.cols-1;
r.setDelta(u[0].row-m[0].row,u[0].col-m[0].col);
for(h=u[1].row-this.ROWS;
h-->=0;
){
this.insertRow()
}
for(h=u[1].col-this.COLS;
h-->=0;
){
this.insertCol()
}
var a=0;
var o=0;
var l=[];
for(var h=u[0].row;
h<=u[1].row;
++h){
var e=0;
var p=0;
for(var s=u[0].col;
s<=u[1].col;
++s){
var d=this.data[h][s];
r.paste(a,e,d,o,p);
l.push(d);
e++;
if(e==n.cols){
p+=n.cols;
e=0
}}
a++;
if(a==n.rows){
o+=n.rows;
a=0
}}
var c=this._orderExpressionCells(l);
for(var h=0;
h<c.length;
++h){
c[h].recompute()
}
return[ZmSpreadSheetModel.getCellName(u[0].row+1,u[0].col+1),ZmSpreadSheetModel.getCellName(u[1].row+1,u[1].col+1)]
};
ZmSpreadSheetModel.serializeJSObject=function(a){
var e;
var o=ZmSpreadSheetModel.DEBUG?",\n":",";
switch(typeof a){
case"object":if(a==null){
e="null"
}else{
if(a.serialize&&typeof a.serialize=="function"){
e=a.serialize()
}else{
if(a instanceof Array){
e=new Array(a.length);
for(var t=0;
t<a.length;
++t){
e[t]=this.serializeJSObject(a[t])
}
e=["[",e.join(o),"]"].join("")
}else{
e=new Array();
for(var t in a){
e.push(['"',t.replace(/\x22/g,"\\x22"),'":',this.serializeJSObject(a[t])].join(""))
}
e=["{",e.join(o),"}"].join("")
}}}
break;
case"string":e=a.replace(/\n/g,"\\n").replace(/\x5c/g,"\\x5c").replace(/\x22/g,'\\"');
e=['"',e,'"'].join("");
break;
default:e=a
}
return e
};
ZmSpreadSheetModel.deserializeJSObject=function(str){
var tmp=str.replace(/(\x22(\\.|[^\x22\\])*\x22|\x27(\\.|[^\x27\\])*\x27)/g,"");
var forbid=ZmSpreadSheetModel.DEBUG?/([;()+=\x2f*.-])/g:/([\n;()+=\x2f*.-])/g;
if(forbid.test(tmp)){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: "+RegExp.$1+" characters not allowed.")
}
try{
var foo;
eval(["foo=",str].join(""));
return foo
}
catch(ex){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: malformed data\n[ "+ex+" ]")
}};
ZmSpreadSheetModel.prototype.serialize=function(){
var e={
ROWS:this.ROWS,COLS:this.COLS,version:1,colProps:this.colProps,data:this.data};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetModel.prototype.deserialize=function(s){
var a=ZmSpreadSheetModel.deserializeJSObject(s);
this.ROWS=a.ROWS;
this.COLS=a.COLS;
this.colProps=a.colProps;
this.version=a.version||0;
var o=this.data=a.data;
for(var t=0;
t<this.ROWS;
++t){
var n=o[t];
for(var e=0;
e<this.COLS;
++e){
n[e]=ZmSpreadSheetCellModel.deserialize(this,n[e])
}}};
ZmSpreadSheetModel.prototype.loadFromXml=function(h){
var a=AjxXmlDoc.createFromXml(h);
if(a){
var u=a.toJSObject(false,false,true);
if(!u){
return
}
var r=(u&&u.Worksheet)?u.Worksheet:null;
var p=(r&&r.ColProps)?r.ColProps:null;
var c=(r&&r.Table)?r.Table:null;
var f=(c&&c.Row)?c.Row:[];
this.ROWS=(c&&c.ExpandedRowCount)?c.ExpandedRowCount:0;
this.COLS=(c&&c.ExpandedColumnCount)?c.ExpandedColumnCount:0;
this.colProps=(p&&p.Col)?p.Col:[];
this.version=(r&&r.version)?r.version:0;
var n=this.data=new Array(this.ROWS);
var s=null;
var o=null;
for(var t=0;
t<this.ROWS;
++t){
if(!f||!f[t]){
continue
}
var l=f[t].Cell;
if(!l){
continue
}
var m=n[t]=new Array(this.COLS);
for(var e=0;
e<this.COLS;
++e){
if(!l[e]){
continue
}
s=l[e];
o={
row:s.row,col:s.col,type:s.type,decimals:s.decimals,editValue:s.editValue,style:s.Style};
m[e]=ZmSpreadSheetCellModel.deserialize(this,o)
}}}};
ZmSpreadSheetModel.prototype.doneSetView=function(){
var r=this.data;
for(var s=0;
s<this.ROWS;
++s){
var h=r[s];
for(var n=0;
n<this.COLS;
++n){
var e=h[n];
e.setEditValue(e._editValue,true)
}}
this._orderExpressionCells();
var t=this._expressionCells;
if(ZmSpreadSheetModel.DEBUG){
var o=[];
for(var s=0;
s<t.length;
++s){
o[s]=t[s].getName()
}
console.log("Computing: %s",o.join(", "))
}
for(var s=0;
s<t.length;
++s){
t[s].recompute()
}};
ZmSpreadSheetModel.prototype.getHtml=function(){
var a=["<table style='font: 8pt tahoma,verdana,sans-serif; background-color: #fff; border-collapse: collapse'>"];
for(var t=0;
t<this.ROWS;
++t){
a.push("<tr>");
for(var e=0;
e<this.COLS;
++e){
a.push(this.data[t][e].getHtml())
}
a.push("</tr>")
}
a.push("</table>");
return a.join("")
};
ZmSpreadSheetModel.prototype.addChart=function(e){
if(!this._charts){
this._charts={}
}
var t=e.getHTMLElId();
this._charts[t]=e
};
ZmSpreadSheetModel.prototype.removeChart=function(e){
if(this._charts){
delete this._charts[e];
if(this._charts[e]){
this._charts[e]=null
}}};
ZmSpreadSheetModel.prototype.getXML=function(w){
var d=AjxXmlDoc.createRoot("WorkBook");
d.root.setAttribute("version",1);
var c=AjxXmlDoc.createElement("WorkSheets");
var u=AjxXmlDoc.createElement("WorkSheet");
u.root.setAttribute("name","Sheet1");
if(w.selRow&&w.selCol){
var e=AjxXmlDoc.createElement("Selection");
e.root.setAttribute("row",w.selRow);
e.root.setAttribute("col",w.selCol);
u.appendChild(e)
}
var b=AjxXmlDoc.createElement("Cols");
var s=ZmSpreadSheetModel.getDefaultColProp().width,v,h,p=false;
for(var g=0;
g<this.COLS;
++g){
v=this.colProps[g].width;
if(v!=s){
h=AjxXmlDoc.createElement("Col");
h.root.setAttribute("col",g+1);
h.root.setAttribute("width",this.colProps[g].width);
b.appendChild(h);
p=true
}}
if(p){
u.appendChild(b)
}
var l=this.getChartsXML();
if(l){
u.appendChild(l)
}
var m=AjxXmlDoc.createElement("SheetData");
var r,k,n,p=false,a=0,x=0,o;
var y=ZmSpreadSheetModel.getDefaultRowProp().height;
for(var g=0;
g<this.ROWS;
++g){
p=false;
r=AjxXmlDoc.createElement("Row");
r.root.setAttribute("row",g+1);
for(var f=0;
f<this.COLS;
++f){
o=this.data[g][f];
k=o.getXML(g+1,f+1);
if(k){
a=o.getRow();
x=o.getCol();
r.appendChild(k);
p=true
}}
n=this.rowProps[g].height;
if(n!=y){
r.root.setAttribute("height",n);
p=true
}
if(p){
m.appendChild(r)
}}
var t=AjxXmlDoc.createElement("Active");
t.root.setAttribute("row",a);
t.root.setAttribute("col",x);
u.appendChild(t);
u.appendChild(m);
c.appendChild(u);
d.appendChild(c);
return d
};
ZmSpreadSheetModel.prototype.getChartsXML=function(){
if(!this._charts){
return null
}
var a=AjxXmlDoc.createElement("Charts");
var s,e=false;
for(var n in this._charts){
var t=this._charts[n];
s=AjxXmlDoc.createElement("Chart");
s.root.setAttribute("type",t.getChartType());
var i=t.getChartRange();
s.root.setAttribute("srow",i.sRow);
s.root.setAttribute("scol",i.sCol);
s.root.setAttribute("erow",i.eRow);
s.root.setAttribute("ecol",i.eCol);
var o=t.getChartPos();
if(o){
s.root.setAttribute("x",o.x);
s.root.setAttribute("y",o.y)
}
a.appendChild(s);
e=true
}
return(e?a:null)
};
ZmSpreadSheetModel.MIN_ROWS=40;
ZmSpreadSheetModel.MIN_COLS=15;
ZmSpreadSheetModel.prototype.loadFromXML=function(a){
var n=AjxXmlDoc.createFromXml(a);
if(!n){
return
}
var z=n.toJSObject(false,false,true);
if(!z){
return
}
this.version=z.version;
var v=z.WorkSheets;
v=(v)?v.WorkSheet:null;
if(!v){
return
}
var l=(v instanceof Array)?v[0]:v;
var h,u,s,w;
h=l.Active;
var f=h?new Number(h.row):0;
var p=h?new Number(h.col):0;
this.ROWS=f=(f<=ZmSpreadSheetModel.MIN_ROWS)?ZmSpreadSheetModel.MIN_ROWS:f+5;
this.COLS=p=(p<=ZmSpreadSheetModel.MIN_COLS)?ZmSpreadSheetModel.MIN_COLS:p+3;
this.colProps=new Array(this.COLS);
for(w=0;
w<this.colProps.length;
w++){
this.colProps[w]=ZmSpreadSheetModel.getDefaultColProp()
}
this.rowProps=new Array(this.ROWS);
for(w=0;
w<this.rowProps.length;
w++){
this.rowProps[w]=ZmSpreadSheetModel.getDefaultRowProp()
}
u=l.Cols;
if(u&&u.Col){
u=u.Col;
if(!(u instanceof Array)){
u=[u]
}
for(var w=0;
w<u.length;
w++){
s=new Number(u[w].col)-1;
this.colProps[s].width=u[w].width
}}
var g,x=l.Charts;
if(x&&x.Chart){
this._rawCharts=[];
x=x.Chart;
if(!(x instanceof Array)){
x=[x]
}
for(w=0;
w<x.length;
w++){
g=x[w];
this._rawCharts.push({
type:g.type,sRow:g.srow,sCol:g.scol,eRow:g.erow,eCol:g.ecol,x:g.x,y:g.y}
)
}}
var q,r,c,y,o,t,m,k;
function e(T,j){
var O=null;
for(var i=0;
i<T.length;
i++){
if(T[i].row==j){
O=T[i];
break
}}
return O
}
function d(T,O){
var j=null;
for(var i=0;
i<T.length;
i++){
if(T[i].col==O){
j=T[i];
break
}}
return j
}
q=l.SheetData;
c=q.Row;
if(c){
c=(c instanceof Array)?c:[c]
}
this.data=new Array(this.ROWS);
for(w=0;
w<this.ROWS;
++w){
this.data[w]=r=new Array(this.COLS);
k=c?e(c,w+1):null;
if(k){
if(k.height){
this.rowProps[w].height=k.height
}
o=k.Cell;
if(o&&!(o instanceof Array)){
o=[o]
}}
for(var b=0;
b<this.COLS;
++b){
if(o){
t=d(o,b+1)
}
t=t||{
row:w+1,col:b+1,type:"",decimals:"",editValue:""};
m={
row:t.row,col:t.col,type:t.type,decimals:t.decimals,editValue:t.value,style:t.Style};
r[b]=ZmSpreadSheetCellModel.deserialize(this,m)
}
o=null;
k=null
}};
ZmSpreadSheetClipboard=function(n,o,t){
this._move=!!t;
this.model=n;
this.geometry=ZmSpreadSheetModel.getRangeGeometry(o);
this.range=o;
this.bounds=this.geometry.bounds;
var e=this.cells=n.getCellsInRange(o);
if(!t){
for(var s=e.length;
--s>=0;
){
e[s]=e[s].clone()
}}};
ZmSpreadSheetClipboard.prototype.getCell=function(t,e){
return this.cells[t*this.geometry.cols+e]
};
ZmSpreadSheetClipboard.prototype.setDelta=function(e,t){
this.delta={
rows:e,cols:t}
};
ZmSpreadSheetClipboard.prototype.paste=function(d,a,l,o,c){
var t=this.getCell(d,a);
for(var s in t._style){
l._style[s]=t._style[s]
}
if(t._expr){
var r=t._expr;
var n=r.shift(this.delta.rows+o,this.delta.cols+c);
l._type=t._type;
l._decimals=t._decimals;
l.setEditValue("="+n)
}else{
l._type=t._type;
l._autoType=t._autoType;
l._decimals=t._decimals;
l.setEditValue(t.getEditValue())
}
if(this._move&&!t._wasCut){
var h=t.clone();
this.cells[d*this.geometry.cols+a]=h;
h._wasCut=true;
t.clearAll()
}};
ZmSpreadSheetCellModel=function(t,i,e,a){
if(e==null){
e=""
}
if(i==null){
i=null
}
this._model=t;
this._td=null;
this._decimals=null;
this._type=i;
this._autoType=null;
this._editValue=e;
this._value=e;
this._style=ZmSpreadSheetCellModel.getDefaultStyle(a);
this._expr=null;
this._affects=[]
};
ZmSpreadSheetCellModel.defaultStyle={
fontFamily:"",fontWeight:"",fontStyle:"",fontSize:"",backgroundColor:"",color:"",textAlign:"",verticalAlign:"",textDecoration:""};
ZmSpreadSheetCellModel.prototype.serialize=function(){
var e={
decimals:this._decimals,type:this._type,editValue:this._editValue,style:this._style,row:this.getRow(),col:this.getCol()};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetCellModel.deserialize=function(t,a){
var e=new ZmSpreadSheetCellModel(t,a.type,a.editValue,a.style);
e._decimals=a.decimals;
e._savedRow=a.row;
e._savedCol=a.col;
return e
};
ZmSpreadSheetCellModel.getDefaultStyle=function(a){
if(!a){
a={}
}
var t=ZmSpreadSheetCellModel.defaultStyle;
for(var e in t){
if(typeof a[e]=="undefined"){
a[e]=t[e]
}}
return a
};
ZmSpreadSheetCellModel.prototype.clone=function(){
var t=new ZmSpreadSheetCellModel(null);
t._decimals=this._decimals;
t._type=this._type;
t._autoType=this._autoType;
t._editValue=this._editValue;
t._value=this._value;
t._expr=this._expr;
for(var e in this._style){
t._style[e]=this._style[e]
}
return t
};
ZmSpreadSheetCellModel.prototype.getHtml=function(){
var n=[];
for(var a in this._style){
if(this._style[a]!=""){
var e=a.replace(/([a-z])([A-Z])([a-z])/g,function(l,h,r,i){
return h+"-"+r.toLowerCase()+i
}
);
n.push(e+":"+this._style[a])
}}
var o=this._model.getColWidth(this.getCol()-1);
if(AjxEnv.isIE){
o-=2
}
n.push("width:"+o+"px");
n.push("border:1px solid #aaa");
if(n.length>0){
n=[" style='",n.join(";"),"'"].join("")
}else{
n=""
}
var t=this.getType();
if(t){
var t=" class='SpreadSheet-Type-"+t+"'"
}else{
t=""
}
var s=AjxStringUtil.htmlEncode(this.getDisplayValue().toString());
if(s==""){
s="&nbsp;"
}
return["<td",t,n,">",s,"</td>"].join("")
};
ZmSpreadSheetCellModel.prototype.getXML=function(r,a){
var h=AjxXmlDoc.createElement("Style");
var t=false;
for(var o in this._style){
if(this._style[o]!=""){
var e=o;
if(e!="toString"){
h.root.setAttribute(e,this._style[o]);
t=true
}}}
if(!t&&!this._editValue&&!this._decimals&&!this._type){
return null
}
var s=AjxXmlDoc.createElement("Cell");
var n=s.root;
n.setAttribute("row",r);
n.setAttribute("col",a);
n.setAttribute("value",(this._editValue?this._editValue:""));
if(this._decimals){
n.setAttribute("decimals",(this._decimals?this._decimals:""))
}
if(this._type){
n.setAttribute("type",(this._type?this._type:""))
}
if(t){
s.appendChild(h)
}
return s
};
ZmSpreadSheetCellModel.prototype.setToElement=function(t){
var i=t.firstChild;
if(!i){
t.innerHTML="<div class='Wrapper'></div>";
i=t.firstChild
}
var a=this.getDisplayValue();
if(!/\S/.test(a)){
a="\xA0"
}else{
a=a.toString().replace(/\s/g,"\xA0")
}
i.innerHTML="";
i.appendChild(document.createTextNode(a));
this.setStyleToElement(t);
if(this._expr){
Dwt.addClass(t,"hasFormula")
}else{
Dwt.delClass(t,"hasFormula")
}
var e=this.getType();
if(e){
t.className=t.className.replace(/(^|\s)SpreadSheet-Type-.*?(\s|$)/g," ");
Dwt.addClass(t,"SpreadSheet-Type-"+e)
}};
ZmSpreadSheetCellModel.prototype.setStyleToElement=function(a,e){
for(var t in this._style){
var o=this._style[t];
switch(t){
default:a.style[t]=o
}}};
ZmSpreadSheetCellModel.prototype._mkDeps=function(){
var a=[];
var t={};
function e(o){
var n=o._affects,r=0,h,s;
while(h=n[r++]){
s=h.getName();
if(!t[s]){
t[s]=true;
e(h);
a.unshift(h)
}}}
e(this);
return a
};
ZmSpreadSheetCellModel.prototype.setValue=function(n,t){
if(!this._settingValue){
this._settingValue=true;
this._value=n;
this._model.triggerEvent("onCellValue",this.getRow(),this.getCol(),this);
if(!t){
var e=this._mkDeps();
for(var o=0;
o<e.length;
++o){
e[o].recompute()
}}
this._settingValue=false
}};
ZmSpreadSheetCellModel.prototype.getValue=function(){
switch(this.getType()){
case"currency":case"percentage":case"number":return ZmSpreadSheetFormulae.parseFloat(this._value)
}
return this._value
};
ZmSpreadSheetCellModel.prototype.getEditValue=function(){
return this._editValue
};
ZmSpreadSheetCellModel.prototype.getDisplayValue=function(){
var s=this.getValue();
var o=this.getType();
switch(o){
case"number":if(!/\S/.test(this._editValue)){
s=""
}else{
s=ZmSpreadSheetFormulae.parseFloat(s);
if(this._decimals!=null){
s=s.toFixed(this._decimals)
}}
break;
case"currency":s=ZmSpreadSheetFormulae.parseFloat(s);
if(this._decimals!=null){
s=s.toFixed(this._decimals)
}
s="$"+s;
break;
case"percentage":s=ZmSpreadSheetFormulae.parseFloat(s);
if(this._decimals!=null){
s=s.toFixed(this._decimals)
}
s=s+"%";
break;
case"date":this._formatter=new AjxDateFormat("MM/dd/yy");
var t=null;
for(var a in ZmSpreadSheetModel.DATE_FORMATS){
var n=ZmSpreadSheetModel.DATE_FORMATS[a];
var e=(new AjxDateFormat(n)).parse(s);
if(e){
t=e;
break
}}
s=t?this._formatter.format(t):s;
break
}
return s
};
ZmSpreadSheetCellModel.prototype.setExpression=function(s){
var e=this._model._expressionCells;
for(var n=e.length;
--n>=0;
){
if(e[n]===this){
e.splice(n,1)
}}
if(this._expr){
var r=this._expr.depends();
for(var n in r){
var t=r[n]._affects;
for(var o=t.length;
--o>=0;
){
if(t[o]===this){
t.splice(o,1)
}}}}
this._expr=s;
if(s){
e.push(this);
var r=this._expr.depends();
for(var n in r){
r[n]._affects.push(this)
}}};
ZmSpreadSheetCellModel.prototype.recompute=function(){
this.setValue(this._expr.eval(),true)
};
ZmSpreadSheetCellModel.prototype.updateExpression=function(){
if(this._expr){
var e=this._expr.update();
if(e){
this._editValue="="+e;
this.recompute()
}}};
ZmSpreadSheetCellModel.prototype._determineType=function(a){
var t=a;
var e=null;
if(/^\x27(.*)$/.test(a)){
e="string";
t=RegExp.$1
}else{
if(/^=(.+)$/.test(a)){
t=RegExp.$1;
if(/\S/.test(t)){
e="expression"
}else{
t=a
}}else{
if(/^(\-?[0-9]*\.?[0-9]+)$/.test(a)){
e="number";
t=RegExp.$1
}else{
if(/^\$\s*(\-?[0-9]*\.?[0-9]+)$/.test(a)||/^(\-?[0-9]*\.?[0-9]+)\$$/.test(a)){
e="currency";
t=RegExp.$1;
if(this._decimals==null){
this._decimals=2
}}else{
if(/^(\-?[0-9]*\.?[0-9]+)\s*%$/.test(a)){
e="percentage";
t=RegExp.$1
}else{
if(/^(\d{1,2})(\/|-|\.)(\d{1,2})(\/|-|\.)(\d{2}|\d{4})$/.test(a)){
if(AjxDateUtil.validDate(RegExp.$5,(RegExp.$1-1),RegExp.$3)){
e="date";
this._editValue=t=[RegExp.$1,"/",RegExp.$3,"/",RegExp.$5].join("")
}}}}}}}
return{
type:e,val:t}
};
ZmSpreadSheetCellModel.prototype.getType=function(){
return this._type||this._autoType||"string"
};
ZmSpreadSheetCellModel.prototype.setType=function(e){
this._type=e;
if(e==null){
var t=this._determineType(this.getValue());
this._value=t.val;
this._type=t.type
}else{
if(e=="currency"&&this._decimals==null){
this._decimals=2
}}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getDecimals=function(){
return this._decimals
};
ZmSpreadSheetCellModel.prototype.setDecimals=function(t){
this._decimals=t;
var e=this.getType();
if(e=="currency"&&t==null){
this._decimals=2
}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearValue=function(){
this._type=null;
this.setEditValue("")
};
ZmSpreadSheetCellModel.prototype.clearStyle=function(){
this._style=ZmSpreadSheetCellModel.getDefaultStyle();
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearAll=function(){
this._type=this._decimals=null;
this.clearStyle();
this.clearValue()
};
ZmSpreadSheetCellModel.prototype.setEditValue=function(editValue,force){
if(force||editValue!=this._editValue){
this._editValue=editValue;
var val=editValue;
var auto=this._determineType(editValue);
this._autoType=auto.type;
if(auto.type=="expression"){
var expr;
try{
expr=new ZmSpreadSheetFormulae(this._model,auto.val);
this._errorMessage=null
}
catch(ex){
expr=null;
this._errorMessage=ex;
val="#ERROR"
}
this.setExpression(expr);
if(expr){
val=expr.eval();
if(expr.decimals!=null&&this._decimals==null){
this._decimals=expr.decimals
}
auto=this._determineType(val);
this._autoType=expr.autoType||auto.type;
if(this._autoType=="currency"){
val=auto.val
}}else{
this._type=null;
this._autoType="error"
}}else{
this.setExpression(null);
val=auto.val;
if(auto.type=="string"){
if(!/^([\x27=]|\$?[0-9]+\.?[0-9]*$)/.test(val)){
this._editValue=editValue=val
}}}
this.setValue(val)
}};
ZmSpreadSheetCellModel.prototype.getEditValue=function(){
return this._expr?"="+this._expr.getFormula():this._editValue
};
ZmSpreadSheetCellModel.prototype.getRow=function(){
if(this._td){
return this._td.parentNode.rowIndex
}else{
return this._savedRow
}};
ZmSpreadSheetCellModel.prototype.getCol=function(){
if(this._td){
return this._td.cellIndex
}else{
return this._savedCol
}};
ZmSpreadSheetCellModel.prototype._getTD=function(){
return this._td
};
ZmSpreadSheetCellModel.prototype.getName=function(){
if(this._td||(this._savedRow&&this._savedCol)){
return ZmSpreadSheetModel.getCellName(this.getRow(),this.getCol())
}else{
return"##"
}};
ZmSpreadSheetCellModel.prototype.setStyleProp=function(t,e){
this._style[t]=e;
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getStyleProp=function(e){
return this._style[e]
};
ZmSpreadSheetCellModel.prototype.isEmpty=function(){
return this._editValue==""
};
ZmSpreadSheetCellModel.prototype.getTooltipText=function(){
var o=["<div class='ZmSpreadSheet-Tooltip'>","<div class='CellName'>",ZmMsg.cell," - ",this.getName(),"</div>"];
if(!this.isEmpty()){
o.push("<div class='CellType'>",ZmMsg.type,": ",this.getType(),"</div>")
}else{
o.push("<div class='CellType'>",ZmMsg.emptyCell,"</div>")
}
if(this._errorMessage){
o.push(ZmMsg.editValue,": ",this._editValue);
o.push("<div class='CellExprError'>",this._errorMessage,"</div>")
}else{
if(this._expr){
o.push(ZmMsg.expression,":");
o.push("<div class='CellExpr'>[",this._expr.toString(),"]</div>")
}}
if(ZmSpreadSheetModel.DEBUG){
var e=this._affects;
if(e.length>0){
o.push("Directly affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
e=this._mkDeps();
if(e.length>0){
o.push("Affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
var n=this._td.firstChild;
if(n.offsetWidth>=this._td.offsetWidth){
o.push("Value:","<div class='CellValue'>",this.getDisplayValue(),"</div>")
}}
o.push("</div>");
return o.join("")
}
}
if(AjxPackage.define("zimbraMail.spreadsheets.model.ZmSpreadSheetFormulae")){
ZmSpreadSheetFormulae=function(e,t){
this._model=e;
if(t){
this.compile(t)
}};
ZmSpreadSheetFormulae.TOKEN={
STRING:{
match:{
exec:function(e){
if(!(/^([\x22\x27])/.test(e))){
return null
}
var a=RegExp.$1;
var t=false;
var n="";
for(var o=1;
o<e.length;
++o){
var s=e.charAt(o);
if(!t&&s=="\\"){
t=true
}else{
if(s==a&&!t){
return[e.substr(0,o+1),n]
}
if(t){
switch(s){
case"n":s="\n";
break;
case"t":s="\t";
break
}}
n+=s;
t=false
}}
throw"Unfinished string: "+e
}}
,getVal:function(e){
return e[1]
}
,isOpr:true,type:"string"}
,NUMBER:{
match:/^([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"number"}
,CURRENCY:{
match:/^\$\s*([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"currency"}
,CELLRANGE:{
match:/^([a-z]+[0-9]+:[a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cellrange"}
,CELL:{
match:/^([a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cell"}
,OPERATOR:{
match:/^(<=|>=|==|!=|lt|gt|eq|uc|lc|ne|&&|and|\|\||or|not|[-x*\/+%^.<>!])/,getVal:function(e){
return e[1]
}
,isOpr:false,type:"operator"}
,IDENTIFIER:{
match:/^([a-z_][a-z0-9_?]*)/i,getVal:function(e){
return e[1]
}
,isOpr:false,type:"identifier"}
,OPENPAREN:{
match:new RegExp("^\\("),getVal:function(e){
return e[0]
}
,isOpr:false,type:"openparen"}
,CLOSEPAREN:{
match:/^\)/,getVal:function(e){
return e[0]
}
,isOpr:false,type:"closeparen"}
,COMMA:{
match:new RegExp("^,"),getVal:function(e){
return e[0]
}
,isOpr:false,type:"comma"}};
ZmSpreadSheetFormulae.parseFloat=function(t,e){
if(typeof t=="boolean"){
return t?1:0
}
t=parseFloat(t,10);
if(isNaN(t)){
t=e?e:0
}
return t
};
ZmSpreadSheetFormulae.OPERATORS={
"+":{
priority:10,assoc:3,n_args:2}
,"-":{
priority:10,assoc:2,n_args:2}
,"*":{
priority:20,assoc:3,n_args:2}
,"/":{
priority:20,assoc:2,n_args:2}
,"%":{
priority:30,assoc:2,n_args:2}
,"^":{
priority:30,assoc:2,n_args:2}
,".":{
priority:5,assoc:2,n_args:2}
,lc:{
priority:5,assoc:1,n_args:1}
,uc:{
priority:5,assoc:1,n_args:1}
,x:{
priority:35,assoc:2,n_args:2}
,"<":{
priority:3,assoc:2,n_args:2}
,">":{
priority:3,assoc:2,n_args:2}
,"<=":{
priority:3,assoc:2,n_args:2}
,">=":{
priority:3,assoc:2,n_args:2}
,"==":{
priority:3,assoc:2,n_args:2}
,"!=":{
priority:3,assoc:2,n_args:2}
,lt:{
priority:3,assoc:2,n_args:2}
,gt:{
priority:3,assoc:2,n_args:2}
,eq:{
priority:3,assoc:2,n_args:2}
,ne:{
priority:3,assoc:2,n_args:2}
,"&&":{
priority:2,assoc:2,n_args:2}
,and:{
priority:2,assoc:2,n_args:2}
,"||":{
priority:2,assoc:2,n_args:2}
,or:{
priority:2,assoc:2,n_args:2}
,"!":{
priority:4,assoc:1,n_args:1}
,not:{
priority:4,assoc:1,n_args:1}};
ZmSpreadSheetFormulae.FUNCTIONS={};
ZmSpreadSheetFormulae.getFunc=function(e){
return ZmSpreadSheetFormulae.FUNCTIONS[e.toLowerCase()]
};
ZmSpreadSheetFormulae.HELP={};
ZmSpreadSheetFormulae.getHelp=function(t){
var a=ZmSpreadSheetFormulae.HELP[t];
var e=null;
if(a){
e=a.help;
if(a.args){
e+="<br />"+a.args
}}
return e
};
ZmSpreadSheetFormulae.DEF=function(a,t,h,e){
if(a instanceof Array){
var r=a[0];
var s;
ZmSpreadSheetFormulae.DEF(r,t,h,e);
if(e&&a.length>1){
var n={
alias:r};
for(s in e){
n[s]=e[s]
}
e=n
}
for(s=1;
s<a.length;
++s){
ZmSpreadSheetFormulae.DEF(a[s],t,h,e)
}}else{
var o={
name:a,n_args:t,func:h};
ZmSpreadSheetFormulae.FUNCTIONS[a.toLowerCase()]=o;
if(e){
ZmSpreadSheetFormulae.HELP[a]=e
}}};
ZmSpreadSheetFormulae.DEF(["sum","+"],-1,function(){
var e=0;
for(var t=arguments.length;
--t>=0;
){
e+=ZmSpreadSheetFormulae.parseFloat(arguments[t])
}
return e
}
,ZmMsg.SS.func.sum);
ZmSpreadSheetFormulae.DEF(["multiply","*"],-1,function(){
var e=1;
for(var t=arguments.length;
--t>=0;
){
e*=ZmSpreadSheetFormulae.parseFloat(arguments[t],1)
}
return e
}
,ZmMsg.SS.func.multiply);
ZmSpreadSheetFormulae.DEF(["modulo","%"],2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)%ZmSpreadSheetFormulae.parseFloat(e)
}
,ZmMsg.SS.func.modulo);
ZmSpreadSheetFormulae.DEF(["average","avg"],-1,function(){
var t=arguments.length;
var a=0;
for(var e=t;
--e>=0;
){
var o=arguments[e];
if(!/\S/.test(o)){
o=NaN
}
if(!isNaN(o)){
o=ZmSpreadSheetFormulae.parseFloat(o,NaN)
}
if(!isNaN(o)){
a+=o
}else{
--t
}}
return a/t
}
,ZmMsg.SS.func.average);
ZmSpreadSheetFormulae.DEF("PI",0,function(){
return Math.PI
}
,ZmMsg.SS.func.PI);
ZmSpreadSheetFormulae.DEF("sin",1,function(e){
return Math.sin(e)
}
,ZmMsg.SS.func.sin);
ZmSpreadSheetFormulae.DEF("cos",1,function(e){
return Math.cos(e)
}
,ZmMsg.SS.func.cos);
ZmSpreadSheetFormulae.DEF("tan",1,function(e){
return Math.tan(e)
}
,ZmMsg.SS.func.tan);
ZmSpreadSheetFormulae.DEF("round",1,function(e){
return Math.round(e)
}
,ZmMsg.SS.func.round);
ZmSpreadSheetFormulae.DEF("ceil",1,function(e){
return Math.ceil(e)
}
,ZmMsg.SS.func.ceil);
ZmSpreadSheetFormulae.DEF("floor",1,function(e){
return Math.floor(e)
}
,ZmMsg.SS.func.floor);
ZmSpreadSheetFormulae.DEF("abs",1,function(e){
return Math.abs(e)
}
,ZmMsg.SS.func.abs);
ZmSpreadSheetFormulae.DEF("sqrt",1,function(e){
return Math.sqrt(e)
}
,ZmMsg.SS.func.sqrt);
ZmSpreadSheetFormulae.DEF("exp",1,function(e){
return Math.exp(e)
}
,ZmMsg.SS.func.exp);
ZmSpreadSheetFormulae.DEF("log",1,function(e){
return Math.log(e)
}
,ZmMsg.SS.func.log);
ZmSpreadSheetFormulae.DEF("min",-1,function(){
var t=arguments[0];
for(var e=1;
e<arguments.length;
++e){
if(t>arguments[e]){
t=arguments[e]
}}
return t
}
,ZmMsg.SS.func.min);
ZmSpreadSheetFormulae.DEF("max",-1,function(){
var e=arguments[0];
for(var t=1;
t<arguments.length;
++t){
if(e<arguments[t]){
e=arguments[t]
}}
return e
}
,ZmMsg.SS.func.max);
ZmSpreadSheetFormulae.DEF("len",1,function(e){
return e.toString().length
}
,ZmMsg.SS.func.len);
ZmSpreadSheetFormulae.DEF(["concat","."],-1,function(){
var e=[arguments[0]];
for(var t=1;
t<arguments.length;
++t){
if(arguments[t]!=""){
e.push(arguments[t])
}}
return e.join("")
}
,ZmMsg.SS.func.concat);
ZmSpreadSheetFormulae.DEF("join",-2,function(t){
var e=[arguments[1]];
for(var a=2;
a<arguments.length;
++a){
if(arguments[a]!=""){
e.push(arguments[a])
}}
return e.join(t)
}
,ZmMsg.SS.func.join);
ZmSpreadSheetFormulae.DEF("x",2,function(a,t){
var e="";
while(t-->0){
e+=a
}
return e
}
);
ZmSpreadSheetFormulae.DEF("<",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("<=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("==",2,function(t,e){
return t==e
}
);
ZmSpreadSheetFormulae.DEF("!=",2,function(t,e){
return t!=e
}
);
ZmSpreadSheetFormulae.DEF(["&&","and"],2,function(t,e){
return t&&e
}
);
ZmSpreadSheetFormulae.DEF(["||","or"],2,function(t,e){
return t||e
}
);
ZmSpreadSheetFormulae.DEF(["!","not"],1,function(e){
return !e
}
);
ZmSpreadSheetFormulae.DEF("lt",2,function(t,e){
return t.toString()<e.toString()
}
);
ZmSpreadSheetFormulae.DEF("gt",2,function(t,e){
return t.toString()>e.toString()
}
);
ZmSpreadSheetFormulae.DEF("eq",2,function(t,e){
return t.toString()==e.toString()
}
);
ZmSpreadSheetFormulae.DEF("ne",2,function(t,e){
return t.toString()!=e.toString()
}
);
ZmSpreadSheetFormulae.DEF("lc",1,function(e){
return e.toString().toLowerCase()
}
);
ZmSpreadSheetFormulae.DEF("uc",1,function(e){
return e.toString().toUpperCase()
}
);
ZmSpreadSheetFormulae.DEF("if",3,function(a,e,t){
return a?e:t
}
);
ZmSpreadSheetFormulae.DEF("WHO_are_YOU?",0,function(){
return"http://www.zimbra.com/"
}
);
ZmSpreadSheetFormulae.DEF("-",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)-ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("/",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)/ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("^",2,function(t,e){
return Math.pow(t,e)
}
);
ZmSpreadSheetFormulae.prototype.depends=function(e){
return e!=null?this._deps[e]:this._deps
};
ZmSpreadSheetFormulae.prototype.dependsArray=function(){
return this._depsArray
};
ZmSpreadSheetFormulae.prototype.callFunction=function(t,e){
var a=ZmSpreadSheetFormulae.getFunc(t);
if(!a){
throw"No such function: "+t
}
return a.func.apply(this,e)
};
ZmSpreadSheetFormulae.prototype._analyzeRange=function(g){
var o=g.val;
var m=o.split(/:/);
var l=ZmSpreadSheetModel.identifyCell(m[0]);
var s=ZmSpreadSheetModel.identifyCell(m[1]);
var f=g.startRow=Math.min(l.row,s.row);
var t=g.startCol=Math.min(l.col,s.col);
var r=g.endRow=Math.max(l.row,s.row);
var d=g.endCol=Math.max(l.col,s.col);
g.startCell=this._model.data[f][t];
g.endCell=this._model.data[r][d];
var p=g.cells=[];
for(var h=f;
h<=r;
++h){
for(var n=t;
n<=d;
++n){
var u=this._model.data[h][n];
p.push(u);
var e=ZmSpreadSheetModel.getCellName(h+1,n+1);
if(!this._deps[e]){
this._deps[e]=u;
this._depsArray.push(u)
}}}};
ZmSpreadSheetFormulae.prototype.update=function(){
var h=this._formula,e=this._cellTokens,r=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===r.CELL){
o=n.cell.getName()
}
if(n.type===r.CELLRANGE){
o=n.startCell.getName()+":"+n.endCell.getName()
}
if(o&&n.val!=o){
h=[h.substr(0,n.strPos),o,h.substr(n.strPos+n.strLen)].join("")
}}
if(h!=this._formula){
this.compile(h);
return h
}};
ZmSpreadSheetFormulae.prototype.shift=function(r,h){
var c=this._formula,e=this._cellTokens,l=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===l.CELL){
o=ZmSpreadSheetModel.shiftCell(n.val,r,h)
}
if(n.type===l.CELLRANGE){
o=ZmSpreadSheetModel.shiftRange(n.val,r,h)
}
if(o&&n.val!=o){
c=[c.substr(0,n.strPos),o,c.substr(n.strPos+n.strLen)].join("")
}}
return c
};
ZmSpreadSheetFormulae.prototype.getFormula=function(){
return this._formula
};
ZmSpreadSheetFormulae.parseTokens=function(c,s){
var l=ZmSpreadSheetFormulae.TOKEN;
var d=[];
var u=0;
function g(t){
return t[t.length-1]
}
while(c.length>0){
var m=/^\s+/.exec(c);
if(m){
var h=m[0].length;
u+=h;
c=c.substr(h)
}
var y=false;
for(var r in l){
var p=l[r];
var m=p.match.exec(c);
if(m){
var e=p.getVal(m);
var h=m[0].length;
c=c.substr(h);
var f={
type:p,val:e,isOpr:p.isOpr,strPos:u,strLen:h};
u+=h;
if(p===l.OPERATOR){
var n=ZmSpreadSheetFormulae.OPERATORS[e];
f.priority=n.priority;
f.assoc=n.assoc;
f.n_args=n.n_args
}
if(p===l.IDENTIFIER){
var o=ZmSpreadSheetFormulae.getFunc(e);
if(!o&&!s){
throw'No such function: "'+e+'"'
}
f.priority=100;
if(o&&o.n_args==0){
f.isOpr=true;
f.val=o.func()
}}
d.push(f);
y=true;
break
}}
if(!y){
if(!s){
throw"Parse error at: "+c
}else{
c=c.substr(1);
++u
}}}
return d
};
ZmSpreadSheetFormulae.prototype.getTokens=function(){
return this._tokens
};
ZmSpreadSheetFormulae.prototype.compile=function(h){
this._formula=new String(h);
this._deps={};
this._depsArray=[];
this._cellTokens=[];
this._running=false;
var r=ZmSpreadSheetFormulae.TOKEN;
function p(t){
return t[t.length-1]
}
var l=this._tokens=ZmSpreadSheetFormulae.parseTokens(h);
var u=null;
var m=0;
var y=false;
for(var n=0;
n<l.length;
++n){
var f=l[n];
var s=l[n+1];
if(f.type===r.OPERATOR&&!s){
throw"Misplaced operator"
}
if(u){
if(f.type===r.COMMA&&(u.type===r.COMMA||u.type===r.OPENPAREN)){
throw"Misplaced comma"
}}
if(f.type===r.CELL){
f.val=f.val.toUpperCase();
var d=ZmSpreadSheetModel.identifyCell(f.val);
this._model.checkBounds(d.row,d.col);
f.cell=this._deps[f.val];
if(!f.cell){
f.cell=this._deps[f.val]=this._model.data[d.row][d.col];
this._depsArray.push(f.cell)
}
this._cellTokens.push(f)
}
if(f.type===r.CELLRANGE){
this._analyzeRange(f);
this._cellTokens.push(f)
}
if(f.type===r.OPENPAREN){
m++;
if(u&&u.isOpr){
throw"Paren after operand"
}}
if(f.type===r.CLOSEPAREN){
m--
}
if(f.type===r.OPERATOR&&f.val=="-"&&(!u||!u.isOpr)&&s.type.isNumber){
s.val=-s.val;
l.splice(n,1);
f=u;
--n
}
u=f
}
if(m!=0){
throw"Mismatched parentheses"
}
var c=[];
var a=[];
for(var n=0;
n<l.length;
++n){
var f=l[n];
if(f.isOpr){
a.push(f)
}else{
if(f.type===r.IDENTIFIER){
f.n_args=-1;
c.push(f);
if(ZmSpreadSheetFormulae.getFunc(f.val).n_args!=0){
if(!l[n+1]||l[n+1].type!==r.OPENPAREN){
throw'Function "'+f.val+'" expects arguments.'
}}}else{
if(f.type===r.COMMA){
while(c.length>0&&p(c).type!==r.OPENPAREN){
a.push(c.pop())
}
if(c.length==0||!l[n+1]||l[n+1].type===r.CLOSEPAREN){
throw"Syntax error: misplaced comma or parens"
}
var o=c[c.length-2];
if(!o||o.type!==r.IDENTIFIER){
throw"Syntax error: expecting a function identifier"
}
++o.n_args
}else{
if(f.type===r.OPERATOR){
var e;
while(((e=p(c))!=null)&&e.type===r.OPERATOR&&((f.assoc>=2&&f.priority<=e.priority)||(f.assoc==1&&f.priority>e.priority))){
a.push(c.pop())
}
c.push(f)
}else{
if(f.type===r.OPENPAREN){
var o=p(c);
var s=l[n+1];
if(o&&o.type===r.IDENTIFIER&&s&&s.type!==r.CLOSEPAREN){
++o.n_args
}
c.push(f)
}else{
if(f.type===r.CLOSEPAREN){
while(c.length>0&&p(c).type!==r.OPENPAREN){
a.push(c.pop())
}
if(c.length==0){
throw"Syntax error: misplaced parens"
}else{
c.pop()
}
if(c.length>0&&p(c).type===r.IDENTIFIER){
var o=c.pop();
o.n_args++;
a.push(o);
var g=ZmSpreadSheetFormulae.getFunc(o.val).n_args;
if(g!=null){
if(g>=0&&o.n_args!=g){
throw"Function "+o.val+" expects exactly "+g+" arguments."
}
if(g<0&&o.n_args+g<0){
throw"Function "+o.val+" expects at least "+(-g)+" arguments."
}}}}}}}}}}
while(c.length>0){
var f=c.pop();
if((f.type!==r.OPERATOR&&f.type!==r.IDENTIFIER)||(f.type===r.IDENTIFIER&&ZmSpreadSheetFormulae.getFunc(f.val).n_args>0)){
throw"Expecting only operators or constants at ZmSpreadSheetFormulae.compile"
}
a.push(f)
}
this._stack=a
};
ZmSpreadSheetFormulae.prototype.eval=function(){
if(this._running){
return""
}
this._running=true;
var o=ZmSpreadSheetFormulae.TOKEN,n=this._stack,a=n.length-1,r=this;
var h={};
var e=null;
function s(l){
h[l.getType()]=true;
if(l.getDecimals()!=null){
if(e==null){
e=0
}
if(e<l.getDecimals()){
e=l.getDecimals()
}}
return l.getValue()
}
function t(){
var c=n[a--];
if(c.type===o.CELL){
return s(c.cell)
}
if(c.type===o.CELLRANGE){
var l=new Array(c.cells.length);
for(var m=l.length;
--m>=0;
){
l[m]=s(c.cells[m])
}
return l
}
if(c.isOpr){
return c.val
}
var u=[],d=c.n_args;
while(d-->0){
var f=t();
if(f instanceof Array){
u.unshift.apply(u,f)
}else{
u.unshift(f)
}}
return r.callFunction(c.val,u)
}
var i=t();
if(h.percentage&&!h.currency){
h="percentage"
}else{
if(h.currency){
h="currency"
}else{
h=null
}}
this.autoType=h;
this.decimals=e;
this._running=false;
return i
};
ZmSpreadSheetFormulae.prototype.toString=function(){
return this._formula
}
}
if(AjxPackage.define("zimbraMail.spreadsheets.view.ZmSpreadSheetPreview")){
ZmSpreadSheetPreview=function(e,t){
this._container=document.getElementById(e);
t=t||{};
if(t.versionCont){
t.versionCont=document.getElementById(t.versionCont)
}
this._params=t;
this.init()
};
ZmSpreadSheetPreview.prototype.constructor=ZmSpreadSheetPreview;
ZmSpreadSheetPreview.launch=function(e,t){
return(new ZmSpreadSheetPreview(e,t))
};
ZmSpreadSheetPreview.prototype.init=function(){
this.loadContent()
};
ZmSpreadSheetPreview.prototype.loadContent=function(){
if(!this._content){
this.fetchContent(new AjxCallback(this,this.loadContent));
return
}
var e=this._model=new ZmSpreadSheetModel(0,0);
e.loadFromXML(this._content);
e.doneSetView();
this.show()
};
ZmSpreadSheetPreview.prototype.fetchContent=function(i){
var e=window.location.href;
e=e.replace(/\?.*/,"");
var a=[];
a.push("fmt=native");
var t=this._params.version;
if(t){
a.push("ver="+t)
}
a=a.join("&");
e=e+(a.length>0?"?":"")+a;
AjxRpc.invoke(a,e,null,new AjxCallback(this,this._handleFetchContent,i),true)
};
ZmSpreadSheetPreview.prototype._handleFetchContent=function(t,e){
this._content=e.text;
if(t){
t.run()
}};
ZmSpreadSheetPreview.prototype.show=function(){
var e=this._model.getHtml();
this._container.innerHTML=e;
if(this._params.versionCont){
this._params.versionCont.innerHTML=this._params.version
}}
}};
