
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtChooser=function(a){
if(arguments.length==0){
return
}
DwtComposite.call(this,a.parent,a.className);
this._slvClassName=a.slvClassName;
this._tlvClassName=a.tlvClassName;
this._layoutStyle=a.layoutStyle?a.layoutStyle:DwtChooser.HORIZ_STYLE;
this._selectStyle=a.selectStyle?a.selectStyle:DwtChooser.MULTI_SELECT;
this._mode=a.listStyle?a.listStyle:DwtChooser.MODE_MOVE;
this._noDuplicates=(a.noDuplicates!==false);
this._singleHeight=a.singleHeight?a.singleHeight:45;
this._listSize=a.listSize;
this._sourceEmptyOk=a.sourceEmptyOk;
this._allButtons=a.allButtons;
this._hasTextField=a.hasTextField;
this._handleButtonInfo(a.buttonInfo);
this._mode=a.mode?a.mode:this._hasMultiButtons?DwtChooser.MODE_COPY:DwtChooser.MODE_MOVE;
this._createHtml();
this._initialize();
var t=a.parent.getSize();
var i=a.listWidth||t.x;
var e=a.listHeight||t.y;
if(i&&e){
this.resize(i,e)
}};
DwtChooser.prototype=new DwtComposite;
DwtChooser.prototype.constructor=DwtChooser;
DwtChooser.HORIZ_STYLE=1;
DwtChooser.VERT_STYLE=2;
DwtChooser.SINGLE_SELECT=1;
DwtChooser.MULTI_SELECT=2;
DwtChooser.MODE_COPY=1;
DwtChooser.MODE_MOVE=2;
DwtChooser.REMOVE_BTN_ID="__remove__";
DwtChooser.ADD_ALL_BTN_ID="__addAll__";
DwtChooser.REMOVE_ALL_BTN_ID="__removeAll__";
DwtChooser.prototype.toString=function(){
return"DwtChooser"
};
DwtChooser.prototype.setItems=function(t,e,a){
e=e?e:DwtChooserListView.SOURCE;
this._reset(e);
this.addItems(t,e,true);
this._selectFirst(e);
if(a){
this._reset((e==DwtChooserListView.SOURCE)?DwtChooserListView.TARGET:DwtChooserListView.SOURCE)
}};
DwtChooser.prototype.getItems=function(e){
e=e?e:DwtChooserListView.TARGET;
if(e==DwtChooserListView.SOURCE){
return this.sourceListView.getList().clone()
}else{
if(this._hasMultiButtons){
var a={};
for(var t in this._data){
a[t]=this._data[t].clone()
}
return a
}else{
return this._data[this._buttonInfo[0].id].clone()
}}};
DwtChooser.prototype.addItems=function(t,e,o,r){
e=e?e:DwtChooserListView.SOURCE;
var s=(t instanceof AjxVector)?t.getArray():(t instanceof Array)?t:[t];
if(e==DwtChooserListView.SOURCE){
for(var a=0;
a<s.length;
a++){
this._addToSource(s[a],null,o)
}}else{
var n;
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
this.targetListView._resetList();
s=(s.length>0)?[s[0]]:s
}
for(var a=0;
a<s.length;
a++){
this._addToTarget(s[a],r,o)
}}
if(e==DwtChooserListView.SOURCE){
var s=this.sourceListView.getList();
this._sourceSize=s?s.size():0
}};
DwtChooser.prototype.removeItems=function(o,e,a){
o=(o instanceof AjxVector)?o.getArray():(o instanceof Array)?o:[o];
for(var t=0;
t<o.length;
t++){
(e==DwtChooserListView.SOURCE)?this._removeFromSource(o[t],a):this._removeFromTarget(o[t],a)
}};
DwtChooser.prototype.transfer=function(t,i,e){
i=i?i:this._activeButtonId;
this._setActiveButton(i);
if(this._mode==DwtChooser.MODE_MOVE){
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
var a=this.targetListView.getList();
if(a&&a.size()){
this.remove(a,true)
}}
this.removeItems(t,DwtChooserListView.SOURCE,true)
}
this.addItems(t,DwtChooserListView.TARGET,e);
this.sourceListView.deselectAll()
};
DwtChooser.prototype.remove=function(o,a){
o=(o instanceof AjxVector)?o.getArray():(o instanceof Array)?o:[o];
if(this._mode==DwtChooser.MODE_MOVE){
for(var t=0;
t<o.length;
t++){
var e=this._getInsertionIndex(this.sourceListView,o[t]);
this.sourceListView.addItem(o[t],e,true)
}
this._sourceSize=o?o.length:0
}
this.removeItems(o,DwtChooserListView.TARGET)
};
DwtChooser.prototype.setSelectStyle=function(i,s){
if(i==this._selectStyle){
return
}
this._selectStyle=i;
if(this._defLabel){
var t=this._button[this._buttonInfo[0].id];
t.setText((i==DwtChooser.SINGLE_SELECT)?AjxMsg.select:AjxMsg.add)
}
if(!s){
var o=this.getSize();
this.resize(o.x,o.y)
}
if(this._allButtons){
this._addAllButton.setVisible(i==DwtChooser.MULTI_SELECT);
this._removeAllButton.setVisible(i==DwtChooser.MULTI_SELECT);
this._enableButtons()
}
if(i==DwtChooser.SINGLE_SELECT){
var n=this.targetListView.getList();
var e=n?n.clone().getArray():null;
if(e&&e.length){
this._reset(DwtChooserListView.TARGET);
this.addItems(e[0],DwtChooserListView.TARGET,true);
this.targetListView.deselectAll();
if(e.length>1&&this._mode==DwtChooser.MODE_MOVE){
this.addItems(e.slice(1),DwtChooserListView.SOURCE,true)
}
this._enableButtons()
}}
this.sourceListView.multiSelectEnabled=(i==DwtChooser.MULTI_SELECT);
this.targetListView.multiSelectEnabled=(i==DwtChooser.MULTI_SELECT)
};
DwtChooser.prototype.reset=function(e){
this._reset(e);
this._setActiveButton(this._buttonInfo[0].id);
this._enableButtons();
if(this._hasTextField){
this._textField.setValue("")
}};
DwtChooser.prototype._reset=function(e){
if(!e||e==DwtChooserListView.SOURCE){
this.sourceListView._resetList()
}
if(!e||e==DwtChooserListView.TARGET){
this.targetListView._resetList();
for(var t in this._data){
this._data[t].removeAll()
}}};
DwtChooser.prototype.addStateChangeListener=function(e){
this.targetListView.addStateChangeListener(e)
};
DwtChooser.prototype.removeStateChangeListener=function(e){
this.targetListView.removeStateChangeListener(e)
};
DwtChooser.prototype.getSourceListView=function(){
return document.getElementById(this._sourceListViewDivId)
};
DwtChooser.prototype.getButtons=function(){
return document.getElementById(this._buttonsDivId)
};
DwtChooser.prototype.getTargetListView=function(){
return document.getElementById(this._targetListViewDivId)
};
DwtChooser.prototype.getTextField=function(){
return this._textField
};
DwtChooser.prototype._createHtml=function(){
this._sourceListViewDivId=Dwt.getNextId();
this._targetListViewDivId=Dwt.getNextId();
this._buttonsDivId=Dwt.getNextId();
this._removeButtonDivId=Dwt.getNextId();
if(this._allButtons){
this._addAllButtonDivId=Dwt.getNextId();
this._removeAllButtonDivId=Dwt.getNextId()
}
if(this._hasTextField){
this._textFieldTdId=Dwt.getNextId()
}
var a=[];
var e=0;
if(this._layoutStyle==DwtChooser.HORIZ_STYLE){
a[e++]="<table cellspacing=0 cellpadding=0 border=0>";
a[e++]="<tr>";
a[e++]="<td id='";
a[e++]=this._sourceListViewDivId;
a[e++]="'></td>";
a[e++]="<td valign='middle' id='";
a[e++]=this._buttonsDivId;
a[e++]="'>";
if(this._allButtons){
a[e++]="<div id='";
a[e++]=this._addAllButtonDivId;
a[e++]="'></div><br>"
}
for(var t=0;
t<this._buttonInfo.length;
t++){
var o=this._buttonInfo[t].id;
a[e++]="<div id='";
a[e++]=this._buttonDivId[o];
a[e++]="'></div><br>"
}
a[e++]="<br><div id='";
a[e++]=this._removeButtonDivId;
a[e++]="'></div>";
if(this._allButtons){
a[e++]="<br><div id='";
a[e++]=this._removeAllButtonDivId;
a[e++]="'></div><br>"
}
a[e++]="</td>";
a[e++]="<td id='";
a[e++]=this._targetListViewDivId;
a[e++]="'></td>";
a[e++]="</tr>";
if(this._hasTextField){
a[e++]="<tr><td>";
a[e++]="<table border=0 width=100%><tr><td style='white-space:nowrap; width:1%'>";
a[e++]=AjxMsg.add;
a[e++]=":</td><td id='";
a[e++]=this._textFieldTdId;
a[e++]="'></td></tr></table>";
a[e++]="</td><td>&nbsp;</td><td>&nbsp;</td></tr>"
}
a[e++]="</table>"
}else{
a[e++]="<div id='";
a[e++]=this._sourceListViewDivId;
a[e++]="'></div>";
a[e++]="<div align='center' id='";
a[e++]=this._buttonsDivId;
a[e++]="'>";
a[e++]="<table><tr>";
if(this._allButtons){
a[e++]="<td id='";
a[e++]=this._addAllButtonDivId;
a[e++]="'></td>"
}
for(var t=0;
t<this._buttonInfo.length;
t++){
var o=this._buttonInfo[t].id;
a[e++]="<td id='";
a[e++]=this._buttonDivId[o];
a[e++]="'></td>"
}
a[e++]="<td id='";
a[e++]=this._removeButtonDivId;
a[e++]="'></td>";
if(this._allButtons){
a[e++]="<td id='";
a[e++]=this._removeAllButtonDivId;
a[e++]="'></td>"
}
a[e++]="</tr></table></div>";
a[e++]="<div id='";
a[e++]=this._targetListViewDivId;
a[e++]="'></div>"
}
this.getHtmlElement().innerHTML=a.join("")
};
DwtChooser.prototype._handleButtonInfo=function(t){
if(!t){
this._defLabel=(this._selectStyle==DwtChooser.SINGLE_SELECT)?AjxMsg.select:AjxMsg.add;
t=[{
label:this._defLabel}
]
}
this._buttonInfo=t;
this._buttonDivId={};
this._buttonId={};
if(this._buttonInfo.length==1){
if(!this._buttonInfo[0].id){
this._buttonInfo[0].id=Dwt.getNextId("DwtChooserButtonInfo_")
}
this._activeButtonId=this._buttonInfo[0].id
}
for(var e=0;
e<this._buttonInfo.length;
e++){
var a=this._buttonInfo[e].id;
this._buttonDivId[a]=Dwt.getNextId("DwtChooserButtonDiv_");
this._buttonId[a]=Dwt.getNextId("DwtChooserButton_")
}
this._hasMultiButtons=(this._buttonInfo.length>1)
};
DwtChooser.prototype._initialize=function(){
var e=new AjxListener(this,this._transferButtonListener);
this._button={};
this._buttonIndex={};
this._data={};
for(var t=0;
t<this._buttonInfo.length;
t++){
var o=this._buttonInfo[t].id;
this._button[o]=this._setupButton(o,this._buttonId[o],this._buttonDivId[o],this._buttonInfo[t].label);
this._button[o].addSelectionListener(e);
this._buttonIndex[o]=t;
this._data[o]=new AjxVector()
}
this.sourceListView=this._createSourceListView();
this._addListView(this.sourceListView,this._sourceListViewDivId);
this.sourceListView.addSelectionListener(new AjxListener(this,this._sourceListener));
this.targetListView=this._createTargetListView();
this._addListView(this.targetListView,this._targetListViewDivId);
this.targetListView.addSelectionListener(new AjxListener(this,this._targetListener));
this._removeButtonId=Dwt.getNextId("DwtChooserRemoveButton_");
this._removeButton=this._setupButton(DwtChooser.REMOVE_BTN_ID,this._removeButtonId,this._removeButtonDivId,AjxMsg.remove);
this._removeButton.addSelectionListener(new AjxListener(this,this._removeButtonListener));
if(this._allButtons){
this._addAllButtonId=Dwt.getNextId();
this._addAllButton=this._setupButton(DwtChooser.ADD_ALL_BTN_ID,this._addAllButtonId,this._addAllButtonDivId,AjxMsg.addAll);
this._addAllButton.addSelectionListener(new AjxListener(this,this._addAllButtonListener));
this._removeAllButtonId=Dwt.getNextId();
this._removeAllButton=this._setupButton(DwtChooser.REMOVE_ALL_BTN_ID,this._removeAllButtonId,this._removeAllButtonDivId,AjxMsg.removeAll);
this._removeAllButton.addSelectionListener(new AjxListener(this,this._removeAllButtonListener));
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
this._addAllButton.setVisible(false);
this._removeAllButton.setVisible(false)
}}
if(this._hasTextField){
var a={
parent:this,type:DwtInputField.STRING};
this._textField=new DwtInputField(a);
this._textField.reparentHtmlElement(this._textFieldTdId);
this._textField._chooser=this;
this._textField.setHandler(DwtEvent.ONKEYUP,DwtChooser._onKeyUp);
Dwt.setSize(this._textField.getInputElement(),"100%",Dwt.DEFAULT)
}
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
this.sourceListView.multiSelectEnabled=false;
this.targetListView.multiSelectEnabled=false
}};
DwtChooser.prototype._createSourceListView=function(){
return new DwtChooserListView(this,DwtChooserListView.SOURCE,this._slvClassName)
};
DwtChooser.prototype._createTargetListView=function(){
return new DwtChooserListView(this,DwtChooserListView.TARGET,this._tlvClassName)
};
DwtChooser.prototype._addListView=function(t,a){
var e=document.getElementById(a);
e.appendChild(t.getHtmlElement());
t.setUI(null,true);
t._initialized=true
};
DwtChooser.prototype.resize=function(o,e){
if(!o||!e){
return
}
if(o==Dwt.DEFAULT&&e==Dwt.DEFAULT){
return
}
var a=document.getElementById(this._buttonsDivId);
var s=Dwt.getSize(a);
var t,i,n;
if(this._layoutStyle==DwtChooser.HORIZ_STYLE){
t=this._listSize?this._listSize:(o==Dwt.DEFAULT)?o:Math.floor(((o-s.x)/2)-12);
i=n=e
}else{
t=o;
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
i=this._listSize?this._listSize:(e==Dwt.DEFAULT)?e:e-s.y-this._singleHeight-30;
n=(e==Dwt.DEFAULT)?e:e-s.y-i-30
}else{
i=n=this._listSize?this._listSize:(e==Dwt.DEFAULT)?e:Math.floor(((e-s.y)/2)-12)
}}
this.sourceListView.setSize((t==Dwt.DEFAULT)?t:t+2,i);
this.targetListView.setSize((t==Dwt.DEFAULT)?t:t+2,n)
};
DwtChooser.prototype._setupButton=function(n,a,o,e){
var t=new DwtButton({
parent:this,id:a}
);
t.setText(e);
t.id=a;
t._buttonId=n;
var i=document.getElementById(o);
i.appendChild(t.getHtmlElement());
return t
};
DwtChooser.prototype._sourceListener=function(e){
if(e.detail==DwtListView.ITEM_DBL_CLICKED){
this.transfer(this.sourceListView.getSelection(),this._activeButtonId);
this.sourceListView.deselectAll()
}else{
if(this._activeButtonId==DwtChooser.REMOVE_BTN_ID){
var t=this._lastActiveTransferButtonId?this._lastActiveTransferButtonId:this._buttonInfo[0].id;
this._setActiveButton(t)
}}
this.targetListView.deselectAll();
this._enableButtons()
};
DwtChooser.prototype._targetListener=function(e){
if(e.detail==DwtListView.ITEM_DBL_CLICKED){
this.remove(this.targetListView.getSelection())
}else{
this._setActiveButton(DwtChooser.REMOVE_BTN_ID);
this.sourceListView.deselectAll();
this._enableButtons()
}};
DwtChooser.prototype._transferButtonListener=function(a){
var t=DwtControl.getTargetControl(a);
var n=t._buttonId;
var o=this.sourceListView.getSelection();
if(o&&o.length){
this.transfer(o,n);
var i=this.sourceListView.getList();
if(i&&i.size()){
this._selectFirst(DwtChooserListView.SOURCE)
}else{
this._enableButtons()
}}else{
var e=this._getEmailFromText();
if(e){
this.transfer([e],n)
}else{
this._setActiveButton(n)
}}};
DwtChooser.prototype._removeButtonListener=function(e){
this.remove(this.targetListView.getSelection());
var t=this.targetListView.getList();
if(t&&t.size()){
this._selectFirst(DwtChooserListView.TARGET)
}else{
this._enableButtons()
}};
DwtChooser.prototype._addAllButtonListener=function(e){
this.transfer(this.sourceListView.getList().clone());
this._selectFirst(DwtChooserListView.TARGET)
};
DwtChooser.prototype._removeAllButtonListener=function(e){
this.remove(this.targetListView.getList().clone());
this._selectFirst(DwtChooserListView.SOURCE)
};
DwtChooser.prototype._enableButtons=function(a,r){
var h=this.sourceListView.getList();
var c=this.targetListView.getList();
var o=(a||(this.sourceListView.getSelectionCount()>0));
for(var s=0;
s<this._buttonInfo.length;
s++){
var t=this._buttonInfo[s].id;
this._button[t].setEnabled(o)
}
var l=(r||(this.targetListView.getSelectionCount()>0));
this._removeButton.setEnabled(l);
if(this._allButtons&&(this._selectStyle==DwtChooser.MULTI_SELECT)){
var e=h?h.size():0;
var n=c?c.size():0;
this._addAllButton.setEnabled(e>0);
this._removeAllButton.setEnabled(n>0)
}};
DwtChooser.prototype._selectFirst=function(t,a){
var e=(t==DwtChooserListView.SOURCE)?this.sourceListView:this.targetListView;
var i=e.getList();
if(i&&i.size()>0){
e.setSelection(i.get(0))
}};
DwtChooser.prototype._setActiveButton=function(i){
if(!this._hasMultiButtons){
return
}
if(i!=this._activeButtonId){
var a=(this._activeButtonId==DwtChooser.REMOVE_BTN_ID)?this._removeButtonId:this._buttonId[this._activeButtonId];
if(a){
var e=DwtControl.findControl(document.getElementById(a));
if(e){
e.setDisplayState(DwtControl.NORMAL)
}}
a=(i==DwtChooser.REMOVE_BTN_ID)?this._removeButtonId:this._buttonId[i];
var t=DwtControl.findControl(document.getElementById(a));
if(t){
t.setDisplayState(DwtControl.DEFAULT)
}
this._activeButtonId=i;
if(i!=DwtChooser.REMOVE_BTN_ID){
this._lastActiveTransferButtonId=i
}}};
DwtChooser.prototype._isDuplicate=function(e,t){
return t.contains(e)
};
DwtChooser.prototype._addToSource=function(a,e,t){
if(!a){
return
}
if(!a._chooserIndex){
var i=this.sourceListView.getList();
a._chooserIndex=i?i.size()+1:1
}
this.sourceListView.addItem(a,e,t)
};
DwtChooser.prototype._addToTarget=function(l,e,s){
if(!l){
return
}
e=e?e:this._activeButtonId;
if(this._noDuplicates&&this._data[e]&&this._isDuplicate(l,this._data[e])){
return
}
var n=this.targetListView.getList();
if(n&&n.contains(l)&&l.clone){
var a=l.clone();
a.id=Dwt.getNextId();
l=a
}
var r=null;
if(this._hasMultiButtons){
n=[];
for(var t=0;
t<this._buttonInfo.length;
t++){
n=n.concat(this._data[this._buttonInfo[t].id].getArray())
}
var o=this._buttonIndex[e];
for(r=0;
r<n.length;
r++){
var h=this._buttonIndex[n[r]._buttonId];
if(h>o){
break
}}}
l._buttonId=e;
l.id=l.id||Dwt.getNextId();
this._data[e].add(l);
this.targetListView.addItem(l,r,s)
};
DwtChooser.prototype._removeFromSource=function(t,e){
if(!t){
return
}
var a=this.sourceListView.getList();
if(!a){
return
}
if(!a.contains(t)){
return
}
this.sourceListView.removeItem(t,e)
};
DwtChooser.prototype._removeFromTarget=function(t,e){
if(!t){
return
}
var a=this.targetListView.getList();
if(!a){
return
}
if(!a.contains(t)){
return
}
this._data[t._buttonId].remove(t);
this.targetListView.removeItem(t,e)
};
DwtChooser.prototype._getInsertionIndex=function(t,n){
var s=t.getList();
if(!s){
return null
}
var e=s.getArray();
for(var o=0;
o<e.length;
o++){
if(n._chooserIndex&&e[o]._chooserIndex&&(e[o]._chooserIndex>=n._chooserIndex)){
return o
}}
return null
};
DwtChooser.prototype._getEmailFromText=function(){
if(this._hasTextField){
var t=this._textField.getValue();
var e=AjxEmailAddress.parse(t);
if(e){
e.id=Dwt.getNextId();
return e
}}};
DwtChooser._onKeyUp=function(o){
var a=DwtUiEvent.getTarget(o);
var n=DwtControl.findControl(a);
var i=n._chooser;
var t=DwtKeyEvent.getCharCode(o);
if(t==3||t==13){
var e=i._getEmailFromText();
if(e){
i.transfer([e],i._activeButtonId);
a.value=""
}}
i._enableButtons(a.value.length)
};
DwtChooserListView=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtChooserListView.PARAMS);
e.className=e.className||"DwtChooserListView";
e.headerList=this._getHeaderList(parent);
DwtListView.call(this,e);
this.type=e.type;
this._chooserParent=e.parent.parent
};
DwtChooserListView.PARAMS=["parent","type","className","view"];
DwtChooserListView.SOURCE=1;
DwtChooserListView.TARGET=2;
DwtChooserListView.prototype=new DwtListView;
DwtChooserListView.prototype.constructor=DwtChooserListView;
DwtChooserListView.prototype._getHeaderList=function(){};
DwtChooserListView.prototype.toString=function(){
return"DwtChooserListView"
};
DwtChooserListView.prototype.setUI=function(t,e){
e=e?e:((this.type==DwtChooserListView.TARGET)||this.parent._sourceEmptyOk);
DwtListView.prototype.setUI.call(this,t,e)
};
DwtChooserListView.prototype._itemClicked=function(e,t){
if(!t.shiftKey&&!t.ctrlKey&&t.button==DwtMouseEvent.RIGHT){
return
}else{
DwtListView.prototype._itemClicked.call(this,e,t)
}};
DwtChooserListView.prototype._sortColumn=function(t,e){
this._chooserParent.search(t,e)
};
DwtChooserListView.prototype._getHeaderSashLocation=function(){
var t=this.getHtmlElement();
if(Dwt.getPosition(t)==Dwt.ABSOLUTE_STYLE){
return DwtListView.prototype._getHeaderSashLocation.call(this)
}
var a=Dwt.toWindow(t,0,0);
var e=Dwt.toWindow(this._chooserParent.getHtmlElement(),0,0);
if(!this._tmpPoint){
this._tmpPoint=new DwtPoint()
}
this._tmpPoint.x=a.x-e.x;
this._tmpPoint.y=a.y-e.y;
return this._tmpPoint
};
