
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtInputField=function(h){
if(arguments.length==0){
return
}
this._origClassName=h.className?h.className:"DwtInputField";
this._errorClassName=this._origClassName+"-Error";
this._hintClassName=this._origClassName+"-hint";
this._disabledClassName=this._origClassName+"-disabled";
this._errorHintClassName=this._origClassName+"-errorhint";
DwtComposite.call(this,h);
this._inputEventHandlers={};
this._type=h.type?h.type:DwtInputField.STRING;
this._rows=h.rows?h.rows:1;
this._size=h.size;
this._errorIconStyle=h.errorIconStyle?h.errorIconStyle:h.validator?DwtInputField.ERROR_ICON_RIGHT:DwtInputField.ERROR_ICON_NONE;
this._validationStyle=h.validationStyle?h.validationStyle:DwtInputField.ONEXIT_VALIDATION;
this._hasError=false;
this._hintIsVisible=false;
this._hint=h.hint;
var r=h.inputId||Dwt.getNextId();
var s=Dwt.getNextId();
var n=this.getHtmlElement();
if(this._errorIconStyle==DwtInputField.ERROR_ICON_NONE){
if(h.forceMultiRow||(h.rows&&h.rows>1)){
var e=["<textarea id='",r,"' rows=",h.rows];
var o=e.length;
if(h.forceMultiRow||h.size){
e[o++]=" cols=";
e[o++]=h.size||1
}
if(h.wrap){
e[o++]=" wrap=";
e[o++]=h.wrap
}
e[o++]="></textarea>";
n.innerHTML=e.join("")
}else{
n.innerHTML=["<input id='",r,"'>"].join("")
}}else{
var e=["<table cellspacing='0' cellpadding='0'><tr>"];
var o=1;
if(this._errorIconStyle==DwtInputField.ERROR_ICON_LEFT){
e[o++]=["<td style='padding-right:2px;'id='",s,"'></td>"].join("")
}
e[o++]=["<td>","<input id='",r,"'>","</td>"].join("");
if(this._errorIconStyle==DwtInputField.ERROR_ICON_RIGHT){
e[o++]=["<td style='padding-left:2px;' id='",s,"'></td>"].join("")
}
e[o++]="</tr></table>";
n.innerHTML=e.join("");
if(this._errorIconStyle!=DwtInputField.ERROR_ICON_NONE){
this._errorIconTd=document.getElementById(s);
this._errorIconTd.vAlign="middle";
this._errorIconTd.innerHTML=DwtInputField._NOERROR_ICON_HTML
}}
this._tabGroup=new DwtTabGroup(this._htmlElId);
if(h.forceMultiRow||this._rows>1){
this._inputField=document.getElementById(r);
this._inputField.onkeyup=DwtInputField._keyUpHdlr;
this._inputField.onblur=DwtInputField._blurHdlr;
this._inputField.onfocus=DwtInputField._focusHdlr;
this._inputField.onkeydown=DwtInputField._keyDownHdlr;
if(h.size){
this._inputField.size=h.size
}
if(h.maxLen){
this._inputField.maxLength=this._maxLen=h.maxLen
}
this._inputField.value=h.initialValue||"";
this._tabGroup.addMember(this._inputField)
}else{
var t=document.getElementById(r);
var a=this.__createInputEl(h);
if(AjxEnv.isCamino){
t.parentNode.style.overflow="hidden"
}
t.parentNode.replaceChild(a,t)
}
this.setValidatorFunction(h.validatorCtxtObj,h.validator);
this._setMouseEventHdlrs(false);
this._setKeyPressEventHdlr(false);
if(h.required!=null){
this.setRequired(h.required)
}};
DwtInputField.prototype=new DwtComposite;
DwtInputField.prototype.constructor=DwtInputField;
DwtInputField.prototype.toString=function(){
return"DwtInputField"
};
DwtInputField.ERROR_ICON_LEFT=1;
DwtInputField.ERROR_ICON_RIGHT=2;
DwtInputField.ERROR_ICON_NONE=3;
DwtInputField.CONTINUAL_VALIDATION=1;
DwtInputField.ONEXIT_VALIDATION=2;
DwtInputField.MANUAL_VALIDATION=3;
DwtInputField.NUMBER=1;
DwtInputField.INTEGER=2;
DwtInputField.FLOAT=3;
DwtInputField.STRING=4;
DwtInputField.PASSWORD=5;
DwtInputField.DATE=6;
DwtInputField._ERROR_ICON_HTML=AjxImg.getImageHtml("ClearSearch");
DwtInputField._NOERROR_ICON_HTML=AjxImg.getImageHtml("Blank_9");
DwtInputField.prototype.dispose=function(){
this._errorIconTd=null;
this._inputField=null;
DwtComposite.prototype.dispose.call(this)
};
DwtInputField.prototype.getTabGroupMember=function(){
return this._tabGroup
};
DwtInputField.prototype.setHandler=function(t,e){
if(!this._checkState()){
return
}
this._inputEventHandlers[t]=e;
Dwt.setHandler(this.getInputElement(),t,e)
};
DwtInputField.prototype.setInputType=function(a){
if(a!=this._type&&this._rows==1){
this._type=a;
if(AjxEnv.isIE){
var e=this._inputField;
var t=this.__createInputEl();
e.parentNode.replaceChild(t,e)
}else{
this._inputField.type=this._type!=DwtInputField.PASSWORD?"text":"password"
}}};
DwtInputField.prototype.setValidatorFunction=function(t,e){
if(e){
this._validator=e;
this._validatorObj=t
}else{
switch(this._type){
case DwtInputField.NUMBER:this._validator=DwtInputField.validateNumber;
break;
case DwtInputField.INTEGER:this._validator=DwtInputField.validateInteger;
break;
case DwtInputField.FLOAT:this._validator=DwtInputField.validateFloat;
break;
case DwtInputField.STRING:case DwtInputField.PASSWORD:this._validator=DwtInputField.validateString;
break;
case DwtInputField.DATE:this._validator=DwtInputField.validateDate;
break;
default:this._validator=DwtInputField.validateAny
}}};
DwtInputField.prototype.setValidatorRegExp=function(e,t){
this._validator=e;
this._validatorObj=null;
this._errorString=t||""
};
DwtInputField.prototype.setValidationCallback=function(e){
this._validationCallback=e
};
DwtInputField.prototype.getInputElement=function(){
return this._inputField
};
DwtInputField.prototype.getValue=function(){
return this._hintIsVisible?"":this._inputField.value
};
DwtInputField.prototype.setValue=function(t,e){
t=t||"";
this._inputField.value=t;
if(!e){
t=this._validateInput(t);
if(t!=null){
this._inputField.value=t
}}
if(this._hintIsVisible&&t){
this._hideHint(t)
}else{
if(!t){
this._showHint()
}}};
DwtInputField.prototype.clear=function(){
this.setValue("")
};
DwtInputField.prototype.setHint=function(t){
var e=this._hint;
this._hint=t;
if(this._hintIsVisible){
this.getInputElement().value=t;
if(!t){
this._hintIsVisible=false;
this._updateClassName()
}}else{
if(this._inputField.value==""){
this._showHint()
}}};
DwtInputField.prototype.setValidNumberRange=function(t,e){
this._minNumVal=t;
this._maxNumVal=e;
var a=this._validateInput(this.getValue());
if(a!=null){
this.setValue(a)
}};
DwtInputField.prototype.setValidStringLengths=function(t,e){
this._minLen=t||0;
if(e!=null){
this._inputField.maxLength=e;
this._maxLen=e
}};
DwtInputField.prototype.setNumberPrecision=function(e){
this._decimals=e
};
DwtInputField.prototype.setReadOnly=function(e){
this._inputField.setAttribute("readonly",(e==null?true:e))
};
DwtInputField.prototype.setRequired=function(t){
var e=t==null?true:t;
if(this._required!=e){
this._required=e;
this.validate()
}};
DwtInputField.prototype.getEnabled=function(){
return !this.getInputElement().disabled
};
DwtInputField.prototype.setEnabled=function(e){
DwtControl.prototype.setEnabled.call(this,e);
this.getInputElement().disabled=!e;
this._validateInput(this.getValue())
};
DwtInputField.prototype.focus=function(){
if(this.getEnabled()){
this._hasFocus=true;
this.getInputElement().focus();
DwtShell.getShell(window).getKeyboardMgr().grabFocus(this.getTabGroupMember())
}};
DwtInputField.prototype.blur=function(){
this.getInputElement().blur()
};
DwtInputField.prototype.setVisible=function(e){
DwtComposite.prototype.setVisible.apply(this,arguments);
Dwt.setVisible(this.getInputElement(),e)
};
DwtInputField.prototype.isValid=function(){
if(!this.getEnabled()){
return this.getValue()
}
try{
if(typeof this._validator=="function"){
return this._validatorObj?this._validator.call(this._validatorObj,this.getValue(),this):this._validator(this.getValue())
}else{
return this._validator.test(this._inputField.value)
}}
catch(e){
if(typeof e=="string"){
return null
}else{
throw e
}}};
DwtInputField.prototype.validate=function(){
var e=this._validateInput(this.getValue());
if(e!=null){
this.setValue(e);
return true
}else{
return false
}};
DwtInputField.validateNumber=function(e){
var t=new Number(e);
if(isNaN(t)||(Math.round(t)!=t)){
throw AjxMsg.notAnInteger
}
return DwtInputField.validateFloat.call(this,e)
};
DwtInputField.validateInteger=function(e){
var t=new Number(e);
if(isNaN(t)||(Math.round(t)!=t)||(t.toString()!=e)){
throw AjxMsg.notAnInteger
}
if(this._minNumVal&&e<this._minNumVal){
throw AjxMessageFormat.format(AjxMsg.numberLessThanMin,this._minNumVal)
}
if(this._maxNumVal&&e>this._maxNumVal){
throw AjxMessageFormat.format(AjxMsg.numberMoreThanMax,this._maxNumVal)
}
return e
};
DwtInputField.validateFloat=function(e){
if(this._required&&e==""){
throw AjxMsg.valueIsRequired
}
var i=new Number(e);
if(isNaN(i)){
throw AjxMsg.notANumber
}
if(this._minNumVal&&e<this._minNumVal){
throw AjxMessageFormat.format(AjxMsg.numberLessThanMin,this._minNumVal)
}
if(this._maxNumVal&&e>this._maxNumVal){
throw AjxMessageFormat.format(AjxMsg.numberMoreThanMax,this._maxNumVal)
}
if(this._decimals!=null){
var t=i.toString();
var a=t.indexOf(".");
if(a==-1){
a=t.length
}
e=i.toPrecision(a+this._decimals)
}else{
e=i.toString()
}
return e
};
DwtInputField.validateString=function(e){
if(this._required&&e==""){
throw AjxMsg.valueIsRequired
}
if(this._minLen!=null&&e.length<this._minLen){
throw AjxMessageFormat.format(AjxMsg.stringTooShort,this._minLen)
}
if(this._maxLen!=null&&e.length>this._maxLen){
throw AjxMessageFormat.format(AjxMsg.stringTooLong,this._maxLen)
}
return e
};
DwtInputField.validateDate=function(e){
if(this._required&&e==""){
throw AjxMsg.valueIsRequired
}
if(AjxDateUtil.simpleParseDateStr(e)==null){
throw AjxMsg.invalidDatetimeString
}
return e
};
DwtInputField.validateEmail=function(e){
if(this._required&&e==""){
throw AjxMsg.valueIsRequired
}
if(!AjxEmailAddress.isValid(e)){
throw AjxMsg.invalidEmailAddr
}
return e
};
DwtInputField.validateAny=function(e){
if(this._required&&e==""){
throw AjxMsg.valueIsRequired
}
return e
};
DwtInputField.prototype._validateRegExp=function(e){
if(this._required&&e==""){
throw AjxMsg.valueIsRequired
}
if(this._regExp&&!this._regExp.test(e)){
throw this._errorString
}
return e
};
DwtInputField._keyUpHdlr=function(t){
var e=DwtShell.keyEvent;
e.setFromDhtmlEvent(t,true);
var i=e.dwtObj;
var a=e.keyCode;
if(i.notifyListeners(DwtEvent.ONKEYUP,e)){
return true
}
var o=null;
if((a==13||a==9)&&i._validationStyle==DwtInputField.ONEXIT_VALIDATION){
o=i._validateInput(i.getValue())
}else{
if(i._validationStyle==DwtInputField.CONTINUAL_VALIDATION){
o=i._validateInput(i.getValue())
}}
if(o!=null&&o!=i.getValue()){
i.setValue(o)
}
return true
};
DwtInputField._blurHdlr=function(e){
var t=DwtControl.getTargetControl(e);
if(t){
t._hasFocus=false;
if(t._validationStyle==DwtInputField.ONEXIT_VALIDATION){
var a=t._validateInput(t.getValue());
if(a!=null){
t.setValue(a)
}}
if(!t._hintIsVisible&&t._hint){
t._showHint()
}}};
DwtInputField._focusHdlr=function(e){
var t=DwtControl.getTargetControl(e);
if(t){
var a=DwtShell.getShell(window).getKeyboardMgr().inputGotFocus(t);
if(t._hintIsVisible){
t._hideHint("")
}}};
DwtInputField._keyDownHdlr=function(e){
var t=DwtControl.getTargetControl(e);
if(t){
if(t._hintIsVisible){
t._hideHint("")
}}};
DwtInputField.prototype._hideHint=function(t){
var e=this.getInputElement();
e.value=t;
e.title=this._hint||"";
this._hintIsVisible=false;
this._updateClassName()
};
DwtInputField.prototype._showHint=function(){
if(this._hint){
var e=this.getInputElement();
if(!e.value){
this._hintIsVisible=true;
this._updateClassName();
e.title="";
e.value=this._hint
}}};
DwtInputField.prototype._updateClassName=function(){
var e;
if(!this.getEnabled()){
e=this._disabledClassName
}else{
if(this._hasError){
if(this._hintIsVisible&&!this._hasFocus){
e=this._errorHintClassName
}else{
e=this._errorClassName
}}else{
if(this._hintIsVisible&&!this._hasFocus){
e=this._hintClassName
}else{
e=this._origClassName
}}}
this.getHtmlElement().className=e
};
DwtInputField.prototype._validateInput=function(a){
var o=true;
var i;
var t;
if(!this.getEnabled()){
i=this.getValue()
}else{
try{
if(typeof this._validator=="function"){
i=a=this._validatorObj?this._validator.call(this._validatorObj,a,this):this._validator(a)
}else{
if(!this._validator.test(a)){
t=this._errorString
}}}
catch(e){
if(typeof e=="string"){
t=e
}else{
throw e
}}}
if(t){
this._hasError=true;
if(this._errorIconTd){
this._errorIconTd.innerHTML=DwtInputField._ERROR_ICON_HTML
}
this.setToolTipContent(t);
o=false;
i=null
}else{
this._hasError=false;
if(this._errorIconTd){
this._errorIconTd.innerHTML=DwtInputField._NOERROR_ICON_HTML
}
this.setToolTipContent(null);
o=true
}
this._updateClassName();
if(this._validationCallback){
this._validationCallback.run(this,o,a)
}
return i
};
DwtInputField.prototype._focusByMouseUpEvent=function(){
if(this.getEnabled()){
this._hasFocus=true
}};
DwtInputField.prototype._replaceElementHook=function(t,a,e,i){
a=this.getInputElement();
DwtControl.prototype._replaceElementHook.call(this,t,a,e,i);
if(t.id){
a.id=t.id
}
if(t.size){
a.size=t.size
}
if(t.title){
this.setHint(t.title)
}};
DwtInputField.prototype.__createInputEl=function(s){
var t=this._inputField;
if(t){
for(var o in this._inputEventHandlers){
t.removeAttribute(o)
}}
var n=this._type!=DwtInputField.PASSWORD?"text":"password";
var i=document.createElement(AjxEnv.isIE?["<INPUT type='",n,"'>"].join(""):"INPUT");
if(!AjxEnv.isIE){
i.type=n
}
this._inputField=i;
var a=s?s.size:t.size;
var e=s?s.maxLen:t.maxLength;
i.autocomplete="off";
if(a){
i.size=a
}
if(e){
i.maxLength=e
}
i.value=(s?s.initialValue:t.value)||"";
i.readonly=t?t.readonly:false;
if(s&&s.inputId){
i.id=s.inputId
}
i.onkeyup=DwtInputField._keyUpHdlr;
i.onblur=DwtInputField._blurHdlr;
i.onfocus=DwtInputField._focusHdlr;
i.onkeydown=DwtInputField._keyDownHdlr;
for(var o in this._inputEventHandlers){
i[o]=this._inputEventHandlers[o]
}
this._tabGroup.removeAllMembers();
this._tabGroup.addMember(i);
return i
};
DwtInputField.prototype.disableFocusHdlr=function(){
this._inputField.onfocus=null
};
DwtInputField.prototype.enableFocusHdlr=function(){
this._inputField.onfocus=DwtInputField._focusHdlr
};
