
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtTabView=function(t){
if(arguments.length==0){
return
}
t=Dwt.getParams(arguments,DwtListView.PARAMS);
t.className=t.className||"ZTabView";
t.posStyle=t.posStyle||DwtControl.ABSOLUTE_STYLE;
DwtComposite.call(this,t);
this._stateChangeEv=new DwtEvent(true);
this._stateChangeEv.item=this;
this._tabs=[];
this._tabIx=1;
this._createHtml();
var e=[this.toString(),this._htmlElId].join("-");
this._tabGroup=new DwtTabGroup(e);
this._tabGroup.addMember(this._tabBar)
};
DwtTabView.PARAMS=["parent","className","posStyle"];
DwtTabView.prototype=new DwtComposite;
DwtTabView.prototype.constructor=DwtTabView;
DwtTabView.Z_ACTIVE_TAB=Dwt.Z_VIEW+10;
DwtTabView.Z_HIDDEN_TAB=Dwt.Z_HIDDEN;
DwtTabView.Z_TAB_PANEL=Dwt.Z_VIEW+20;
DwtTabView.Z_CURTAIN=Dwt.Z_CURTAIN;
DwtTabView.prototype.TEMPLATE="dwt.Widgets#ZTabView";
DwtTabView.prototype.toString=function(){
return"DwtTabView"
};
DwtTabView.prototype.addStateChangeListener=function(e){
this._eventMgr.addListener(DwtEvent.STATE_CHANGE,e)
};
DwtTabView.prototype.removeStateChangeListener=function(e){
this._eventMgr.removeListener(DwtEvent.STATE_CHANGE,e)
};
DwtTabView.prototype.getTabGroupMember=function(){
return this._tabGroup
};
DwtTabView.prototype.addTab=function(o,i,t,e){
var a=this._tabIx++;
this._tabs[a]={
title:o,button:this._tabBar.addButton(a,o,t,e)};
this.setTabView(a,i);
if(a==1){
if(i instanceof AjxCallback){
i=i.run(a)
}
if(i){
i.showMe()
}
this._currentTabKey=a;
this.switchToTab(a)
}else{
if(i&&!(i instanceof AjxCallback)){
i.hideMe();
Dwt.setVisible(i.getHtmlElement(),false)
}}
this._tabBar.addSelectionListener(a,new AjxListener(this,DwtTabView.prototype._tabButtonListener));
return a
};
DwtTabView.prototype.enable=function(e){
for(var a in this._tabs){
var t=this._tabs[a].button;
if(t){
t.setEnabled(e)
}}};
DwtTabView.prototype.getCurrentTab=function(){
return this._currentTabKey
};
DwtTabView.prototype.getNumTabs=function(){
return(this._tabs.length-1)
};
DwtTabView.prototype.getTab=function(e){
return(this._tabs&&this._tabs[e])?this._tabs[e]:null
};
DwtTabView.prototype.getTabBar=function(){
return this._tabBar
};
DwtTabView.prototype.getTabTitle=function(e){
return(this._tabs&&this._tabs[e])?this._tabs[e]["title"]:null
};
DwtTabView.prototype.getTabButton=function(e){
return(this._tabs&&this._tabs[e])?this._tabs[e]["button"]:null
};
DwtTabView.prototype.setTabView=function(i,a){
var t=this.getTab(i);
t.view=a;
if(a&&!(a instanceof AjxCallback)){
this._pageEl.appendChild(a.getHtmlElement());
a._tabKey=i;
if(i==this._currentTabKey){
var e=a.getTabGroupMember();
this._tabGroup.replaceMember(t.tabGroup,e);
t.tabGroup=e
}}};
DwtTabView.prototype.getTabView=function(i){
var a=this.getTab(i);
var t=a&&a.view;
if(t instanceof AjxCallback){
var o=t;
t=o.run(i);
this.setTabView(i,t);
var e=this._getTabSize();
t.setSize(e.x,e.y)
}
return t
};
DwtTabView.prototype.switchToTab=function(a){
var t=this.getTab(a);
if(t){
var e=this.getTab(this._currentTabKey);
if(e){
this._tabGroup.removeMember(e.tabGroup)
}
this._showTab(a);
this._tabBar.openTab(a);
if(!t.tabGroup&&t.view){
t.tabGroup=t.view.getTabGroupMember()
}
this._tabGroup.addMember(t.tabGroup);
if(this._eventMgr.isListenerRegistered(DwtEvent.STATE_CHANGE)){
this._eventMgr.notifyListeners(DwtEvent.STATE_CHANGE,this._stateChangeEv)
}}};
DwtTabView.prototype.setBounds=function(t,i,a,e){
DwtComposite.prototype.setBounds.call(this,t,i,a,e);
this._resetTabSizes(a,e)
};
DwtTabView.prototype.getActiveView=function(){
return this._tabs[this._currentTabKey].view
};
DwtTabView.prototype.getKeyMapName=function(){
return"DwtTabView"
};
DwtTabView.prototype.resetKeyBindings=function(){
var t=this.shell.getKeyboardMgr();
if(t.isEnabled()){
var n=t.__keyMapMgr;
if(!n){
return
}
var o=this.getNumTabs();
var r=n.getKeySequences("DwtTabView","GoToTab");
for(var e=0;
e<r.length;
e++){
var h=r[e];
for(var a=1;
a<=o;
a++){
var s=48+a;
var l=h.replace(/NNN/,s);
n.setMapping("DwtTabView",l,"GoToTab"+a)
}}
n.reloadMap("DwtTabView")
}};
DwtTabView.prototype.handleKeyAction=function(i){
switch(i){
case DwtKeyMap.NEXT_TAB:var a=this.getCurrentTab();
if(a<this.getNumTabs()){
this.switchToTab(a+1)
}
break;
case DwtKeyMap.PREV_TAB:var a=this.getCurrentTab();
if(a>1){
this.switchToTab(a-1)
}
break;
default:var t=i.match(DwtKeyMap.GOTO_TAB_RE);
if(t&&t.length){
var e=t[1];
if((e<=this.getNumTabs())&&(e!=this.getCurrentTab())){
this.switchToTab(e)
}}else{
return false
}}
return true
};
DwtTabView.prototype._resetTabSizes=function(a,e){
if(this._tabs&&this._tabs.length){
for(var o in this._tabs){
var t=this._tabs[o].view;
if(t&&!(t instanceof AjxCallback)){
var i;
i=i||e-Dwt.getSize(this._tabBarEl).y;
t.resetSize(a,i)
}}}};
DwtTabView.prototype._getTabSize=function(){
var t=this.getSize();
var a=t.x||this.getHtmlElement().clientWidth;
var e=t.y||this.getHtmlElement().clientHeight;
var i=this._tabBar.getSize();
var o=i.y||this._tabBar.getHtmlElement().clientHeight;
return new DwtPoint(a,(e-o))
};
DwtTabView.prototype._createHtml=function(e){
this._createHtmlFromTemplate(e||this.TEMPLATE,{
id:this._htmlElId}
)
};
DwtTabView.prototype._createHtmlFromTemplate=function(e,t){
DwtComposite.prototype._createHtmlFromTemplate.call(this,e,t);
this._tabBarEl=document.getElementById(t.id+"_tabbar");
this._tabBar=new DwtTabBar(this);
this._tabBar.reparentHtmlElement(this._tabBarEl);
this._pageEl=document.getElementById(t.id+"_page")
};
DwtTabView.prototype._showTab=function(t){
if(this._tabs&&this._tabs[t]){
this._currentTabKey=t;
this._hideAllTabs();
var e=this.getTabView(t);
if(e){
e.setVisible(true);
e.showMe()
}}};
DwtTabView.prototype._hideAllTabs=function(){
if(this._tabs&&this._tabs.length){
for(var t in this._tabs){
var e=this._tabs[t].view;
if(e&&!(e instanceof AjxCallback)){
e.hideMe();
Dwt.setVisible(e.getHtmlElement(),false)
}}}};
DwtTabView.prototype._tabButtonListener=function(e){
this.switchToTab(e.item.getData("tabKey"))
};
DwtTabViewPage=function(a,t,e){
if(arguments.length==0){
return
}
params=Dwt.getParams(arguments,DwtTabViewPage.PARAMS);
params.className=params.className||"ZTabPage";
params.posStyle=params.posStyle||DwtControl.ABSOLUTE_STYLE;
this._rendered=true;
DwtPropertyPage.call(this,params);
this._createHtml();
this.getHtmlElement().style.overflowY="auto";
this.getHtmlElement().style.overflowX="visible";
if(params.contentTemplate){
this.getContentHtmlElement().innerHTML=AjxTemplate.expand(params.contentTemplate,this._htmlElId)
}};
DwtTabViewPage.prototype=new DwtPropertyPage;
DwtTabViewPage.prototype.constructor=DwtTabViewPage;
DwtTabViewPage.prototype.toString=function(){
return"DwtTabViewPage"
};
DwtTabViewPage.prototype.TEMPLATE="dwt.Widgets#ZTabPage";
DwtTabViewPage.PARAMS=DwtPropertyPage.PARAMS.concat("contentTemplate");
DwtTabViewPage.prototype.getContentHtmlElement=function(){
return this._contentEl||this.getHtmlElement()
};
DwtTabViewPage.prototype.showMe=function(){
this.setZIndex(DwtTabView.Z_ACTIVE_TAB);
if(this.parent.getHtmlElement().offsetHeight>80){
this._contentEl.style.height=this.parent.getHtmlElement().offsetHeight-80
}else{
var t=parseInt(this.parent.getHtmlElement().style.height);
var e=AjxStringUtil.getUnitsFromSizeString(this.parent.getHtmlElement().style.height);
if(t>80){
this._contentEl.style.height=(Number(t-80).toString()+e)
}}
this._contentEl.style.width=this.parent.getHtmlElement().style.width
};
DwtTabViewPage.prototype.hideMe=function(){
this.setZIndex(DwtTabView.Z_HIDDEN_TAB)
};
DwtTabViewPage.prototype.resetSize=function(t,e){
this.setSize(t,e)
};
DwtTabViewPage.prototype._createHtml=function(e){
this._createHtmlFromTemplate(e||this.TEMPLATE,{
id:this._htmlElId}
)
};
DwtTabViewPage.prototype._createHtmlFromTemplate=function(e,t){
DwtPropertyPage.prototype._createHtmlFromTemplate.call(this,e,t);
this._contentEl=document.getElementById(t.id+"_content")||this.getHtmlElement()
};
DwtTabBar=function(a,t,i){
if(arguments.length==0){
return
}
this._buttons=[];
this._btnStyle=i||"ZTab";
this._btnImage=null;
this._currentTabKey=1;
var e=t||"ZTabBar";
DwtToolBar.call(this,{
parent:a,className:e,posStyle:DwtControl.STATIC_STYLE}
);
if(AjxEnv.isFirefox){
if(this._prefixEl&&this.constructor==DwtTabBar){
this._prefixEl.style.cssFloat="none"
}}};
DwtTabBar.prototype=new DwtToolBar;
DwtTabBar.prototype.constructor=DwtTabBar;
DwtTabBar.prototype.TEMPLATE="dwt.Widgets#ZTabBar";
DwtTabBar.prototype.toString=function(){
return"DwtTabBar"
};
DwtTabBar.prototype.getCurrentTab=function(){
return this._currentTabKey
};
DwtTabBar.prototype.addStateChangeListener=function(e){
this._eventMgr.addListener(DwtEvent.STATE_CHANGE,e)
};
DwtTabBar.prototype.removeStateChangeListener=function(e){
this._eventMgr.removeListener(DwtEvent.STATE_CHANGE,e)
};
DwtTabBar.prototype.addSelectionListener=function(t,e){
this._buttons[t].addSelectionListener(e)
};
DwtTabBar.prototype.removeSelectionListener=function(t,e){
this._buttons[t].removeSelectionListener(e)
};
DwtTabBar.prototype.addButton=function(n,o,s,a){
var t=this._buttons[n]=new DwtTabButton(this,s,a);
this._buttons[n].addSelectionListener(new AjxListener(this,DwtTabBar._setActiveTab));
if(this._btnImage!=null){
t.setImage(this._btnImage)
}
if(o!=null){
t.setText(o)
}
t.setEnabled(true);
t.setData("tabKey",n);
if(parseInt(n)==1){
this.openTab(n,true)
}
var e=this.__getButtonIndex(this._currentTabKey);
if(e!=-1){
var i=this.__getButtonIndex(n);
if(i==e+1){
Dwt.addClass(t.getHtmlElement(),DwtTabBar.SELECTED_NEXT)
}}
return t
};
DwtTabBar.prototype.getButton=function(e){
return(this._buttons[e])?this._buttons[e]:null
};
DwtTabBar.prototype.openTab=function(e,o){
this._currentTabKey=e;
var i=this._buttons.length;
for(var t=0;
t<i;
t++){
if(t==e){
continue
}
var a=this._buttons[t];
if(a){
this.__markPrevNext(t,false);
a.setClosed()
}}
var a=this._buttons[e];
if(a){
a.setOpen();
this.__markPrevNext(e,true)
}
if(!o&&this._eventMgr.isListenerRegistered(DwtEvent.STATE_CHANGE)){
this._eventMgr.notifyListeners(DwtEvent.STATE_CHANGE,this._stateChangeEv)
}};
DwtTabBar._setActiveTab=function(a){
var e;
if(a&&a.item){
e=a.item.getData("tabKey")
}else{
if(a&&a.target){
var t=a.target;
while(t.tagName!="TABLE"&&t.offsetParent){
t=t.offsetParent
}
e=t.getAttribute("tabKey");
if(e==null){
return false
}}else{
return false
}}
this.openTab(e)
};
DwtTabButton=function(a,i,e,t){
if(arguments.length==0){
return
}
DwtButton.call(this,{
parent:a,className:t,id:i,index:e}
)
};
DwtTabButton.prototype=new DwtButton;
DwtTabButton.prototype.constructor=DwtTabButton;
DwtTabButton.prototype.TEMPLATE="dwt.Widgets#ZTab";
DwtTabButton.prototype.toString=function(){
return"DwtTabButton"
};
DwtTabButton.prototype.setOpen=function(){
this._isSelected=true;
this.setDisplayState(DwtControl.SELECTED)
};
DwtTabButton.prototype.setClosed=function(){
this._isSelected=false;
this.setDisplayState(DwtControl.NORMAL)
};
DwtTabButton.prototype.setDisplayState=function(e){
if(this._isSelected&&e!=DwtControl.SELECTED){
e=[DwtControl.SELECTED,e].join(" ")
}
DwtButton.prototype.setDisplayState.call(this,e)
};
DwtTabBarFloat=function(t,e,a){
if(arguments.length==0){
return
}
DwtTabBar.call(this,t,e,a)
};
DwtTabBarFloat.prototype=new DwtTabBar;
DwtTabBarFloat.prototype.constructor=DwtTabBarFloat;
DwtTabBarFloat.prototype.TEMPLATE="dwt.Widgets#ZTabBarFloat";
DwtTabBarFloat.prototype.addButton=function(o,i,n){
var t=this._buttons[o]=new DwtTabButtonFloat(this,n);
this._buttons[o].addSelectionListener(new AjxListener(this,DwtTabBar._setActiveTab));
if(this._btnImage!=null){
t.setImage(this._btnImage)
}
if(i!=null){
t.setText(i)
}
t.setEnabled(true);
t.setData("tabKey",o);
if(parseInt(o)==1){
this.openTab(o,true)
}
var e=this.__getButtonIndex(this._currentTabKey);
if(e!=-1){
var a=this.__getButtonIndex(o);
if(a==e+1){
Dwt.addClass(t.getHtmlElement(),DwtTabBar.SELECTED_NEXT)
}}
return t
};
DwtTabBarFloat.prototype.addChild=function(t,e){
DwtComposite.prototype.addChild.apply(this,arguments);
this._addItem(DwtToolBar.ELEMENT,t,e)
};
DwtTabBarFloat.prototype._addItem=function(i,a,t){
var o=this._items[t]||this._suffixEl;
var e=t||(typeof t=="number")?t:this._items.length;
this._items.splice(e,0,a);
this._itemsEl.insertBefore(a.getHtmlElement(),o)
};
DwtTabButtonFloat=function(e,t){
DwtTabButton.call(this,e,t,undefined,"ZTab")
};
DwtTabButtonFloat.prototype=new DwtTabButton;
DwtTabButtonFloat.prototype.constructor=DwtTabButtonFloat;
DwtTabButtonFloat.prototype.TEMPLATE="dwt.Widgets#ZTabFloat";
