
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtToolBar=function(a){
if(arguments.length==0){
return
}
a=Dwt.getParams(arguments,DwtToolBar.PARAMS);
a.className=a.className||"ZToolbar";
DwtComposite.call(this,a);
if(a.parent instanceof DwtToolBar){
this._hasSetMouseEvents=a.parent._hasSetMouseEvents
}
if(a.handleMouse!==false&&!this._hasSetMouseEvents){
var e=AjxEnv.isIE?[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP]:[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP,DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT];
this._setEventHdlrs(e);
this._hasSetMouseEvents=true
}
this._style=a.style||DwtToolBar.HORIZ_STYLE;
this._items=[];
this._createHtml();
this._numFillers=0;
this._curFocusIndex=0;
var t=(this._style==DwtToolBar.HORIZ_STYLE)?"horiz":"vert";
this._keyMapName=["DwtToolBar",t].join("-")
};
DwtToolBar.PARAMS=["parent","className","posStyle","style","index","id"];
DwtToolBar.prototype=new DwtComposite;
DwtToolBar.prototype.constructor=DwtToolBar;
DwtToolBar.prototype.toString=function(){
return"DwtToolBar"
};
DwtToolBar.HORIZ_STYLE=1;
DwtToolBar.VERT_STYLE=2;
DwtToolBar.ELEMENT=1;
DwtToolBar.SPACER=2;
DwtToolBar.SEPARATOR=3;
DwtToolBar.FILLER=4;
DwtToolBar.FIRST_ITEM="ZFirstItem";
DwtToolBar.LAST_ITEM="ZLastItem";
DwtToolBar.SELECTED_NEXT=DwtControl.SELECTED+"Next";
DwtToolBar.SELECTED_PREV=DwtControl.SELECTED+"Prev";
DwtToolBar._NEXT_PREV_RE=new RegExp("\\b"+[DwtToolBar.SELECTED_NEXT,DwtToolBar.SELECTED_PREV].join("|")+"\\b","g");
DwtToolBar.prototype.TEMPLATE="dwt.Widgets#ZToolbar";
DwtToolBar.prototype.ITEM_TEMPLATE="dwt.Widgets#ZToolbarItem";
DwtToolBar.prototype.SEPARATOR_TEMPLATE="dwt.Widgets#ZToolbarSeparator";
DwtToolBar.prototype.SPACER_TEMPLATE="dwt.Widgets#ZToolbarSpacer";
DwtToolBar.prototype.FILLER_TEMPLATE="dwt.Widgets#ZToolbarFiller";
DwtToolBar.__itemCount=0;
DwtToolBar.prototype.dispose=function(){
this._itemsEl=null;
this._prefixEl=null;
this._suffixEl=null;
DwtComposite.prototype.dispose.call(this)
};
DwtToolBar.prototype.getItem=function(e){
return this._children.get(e)
};
DwtToolBar.prototype.getItemCount=function(){
return this._children.size()
};
DwtToolBar.prototype.getItems=function(){
return this._children.getArray()
};
DwtToolBar.prototype.addSpacer=function(t,e){
var a=this._createSpacerElement();
this._addItem(DwtToolBar.SPACER,a,e);
return a
};
DwtToolBar.prototype.addSeparator=function(a,e){
var t=this._createSeparatorElement();
this._addItem(DwtToolBar.SEPARATOR,t,e);
return t
};
DwtToolBar.prototype.removeSeparator=function(e){
this._removeItem(e)
};
DwtToolBar.prototype.addFiller=function(a,e){
var t=this._createFillerElement();
this._addItem(DwtToolBar.FILLER,t,e);
return t
};
DwtToolBar.prototype.addChild=function(a,e){
DwtComposite.prototype.addChild.apply(this,arguments);
var t=this._createItemElement();
t.appendChild(a.getHtmlElement());
this._addItem(DwtToolBar.ELEMENT,t,e)
};
DwtToolBar.prototype.getKeyMapName=function(){
return this._keyMapName
};
DwtToolBar.prototype.handleKeyAction=function(t,i){
var a=this.getItem(this._curFocusIndex);
var e=this.getItemCount();
if(e<2){
return true
}
switch(t){
case DwtKeyMap.PREV:if(this._curFocusIndex>0){
this._moveFocus(true)
}
break;
case DwtKeyMap.NEXT:if(this._curFocusIndex<(e-1)){
this._moveFocus()
}
break;
default:if(a){
return a.handleKeyAction(t,i)
}}
return true
};
DwtToolBar.prototype._createItemId=function(t){
t=t||this._htmlElId;
var e=[t,"item",++DwtToolBar.__itemCount].join("_");
return e
};
DwtToolBar.prototype._createHtml=function(){
var e={
id:this._htmlElId};
this._createHtmlFromTemplate(this.TEMPLATE,e);
this._itemsEl=document.getElementById(e.id+"_items");
this._prefixEl=document.getElementById(e.id+"_prefix");
this._suffixEl=document.getElementById(e.id+"_suffix")
};
DwtToolBar.prototype._createItemElement=function(a){
a=a||this.ITEM_TEMPLATE;
var i={
id:this._htmlElId,itemId:this._createItemId()};
var t=AjxTemplate.expand(a,i);
var e=AjxStringUtil.calcDIV();
e.innerHTML=t;
return e.firstChild.rows[0].cells[0]
};
DwtToolBar.prototype._createSpacerElement=function(e){
return this._createItemElement(e||this.SPACER_TEMPLATE)
};
DwtToolBar.prototype._createSeparatorElement=function(e){
return this._createItemElement(e||this.SEPARATOR_TEMPLATE)
};
DwtToolBar.prototype._createFillerElement=function(e){
return this._createItemElement(e||this.FILLER_TEMPLATE)
};
DwtToolBar.prototype._addItem=function(i,a,t){
var o=this._items[t]||this._suffixEl;
var e=t||(typeof t=="number")?t:this._items.length;
this._items.splice(e,0,a);
this._itemsEl.insertBefore(a,o)
};
DwtToolBar.prototype._removeItem=function(t){
for(var e=0;
e<this._items.length;
e++){
if(this._items[e]==t){
this._items.splice(e,1);
this._itemsEl.removeChild(t);
break
}}};
DwtToolBar.prototype._focus=function(e){
if(!this._submenuKeySet){
var a=this.shell.getKeyboardMgr();
if(a.isEnabled()){
var t=a.__keyMapMgr;
if(t){
if(this._style==DwtToolBar.HORIZ_STYLE){
t.removeMapping("DwtButton","ArrowRight");
t.setMapping("DwtButton","ArrowDown",DwtKeyMap.SUBMENU)
}else{
t.removeMapping("DwtButton","ArrowDown");
t.setMapping("DwtButton","ArrowRight",DwtKeyMap.SUBMENU)
}
t.reloadMap("DwtButton")
}}
this._submenuKeySet=true
}
e=e?e:this._getFocusItem(this._curFocusIndex);
if(e){
e._hasFocus=true;
e._focus()
}else{
this._moveFocus()
}};
DwtToolBar.prototype._blur=function(e){
e=e?e:this._getFocusItem(this._curFocusIndex);
if(e){
e._hasFocus=false;
e._blur()
}};
DwtToolBar.prototype._getFocusItem=function(e){
var t=this.getItem(e);
if(!t||(t instanceof DwtToolBar)){
return null
}
if(t._noFocus){
return null
}
if(t.getEnabled&&!t.getEnabled()){
return null
}
if(t.getVisible&&!t.getVisible()){
return null
}
return t
};
DwtToolBar.prototype._moveFocus=function(e){
var t=this._curFocusIndex;
var a=this.getItemCount()-1;
var i=null;
while(!i&&t>=0&&t<=a){
t=e?t-1:t+1;
i=this._getFocusItem(t)
}
if(i){
this._blur();
this._curFocusIndex=t;
this._focus(i)
}};
DwtToolBar.prototype.__markPrevNext=function(s,n){
var e=this.__getButtonIndex(s);
var i=this.__getButtonAt(e-1);
var t=this.__getButtonAt(e+1);
if(n){
if(i){
Dwt.delClass(i.getHtmlElement(),DwtToolBar._NEXT_PREV_RE,DwtToolBar.SELECTED_PREV)
}
if(t){
Dwt.delClass(t.getHtmlElement(),DwtToolBar._NEXT_PREV_RE,DwtToolBar.SELECTED_NEXT)
}}else{
if(i){
Dwt.delClass(i.getHtmlElement(),DwtToolBar._NEXT_PREV_RE)
}
if(t){
Dwt.delClass(t.getHtmlElement(),DwtToolBar._NEXT_PREV_RE)
}}
var o=this.__getButtonAt(0);
if(o){
Dwt.addClass(o.getHtmlElement(),DwtToolBar.FIRST_ITEM)
}
var a=this.__getButtonAt(this.getItemCount()-1);
if(a){
Dwt.addClass(a.getHtmlElement(),DwtToolBar.LAST_ITEM)
}};
DwtToolBar.prototype.__getButtonIndex=function(a){
var t=0;
for(var e in this._buttons){
if(e==a){
return t
}
t++
}
return -1
};
DwtToolBar.prototype.__getButtonAt=function(t){
var a=0;
for(var e in this._buttons){
if(a==t){
return this._buttons[e]
}
a++
}
return null
};
DwtToolBarButton=function(e){
if(arguments.length==0){
return
}
var e=Dwt.getParams(arguments,DwtToolBarButton.PARAMS);
e.className=e.className||"ZToolbarButton";
DwtButton.call(this,e)
};
DwtToolBarButton.PARAMS=["parent","style","className","posStyle","actionTiming","id","index"];
DwtToolBarButton.prototype=new DwtButton;
DwtToolBarButton.prototype.constructor=DwtToolBarButton;
DwtToolBarButton.prototype.TEMPLATE="dwt.Widgets#ZToolbarButton";
