
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
XFormItemFactory=function(){};
XFormItemFactory.createItem=function(r,o,c){
var s=this.getRefPath(r,o);
var a=this.getSubRefPath(r,o);
var h,t;
if(s!=null){
h=this.getModelItem(c.xmodel,r,s)
}
if(a!=null){
t=this.getModelItem(c.xmodel,r,a)
}
var l=this.getItemType(r,h);
var n=this.getItemTypeConstructor(l,c);
var d=new n();
d._setAttributes(r);
var e=(r.id?c.getId()+"_"+r.id:s?c.getId()+"_"+s:d.__parentItem?d.__parentItem.getId():c.getId()+"_"+d.type);
d.id=c.getUniqueId(e);
d.refPath=s;
d.subRefPath=a;
d.__modelItem=h;
d.__subModelItem=t;
d.__xform=c;
d.__parentItem=o;
c.indexItem(d,d.id);
d.initFormItem();
return d
};
XFormItemFactory.getRefPath=function(a,e){
if(a.refPath){
return a.refPath
}
var o=a.ref;
if(o==null){
return null
}
if(e){
var t=e.getRefPath();
if(t==null){
t=""
}}else{
var t=""
}
var n=o;
if(o=="."){
n=t
}else{
if(o==".."){
t=t.split("/");
n=t.slice(0,t.length-1).join("/")
}else{
if(t==""){
n=o
}else{
n=t+"/"+o
}}}
return n
};
XFormItemFactory.getSubRefPath=function(a,e){
if(a.subRefPath){
return a.subRefPath
}
var n=a.subRef;
if(n==null){
return null
}
if(e){
var t=e.getSubRefPath();
if(t==null){
t=""
}}else{
var t=""
}
var o=n;
if(n=="."){
o=t
}else{
if(n==".."){
t=t.split("/");
o=t.slice(0,t.length-1).join("/")
}else{
if(t==""){
o=n
}else{
o=t+"/"+n
}}}
return o
};
XFormItemFactory.getModelItem=function(a,e,t){
if(t==null||t==""){
return null
}
return a.getItem(t,true)
};
XFormItemFactory.getItemType=function(t,o){
var n=t.type;
if(n==null){
n=t.type=_OUTPUT_
}
var a=(o&&o.type?o.type:_STRING_);
if(n==_INPUT_){
if(t.value!==_UNDEFINED_){
n=_CHECKBOX_
}else{
switch(a){
case _STRING_:case _NUMBER_:n=_INPUT_;
break;
case _DATE_:case _DATETIME_:case _TIME_:n=a;
break;
default:n=_INPUT_
}}}else{
if(n==_SELECT_){
var e=t.appearance;
if(e==_RADIO_){
n=_RADIO_
}else{
n=_SELECT_
}}}
return n
};
XFormItemFactory.typeConstructorMap={};
XFormItemFactory.createItemType=function(o,e,a,t){
if(a==null){
a=new Function()
}
if(typeof t=="string"){
t=this.getItemTypeConstructor(t)
}
if(t==null){
t=XFormItem
}
a.prototype=new t();
a.prototype.type=e;
a.prototype.constructor=a;
a.prototype.toString=new Function("return '[XFormItem:"+e+" ' + this.getId() + ']'");
a.toString=new Function("return '[Class XFormItem:"+e+"]'");
this.registerItemType(o,e,a);
return a
};
XFormItemFactory.registerItemType=function(a,e,t){
window[a]=e;
this.typeConstructorMap[e]=t
};
XFormItemFactory.defaultItemType="output";
XFormItemFactory.getItemTypeConstructor=function(e,t){
var a=(t&&t.typeConstructorMap?t.typeConstructorMap:this.typeConstructorMap);
var n=a[e];
if(n==null){
var o=(t?t.defaultItemType:this.defaultItemType);
a[o]
}
return n
};
XFormItemFactory.quickClone=function(e){
this.cloner.prototype=e;
return new this.cloner()
};
XFormItemFactory.cloner=function(){};
XFormItemFactory.initItemDefaults=function(o,r){
o.typeConstructorMap=this.quickClone(this.typeConstructorMap);
if(r==null){
r=o.itemDefaults
}
if(r!=null){
for(var a in r){
var t=this.typeConstructorMap[a];
var n=r[a];
if(t==null){
a=window[a];
t=this.typeConstructorMap[a]
}
if(t==null){
continue
}
var e=o.typeConstructorMap[a]=new Function();
e.prototype=new t();
e.prototype.constructor=e;
for(var s in n){
e.prototype[s]=n[s]
}}}};
XFormItem=function(){};
XFormItem.prototype.constructor=XFormItem;
XFormItemFactory.registerItemType("_FORM_ITEM_","form_item",XFormItem);
XFormItem.ERROR_STATE_ERROR=0;
XFormItem.ERROR_STATE_VALID=1;
XFormItem.prototype._isXFormItem=true;
XFormItem.prototype.writeElementDiv=false;
XFormItem.prototype.labelLocation=_LEFT_;
XFormItem.prototype.tableCssClass="xform_table";
XFormItem.prototype.tableCssStyle=null;
XFormItem.prototype.containerCssClass="xform_container";
XFormItem.prototype.containerCssStyle=null;
XFormItem.prototype.cssClass=null;
XFormItem.prototype.labelCssClass="xform_label";
XFormItem.prototype.errorCssClass="xform_error";
XFormItem.prototype.nowrap=false;
XFormItem.prototype.labelWrap=false;
XFormItem.prototype.align=_UNDEFINED_;
XFormItem.prototype.valign=_UNDEFINED_;
XFormItem.prototype.focusable=false;
XFormItem.prototype.bmolsnr=false;
XFormItem.prototype.forceUpdate=false;
XFormItem.prototype.isBlockElement=false;
XFormItem.prototype.visibilityChecks=[];
XFormItem.prototype.enableDisableChecks=[];
XFormItem.prototype.visibilityChangeEventSources=[];
XFormItem.prototype.enableDisableChangeEventSources=[];
XFormItem.prototype.valueChangeEventSources=[];
XFormItem.prototype.visibilityUpdaters=[];
XFormItem.prototype.enabledDisabledUpdaters=[];
XFormItem.prototype.elementChangeHandler="onchange";
XFormItem.prototype.selection=_CLOSED_;
XFormItem.prototype.openSelectionLabel="";
XFormItem.prototype.errorLocation=_SELF_;
XFormItem.prototype._setAttributes=function(e){
this.__attributes=e
};
XFormItem.prototype.initFormItem=function(){
if(this.focusable){
var e=XFormItem.getParentTabGroupId(this);
if(e){
var t=this.getForm().getItemById(e);
t.tabIdOrder.push(this.getId())
}}};
XFormItem.prototype.initializeItems=function(){
var e=this.getItems();
if(e!=null){
this.items=this.getForm().initItemList(e,this)
}};
XFormItem.prototype.registerActiveChild=function(e){
if(!this.activeChildren){
this.activeChildren={}
}
this.activeChildren[e.getId()]=true
};
XFormItem.prototype.signUpForEvents=function(){
var s;
s=this.getModelItem();
var o=this.getInheritedProperty("visibilityChangeEventSources");
if(!AjxUtil.isEmpty(o)){
var r=this.getModel();
var t=o.length;
if(r&&t>0){
for(var n=0;
n<t;
n++){
var e=r.getItem(o[n],false);
if(e){
var h=new AjxListener(this,XFormItem.prototype.updateVisibilityLsnr);
e.addListener(DwtEvent.XFORMS_VALUE_CHANGED,h)
}}}}
var a=this.getInheritedProperty("enableDisableChangeEventSources");
if(!AjxUtil.isEmpty(a)){
var r=this.getModel();
var t=a.length;
if(r&&t>0){
for(var n=0;
n<t;
n++){
var e=r.getItem(a[n],false);
if(e){
var h=new AjxListener(this,XFormItem.prototype.updateEnabledDisabledLsnr);
e.addListener(DwtEvent.XFORMS_VALUE_CHANGED,h)
}}}}
var c=this.getInheritedProperty("valueChangeEventSources");
if(!AjxUtil.isEmpty(c)){
var r=this.getModel();
var t=c.length;
if(r&&t>0){
for(var n=0;
n<t;
n++){
var e=r.getItem(c[n],false);
if(e){
var h=new AjxListener(this,XFormItem.prototype.valueChangeLsnr);
e.addListener(DwtEvent.XFORMS_VALUE_CHANGED,h)
}}}}
var l=this.getInheritedProperty("bmolsnr");
if(s&&l){
var h=new AjxListener(this,XFormItem.prototype.valueChangeLsnr);
s.addListener(DwtEvent.XFORMS_VALUE_CHANGED,h)
}};
XFormItem.prototype.valueChangeLsnr=function(t){
var o=this.getUpdateElementMethod();
if(!o){
return
}
var a=this.getInstanceValue();
var e=this.getDisplayValueMethod();
if(e){
a=e.call(this,a)
}
o.call(this,a)
};
XFormItem.prototype.updateElement=function(){
if(!this.activeChildren){
return
}
for(var s in this.activeChildren){
if(this.activeChildren[s]===true){
var a=this.getForm().getItemById(s);
if(a&&this.getInstance()){
var n=a.getUpdateElementMethod();
var t=a.getDisplayValueMethod();
if(n){
var e=this.getModel();
var o=a.getRefPath()?e.getInstanceValue(this.getInstance(),a.getRefPath()):a.getValue();
if(t){
o=t.call(a,o)
}
n.call(a,o)
}}}}};
XFormItem.prototype.hasReadPermission=function(t){
var e=this.getInstance();
if(!e.getAttrs){
return false
}
var a=null;
if(t){
a=t
}else{
if(!this.refPath){
return true
}else{
a=this.refPath
}}
return((e.getAttrs.all===true)||(e.getAttrs[a]===true))
};
XFormItem.prototype.hasWritePermission=function(t){
var e=this.getInstance();
if(!e.setAttrs){
return false
}
var a=null;
if(t){
a=t
}else{
if(!this.refPath){
return true
}else{
a=this.refPath
}}
return((e.setAttrs.all===true)||(e.setAttrs[a]===true))
};
XFormItem.prototype.hasRight=function(t){
var e=this.getInstance();
if(!e.rights){
return false
}
if(!t){
return true
}
return(e.rights[t]===true)
};
XFormItem.prototype.updateVisibilityLsnr=function(e){
var t=this.getUpdateVisibilityMethod();
t.call(this)
};
XFormItem.prototype.updateVisibility=function(){
var isVisible=true;
var parentItem=this.getParentItem();
if(parentItem){
isVisible=this.getParentItem().getIsVisible()
}
if(isVisible){
var myVisibilityChecks=this.getInheritedProperty("visibilityChecks");
if(myVisibilityChecks&&myVisibilityChecks instanceof Array){
var cnt=myVisibilityChecks.length;
for(var i=0;
i<cnt;
i++){
if(myVisibilityChecks[i]!=null){
if(typeof(myVisibilityChecks[i])=="function"){
isVisible=myVisibilityChecks[i].call(this);
if(!isVisible){
break
}}else{
if(myVisibilityChecks[i] instanceof Array){
var func=myVisibilityChecks[i].shift();
isVisible=func.apply(this,myVisibilityChecks[i]);
myVisibilityChecks[i].unshift(func);
if(!isVisible){
break
}}else{
if(typeof(myVisibilityChecks[i])=="string"){
var instance=this.getInstance();
isVisible=eval(myVisibilityChecks[i]);
if(!isVisible){
break
}}}}}}}}
var reRunRefresh=false;
if(isVisible){
if(this.deferred){
reRunRefresh=true
}
this.show()
}else{
this.hide()
}
for(var itemId in this.activeChildren){
if(this.activeChildren[itemId]===true){
var item=this.getForm().getItemById(itemId);
if(item&&this.getInstance()){
var updateMethod=item.getUpdateVisibilityMethod();
if(updateMethod){
updateMethod.call(item)
}}}}
if(reRunRefresh){
this.updateEnabledDisabled();
this.updateElement()
}};
XFormItem.prototype.updateEnabledDisabledLsnr=function(e){
var t=this.getUpdateEnabledDisabledtMethod();
t.call(this)
};
XFormItem.prototype.updateEnabledDisabled=function(r){
var l=true;
var e=this.getParentItem();
if(e){
l=this.getParentItem().getIsEnabled()
}
if(l){
var o=this.getInheritedProperty("enableDisableChecks");
if(o&&o instanceof Array){
var t=o.length;
for(var n=0;
n<t;
n++){
if(o[n]!=null){
if(typeof(o[n])=="function"){
l=o[n].call(this);
if(!l){
break
}}else{
if(o[n] instanceof Array){
var a=o[n].shift();
if(!a||!a.apply){
continue
}
l=a.apply(this,o[n]);
o[n].unshift(a);
if(!l){
break
}}}}}}else{
if(o==false){
l=false
}}}
if(l){
this.enableElement()
}else{
this.disableElement()
}
for(var h in this.activeChildren){
if(this.activeChildren[h]===true){
var c=this.getForm().getItemById(h);
if(c&&this.getInstance()){
var s=c.getUpdateEnabledDisabledtMethod();
if(s){
s.call(c)
}}}}};
XFormItem.prototype.setError=function(a,o){
var t=this.getErrorLocation();
if(t==_PARENT_||t==_INHERIT_){
this.getParentItem().setError(a,true);
return
}
this.getForm().addErrorItem(this);
this.__errorState=XFormItem.ERROR_STATE_ERROR;
var e=this.getErrorContainer(true);
if(e){
e.innerHTML=a
}};
XFormItem.prototype.clearError=function(){
var e=this.getErrorLocation();
if(e==_PARENT_||e==_INHERIT_){
this.getParentItem().clearError();
return
}
this.getForm().removeErrorItem(this);
this.__errorState=XFormItem.ERROR_STATE_VALID;
this.removeErrorContainer()
};
XFormItem.prototype.hasError=function(){
return(this.__errorState==XFormItem.ERROR_STATE_ERROR)
};
XFormItem.prototype.getErrorContainer=function(t){
var e=this.getElement(this.getId()+"___error_container");
if(e!=null){
return e
}
if(t==true&&this.getContainer()){
return this.createErrorContainer()
}
return null
};
XFormItem.prototype.createErrorContainer=function(){
var t=document.createElement("div");
t.id=this.getId()+"___error_container";
t.className=this.getErrorCssClass();
var e=this.getContainer();
if(e.hasChildNodes()){
e.insertBefore(t,e.firstChild)
}else{
e.appendChild(t)
}
return t
};
XFormItem.prototype.removeErrorContainer=function(){
var e=this.getErrorContainer();
if(e!=null){
e.parentNode.removeChild(e)
}};
XFormItem.prototype.getType=function(){
return this.type
};
XFormItem.prototype.getParentItem=function(){
return this.__parentItem
};
XFormItem.prototype.getForm=function(){
return this.__xform
};
XFormItem.prototype.getGlobalRef=function(){
return this.getForm().getGlobalRefString()+".getItemById('"+this.getId()+"')"
};
XFormItem.prototype.getFormGlobalRef=function(){
return this.getForm().getGlobalRefString()
};
XFormItem.prototype.getInstance=function(){
return this.getForm().instance
};
XFormItem.prototype.getModel=function(){
return this.getForm().getModel()
};
XFormItem.prototype.getController=function(){
return this.getForm().getController()
};
XFormItem.prototype.getFormController=function(){
return this.getForm().getController()
};
XFormItem.prototype.getModelItem=function(){
return this.__modelItem
};
XFormItem.prototype.getSubModelItem=function(){
return this.__subModelItem
};
XFormItem.prototype.getRef=function(){
if(this.ref!==_UNDEFINED_){
return this.ref
}
return this.__attributes.ref
};
XFormItem.prototype.getRefPath=function(){
return this.refPath
};
XFormItem.prototype.getSubRefPath=function(){
return this.subRefPath
};
XFormItem.prototype.getId=function(){
return this.id
};
XFormItem.prototype.getExternalId=function(){
var e=null;
if(this.__attributes.id!==_UNDEFINED_){
e=this.__attributes.id
}else{
if((e=this.getRef())!==_UNDEFINED_){}else{
e=null
}}
return e
};
XFormItem.prototype.getOnChangeMethod=function(){
return this.cacheInheritedMethod("onChange","$onChange","value,event,form")
};
XFormItem.prototype.getOnActivateMethod=function(){
return this.cacheInheritedMethod("onActivate","$onActivate","event")
};
XFormItem.prototype.getOnClickMethod=function(){
return this.cacheInheritedMethod("onClick","$onClick","event")
};
XFormItem.prototype.getExternalChangeHandler=function(){
return"var item = "+this.getGlobalRef()+"; var elementChangedMethod = item.getElementChangedMethod(); elementChangedMethod.call(item, value, item.getInstanceValue(), event||window.event);"
};
XFormItem.prototype.getElementValueGetterHTML=function(){
return"var value = this.value;"
};
XFormItem.prototype.getChangeHandlerHTML=function(){
var e=this.getElementChangeHandler();
if(e!="onkeypress"){
return AjxBuffer.concat(" ",e,'="',this.getChangehandlerJSCode()+'"',this.getKeyPressHandlerHTML())
}else{
return this.getKeyPressHandlerHTML()
}};
XFormItem.prototype.getChangehandlerJSCode=function(){
return AjxBuffer.concat(this.getElementValueGetterHTML(),this.getExternalChangeHandler())
};
XFormItem.prototype.getFocusHandlerHTML=function(){
var o=this.getFormGlobalRef(),a=this.getId();
var t=this.getInheritedProperty("inputHelp");
var n="";
if(t!=null){
n="if (this.value == '"+t+"') this.value=''; "
}
var e=null;
if(this.getInheritedProperty("onFocus")!=null){
e=AjxBuffer.concat(' onfocus="',o,".onFocus('",a,"'); ",n,this.getInheritedProperty("onFocus"),".call(",this.getGlobalRef(),', event )"')
}else{
e=AjxBuffer.concat(' onfocus="',o,".onFocus('",a,"');",n,'"')
}
return AjxBuffer.concat(e,' onblur="',o,".onBlur('",a,"')\"")
};
XFormItem.prototype.getOnActivateHandlerHTML=function(){
var e=this.getOnActivateMethod();
if(e==null){
return""
}
return AjxBuffer.concat(" ",this.getElementChangeHandler(),'="',this.getGlobalRef(),'.$onActivate(event||window.event)"')
};
XFormItem.prototype.getClickHandlerHTML=function(){
var e=this.getOnClickMethod();
if(e==null){
return""
}
return AjxBuffer.concat(' onclick="',this.getGlobalRef(),'.$onClick(event||window.event)"');
return AjxBuffer.concat(onClickAction)
};
XFormItem.prototype.handleKeyUp=function(n,a){
var t=DwtKeyEvent.getCharCode(n);
if(!AjxUtil.isEmpty(this.keyPressDelayHdlr)&&t!=DwtKeyEvent.KEY_ENTER){
AjxTimedAction.cancelAction(this.keyPressDelayHdlr);
this.keyPressDelayHdlr=null
}
var o=this.getForm();
var e=new DwtKeyEvent();
e.setFromDhtmlEvent(n);
if(t==DwtKeyEvent.KEY_TAB){
DwtUiEvent.setBehaviour(n,true,false);
return false
}else{
var s=new AjxTimedAction(this,this.handleKeyPressDelay,[e,a]);
this.keyPressDelayHdlr=AjxTimedAction.scheduleAction(s,250)
}};
XFormItem.prototype.handleKeyDown=function(o,a){
o=(o!=null)?o:window.event;
var t=DwtKeyEvent.getCharCode(o);
if(t==DwtKeyEvent.KEY_ENTER){
DwtUiEvent.setBehaviour(o,true,true);
return false
}else{
if(t==DwtKeyEvent.KEY_TAB){
DwtUiEvent.setBehaviour(o,true,false);
var e=XFormItem.getParentTabGroupId(this);
if(o.shiftKey){
this.getForm().focusPrevious(this.getId(),e)
}else{
this.getForm().focusNext(this.getId(),e)
}
return false
}}
return true
};
XFormItem.prototype.handleKeyPressDelay=function(a,t){
this.keyPressDelayHdlr=null;
if(this.$changeHandlerFunc==null){
var e=this.getChangehandlerJSCode();
this.$changeHandlerFunc=new Function("event",e)
}
if(this.$changeHandlerFunc){
this.$changeHandlerFunc.call(t,a)
}};
XFormItem.prototype.getKeyPressHandlerHTML=function(){
var e="onkeydown";
if(AjxEnv.isNav){
e="onkeypress"
}
return AjxBuffer.concat(" ",e,'="',this.getGlobalRef(),'.handleKeyDown(event, this)"',' onkeyup="',this.getGlobalRef(),'.handleKeyUp(event, this)"')
};
XFormItem.prototype.outputContainerTDStartHTML=function(e,o,a){
var t=this.getAlign();
e.append('<td id="',this.getId(),'___container"',(o>1?" colspan="+o:""),(a>1?" rowspan="+a:""),this.getContainerCssString(),(t!=_UNDEFINED_?" align='"+t+"'":""),">")
};
XFormItem.prototype.outputContainerTDEndHTML=function(e){
e.append('</td id="',this.getId(),'___container">')
};
XFormItem.prototype.outputElementDivStart=function(e){
e.append("<div id=",this.getId(),this.getCssString()," xform_type='elementDiv'>")
};
XFormItem.prototype.outputElementDivEnd=function(e){
e.append('</div id="',this.getId(),'">')
};
XFormItem.prototype.outputLabelCellHTML=function(o,s,e){
var a=this.getLabel();
if(a==null){
return
}
if(a==""){
a="&nbsp;"
}
if(e==_INLINE_){
var n=this.getLabelCssStyle();
if(n==null){
n=""
}
n="position:relative;left:10;top:5;text-align:left;background-color:#eeeeee;margin-left:5px;margin-right:5px;"+n;
o.append('<div id="',this.getId(),'___label"',this.getLabelCssString(null,n),">",a,"</div>")
}else{
var t=this.getInheritedProperty("enableLabelFor");
if(t){
o.append('<td id="',this.getId(),'___label"',this.getLabelCssString(),(s>1?" rowspan="+s:""),">","<label for='",this.getId(),"'>",a,"</label>")
}else{
o.append('<td id="',this.getId(),'___label"',this.getLabelCssString(),(s>1?" rowspan="+s:""),">",a)
}
if(this.getRequired()){
o.append("<span class='redAsteric'>*</span>")
}
o.append("</td>")
}};
XFormItem.getParentTabGroupId=function(e){
while(e!=null){
var t=e.getParentItem();
if(t==null||(!t instanceof XFormItem)){
return null
}else{
if(t instanceof Group_XFormItem&&t.getInheritedProperty("isTabGroup")==true){
return t.getId()
}}
e=t
}};
XFormItem.prototype.elementChanged=function(a,t,e){
this.getForm().itemChanged(this.getId(),a,e)
};
XFormItem.prototype.getInstanceValue=function(e){
if(e==null){
e=this.getRefPath()
}
if(e==null){
return null
}
return this.getModel().getInstanceValue(this.getInstance(),e)
};
XFormItem.prototype.getInstanceCount=function(){
if(this.getRefPath()==null){
return 0
}
return this.getModel().getInstanceCount(this.getInstance(),this.getRefPath())
};
XFormItem.prototype.setInstanceValue=function(e,t){
if(t==null){
t=this.getRefPath()
}
if(t==null){
return null
}
return this.getModel().setInstanceValue(this.getInstance(),t,e)
};
XFormItem.prototype.set=XFormItem.prototype.setInstancevalue;
XFormItem.getValueFromHTMLSelect=function(a){
var e=[];
for(var t=0;
t<a.options.length;
t++){
if(a.options[t].selected){
e[e.length]=a.options[t].value
}}
return e.join(",")
};
XFormItem.prototype.getValueFromHTMLSelect=function(e){
if(e==null){
e=this.getElement()
}
return XFormItem.getValueFromHTMLSelect(e)
};
XFormItem.updateValueInHTMLSelect1=function(n,a,o){
if(a==null){
return null
}
if(o==null){
o=false
}
var t=a.options;
for(i=0;
i<t.length;
i++){
var e=t[i];
if(e.value==n){
a.selectedIndex=i;
return a.value
}}
if(t.length>0){
a.selectedIndex=0;
return t[0].value
}
return null
};
XFormItem.prototype.updateValueInHTMLSelect1=function(a,e,t){
if(e==null){
e=this.getElement()
}
if(t==null){
t=this.getSelectionIsOpen()
}
return XFormItem.updateValueInHTMLSelect1(a,e,t)
};
XFormItem.updateValueInHTMLSelect=function(e,o,a){
if(o==null){
return null
}
if(e==null){
e=""
}
if(a==null){
a=false
}
if(typeof e=="string"){
e=e.split(",")
}
var s="{|[",r="]|}";
e=s+e.join(r+s)+r;
var l=o.options;
var t=false;
for(var n=0;
n<l.length;
n++){
var h=(e.indexOf(s+l[n].value+r)>-1);
l[n].selected=h;
t=t||h
}
if(!t&&!a){
l[0].selected=true
}};
XFormItem.prototype.updateValueInHTMLSelect=function(a,e,t){
if(a==null){
a=""
}
if(e==null){
e=this.getElement()
}
if(t==null){
t=this.getSelectionIsOpen()
}
return XFormItem.updateValueInHTMLSelect(a,e,t)
};
XFormItem.prototype.getChoicesHTML=function(){
var r=this.getNormalizedChoices();
if(r==null){
return""
}
var a=new AjxBuffer();
this.outputChoicesHTMLStart(a);
var e=r.values;
var s=r.labels;
var o=r.visible;
var n=this.getChoiceCssClass();
for(var t=0;
t<e.length;
t++){
if(o&&(o[t]==false)){}else{
a.append("",this.getChoiceHTML(t,e[t],s[t],n,""))
}}
this.outputChoicesHTMLEnd(a);
return a.toString()
};
XFormItem.prototype.outputChoicesHTMLStart=function(e){
return
};
XFormItem.prototype.outputChoicesHTMLEnd=function(e){
return
};
XFormItem.prototype.getChoiceCssClass=function(){
return""
};
XFormItem.prototype.getChoiceHTML=function(o,a,t,e){
return AjxBuffer.concat('<option value="',a,'">',t,"</option>")
};
XFormItem.prototype.updateChoicesHTML=function(){
this.cleanChoiceDisplay();
var e=new AjxBuffer();
this.outputHTML(e,new AjxBuffer());
if(this.getContainer()){
this.getContainer().innerHTML=e.toString()
}
return
};
XFormItem.prototype.getInheritedProperty=function(t){
if(this.__attributes[t]!==_UNDEFINED_){
return this.__attributes[t]
}
if(this[t]!==_UNDEFINED_){
return this[t]
}
var e=this.__modelItem;
if(e&&e[t]){
return e[t]
}
return null
};
XFormItem.prototype.cacheInheritedProperty=function(t,e){
if(this[e]!==_UNDEFINED_){
return this[e]
}
return(this[e]=this.getInheritedProperty(t))
};
XFormItem.prototype.cacheInheritedMethod=function(e,t,o){
if(this[t]!==_UNDEFINED_){
return this[t]
}
var a=this.getInheritedProperty(e);
if(a!=null){
a=this.convertToFunction(a,o)
}
this[t]=a;
return a
};
XFormItem.prototype.getElement=XForm.prototype.getElement;
XFormItem.prototype.showElement=function(e){
XForm.prototype.showElement.call(this,e)
};
XFormItem.prototype.getIsVisible=function(){
return this.__isVisible
};
XFormItem.prototype.getIsEnabled=function(){
return this.__isEnabled
};
XFormItem.prototype.hideElement=function(t,e){
XForm.prototype.hideElement.call(this,t,e)
};
XFormItem.prototype.createElement=XForm.prototype.createElement;
XFormItem.estimateMyWidth=function(e,a,n,o){
var t=(String(e).length/2)*XForm.FONT_WIDTH1+(String(e).length/2)*XForm.FONT_WIDTH2+14;
if(a){
t=t+24
}
if(n>0){
t=t+n
}
t=(t>=o)?t:o;
return[t,"px"].join("")
};
XFormItem.prototype.getWidget=function(){
return this.widget
};
XFormItem.prototype.setWidget=function(e){
this.widget=e
};
XFormItem.prototype.getContainer=function(){
return this.getElement(this.getId()+"___container")
};
XFormItem.prototype.getLabelContainer=function(){
return this.getElement(this.getId()+"___label")
};
XFormItem.prototype.show=function(){
if(this.deferred){
this._outputHTML()
}
var e=this.getLabelContainer();
if(e){
this.showElement(e)
}
e=this.getContainer();
if(e!=null){
this.showElement(e)
}
this.__isVisible=true
};
XFormItem.prototype.hide=function(e){
e=this.getInheritedProperty("isBlockElement")||e;
var t=this.getLabelContainer();
if(t){
this.hideElement(t,e)
}
t=this.getContainer();
if(t!=null){
this.hideElement(t,e)
}else{
var a=this.getItems();
if(a!=null){
for(var o=0;
o<a.length;
o++){
a[o].hide(e)
}}}
this.__isVisible=false
};
XFormItem.prototype.focus=function(){
this.getForm().focusElement(this.getId())
};
XFormItem.prototype.getRequired=function(){
return this.getInheritedProperty("required")
};
XFormItem.prototype.getValue=function(){
return this.getInheritedProperty("value")
};
XFormItem.prototype.getItems=function(){
if(this.items){
return this.items
}
return this.__attributes.items
};
XFormItem.prototype.getChoices=function(){
return this.getInheritedProperty("choices")
};
XFormItem.prototype.getNormalizedChoices=function(){
if(this.$normalizedChoices){
return this.$normalizedChoices
}
var t=this.getChoices();
if(t==null){
return null
}
if(typeof t=="function"){
t=t.call(this)
}
var e;
if(typeof t.getChoices=="function"){
e=t.getChoices()
}else{
if(AjxUtil.isArray(t)){
if(typeof t[0]=="object"){
e=XFormChoices.normalizeChoices(t,XFormChoices.OBJECT_LIST)
}else{
e=XFormChoices.normalizeChoices(t,XFormChoices.SIMPLE_LIST)
}}else{
e=XFormChoices.normalizeChoices(t,XFormChoices.HASH)
}}
this.$normalizedChoices=e;
return this.$normalizedChoices
};
XFormItem.prototype.getNormalizedValues=function(){
var e=this.getNormalizedChoices();
if(e){
return e.values
}
return null
};
XFormItem.prototype.getNormalizedLabels=function(){
var e=this.getNormalizedChoices();
if(e){
return e.labels
}
return null
};
XFormItem.prototype.getAppearance=function(){
return this.getInheritedProperty("appearance")
};
XFormItem.prototype.getCssClass=function(){
return this.getInheritedProperty("cssClass")
};
XFormItem.prototype.getCssStyle=function(){
return this.getInheritedProperty("cssStyle")
};
XFormItem.prototype.getLabel=function(e){
return this.getInheritedProperty("label")
};
XFormItem.prototype.getErrorCssClass=function(){
return this.getInheritedProperty("errorCssClass")
};
XFormItem.prototype.getLabelCssClass=function(e){
if(e!=null){
return e
}
return this.getInheritedProperty("labelCssClass")
};
XFormItem.prototype.getLabelCssStyle=function(e){
if(e!=null){
return e
}
return this.getInheritedProperty("labelCssStyle")
};
XFormItem.prototype.getLabelWrap=function(){
return this.getInheritedProperty("labelWrap")
};
XFormItem.prototype.getLabelLocation=function(){
return this.getInheritedProperty("labelLocation")
};
XFormItem.prototype.getContainerCssClass=function(){
return this.getInheritedProperty("containerCssClass")
};
XFormItem.prototype.getContainerCssStyle=function(){
return this.getInheritedProperty("containerCssStyle")
};
XFormItem.prototype.getTableCssClass=function(){
return this.getInheritedProperty("tableCssClass")
};
XFormItem.prototype.getTableCssStyle=function(){
return this.getInheritedProperty("tableCssStyle")
};
XFormItem.prototype.getNowrap=function(){
return this.getInheritedProperty("nowrap")
};
XFormItem.prototype.getWidth=function(){
return this.cacheInheritedProperty("width","_width")
};
XFormItem.prototype.getHeight=function(){
return this.getInheritedProperty("height")
};
XFormItem.prototype.getOverflow=function(){
return this.getInheritedProperty("overflow")
};
XFormItem.prototype.getNumCols=function(){
return this.getInheritedProperty("numCols")
};
XFormItem.prototype.getAlign=function(){
return this.getInheritedProperty("align")
};
XFormItem.prototype.getValign=function(){
return this.getInheritedProperty("valign")
};
XFormItem.prototype.getName=function(){
return this.getInheritedProperty("name")
};
XFormItem.prototype.useParentTable=true;
XFormItem.prototype.getUseParentTable=function(){
return this.getInheritedProperty("useParentTable")
};
XFormItem.prototype.colSizes=_UNDEFINED_;
XFormItem.prototype.getColSizes=function(){
return this.getInheritedProperty("colSizes")
};
XFormItem.prototype.colSpan=1;
XFormItem.prototype.getColSpan=function(){
return this.getInheritedProperty("colSpan")
};
XFormItem.prototype.rowSpan=1;
XFormItem.prototype.getRowSpan=function(){
return this.getInheritedProperty("rowSpan")
};
XFormItem.prototype.getErrorLocation=function(){
return this.getInheritedProperty("errorLocation")
};
XFormItem.prototype.getChoiceLabel=function(a){
var o=this.getNormalizedChoices();
if(o==null){
return a
}
if(a==null){
a=""
}
var e=o.values;
for(var t=0;
t<e.length;
t++){
if(e[t]==a){
return o.labels[t]
}}
return a
};
XFormItem.prototype.getChoiceValue=function(t){
function o(h,r){
return String(h).toLowerCase()<String(r).toLowerCase()?-1:(String(h).toLowerCase()>String(r).toLowerCase()?1:0)
}
var s=this.getNormalizedChoices();
if(s==null){
return t
}
var n=s.labels;
var e=-1;
for(var a=0;
a<n.length;
a++){
if(o(t,n[a])==0){
e=a;
break
}}
if(e>=0){
return s.values[e]
}else{
return t
}};
XFormItem.prototype.getChoiceNum=function(a){
var o=this.getNormalizedChoices();
if(o==null){
return -1
}
var e=o.values;
for(var t=0;
t<e.length;
t++){
if(e[t]==a){
return t
}}
return -1
};
XFormItem.prototype.getCssString=function(){
var a=(this.getCssClass()||"");
if(a!=""&&a!=null){
a=' class="'+a+'"'
}
var n=(this.getCssStyle()||"");
var o=this.getWidth();
if(o!=null&&o!="auto"){
if(n.length){
n+=";"
}
n+="width:"+o
}
var e=this.getHeight();
if(e!=null){
if(n.length){
n+=";"
}
n+="height:"+e
}
var s=this.getOverflow();
if(s!=null){
if(n.length){
n+=";"
}
n+="overflow:"+s
}
if(this.getNowrap()){
if(n.length){
n+=";"
}
n+="white-space:nowrap"
}
var t=this.getValign();
if(t){
if(n.length){
n+=";"
}
n+="vertical-align:"+t
}
if(n!=""){
a+=' style="'+n+';"'
}
return a
};
XFormItem.prototype.getLabelCssString=function(a,t){
var e=(this.getLabelCssClass(a)||"");
if(e!=""&&e!=null){
e=' class="'+e+'"'
}
var t=(this.getLabelCssStyle(t)||"");
if(this.getLabelWrap()==false){
if(t.length){
t+=";"
}
t+="white-space:nowrap"
}
if(t!=""){
e+=' style="'+t+';"'
}
return e
};
XFormItem.prototype.getTableCssString=function(){
var e=(this.getTableCssClass()||"");
if(e!=""&&e!=null){
e=' class="'+e+'"'
}
var a=this.getTableCssStyle();
if(a==null){
a=""
}
var o=this.getColSizes();
if(o!=null){
if(a.length){
a+=";"
}
a+="table-layout:fixed"
}
var t=this.getWidth();
if(t!=null){
a+=";width:"+t
}
var n=this.getOverflow();
if(n!=null){
if(a.length){
a+=";"
}
a+="overflow:"+n
}
return e+(a!=null?' style="'+a+';"':"")
};
XFormItem.prototype.getContainerCssString=function(){
var t=(this.getContainerCssClass()||"");
if(t!=""&&t!=null){
t=' class="'+t+'"'
}
var a=this.getContainerCssStyle();
if(a==null){
a=""
}
var o=this.getAlign();
if(o!=_LEFT_){
if(o==_CENTER_||o==_MIDDLE_){
if(a.length){
a+=";"
}
a+="text-align:center"
}else{
if(o==_RIGHT_){
if(a.length){
a+=";"
}
a+="text-align:right"
}}}
var e=this.getValign();
if(e==_TOP_){
if(a.length){
a+=";"
}
a+="vertical-align:top"
}else{
if(e==_BOTTOM_){
if(a.length){
a+=";"
}
a+="vertical-align:bottom"
}else{
if(e==_CENTER_||e==_MIDDLE_){
if(a.length){
a+=";"
}
a+="vertical-align:middle"
}}}
if(a!=""){
t+=' style="'+a+';"'
}
return t
};
XFormItem.prototype.getElementChangeHandler=function(){
return this.getInheritedProperty("elementChangeHandler")
};
XFormItem.prototype.getForceUpdate=function(){
return this.getInheritedProperty("forceUpdate")
};
XFormItem.prototype.getOutputHTMLMethod=function(){
return this.convertToFunction(this.getInheritedProperty("outputHTML"),"html,currentCol")
};
XFormItem.prototype.getElementChangedMethod=function(){
return this.cacheInheritedMethod("elementChanged","$elementChanged","elementValue, instanceValue, event")
};
XFormItem.prototype.getUpdateElementMethod=function(){
return this.cacheInheritedMethod("updateElement","$updateElement","newValue")
};
XFormItem.prototype.getDisplayValueMethod=function(){
return this.cacheInheritedMethod("getDisplayValue","$getDisplayValue","newValue")
};
XFormItem.prototype.getUpdateVisibilityMethod=function(){
return this.cacheInheritedMethod("updateVisibility","$updateVisibility")
};
XFormItem.prototype.getUpdateEnabledDisabledtMethod=function(){
return this.cacheInheritedMethod("updateEnabledDisabled","$updateEnabledDisabled")
};
XFormItem.prototype.convertToFunction=function(e,t){
if((e==null)||(typeof(e)=="function")){
return e
}
if(typeof(this[e])=="function"){
return this[e]
}
return new Function(t,e)
};
XFormItem.prototype.dirtyDisplay=function(){
delete this.$lastDisplayValue
};
XFormItem.prototype.setElementEnabled=function(e){};
XFormItem.prototype.disableElement=function(){
this.setElementEnabled(false);
this.__isEnabled=false
};
XFormItem.prototype.enableElement=function(){
this.setElementEnabled(true);
this.__isEnabled=true
};
XFormItem.prototype.setElementDisabledProperty=function(e){
this.getElement().disabled=(e!=true)
};
XFormItem.prototype.setElementEnabledCssClass=function(e){
var t=this.getElement();
if(!t){
return
}
if(e){
t.className=this.getCssClass()
}else{
t.className=(this.getCssClass()+"_disabled")
}};
XFormItem.prototype.getSelection=function(){
return this.getInheritedProperty("selection")
};
XFormItem.prototype.getSelectionIsOpen=function(){
return this.getInheritedProperty("selection")
};
XFormItem.prototype.getOpenSelectionLabel=function(){
return this.getInheritedProperty("openSelectionLabel")
};
XFormItem.prototype.getNumberToShow=function(){
return this.getInheritedProperty("number")
};
XFormItem.prototype.getShowAddButton=function(){
return this.getInheritedProperty("showAddButton")
};
XFormItem.prototype.getShowRemoveButton=function(){
return this.getInheritedProperty("showRemoveButton")
};
XFormItem.prototype.getShowMoveUpButton=function(){
return this.getInheritedProperty("showMoveUpButton")
};
XFormItem.prototype.getShowMoveDownButton=function(){
return this.getInheritedProperty("showMoveDownButton")
};
XFormItem.prototype.getAddButton=function(){
return this.getInheritedProperty("addButton")
};
XFormItem.prototype.getRemoveButton=function(){
return this.getInheritedProperty("removeButton")
};
XFormItem.prototype.getMoveUpButton=function(){
return this.getInheritedProperty("moveUpButton")
};
XFormItem.prototype.getMoveDownButton=function(){
return this.getInheritedProperty("moveDownButton")
};
XFormItem.prototype.getAlwaysShowAddButton=function(){
return this.getInheritedProperty("alwaysShowAddButton")
};
XFormItem.prototype.getRepeatInstance=function(){
return this.getInheritedProperty("repeatInstance")
};
XFormItem.prototype.getSrc=function(){
return this.getInheritedProperty("src")
};
XFormItem.prototype.getSrcPath=function(){
return this.getInheritedProperty("srcPath")
};
XFormItem.prototype.getShowInNewWindow=function(){
return this.getInheritedProperty("showInNewWindow")
};
XFormItem.prototype.getWriteElementDiv=function(){
return this.getInheritedProperty("writeElementDiv")
};
XFormItem.prototype.getMultiple=function(){
return this.getInheritedProperty("multiple")
};
XFormItem.prototype.getAlwaysUpdateChoices=function(){
return this.getInheritedProperty("alwaysUpdateChoices")
};
XFormItem.prototype.choicesAreDirty=function(){
return(this._choiceDisplayIsDirty==true||this.getAlwaysUpdateChoices())
};
XFormItem.prototype.cleanChoiceDisplay=function(){
this._choiceDisplayIsDirty=false
};
XFormItem.prototype.showInputTooltip=function(t){
var o=new DwtUiEvent(true);
o.setFromDhtmlEvent(t);
var e=DwtShell.getShell(window);
var a=e.getToolTip();
a.setContent(this.getInheritedProperty("toolTipContent"));
a.popup(o.docX,o.docY)
};
XFormItem.prototype.hideInputTooltip=function(t){
var e=DwtShell.getShell(window);
var a=e.getToolTip();
a.popdown()
};
Output_XFormItem=function(){};
XFormItemFactory.createItemType("_OUTPUT_","output",Output_XFormItem,XFormItem);
Output_XFormItem.prototype.writeElementDiv=true;
Output_XFormItem.prototype.labelWrap=true;
Output_XFormItem.prototype.cssClass="xform_output";
Output_XFormItem.prototype.containerCssClass="xform_output_container";
Output_XFormItem.prototype.outputHTML=function(t){
var a=this.getValue();
var n=this.getDisplayValueMethod();
if(n){
a=n.call(this,a)
}
var e=this.getClickHandlerHTML();
var o=null;
if(e!=null&&e!=""){
o="<div "+this.getClickHandlerHTML()+">"+a+"</div>"
}
t.append(o||a)
};
Output_XFormItem.prototype.getDisplayValue=function(e){
e=this.getChoiceLabel(e);
if(e==null){
e=""
}else{
e=""+e
}
return e
};
Output_XFormItem.prototype.updateElement=function(t){
var e=this.getElement();
if(e){
this.getElement().innerHTML=t
}};
Output_XFormItem.prototype.initFormItem=function(){
XFormItem.prototype.initFormItem.call(this);
var t=this.getChoices();
if(t==null||t.constructor!=XFormChoices){
return
}
var e=new AjxListener(this,this.dirtyDisplay);
t.addListener(DwtEvent.XFORMS_CHOICES_CHANGED,e);
this.signUpForEvents()
};
Output_XFormItem.prototype.dirtyDisplay=function(){
XFormItem.prototype.dirtyDisplay.call(this);
this._choiceDisplayIsDirty=true;
delete this.$normalizedChoices
};
Output_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementEnabledCssClass;
Textfield_XFormItem=function(){};
XFormItemFactory.createItemType("_TEXTFIELD_","textfield",Textfield_XFormItem,XFormItem);
XFormItemFactory.registerItemType("_INPUT_","input",Textfield_XFormItem);
Textfield_XFormItem.prototype._inputType="text";
Textfield_XFormItem.prototype.cssClass="xform_field";
Textfield_XFormItem.prototype.elementChangeHandler="onchange";
Textfield_XFormItem.prototype.focusable=true;
Textfield_XFormItem.prototype.nowrap=false;
Textfield_XFormItem.prototype.labelWrap=true;
Textfield_XFormItem.prototype.containerCssClass="xform_field_container";
Textfield_XFormItem.prototype.visibilityChecks=[XFormItem.prototype.hasReadPermission];
Textfield_XFormItem.prototype.enableDisableChecks=[XFormItem.prototype.hasWritePermission];
Textfield_XFormItem.prototype.outputHTML=function(a,s){
var o=this._inputType;
var n=this.getValue();
var t=this.getModelItem();
var e=this.getInheritedProperty("inputHelp");
a.append("<input autocomplete='off' id=\"",this.getId(),'" type="',o,'"',this.getCssString(),this.getChangeHandlerHTML(),this.getFocusHandlerHTML(),this.getClickHandlerHTML(),this.getMouseoutHandlerHTML(),(n!=null?' value="'+n+'"':""),">")
};
Textfield_XFormItem.prototype.getClickHandlerHTML=function(){
var o=this.getFormGlobalRef(),a=this.getId();
var e="";
var t=this.getInheritedProperty("onClick");
e=AjxBuffer.concat(' onclick="',t||"XFormItem.prototype.showInputTooltip",".call(",this.getGlobalRef(),', event );" ');
return AjxBuffer.concat(e)
};
Textfield_XFormItem.prototype.getMouseoutHandlerHTML=function(){
var o=this.getFormGlobalRef(),a=this.getId();
var e="";
var t=this.getInheritedProperty("onMouseout");
e=AjxBuffer.concat(' onmouseout="',t||"XFormItem.prototype.hideInputTooltip",".call(",this.getGlobalRef(),', event );" ');
return AjxBuffer.concat(e)
};
Textfield_XFormItem.prototype.updateElement=function(t){
if(t==null){
t=this.getValue()
}
var e=this.getInheritedProperty("inputHelp");
if((t==null)&&(e!=null)){
t=e
}else{
if(t==null){
t=""
}}
if(this.getElement()&&this.getElement().value!=t){
this.getElement().value=t
}};
Textfield_XFormItem.prototype.setElementEnabled=function(e){
this.setElementDisabledProperty(e);
this.setElementEnabledCssClass(e)
};
Secret_XFormItem=function(){};
XFormItemFactory.createItemType("_SECRET_","secret",Secret_XFormItem,Textfield_XFormItem);
XFormItemFactory.registerItemType("_PASSWORD_","password",Secret_XFormItem);
Secret_XFormItem.prototype._inputType="password";
Secret_XFormItem.prototype.focusable=true;
File_XFormItem=function(){};
XFormItemFactory.createItemType("_FILE_","file",File_XFormItem,Textfield_XFormItem);
File_XFormItem.prototype._inputType="file";
File_XFormItem.prototype.forceUpdate=false;
File_XFormItem.prototype.focusable=true;
Textarea_XFormItem=function(){};
XFormItemFactory.createItemType("_TEXTAREA_","textarea",Textarea_XFormItem,Textfield_XFormItem);
Textarea_XFormItem.prototype.width="100%";
Textarea_XFormItem.prototype.height=100;
Textarea_XFormItem.prototype.focusable=true;
Textarea_XFormItem.prototype.outputHTML=function(e,a){
var t=this.getInheritedProperty("textWrapping");
if(!t){
t="off"
}
e.append('<textarea id="',this.getId(),'"',this.getCssString(),this.getChangeHandlerHTML(),this.getFocusHandlerHTML(),"wrap='",t,"'","></textarea>")
};
Textarea_XFormItem.prototype.setElementDisabledProperty=function(e){
this.getElement().disabled=(e!=true);
this.getElement().readOnly=(e!=true)
};
Textarea_XFormItem.prototype.getKeyPressHandlerHTML=function(){
var e="onkeydown";
if(AjxEnv.isNav||AjxEnv.isChrome||AjxEnv.isSafari){
e="onkeypress"
}
return AjxBuffer.concat(" ",e,'="',this.getGlobalRef(),'.handleKeyDown(event, this)"',' onkeyup="',this.getGlobalRef(),'.handleKeyUp(event, this)"')
};
Checkbox_XFormItem=function(){};
XFormItemFactory.createItemType("_CHECKBOX_","checkbox",Checkbox_XFormItem,XFormItem);
Checkbox_XFormItem.prototype._inputType="checkbox";
Checkbox_XFormItem.prototype.elementChangeHandler="onclick";
Checkbox_XFormItem.prototype.labelLocation=_RIGHT_;
Checkbox_XFormItem.prototype.cssClass="xform_checkbox";
Checkbox_XFormItem.prototype.labelCssClass="xform_checkbox";
Checkbox_XFormItem.prototype.align=_RIGHT_;
Checkbox_XFormItem.prototype.trueValue=_UNDEFINED_;
Checkbox_XFormItem.prototype.falseValue=_UNDEFINED_;
Checkbox_XFormItem.prototype.focusable=true;
Checkbox_XFormItem.prototype.visibilityChecks=[XFormItem.prototype.hasReadPermission];
Checkbox_XFormItem.prototype.enableDisableChecks=[XFormItem.prototype.hasWritePermission];
Checkbox_XFormItem.prototype.nowrap=false;
Checkbox_XFormItem.prototype.labelWrap=true;
Checkbox_XFormItem.prototype.outputHTML=function(e,a){
var t="";
if(this.getInstanceValue()==this.getTrueValue()){
t=" CHECKED"
}
e.append("<input autocomplete='off' id=\"",this.getId(),'" type="',this._inputType,'"',this.getChangeHandlerHTML(),this.getFocusHandlerHTML(),t,">")
};
Checkbox_XFormItem.prototype.getTrueValue=function(){
var e=this.getInheritedProperty("trueValue");
if(e==null){
e=true
}
return e
};
Checkbox_XFormItem.prototype.getFalseValue=function(){
var e=this.getInheritedProperty("falseValue");
if(e==null){
e=false
}
return e
};
Checkbox_XFormItem.prototype.updateElement=function(e){
e=(e==this.getTrueValue());
this.getElement().checked=e
};
Checkbox_XFormItem.prototype.getElementValueGetterHTML=function(){
var e=this.getTrueValue();
if(e!==_UNDEFINED_){
if(typeof e=="string"){
e="'"+e+"'"
}
var t=this.getFalseValue();
if(typeof t=="string"){
t="'"+t+"'"
}
if(e==null){
e=true
}
if(t==null){
t=false
}
return AjxBuffer.concat("var value = (this.checked ? ",e," : ",t,");")
}else{
return"var value = '"+this.getValue()+"';"
}};
Checkbox_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementDisabledProperty;
Radio_XFormItem=function(){};
XFormItemFactory.createItemType("_RADIO_","radio",Radio_XFormItem,Checkbox_XFormItem);
Radio_XFormItem.prototype._inputType="radio";
Radio_XFormItem.prototype.focusable=true;
Radio_XFormItem.prototype.groupname=null;
Radio_XFormItem.prototype.updateElement=function(e){
this.getElement().checked=(this.getValue()==e)
};
Radio_XFormItem.prototype.outputHTML=function(t,o){
var a="";
if(this.getInstanceValue()==this.getTrueValue()){
a=" CHECKED"
}
t.append("<input autocomplete='off' id=\"",this.getId(),'" type="',this._inputType,'"',this.getChangeHandlerHTML(),this.getFocusHandlerHTML(),a);
var e=this.getInheritedProperty("groupname");
if(e){
t.append(" name='",e,"'")
}
t.append(">")
};
Radio_Label_XFormItem=function(){};
XFormItemFactory.createItemType("_RADIO_LABEL_","radio_label",Radio_Label_XFormItem,Radio_XFormItem);
Radio_Label_XFormItem.prototype._inputType="radio";
Radio_Label_XFormItem.prototype.focusable=true;
Radio_Label_XFormItem.prototype.groupname=null;
Radio_XFormItem.prototype.elementChanged=function(a,t,e){
if(a==true){
this.getForm().itemChanged(this.getId(),this.getValue(),e)
}};
Radio_XFormItem.prototype.updateElement=function(o){
this.getElement().checked=(this.getValue()==o);
var t=XFG.getEl((this.getId()+"___labelValue"));
if(t){
var a=this.getInheritedProperty("labelRef");
if(a==null){
return
}
var e=this.getInstanceValue(a);
t.innerHTML=e
}};
Radio_Label_XFormItem.prototype.outputHTML=function(t,o){
var a="";
if(this.getInstanceValue()==this.getTrueValue()){
a=" CHECKED"
}
t.append("<input autocomplete='off' id=\"",this.getId(),'" type="',this._inputType,'"',this.getChangeHandlerHTML(),this.getFocusHandlerHTML(),a);
var e=this.getInheritedProperty("groupname");
if(e){
t.append(" name='",e,"'")
}
t.append(">")
};
Radio_Label_XFormItem.prototype.outputLabelCellHTML=function(o,r,e){
var a=this.getInheritedProperty("labelRef");
if(a==null){
return
}
var t=this.getInstanceValue(a);
if(t==null){
return
}
if(t==""){
t="&nbsp;"
}
var s=this.getInheritedProperty("labelValue");
if(e==_INLINE_){
var n=this.getLabelCssStyle();
if(n==null){
n=""
}
n="position:relative;left:10;top:5;text-align:left;background-color:#eeeeee;margin-left:5px;margin-right:5px;"+n;
o.append('<label id="',this.getId(),'___labelValue"',this.getLabelCssString(null,n),' FOR="',this.getId(),'">',t,"</label>")
}else{
o.append("<td ",this.getLabelCssString(),(r>1?" rowspan="+r:""),">",'<label id="',this.getId(),'___labelValue"',' FOR="',this.getId(),'">',t,"</label>");
o.append("</td>")
}};
Button_XFormItem=function(){};
XFormItemFactory.createItemType("_BUTTON_","button",Button_XFormItem,XFormItem);
XFormItemFactory.registerItemType("_TRIGGER_","trigger",Button_XFormItem);
Button_XFormItem.prototype.forceUpdate=false;
Button_XFormItem.prototype.elementChangeHandler="onclick";
Button_XFormItem.prototype.labelLocation=_NONE_;
Button_XFormItem.prototype.relevantBehavior=_DISABLE_;
Button_XFormItem.prototype.cssClass="xform_button";
Button_XFormItem.prototype.focusable=true;
Button_XFormItem.prototype.outputHTML=function(e,t){
e.append('<button id="',this.getId(),'"',this.getCssString(),"\r  ",this.getOnActivateHandlerHTML(),"\r  ",this.getFocusHandlerHTML(),"\r",">",this.getLabel(),"</button>")
};
Button_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementDisabledProperty;
Submit_XFormItem=function(){};
XFormItemFactory.createItemType("_SUBMIT_","submit",Submit_XFormItem,Button_XFormItem);
Submit_XFormItem.prototype.outputHTML=function(e,t){
e.append('<input id="',this.getId(),'" type="submit"',this.getCssString(),this.getChangeHandlerHTML(),this.getFocusHandlerHTML(),' value="',this.getLabel(),">")
};
Anchor_XFormItem=function(){};
XFormItemFactory.createItemType("_ANCHOR_","anchor",Anchor_XFormItem,XFormItem);
Anchor_XFormItem.prototype.writeElementDiv=true;
Anchor_XFormItem.prototype.forceUpdate=true;
Anchor_XFormItem.prototype.cssClass="xform_anchor";
Anchor_XFormItem.prototype.elementChangeHandler="onclick";
Anchor_XFormItem.prototype.href="javascript:;";
Anchor_XFormItem.prototype.showInNewWindow=true;
Anchor_XFormItem.prototype.focusable=true;
Anchor_XFormItem.prototype.getHref=function(){
return this.getInheritedProperty("href")
};
Anchor_XFormItem.prototype.getAnchorTag=function(e,t){
if(e==null){
e=this.getHref()
}
if(t==null){
t=this.getLabel()
}
var a=this.getShowInNewWindow();
return AjxBuffer.concat("<a href=",e,this.getOnActivateHandlerHTML(),(a?' target="_blank"':""),">",t,"</a>")
};
Anchor_XFormItem.prototype.outputHTML=function(e){
e.append(this.getAnchorTag())
};
Anchor_XFormItem.prototype.updateElement=function(e){
this.getElement().innerHTML=this.getAnchorTag(e)
};
Anchor_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementEnabledCssClass;
Data_Anchor_XFormItem=function(){};
XFormItemFactory.createItemType("_DATA_ANCHOR_","data_anchor",Data_Anchor_XFormItem,Anchor_XFormItem);
Data_Anchor_XFormItem.prototype.updateElement=function(e){
this.getElement().innerHTML=this.getAnchorTag(null,e)
};
Url_XFormItem=function(){};
XFormItemFactory.createItemType("_URL_","url",Url_XFormItem,Anchor_XFormItem);
Url_XFormItem.prototype.updateElement=function(e){
this.getElement().innerHTML=this.getAnchorTag(e,e)
};
DataUrl_XFormItem=function(){};
XFormItemFactory.createItemType("_DATA_URL_","rata_url",DataUrl_XFormItem,Anchor_XFormItem);
Url_XFormItem.prototype.updateElement=function(e){
this.getElement().innerHTML=this.getAnchorTag(e,null)
};
Mailto_XFormItem=function(){};
XFormItemFactory.createItemType("_MAILTO_","mailto",Mailto_XFormItem,Anchor_XFormItem);
Mailto_XFormItem.prototype.updateElement=function(e){
this.getElement().innerHTML=this.getAnchorTag("mailto:"+e,e)
};
Image_XFormItem=function(){};
XFormItemFactory.createItemType("_IMAGE_","image",Image_XFormItem,XFormItem);
Image_XFormItem.prototype.forceUpdate=true;
Image_XFormItem.prototype.src=_UNDEFINED_;
Image_XFormItem.prototype.srcPath=_UNDEFINED_;
Image_XFormItem.prototype.writeElementDiv=true;
Image_XFormItem.prototype.updateElement=function(a){
if(a==null){
a=this.getSrc()
}
a=this.getChoiceLabel(a);
if(a==null||a==""){
var e=""
}else{
var t=this.getSrcPath();
if(t!=null){
a=t+a
}
var e=AjxBuffer.concat('<img id="',this.getId(),'" border=0 ',this.getCssString(),' src="',a,'"',">")
}
this.getElement().innerHTML=e
};
Image_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementEnabledCssClass;
Ajx_Image_XFormItem=function(){};
XFormItemFactory.createItemType("_AJX_IMAGE_","ajx_image",Ajx_Image_XFormItem,XFormItem);
Ajx_Image_XFormItem.prototype.forceUpdate=true;
Ajx_Image_XFormItem.prototype.src=_UNDEFINED_;
Ajx_Image_XFormItem.prototype.srcPath=_UNDEFINED_;
Ajx_Image_XFormItem.prototype.writeElementDiv=false;
Ajx_Image_XFormItem.prototype.updateElement=function(o){
if(o==null){
o=this.getSrc()
}
o=this.getChoiceLabel(o);
var e;
if(o==null||o==""){
e=""
}else{
var a=this.getSrcPath();
if(a!=null){
o=a+o
}
var t=this.getCssStyle();
e=AjxImg.getImageHtml(o,"position:relative;"+(t?t:""))
}
if(this.getContainer()){
this.getContainer().innerHTML=e
}};
Dwt_Image_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_IMAGE_","dwt_image",Dwt_Image_XFormItem,XFormItem);
Dwt_Image_XFormItem.prototype.forceUpdate=true;
Dwt_Image_XFormItem.prototype.src=_UNDEFINED_;
Dwt_Image_XFormItem.prototype.srcPath=_UNDEFINED_;
Dwt_Image_XFormItem.prototype.writeElementDiv=false;
Dwt_Image_XFormItem.prototype.updateElement=function(o){
if(o==null){
o=this.getSrc()
}
o=this.getChoiceLabel(o);
var e;
if(o==null||o==""){
e=""
}else{
var a=this.getSrcPath();
if(a!=null){
o=a+o
}
var t=this.getCssStyle();
t=t||"";
styleStr="style='position:relative;'";
if(o){
e=["<div class='",o,"' ",styleStr," ></div>"].join("")
}else{
e=["<div ",styleStr," ></div>"].join("")
}}
this.getContainer().innerHTML=e
};
Select1_XFormItem=function(){};
XFormItemFactory.createItemType("_SELECT1_","select1",Select1_XFormItem,XFormItem);
Select1_XFormItem.prototype.multiple=false;
Select1_XFormItem.prototype.alwaysUpdateChoices=false;
Select1_XFormItem.prototype.focusable=true;
Select1_XFormItem.prototype.cssClass="xform_select1";
Select1_XFormItem.prototype.containerCssClass="xform_select_container";
Select1_XFormItem.prototype.visibilityChecks=[XFormItem.prototype.hasReadPermission];
Select1_XFormItem.prototype.enableDisableChecks=[XFormItem.prototype.hasWritePermission];
Select1_XFormItem.prototype.initFormItem=function(){
var t=this.getChoices();
if(t==null||t.constructor!=XFormChoices){
return
}
var e=new AjxListener(this,this.dirtyDisplay);
t.addListener(DwtEvent.XFORMS_CHOICES_CHANGED,e)
};
Select1_XFormItem.prototype.outputHTML=function(e,t){
e.append('<select id="',this.getId(),'" ',this.getCssString(),(this.getMultiple()?"multiple ":""),this.getChangeHandlerHTML(),this.getFocusHandlerHTML(),">",this.getChoicesHTML(),"</select>");
this.cleanChoiceDisplay()
};
Select1_XFormItem.prototype.getElementValueGetterHTML=function(){
return"var value = XFormItem.getValueFromHTMLSelect(this);"
};
Select1_XFormItem.prototype.setChoices=function(e){
this.choices=e;
this.dirtyDisplay();
this.updateChoicesHTML()
};
Select1_XFormItem.prototype.dirtyDisplay=function(){
XFormItem.prototype.dirtyDisplay.call(this);
this._choiceDisplayIsDirty=true;
delete this.$normalizedChoices
};
Select1_XFormItem.prototype.updateElement=function(e){
if(this.choicesAreDirty()){
this.updateChoicesHTML()
}
this.updateValueInHTMLSelect1(e,this.getElement(),this.getSelectionIsOpen())
};
Select1_XFormItem.prototype.cleanChoiceDisplay=function(){
this._choiceDisplayIsDirty=false
};
Select1_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementDisabledProperty;
Select_XFormItem=function(){};
XFormItemFactory.createItemType("_SELECT_","select",Select_XFormItem,Select1_XFormItem);
Select_XFormItem.prototype.multiple=true;
Select_XFormItem.prototype.selection=_OPEN_;
Select_XFormItem.prototype.focusable=true;
Select_XFormItem.prototype.containerCssClass="xform_select_container";
Select_XFormItem.prototype.updateElement=function(e){
if(this.choicesAreDirty()){
this.updateChoicesHTML()
}
this.updateValueInHTMLSelect(e,this.getElement(),this.getSelectionIsOpen())
};
Spacer_XFormItem=function(){};
XFormItemFactory.createItemType("_SPACER_","spacer",Spacer_XFormItem,XFormItem);
Spacer_XFormItem.prototype.forceUpdate=false;
Spacer_XFormItem.prototype.labelLocation=_NONE_;
Spacer_XFormItem.prototype.width=1;
Spacer_XFormItem.prototype.height=10;
Spacer_XFormItem.prototype.cssStyle="font-size:1px;overflow:hidden;";
Spacer_XFormItem.prototype.colSpan="*";
Spacer_XFormItem.prototype.focusable=false;
Spacer_XFormItem.prototype.outputHTML=function(e,t){
e.append("<div id=",this.getId(),this.getCssString(),"></div>")
};
Spacer_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementEnabledCssClass;
Cell_Spacer_XFormItem=function(){};
XFormItemFactory.createItemType("_CELL_SPACER_","cell_spacer",Cell_Spacer_XFormItem,Spacer_XFormItem);
XFormItemFactory.registerItemType("_CELLSPACER_","cell_spacer",Cell_Spacer_XFormItem);
Cell_Spacer_XFormItem.prototype.width=10;
Cell_Spacer_XFormItem.prototype.height=10;
Cell_Spacer_XFormItem.prototype.colSpan=1;
Cell_Spacer_XFormItem.prototype.focusable=false;
Separator_XFormItem=function(){};
XFormItemFactory.createItemType("_SEPARATOR_","separator",Separator_XFormItem,XFormItem);
Separator_XFormItem.prototype.cssClass="xform_separator";
Separator_XFormItem.prototype.colSpan="*";
Separator_XFormItem.prototype.align=_CENTER_;
Separator_XFormItem.prototype.valign=_CENTER_;
Separator_XFormItem.prototype.height=10;
Separator_XFormItem.prototype.focusable=false;
Separator_XFormItem.prototype.outputHTML=function(t,a){
var e=(this.getCssClass()||"");
if(e!=""&&e!=null){
e=' class="'+e+'"'
}
t.append("<table width=100% cellspacing=0 cellpadding=0>","<tr><td height=",this.getHeight(),">","<div ",e,"></div>","</td></tr></table>")
};
Separator_XFormItem.prototype.setElementEnabled=XFormItem.prototype.setElementEnabledCssClass;
Group_XFormItem=function(){
this.tabIdOrder=[]
};
XFormItemFactory.createItemType("_GROUP_","group",Group_XFormItem,XFormItem);
Group_XFormItem.prototype.forceUpdate=false;
Group_XFormItem.prototype.numCols=2;
Group_XFormItem.prototype.useParentTable=false;
Group_XFormItem.prototype.focusable=false;
Group_XFormItem.prototype.cellspacing=0;
Group_XFormItem.prototype.cellpadding=0;
Group_XFormItem.prototype.initFormItem=function(){
XFormItem.prototype.initFormItem.call(this);
if(this.getInheritedProperty("isTabGroup")){
var e=this.getForm();
e.tabIdOrder[this.getId()]=this.tabIdOrder;
e.addTabGroup(this)
}};
Group_XFormItem.prototype.outputHTML=function(e,t){
this.getForm().outputItemList(this.getItems(),this,e,this.getNumCols(),t)
};
Group_XFormItem.prototype.clearError=function(){
var a=this.getErrorLocation();
if(a==_PARENT_||a==_INHERIT_){
this.getParentItem().clearError();
return
}
this.getForm().removeErrorItem(this);
if(this.items){
var t=this.items.length;
for(var e=0;
e<t;
e++){
if(this.items[e].getErrorLocation()!=_PARENT_&&this.items[e].getErrorLocation()!=_INHERIT_){
this.items[e].clearError()
}}}
this.__errorState=XFormItem.ERROR_STATE_VALID;
this.removeErrorContainer()
};
Group_XFormItem.prototype.setElementEnabled=function(e){};
Group_XFormItem.prototype.updateVisibility=function(){
var isVisible=true;
var parentItem=this.getParentItem();
if(parentItem){
isVisible=this.getParentItem().getIsVisible()
}
if(isVisible){
var myVisibilityChecks=this.getInheritedProperty("visibilityChecks");
if(myVisibilityChecks&&myVisibilityChecks instanceof Array){
var cnt=myVisibilityChecks.length;
for(var i=0;
i<cnt;
i++){
if(myVisibilityChecks[i]!=null){
if(typeof(myVisibilityChecks[i])=="function"){
isVisible=myVisibilityChecks[i].call(this);
if(!isVisible){
break
}}else{
if(myVisibilityChecks[i] instanceof Array){
var func=myVisibilityChecks[i].shift();
isVisible=func.apply(this,myVisibilityChecks[i]);
myVisibilityChecks[i].unshift(func);
if(!isVisible){
break
}}else{
if(typeof(myVisibilityChecks[i])=="string"){
var instance=this.getInstance();
isVisible=eval(myVisibilityChecks[i]);
if(!isVisible){
break
}}}}}}}}
var reRunRefresh=false;
if(isVisible){
if(this.deferred){
reRunRefresh=true
}
this.show()
}else{
this.hide()
}
if(isVisible){
for(var itemId in this.activeChildren){
if(this.activeChildren[itemId]===true){
var item=this.getForm().getItemById(itemId);
if(item&&this.getInstance()){
var updateMethod=item.getUpdateVisibilityMethod();
if(updateMethod){
updateMethod.call(item)
}}}}}
if(reRunRefresh){
this.updateEnabledDisabled();
this.updateElement()
}};
Grouper_XFormItem=function(){};
XFormItemFactory.createItemType("_GROUPER_","grouper",Grouper_XFormItem,Group_XFormItem);
Grouper_XFormItem.prototype.labelCssClass="GrouperLabel";
Grouper_XFormItem.prototype.labelLocation=_INLINE_;
Grouper_XFormItem.prototype.borderCssClass="GrouperBorder";
Grouper_XFormItem.prototype.insetCssClass="GrouperInset";
Grouper_XFormItem.prototype.getBorderCssClass=function(){
return this.getInheritedProperty("borderCssClass")
};
Grouper_XFormItem.prototype.getInsetCssClass=function(){
return this.getInheritedProperty("insetCssClass")
};
Grouper_XFormItem.prototype.outputHTMLStart=function(e,t){
e.append("<div class=",this.getBorderCssClass(),">","<span ",this.getLabelCssString(),">",this.getLabel(),"</span>","<div class=",this.getInsetCssClass(),">")
};
Grouper_XFormItem.prototype.outputHTMLEnd=function(e,t){
e.append("</div></div>")
};
RadioGrouper_XFormItem=function(){};
XFormItemFactory.createItemType("_RADIO_GROUPER_","radiogrouper",RadioGrouper_XFormItem,Grouper_XFormItem);
RadioGrouper_XFormItem.prototype.labelCssClass="xform_radio_grouper_label";
RadioGrouper_XFormItem.prototype.borderCssClass="xform_radio_grouper_border";
RadioGrouper_XFormItem.prototype.insetCssClass="xform_radio_grouper_inset";
RadioGrouper_XFormItem.prototype.width="100%";
CollapsableRadioGrouper_XFormItem=function(){};
XFormItemFactory.createItemType("_COLLAPSABLE_RADIO_GROUPER_","collapsableradiogrouper",CollapsableRadioGrouper_XFormItem,RadioGrouper_XFormItem);
CollapsableRadioGrouper_XFormItem.prototype.getLabel=function(){
var e=XFormItem.prototype.getLabel.apply(this);
return"<nobr><span class=xform_button style='font-size:9px;color:black;'>&nbsp;&ndash;&nbsp;</span>&nbsp;"+e+"</nobr>"
};
Case_XFormItem=function(){
Group_XFormItem.call(this)
};
XFormItemFactory.createItemType("_CASE_","case",Case_XFormItem,Group_XFormItem);
Case_XFormItem.prototype.labelLocation=_NONE_;
Case_XFormItem.prototype.useParentTable=false;
Case_XFormItem.prototype.width="100%";
Case_XFormItem.prototype.focusable=false;
Case_XFormItem.prototype.deferred=true;
Case_XFormItem.prototype.cellspacing=0;
Case_XFormItem.prototype.cellpadding=0;
Case_XFormItem.prototype.cssClass="XFormCase";
Case_XFormItem.prototype.isTabGroup=true;
Case_XFormItem.prototype.caseVarRef="currentStep";
Case_XFormItem.prototype.visibilityChangeEventSources=[Case_XFormItem.prototype.caseVarRef];
Case_XFormItem.prototype.initFormItem=function(){
XFormItem.prototype.initFormItem.call(this);
if(this.getInheritedProperty("isTabGroup")){
var e=this.getForm();
e.tabIdOrder[this.getId()]=this.tabIdOrder;
e.addTabGroup(this,"caseKey")
}};
Case_XFormItem.prototype.outputHTML=function(e,t){
this.deferred=this.getInheritedProperty("deferred");
if(this.deferred){
this.getForm().outputItemList([],this,e,this.getNumCols(),0,true,false)
}else{
this.getForm().outputItemList(this.getItems(),this,e,this.getNumCols(),t)
}};
Case_XFormItem.prototype._outputHTML=function(){
var a=this.getForm();
var l=this.getElement();
if(!l){
return
}
var e=this.getId();
if(this.cacheInheritedMethod("getCustomHeight","$getCustomHeight")){
var m=this.cacheInheritedMethod("getCustomHeight","$getCustomHeight").call(this);
if(m){
l.style.height=m
}
var o=this.cacheInheritedMethod("getCustomWidth","$getCustomWidth").call(this);
if(o){
l.style.width=o
}
var t=(a.parent instanceof DwtControl)?a.parent:DwtControl.fromElementId(window._dwtShellId);
if(t){
if(this.cacheInheritedMethod("resizeHdlr","$resizeHdlr")){
t.addControlListener(new AjxListener(this,this.cacheInheritedMethod("resizeHdlr","$resizeHdlr")))
}}}
if(AjxEnv.isIE){
var s=this.createElement("temp",null,"div","");
s.display="none"
}
var c=new AjxBuffer();
if(this.outputHTMLStart){
this.outputHTMLStart(c,0)
}
var u=(this.getUseParentTable()==false);
if(u){
var n=this.getColSizes();
var h=this.getInheritedProperty("cellspacing");
var d=this.getInheritedProperty("cellpadding");
c.append("<table cellspacing=",h," cellpadding=",d," ",(XForm._showBorder?"border=1":"border=0"),' id="',this.getId(),'_table" ',this.getTableCssString(),">");
if(n!=null){
c.append(" <colgroup>");
for(var r=0;
r<n.length;
r++){
var f=n[r];
if(f<1){
f=f*100+"%"
}
c.append("<col width=",f,">")
}
c.append("</colgroup>")
}
c.append("<tbody>")
}
a.outputItemList(this.getItems(),this,c,this.getNumCols(),0,true,true);
c.append("</table>");
l.innerHTML=c.toString();
this.deferred=false
};
Case_XFormItem.prototype.hide=function(e){
XFormItem.prototype.hide.call(this,e);
this.hideElement(this.getElement(),e)
};
Case_XFormItem.prototype.show=function(e){
XFormItem.prototype.show.call(this,e);
this.showElement(this.getElement(),e)
};
Case_XFormItem.prototype.isCurrentTab=function(){
var t=false;
var e=this.getInheritedProperty("caseKey");
if(!AjxUtil.isEmpty(e)){
var a=this.getInheritedProperty("caseVarRef");
var o=this.getInstanceValue(a);
t=(o==e)
}
return t
};
Case_XFormItem.prototype.visibilityChecks=[Case_XFormItem.prototype.isCurrentTab];
TopGrouper_XFormItem=function(){};
XFormItemFactory.createItemType("_TOP_GROUPER_","top_grouper",TopGrouper_XFormItem,RadioGrouper_XFormItem);
TopGrouper_XFormItem.prototype.borderCssClass="TopGrouperBorder";
TopGrouper_XFormItem.prototype.labelCssClass="GrouperLabel";
TopGrouper_XFormItem.prototype.labelLocation=_INLINE_;
TopGrouper_XFormItem.prototype.insetCssClass="GrouperInset";
TopGrouper_XFormItem.prototype.outputHTMLStart=function(e,t){
e.append("<div class=",this.getBorderCssClass(),">","<div ",this.getLabelCssString(),">",this.getLabel(),"</div>","<div class=",this.getInsetCssClass(),">")
};
TopGrouper_XFormItem.prototype.outputHTMLEnd=function(e,t){
e.append("</div></div>")
};
Switch_XFormItem=function(){};
XFormItemFactory.createItemType("_SWITCH_","switch",Switch_XFormItem,Group_XFormItem);
Switch_XFormItem.prototype.labelLocation=_NONE_;
Switch_XFormItem.prototype.colSpan="*";
Switch_XFormItem.prototype.width="100%";
Switch_XFormItem.prototype.numCols=1;
Switch_XFormItem.prototype.outputHTML=function(e){
Switch_XFormItem.outputItemList.call(this.getForm(),this.getItems(),this,e)
};
Switch_XFormItem.prototype.setElementEnabled=function(e){};
Switch_XFormItem.outputItemList=function(l,t,n,a,e,s,r){
if(t.outputHTMLStart){
t.outputHTMLStart(n,e)
}
var y=null;
if(!r){
y=t.getCssString();
if(y!=null&&y!=""){
t.outputElementDivStart(n)
}}
for(var c=0;
c<l.length;
c++){
var g=l[c];
var o=(g.getItems()!=null);
var h=(g.getUseParentTable()!=false);
var f=g.getWriteElementDiv();
var d=g.getOutputHTMLMethod();
if(o&&h){
if(d){
d.call(g,n,e)
}}else{
if(f){
g.outputElementDivStart(n)
}
if(d){
d.call(g,n,0)
}
if(f){
g.outputElementDivEnd(n)
}}
if(t){
t.registerActiveChild(g)
}
g.signUpForEvents();
var m=g.getUpdateElementMethod();
if(m){
var p=g.getRefPath();
if(p){
var u=this.getInstance();
if(u){
m.call(g,g.getInstanceValue())
}}}}
if(y!=null&&y!=""){
t.outputElementDivEnd(n)
}
if(t.outputHTMLEnd){
t.outputHTMLEnd(n,e)
}};
Repeat_XFormItem=function(){
Group_XFormItem.call(this)
};
XFormItemFactory.createItemType("_REPEAT_","repeat",Repeat_XFormItem,Group_XFormItem);
Repeat_XFormItem.prototype.useParentTable=false;
Repeat_XFormItem.prototype.writeElementDiv=true;
Repeat_XFormItem.prototype.numCols=1;
Repeat_XFormItem.prototype.number=1;
Repeat_XFormItem.prototype.showRemoveButton=true;
Repeat_XFormItem.prototype.showAddButton=true;
Repeat_XFormItem.prototype.alwaysShowAddButton=false;
Repeat_XFormItem.prototype.showMoveUpButton=false;
Repeat_XFormItem.prototype.showMoveDownButton=false;
Repeat_XFormItem.prototype.bmolsnr=true;
Repeat_XFormItem.prototype.enableDisableChecks=[XFormItem.prototype.hasWritePermission];
Repeat_XFormItem.prototype.visibilityChecks=[XFormItem.prototype.hasReadPermission];
Repeat_XFormItem.haveAnyRows=function(){
return(this.getParentItem().getInstanceCount()!=0)
};
Repeat_XFormItem.isLastRow=function(){
return((this.getParentItem().getInstanceCount()-1)==this.getParentItem().instanceNum)
};
Repeat_XFormItem.isAddButtonVisible=function(){
return(this.getParentItem().getParentItem().getAlwaysShowAddButton()||Repeat_XFormItem.isLastRow.call(this)||!(Repeat_XFormItem.haveAnyRows.call(this)))
};
Repeat_XFormItem.prototype.getRemoveButton=function(){
if(!this.removeButton){
this.removeButton={
type:_BUTTON_,label:AjxMsg.xformRepeatRemove,cssStyle:"margin-left:20px;",onActivate:function(n){
var o=this.getParentItem().getParentItem();
o.removeRowButtonClicked(this.getParentItem().instanceNum)
}
,visibilityChecks:[Repeat_XFormItem.haveAnyRows],visibilityChangeEventSources:[this.getRef()]};
var e=this.getInheritedProperty("removeButtonLabel");
if(e){
this.removeButton.label=e
}
var t=this.getInheritedProperty("removeButtonWidth");
if(t){
this.removeButton.width=t
}
var a=this.getInheritedProperty("removeButtonCSSStyle");
if(a){
this.removeButton.cssStyle=a
}}
return this.removeButton
};
Repeat_XFormItem.prototype.getAddButton=function(){
if(!this.addButton){
var e=this.getInheritedProperty("showAddOnNextRow");
this.addButton={
ref:".",type:_BUTTON_,label:AjxMsg.xformRepeatAdd,onActivate:function(n){
var o=this.getParentItem().getParentItem();
o.addRowButtonClicked(this.getParentItem().instanceNum)
}
,visibilityChecks:[Repeat_XFormItem.isAddButtonVisible],visibilityChangeEventSources:[this.getRefPath()],forceUpdate:true};
var t=this.getInheritedProperty("addButtonLabel");
if(t){
this.addButton.label=t
}
var a=this.getInheritedProperty("addButtonWidth");
if(a){
this.addButton.width=a
}
if(e){
this.addButton.colSpan="*"
}}
return this.addButton
};
Repeat_XFormItem.prototype.moveUpButton={
type:_BUTTON_,label:"^",width:20,cssStyle:"margin-left:20px;",onActivate:function(t){
var e=this.getParentItem().getParentItem();
e.moveUpButtonClicked(this.getParentItem().instanceNum)
}};
Repeat_XFormItem.prototype.moveDownButton={
ref:".",type:_BUTTON_,label:"v",width:20,onActivate:function(t){
var e=this.getParentItem().getParentItem();
e.moveDownButtonClicked(this.getParentItem().instanceNum)
}
,forceUpdate:true};
Repeat_XFormItem.groupVisibilityCheck=function(){
return((this.instanceNum<this.getNumberToShow())||(this.instanceNum<this.getInstanceCount())||(this.instanceNum==0))
};
Repeat_XFormItem.prototype.initializeItems=function(){
var t=this.getItems();
if(t.length==1&&t[0].items){
var o=t[0]
}else{
var o={
ref:this.getRef(),fromRepeat:true,type:_GROUP_,numCols:t.length,items:[].concat(t),visibilityChangeEventSources:[this.getRefPath()],visibilityChecks:[function(){
return(this.instanceNum==0||(this.instanceNum<this.getNumberToShow())||(this.instanceNum<this.getInstanceCount()))
}
]}
}
o.colSpan=1;
if(this.getShowRemoveButton()){
var a=this.getRemoveButton();
o.items[o.items.length]=a;
o.numCols++
}
if(this.getShowAddButton()){
var a=this.getAddButton();
var e=this.getInheritedProperty("showAddOnNextRow");
o.items[o.items.length]=a;
if(e){
o.items[o.items.length]={
type:_SPACER_,colSpan:(o.numCols-1),visibilityChecks:[Repeat_XFormItem.isLastRow],visibilityChangeEventSources:[this.getRefPath()]}
}else{
o.numCols++
}}
if(this.getShowMoveUpButton()){
o.items[o.items.length]=this.getMoveUpButton();
o.numCols++
}
if(this.getShowMoveDownButton()){
o.items[o.items.length]=this.getMoveDownButton();
o.numCols++
}
this.__originalItems=o;
this.items=[]
};
Repeat_XFormItem.prototype.makeRepeatInstance=function(){
var e=this.__originalItems;
var n=this.getNumCols();
var t=[];
for(var o=0;
o<n;
o++){
var a=this.items.length;
e.refPath=this.getRefPath()+"["+a+"]";
groupItem=this.getForm().initItem(e,this);
groupItem.instanceNum=a;
t.push(groupItem);
this.items.push(groupItem)
}
return t
};
Repeat_XFormItem.prototype.outputHTML=function(e,t){
this.makeRepeatInstance();
this.getForm().outputItemList(this.items,this,e,this.getNumCols(),0)
};
Repeat_XFormItem.prototype.updateElement=function(f){
var t=this.getForm();
var a=this.getElement();
if(f==null||f===""){
f=[]
}
var d=Math.max(f.length,this.getNumberToShow());
var g=this.items.length;
var p=this.getId();
if(d>g){
var n=(d-g);
var w=a.getElementsByTagName("table")[0];
var e=a.getElementsByTagName("tbody")[0];
var m;
if(AjxEnv.isIE){
m=this.createElement("temp",null,"div","");
m.display="none"
}
while(this.items.length<d){
var s=this.makeRepeatInstance(this);
var l=new AjxBuffer();
t.outputItemList(s,this,l,this.getNumCols(),0,true);
if(AjxEnv.isIE){
m.innerHTML="<table>"+l.toString()+"</table>";
var h=m.getElementsByTagName("table")[0].rows;
for(var u=0;
u<h.length;
u++){
e.appendChild(h[u])
}}else{
var o=w.insertRow(-1);
o.innerHTML=l
}
var y=s.length;
for(var b=0;
b<y;
b++){
var c=s[b].getUpdateVisibilityMethod();
if(c){
c.call(s[b])
}
c=s[b].getUpdateEnabledDisabledtMethod();
if(c){
c.call(s[b])
}}}}
XFormItem.prototype.updateElement.call(this,f)
};
Repeat_XFormItem.prototype.addRowButtonClicked=function(e){
var t=this.getRefPath();
this.getModel().addRowAfter(this.getInstance(),t,e)
};
Repeat_XFormItem.prototype.removeRowButtonClicked=function(e){
var a=this.getForm();
if(this.getOnRemoveMethod()){
this.getOnRemoveMethod().call(this,e,a)
}else{
var o=this.getRefPath();
this.getModel().removeRow(this.getInstance(),o,e)
}
this.items[e].clearError();
var t=new DwtXFormsEvent(a,this,this.getInstanceValue());
a.notifyListeners(DwtEvent.XFORMS_VALUE_CHANGED,t)
};
Repeat_XFormItem.prototype.getOnRemoveMethod=function(){
return this.cacheInheritedMethod("onRemove","$onRemove","index,form")
};
Repeat_Grid_XFormItem=function(){};
XFormItemFactory.createItemType("_REPEAT_GRID_","repeat_grid",Repeat_Grid_XFormItem,Repeat_XFormItem);
Repeat_Grid_XFormItem.prototype.showRemoveButton=false;
Repeat_Grid_XFormItem.prototype.showAddButton=false;
Repeat_Grid_XFormItem.numCols=2;
Composite_XFormItem=function(){
Group_XFormItem.call(this)
};
XFormItemFactory.createItemType("_COMPOSITE_","composite",Composite_XFormItem,Group_XFormItem);
Composite_XFormItem.prototype.useParentTable=false;
Composite_XFormItem.prototype.tableCssClass="xform_composite_table";
Composite_XFormItem.prototype.focusable=false;
Composite_XFormItem.prototype.initializeItems=function(){
var e=this.getItems();
if(e==null){
return
}
if(this.numCols==null){
this.numCols=e.length
}
this.items=this.getForm().initItemList(e,this)
};
Composite_XFormItem.onFieldChange=function(a,t,e){
if(this.getParentItem()&&this.getParentItem().getOnChangeMethod()){
return this.getParentItem().getOnChangeMethod().call(this,a,t,e)
}else{
return this.setInstanceValue(a)
}};
Date_XFormItem=function(){};
XFormItemFactory.createItemType("_DATE_","date",Date_XFormItem,Composite_XFormItem);
Date_XFormItem.prototype.DATE_MONTH_CHOICES=[{
value:1,label:I18nMsg.monthJanMedium}
,{
value:2,label:I18nMsg.monthFebMedium}
,{
value:3,label:I18nMsg.monthMarMedium}
,{
value:4,label:I18nMsg.monthAprMedium}
,{
value:5,label:I18nMsg.monthMayMedium}
,{
value:6,label:I18nMsg.monthJunMedium}
,{
value:7,label:I18nMsg.monthJulMedium}
,{
value:8,label:I18nMsg.monthAugMedium}
,{
value:9,label:I18nMsg.monthSepMedium}
,{
value:10,label:I18nMsg.monthOctMedium}
,{
value:11,label:I18nMsg.monthNovMedium}
,{
value:12,label:I18nMsg.monthDecMedium}
];
Date_XFormItem.prototype.DATE_DAY_CHOICES=["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"];
Date_XFormItem.prototype.numCols=3;
Date_XFormItem.prototype.items=[{
type:_SELECT1_,ref:".",width:50,valign:_MIDDLE_,relevantBehavior:_PARENT_,choices:Date_XFormItem.prototype.DATE_MONTH_CHOICES,labelLocation:_NONE_,getDisplayValue:function(e){
if(!(e instanceof Date)){
e=new Date()
}
return""+(e.getMonth()+1)
}
,elementChanged:function(t,e,a){
if(e==null){
e=new Date()
}
var o=parseInt(t);
if(!isNaN(o)){
o-=1;
e.setMonth(o)
}
this.getForm().itemChanged(this.getParentItem(),e,a)
}}
,{
type:_SELECT1_,ref:".",width:50,valign:_MIDDLE_,relevantBehavior:_PARENT_,labelLocation:_NONE_,choices:Date_XFormItem.prototype.DATE_DAY_CHOICES,getDisplayValue:function(e){
if(!(e instanceof Date)){
e=new Date()
}
return""+e.getDate()
}
,elementChanged:function(t,e,o){
if(e==null){
e=new Date()
}
var a=parseInt(t);
if(!isNaN(a)){
e.setDate(a)
}
this.getForm().itemChanged(this.getParentItem(),e,o)
}}
,{
type:_TEXTFIELD_,ref:".",relevantBehavior:_PARENT_,width:45,labelLocation:_NONE_,getDisplayValue:function(e){
if(!(e instanceof Date)){
e=new Date()
}
return""+e.getFullYear()
}
,elementChanged:function(t,e,o){
if(e==null){
e=new Date()
}
var a=parseInt(t);
if(!isNaN(a)){
e.setYear(a)
}
this.getForm().itemChanged(this.getParentItem(),e,o)
}}
];
Time_XFormItem=function(){};
XFormItemFactory.createItemType("_TIME_","time",Time_XFormItem,Composite_XFormItem);
Time_XFormItem.prototype.numCols=3;
Time_XFormItem.prototype.TIME_HOUR_CHOICES=["1","2","3","4","5","6","7","8","9","10","11","12"];
Time_XFormItem.prototype.TIME_MINUTE_CHOICES=["00","05","10","15","20","25","30","35","40","45","50","55"];
Time_XFormItem.prototype.TIME_AMPM_CHOICES=[I18nMsg.periodAm,I18nMsg.periodPm];
Time_XFormItem.prototype.items=[{
type:_SELECT1_,ref:".",width:50,valign:_MIDDLE_,choices:Time_XFormItem.prototype.TIME_HOUR_CHOICES,labelLocation:_NONE_,getDisplayValue:function(t){
if(!(t instanceof Date)){
t=new Date()
}
var e=""+(t.getHours()%12);
if(e=="0"){
e="12"
}
return e
}
,elementChanged:function(r,n,s){
if(n==null){
n=new Date()
}
if(this.__dummyDate==null){
this.__dummyDate=new Date()
}
this.__dummyDate.setTime(n.getTime());
var o=parseInt(r);
if(!isNaN(o)){
if(o==12){
o=0
}
var a=(n.getHours()>11);
if(a){
o+=12
}
this.__dummyDate.setHours(o)
}
var t=this.getParentItem();
var e=t.getElementChangedMethod();
if(e!=null){
e.call(this.getParentItem(),this.__dummyDate,n,s)
}else{
this.getForm().itemChanged(this.getParentItem(),this.__dummyDate,s)
}}}
,{
type:_SELECT1_,ref:".",width:50,valign:_MIDDLE_,choices:Time_XFormItem.prototype.TIME_MINUTE_CHOICES,labelLocation:_NONE_,getDisplayValue:function(t){
if(!(t instanceof Date)){
t=new Date()
}
var e=t.getMinutes();
e=Math.round(e/5)*5;
e=(e<10?"0"+e:""+e);
return e
}
,elementChanged:function(s,a,n){
if(a==null){
a=new Date()
}
if(this.__dummyDate==null){
this.__dummyDate=new Date()
}
this.__dummyDate.setTime(a.getTime());
var o=parseInt(s);
if(!isNaN(o)){
this.__dummyDate.setMinutes(o)
}
var t=this.getParentItem();
var e=t.getElementChangedMethod();
if(e!=null){
e.call(this.getParentItem(),this.__dummyDate,a,n)
}else{
this.getForm().itemChanged(this.getParentItem(),this.__dummyDate,n)
}}}
,{
type:_SELECT1_,ref:".",choices:Time_XFormItem.prototype.TIME_AMPM_CHOICES,width:50,valign:_MIDDLE_,labelLocation:_NONE_,getDisplayValue:function(t){
if(!(t instanceof Date)){
t=new Date()
}
var e=t.getHours();
if(e>11){
return I18nMsg.periodPm
}
return I18nMsg.periodAm
}
,elementChanged:function(o,s,r){
if(s==null){
s=new Date()
}
if(this.__dummyDate==null){
this.__dummyDate=new Date()
}
this.__dummyDate.setTime(s.getTime());
var a=(o==I18nMsg.periodPm);
var n=s.getHours()%12;
this.__dummyDate.setHours(n+(a?12:0));
var t=this.getParentItem();
var e=t.getElementChangedMethod();
if(e!=null){
e.call(this.getParentItem(),this.__dummyDate,s,r)
}else{
this.getForm().itemChanged(this.getParentItem(),this.__dummyDate,r)
}}}
];
Datetime_XFormItem=function(){};
XFormItemFactory.createItemType("_DATETIME_","datetime",Datetime_XFormItem,Composite_XFormItem);
Datetime_XFormItem._datetimeFormatToItems=function(h,o,r){
var t=[];
var s=/{(\d+),\s*(date|time)}/;
var a=0;
while((a=h.search(s))!=-1){
if(a>0){
var n={
type:_OUTPUT_,value:h.substring(0,a),valign:_CENTER_};
t.push(n);
h=h.substring(a)
}
var e=s.exec(h);
t.push(e[2]=="date"?o:r);
h=h.substring(e[0].length)
}
if(h.length>0){
var n={
type:_OUTPUT_,value:h};
t.push(n)
}
return t
};
Datetime_XFormItem.prototype.numCols=3;
Datetime_XFormItem.prototype.items=Datetime_XFormItem._datetimeFormatToItems(AjxMsg.xformDateTimeFormat,{
type:_DATE_,ref:".",labelLocation:_NONE_}
,{
type:_TIME_,ref:".",labelLocation:_NONE_}
);
WidgetAdaptor_XFormItem=function(){};
XFormItemFactory.createItemType("_WIDGET_ADAPTOR_","widget_adaptor",WidgetAdaptor_XFormItem,XFormItem);
WidgetAdaptor_XFormItem.prototype.writeElementDiv=true;
WidgetAdaptor_XFormItem.prototype.focusable=false;
WidgetAdaptor_XFormItem.prototype.constructWidget=function(){};
WidgetAdaptor_XFormItem.prototype.insertElement=function(){
if(!this.__alreadyInserted){
this.__alreadyInserted=true;
var e=this.constructWidget();
if(e==null){
return
}
this.widget=e;
this.insertWidget(this.getForm(),this.widget,this.getElement())
}};
WidgetAdaptor_XFormItem.prototype.showElement=function(e){
this.insertElement();
XForm.prototype.showElement.call(this,e)
};
WidgetAdaptor_XFormItem.prototype.insertWidget=function(t,a,e){
this.widget.insertIntoXForm(t,this,e)
};
WidgetAdaptor_XFormItem.prototype.updateElement=function(e){
if(this.__alreadyInserted){
this.updateWidget(e)
}};
WidgetAdaptor_XFormItem.prototype.updateWidget=function(e){
this.widget.updateInXForm(this.getForm(),this,e,this.getElement())
};
Dwt_Adaptor_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_ADAPTOR_","dwt_adaptor",Dwt_Adaptor_XFormItem,WidgetAdaptor_XFormItem);
Dwt_Adaptor_XFormItem.prototype.focusable=false;
Dwt_Adaptor_XFormItem.prototype.setElementEnabled=function(e){
WidgetAdaptor_XFormItem.prototype.setElementEnabled.call(this,e);
if(this.widget){
this.widget.setEnabled(e)
}
this._enabled=e
};
Dwt_Adaptor_XFormItem.prototype.constructWidget=function(){};
Dwt_Adaptor_XFormItem.prototype.insertWidget=function(t,a,e){
this.getForm()._reparentDwtObject(a,e)
};
Dwt_Adaptor_XFormItem.prototype.updateWidget=function(e){};
Dwt_Adaptor_XFormItem.prototype.getDwtSelectItemChoices=function(){
if(this.__selOption!=null){
return this.__selOptions
}
var t=null;
var s=this.getChoices();
if(s!=null){
var t=new Array(s.length);
for(var o=0;
o<s.length;
o++){
var e=s[o];
var n=(e instanceof Object?e.value:e);
var a=(e instanceof Object?e.label:e);
t[o]=new DwtSelectOptionData(n,a)
}}
this.__selOptions=t;
return this.__selOptions
};
Dwt_Adaptor_XFormItem.prototype._addCssStylesToDwtWidget=function(){
var s=this.getCssStyle();
if(s!=null){
var e=s.split(";");
var n=this.widget.getHtmlElement();
var t;
for(var o=0;
o<e.length;
++o){
t=e[o].split(":");
if(t.length>0){
var a=t[0];
if(a!=null){
a=a.replace(/^(\s)*/,"")
}
if(a=="float"){
a=(AjxEnv.isIE)?"styleFloat":"cssFloat"
}
var r=t[1];
if(r!=null){
n.style[a]=r.replace(/^(\s)*/,"")
}}}}};
Dwt_Button_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_BUTTON_","dwt_button",Dwt_Button_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_Button_XFormItem.estimateMyWidth=function(e,a,o){
var t=(String(e).length/2)*XForm.FONT_WIDTH1+(String(e).length/2)*XForm.FONT_WIDTH2+14;
if(a){
t=t+24
}
if(o>0){
t=t+o
}
return[t,"px"].join("")
};
Dwt_Button_XFormItem.prototype.labelLocation=DwtLabel.IMAGE_LEFT|DwtLabel.ALIGN_CENTER;
Dwt_Button_XFormItem.prototype.writeElementDiv=false;
Dwt_Button_XFormItem.prototype.insertWidget=function(t,a,e){
this.getForm()._reparentDwtObject(a,this.getContainer())
};
Dwt_Button_XFormItem.prototype.constructWidget=function(){
var c=this.widget=new DwtButton(this.getForm(),this.getLabelLocation(),this.getCssClass());
var p=this.getHeight();
var a=this.getWidth();
var o=null;
if(a!=null||p!=null){
o=c.getHtmlElement();
if(a!=null){
o.style.width=a
}
if(p!=null){
o.style.height=p
}}
this._addCssStylesToDwtWidget();
var m=this.getInheritedProperty("icon");
if(m!=null){
c.setImage(m)
}
var d=false;
var f=this.getInheritedProperty("toolTipContent");
if(f!=null){
c.setToolTipContent(f);
d=true
}
var t=this.getLabel();
try{
var y=Dwt.getSize(this.getContainer());
if(t){
var h=AjxStringUtil.getWidth(t);
var g;
if(m){
g=y.x-42
}else{
g=y.x-22
}
if((g>0)&&(h>g)){
if(!d){
c.setToolTipContent(t)
}
var e=t.length;
var g=g-AjxStringUtil.getWidth("...");
var n=Math.floor(g*e/h);
if(g>0){
t=t.substring(0,n)+"..."
}}
o=c.getHtmlElement();
var s=o.firstChild;
if(!s.style.width){
s.style.width="100%"
}}}
catch(u){}
c.setText(t);
var r=this.getOnActivateMethod();
if(r!=null){
var l=new AjxListener(this,r);
c.addSelectionListener(l)
}
if(this._enabled!==void 0){
this.setElementEnabled(this._enabled)
}
return c
};
Dwt_Button_XFormItem.prototype.getWidget=function(){
return this.widget
};
Dwt_Select_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_SELECT_","dwt_select",Dwt_Select_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_Select_XFormItem.prototype.writeElementDiv=false;
Dwt_Select_XFormItem.prototype.insertWidget=function(t,a,e){
this.getForm()._reparentDwtObject(a,this.getContainer())
};
Dwt_Select_XFormItem.prototype.constructWidget=function(){
var r=this.getDwtSelectItemChoices(this.getChoices());
var s=this.widget=new DwtSelect(this.getForm(),r);
var e=this.getHeight();
var n=this.getWidth();
if(n!=null||e!=null){
var o=s.getHtmlElement();
if(n!=null){
o.style.width=n
}
if(e!=null){
o.style.height=e
}}
this._addCssStylesToDwtWidget();
var a=new Function("event","var widget = event._args.selectObj;\rvalue = event._args.newValue; "+this.getExternalChangeHandler());
var t=new AjxListener(this.getForm(),a);
s.addChangeListener(t);
if(this._enabled!==void 0){
this.setElementEnabled(this._enabled)
}
return s
};
Dwt_Select_XFormItem.prototype.updateWidget=function(e){
this.widget.setSelectedValue(e)
};
Dwt_Select_XFormItem.prototype.setElementEnabled=function(e){
this._enabled=e;
if(this.widget==null){
return
}
if(e){
this.widget.enable()
}else{
this.widget.disable()
}};
Dwt_ColorPicker_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_COLORPICKER_","dwt_colorpicker",Dwt_ColorPicker_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_ColorPicker_XFormItem.prototype.cssStyle="width:80px;";
Dwt_ColorPicker_XFormItem.prototype.nowrap=false;
Dwt_ColorPicker_XFormItem.prototype.labelWrap=true;
Dwt_ColorPicker_XFormItem.prototype.constructWidget=function(){
var a={
parent:this.getForm(),allowColorInput:true,noFillLabel:ZaMsg.bt_reset};
var t=new DwtButtonColorPicker(a);
t.setActionTiming(DwtButton.ACTION_MOUSEDOWN);
var e=this.getInheritedProperty("buttonImage")||"FontColor";
t.setImage(e);
t.showColorDisplay(true);
t.setToolTipContent(ZMsg.xformFontColor);
if(this.getInstanceValue()!=null){
t.setColor(this.getInstanceValue())
}
t.__colorPicker.addSelectionListener(new AjxListener(this,this._colorOnChange));
return t
};
Dwt_ColorPicker_XFormItem.prototype.updateWidget=function(e){
if(!this.widget){
return
}
if(e!=null){
this.widget.setColor(e)
}else{
this.widget.setColor("")
}};
Dwt_ColorPicker_XFormItem.prototype._colorOnChange=function(t){
var a=t.detail;
var o=this.getElementChangedMethod();
if(o){
o.call(this,a,this.getInstanceValue(),t)
}
var e=this.getOnChangeMethod();
if(e){
e.call(this,a,t,this.getForm())
}};
Dwt_Date_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_DATE_","dwt_date",Dwt_Date_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_Date_XFormItem.prototype.cssStyle="width:80px;";
Dwt_Date_XFormItem.prototype.constructWidget=function(){
var e=this.getInheritedProperty("firstDayOfWeek");
var t=new DwtButton(this.getForm());
t.setActionTiming(DwtButton.ACTION_MOUSEDOWN);
var o=this.menu=new DwtMenu(t,DwtMenu.CALENDAR_PICKER_STYLE,null,null,this.getForm());
o.setSize("150");
o._table.width="100%";
t.setMenu(o,true);
o.setAssociatedObj(t);
var a=new DwtCalendar({
parent:o,firstDayOfWeek:(!AjxUtil.isEmpty(e)?e:0)}
);
a._invokingForm=this.getForm();
a._invokingFormItemId=this.getId();
a.setDate(new Date(),true);
a.addSelectionListener(new AjxListener(this,this._calOnChange));
t.__cal=a;
return t
};
Dwt_Date_XFormItem.prototype.updateWidget=function(e){
if(e==null){
e=new Date()
}
this.widget.setText(this.getButtonLabel(e));
this.widget._date=e;
this.widget.__cal.setDate(e,true)
};
Dwt_Date_XFormItem.prototype._calOnChange=function(t){
var a=t.detail;
var o=t.item;
var e=this.getElementChangedMethod();
e.call(this,a,this.getInstanceValue(),t)
};
Dwt_Date_XFormItem.prototype.getButtonLabel=function(e){
if(e==null||!(e instanceof Date)){
return""
}
return(e.getMonth()+1)+"/"+e.getDate()+"/"+(e.getFullYear())
};
Dwt_Time_XFormItem=function(){
this.items[0].type=_DWT_SELECT_;
this.items[0].errorLocation=_INHERIT_;
this.items[1].type=_DWT_SELECT_;
this.items[1].errorLocation=_INHERIT_;
this.items[1].choices=Dwt_Time_XFormItem.TIME_MINUTE_CHOICES;
this.items[1].getDisplayValue=function(t){
if(!(t instanceof Date)){
t=new Date()
}
var e=AjxDateUtil._pad(AjxDateUtil.getRoundedMins(t,15));
return e
};
this.items[2].type=_DWT_SELECT_;
this.items[2].errorLocation=_INHERIT_
};
Dwt_Time_XFormItem.TIME_MINUTE_CHOICES=["00","15","30","45"];
XFormItemFactory.createItemType("_DWT_TIME_","dwt_time",Dwt_Time_XFormItem,Time_XFormItem);
Dwt_Datetime_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_DATETIME_","dwt_datetime",Dwt_Datetime_XFormItem,Composite_XFormItem);
Dwt_Datetime_XFormItem.prototype.numCols=3;
Dwt_Datetime_XFormItem.prototype.useParentTable=false;
Dwt_Datetime_XFormItem.prototype.cssClass="xform_dwt_datetime";
Dwt_Datetime_XFormItem.prototype.items=Datetime_XFormItem._datetimeFormatToItems(AjxMsg.xformDateTimeFormat,{
type:_DWT_DATE_,ref:".",labelLocation:_NONE_,errorLocation:_PARENT_,elementChanged:function(a,t,o){
t=t?t:new Date();
a.setHours(t.getHours(),t.getMinutes(),t.getSeconds(),0);
var e=this.getParentItem().getElementChangedMethod();
if(e){
e.call(this.getParentItem(),a,t,o)
}}}
,{
type:_DWT_TIME_,ref:".",labelLocation:_NONE_,errorLocation:_PARENT_,elementChanged:function(a,t,o){
t=t?t:new Date();
var e=this.getParentItem().getElementChangedMethod();
if(e){
e.call(this.getParentItem(),a,t,o)
}}}
);
Dwt_List_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_LIST_","dwt_list",Dwt_List_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_List_XFormItem.prototype.writeElementDiv=false;
Dwt_List_XFormItem.prototype.widgetClass=DwtListView;
Dwt_List_XFormItem.prototype.bmolsnr=true;
Dwt_List_XFormItem.prototype.getOnSelectionMethod=function(){
return this.cacheInheritedMethod("onSelection","$onSelection","event")
};
Dwt_List_XFormItem.prototype.constructWidget=function(){
var n=this.getInheritedProperty("headerList");
var m=this.getInheritedProperty("widgetClass");
var c=this.getInheritedProperty("hideHeader");
var l=new m(this.getForm(),this.getCssClass(),null,((c!=undefined&&c==true)?null:n));
var s=this.getInheritedProperty("emptyText");
if(s!=null||s===""){
l.emptyText=s
}
if(c!=undefined){
l.hideHeader=c;
if(c&&n){
l._headerList=n
}}
var r=this.getInheritedProperty("multiselect");
if(r!=undefined){
l.setMultiSelect(r)
}
if(this.cacheInheritedMethod("getCustomHeight","$getCustomHeight")&&this.cacheInheritedMethod("getCustomWidth","$getCustomWidth")){
var u=this.cacheInheritedMethod("getCustomHeight","$getCustomHeight").call(this);
var o=this.cacheInheritedMethod("getCustomWidth","$getCustomWidth").call(this);
if(o&&u){
l.setSize(o,u)
}}else{
var o=this.getWidth();
var u=this.getHeight();
if(o&&u){
l.setSize(o,u)
}
if(u){
l.setListDivHeight(u)
}}
var h=this.getOnSelectionMethod();
if(h){
l.addSelectionListener(new AjxListener(this,h))
}else{
var d=new AjxListener(this,this._handleSelection);
l.addSelectionListener(d)
}
var a=this.cacheInheritedMethod("createPopupMenu","$createPopupMenu","parent");
if(a!=null){
a.call(this,l)
}
var t=this.getForm();
var e=(t.parent instanceof DwtControl)?t.parent:DwtControl.fromElementId(window._dwtShellId);
if(e){
if(this.cacheInheritedMethod("resizeHdlr","$resizeHdlr")&&this.cacheInheritedMethod("getCustomHeight","$getCustomHeight")&&this.cacheInheritedMethod("getCustomWidth","$getCustomWidth")){
e.addControlListener(new AjxListener(this,this.cacheInheritedMethod("resizeHdlr","$resizeHdlr")))
}}
return l
};
Dwt_List_XFormItem.prototype.resizeHdlr=function(){
try{
var e=this.cacheInheritedMethod("getCustomHeight","$getCustomHeight").call(this);
var a=this.cacheInheritedMethod("getCustomWidth","$getCustomWidth").call(this);
this.widget.setSize(a,e)
}
catch(t){
alert(t)
}};
Dwt_List_XFormItem.prototype.getSelection=function(){
return this.widget.getSelection()
};
Dwt_List_XFormItem.prototype._handleSelection=function(t){
var e=this.getModelItem();
var t=new DwtXModelEvent(this.getInstance(),e,null,null);
e.notifyListeners(DwtEvent.XFORMS_VALUE_CHANGED,t)
};
Dwt_List_XFormItem.prototype.insertWidget=function(t,a,e){
this.getForm()._reparentDwtObject(a,this.getContainer())
};
Dwt_List_XFormItem.prototype.updateWidget=function(e){
if(typeof(e)!="undefined"){
this.setItems(e)
}};
Dwt_List_XFormItem.isItemsChanged=function(e,h){
var t=false;
if((e._version!=null&&h._version!=null&&(e._version!=h._version))||(e.length!=h.length)){
t=true
}else{
var n=[];
var o=[];
for(var a=0;
a<e.length;
a++){
if(e[a] instanceof Object){
for(var s in e[a]){
n.push(e[a][s])
}}else{
n.push(e[a])
}
if(h[a] instanceof Object){
for(var r in h[a]){
o.push(h[a][r])
}}else{
o.push(h[a])
}
if(n.join()!=o.join()){
t=true;
break
}else{
n=[];
o=[]
}}}
return t
};
Dwt_List_XFormItem.prototype.setItems=function(e){
var s=this.widget.getList();
var r=new Array();
var a=new Array();
if(s){
r=s.getArray()
}
a=new Array();
var h=this.getInheritedProperty("defaultColumnSortable");
if(e&&e.length>0){
if(Dwt_List_XFormItem.isItemsChanged(e,r)){
var n=this.getInheritedProperty("preserveSelection");
var l=null;
if(n){
l=this.widget.getSelection()
}
var t=e.length;
for(var o=0;
o<t;
o++){
a.push(e[o])
}
this.widget.set(AjxVector.fromArray(a),h);
if(e._version!=undefined&&e._version!=null){
this.widget.getList().getArray()._version=e._version
}
if(n&&l){
this.widget.setSelectedItems(l)
}}}else{
this.widget.set(AjxVector.fromArray([]),h)
}};
Dwt_List_XFormItem.prototype.appendItems=function(e){
this.widget.addItems(e)
};
Button_Grid_XFormItem=function(){};
XFormItemFactory.createItemType("_BUTTON_GRID_","button_grid",Button_Grid_XFormItem,WidgetAdaptor_XFormItem);
Button_Grid_XFormItem.prototype.numCols=5;
Button_Grid_XFormItem.prototype.cssClass="xform_button_grid_medium";
Button_Grid_XFormItem.prototype.forceUpdate=true;
Button_Grid_XFormItem.prototype.constructWidget=function(){
var a=this.getExternalChangeHandler();
var t={
numCols:this.getNumCols(),choices:choices.getChoiceObject(),cssClass:this.getCssClass(),onChange:a,addBracketingCells:(this.getAlign()==_CENTER_)};
var e=this.getMultiple();
if(e!==null){
t.multiple=e
}
return new ButtonGrid(t)
};
Dwt_Chooser_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_CHOOSER_","chooser",Dwt_Chooser_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_Chooser_XFormItem.prototype.widgetClass=DwtChooser;
Dwt_Chooser_XFormItem.prototype.listSize=100;
Dwt_Chooser_XFormItem.prototype.getSorted=function(){
return this.getInheritedProperty("sorted")
};
Dwt_Chooser_XFormItem.prototype.getListCssClass=function(){
return this.getInheritedProperty("listCssClass")
};
Dwt_Chooser_XFormItem.prototype.getTargetListCssClass=function(){
return this.getInheritedProperty("targetListCssClass")
};
Dwt_Chooser_XFormItem.prototype.getSourceInstanceValue=function(){
var e=this.getModel().getInstanceValue(this.getInstance(),this.getInheritedProperty("sourceRef"));
if(!e){
e=new AjxVector()
}else{
if(typeof e=="string"){
e=new Array(e)
}}
return e
};
Dwt_Chooser_XFormItem.prototype.getTargetInstanceValue=function(){
var e=this.getInstanceValue();
if(!e){
e=new AjxVector()
}else{
if(typeof e=="string"){
e=new Array(e)
}}
return e
};
Dwt_Chooser_XFormItem.prototype._handleStateChange=function(t){
var e=this.getForm();
var n=this.getId();
var o=this.getWidget();
var a=o.getItems();
this._skipUpdate=true;
e.itemChanged(n,a);
this._skipUpdate=false
};
Dwt_Chooser_XFormItem.prototype.constructWidget=function(){
var o=this.getForm();
var e=this.getCssClass();
var r=this.getListCssClass();
var t=this.getTargetListCssClass();
var s=this.getInheritedProperty("widgetClass");
if(r&&!t){
t=r
}
var a=this.getInheritedProperty("listSize");
var n={
parent:o,className:e,slvClassName:r,tlvClassName:t,layoutStyle:(this.getInheritedProperty("layoutStyle")?this.getInheritedProperty("layoutStyle"):DwtChooser.HORIZ_STYLE),listSize:a,sourceEmptyOk:true,allButtons:true,listWidth:(this.getInheritedProperty("listWidth")?this.getInheritedProperty("listWidth"):null),listHeight:(this.getInheritedProperty("listHeight")?this.getInheritedProperty("listHeight"):null),tableWidth:(this.getInheritedProperty("tableWidth")?this.getInheritedProperty("tableWidth"):null),labelWidth:(this.getInheritedProperty("labelWidth")?this.getInheritedProperty("labelWidth"):null),splitButtons:this.getInheritedProperty("splitButtons")};
return new s(n)
};
Dwt_Chooser_XFormItem.prototype.updateWidget=function(s,t,e){
if(this._skipUpdate){
return
}
if(this._stateChangeListener){
this.widget.removeStateChangeListener(this._stateChangeListener)
}else{
this._stateChangeListener=new AjxListener(this,Dwt_Chooser_XFormItem.prototype._handleStateChange)
}
var l=this.getSourceInstanceValue();
var c;
if(l instanceof Array){
var d=[];
var a=l.length;
for(var r=0;
r<a;
r++){
d.push(l[r])
}
c=AjxVector.fromArray(d)
}else{
c=l.clone()
}
var n=this.getTargetInstanceValue();
if(n instanceof Array){
n=AjxVector.fromArray(n)
}
if(t){
var a=n.size();
for(var r=0;
r<a;
r++){
if(e){
var o=c.indexOfLike(n.get(r),e);
if(o>-1){
c.removeAt(o)
}}else{
var o=c.indexOf(n.get(r));
if(o>-1){
c.removeAt(o)
}}}}
var h=this.getSorted();
if(h){
c.sort();
n.sort()
}
this.widget.setItems(c);
this.widget.setItems(n,DwtChooserListView.TARGET);
this.widget.addStateChangeListener(this._stateChangeListener)
};
Dwt_Alert_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_ALERT_","alert",Dwt_Alert_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_Alert_XFormItem.prototype.colSpan="*";
Dwt_Alert_XFormItem.prototype.labelLocation=_NONE_;
Dwt_Alert_XFormItem.prototype.getStyle=function(){
return this.getInheritedProperty("style")
};
Dwt_Alert_XFormItem.prototype.getIconVisible=function(){
return this.getInheritedProperty("iconVisible")
};
Dwt_Alert_XFormItem.prototype.getTitle=function(){
return this.getInheritedProperty("title")
};
Dwt_Alert_XFormItem.prototype.getContent=function(){
return this.getInheritedProperty("content")
};
Dwt_Alert_XFormItem.prototype.getAlertCssClass=function(){
return this.getInheritedProperty("alertCssClass")
};
Dwt_Alert_XFormItem.prototype.constructWidget=function(){
var u=this.getStyle();
var d=this.getIconVisible();
var b=this.getTitle();
var c=this.getContent();
var n=this.getAlertCssClass();
var t=this.getForm();
var a=new DwtAlert(t,n);
a.setStyle(u);
a.setIconVisible(d);
a.setTitle(b);
a.setContent(c);
if(AjxEnv.isIE){
try{
var w=a.getHtmlElement();
var s=Dwt.getSize(w);
var o=this.getContainer();
var l=Dwt.getSize(o);
var u=DwtCssStyle.getComputedStyleObject(w);
var e=parseInt(u.borderLeftWidth)||1;
var y=parseInt(u.borderRightWidth)||1;
var p=parseInt(u.paddingLeft)||5;
var h=parseInt(u.paddingRight)||5;
var m=parseInt(u.marginLeft)||5;
var r=parseInt(u.marginRight)||5;
var g=e+y+p+h+m+r;
if(l.x>g){
s.x=l.x-g;
Dwt.setSize(w,s.x,s.y)
}}
catch(f){}}
return a
};
Dwt_Alert_XFormItem.prototype.updateWidget=function(e){
var t=this.getContent();
if(!t&&e){
this.getWidget().setContent(e)
}};
Dwt_TabBar_XFormItem=function(){};
XFormItemFactory.createItemType("_TAB_BAR_","tab_bar",Dwt_TabBar_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_TabBar_XFormItem.prototype.colSpan="*";
Dwt_TabBar_XFormItem.prototype.labelLocation=_NONE_;
Dwt_TabBar_XFormItem.prototype.cssStyle="margin-right: 5px";
Dwt_TabBar_XFormItem.prototype._value2tabkey;
Dwt_TabBar_XFormItem.prototype._tabkey2value;
Dwt_TabBar_XFormItem.prototype._stateChangeListener;
Dwt_TabBar_XFormItem.prototype.getChoices=function(){
return this.getInheritedProperty("choices")
};
Dwt_TabBar_XFormItem.prototype._handleStateChange=function(a){
var t=this.getForm();
var o=this.getWidget();
var n=o.getCurrentTab();
var e=this._tabkey2value[n];
var s=this.getId();
t.releaseFocus();
t.itemChanged(s,e,a,true)
};
Dwt_TabBar_XFormItem.prototype.constructWidget=function(){
var e=this.getForm();
var d=this.getCssClass();
var n=this.getInheritedProperty("buttonCssClass");
var r=new DwtTabBarFloat(e,d,n);
this._value2tabkey={};
this._tabkey2value={};
var c=this.getChoices();
if(c.constructor==XFormChoices){
this.choices=c;
var a=new AjxListener(this,this.dirtyDisplay);
c.addListener(DwtEvent.XFORMS_CHOICES_CHANGED,a);
var l=this.getNormalizedValues();
var h=this.getNormalizedLabels();
var t=l.length;
for(var s=0;
s<t;
s++){
this._value2tabkey[l[s]]=s+1;
this._tabkey2value[s+1]=l[s];
r.addButton(s+1,h[s]);
r.getButton(s+1).getHtmlElement().style.paddingRight="2px"
}}else{
var t=c.length;
for(var s=0;
s<t;
s++){
var o=c[s];
this._value2tabkey[o.value]=s+1;
this._tabkey2value[s+1]=o.value;
r.addButton(s+1,o.label);
r.getButton(s+1).getHtmlElement().style.paddingRight="2px"
}}
return r
};
Dwt_TabBar_XFormItem.prototype.updateWidget=function(e){
if(this.widget.isUpdating){
this.widget.isUpdating=false;
return
}
if(this._stateChangeListener){
this.widget.removeStateChangeListener(this._stateChangeListener)
}else{
this._stateChangeListener=new AjxListener(this,Dwt_TabBar_XFormItem.prototype._handleStateChange)
}
var t=this._value2tabkey[e];
if(t!=this.widget.getCurrentTab()){
this.widget.openTab(t)
}
this.widget.addStateChangeListener(this._stateChangeListener)
};
Dwt_TabBar_XFormItem.prototype.dirtyDisplay=function(){
this.$normalizedChoices=null;
if(this.choices&&this.choices.constructor==XFormChoices){
var s=this.getNormalizedLabels();
var e=this.getNormalizedValues();
var o=s.length;
for(var a=0;
a<o;
a++){
var n=this._value2tabkey[e[a]];
if(n){
var t=this.widget.getButton(n);
if(t){
t.setText(s[a])
}}}}
this._choiceDisplayIsDirty=true;
delete this.$normalizedChoices
};
Dwt_ProgressBar_XFormItem=function(){};
XFormItemFactory.createItemType("_DWT_PROGRESS_BAR_","dwt_progress_bar",Dwt_ProgressBar_XFormItem,Dwt_Adaptor_XFormItem);
Dwt_ProgressBar_XFormItem.prototype.constructWidget=function(){
var a=this.getForm();
var o=new DwtProgressBar(a,null);
var t=this.getInheritedProperty("maxValue");
if(!t){
this.maxValueRef=this.getInheritedProperty("maxValueRef");
t=this.getModel().getInstanceValue(this.getInstance(),this.maxValueRef)
}
o.setMaxValue(t);
var n=this.getInheritedProperty("progressCssClass");
if(n){
o.setProgressCssClass(n)
}
var e=this.getInheritedProperty("wholeCssClass");
if(e){
o.setWholeCssClass(e)
}
return o
};
Dwt_ProgressBar_XFormItem.prototype.updateWidget=function(e){
if(!e){
e=0
}
if(this.maxValueRef){
maxvalue=this.getModel().getInstanceValue(this.getInstance(),this.maxValueRef);
this.getWidget().setMaxValue(maxvalue)
}
this.getWidget().setValue(e)
};
