
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxTimezoneData={};
AjxTimezoneData.TRANSITION_YEAR=2018;
AjxTimezoneData.TIMEZONE_RULES=[{
serverId:"Etc/GMT+12",clientId:"Etc/GMT+12",score:100,standard:{
offset:-720,tzname:"GMT+12"}}
,{
serverId:"Pacific/Midway",clientId:"Pacific/Midway",score:100,standard:{
offset:-660,tzname:"SST"}}
,{
serverId:"Pacific/Honolulu",clientId:"Pacific/Honolulu",score:200,standard:{
offset:-600,tzname:"HST"}}
,{
serverId:"America/Anchorage",clientId:"America/Anchorage",score:200,standard:{
offset:-540,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"AKST"}
,daylight:{
offset:-480,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"AKDT"}}
,{
serverId:"America/Los_Angeles",clientId:"America/Los_Angeles",score:200,standard:{
offset:-480,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"PST"}
,daylight:{
offset:-420,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"PDT"}}
,{
serverId:"America/Tijuana",clientId:"America/Tijuana",score:100,standard:{
offset:-480,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"PST"}
,daylight:{
offset:-420,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"PDT"}}
,{
serverId:"America/Chihuahua",clientId:"America/Chihuahua",score:100,standard:{
offset:-420,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"MST"}
,daylight:{
offset:-360,mon:4,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,4,1],tzname:"MDT"}}
,{
serverId:"America/Denver",clientId:"America/Denver",score:200,standard:{
offset:-420,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"MST"}
,daylight:{
offset:-360,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"MDT"}}
,{
serverId:"America/Phoenix",clientId:"America/Phoenix",score:200,standard:{
offset:-420,tzname:"MST"}}
,{
serverId:"America/Chicago",clientId:"America/Chicago",score:200,standard:{
offset:-360,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"CST"}
,daylight:{
offset:-300,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"CDT"}}
,{
serverId:"America/Guatemala",clientId:"America/Guatemala",score:100,standard:{
offset:-360}}
,{
serverId:"America/Mexico_City",clientId:"America/Mexico_City",score:100,standard:{
offset:-360,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"CST"}
,daylight:{
offset:-300,mon:4,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,4,1],tzname:"CDT"}}
,{
serverId:"America/Regina",clientId:"America/Regina",score:200,standard:{
offset:-360,tzname:"CST"}}
,{
serverId:"America/Bogota",clientId:"America/Bogota",score:100,standard:{
offset:-300}}
,{
serverId:"America/Cancun",clientId:"America/Cancun",score:100,standard:{
offset:-300,tzname:"EST"}}
,{
serverId:"America/Indiana/Indianapolis",clientId:"America/Indiana/Indianapolis",score:100,standard:{
offset:-300,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"EST"}
,daylight:{
offset:-240,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"EDT"}}
,{
serverId:"America/New_York",clientId:"America/New_York",score:200,standard:{
offset:-300,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"EST"}
,daylight:{
offset:-240,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"EDT"}}
,{
serverId:"America/Caracas",clientId:"America/Caracas",score:100,standard:{
offset:-270,tzname:"VET"}}
,{
serverId:"America/Asuncion",clientId:"America/Asuncion",score:100,standard:{
offset:-240,mon:3,week:4,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"PYT"}
,daylight:{
offset:-180,mon:10,week:1,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,7],tzname:"PYST"}}
,{
serverId:"America/Cuiaba",clientId:"America/Cuiaba",score:100,standard:{
offset:-240,mon:2,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,2,25],tzname:"AMT"}
,daylight:{
offset:-180,mon:10,week:3,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,21],tzname:"AMST"}}
,{
serverId:"America/Guyana",clientId:"America/Guyana",score:100,standard:{
offset:-240,tzname:"GYT"}}
,{
serverId:"America/Halifax",clientId:"America/Halifax",score:100,standard:{
offset:-240,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"AST"}
,daylight:{
offset:-180,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"ADT"}}
,{
serverId:"America/St_Johns",clientId:"America/St_Johns",score:100,standard:{
offset:-210,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"NST"}
,daylight:{
offset:-150,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"NDT"}}
,{
serverId:"America/Argentina/Buenos_Aires",clientId:"America/Argentina/Buenos_Aires",score:100,standard:{
offset:-180}}
,{
serverId:"America/Bahia",clientId:"America/Bahia",score:100,standard:{
offset:-180,tzname:"BRT"}}
,{
serverId:"America/Cayenne",clientId:"America/Cayenne",score:100,standard:{
offset:-180,tzname:"GFT"}}
,{
serverId:"America/Godthab",clientId:"America/Godthab",score:100,standard:{
offset:-180,mon:10,week:-1,wkday:1,hour:1,min:0,sec:0,trans:[2018,10,28],tzname:"WGT"}
,daylight:{
offset:-120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"WGST"}}
,{
serverId:"America/Montevideo",clientId:"America/Montevideo",score:100,standard:{
offset:-180,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"UYT"}
,daylight:{
offset:-120,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"UYST"}}
,{
serverId:"America/Santiago",clientId:"America/Santiago",score:100,standard:{
offset:-180,tzname:"CLT"}}
,{
serverId:"America/Sao_Paulo",clientId:"America/Sao_Paulo",score:100,standard:{
offset:-180,mon:2,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,2,25],tzname:"BRT"}
,daylight:{
offset:-120,mon:10,week:3,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,21],tzname:"BRST"}}
,{
serverId:"Atlantic/South_Georgia",clientId:"Atlantic/South_Georgia",score:100,standard:{
offset:-120,tzname:"GST"}}
,{
serverId:"Atlantic/Azores",clientId:"Atlantic/Azores",score:100,standard:{
offset:-60,mon:10,week:-1,wkday:1,hour:1,min:0,sec:0,trans:[2018,10,28],tzname:"AZOT"}
,daylight:{
offset:0,mon:3,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"AZOST"}}
,{
serverId:"Atlantic/Cape_Verde",clientId:"Atlantic/Cape_Verde",score:100,standard:{
offset:-60,tzname:"CVT"}}
,{
serverId:"Africa/Casablanca",clientId:"Africa/Casablanca",score:100,standard:{
offset:0,mon:6,week:2,wkday:7,hour:3,min:0,sec:0,trans:[2018,6,9],tzname:"WET"}
,daylight:{
offset:60,mon:7,week:3,wkday:7,hour:2,min:0,sec:0,trans:[2018,7,21],tzname:"WEST"}}
,{
serverId:"Africa/Monrovia",clientId:"Africa/Monrovia",score:100,standard:{
offset:0,tzname:"GMT"}}
,{
serverId:"Europe/London",clientId:"Europe/London",score:100,standard:{
offset:0,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"GMT/BST"}
,daylight:{
offset:60,mon:3,week:-1,wkday:1,hour:1,min:0,sec:0,trans:[2018,3,25],tzname:"GMT/BST"}}
,{
serverId:"UTC",clientId:"UTC",score:100,standard:{
offset:0,tzname:"UTC"}}
,{
serverId:"Africa/Algiers",clientId:"Africa/Algiers",score:100,standard:{
offset:60,tzname:"CET"}}
,{
serverId:"Africa/Windhoek",clientId:"Africa/Windhoek",score:100,standard:{
offset:60,mon:4,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,4,1],tzname:"WAT"}
,daylight:{
offset:120,mon:9,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,9,2],tzname:"WAST"}}
,{
serverId:"Europe/Belgrade",clientId:"Europe/Belgrade",score:100,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Europe/Berlin",clientId:"Europe/Berlin",score:200,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Europe/Brussels",clientId:"Europe/Brussels",score:100,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Europe/Warsaw",clientId:"Europe/Warsaw",score:100,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Africa/Cairo",clientId:"Africa/Cairo",score:100,standard:{
offset:120}}
,{
serverId:"Africa/Harare",clientId:"Africa/Harare",score:200,standard:{
offset:120,tzname:"CAT"}}
,{
serverId:"Africa/Tripoli",clientId:"Africa/Tripoli",score:100,standard:{
offset:120,tzname:"EET"}}
,{
serverId:"Asia/Amman",clientId:"Asia/Amman",score:100,standard:{
offset:120,mon:10,week:-1,wkday:6,hour:1,min:0,sec:0,trans:[2018,10,26],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:5,hour:23,min:59,sec:59,trans:[2018,3,29],tzname:"EEST"}}
,{
serverId:"Asia/Beirut",clientId:"Asia/Beirut",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Asia/Damascus",clientId:"Asia/Damascus",score:100,standard:{
offset:120,mon:10,week:-1,wkday:6,hour:0,min:0,sec:0,trans:[2018,10,26],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:6,hour:0,min:0,sec:0,trans:[2018,3,30],tzname:"EEST"}}
,{
serverId:"Asia/Jerusalem",clientId:"Asia/Jerusalem",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"IST"}
,daylight:{
offset:180,mon:3,week:-1,wkday:6,hour:2,min:0,sec:0,trans:[2018,3,30],tzname:"IDT"}}
,{
serverId:"Europe/Athens",clientId:"Europe/Athens",score:200,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Bucharest",clientId:"Europe/Bucharest",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Helsinki",clientId:"Europe/Helsinki",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Istanbul",clientId:"Europe/Istanbul",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Kaliningrad",clientId:"Europe/Kaliningrad",score:100,standard:{
offset:120,tzname:"EET"}}
,{
serverId:"Africa/Nairobi",clientId:"Africa/Nairobi",score:200,standard:{
offset:180,tzname:"EAT"}}
,{
serverId:"Asia/Baghdad",clientId:"Asia/Baghdad",score:100,standard:{
offset:180}}
,{
serverId:"Asia/Kuwait",clientId:"Asia/Kuwait",score:100,standard:{
offset:180,tzname:"AST"}}
,{
serverId:"Europe/Minsk",clientId:"Europe/Minsk",score:100,standard:{
offset:180,tzname:"MSK"}}
,{
serverId:"Europe/Moscow",clientId:"Europe/Moscow",score:100,standard:{
offset:180,tzname:"MSK"}}
,{
serverId:"Asia/Tehran",clientId:"Asia/Tehran",score:100,standard:{
offset:210,mon:9,week:4,wkday:3,hour:0,min:0,sec:0,trans:[2018,9,25],tzname:"IRST"}
,daylight:{
offset:270,mon:3,week:4,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"IRDT"}}
,{
serverId:"Asia/Baku",clientId:"Asia/Baku",score:100,standard:{
offset:240,mon:10,week:-1,wkday:1,hour:5,min:0,sec:0,trans:[2018,10,28],tzname:"AZT"}
,daylight:{
offset:300,mon:3,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,3,25],tzname:"AZST"}}
,{
serverId:"Asia/Muscat",clientId:"Asia/Muscat",score:100,standard:{
offset:240,tzname:"GST"}}
,{
serverId:"Asia/Tbilisi",clientId:"Asia/Tbilisi",score:200,standard:{
offset:240,tzname:"GET"}}
,{
serverId:"Asia/Yerevan",clientId:"Asia/Yerevan",score:100,standard:{
offset:240,tzname:"AMT"}}
,{
serverId:"Europe/Samara",clientId:"Europe/Samara",score:100,standard:{
offset:240,tzname:"SAMT"}}
,{
serverId:"Indian/Mauritius",clientId:"Indian/Mauritius",score:100,standard:{
offset:240}}
,{
serverId:"Asia/Kabul",clientId:"Asia/Kabul",score:100,standard:{
offset:270,tzname:"AFT"}}
,{
serverId:"Asia/Karachi",clientId:"Asia/Karachi",score:200,standard:{
offset:300}}
,{
serverId:"Asia/Tashkent",clientId:"Asia/Tashkent",score:100,standard:{
offset:300,tzname:"UZT"}}
,{
serverId:"Asia/Yekaterinburg",clientId:"Asia/Yekaterinburg",score:100,standard:{
offset:300,tzname:"YEKT"}}
,{
serverId:"Asia/Colombo",clientId:"Asia/Colombo",score:100,standard:{
offset:330,tzname:"IST"}}
,{
serverId:"Asia/Kolkata",clientId:"Asia/Kolkata",score:200,standard:{
offset:330,tzname:"IST"}}
,{
serverId:"Asia/Kathmandu",clientId:"Asia/Kathmandu",score:100,standard:{
offset:345,tzname:"NPT"}}
,{
serverId:"Asia/Almaty",clientId:"Asia/Almaty",score:100,standard:{
offset:360,tzname:"ALMT"}}
,{
serverId:"Asia/Dhaka",clientId:"Asia/Dhaka",score:100,standard:{
offset:360}}
,{
serverId:"Asia/Novosibirsk",clientId:"Asia/Novosibirsk",score:100,standard:{
offset:360,tzname:"NOVT"}}
,{
serverId:"Asia/Rangoon",clientId:"Asia/Rangoon",score:100,standard:{
offset:390,tzname:"MMT"}}
,{
serverId:"Asia/Bangkok",clientId:"Asia/Bangkok",score:100,standard:{
offset:420,tzname:"ICT"}}
,{
serverId:"Asia/Krasnoyarsk",clientId:"Asia/Krasnoyarsk",score:100,standard:{
offset:420,tzname:"KRAT"}}
,{
serverId:"Asia/Hong_Kong",clientId:"Asia/Hong_Kong",score:200,standard:{
offset:480}}
,{
serverId:"Asia/Irkutsk",clientId:"Asia/Irkutsk",score:100,standard:{
offset:480,tzname:"IRKT"}}
,{
serverId:"Asia/Kuala_Lumpur",clientId:"Asia/Kuala_Lumpur",score:100,standard:{
offset:480,tzname:"MYT"}}
,{
serverId:"Asia/Singapore",clientId:"Asia/Singapore",score:100,standard:{
offset:480,tzname:"SGT"}}
,{
serverId:"Asia/Taipei",clientId:"Asia/Taipei",score:100,standard:{
offset:480}}
,{
serverId:"Asia/Ulaanbaatar",clientId:"Asia/Ulaanbaatar",score:100,standard:{
offset:480,mon:9,week:-1,wkday:7,hour:0,min:0,sec:0,trans:[2018,9,29],tzname:"ULAT"}
,daylight:{
offset:540,mon:3,week:-1,wkday:7,hour:2,min:0,sec:0,trans:[2018,3,31],tzname:"ULAST"}}
,{
serverId:"Australia/Perth",clientId:"Australia/Perth",score:100,standard:{
offset:480}}
,{
serverId:"Asia/Seoul",clientId:"Asia/Seoul",score:100,standard:{
offset:540}}
,{
serverId:"Asia/Tokyo",clientId:"Asia/Tokyo",score:200,standard:{
offset:540}}
,{
serverId:"Asia/Yakutsk",clientId:"Asia/Yakutsk",score:100,standard:{
offset:540,tzname:"YAKT"}}
,{
serverId:"Australia/Adelaide",clientId:"Australia/Adelaide",score:100,standard:{
offset:570,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"ACST"}
,daylight:{
offset:630,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"ACDT"}}
,{
serverId:"Australia/Darwin",clientId:"Australia/Darwin",score:100,standard:{
offset:570}}
,{
serverId:"Asia/Magadan",clientId:"Asia/Magadan",score:100,standard:{
offset:600,tzname:"MAGT"}}
,{
serverId:"Asia/Vladivostok",clientId:"Asia/Vladivostok",score:100,standard:{
offset:600,tzname:"VLAT"}}
,{
serverId:"Australia/Brisbane",clientId:"Australia/Brisbane",score:200,standard:{
offset:600}}
,{
serverId:"Australia/Hobart",clientId:"Australia/Hobart",score:100,standard:{
offset:600,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"AEST"}
,daylight:{
offset:660,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"AEDT"}}
,{
serverId:"Australia/Sydney",clientId:"Australia/Sydney",score:200,standard:{
offset:600,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"AEST"}
,daylight:{
offset:660,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"AEDT"}}
,{
serverId:"Pacific/Guam",clientId:"Pacific/Guam",score:100,standard:{
offset:600,tzname:"ChST"}}
,{
serverId:"Asia/Srednekolymsk",clientId:"Asia/Srednekolymsk",score:100,standard:{
offset:660,tzname:"SRET"}}
,{
serverId:"Pacific/Bougainville",clientId:"Pacific/Bougainville",score:100,standard:{
offset:660,tzname:"BST"}}
,{
serverId:"Pacific/Guadalcanal",clientId:"Pacific/Guadalcanal",score:100,standard:{
offset:660,tzname:"SBT"}}
,{
serverId:"Asia/Kamchatka",clientId:"Asia/Kamchatka",score:100,standard:{
offset:720,tzname:"PETT"}}
,{
serverId:"Pacific/Auckland",clientId:"Pacific/Auckland",score:100,standard:{
offset:720,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"NZST"}
,daylight:{
offset:780,mon:9,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,9,30],tzname:"NZDT"}}
,{
serverId:"Pacific/Fiji",clientId:"Pacific/Fiji",score:100,standard:{
offset:720,mon:1,week:3,wkday:1,hour:3,min:0,sec:0,trans:[2018,1,21],tzname:"FJT"}
,daylight:{
offset:780,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"FJST"}}
,{
serverId:"Pacific/Apia",clientId:"Pacific/Apia",score:100,standard:{
offset:780,mon:4,week:1,wkday:1,hour:4,min:0,sec:0,trans:[2018,4,1],tzname:"WSST"}
,daylight:{
offset:840,mon:9,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,9,30],tzname:"WSDT"}}
,{
serverId:"Pacific/Tongatapu",clientId:"Pacific/Tongatapu",score:100,standard:{
offset:780}}
,{
serverId:"Pacific/Kiritimati",clientId:"Pacific/Kiritimati",score:100,standard:{
offset:840,tzname:"LINT"}}
];
