
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.Layer",{
init:function(t,e){
var i=this;
i.editor=t;
t.addCommand("mceInsertLayer",i._insertLayer,i);
t.addCommand("mceMoveForward",function(){
i._move(1)
}
);
t.addCommand("mceMoveBackward",function(){
i._move(-1)
}
);
t.addCommand("mceMakeAbsolute",function(){
i._toggleAbsolute()
}
);
t.addButton("moveforward",{
title:"layer.forward_desc",cmd:"mceMoveForward"}
);
t.addButton("movebackward",{
title:"layer.backward_desc",cmd:"mceMoveBackward"}
);
t.addButton("absolute",{
title:"layer.absolute_desc",cmd:"mceMakeAbsolute"}
);
t.addButton("insertlayer",{
title:"layer.insertlayer_desc",cmd:"mceInsertLayer"}
);
t.onInit.add(function(){
if(tinymce.isIE){
t.getDoc().execCommand("2D-Position",false,true)
}}
);
t.onNodeChange.add(i._nodeChange,i);
t.onVisualAid.add(i._visualAid,i)
}
,getInfo:function(){
return{
longname:"Layer",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/layer",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_nodeChange:function(t,i,o){
var s,n;
s=this._getParentLayer(o);
n=t.dom.getParent(o,"DIV,P,IMG");
if(!n){
i.setDisabled("absolute",1);
i.setDisabled("moveforward",1);
i.setDisabled("movebackward",1)
}else{
i.setDisabled("absolute",0);
i.setDisabled("moveforward",!s);
i.setDisabled("movebackward",!s);
i.setActive("absolute",s&&s.style.position.toLowerCase()=="absolute")
}}
,_visualAid:function(t,o,e){
var i=t.dom;
tinymce.each(i.select("div,p",o),function(a){
if(/^(absolute|relative|static)$/i.test(a.style.position)){
if(e){
i.addClass(a,"mceItemVisualAid")
}else{
i.removeClass(a,"mceItemVisualAid")
}}}
)
}
,_move:function(n){
var t=this.editor,r,s=[],l=this._getParentLayer(t.selection.getNode()),d=-1,o=-1,i;
i=[];
tinymce.walk(t.getBody(),function(e){
if(e.nodeType==1&&/^(absolute|relative|static)$/i.test(e.style.position)){
i.push(e)
}}
,"childNodes");
for(r=0;
r<i.length;
r++){
s[r]=i[r].style.zIndex?parseInt(i[r].style.zIndex):0;
if(d<0&&i[r]==l){
d=r
}}
if(n<0){
for(r=0;
r<s.length;
r++){
if(s[r]<s[d]){
o=r;
break
}}
if(o>-1){
i[d].style.zIndex=s[o];
i[o].style.zIndex=s[d]
}else{
if(s[d]>0){
i[d].style.zIndex=s[d]-1
}}}else{
for(r=0;
r<s.length;
r++){
if(s[r]>s[d]){
o=r;
break
}}
if(o>-1){
i[d].style.zIndex=s[o];
i[o].style.zIndex=s[d]
}else{
i[d].style.zIndex=s[d]+1
}}
t.execCommand("mceRepaint")
}
,_getParentLayer:function(e){
return this.editor.dom.getParent(e,function(t){
return t.nodeType==1&&/^(absolute|relative|static)$/i.test(t.style.position)
}
)
}
,_insertLayer:function(){
var t=this.editor,e=t.dom.getPos(t.dom.getParent(t.selection.getNode(),"*"));
t.dom.add(t.getBody(),"div",{
style:{
position:"absolute",left:e.x,top:(e.y>20?e.y:20),width:100,height:100}
,"class":"mceItemVisualAid"}
,t.selection.getContent()||t.getLang("layer.content"))
}
,_toggleAbsolute:function(){
var t=this.editor,e=this._getParentLayer(t.selection.getNode());
if(!e){
e=t.dom.getParent(t.selection.getNode(),"DIV,P,IMG")
}
if(e){
if(e.style.position.toLowerCase()=="absolute"){
t.dom.setStyles(e,{
position:"",left:"",top:"",width:"",height:""}
);
t.dom.removeClass(e,"mceItemVisualAid")
}else{
if(e.style.left==""){
e.style.left=20+"px"
}
if(e.style.top==""){
e.style.top=20+"px"
}
if(e.style.width==""){
e.style.width=e.width?(e.width+"px"):"100px"
}
if(e.style.height==""){
e.style.height=e.height?(e.height+"px"):"100px"
}
e.style.position="absolute";
t.addVisual(t.getBody())
}
t.execCommand("mceRepaint");
t.nodeChanged()
}}}
);
tinymce.PluginManager.add("layer",tinymce.plugins.Layer)
}
)();
