
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
var e=tinymce.each;
tinymce.create("tinymce.plugins.MediaPlugin",{
init:function(t,n){
var i=this;
i.editor=t;
i.url=n;
function a(s){
return/^(mceItemFlash|mceItemShockWave|mceItemWindowsMedia|mceItemQuickTime|mceItemRealMedia)$/.test(s.className)
}
t.onPreInit.add(function(){
t.serializer.addRules("param[name|value|_mce_value]")
}
);
t.addCommand("mceMedia",function(){
t.windowManager.open({
file:n+"/media.htm",width:430+parseInt(t.getLang("media.delta_width",0)),height:470+parseInt(t.getLang("media.delta_height",0)),inline:1}
,{
plugin_url:n}
)
}
);
t.addButton("media",{
title:"media.desc",cmd:"mceMedia"}
);
t.onNodeChange.add(function(r,l,s){
l.setActive("media",s.nodeName=="IMG"&&a(s))
}
);
t.onInit.add(function(){
var s={
mceItemFlash:"flash",mceItemShockWave:"shockwave",mceItemWindowsMedia:"windowsmedia",mceItemQuickTime:"quicktime",mceItemRealMedia:"realmedia"};
t.selection.onSetContent.add(function(){
i._spansToImgs(t.getBody())
}
);
t.selection.onBeforeSetContent.add(i._objectsToSpans,i);
if(t.settings.content_css!==false){
t.dom.loadCSS(n+"/css/content.css")
}
if(t.theme.onResolveName){
t.theme.onResolveName.add(function(l,r){
if(r.name=="img"){
e(s,function(h,c){
if(t.dom.hasClass(r.node,c)){
r.name=h;
r.title=t.dom.getAttrib(r.node,"title");
return false
}}
)
}}
)
}
if(t&&t.plugins.contextmenu){
t.plugins.contextmenu.onContextMenu.add(function(l,c,r){
if(r.nodeName=="IMG"&&/mceItem(Flash|ShockWave|WindowsMedia|QuickTime|RealMedia)/.test(r.className)){
c.add({
title:"media.edit",icon:"media",cmd:"mceMedia"}
)
}}
)
}}
);
t.onBeforeSetContent.add(i._objectsToSpans,i);
t.onSetContent.add(function(){
i._spansToImgs(t.getBody())
}
);
t.onPreProcess.add(function(l,s){
var r=l.dom;
if(s.set){
i._spansToImgs(s.node);
e(r.select("IMG",s.node),function(h){
var c;
if(a(h)){
c=i._parse(h.title);
r.setAttrib(h,"width",r.getAttrib(h,"width",c.width||100));
r.setAttrib(h,"height",r.getAttrib(h,"height",c.height||100))
}}
)
}
if(s.get){
e(r.select("IMG",s.node),function(h){
var c,u,d;
if(l.getParam("media_use_script")){
if(a(h)){
h.className=h.className.replace(/mceItem/g,"mceTemp")
}
return
}
switch(h.className){
case"mceItemFlash":c="d27cdb6e-ae6d-11cf-96b8-444553540000";
u="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0";
d="application/x-shockwave-flash";
break;
case"mceItemShockWave":c="166b1bca-3f9c-11cf-8075-444553540000";
u="http://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=8,5,1,0";
d="application/x-director";
break;
case"mceItemWindowsMedia":c=l.getParam("media_wmp6_compatible")?"05589fa1-c356-11ce-bf01-00aa0055595a":"6bf52a52-394a-11d3-b153-00c04f79faa6";
u="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701";
d="application/x-mplayer2";
break;
case"mceItemQuickTime":c="02bf25d5-8c17-4b23-bc80-d3488abddc6b";
u="http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0";
d="video/quicktime";
break;
case"mceItemRealMedia":c="cfcdaa03-8be4-11cf-b84b-0020afbbccfa";
u="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0";
d="audio/x-pn-realaudio-plugin";
break
}
if(c){
r.replace(i._buildObj({
classid:c,codebase:u,type:d}
,h),h)
}}
)
}}
);
t.onPostProcess.add(function(r,s){
s.content=s.content.replace(/_mce_value=/g,"value=")
}
);
function o(r,s){
s=new RegExp(s+'="([^"]+)"',"g").exec(r);
return s?t.dom.decode(s[1]):""
}
t.onPostProcess.add(function(r,s){
if(r.getParam("media_use_script")){
s.content=s.content.replace(/<img[^>]+>/g,function(h){
var l=o(h,"class");
if(/^(mceTempFlash|mceTempShockWave|mceTempWindowsMedia|mceTempQuickTime|mceTempRealMedia)$/.test(l)){
at=i._parse(o(h,"title"));
at.width=o(h,"width");
at.height=o(h,"height");
h='<script type="text/javascript">write'+l.substring(7)+"({"+i._serialize(at)+"});<\/script>"
}
return h
}
)
}}
)
}
,getInfo:function(){
return{
longname:"Media",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/media",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_objectsToSpans:function(t,a){
var o=this,i=a.content;
i=i.replace(/<script[^>]*>\s*write(Flash|ShockWave|WindowsMedia|QuickTime|RealMedia)\(\{([^\)]*)\}\);\s*<\/script>/gi,function(r,l,n){
var s=o._parse(n);
return'<img class="mceItem'+l+'" title="'+t.dom.encode(n)+'" src="'+o.url+'/img/trans.gif" width="'+s.width+'" height="'+s.height+'" />'
}
);
i=i.replace(/<object([^>]*)>/gi,'<span class="mceItemObject" $1>');
i=i.replace(/<embed([^>]*)\/?>/gi,'<span class="mceItemEmbed" $1></span>');
i=i.replace(/<embed([^>]*)>/gi,'<span class="mceItemEmbed" $1>');
i=i.replace(/<\/(object)([^>]*)>/gi,"</span>");
i=i.replace(/<\/embed>/gi,"");
i=i.replace(/<param([^>]*)>/gi,function(n,s){
return"<span "+s.replace(/value=/gi,"_mce_value=")+' class="mceItemParam"></span>'
}
);
i=i.replace(/\/ class=\"mceItemParam\"><\/span>/gi,'class="mceItemParam"></span>');
a.content=i
}
,_buildObj:function(i,a){
var s,r=this.editor,o=r.dom,n=this._parse(a.title),t;
t=r.getParam("media_strict",true)&&i.type=="application/x-shockwave-flash";
n.width=i.width=o.getAttrib(a,"width")||100;
n.height=i.height=o.getAttrib(a,"height")||100;
if(n.src){
n.src=r.convertURL(n.src,"src",a)
}
if(t){
s=o.create("span",{
id:n.id,mce_name:"object",type:"application/x-shockwave-flash",data:n.src,style:o.getAttrib(a,"style"),width:i.width,height:i.height}
)
}else{
s=o.create("span",{
id:n.id,mce_name:"object",classid:"clsid:"+i.classid,style:o.getAttrib(a,"style"),codebase:i.codebase,width:i.width,height:i.height}
)
}
e(n,function(h,l){
if(!/^(width|height|codebase|classid|id|_cx|_cy)$/.test(l)){
if(i.type=="application/x-mplayer2"&&l=="src"&&!n.url){
l="url"
}
if(h){
o.add(s,"span",{
mce_name:"param",name:l,_mce_value:h}
)
}}}
);
if(!t){
o.add(s,"span",tinymce.extend({
mce_name:"embed",type:i.type,style:o.getAttrib(a,"style")}
,n))
}
return s
}
,_spansToImgs:function(i){
var o=this,a=o.editor.dom,t,n;
e(a.select("span",i),function(s){
if(a.getAttrib(s,"class")=="mceItemObject"){
n=a.getAttrib(s,"classid").toLowerCase().replace(/\s+/g,"");
switch(n){
case"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000":a.replace(o._createImg("mceItemFlash",s),s);
break;
case"clsid:166b1bca-3f9c-11cf-8075-444553540000":a.replace(o._createImg("mceItemShockWave",s),s);
break;
case"clsid:6bf52a52-394a-11d3-b153-00c04f79faa6":case"clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95":case"clsid:05589fa1-c356-11ce-bf01-00aa0055595a":a.replace(o._createImg("mceItemWindowsMedia",s),s);
break;
case"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b":a.replace(o._createImg("mceItemQuickTime",s),s);
break;
case"clsid:cfcdaa03-8be4-11cf-b84b-0020afbbccfa":a.replace(o._createImg("mceItemRealMedia",s),s);
break;
default:a.replace(o._createImg("mceItemFlash",s),s)
}
return
}
if(a.getAttrib(s,"class")=="mceItemEmbed"){
switch(a.getAttrib(s,"type")){
case"application/x-shockwave-flash":a.replace(o._createImg("mceItemFlash",s),s);
break;
case"application/x-director":a.replace(o._createImg("mceItemShockWave",s),s);
break;
case"application/x-mplayer2":a.replace(o._createImg("mceItemWindowsMedia",s),s);
break;
case"video/quicktime":a.replace(o._createImg("mceItemQuickTime",s),s);
break;
case"audio/x-pn-realaudio-plugin":a.replace(o._createImg("mceItemRealMedia",s),s);
break;
default:a.replace(o._createImg("mceItemFlash",s),s)
}}}
)
}
,_createImg:function(r,a){
var t,i=this.editor.dom,o={}
,n="",s;
s=["id","name","width","height","bgcolor","align","flashvars","src","wmode","allowfullscreen","quality"];
t=i.create("img",{
src:this.url+"/img/trans.gif",width:i.getAttrib(a,"width")||100,height:i.getAttrib(a,"height")||100,style:i.getAttrib(a,"style"),"class":r}
);
e(s,function(l){
var h=i.getAttrib(a,l);
if(h){
o[l]=h
}}
);
e(i.select("span",a),function(h){
if(i.hasClass(h,"mceItemParam")){
o[i.getAttrib(h,"name")]=i.getAttrib(h,"_mce_value")
}}
);
if(o.movie){
o.src=o.movie;
delete o.movie
}
a=i.select(".mceItemEmbed",a)[0];
if(a){
e(s,function(l){
var h=i.getAttrib(a,l);
if(h&&!o[l]){
o[l]=h
}}
)
}
delete o.width;
delete o.height;
t.title=this._serialize(o);
return t
}
,_parse:function(t){
return tinymce.util.JSON.parse("{"+t+"}")
}
,_serialize:function(t){
return tinymce.util.JSON.serialize(t).replace(/[{}]/g,"")
}}
);
tinymce.PluginManager.add("media",tinymce.plugins.MediaPlugin)
}
)();
