
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(o){
var i=o.DOM,t=o.dom.Event,r=o.extend,n=o.each,e=o.util.Cookie,s,a=o.explode;
o.ThemeManager.requireLangPack("advanced");
o.create("tinymce.themes.AdvancedTheme",{
sizes:[8,10,12,14,18,24,36],controls:{
bold:["bold_desc","Bold"],italic:["italic_desc","Italic"],underline:["underline_desc","Underline"],strikethrough:["striketrough_desc","Strikethrough"],justifyleft:["justifyleft_desc","JustifyLeft"],justifycenter:["justifycenter_desc","JustifyCenter"],justifyright:["justifyright_desc","JustifyRight"],justifyfull:["justifyfull_desc","JustifyFull"],bullist:["bullist_desc","InsertUnorderedList"],numlist:["numlist_desc","InsertOrderedList"],outdent:["outdent_desc","Outdent"],indent:["indent_desc","Indent"],cut:["cut_desc","Cut"],copy:["copy_desc","Copy"],paste:["paste_desc","Paste"],undo:["undo_desc","Undo"],redo:["redo_desc","Redo"],link:["link_desc","mceLink"],unlink:["unlink_desc","unlink"],image:["image_desc","mceImage"],cleanup:["cleanup_desc","mceCleanup"],help:["help_desc","mceHelp"],code:["code_desc","mceCodeEditor"],hr:["hr_desc","InsertHorizontalRule"],removeformat:["removeformat_desc","RemoveFormat"],sub:["sub_desc","subscript"],sup:["sup_desc","superscript"],forecolor:["forecolor_desc","ForeColor"],forecolorpicker:["forecolor_desc","mceForeColor"],backcolor:["backcolor_desc","HiliteColor"],backcolorpicker:["backcolor_desc","mceBackColor"],charmap:["charmap_desc","mceCharMap"],visualaid:["visualaid_desc","mceToggleVisualAid"],anchor:["anchor_desc","mceInsertAnchor"],newdocument:["newdocument_desc","mceNewDocument"],blockquote:["blockquote_desc","mceBlockQuote"]}
,stateControls:["bold","italic","underline","strikethrough","bullist","numlist","justifyleft","justifycenter","justifyright","justifyfull","sub","sup","blockquote"],init:function(l,c){
var d=this,u,h,m;
d.editor=l;
d.url=c;
d.onResolveName=new o.util.Dispatcher(this);
d.settings=u=r({
theme_advanced_path:true,theme_advanced_toolbar_location:"bottom",theme_advanced_buttons1:"bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect",theme_advanced_buttons2:"bullist,numlist,|,outdent,indent,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code",theme_advanced_buttons3:"hr,removeformat,visualaid,|,sub,sup,|,charmap",theme_advanced_blockformats:"p,address,pre,h1,h2,h3,h4,h5,h6",theme_advanced_toolbar_align:"center",theme_advanced_fonts:"Andale Mono=andale mono,times;Arial=arial,helvetica,sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;Courier New=courier new,courier;Georgia=georgia,palatino;Helvetica=helvetica;Impact=impact,chicago;Symbol=symbol;Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal,monaco;Times New Roman=times new roman,times;Trebuchet MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;Wingdings=wingdings,zapf dingbats",theme_advanced_more_colors:1,theme_advanced_row_height:23,theme_advanced_resize_horizontal:1,theme_advanced_resizing_use_cookie:1,theme_advanced_font_sizes:"1,2,3,4,5,6,7",readonly:l.settings.readonly}
,l.settings);
if(!u.font_size_style_values){
u.font_size_style_values="8pt,10pt,12pt,14pt,18pt,24pt,36pt"
}
if(o.is(u.theme_advanced_font_sizes,"string")){
u.font_size_style_values=o.explode(u.font_size_style_values);
u.font_size_classes=o.explode(u.font_size_classes||"");
m={};
l.settings.theme_advanced_font_sizes=u.theme_advanced_font_sizes;
n(l.getParam("theme_advanced_font_sizes","","hash"),function(g,p){
var f;
if(p==g&&g>=1&&g<=7){
p=g+" ("+d.sizes[g-1]+"pt)";
if(l.settings.convert_fonts_to_spans){
f=u.font_size_classes[g-1];
g=u.font_size_style_values[g-1]||(d.sizes[g-1]+"pt")
}}
if(/^\s*\./.test(g)){
f=g.replace(/\./g,"")
}
m[p]=f?{
"class":f}
:{
fontSize:g}
}
);
u.theme_advanced_font_sizes=m
}
if((h=u.theme_advanced_path_location)&&h!="none"){
u.theme_advanced_statusbar_location=u.theme_advanced_path_location
}
if(u.theme_advanced_statusbar_location=="none"){
u.theme_advanced_statusbar_location=0
}
l.onInit.add(function(){
l.onNodeChange.add(d._nodeChanged,d);
if(l.settings.content_css!==false){
l.dom.loadCSS(l.baseURI.toAbsolute("themes/advanced/skins/"+l.settings.skin+"/content.css"))
}}
);
l.onSetProgressState.add(function(g,f,y){
var w,v=g.id,p;
if(f){
d.progressTimer=setTimeout(function(){
w=g.getContainer();
w=w.insertBefore(i.create("DIV",{
style:"position:relative"}
),w.firstChild);
p=i.get(g.id+"_tbl");
i.add(w,"div",{
id:v+"_blocker","class":"mceBlocker",style:{
width:p.clientWidth+2,height:p.clientHeight+2}}
);
i.add(w,"div",{
id:v+"_progress","class":"mceProgress",style:{
left:p.clientWidth/2,top:p.clientHeight/2}}
)
}
,y||0)
}else{
i.remove(v+"_blocker");
i.remove(v+"_progress");
clearTimeout(d.progressTimer)
}}
);
i.loadCSS(u.editor_css?l.documentBaseURI.toAbsolute(u.editor_css):c+"/skins/"+l.settings.skin+"/ui.css");
if(u.skin_variant){
i.loadCSS(c+"/skins/"+l.settings.skin+"/ui_"+u.skin_variant+".css")
}}
,createControl:function(u,h){
var l,d;
if(d=h.createControl(u)){
return d
}
switch(u){
case"styleselect":return this._createStyleSelect();
case"formatselect":return this._createBlockFormats();
case"fontselect":return this._createFontSelect();
case"fontsizeselect":return this._createFontSizeSelect();
case"forecolor":return this._createForeColorMenu();
case"backcolor":return this._createBackColorMenu()
}
if((l=this.controls[u])){
return h.createButton(u,{
title:"advanced."+l[0],cmd:l[1],ui:l[2],value:l[3]}
)
}}
,execCommand:function(c,l,d){
var h=this["_"+c];
if(h){
h.call(this,l,d);
return true
}
return false
}
,_importClasses:function(l){
var h=this.editor,d=h.controlManager.get("styleselect");
if(d.getLength()==0){
n(h.dom.getClasses(),function(c){
d.add(c["class"],c["class"])
}
)
}}
,_createStyleSelect:function(m){
var l=this,h=l.editor,d=h.controlManager,u=d.createListBox("styleselect",{
title:"advanced.style_select",onselect:function(c){
if(u.selectedValue===c){
h.execCommand("mceSetStyleInfo",0,{
command:"removeformat"}
);
u.select();
return false
}else{
h.execCommand("mceSetCSSClass",0,c)
}}}
);
if(u){
n(h.getParam("theme_advanced_styles","","hash"),function(f,c){
if(f){
u.add(l.editor.translate(c),f)
}}
);
u.onPostRender.add(function(c,f){
if(!u.NativeListBox){
t.add(f.id+"_text","focus",l._importClasses,l);
t.add(f.id+"_text","mousedown",l._importClasses,l);
t.add(f.id+"_open","focus",l._importClasses,l);
t.add(f.id+"_open","mousedown",l._importClasses,l)
}else{
t.add(f.id,"focus",l._importClasses,l)
}}
)
}
return u
}
,_createFontSelect:function(){
var d,l=this,h=l.editor;
d=h.controlManager.createListBox("fontselect",{
title:"advanced.fontdefault",cmd:"FontName"}
);
if(d){
n(h.getParam("theme_advanced_fonts",l.settings.theme_advanced_fonts,"hash"),function(u,c){
d.add(h.translate(c),u,{
style:u.indexOf("dings")==-1?"font-family:"+u:""}
)
}
)
}
return d
}
,_createFontSizeSelect:function(){
var u=this,l=u.editor,m,d=0,h=[];
m=l.controlManager.createListBox("fontsizeselect",{
title:"advanced.font_size",onselect:function(c){
if(c.fontSize){
l.execCommand("FontSize",false,c.fontSize)
}else{
n(u.settings.theme_advanced_font_sizes,function(p,f){
if(p["class"]){
h.push(p["class"])
}}
);
l.editorCommands._applyInlineStyle("span",{
"class":c["class"]}
,{
check_classes:h}
)
}}}
);
if(m){
n(u.settings.theme_advanced_font_sizes,function(f,c){
var p=f.fontSize;
if(p>=1&&p<=7){
p=u.sizes[parseInt(p)-1]+"pt"
}
m.add(c,f,{
style:"font-size:"+p,"class":"mceFontSize"+(d++)+(" "+(f["class"]||""))}
)
}
)
}
return m
}
,_createBlockFormats:function(){
var d,h={
p:"advanced.paragraph",address:"advanced.address",pre:"advanced.pre",h1:"advanced.h1",h2:"advanced.h2",h3:"advanced.h3",h4:"advanced.h4",h5:"advanced.h5",h6:"advanced.h6",div:"advanced.div",blockquote:"advanced.blockquote",code:"advanced.code",dt:"advanced.dt",dd:"advanced.dd",samp:"advanced.samp"}
,l=this;
d=l.editor.controlManager.createListBox("formatselect",{
title:"advanced.block",cmd:"FormatBlock"}
);
if(d){
n(l.editor.getParam("theme_advanced_blockformats",l.settings.theme_advanced_blockformats,"hash"),function(u,c){
d.add(l.editor.translate(c!=u?c:h[u]),u,{
"class":"mce_formatPreview mce_"+u}
)
}
)
}
return d
}
,_createForeColorMenu:function(){
var m,l=this,d=l.settings,u={}
,h;
if(d.theme_advanced_more_colors){
u.more_colors_func=function(){
l._mceColorPicker(0,{
color:m.value,func:function(c){
m.setColor(c)
}}
)
}
}
if(h=d.theme_advanced_text_colors){
u.colors=h
}
if(d.theme_advanced_default_foreground_color){
u.default_color=d.theme_advanced_default_foreground_color
}
u.title="advanced.forecolor_desc";
u.cmd="ForeColor";
u.scope=this;
m=l.editor.controlManager.createColorSplitButton("forecolor",u);
return m
}
,_createBackColorMenu:function(){
var m,l=this,d=l.settings,u={}
,h;
if(d.theme_advanced_more_colors){
u.more_colors_func=function(){
l._mceColorPicker(0,{
color:m.value,func:function(c){
m.setColor(c)
}}
)
}
}
if(h=d.theme_advanced_background_colors){
u.colors=h
}
if(d.theme_advanced_default_background_color){
u.default_color=d.theme_advanced_default_background_color
}
u.title="advanced.backcolor_desc";
u.cmd="HiliteColor";
u.scope=this;
m=l.editor.controlManager.createColorSplitButton("backcolor",u);
return m
}
,renderUI:function(c){
var u,d,m,y=this,f=y.editor,b=y.settings,g,l,h;
u=l=i.create("span",{
id:f.id+"_parent","class":"mceEditor "+f.settings.skin+"Skin"+(b.skin_variant?" "+f.settings.skin+"Skin"+y._ufirst(b.skin_variant):"")}
);
if(!i.boxModel){
u=i.add(u,"div",{
"class":"mceOldBoxModel"}
)
}
u=g=i.add(u,"table",{
id:f.id+"_tbl","class":"mceLayout",cellSpacing:0,cellPadding:0}
);
u=m=i.add(u,"tbody");
switch((b.theme_advanced_layout_manager||"").toLowerCase()){
case"rowlayout":d=y._rowLayout(b,m,c);
break;
case"customlayout":d=f.execCallback("theme_advanced_custom_layout",b,m,c,l);
break;
default:d=y._simpleLayout(b,m,c,l)
}
u=c.targetNode;
h=i.stdMode?g.getElementsByTagName("tr"):g.rows;
i.addClass(h[0],"mceFirst");
i.addClass(h[h.length-1],"mceLast");
n(i.select("tr",m),function(p){
i.addClass(p.firstChild,"mceFirst");
i.addClass(p.childNodes[p.childNodes.length-1],"mceLast")
}
);
if(i.get(b.theme_advanced_toolbar_container)){
i.get(b.theme_advanced_toolbar_container).appendChild(l)
}else{
i.insertAfter(l,u)
}
t.add(f.id+"_path_row","click",function(p){
p=p.target;
if(p.nodeName=="A"){
y._sel(p.className.replace(/^.*mcePath_([0-9]+).*$/,"$1"));
return t.cancel(p)
}}
);
if(!f.getParam("accessibility_focus")){
t.add(i.add(l,"a",{
href:"#"}
,"<!-- IE -->"),"focus",function(){
tinyMCE.get(f.id).focus()
}
)
}
if(b.theme_advanced_toolbar_location=="external"){
c.deltaHeight=0
}
y.deltaHeight=c.deltaHeight;
c.targetNode=null;
return{
iframeContainer:d,editorContainer:f.id+"_parent",sizeContainer:g,deltaHeight:c.deltaHeight}
}
,getInfo:function(){
return{
longname:"Advanced theme",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",version:o.majorVersion+"."+o.minorVersion}
}
,resizeBy:function(h,l){
var c=i.get(this.editor.id+"_tbl");
this.resizeTo(c.clientWidth+h,c.clientHeight+l)
}
,resizeTo:function(l,u){
var c=this.editor,d=c.settings,f=i.get(c.id+"_tbl"),p=i.get(c.id+"_ifr"),m;
l=Math.max(d.theme_advanced_resizing_min_width||100,l);
u=Math.max(d.theme_advanced_resizing_min_height||100,u);
l=Math.min(d.theme_advanced_resizing_max_width||65535,l);
u=Math.min(d.theme_advanced_resizing_max_height||65535,u);
m=f.clientHeight-p.clientHeight;
i.setStyle(p,"height",u-m);
i.setStyles(f,{
width:l,height:u}
)
}
,destroy:function(){
var h=this.editor.id;
t.clear(h+"_resize");
t.clear(h+"_path_row");
t.clear(h+"_external_close")
}
,_simpleLayout:function(k,g,d,h){
var v=this,y=v.editor,b=k.theme_advanced_toolbar_location,m=k.theme_advanced_statusbar_location,u,l,f,w;
if(k.readonly){
u=i.add(g,"tr");
u=l=i.add(u,"td",{
"class":"mceIframeContainer"}
);
return l
}
if(b=="top"){
v._addToolbars(g,d)
}
if(b=="external"){
u=w=i.create("div",{
style:"position:relative"}
);
u=i.add(u,"div",{
id:y.id+"_external","class":"mceExternalToolbar"}
);
i.add(u,"a",{
id:y.id+"_external_close",href:"javascript:;","class":"mceExternalClose"}
);
u=i.add(u,"table",{
id:y.id+"_tblext",cellSpacing:0,cellPadding:0}
);
f=i.add(u,"tbody");
if(h.firstChild.className=="mceOldBoxModel"){
h.firstChild.appendChild(w)
}else{
h.insertBefore(w,h.firstChild)
}
v._addToolbars(f,d);
y.onMouseUp.add(function(){
var p=i.get(y.id+"_external");
i.show(p);
i.hide(s);
var c=t.add(y.id+"_external_close","click",function(){
i.hide(y.id+"_external");
t.remove(y.id+"_external_close","click",c)
}
);
i.show(p);
i.setStyle(p,"top",0-i.getRect(y.id+"_tblext").h-1);
i.hide(p);
i.show(p);
p.style.filter="";
s=y.id+"_external";
p=null
}
)
}
if(m=="top"){
v._addStatusBar(g,d)
}
if(!k.theme_advanced_toolbar_container){
u=i.add(g,"tr");
u=l=i.add(u,"td",{
"class":"mceIframeContainer"}
)
}
if(b=="bottom"){
v._addToolbars(g,d)
}
if(m=="bottom"){
v._addStatusBar(g,d)
}
return l
}
,_rowLayout:function(b,u,c){
var y=this,m=y.editor,g,w,h=m.controlManager,d,l,p,f;
g=b.theme_advanced_containers_default_class||"";
w=b.theme_advanced_containers_default_align||"center";
n(a(b.theme_advanced_containers||""),function(q,x){
var k=b["theme_advanced_container_"+q]||"";
switch(k.toLowerCase()){
case"mceeditor":d=i.add(u,"tr");
d=l=i.add(d,"td",{
"class":"mceIframeContainer"}
);
break;
case"mceelementpath":y._addStatusBar(u,c);
break;
default:f=(b["theme_advanced_container_"+q+"_align"]||w).toLowerCase();
f="mce"+y._ufirst(f);
d=i.add(i.add(u,"tr"),"td",{
"class":"mceToolbar "+(b["theme_advanced_container_"+q+"_class"]||g)+" "+f||w}
);
p=h.createToolbar("toolbar"+x);
y._addControls(k,p);
i.setHTML(d,p.renderHTML());
c.deltaHeight-=b.theme_advanced_row_height
}}
);
return l
}
,_addControls:function(l,h){
var c=this,d=c.settings,u,m=c.editor.controlManager;
if(d.theme_advanced_disable&&!c._disabled){
u={};
n(a(d.theme_advanced_disable),function(f){
u[f]=1
}
);
c._disabled=u
}else{
u=c._disabled
}
n(a(l),function(p){
var f;
if(u&&u[p]){
return
}
if(p=="tablecontrols"){
n(["table","|","row_props","cell_props","|","row_before","row_after","delete_row","|","col_before","col_after","delete_col","|","split_cells","merge_cells"],function(g){
g=c.createControl(g,m);
if(g){
h.add(g)
}}
);
return
}
f=c.createControl(p,m);
if(f){
h.add(f)
}}
)
}
,_addToolbars:function(b,d){
var x=this,f,m,g=x.editor,q=x.settings,k,l=g.controlManager,y,u,p=[],w;
w=q.theme_advanced_toolbar_align.toLowerCase();
w="mce"+x._ufirst(w);
u=i.add(i.add(b,"tr"),"td",{
"class":"mceToolbar "+w}
);
if(!g.getParam("accessibility_focus")){
p.push(i.createHTML("a",{
href:"#",onfocus:"tinyMCE.get('"+g.id+"').focus();"}
,"<!-- IE -->"))
}
p.push(i.createHTML("a",{
href:"#",accesskey:"q",title:g.getLang("advanced.toolbar_focus")}
,"<!-- IE -->"));
for(f=1;
(k=q["theme_advanced_buttons"+f]);
f++){
m=l.createToolbar("toolbar"+f,{
"class":"mceToolbarRow"+f}
);
if(q["theme_advanced_buttons"+f+"_add"]){
k+=","+q["theme_advanced_buttons"+f+"_add"]
}
if(q["theme_advanced_buttons"+f+"_add_before"]){
k=q["theme_advanced_buttons"+f+"_add_before"]+","+k
}
x._addControls(k,m);
p.push(m.renderHTML());
d.deltaHeight-=q.theme_advanced_row_height
}
p.push(i.createHTML("a",{
href:"#",accesskey:"z",title:g.getLang("advanced.toolbar_focus"),onfocus:"tinyMCE.getInstanceById('"+g.id+"').focus();"}
,"<!-- IE -->"));
i.setHTML(u,p.join(""))
}
,_addStatusBar:function(u,l){
var c,g=this,m=g.editor,y=g.settings,h,f,p,d;
c=i.add(u,"tr");
c=d=i.add(c,"td",{
"class":"mceStatusbar"}
);
c=i.add(c,"div",{
id:m.id+"_path_row"}
,y.theme_advanced_path?m.translate("advanced.path")+": ":"&#160;");
i.add(c,"a",{
href:"#",accesskey:"x"}
);
if(y.theme_advanced_resizing){
i.add(d,"a",{
id:m.id+"_resize",href:"javascript:;",onclick:"return false;","class":"mceResize"}
);
if(y.theme_advanced_resizing_use_cookie){
m.onPostRender.add(function(){
var b=e.getHash("TinyMCE_"+m.id+"_size"),w=i.get(m.id+"_tbl");
if(!b){
return
}
if(y.theme_advanced_resize_horizontal){
w.style.width=Math.max(10,b.cw)+"px"
}
w.style.height=Math.max(10,b.ch)+"px";
i.get(m.id+"_ifr").style.height=Math.max(10,parseInt(b.ch)+g.deltaHeight)+"px"
}
)
}
m.onPostRender.add(function(){
t.add(m.id+"_resize","mousedown",function(q){
var z,x,b,k,j,v;
z=i.get(m.id+"_tbl");
b=z.clientWidth;
k=z.clientHeight;
miw=y.theme_advanced_resizing_min_width||100;
mih=y.theme_advanced_resizing_min_height||100;
maw=y.theme_advanced_resizing_max_width||65535;
mah=y.theme_advanced_resizing_max_height||65535;
x=i.add(i.get(m.id+"_parent"),"div",{
"class":"mcePlaceHolder"}
);
i.setStyles(x,{
width:b,height:k}
);
i.hide(z);
i.show(x);
h={
x:q.screenX,y:q.screenY,w:b,h:k,dx:null,dy:null};
f=t.add(i.doc,"mousemove",function(A){
var T,O;
h.dx=A.screenX-h.x;
h.dy=A.screenY-h.y;
T=Math.max(miw,h.w+h.dx);
O=Math.max(mih,h.h+h.dy);
T=Math.min(maw,T);
O=Math.min(mah,O);
if(y.theme_advanced_resize_horizontal){
x.style.width=T+"px"
}
x.style.height=O+"px";
return t.cancel(A)
}
);
p=t.add(i.doc,"mouseup",function(w){
var T;
t.remove(i.doc,"mousemove",f);
t.remove(i.doc,"mouseup",p);
z.style.display="";
i.remove(x);
if(h.dx===null){
return
}
T=i.get(m.id+"_ifr");
if(y.theme_advanced_resize_horizontal){
z.style.width=Math.max(10,h.w+h.dx)+"px"
}
z.style.height=Math.max(10,h.h+h.dy)+"px";
T.style.height=Math.max(10,T.clientHeight+h.dy)+"px";
if(y.theme_advanced_resizing_use_cookie){
e.setHash("TinyMCE_"+m.id+"_size",{
cw:h.w+h.dx,ch:h.h+h.dy}
)
}}
);
return t.cancel(q)
}
)
}
)
}
l.deltaHeight-=21;
c=u=null
}
,_nodeChanged:function(u,b,d,g){
var x=this,h,y=0,k,m,q=x.settings,w,l,f;
if(q.readonly){
return
}
o.each(x.stateControls,function(p){
b.setActive(p,u.queryCommandState(x.controls[p][1]))
}
);
b.setActive("visualaid",u.hasVisual);
b.setDisabled("undo",!u.undoManager.hasUndo()&&!u.typing);
b.setDisabled("redo",!u.undoManager.hasRedo());
b.setDisabled("outdent",!u.queryCommandState("Outdent"));
h=i.getParent(d,"A");
if(m=b.get("link")){
if(!h||!h.name){
m.setDisabled(!h&&g);
m.setActive(!!h)
}}
if(m=b.get("unlink")){
m.setDisabled(!h&&g);
m.setActive(!!h&&!h.name)
}
if(m=b.get("anchor")){
m.setActive(!!h&&h.name);
if(o.isWebKit){
h=i.getParent(d,"IMG");
m.setActive(!!h&&i.getAttrib(h,"mce_name")=="a")
}}
h=i.getParent(d,"IMG");
if(m=b.get("image")){
m.setActive(!!h&&d.className.indexOf("mceItem")==-1)
}
if(m=b.get("styleselect")){
if(d.className){
x._importClasses();
m.select(d.className)
}else{
m.select()
}}
if(m=b.get("formatselect")){
h=i.getParent(d,i.isBlock);
if(h){
m.select(h.nodeName.toLowerCase())
}}
if(u.settings.convert_fonts_to_spans){
u.dom.getParent(d,function(c){
if(c.nodeName==="SPAN"){
if(!w&&c.className){
w=c.className
}
if(!l&&c.style.fontSize){
l=c.style.fontSize
}
if(!f&&c.style.fontFamily){
f=c.style.fontFamily.replace(/[\"\']+/g,"").replace(/^([^,]+).*/,"$1").toLowerCase()
}}
return false
}
);
if(m=b.get("fontselect")){
m.select(function(c){
return c.replace(/^([^,]+).*/,"$1").toLowerCase()==f
}
)
}
if(m=b.get("fontsizeselect")){
m.select(function(c){
if(c.fontSize&&c.fontSize===l){
return true
}
if(c["class"]&&c["class"]===w){
return true
}}
)
}}else{
if(m=b.get("fontselect")){
m.select(u.queryCommandValue("FontName"))
}
if(m=b.get("fontsizeselect")){
k=u.queryCommandValue("FontSize");
m.select(function(c){
return c.fontSize==k
}
)
}}
if(q.theme_advanced_path&&q.theme_advanced_statusbar_location){
h=i.get(u.id+"_path")||i.add(u.id+"_path_row","span",{
id:u.id+"_path"}
);
i.setHTML(h,"");
u.dom.getParent(d,function(z){
var c=z.nodeName.toLowerCase(),p,j,v="";
if(z.nodeType!=1||z.nodeName==="BR"||(i.hasClass(z,"mceItemHidden")||i.hasClass(z,"mceItemRemoved"))){
return
}
if(k=i.getAttrib(z,"mce_name")){
c=k
}
if(o.isIE&&z.scopeName!=="HTML"){
c=z.scopeName+":"+c
}
c=c.replace(/mce\:/g,"");
switch(c){
case"b":c="strong";
break;
case"i":c="em";
break;
case"img":if(k=i.getAttrib(z,"src")){
v+="src: "+k+" "
}
break;
case"a":if(k=i.getAttrib(z,"name")){
v+="name: "+k+" ";
c+="#"+k
}
if(k=i.getAttrib(z,"href")){
v+="href: "+k+" "
}
break;
case"font":if(q.convert_fonts_to_spans){
c="span"
}
if(k=i.getAttrib(z,"face")){
v+="font: "+k+" "
}
if(k=i.getAttrib(z,"size")){
v+="size: "+k+" "
}
if(k=i.getAttrib(z,"color")){
v+="color: "+k+" "
}
break;
case"span":if(k=i.getAttrib(z,"style")){
v+="style: "+k+" "
}
break
}
if(k=i.getAttrib(z,"id")){
v+="id: "+k+" "
}
if(k=z.className){
k=k.replace(/(webkit-[\w\-]+|Apple-[\w\-]+|mceItem\w+|mceVisualAid)/g,"");
if(k&&k.indexOf("mceItem")==-1){
v+="class: "+k+" ";
if(i.isBlock(z)||c=="img"||c=="span"){
c+="."+k
}}}
c=c.replace(/(html:)/g,"");
c={
name:c,node:z,title:v};
x.onResolveName.dispatch(x,c);
v=c.title;
c=c.name;
j=i.create("a",{
href:"javascript:;",onmousedown:"return false;",title:v,"class":"mcePath_"+(y++)}
,c);
if(h.hasChildNodes()){
h.insertBefore(i.doc.createTextNode(" \u00bb "),h.firstChild);
h.insertBefore(j,h.firstChild)
}else{
h.appendChild(j)
}}
,u.getBody())
}}
,_sel:function(h){
this.editor.execCommand("mceSelectNodeDepth",false,h)
}
,_mceInsertAnchor:function(c,l){
var h=this.editor;
h.windowManager.open({
url:o.baseURL+"/themes/advanced/anchor.htm",width:320+parseInt(h.getLang("advanced.anchor_delta_width",0)),height:90+parseInt(h.getLang("advanced.anchor_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceCharMap:function(){
var h=this.editor;
h.windowManager.open({
url:o.baseURL+"/themes/advanced/charmap.htm",width:550+parseInt(h.getLang("advanced.charmap_delta_width",0)),height:250+parseInt(h.getLang("advanced.charmap_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceHelp:function(){
var h=this.editor;
h.windowManager.open({
url:o.baseURL+"/themes/advanced/about.htm",width:480,height:380,inline:true}
,{
theme_url:this.url}
)
}
,_mceColorPicker:function(c,l){
var h=this.editor;
l=l||{};
h.windowManager.open({
url:o.baseURL+"/themes/advanced/color_picker.htm",width:375+parseInt(h.getLang("advanced.colorpicker_delta_width",0)),height:250+parseInt(h.getLang("advanced.colorpicker_delta_height",0)),close_previous:false,inline:true}
,{
input_color:l.color,func:l.func,theme_url:this.url}
)
}
,_mceCodeEditor:function(l,c){
var h=this.editor;
h.windowManager.open({
url:o.baseURL+"/themes/advanced/source_editor.htm",width:parseInt(h.getParam("theme_advanced_source_editor_width",720)),height:parseInt(h.getParam("theme_advanced_source_editor_height",580)),inline:true,resizable:true,maximizable:true}
,{
theme_url:this.url}
)
}
,_mceImage:function(l,c){
var h=this.editor;
if(h.dom.getAttrib(h.selection.getNode(),"class").indexOf("mceItem")!=-1){
return
}
h.windowManager.open({
url:o.baseURL+"/themes/advanced/image.htm",width:355+parseInt(h.getLang("advanced.image_delta_width",0)),height:275+parseInt(h.getLang("advanced.image_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceLink:function(l,c){
var h=this.editor;
h.windowManager.open({
url:o.baseURL+"/themes/advanced/link.htm",width:310+parseInt(h.getLang("advanced.link_delta_width",0)),height:200+parseInt(h.getLang("advanced.link_delta_height",0)),inline:true}
,{
theme_url:this.url}
)
}
,_mceNewDocument:function(){
var h=this.editor;
h.windowManager.confirm("advanced.newdocument",function(l){
if(l){
h.execCommand("mceSetContent",false,"")
}}
)
}
,_mceForeColor:function(){
var h=this;
this._mceColorPicker(0,{
color:h.fgColor,func:function(l){
h.fgColor=l;
h.editor.execCommand("ForeColor",false,l)
}}
)
}
,_mceBackColor:function(){
var h=this;
this._mceColorPicker(0,{
color:h.bgColor,func:function(l){
h.bgColor=l;
h.editor.execCommand("HiliteColor",false,l)
}}
)
}
,_ufirst:function(h){
return h.substring(0,1).toUpperCase()+h.substring(1)
}}
);
o.ThemeManager.add("advanced",o.themes.AdvancedTheme)
}
(tinymce));
