package org.apache.jsp.tag.web;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import java.io.*;
import java.util.*;
import com.zimbra.webClient.servlet.SkinResources;

public final class imginfo_tag
    extends javax.servlet.jsp.tagext.SimpleTagSupport
    implements org.apache.jasper.runtime.JspSourceDependent {



static final String V_NO_SKIN = "<noskin>";

static File getImageSrc(File appdir, String src, Locale locale) {
    File file = new File(appdir, src);
    String filename = file.getName();
    File dir = file.getParentFile();
    String dirname = dir.getName();
    File dirdir = dir.getParentFile();
    if (!file.exists()) {
        File zfile = new File(dir.getParentFile(), "zimbra/"+file.getName());
        if (zfile.exists()) {
            file = zfile;
        }
    }
    Locale[] locales = locale.getCountry() != null
                     ? new Locale[] { locale, new Locale(locale.getLanguage()) }
                     : new Locale[] { locale };
    for (Locale loc : locales) {
        File locdir = new File(dirdir, dirname+"_"+loc);
        File locfile = new File(locdir, filename);
        if (locfile.exists()) {
            return locfile;
        }
    }
    return file;
}

static private org.apache.jasper.runtime.ProtectedFunctionMapper _jspx_fnmap_0;

static {
  _jspx_fnmap_0= org.apache.jasper.runtime.ProtectedFunctionMapper.getMapForFunction("zm:getMailURL", com.zimbra.cs.taglib.bean.BeanUtils.class, "getMailURL", new Class[] {javax.servlet.jsp.PageContext.class});
}

  private static final JspFactory _jspxFactory = JspFactory.getDefaultFactory();

  private static java.util.Vector _jspx_dependants;

  private JspContext jspContext;
  private java.io.Writer _jspx_sout;
  private org.apache.jasper.runtime.TagHandlerPool _jspx_tagPool_c_set_var_value_nobody;

  private org.apache.jasper.runtime.ResourceInjector _jspx_resourceInjector;

  public void setJspContext(JspContext ctx, java.util.Map aliasMap) {
    super.setJspContext(ctx);
    java.util.ArrayList _jspx_nested = null;
    java.util.ArrayList _jspx_at_begin = null;
    java.util.ArrayList _jspx_at_end = null;
    _jspx_at_end = new java.util.ArrayList();
    _jspx_at_end.add("info");
    this.jspContext = new org.apache.jasper.runtime.JspContextWrapper(ctx, _jspx_nested, _jspx_at_begin, _jspx_at_end, aliasMap);
  }

  public JspContext getJspContext() {
    return this.jspContext;
  }
  private java.lang.String var;
  private java.lang.String value;

  public java.lang.String getVar() {
    return this.var;
  }

  public void setVar(java.lang.String var) {
    this.var = var;
  }

  public java.lang.String getValue() {
    return this.value;
  }

  public void setValue(java.lang.String value) {
    this.value = value;
  }

  public Object getDependants() {
    return _jspx_dependants;
  }

  private void _jspInit(ServletConfig config) {
    _jspx_tagPool_c_set_var_value_nobody = org.apache.jasper.runtime.TagHandlerPool.getTagHandlerPool(config);
  }

  public void _jspDestroy() {
    _jspx_tagPool_c_set_var_value_nobody.release();
  }

  public void doTag() throws JspException, java.io.IOException {
    PageContext _jspx_page_context = (PageContext)jspContext;
    HttpServletRequest request = (HttpServletRequest) _jspx_page_context.getRequest();
    HttpServletResponse response = (HttpServletResponse) _jspx_page_context.getResponse();
    HttpSession session = _jspx_page_context.getSession();
    ServletContext application = _jspx_page_context.getServletContext();
    ServletConfig config = _jspx_page_context.getServletConfig();
    JspWriter out = jspContext.getOut();
    _jspInit(config);
    if( getVar() != null ) {
      _jspx_page_context.setAttribute("var", getVar());
}
    if( getValue() != null ) {
      _jspx_page_context.setAttribute("value", getValue());
}

    try {
      if (_jspx_meth_fmt_getLocale_0(_jspx_page_context))
        return;

PageContext pageContext = (PageContext)getJspContext();

      if (_jspx_meth_c_set_0(_jspx_page_context))
        return;
      if (_jspx_meth_c_set_1(_jspx_page_context))
        return;

// generate cache-id
String skin = (String)pageContext.findAttribute("skin");
if (skin == null) skin = V_NO_SKIN;
Locale locale = (Locale)pageContext.findAttribute("locale");
if (locale == null) locale = Locale.US;
String cacheId = skin + ":" + locale + ":" + value;

// get cache from SkinResources' servlet context
Map<String,SkinResources.ImageInfo> cache = null;
synchronized (this) {
    // NOTE: The context URL *must* be one serviced by SkinResources.
    String contextURL = (String)pageContext.getAttribute("contextURL");
    ServletContext resources = pageContext.getServletContext().getContext(contextURL);
    if (resources != null) {
        cache = (Map<String,SkinResources.ImageInfo>)resources.getAttribute(SkinResources.A_IMAGE_CACHE);
        if (cache == null) {
            cache = new HashMap<String,SkinResources.ImageInfo>();
            resources.setAttribute(SkinResources.A_IMAGE_CACHE, cache);
        }
    }
    else {
       // Initialize the cache for future references
       if (cache == null)
            cache = new HashMap<String,SkinResources.ImageInfo>();
    }
}

// find image
SkinResources.ImageInfo info = cache.get(cacheId);
if (info == null) {
    String iconPath = null;
    if (!value.startsWith("/")) {
        iconPath = (String)pageContext.findAttribute("iconPath");
        if (iconPath == null) iconPath = "/img";
        if (iconPath.endsWith("/")) iconPath = iconPath.substring(0, iconPath.length() - 1);
    }
    String imageSrc = iconPath != null ? iconPath+"/"+value : value;

    // find image
    ServletContext servletContext = pageContext.getServletContext();
    File basedir = new File(servletContext.getRealPath("/"));
    File imageFile = getImageSrc(basedir, imageSrc, locale);
    imageSrc = imageFile.getAbsolutePath().substring(basedir.getAbsolutePath().length());
    imageSrc = imageSrc.replace(File.separatorChar, '/');

    // save so we don't have to do this again
    info = new SkinResources.ImageInfo(imageFile, imageSrc);
    cache.put(cacheId, info);
}

// store image info in page context
pageContext.setAttribute("info", info, PageContext.PAGE_SCOPE);

    } catch( Throwable t ) {
      if( t instanceof SkipPageException )
          throw (SkipPageException) t;
      if( t instanceof java.io.IOException )
          throw (java.io.IOException) t;
      if( t instanceof IllegalStateException )
          throw (IllegalStateException) t;
      if( t instanceof JspException )
          throw (JspException) t;
      throw new JspException(t);
    } finally {
      ((org.apache.jasper.runtime.JspContextWrapper) jspContext).syncEndTagFile();
      _jspDestroy();
    }
  }

  private boolean _jspx_meth_fmt_getLocale_0(PageContext _jspx_page_context)
          throws Throwable {
    JspWriter out = _jspx_page_context.getOut();
    //  fmt:getLocale
    com.zimbra.cs.taglib.tag.i18n.GetLocaleTag _jspx_th_fmt_getLocale_0 = new com.zimbra.cs.taglib.tag.i18n.GetLocaleTag();
    if (_jspx_resourceInjector != null) {
      _jspx_resourceInjector.inject(_jspx_th_fmt_getLocale_0      );
    }
    _jspx_th_fmt_getLocale_0.setJspContext(_jspx_page_context);
    _jspx_th_fmt_getLocale_0.setVar("locale");
    _jspx_th_fmt_getLocale_0.setScope("page");
    _jspx_th_fmt_getLocale_0.doTag();
    return false;
  }

  private boolean _jspx_meth_c_set_0(PageContext _jspx_page_context)
          throws Throwable {
    JspWriter out = _jspx_page_context.getOut();
    //  c:set
    org.apache.taglibs.standard.tag.rt.core.SetTag _jspx_th_c_set_0 = (org.apache.taglibs.standard.tag.rt.core.SetTag) _jspx_tagPool_c_set_var_value_nobody.get(org.apache.taglibs.standard.tag.rt.core.SetTag.class);
    _jspx_th_c_set_0.setPageContext(_jspx_page_context);
    _jspx_th_c_set_0.setParent(null);
    _jspx_th_c_set_0.setVar("zimbraMailURL");
    _jspx_th_c_set_0.setValue((java.lang.Object) org.apache.jasper.runtime.PageContextImpl.evaluateExpression("${zm:getMailURL(pageContext)}", java.lang.Object.class, (PageContext)this.getJspContext(), _jspx_fnmap_0));
    int _jspx_eval_c_set_0 = _jspx_th_c_set_0.doStartTag();
    if (_jspx_th_c_set_0.doEndTag() == javax.servlet.jsp.tagext.Tag.SKIP_PAGE) {
      _jspx_tagPool_c_set_var_value_nobody.reuse(_jspx_th_c_set_0);
      throw new SkipPageException();
    }
    _jspx_tagPool_c_set_var_value_nobody.reuse(_jspx_th_c_set_0);
    return false;
  }

  private boolean _jspx_meth_c_set_1(PageContext _jspx_page_context)
          throws Throwable {
    JspWriter out = _jspx_page_context.getOut();
    //  c:set
    org.apache.taglibs.standard.tag.rt.core.SetTag _jspx_th_c_set_1 = (org.apache.taglibs.standard.tag.rt.core.SetTag) _jspx_tagPool_c_set_var_value_nobody.get(org.apache.taglibs.standard.tag.rt.core.SetTag.class);
    _jspx_th_c_set_1.setPageContext(_jspx_page_context);
    _jspx_th_c_set_1.setParent(null);
    _jspx_th_c_set_1.setVar("contextURL");
    _jspx_th_c_set_1.setValue((java.lang.Object) org.apache.jasper.runtime.PageContextImpl.evaluateExpression("${zimbraMailURL}/css/skin.css", java.lang.Object.class, (PageContext)this.getJspContext(), null));
    int _jspx_eval_c_set_1 = _jspx_th_c_set_1.doStartTag();
    if (_jspx_th_c_set_1.doEndTag() == javax.servlet.jsp.tagext.Tag.SKIP_PAGE) {
      _jspx_tagPool_c_set_var_value_nobody.reuse(_jspx_th_c_set_1);
      throw new SkipPageException();
    }
    _jspx_tagPool_c_set_var_value_nobody.reuse(_jspx_th_c_set_1);
    return false;
  }
}
